-- MySQL dump 10.16  Distrib 10.1.43-MariaDB, for debian-linux-gnueabihf (armv7l)
--
-- Host: localhost    Database: db_terminal
-- ------------------------------------------------------
-- Server version	10.1.43-MariaDB-0ubuntu0.18.04.1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `COUNTRY`
--

DROP TABLE IF EXISTS `COUNTRY`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `COUNTRY` (
  `COUNTRY_ID` int(10) NOT NULL,
  `COUNTRY_GUID` varchar(48) NOT NULL,
  `COUNTRY_NAME` varchar(64) NOT NULL,
  `LM_DATE` datetime NOT NULL,
  `COUNTRY_CODE` varchar(8) DEFAULT NULL,
  `COUNTRY_PHONE_CODE` varchar(8) DEFAULT NULL,
  `LATITUDE` float(18,5) DEFAULT NULL,
  `LONGITUDE` float(18,5) DEFAULT NULL,
  PRIMARY KEY (`COUNTRY_ID`),
  KEY `AK_COUNTRY__GUID` (`COUNTRY_GUID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `COUNTRY`
--

LOCK TABLES `COUNTRY` WRITE;
/*!40000 ALTER TABLE `COUNTRY` DISABLE KEYS */;
INSERT INTO `COUNTRY` VALUES (186,'18A6D74E-6BE8-4CC8-8473-28EF91B436B2','Russia','2017-02-01 16:13:26','RU','7',NULL,NULL);
/*!40000 ALTER TABLE `COUNTRY` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `OPENWEATHER_CITY`
--

DROP TABLE IF EXISTS `OPENWEATHER_CITY`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `OPENWEATHER_CITY` (
  `CITY_ID` int(10) NOT NULL,
  `COUNTRY_ID` int(10) NOT NULL,
  `CITY_NAME` varchar(255) NOT NULL,
  `CITY_LAT` float(10,6) NOT NULL,
  `CITY_LNG` float(10,6) NOT NULL,
  `LM_DATE` datetime NOT NULL,
  PRIMARY KEY (`CITY_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `OPENWEATHER_CITY`
--

LOCK TABLES `OPENWEATHER_CITY` WRITE;
/*!40000 ALTER TABLE `OPENWEATHER_CITY` DISABLE KEYS */;
/*!40000 ALTER TABLE `OPENWEATHER_CITY` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `POST_MAIL`
--

DROP TABLE IF EXISTS `POST_MAIL`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `POST_MAIL` (
  `FLAG_SEND` varchar(1) NOT NULL DEFAULT 'N',
  `LM_DATE` datetime NOT NULL,
  `NOTIFY_EMAIL` varchar(64) DEFAULT NULL,
  `NOTIFY_SUBJ` varchar(255) DEFAULT NULL,
  `ACC_NAME` varchar(64) DEFAULT NULL,
  `ACC_PASSWD` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`FLAG_SEND`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `POST_MAIL`
--

LOCK TABLES `POST_MAIL` WRITE;
/*!40000 ALTER TABLE `POST_MAIL` DISABLE KEYS */;
INSERT INTO `POST_MAIL` VALUES ('N','2016-10-15 21:55:27',NULL,NULL,'','');
/*!40000 ALTER TABLE `POST_MAIL` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `POST_PROXY`
--

DROP TABLE IF EXISTS `POST_PROXY`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `POST_PROXY` (
  `FLAG_PROXY` varchar(1) NOT NULL DEFAULT 'N',
  `PROXY_HOST` varchar(64) DEFAULT NULL,
  `PROXY_PORT` varchar(4) DEFAULT NULL,
  `PROXY_USER` varchar(64) DEFAULT NULL,
  `PROXY_PASSWD` varchar(64) DEFAULT NULL,
  `LM_DATE` datetime NOT NULL,
  PRIMARY KEY (`FLAG_PROXY`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `POST_PROXY`
--

LOCK TABLES `POST_PROXY` WRITE;
/*!40000 ALTER TABLE `POST_PROXY` DISABLE KEYS */;
INSERT INTO `POST_PROXY` VALUES ('N',NULL,NULL,NULL,NULL,'2016-10-15 21:55:27');
/*!40000 ALTER TABLE `POST_PROXY` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `POST_TRACK`
--

DROP TABLE IF EXISTS `POST_TRACK`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `POST_TRACK` (
  `TRACK_ID` varchar(14) NOT NULL,
  `TRACK_NAME` varchar(64) NOT NULL,
  `FLAG_CHECK` varchar(1) NOT NULL DEFAULT 'Y',
  `TRACK_DATE` datetime NOT NULL,
  `LM_DATE` datetime NOT NULL,
  `TRACK_URL` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`TRACK_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `POST_TRACK`
--

LOCK TABLES `POST_TRACK` WRITE;
/*!40000 ALTER TABLE `POST_TRACK` DISABLE KEYS */;
/*!40000 ALTER TABLE `POST_TRACK` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `POST_TRACKINFO`
--

DROP TABLE IF EXISTS `POST_TRACKINFO`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `POST_TRACKINFO` (
  `TRACK_ID` varchar(14) NOT NULL,
  `OPER_DATE` datetime NOT NULL,
  `OPER_TYPE` int(10) NOT NULL,
  `OPER_NAME` varchar(64) NOT NULL,
  `ATTRIB_ID` int(10) DEFAULT NULL,
  `ATTRIB_NAME` varchar(64) DEFAULT NULL,
  `OPER_POSTCODE` int(10) DEFAULT NULL,
  `OPER_POSTPLACE` varchar(64) NOT NULL,
  `ITEM_WEIGHT` decimal(10,6) DEFAULT NULL,
  `DECLARED_VALUE` decimal(10,6) DEFAULT NULL,
  `DELIVERY_PRICE` decimal(10,6) DEFAULT NULL,
  `DESTINATION_POSTCODE` int(10) DEFAULT NULL,
  `DELIVERY_ADDRESS` varchar(255) DEFAULT NULL,
  `LM_DATE` datetime NOT NULL,
  PRIMARY KEY (`TRACK_ID`,`OPER_DATE`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `POST_TRACKINFO`
--

LOCK TABLES `POST_TRACKINFO` WRITE;
/*!40000 ALTER TABLE `POST_TRACKINFO` DISABLE KEYS */;
/*!40000 ALTER TABLE `POST_TRACKINFO` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `actions_log`
--

DROP TABLE IF EXISTS `actions_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actions_log` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ADDED` datetime DEFAULT NULL,
  `ACTION_TYPE` varchar(100) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `USER` varchar(255) NOT NULL DEFAULT '',
  `TERMINAL` varchar(255) NOT NULL DEFAULT '',
  `IP` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `ACTION_TYPE` (`ACTION_TYPE`)
) ENGINE=InnoDB AUTO_INCREMENT=70 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actions_log`
--

LOCK TABLES `actions_log` WRITE;
/*!40000 ALTER TABLE `actions_log` DISABLE KEYS */;
INSERT INTO `actions_log` VALUES (1,'2020-01-26 12:16:27','market_update','Update all','','','192.168.5.59'),(2,'2020-01-26 20:18:45','control_panel_enter','admin','admin','','192.168.5.59'),(3,'2020-01-26 20:18:48','control_panel_enter','admin','admin','','192.168.5.59'),(4,'2020-01-26 21:09:58','scene_clicked','telcast_Управление.4.off','admin','MAIN','192.168.5.59'),(5,'2020-01-26 21:09:59','scene_clicked','telcast_Управление.4.on','admin','MAIN','192.168.5.59'),(6,'2020-01-26 21:10:00','scene_clicked','telcast_Управление.8.off','admin','MAIN','192.168.5.59'),(7,'2020-01-26 21:10:01','scene_clicked','telcast_Управление.3.off','admin','MAIN','192.168.5.59'),(8,'2020-01-26 21:10:02','scene_clicked','telcast_Управление.3.on','admin','MAIN','192.168.5.59'),(9,'2020-01-26 21:10:03','scene_clicked','telcast_Управление.8.on','admin','MAIN','192.168.5.59'),(10,'2020-01-26 21:10:05','scene_clicked','telcast_Управление.7.off','admin','MAIN','192.168.5.59'),(11,'2020-01-26 21:10:06','scene_clicked','telcast_Управление.1.off','admin','MAIN','192.168.5.59'),(12,'2020-01-26 21:10:07','scene_clicked','telcast_Управление.2.off','admin','MAIN','192.168.5.59'),(13,'2020-01-26 21:10:08','scene_clicked','telcast_Управление.2.on','admin','MAIN','192.168.5.59'),(14,'2020-01-26 21:10:09','scene_clicked','telcast_Управление.1.on','admin','MAIN','192.168.5.59'),(15,'2020-01-26 21:10:09','scene_clicked','telcast_Управление.7.on','admin','MAIN','192.168.5.59'),(16,'2020-01-26 21:10:41','scene_clicked','telcast_Управление.8.off','admin','MAIN','192.168.5.59'),(17,'2020-01-26 21:10:42','scene_clicked','telcast_Управление.8.on','admin','MAIN','192.168.5.59'),(18,'2020-01-26 21:10:43','scene_clicked','telcast_Управление.3.off','admin','MAIN','192.168.5.59'),(19,'2020-01-26 21:10:43','scene_clicked','telcast_Управление.3.on','admin','MAIN','192.168.5.59'),(20,'2020-01-26 21:13:17','scene_clicked','telcast_Управление.3.off','admin','MAIN','192.168.5.59'),(21,'2020-01-26 21:13:18','scene_clicked','telcast_Управление.3.on','admin','MAIN','192.168.5.59'),(22,'2020-01-26 21:13:19','scene_clicked','telcast_Управление.3.off','admin','MAIN','192.168.5.59'),(23,'2020-01-26 21:13:20','scene_clicked','telcast_Управление.3.on','admin','MAIN','192.168.5.59'),(24,'2020-01-26 21:13:22','scene_clicked','telcast_Управление.3.on','admin','MAIN','192.168.5.59'),(25,'2020-01-26 21:13:25','scene_clicked','telcast_Управление.4.off','admin','MAIN','192.168.5.59'),(26,'2020-01-26 21:13:27','scene_clicked','telcast_Управление.4.on','admin','MAIN','192.168.5.59'),(27,'2020-01-26 21:13:41','scene_clicked','telcast_Управление.5.off','admin','MAIN','192.168.5.59'),(28,'2020-01-26 21:13:43','scene_clicked','telcast_Управление.5.on','admin','MAIN','192.168.5.59'),(29,'2020-01-26 21:13:44','scene_clicked','telcast_Управление.6.off','admin','MAIN','192.168.5.59'),(30,'2020-01-26 21:13:44','scene_clicked','telcast_Управление.6.on','admin','MAIN','192.168.5.59'),(31,'2020-01-26 21:13:47','scene_clicked','telcast_Управление.1.off','admin','MAIN','192.168.5.59'),(32,'2020-01-26 21:13:47','scene_clicked','telcast_Управление.1.on','admin','MAIN','192.168.5.59'),(33,'2020-01-26 21:13:53','scene_clicked','telcast_Управление.8.off','admin','MAIN','192.168.5.59'),(34,'2020-01-26 21:13:53','scene_clicked','telcast_Управление.8.on','admin','MAIN','192.168.5.59'),(35,'2020-01-26 21:14:10','scene_clicked','telcast_Управление.6.off','admin','MAIN','192.168.5.59'),(36,'2020-01-26 21:14:11','scene_clicked','telcast_Управление.6.on','admin','MAIN','192.168.5.59'),(37,'2020-01-27 15:30:29','market_install','yandexweather','','','192.168.5.59'),(38,'2020-01-27 18:56:22','menu_clicked','%key.1%','admin','MAIN','192.168.5.59'),(39,'2020-01-27 18:56:31','menu_clicked','%key.1%','admin','MAIN','192.168.5.59'),(40,'2020-01-27 18:56:40','menu_clicked','Комната 1','admin','MAIN','192.168.5.59'),(41,'2020-01-27 18:56:43','menu_clicked','Комната 1','admin','MAIN','192.168.5.59'),(42,'2020-01-27 18:56:49','menu_clicked','Комната 1','admin','MAIN','192.168.5.59'),(43,'2020-01-27 18:56:50','menu_clicked','Комната 1','admin','MAIN','192.168.5.59'),(44,'2020-01-27 21:18:49','system_update','','','','192.168.5.59'),(45,'2020-01-27 21:18:49','system_restore','master.tgz','','','192.168.5.59'),(46,'2020-01-27 22:48:50','system_update','','','','192.168.5.59'),(47,'2020-01-27 22:48:50','system_restore','master.tgz','','','192.168.5.59'),(48,'2020-01-28 00:13:57','menu_clicked','%key.2%','admin','MAIN','192.168.5.59'),(49,'2020-01-28 00:48:35','system_update','','','','192.168.5.59'),(50,'2020-01-28 00:48:35','system_restore','master.tgz','','','192.168.5.59'),(51,'2020-01-28 16:38:46','control_panel_enter','admin','admin','','192.168.5.59'),(52,'2020-01-28 16:38:57','control_panel_enter','admin','admin','','192.168.5.59'),(53,'2020-01-28 17:43:12','menu_clicked','Комната 1','admin','MAIN','192.168.5.59'),(54,'2020-01-28 17:43:12','menu_clicked','Комната 1','admin','MAIN','192.168.5.59'),(55,'2020-01-28 17:43:14','menu_clicked','Комната 2','admin','MAIN','192.168.5.59'),(56,'2020-01-28 17:43:15','menu_clicked','Комната 3','admin','MAIN','192.168.5.59'),(57,'2020-01-28 17:43:18','menu_clicked','Комната 4','admin','MAIN','192.168.5.59'),(58,'2020-01-28 17:43:19','menu_clicked','Комната 5','admin','MAIN','192.168.5.59'),(59,'2020-01-28 17:43:20','menu_clicked','Комната 6','admin','MAIN','192.168.5.59'),(60,'2020-01-28 17:43:21','menu_clicked','Комната 6','admin','MAIN','192.168.5.59'),(61,'2020-01-28 17:43:23','menu_clicked','Комната 7','admin','MAIN','192.168.5.59'),(62,'2020-01-28 17:43:25','menu_clicked','Комната 8','admin','MAIN','192.168.5.59'),(63,'2020-01-28 17:43:27','menu_clicked','Комната 9','admin','MAIN','192.168.5.59'),(64,'2020-01-28 17:43:29','menu_clicked','Комната 10','admin','MAIN','192.168.5.59'),(65,'2020-01-28 17:43:33','menu_clicked','t экономии','admin','MAIN','192.168.5.59'),(66,'2020-01-28 17:43:34','menu_clicked','t экономии','admin','MAIN','192.168.5.59'),(67,'2020-01-28 19:07:48','control_panel_enter','admin','admin','','192.168.5.59'),(68,'2020-01-28 19:07:49','control_panel_enter','admin','admin','','192.168.5.59'),(69,'2020-01-28 20:15:28','system_backup','','','','192.168.5.59');
/*!40000 ALTER TABLE `actions_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_users`
--

DROP TABLE IF EXISTS `admin_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `admin_users` (
  `ID` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(100) NOT NULL DEFAULT '',
  `LOGIN` varchar(100) NOT NULL DEFAULT '',
  `PASSWORD` varchar(100) NOT NULL DEFAULT '',
  `EMAIL` varchar(100) NOT NULL DEFAULT '',
  `COMMENTS` text,
  `ACCESS` text,
  `PRIVATE` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EMAIL_ORDERS` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `EMAIL_INVENTORY` tinyint(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `admin_users`
--

LOCK TABLES `admin_users` WRITE;
/*!40000 ALTER TABLE `admin_users` DISABLE KEYS */;
INSERT INTO `admin_users` VALUES (1,'Administrator','admin','21232f297a57a5a743894a0e4a801fc3','webmaster@domain.com','','control_modules,control_access,master,cms_docs,news,statistic,newsletter,backup,edit_templates,newslist,saverestore,skins,settings,dateselect,thumb,footercode,holdingpage,dashboard,events,users,terminals,mediabrowser,player,commands,classes,history,locations,methods,properties,objects,pvalues,shoutbox,shoutrooms,jobs,btdevices,weather,usbdevices,app_mediabrowser,app_products,app_tdwiki,app_weather,layouts,scripts,rss_channels,languages,pinghosts,watchfolders,app_player,app_gpstrack,webvars,patterns,onewire,app_calendar,xray',0,0,0);
/*!40000 ALTER TABLE `admin_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apiai_actions`
--

DROP TABLE IF EXISTS `apiai_actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apiai_actions` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LATEST_PARAMS` varchar(255) NOT NULL DEFAULT '',
  `LATEST_USAGE` datetime DEFAULT NULL,
  `CODE` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apiai_actions`
--

LOCK TABLES `apiai_actions` WRITE;
/*!40000 ALTER TABLE `apiai_actions` DISABLE KEYS */;
INSERT INTO `apiai_actions` VALUES (1,'input.unknown','','2019-12-17 11:14:41','');
/*!40000 ALTER TABLE `apiai_actions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `apiai_entities`
--

DROP TABLE IF EXISTS `apiai_entities`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `apiai_entities` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(255) NOT NULL DEFAULT '',
  `LAST_EXPORT` datetime DEFAULT NULL,
  `CODE` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `apiai_entities`
--

LOCK TABLES `apiai_entities` WRITE;
/*!40000 ALTER TABLE `apiai_entities` DISABLE KEYS */;
INSERT INTO `apiai_entities` VALUES (1,'terminal',NULL,'$terminals = SQLSelect(\'select NAME, TITLE from terminals\');\n$total = count($terminals);\n$entries = array();\nfor($i=0; $i<$total; $i++) {\n $entries[] = array(\'value\' => $terminals[$i][\'NAME\'], \'synonyms\' => array($terminals[$i][\'TITLE\']));\n}\n\n$entity = array(\n \'name\' => \'terminal\',\n \'entries\' => $entries\n);\n\nreturn $entity;'),(2,'user',NULL,'$users = SQLSelect(\'select USERNAME, NAME from users\');\n$total = count($users);\n$entries = array();\nfor($i=0; $i<$total; $i++) {\n $entries[] = array(\'value\' => $users[$i][\'USERNAME\'], \'synonyms\' => array($users[$i][\'NAME\']));\n}\n\n$entity = array(\n \'name\' => \'user\',\n \'entries\' => $entries\n);\n\nreturn $entity;'),(3,'room',NULL,'$rooms = getObjectsByClass(\'Rooms\');\n$total = count($rooms);\n$entries = array();\nfor($i=0; $i<$total; $i++) {\n $name = $rooms[$i][\'TITLE\'];\n $entry = array(\'value\' => $name);\n $title = gg($rooms[$i][\'TITLE\'].\'.Title\');\n if($title)\n   $entry[\'synonyms\'] = array($title);\n $entries[] = $entry;\n}\n\n$entity = array(\n \'name\' => \'room\',\n \'entries\' => $entries\n);\n\nreturn $entity;');
/*!40000 ALTER TABLE `apiai_entities` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `app_quotes`
--

DROP TABLE IF EXISTS `app_quotes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `app_quotes` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `BODY` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `app_quotes`
--

LOCK TABLES `app_quotes` WRITE;
/*!40000 ALTER TABLE `app_quotes` DISABLE KEYS */;
/*!40000 ALTER TABLE `app_quotes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `app_radio`
--

DROP TABLE IF EXISTS `app_radio`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `app_radio` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `stations` text,
  `name` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=44 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `app_radio`
--

LOCK TABLES `app_radio` WRITE;
/*!40000 ALTER TABLE `app_radio` DISABLE KEYS */;
INSERT INTO `app_radio` VALUES (1,'http://sc-t40.1.fm:7018/?type=.flv','﻿1 FM - TOP40'),(2,'http://193.232.148.42:8000/v3_1','Авторадио'),(3,'http://icecast.vgtrk.cdnvideo.ru/vestifm_mp3_192kbps','Best FM'),(4,'http://79.143.70.114:8000/detifm-96k.mp3','Детское радио'),(5,'http://ep64.streamr.ru','Европпа+'),(6,'http://epfresh128.streamr.ru','Европпа+ Свежее'),(7,'http://eptop128.streamr.ru','Европпа+ Топ 40'),(8,'http://epdance128.streamr.ru','Европпа+ Dance'),(9,'http://eprock128.streamr.ru','Европпа+ POPROCK'),(10,'http://eprnb128.streamr.ru','Европпа+ R&B'),(11,'https://zaycevfm.cdnvideo.ru/ZaycevFM_pop_128.mp3','Зайцев FM'),(12,'http://89.208.99.16:8088/zvezda_128','ЗВЕЗДА'),(13,'http://kpradio.hostingradio.ru:8000/russia.radiokp128.mp3','Комсомольская правда'),(14,'http://icecast.vgtrk.cdnvideo.ru/mayakfm_mp3_192kbps','Маяк'),(15,'http://radio.mvd.ru:8000/mv128.mp3','Милицейская волна'),(16,'http://nashe2.hostingradio.ru/nashe-128.mp3','Наше радио'),(17,'http://srv01.radio7.fmstreams.de/stream1/livestream.mp3','Радио 7'),(18,'http://air.radioday.fm/mp3','Радио день'),(19,'http://icecast.piktv.cdnvideo.ru/rdd128?71','Радио для двоих'),(20,'http://85.114.140.64:8000/1105','Радио Скала'),(21,'http://s5.radioboss.fm:8155/stream','Радио трасса'),(22,'http://91.229.113.62:8000/rsn.mp3','Русская служба'),(23,'http://listen.rusongs.ru/ru-aac-48?type=.flv','Русские Песни'),(24,'http://icecast.russkoeradio.cdnvideo.ru/rr.mp3','Русское Радио'),(25,'http://radio.russkoe.fm:8000/russkoefm_aac?type=.flv','Русскoе FM'),(26,'http://rfe-channel-04.akacast.akamaistream.net/7/885/229654/v1/ibb.akacast.akamaistream.net/rfe_channel_04.mp3','Свобода'),(27,'http://icecast.rian.cdnvideo.ru/rian.voicerus','Спутник'),(28,'http://bcs1.hi-sound.ru:8000/fontan96.mp3','Фонтанка FM'),(29,'http://radio.horoshee.fm:8000/mp3','Хорошее FM'),(30,'http://chanson.hostingradio.ru:8041/chanson128.mp3','Шансон'),(31,'http://emgspb.hostingradio.ru/eldoradio128.mp3','Эльдорадио Санкт-Петербург'),(32,'http://81.19.85.197/echo.mp3','ЭХО Москвы'),(33,'http://ic2.101.ru:8000/v5_1','Юмор FM'),(34,'http://icecast.radiodfm.cdnvideo.ru/dfm.mp3','DFM'),(35,'http://ic2.101.ru:8000/v1_1','ENERGY'),(36,'http://streaming.radio.co/s774887f7b/listen','Jazz radio'),(37,'http://icecast.radiomaximum.cdnvideo.ru/maximum.mp3','Maximum'),(38,'http://ic2.101.ru:8000/v13_1?setst=094548200140236612420140625&tok=75urgZKbvvpyTQMDZ1H4Hfqy5FKeKsXaPod7argnUF%2BwRqI%2Fy3MhBg%3D%3D','Relax FM'),(39,'http://live1.shtorm.fm:8000/aac48_rock?type=.flv','STORM.FM Роковый'),(40,'http://yumfm128.streamr.ru','Yum.fm'),(41,'http://icecast.vgtrk.cdnvideo.ru/ufm_mp3_192kbps','Юность'),(42,'https://audio.baltika.fm/baltika.mp3','радио Балтика'),(43,'http://icecast.piktv.cdnvideo.ru/piterfm','Питер ФМ');
/*!40000 ALTER TABLE `app_radio` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `blockly_code`
--

DROP TABLE IF EXISTS `blockly_code`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `blockly_code` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `SYSTEM_NAME` varchar(255) NOT NULL DEFAULT '',
  `CODE_TYPE` int(3) NOT NULL DEFAULT '0',
  `CODE` text,
  `XML` text,
  `UPDATED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=522 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `blockly_code`
--

LOCK TABLES `blockly_code` WRITE;
/*!40000 ALTER TABLE `blockly_code` DISABLE KEYS */;
INSERT INTO `blockly_code` VALUES (1,'script14',0,'','','2014-09-03 12:28:53'),(2,'method87',0,'//$params[\'t\']\r\n $this->setProperty(\"updated\",time());\r\n $this->setProperty(\"updatedTime\",date(\"H:i\",time()));\r\n $this->setProperty(\"alive\",1); \r\n \r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=30*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout); \r\n\r\nif (!isset($params[\'h\'])) {\r\n return;\r\n}\r\n\r\n\r\n$old_temp=$this->getProperty(\'humidity\');\r\n$t=round($params[\'h\'],1);\r\n\r\nif ($t>100) return;\r\n\r\n$this->setProperty(\'humidity\',$t);\r\nif ($params[\'uptime\']) {\r\n $this->setProperty(\'uptime\',$params[\'uptime\']);\r\n}\r\n\r\nif ($t>$old_temp) {\r\n $d=1;\r\n} elseif ($t<$old_temp) {\r\n $d=-1;\r\n} else {\r\n $d=0;\r\n}\r\n$this->setProperty(\'direction\',$d);\r\n\r\n$linked_room=$this->getProperty(\"LinkedRoom\");\r\nif ($linked_room) {\r\n setGlobal($linked_room.\'.Humidity\',$t);\r\n}','','2014-09-03 13:51:53'),(7,'script16',0,'// got data\r\n$sensor=$params[\'sensor\'];\r\nif (!$sensor) return 0;\r\n\r\n$hum=(int)str_replace(\'-\',\'\',$params[\'other_params\'][6]);\r\nif ($hum>0 && $hum<=100) {\r\n callMethod(\'hum\'.$sensor.\'.humChanged\',array(\'h\'=>$hum));\r\n}\r\n\r\n//$temp=((int)str_replace(\'-\',\'\',$params[\'other_params\'][4]))/10;\r\n$b1 =(int)str_replace(\'-\',\'\',$params[\'other_params\'][4]);\r\n$b2 =(int)str_replace(\'-\',\'\',$params[\'other_params\'][5]);\r\n$y_temp=256*($b2 & 15)+$b1;\r\nif  (($b2 & 8) != 0 ) { // отрицательное значение температуры\r\n $y_temp=4096-$y_temp;\r\n $temp = -1*($y_temp)/10;\r\n} else { // положительное значение температуры\r\n $temp = $y_temp/10;\r\n}\r\n\r\nif ($temp>-30 && $temp<=100) {\r\n callMethod(\'temp\'.$sensor.\'.tempChanged\',array(\'t\'=>$temp));\r\n}','','2014-09-03 16:07:57'),(10,'method88',0,'$rooms=getObjectsByClass(\"Rooms\");\r\n$total=count($rooms);\r\nfor($i=0;$i<$total;$i++) {\r\n $rooms[$i][\'room\']=getGlobal($rooms[$i][\'TITLE\'].\'.Title\');\r\n if (!$rooms[$i][\'room\']) {\r\n  $rooms[$i][\'room\']=$rooms[$i][\'TITLE\'];\r\n } \r\n $rooms[$i][\'active\']=getGlobal($rooms[$i][\'TITLE\'].\'.SomebodyHere\');\r\n $rooms[$i][\'time\']=getGlobal($rooms[$i][\'TITLE\'].\'.LatestActivity\'); \r\n $rooms[$i][\'diff\']=time()-$rooms[$i][\'time\'];\r\n} \r\n\r\nfunction cmp($a, $b)\r\n{\r\n    if ($a[\'diff\'] == $b[\'diff\']) {\r\n        return 0;\r\n    }\r\n    return ($a[\'diff\'] < $b[\'diff\']) ? -1 : 1;\r\n}\r\nusort($rooms,\"cmp\");\r\n\r\nif (!$rooms[0][\'active\']) {\r\n $somebodyHomeText=\"Никого нет дома. Были в \".date(\'H:i\',$rooms[0][\'time\']).\" (\".$rooms[0][\'room\'].\")\";\r\n} else {\r\n $res_rooms=array();\r\n for($i=0;$i<$total;$i++) {\r\n  if ($rooms[$i][\'active\']) {\r\n   $res_rooms[]=$rooms[$i][\'room\'];\r\n  } \r\n }\r\n $somebodyHomeText=\"Кто-то дома: \".implode(\", \",$res_rooms); \r\n}\r\nsetGlobal(\'somebodyHomeText\',$somebodyHomeText);\r\n//echo \"Updated\";','','2014-09-04 16:05:37'),(9,'method66',0,'$latestActivity=$this->getProperty(\'LatestActivity\');\r\n$this->setProperty(\'LatestActivity\',time());\r\n$this->setProperty(\'LatestActivityTime\',date(\'H:i\'));\r\n\r\n$this->setProperty(\'SomebodyHere\',1);\r\n$ot=$this->object_title;\r\nif ($this->getProperty(\"IdleDelay\")) {\r\n $activity_timeout=(int)$this->getProperty(\"IdleDelay\");\r\n} else {\r\n $activity_timeout=10*60;\r\n}\r\nclearTimeOut($ot.\"_activity_timeout\");\r\nsetTimeOut($ot.\"_activity_timeout\",\"callMethod(\'\".$ot.\".onIdle\');\",$activity_timeout);\r\n$this->callMethod(\"updateActivityStatus\");\r\n','','2014-09-04 16:05:03'),(11,'method89',0,'$cmdline=\'\"c:\\Program Files\\nooLite\\nooLite.exe\" -api \'.$params[\'command\'];\r\n$last_called=gg(\'NoolightCommandSend\');\r\n$min_delay=3;\r\n$now=time();\r\nif (($now-$last_called)>$min_delay) {\r\n //safe_exec($cmdline);\r\n $last_callled=$now; \r\n sg(\'NoolightCommandSend\',$last_called);\r\n DebMes(\"Noolite instant exec: \".$cmdline);\r\n system($cmdline);\r\n //exec($cmdline);\r\n} else {\r\n if ($last_callled<$now) {\r\n  $last_callled=$now;\r\n }\r\n $last_called+=$min_delay;\r\n sg(\'NoolightCommandSend\',$last_called);\r\n DebMes(\"Noolite scheduled job for \".date(\'H:i:s\',$last_called));\r\n AddScheduledJob(\"noolight\".md5($cmdline),\"safe_exec(\'\".$cmdline.\"\');\",$last_called);\r\n}\r\n\r\n','','2014-09-04 16:11:33'),(12,'method90',0,'$this->setProperty(\"status\",0);\r\n//safe_exec(\'\"c:\\Program Files\\nooLite\\noolite.exe\" -api -off_ch\'.$this->getProperty(\"channel\"));\r\n$this->callMethod(\"sendCommand\",array(\'command\'=>\'-off_ch\'.$this->getProperty(\"channel\")));','','2014-09-04 16:12:35'),(13,'method91',0,'$this->setProperty(\"status\",1);\r\n$this->callMethod(\"sendCommand\",array(\'command\'=>\'-on_ch\'.$this->getProperty(\"channel\")));','','2014-09-04 16:13:08'),(14,'method92',0,'','','2014-09-04 16:26:02'),(15,'method93',0,'','','2014-09-04 16:26:13'),(16,'method94',0,'','','2014-09-04 16:26:24'),(17,'method95',0,'','','2014-09-04 16:26:34'),(18,'method96',0,'','','2014-09-04 16:27:00'),(489,'object17_method59',0,'$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\n$cycles=array(\'states\'=>\'states\',\'main\'=>\'main\',\'execs\'=>\'exec\',\'scheduler\'=>\'scheduler\');\r\nforeach($cycles as $k=>$v) {\r\n $tm=getGlobal(\'ThisComputer.cycle_\'.$k.\'Run\');\r\n if (time()-$tm>5*60) {\r\n  $red_state=1;\r\n  $details[]=$v.\" \".LANG_GENERAL_CYCLE.\" \".LANG_GENERAL_STOPPED.\".\";\r\n }\r\n}\r\n\r\n$cycles=array(\'ping\'=>\'ping\',\'webvars\'=>\'webvars\');\r\nforeach($cycles as $k=>$v) {\r\n $tm=getGlobal(\'ThisComputer.cycle_\'.$k.\'Run\');\r\n if (time()-$tm>10*60) {\r\n  $yellow_state=1;\r\n  $details[]=$v.\" \".LANG_GENERAL_CYCLE.\" \".LANG_GENERAL_STOPPED.\".\";  \r\n }\r\n}\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  //say(LANG_GENERAL_SYSTEM_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  //say(implode(\". \",$details));\r\n } else {\r\n // say(LANG_GENERAL_SYSTEM_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}\r\n/* begin injection of {SDevices} */\r\nrequire(DIR_MODULES.\'devices/system_checkstate.php\');\r\n/* end injection of {SDevices} */','','2018-03-19 11:02:27'),(74,'pattern6',0,'','','2014-10-31 15:22:41'),(75,'pattern5',0,'','','2014-10-31 15:22:55'),(73,'object18_method59',0,'$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\nif (!isOnline(\'Internet\')) {\r\n $yellow_state=1;\r\n $details[]=LANG_GENERAL_NO_INTERNET_ACCESS;\r\n}\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(LANG_GENERAL_COMMUNICATION_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(LANG_GENERAL_COMMUNICATION_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}','','2014-10-31 15:10:21'),(60,'script15',0,'$weather.=\"Сегодня ожидается \".str_replace(\'&deg;\',\' \',getGlobal(\'weatherToday\'));\r\n$weather.=\". Завтра \".str_replace(\'&deg;\',\' \',getGlobal(\'weatherTomorrow\'));\r\n$weather.=\". Сейчас на улице \".getGlobal(\'TempOutside\').\'.\';\r\n$weather=str_replace(\'&deg;\',\'\',$weather);\r\nsay($weather,2);','','2014-10-30 15:32:00'),(24,'method97',0,'$this->setProperty(\'updated\',time());\r\n$this->setProperty(\'updatedTime\',date(\'H:i\'));','','2014-09-04 17:34:10'),(26,'object72_method97',0,'say(\"Нажата на пульте кнопка Цэ!\",2);','','2014-09-04 17:38:10'),(27,'object70_method97',0,'say(\"Нажата на пульте кнопка А!\",2);','','2014-09-04 17:38:30'),(28,'object71_method97',0,'say(\"Нажата на пульте кнопка Бэ!\",2);','','2014-09-04 17:38:48'),(61,'script17',0,'$lastRead=getGlobal(\'lastNewsRead\');\r\n$limit=10;\r\n\r\n$items=SQLSelect(\"SELECT TITLE FROM rss_items WHERE ADDED>\'\".date(\'Y-m-d H:i:s\',$lastRead).\"\' ORDER BY ADDED DESC LIMIT $limit\");\r\n$total=count($items);\r\nif ($total==0) {\r\n $items=SQLSelect(\"SELECT TITLE FROM rss_items WHERE 1 ORDER BY ADDED DESC LIMIT 2\");\r\n $total=count($items); \r\n}\r\n\r\n$res=array_reverse($items);\r\nfor($i=0;$i<$total;$i++) {\r\n say($res[$i][\'TITLE\'],2);\r\n}\r\nsetGlobal(\'lastNewsRead\',time());','','2014-10-30 15:32:13'),(35,'object72_method98',0,'say(\"Нажата на пульте кнопка Цэ!\",2);\r\nrunScript(\'readLatestNews\');','','2014-09-04 18:04:04'),(63,'script18',0,'// вытягиваем историю из переменной\r\n$alreadyPlayed=gg(\"AlreadyPlayedMusic\");\r\nif (!$alreadyPlayed) {\r\n $alreadyPlayed=\'0\';\r\n}\r\n\r\n// выбираем случайную папку\r\n$rec=SQLSelectOne(\"SELECT * FROM media_favorites WHERE ID NOT IN (\".$alreadyPlayed.\") ORDER BY RAND()\");\r\n\r\nif (!$rec[\'ID\']) {\r\n // папок больше не осталось, поэтому выбираем случайную и сбрасываем историю\r\n $rec=SQLSelectOne(\"SELECT * FROM media_favorites ORDER BY RAND()\");\r\n $alreadyPlayed=\'0\';\r\n}\r\n\r\n\r\nif ($rec[\'ID\']) {\r\n\r\n // добавляем выбранную папку в историю\r\n $alreadyPlayed.=\',\'.$rec[\'ID\'];\r\n sg(\"AlreadyPlayedMusic\",$alreadyPlayed);\r\n\r\n // запускаем на проигрывание\r\n $collection=SQLSelectOne(\"SELECT * FROM collections WHERE ID=\".(int)$rec[\'COLLECTION_ID\']);\r\n $path=$collection[\'PATH\'].$rec[\'PATH\'];\r\n playMedia($path);\r\n //setTimeOut(\'VLCPlayer_update\',\"callMethod(\'VLCPlayer.update\');\",10);\r\n\r\n}','','2014-10-30 15:32:40'),(62,'script19',0,'getURL(\'http://localhost/rc/?command=vlc_pause\',0);','','2014-10-30 15:32:28'),(39,'object19_method64',0,'callMethod(\'noo1.turnOff\'); // выключаем тёплый пол\r\ncallMethod(\'noo2.turnOff\'); // выключаем бойлер на кухне','','2014-09-05 11:10:07'),(40,'object19_method65',0,'callMethod(\'noo1.turnOn\'); // включаем тёплый пол\r\ncallMethod(\'noo2.turnOn\'); // включаем бойлер на кухне','','2014-09-05 11:10:32'),(76,'script20',0,'say(LANG_GENERAL_SETTING_UP_LIGHTS,2);\r\n// to-do','','2014-10-31 15:25:11'),(69,'object17_method73',0,'$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\n$cycles=array(\'states\'=>\'states cycle\',\'main\'=>\'main cycle\',\'execs\'=>\'exec cycle\',\'scheduler\'=>\'scheduler cycle\');\r\nforeach($cycles as $k=>$v) {\r\n $tm=getGlobal(\'ThisComputer.cycle_\'.$k.\'Run\');\r\n if (time()-$tm>5*60) {\r\n  $red_state=1;\r\n  $details[]=$v.\" stopped.\";\r\n }\r\n}\r\n\r\n$cycles=array(\'ping\'=>\'ping cycle\',\'webvars\'=>\'webvars cycle\',\'watchfolders\'=>\'watch folders cycle\',\'rss\'=>\'RSS cycle\');\r\nforeach($cycles as $k=>$v) {\r\n $tm=getGlobal(\'ThisComputer.cycle_\'.$k.\'Run\');\r\n if (time()-$tm>10*60) {\r\n  $yellow_state=1;\r\n  $details[]=$v.\" stopped.\";\r\n }\r\n}\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=\'Red\'; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=\'Yellow\';  \r\n} else {\r\n $state=\'green\';\r\n $state_title=\'Green\';   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(\"System state changed to \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(\"System state restored to \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}','','2014-10-30 15:44:01'),(70,'object16_method75',0,'$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(LANG_GENERAL_SYSTEM_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(LANG_GENERAL_SYSTEM_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}','','2014-10-31 14:57:24'),(59,'script21',0,'$res=\'\';\r\n if (gg(\'Security.stateColor\')==\'green\' && gg(\'System.stateColor\')==\'green\' && gg(\'Communication.stateColor\')==\'green\') {\r\n  $res=\'Все системы работают в штатном режиме\';\r\n } else {\r\n  if (gg(\'Security.stateColor\')!=\'green\') {\r\n   $res.=\" Проблема безопасности: \".getGlobal(\'Security.stateDetails\');\r\n  }\r\n  if (gg(\'System.stateColor\')!=\'green\') {\r\n   $res.=\" Системная проблема: \".getGlobal(\'System.stateDetails\');\r\n  }  \r\n  if (gg(\'Communication.stateColor\')!=\'green\') {\r\n   $res.=\" Проблема связи: \".getGlobal(\'Communication.stateDetails\');\r\n  }  \r\n }\r\n say($res,5);','','2014-10-30 15:31:46'),(48,'script1',0,'say(getRandomLine(\'morning\'),2);\r\n//runScript(\'readWunderTasks\');\r\nrunScript(\'readWeatherToday\');\r\nrunScript(\'reportStatus\');','<xml xmlns=\"http://www.w3.org/1999/xhtml\">\r\n  <block type=\"majordomo_say\" inline=\"false\" x=\"140\" y=\"51\">\r\n    <value name=\"TEXT\">\r\n      <block type=\"text\">\r\n        <title name=\"TEXT\">Good morning!</title>\r\n      </block>\r\n    </value>\r\n    <next>\r\n      <block type=\"controls_if\" inline=\"false\">\r\n        <value name=\"IF0\">\r\n          <block type=\"logic_negate\" inline=\"false\">\r\n            <value name=\"BOOL\">\r\n              <block type=\"majordomo_getglobal\">\r\n                <title name=\"TEXT\">ThisComputer.WeHaveGuests</title>\r\n              </block>\r\n            </value>\r\n          </block>\r\n        </value>\r\n        <statement name=\"DO0\">\r\n          <block type=\"majordomo_runscript\" inline=\"false\">\r\n            <title name=\"TEXT\">sayTodayAgenda</title>\r\n            <next>\r\n              <block type=\"majordomo_runscript\" inline=\"false\">\r\n                <title name=\"TEXT\">playFavoriteMusic</title>\r\n              </block>\r\n            </next>\r\n          </block>\r\n        </statement>\r\n      </block>\r\n    </next>\r\n  </block>\r\n</xml>','2014-09-05 12:30:58'),(47,'script13',0,'say(getRandomLine(\'evening\'),2);\r\nrunScript(\'reportStatus\');','<xml xmlns=\"http://www.w3.org/1999/xhtml\">\r\n  <block type=\"majordomo_say\" inline=\"false\" x=\"140\" y=\"51\">\r\n    <value name=\"TEXT\">\r\n      <block type=\"text\">\r\n        <title name=\"TEXT\">Good morning!</title>\r\n      </block>\r\n    </value>\r\n    <next>\r\n      <block type=\"controls_if\" inline=\"false\">\r\n        <value name=\"IF0\">\r\n          <block type=\"logic_negate\" inline=\"false\">\r\n            <value name=\"BOOL\">\r\n              <block type=\"majordomo_getglobal\">\r\n                <title name=\"TEXT\">ThisComputer.WeHaveGuests</title>\r\n              </block>\r\n            </value>\r\n          </block>\r\n        </value>\r\n        <statement name=\"DO0\">\r\n          <block type=\"majordomo_runscript\" inline=\"false\">\r\n            <title name=\"TEXT\">sayTodayAgenda</title>\r\n            <next>\r\n              <block type=\"majordomo_runscript\" inline=\"false\">\r\n                <title name=\"TEXT\">playFavoriteMusic</title>\r\n              </block>\r\n            </next>\r\n          </block>\r\n        </statement>\r\n      </block>\r\n    </next>\r\n  </block>\r\n</xml>','2014-09-05 12:30:34'),(54,'object8_method',0,'','','2014-10-30 15:29:14'),(55,'object7_method',0,'','','2014-10-30 15:29:39'),(56,'object6_method',0,'','','2014-10-30 15:30:05'),(57,'object5_method',0,'','','2014-10-30 15:30:17'),(58,'object1_method',0,'','','2014-10-30 15:30:59'),(67,'script22',1,'runScript(\"reportStatus\", array());\r\n','<xml xmlns=\"http://www.w3.org/1999/xhtml\">\r\n  <block type=\"majordomo_script_21\" id=\"7\" inline=\"true\" x=\"148\" y=\"87\"></block>\r\n</xml>','2014-10-30 15:35:12'),(66,'method62',0,'$this->setProperty(\'status\',$params[\'status\']); // выставляем статус сенсора\r\n$this->setProperty(\'updatedTimestamp\',time()); // выставляем время срабатывания сенсора\r\n\r\n$this->setProperty(\'alive\',1);\r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=24*60*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout);\r\n\r\nif ($params[\'status\']) {\r\n \r\n $this->setProperty(\'motionDetected\',1);\r\n clearTimeOut($this->object_title.\'_detected\'); \r\n setTimeOut($this->object_title.\'_detected\',\"setGlobal(\'\".$this->object_title.\".motionDetected\',0);\",30);\r\n\r\n $linked_room=$this->getProperty(\'LinkedRoom\');\r\n if ($linked_room!=\'\') {\r\n  callMethod($linked_room.\'.onActivity\');\r\n }\r\n\r\n if ($this->object_title==\'sensorMovement3\' || $this->object_title==\'sensorMovementRemote1\' || $this->object_title==\'sensorMovementRemote2\') {\r\n  //|| $this->object_title==\'sensorMovement5\'\r\n  return; // не реагируем на движение в спальне, по ip-сенсорам и по сенсору на втором этаже\r\n }\r\n\r\n ClearTimeOut(\"nobodyHome\"); \r\n SetTimeOut(\"nobodyHome\",\"callMethod(\'NobodyHomeMode.activate\');\", 1*60*60); // выполняем, если целый час никого не было\r\n\r\n if (getGlobal(\'NobodyHomeMode.active\')) {\r\n  callMethod(\'NobodyHomeMode.deactivate\');\r\n }\r\n\r\n $last_register=registeredEventTime(\'inhouseMovement\'); // проверяем, когда в последний раз срабатывало событие \"движение внутри дома\"\r\n  registerEvent(\'inhouseMovement\',$this->name,2); // регистрируем событие \"движение внутри дома\" \r\n  if (timeBetween(\'05:00\', \'12:00\') && ((time()-$last_register)>2*60*60)) {\r\n   runScript(\'Greeting\'); // запускаем скрипт \"доброе утро\"\r\n  }\r\n}','','2014-10-30 15:34:47'),(68,'object6_method18',0,'$h=(int)date(\'G\',time());\r\n$m=date(\'i\',time());\r\n\r\n\r\nif (isWeekDay()) {\r\n\r\n}\r\n\r\n\r\nif (($h>=8) && getGlobal(\'clockChimeEnabled\')) {\r\n if ($m==\"00\") {\r\n   say(timeNow(),1);\r\n }\r\n}\r\n\r\n\r\nsetGlobal(\'timeNow\',date(\'H:i\'));\r\n\r\n$homeStatus=date(\'H:i\');\r\nif (getGlobal(\'NobodyHomeMode.active\')) {\r\n $homeStatus.=\' Дома никого\';\r\n} else {\r\n $homeStatus.=\' Дома кто-то есть\';\r\n}\r\n\r\n$homeStatus.=\' \'.getGlobal(\'Security.stateDetails\');\r\n$homeStatus.=\' \'.getGlobal(\'System.stateDetails\');\r\n$homeStatus.=\' \'.getGlobal(\'Communication.stateDetails\');\r\nsetGlobal(\'HomeStatus\',$homeStatus);\r\n\r\n if (timeBetween(getGlobal(\'SunRiseTime\'),getGlobal(\'SunSetTime\')) && getGlobal(\'isDark\')==\"1\") {\r\n  setGlobal(\"isDark\",0);\r\n  callMethod(\'DarknessMode.deactivate\');  \r\n } elseif (!timeBetween(getGlobal(\'SunRiseTime\'),getGlobal(\'SunSetTime\')) && getGlobal(\'isDark\')!=\"1\") {\r\n  setGlobal(\"isDark\",1);\r\n  callMethod(\'DarknessMode.activate\');    \r\n }\r\n \r\n  if (timeIs(getGlobal(\'SunRiseTime\'))) {\r\n  say(\'Всходит солнце\');\r\n }\r\n if (timeIs(getGlobal(\'SunSetTime\'))) {\r\n  say(\'Солнце заходит\',2);\r\n }\r\n \r\nif (timeIs(\"23:30\") && (gg(\"EconomMode.active\")!=\"1\") && (gg(\"NobodyHomeMode.active\")==\"1\")) {\r\n say(\"Похоже никого нет сегодня, можно сэкономить немного.\");\r\n callMethod(\'EconomMode.activate\');\r\n}\r\n\r\nif (timeIs(\'20:00\')) {\r\n callMethod(\'NightMode.activate\');\r\n} elseif (timeIs(\'08:00\')) {\r\n callMethod(\'NightMode.deactivate\');\r\n}\r\n\r\nif (timeIs(\"03:00\")) {\r\n runScript(\"systemMaintenance\");\r\n}\r\n\r\nif (gg(\'ThisComputer.AlarmStatus\') && timeIs(gg(\'ThisComputer.AlarmTime\'))) {\r\n runScript(\'MorningAlarm\');\r\n}','','2014-10-30 15:38:26'),(71,'object16_method59',0,'$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(LANG_GENERAL_SECURITY_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(LANG_GENERAL_SECURITY_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}','','2014-10-31 15:02:09'),(78,'object18_method74',0,'$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\nif (!isOnline(\'Internet\')) {\r\n $yellow_state=1;\r\n $details[]=LANG_GENERAL_NO_INTERNET_ACCESS;\r\n}\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(LANG_GENERAL_COMMUNICATION_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(LANG_GENERAL_COMMUNICATION_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}','','2014-10-31 15:33:53'),(80,'pattern8',0,'','','2014-10-31 15:38:58'),(81,'pattern9',0,'','','2014-10-31 15:39:25'),(82,'method61',0,'if ($params[\'status\']) {\r\n $this->setProperty(\'status\',$params[\'status\']);\r\n}\r\n$this->setProperty(\'updatedTimestamp\',time());\r\n\r\n$this->setProperty(\"alive\",1);\r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=12*60*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout);','','2015-01-29 11:29:50'),(205,'command108',0,'','','2017-04-11 11:47:41'),(85,'tlgaction',0,'','','2016-12-17 11:17:49'),(164,'method71',0,'$this->setProperty(\"status\",1);\r\nrunScript(\"scene_switch\",array(\"nameobj\"=>$this->object_title));\r\n','','2017-04-08 21:06:54'),(147,'method70',0,'$this->setProperty(\"status\",0);\r\nrunScript(\"scene_switch\",array(\"nameobj\"=>$this->object_title));\r\n','','2017-04-08 20:40:51'),(505,'object6_method14',0,'//получение времени\r\n$h=(int)date(\'G\',time());\r\n$m=date(\'i\',time());\r\n$d=date(\'d.m.Y\');\r\n//часы с нулем впереди\r\nif($h<10)\r\n{$h1=\"0\".$h;} \r\nelse \r\n{$h1=$h;}; \r\n//---------------\r\nif (isWeekDay()) {\r\n\r\n}\r\n//каждую минуту\r\n setGlobal(\"ThisComputer.timeH\",$h);\r\n setGlobal(\"ThisComputer.timeM\",$m);\r\n\r\n\r\nif (($h>=8) && getGlobal(\'clockChimeEnabled\')) {\r\n if ($m==\"00\") {\r\n//   say(timeNow(),1);\r\n }\r\n}\r\n// в час ночи\r\nif (($h=1) ) {\r\n if ($m==\"00\") {\r\n   runScript(\"voshod\");\r\n }\r\n}\r\n\r\n\r\n\r\n\r\nsetGlobal(\'timeNow\',date(\'H:i\'));\r\nrunScript(\"Econom\");\r\n','','2020-01-28 00:13:16'),(206,'command118',0,'','','2017-04-11 11:48:02'),(207,'command119',0,'','','2017-04-11 11:48:11'),(208,'command120',0,'','','2017-04-11 11:48:21'),(209,'command121',0,'','','2017-04-11 11:48:36'),(210,'command122',0,'','','2017-04-11 11:48:49'),(211,'command123',0,'','','2017-04-11 11:49:00'),(212,'command124',0,'','','2017-04-11 11:49:12'),(213,'command125',0,'','','2017-04-11 11:49:23'),(245,'command126',0,'','','2017-04-11 16:40:10'),(244,'command127',0,'','','2017-04-11 16:39:57'),(243,'command128',0,'','','2017-04-11 16:39:43'),(241,'command129',0,'','','2017-04-11 16:39:23'),(240,'command130',0,'','','2017-04-11 16:39:15'),(239,'command131',0,'','','2017-04-11 16:39:07'),(220,'command132',0,'','','2017-04-11 11:50:50'),(237,'command134',0,'','','2017-04-11 15:20:37'),(238,'command135',0,'','','2017-04-11 15:20:48'),(234,'script24',0,'$latitude=(double) getGlobal(\"myobject.coord1\");\r\n$longitude=(double) getGlobal(\"myobject.coord1\");\r\n$sun_info = date_sun_info(time(), $latitude, $longitude); //Ваши географические координаты.\r\n\r\nforeach ($sun_info as $key => $val) {\r\n\r\nif ($key == \'sunrise\') {\r\n\r\n$sunrise = $val;\r\n//echo \'Восход: \'.date(\"H:i:s\", $sunrise).\'<br>\';\r\nsetGlobal(\'ThisComputer.SunRiseTime\',date(\"H:i\", $sunrise));\r\n}\r\n\r\nif ($key == \'sunset\') {\r\n\r\n$sunset = $val;\r\n$day_length = $sunset - $sunrise;\r\n\r\n//echo \'Заход: \'.date(\"H:i\", $sunset).\'<br>\';\r\n//echo \'Долгота дня: \'.gmdate(\"H:i\", $day_length).\'<br>\';\r\nsetGlobal(\'ThisComputer.SunSetTime\',date(\"H:i\", $sunset));\r\nsetGlobal(\'ThisComputer.LongTagTime\',gmdate(\"H:i\", $day_length));\r\n}\r\n\r\nif ($key == \'transit\') {\r\n//echo \'В зените: \'.date(\"H:i:s\", $val).\'<br>\';\r\nsetGlobal(\'ThisComputer.TransitTime\',date(\"H:i\", $val));\r\n}\r\n\r\nif ($key == \'civil_twilight_begin\') {\r\n//echo \'Начало утренних сумерек: \'.date(\"H:i\", $val).\'<br>\';\r\nsetGlobal(\'ThisComputer.Chicivil_beginTime\',date(\"H:i\", $val));\r\n}\r\n\r\nif ($key == \'civil_twilight_end\') {\r\n//echo \'Конец вечерних сумерек: \'.date(\"H:i:s\", $val).\'<br>\';\r\nsetGlobal(\'ThisComputer.civil_endTime\',date(\"H:i\", $val));\r\n}\r\n\r\n} ','','2017-04-11 15:16:39'),(257,'command136',0,'','','2017-04-13 13:19:48'),(256,'script25',0,'$ow_gorod=getGlobal(\"ow_city.name\");\r\n$Record = SQLSelectOne(\"SELECT * FROM `OPENWEATHER_CITY` WHERE `CITY_NAME`=\'\".$ow_gorod.\"\'\");\r\n   $ow_city_id = $Record[\'CITY_ID\'];\r\n   $ow_city_lat = $Record[\'CITY_LAT\']; \r\n   $ow_city_lng = $Record[\'CITY_LNG\']; \r\nsetGlobal(\'ow_city.id\',$ow_city_id);\r\nsetGlobal(\'myobject.coord1\',$ow_city_lat);\r\nsetGlobal(\'myobject.coord2\',$ow_city_lng);','','2017-04-13 13:15:00'),(276,'object6_method15',0,'$h=(int)date(\'G\',time());\r\n\r\nif (gg(\'ThisComputer.DateD\')!=date(\"d\", time())) {\r\n\r\n$day[0]=\"воскресенье\";\r\n$day[1]=\"понедельник\";\r\n$day[2]=\"вторник\";\r\n$day[3]=\"среда\";\r\n$day[4]=\"четверг\";\r\n$day[5]=\"пятница\";\r\n$day[6]=\"суббота\";\r\n\r\n$month[1]=\"января\";\r\n$monthAlt[1]=\"ЯНВАРЬ\";\r\n$monthShrt[1]=\"ЯНВ\";\r\n$month[2]=\"февраля\";\r\n$monthAlt[2]=\"ФЕВРАЛЬ\";\r\n$monthShrt[2]=\"ФЕВ\";\r\n$month[3]=\"марта\";\r\n$monthAlt[3]=\"МАРТ\";\r\n$monthShrt[3]=\"МАРТ\";\r\n$month[4]=\"апреля\";\r\n$monthAlt[4]=\"АПРЕЛЬ\";\r\n$monthShrt[4]=\"АПР\";\r\n$month[5]=\"мая\";\r\n$monthAlt[5]=\"МАЙ\";\r\n$monthShrt[5]=\"МАЙ\";\r\n$month[6]=\"июня\";\r\n$monthAlt[6]=\"ИЮНЬ\";\r\n$monthShrt[6]=\"ИЮНЬ\";\r\n$month[7]=\"июля\";\r\n$monthAlt[7]=\"ИЮЛЬ\";\r\n$monthShrt[7]=\"ИЮЛЬ\";\r\n$month[8]=\"августа\";\r\n$monthAlt[8]=\"АВГУСТ\";\r\n$monthShrt[8]=\"АВГ\";\r\n$month[9]=\"сентября\";\r\n$monthAlt[9]=\"СЕНТЯБРЬ\"; \r\n$monthShrt[9]=\"СЕН\"; \r\n$month[10]=\"октября\";\r\n$monthAlt[10]=\"ОКТЯБРЬ\";\r\n$monthShrt[10]=\"ОКТ\";\r\n$month[11]=\"ноября\";\r\n$monthAlt[11]=\"НОЯБРЬ\";\r\n$monthShrt[11]=\"НБР\";\r\n$month[12]=\"декабря\";\r\n$monthAlt[12]=\"ДЕКАБРЬ\";\r\n$monthShrt[12]=\"ДЕК\";\r\n\r\nsg(\"ThisComputer.DateD\",date( \"d\", time()));\r\nsg(\"ThisComputer.DateM\",date( \"m\", time()));\r\nsg(\"ThisComputer.DateY\",date( \"Y\", time()));\r\nsg(\"ThisComputer.Date\",date( \"d.m.Y\", time()));\r\nsg(\"ThisComputer.Day\",$day[date(\"w\")]);\r\nsg(\"ThisComputer.Month\",$month[date(\"n\")]);\r\nsg(\"ThisComputer.MonthAlt\",$monthAlt[date(\"n\")]);\r\nsg(\"ThisComputer.MonthShrt\",$monthShrt[date(\"n\")]);\r\n} \r\n\r\n$h=(int)date(\'G\',time());\r\n//часы с нулем впереди\r\nif($h<10)\r\n{$h1=\"0\".$h;} \r\nelse \r\n{$h1=$h;}; \r\nsg(\"ThisComputer.timeHH\",$h1);','','2017-08-30 00:38:38'),(288,'script27',0,'$t = gg(\'ow_fact.temperature\'); // температура на улице\r\n$h = gg(\'ow_fact.humidity\'); // влажность на улице %\r\n$w = gg(\'ow_fact.wind_speed\'); // данные о ветре из прогноза OpenWeather m/s\r\n$tF = $t *1.8+32; // перевод температуры в Farenheit\r\nif ($t > 26.6){\r\n // Считаем HeatIndex\r\n $_f=-42.379 + 2.04901523*$tF + 10.14333127*$h - 0.22475541*$tF*$h - 0.00683783*$tF*$tF - 0.05481717*$h*$h + 0.00122874*$tF*$tF*$h + 0.00085282*$tF*$h*$h -0.00000199*$tF*$tF*$h*$h;\r\n}else if ($t <= 10){\r\n // Считаем фактор WindChild\r\n $_f = 35.74+(0.6215*$tF)-(35.75*($w*0.16))+((0.4275*$tF)*($w*0.16));\r\n}else{\r\n //считаем по Rothfusz\r\n $_f = 0.5*($tF+61+(($tF-68)*1.2)+($h*0.094));\r\n}\r\n// переводим в цельсии\r\n $rf = round(($_f-32)/1.8,0);\r\n//и пропишем значение\r\nsg(\"ThisComputer.reelFeel\",$rf);\r\nsg(\'ow_fact.reelFeel\',$rf);\r\n// внесем дни недели прогноза\r\n$numD=gg(\"ow_setting.forecast_interval\");\r\n$day[0]=\"ВСК\";\r\n$day[1]=\"ПНД\";\r\n$day[2]=\"ВТР\";\r\n$day[3]=\"СРД\";\r\n$day[4]=\"ЧТВ\";\r\n$day[5]=\"ПТН\";\r\n$day[6]=\"СБТ\";\r\nfor ($i = 1; $i < $numD; $i++) {\r\n $dayNum = date(\"w\", strtotime($date .\' +\'.$i.\' day\'));\r\n $name = $day[date(\"w\", strtotime($date .\' +\'.$i.\' day\'))];\r\n sg(\"ow_day\".$i.\".name\", $name);\r\n } ','','2017-10-28 19:31:03'),(485,'script23',0,'//------ включение-выключение реле-----\r\n//------ esp8266 WiFi IoT \r\n//getURL (\"http://ip_adres/gpio&st=1&pin=13\",0);\r\n//getURL (\"http://ip_adres/gpio&st=0&pin=13\",0);\r\n//------ esp8266 скетч http://кушеев.рф/archives/836\r\n//getURL (\"http://ip_adres/gpio13on\",0);\r\n//getURL (\"http://ip_adres/gpio13off\",0);\r\n//------ iMatic http://кушеев.рф/archives/494\r\n//exec (\"python /var/www/cms/scenes/imatic.py 13 1\");\r\n//exec (\"python /var/www/cms/scenes/imatic.py 13 0);\r\n//------ Arduino uart скетч http://кушеев.рф/archives/650\r\n//exec (\"echo 1013 > /dev/ttyS3\");\r\n//exec (\"echo 1113 > /dev/ttyS3\");\r\n//------ GPIO http://кушеев.рф/archives/817\r\n// exec (\"gpio -1 write 29 0\")\r\n// exec (\"gpio -1 write 29 1\")\r\n//------ i2c http://кушеев.рф/archives/923\r\n// exec (\"/var/www/cms/scenes/rele.sh 0x20 1 0\");\r\n// exec (\"/var/www/cms/scenes/rele.sh 0x20 1 1\");\r\n//------ 433Utils\r\n//exec (\"/var/www/cms/scenes/codesend433 7777777\");\r\n//exec (\"/var/www/cms/scenes/codesend315 7777777\");\r\n\r\n$n = $params[\'nameobj\'];\r\n\r\nif ($n == \"Switch1\") {\r\n if (getGlobal(\"Switch1.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 1 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 1 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch2\") {\r\n if (getGlobal(\"Switch2.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 2 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 2 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch3\") {\r\n if (getGlobal(\"Switch3.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 4 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 4 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch4\") {\r\n if (getGlobal(\"Switch4.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 8 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 8 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch5\") {\r\n if (getGlobal(\"Switch5.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 16 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 16 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch6\") {\r\n if (getGlobal(\"Switch6.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 32 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 32 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch7\") {\r\n if (getGlobal(\"Switch7.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 64 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 64 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch8\") {\r\n if (getGlobal(\"Switch8.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 128 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 128 1\");        \r\n    }\r\n}\r\n\r\n','','2018-03-18 23:26:09'),(284,'script28',0,'$filename  = ROOT . \'/database_backup/db.sql\';\r\n$mysqlDumpPath = \"/usr/bin/mysqldump\";\r\n$mysqlDumpParam = \" --user=\" . DB_USER . \" --password=\" . DB_PASSWORD;\r\n$mysqlDumpParam .= \" --no-create-db --add-drop-table --databases \" . DB_NAME;\r\nif (file_exists($filename)) rename($filename, $filename . \'.prev\');\r\nexec($mysqlDumpPath . $mysqlDumpParam . \" > \" . $filename);\r\nsay(\"Подготовка к перезагрузке\",2);\r\nsetTimeout(\"shutdownTimer\",\"safe_exec(\'shutdown -r now\');\",15); ','','2017-10-28 19:27:30'),(286,'script29',0,'$filename  = ROOT . \'/database_backup/db.sql\';\r\n$mysqlDumpPath = \"/usr/bin/mysqldump\";\r\n$mysqlDumpParam = \" --user=\" . DB_USER . \" --password=\" . DB_PASSWORD;\r\n$mysqlDumpParam .= \" --no-create-db --add-drop-table --databases \" . DB_NAME;\r\nif (file_exists($filename)) rename($filename, $filename . \'.prev\');\r\nexec($mysqlDumpPath . $mysqlDumpParam . \" > \" . $filename);\r\nsay(\"Подготовка к выключению\",2);\r\nsetTimeout(\"shutdownTimer\",\"safe_exec(\'shutdown -h now\');\",15); ','','2017-10-28 19:28:22'),(512,'command143',0,'','','2020-01-28 17:39:38'),(511,'command142',0,'','','2020-01-28 17:35:43'),(517,'command147',0,'','','2020-01-28 17:42:30'),(513,'command144',0,'','','2020-01-28 17:40:11'),(516,'command148',0,'','','2020-01-28 17:42:03'),(521,'method208',0,'$temp_s=$this->getProperty(\'tu\');\r\n$temp_s=$temp_s-1;\r\n$this->setProperty(\'tu\',$temp_s);','','2020-01-28 18:00:55'),(305,'command149',0,'','','2017-10-28 20:24:49'),(307,'command150',0,'','','2017-10-28 20:27:52'),(310,'script31',0,'$filename  = ROOT . \'/database_backup/db.sql\';\r\n$mysqlDumpPath = \"/usr/bin/mysqldump\";\r\n$mysqlDumpParam = \" --user=\" . DB_USER . \" --password=\" . DB_PASSWORD;\r\n$mysqlDumpParam .= \" --no-create-db --add-drop-table --databases \" . DB_NAME;\r\nif (file_exists($filename)) rename($filename, $filename . \'.prev\');\r\nexec($mysqlDumpPath . $mysqlDumpParam . \" > \" . $filename);\r\nsay(\"Бэкаплю базу данных\",2);','','2017-10-29 20:08:43'),(382,'script32',0,'$temp0 = file_get_contents (\"/sys/class/thermal/thermal_zone0/temp\");\r\nsg(\'pctemp\',$temp0);\r\n//CPU temp\r\n$cpu_temp=shell_exec(\'cat /sys/class/thermal/thermal_zone0/temp\') / 1000;\r\n$cpu_temp=round($cpu_temp,1);\r\nsg(\"CPU_temp\",$cpu_temp);\r\n\r\n//CPU usage\r\n$cpu_usage=exec(\"top -bn 1 | awk \'{print $9}\' | tail -n +8 | awk \'{s+=$1} END {print s}\'\");\r\nsg(\"CPU_usage\",$cpu_usage);\r\n\r\n//System uptime\r\n$sys_uptime=shell_exec(\"uptime\");\r\n$sys_uptime = explode(\" up \", $sys_uptime);\r\n$sys_uptime = explode(\",\", $sys_uptime[1]);\r\n$sys_uptime = $sys_uptime[0].\", \".$sys_uptime[1];\r\nsg(\"System_uptime\",$sys_uptime);\r\n\r\n//Memory usage/total\r\n$mem_total=exec(\"cat /proc/meminfo | grep MemTotal | awk \'{print $2}\'\");\r\n$mem_usage=$mem_total - exec(\"cat /proc/meminfo | grep MemFree | awk \'{print $2}\'\");\r\n$sys_memory=round($mem_usage * 100 / $mem_total, 1);\r\nsg(\"System_memory\",$sys_memory);\r\n\r\n//Memory Card\r\n$bytes = disk_free_space(\".\"); \r\n$si_prefix = array( \'B\', \'KB\', \'MB\', \'GB\', \'TB\', \'EB\', \'ZB\', \'YB\' );\r\n$base = 1024;\r\n$class = min((int)log($bytes , $base) , count($si_prefix) - 1);\r\n$temp = round($bytes / pow($base,$class)) . \' \' . $si_prefix[$class];\r\nsg(\'System_freespace\',$temp);\r\n\r\n//CPU 1 5 15\r\n$cpu_load=shell_exec(\'cat /proc/loadavg\');\r\n$pos1 = strpos($cpu_load,\" \");\r\n$pos2 = strpos($cpu_load,\" \",$pos1+1);\r\n$pos3 = strpos($cpu_load,\" \",$pos2+1);\r\n$cpu_load1  = substr($cpu_load,0,$pos1);\r\n$cpu_load5  = substr($cpu_load,$pos1+1,$pos2-$pos1-1);\r\n$cpu_load15 = substr($cpu_load,$pos2+1,$pos3-$pos2-1);\r\nsg(\"cpu_load1\",$cpu_load1);\r\nsg(\"cpu_load5\",$cpu_load5);\r\nsg(\"cpu_load15\",$cpu_load15);\r\n//mem info\r\n$mem_info=shell_exec(\'cat /proc/meminfo\');\r\n$pos1 = strpos($mem_info,\"MemTotal\");\r\n$pos2 = strpos($mem_info,\"MemFree\");\r\n$pos3 = strpos($mem_info,\"Cached\");\r\n$pos4 = strpos($mem_info,\"SwapTotal\");\r\n$pos5 = strpos($mem_info,\"SwapFree\");\r\n$mem_total = substr($mem_info,$pos1+11,13)*1;\r\n$mem_free = substr($mem_info,$pos2+11,13)*1;\r\n$mem_cached = substr($mem_info,$pos3+11,13)*1;\r\n$mem_swap_total = substr($mem_info,$pos4+11,13)*1;\r\n$mem_swap_free = substr($mem_info,$pos5+11,13)*1;\r\n$mem_swap_used = $mem_swap_total - $mem_swap_free;\r\n$mem_used = $mem_total - $mem_free - $mem_cached;\r\nsg(\"mem_total\",$mem_total);\r\nsg(\"mem_free\",$mem_free);\r\nsg(\"mem_cached\",$mem_cached);\r\nsg(\"mem_swap_total\",$mem_swap_total);\r\nsg(\"mem_swap_free\",$mem_swap_free);\r\nsg(\"mem_swap_used\",$mem_swap_used);\r\nsg(\"mem_used\",$mem_used);\r\n\r\n$sd_info=shell_exec(\'df /\');\r\n$pos0 = strpos($sd_info,\"dev\");\r\n$pos1 = strpos($sd_info,\" \",$pos0+5);\r\n$pos2 = strpos($sd_info,\" \",$pos1+3);\r\n$pos3 = strpos($sd_info,\" \",$pos2+3);\r\n$pos4 = strpos($sd_info,\" \",$pos3+4);\r\n$sd_total = substr($sd_info,$pos1,$pos2-$pos1)*1;\r\n$sd_used = substr($sd_info,$pos2,$pos3-$pos2)*1;\r\n$sd_free = substr($sd_info,$pos3,$pos4-$pos3)*1;\r\nsg(\"sd_total\",$sd_total);\r\nsg(\"sd_used\",$sd_used);\r\nsg(\"sd_free\",$sd_free);\r\n','','2017-12-05 01:29:05'),(341,'webvar9',0,'','','2017-12-03 21:53:20'),(351,'webvar10',0,'','','2017-12-03 22:23:06'),(340,'webvar11',0,'','','2017-12-03 21:45:33'),(344,'webvar12',0,'','','2017-12-03 22:01:20'),(384,'script10',0,'//setTimeOut(\'testTimer\',\'say(\"Hello world!\");\',30);\r\n\r\n$myip = $_SERVER[\'SERVER_ADDR\'];\r\n\r\necho $myip;','','2018-03-09 11:09:12'),(387,'script33',0,'$mod=gg(\'securityMode\');\r\n\r\nif ($mod){\r\n sg(\'securityMode\',0);\r\n}else{\r\n sg(\'securityMode\',1);\r\n}\r\n\r\n\r\n\r\n','','2018-03-16 23:12:15'),(389,'script34',0,'$mod=gg(\'Econom\');\r\n\r\nif ($mod){\r\n sg(\'Econom\',0);\r\n}else{\r\n sg(\'Econom\',1);\r\n}\r\n\r\n\r\n\r\n','','2018-03-16 23:26:03'),(399,'tlgaction2',0,'','','2018-03-17 01:59:18'),(400,'tlgaction3',0,'return \"Выберите действие:\";','','2018-03-17 01:59:34'),(398,'tlgaction4',0,'return \"Выберите действие:\";','','2018-03-17 01:59:10'),(486,'script12',0,'$id=$params[\'rcswitch\'];\r\nif ($id==\'15170948\') {\r\n //золотистый 3-кл, клавиша 1\r\ncallMethod(\'Switch1.switch\'); \r\n}\r\nif ($id==\'15170946\') {\r\n //золотистый 3-кл, клавиша 2\r\ncallMethod(\'Switch2.switch\'); \r\n}\r\nif ($id==\'15170952\') {\r\n //золотистый 3-кл, клавиша 3\r\ncallMethod(\'Switch3.switch\'); \r\n}\r\nif ($id==\'15170950\') {\r\n //золотистый 3-кл, клавиша 1+2\r\ncallMethod(\'Switch4.switch\'); \r\n}\r\nif ($id==\'15170954\') {\r\n //золотистый 3-кл, клавиша 2+3\r\ncallMethod(\'Switch5.switch\'); \r\n}\r\nif ($id==\'15170956\') {\r\n //золотистый 3-кл, клавиша 1+3\r\ncallMethod(\'Switch6.switch\'); \r\n}','','2018-03-18 23:31:28'),(443,'script26',0,'$n = $params[\'url\'];\r\n$m = $params[\'coun\'];\r\n$s = $params[\'vid\'];\r\n//$n = \"https://youtu.be/JYBpu1OyP0c\";\r\n//$m = \"5\";\r\nshell_exec(\"/var/www/cam/1 $n $m $s\");','','2018-03-17 16:30:01'),(458,'tlgaction5',0,'','','2018-03-17 20:07:37'),(466,'tlgaction1',0,'$off = hex2bin(\'F09F8C91\');\r\n$off1 = hex2bin(\'F09F94B4\');\r\n$on  = hex2bin(\'F09F8C95\');\r\n$on1  = hex2bin(\'F09F94B5\');\r\n$cam = hex2bin(\'F09F8EA5\');	\r\n$pog = hex2bin(\'E29B85\');\r\n$sta = hex2bin(\'F09F92AC\');\r\n$p1 =  hex2bin(\'F09F9188\');\r\n$p2 =  hex2bin(\'F09F9189\');\r\n$p3 =  hex2bin(\'F09F9187\');\r\n$p4 =  hex2bin(\'F09F9186\');\r\n$p5 =  hex2bin(\'F09F918D\');\r\n\r\n$st1 = $off;\r\n$st2 = $off;\r\nif(gg(\"securityMode\")){$st1=$on;}\r\nif(gg(\"Econom\")){$st2=$on;}\r\n//основное меню\r\n$option1 = array(array($cam.\"Камеры\", $pog.\"Погода\", $sta.\"Статус\"),array($st1.\"Охрана\", $st2.\"Эконом\",\"Освещение\"),array(\"Назад\"));\r\n//меню камер\r\n$option2 = array(array($cam.\"Токио\", $cam.\"NASA1\", $cam.\"NASA2\", $cam.\"Птички\"),array($cam.\"Питер1\", $cam.\"Питер2\", $cam.\"Акв1\", $cam.\"Акв2\"),array(\"меню\"));\r\n//меню освещение\r\n$option3 = array(array($cam.\"комната1\", $cam.\"комната2\", $cam.\"комната3\", $cam.\"комната4\"),array($cam.\"комната5\", $cam.\"комната6\", $cam.\"комната7\", $cam.\"комната8\"),array(\"меню\"));\r\n\r\n\r\n//режим экономии\r\n$pos = strripos($text , \"Эконом\");\r\nif ($pos > -1) {\r\n 	if (gg(\"Econom\")){\r\n 	sg(\"Econom\",0);\r\n    $status=\"отключен\";\r\n    $st2=$off;\r\n	}else{\r\n 	sg(\"Econom\",1);\r\n    $status=\"включен\";\r\n    $st2=$on;\r\n	}\r\n 	$option1 = array(array($cam.\"Камеры\", $pog.\"Погода\", $sta.\"Статус\"),array($st1.\"Охрана\", $st2.\"Эконом\",\"Освещение\"),array(\"Назад\"));\r\n 	$this->sendMessageToUser($chat_id,\"Режим экономии \".$status,$option1);\r\n   	$skip = true;\r\n}\r\n//режим охраны\r\n$pos = strripos($text , \"Охрана\");\r\nif ($pos > -1) {\r\n 	if (gg(\"securityMode\")){\r\n 	sg(\"securityMode\",0);\r\n    $status=\"выключена\";\r\n    $st1=$off;\r\n	}else{\r\n 	sg(\"securityMode\",1);\r\n    $status=\"включена\";\r\n    $st1=$on;\r\n	}\r\n 	$option1 = array(array($cam.\"Камеры\", $pog.\"Погода\", $sta.\"Статус\"),array($st1.\"Охрана\", $st2.\"Эконом\",\"Освещение\"),array(\"Назад\"));\r\n 	$this->sendMessageToUser($chat_id,\"Охрана \".$status,$option1);\r\n   	$skip = true;\r\n}\r\n\r\n\r\n//вызов меню камер\r\n$pos = strripos($text , \"Камеры\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите камеру:\",$option2);\r\n   	$skip = true;\r\n}\r\n//вызов меню света\r\n$pos = strripos($text , \"Освещение\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите свет:\",$option3);\r\n   	$skip = true;\r\n}\r\n\r\n\r\n//отправка изображения с камер\r\n\r\n$pos = strripos($text , \"Токио\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/JYBpu1OyP0c\";\r\n$par2 = \"1\";\r\n$par3 = \"96\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"NASA1\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/RtU_mdL2vBM\";\r\n$par2 = \"2\";\r\n$par3 = \"301\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"NASA2\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/ddFvjfvPnqk\";\r\n$par2 = \"3\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Птички\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/jECodSsU8Ds\";\r\n$par2 = \"4\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Питер1\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/OCfjCg4LeDA\";\r\n$par2 = \"5\";\r\n$par3 = \"94\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Питер2\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/oioklYcidp0\";\r\n$par2 = \"6\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Акв1\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/FEiOjdr9Nz4\";\r\n$par2 = \"7\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Акв2\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/jKtjpJBM2x8\";\r\n$par2 = \"8\";\r\n$par3 = \"96\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n\r\n\r\n$pos = strripos($text , \"Камера\");\r\nif ($pos > -1) {\r\n 	$channel=substr($text, -1);\r\n	$url=\"rtsp://192.168.1.10:554/user=immortal&password=123525654&channel=\".$channel.\"&stream=0.sdp?\";  \r\n	$jpg=\"/var/www/cached/snapshot.jpg\";\r\n	exec(\'ffmpeg -y -i \"\'.$url.\'\" -f image2 -vframes 1 \'.$jpg);\r\n	$this->sendImageToUser($chat_id,$jpg,\"Камера \".$channel,$option2);\r\n   $skip = true;\r\n}\r\n//показать погоду\r\n$pos = strripos($text , \"Погода\");\r\nif ($pos > -1) {\r\n	$weather=     \"Сейчас\".hex2bin(\'F09F8CA1\').gg(\'ow_fact.temperature\').\"°C,\".gg(\'ow_fact.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_fact.wind_direction_my\').\" \".gg(\'ow_fact.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_fact.humidity\').\"%, \".hex2bin(\'F09F92AA\').round(gg(\'ow_fact.pressure_mmhg\'),0);\r\n	$weather.=\"\\r\\nЗавтра\".hex2bin(\'F09F8CA1\').gg(\'ow_day1.temperature\').\"°C,\".gg(\'ow_day1.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_day1.wind_direction_my\').\" \".gg(\'ow_day1.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_day1.humidity\').\"%, \".hex2bin(\'F09F92AA\').gg(\'ow_day1.pressure_mmhg\');\r\n	$weather.=\"\\r\\n\".substr(gg(\'ow_day2.date\'),0,6).hex2bin(\'F09F8CA1\').gg(\'ow_day2.temperature\').\"°C,\".gg(\'ow_day2.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_day2.wind_direction_my\').\" \".gg(\'ow_day2.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_day2.humidity\').\"%, \".hex2bin(\'F09F92AA\').round(gg(\'ow_day2.pressure_mmhg\'),0);\r\n	$weather.=\"\\r\\n\".substr(gg(\'ow_day3.date\'),0,6).hex2bin(\'F09F8CA1\').gg(\'ow_day3.temperature\').\"°C,\".gg(\'ow_day3.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_day3.wind_direction_my\').\" \".gg(\'ow_day3.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_day3.humidity\').\"%, \".hex2bin(\'F09F92AA\').round(gg(\'ow_day3.pressure_mmhg\'),0);\r\n	$this->sendMessageToUser($chat_id, $weather, $option1);\r\n	$skip = true;\r\n}\r\n//показать статус\r\n$pos = strripos($text , \"Статус\");\r\nif ($pos > -1) {\r\n if(gg(\'clapan1.status\')){$sttc1=$on1;}else{$sttc1=$off1;};\r\n if(gg(\'clapan2.status\')){$sttc2=$on1;}else{$sttc2=$off1;};\r\n if(gg(\'clapan3.status\')){$sttc3=$on1;}else{$sttc3=$off1;};\r\n if(gg(\'clapan4.status\')){$sttc4=$on1;}else{$sttc4=$off1;};\r\n if(gg(\'clapan5.status\')){$sttc5=$on1;}else{$sttc5=$off1;};\r\n if(gg(\'clapan6.status\')){$sttc6=$on1;}else{$sttc6=$off1;};\r\n if(gg(\'clapan7.status\')){$sttc7=$on1;}else{$sttc7=$off1;};\r\n if(gg(\'clapan8.status\')){$sttc8=$on1;}else{$sttc8=$off1;};\r\n if(gg(\'clapan10.status\')){$sttc10=$on1;}else{$sttc10=$off1;}; \r\n	$weather=     $sttc1.\"Комната1:\".hex2bin(\'F09F8CA1\').gg(\'tempD1.temp\').\"°C,\";\r\n	$weather.=\"\\r\\n\".$sttc2.\"Комната2:\".hex2bin(\'F09F8CA1\').gg(\'tempD2.temp\').\"°C,\";\r\n	$weather.=\"\\r\\n\".$sttc3.\"Комната3:\".hex2bin(\'F09F8CA1\').gg(\'tempD3.temp\').\"°C,\";\r\n	$weather.=   \"\\r\\n\".$sttc4.\"Комната4:\".hex2bin(\'F09F8CA1\').gg(\'tempD4.temp\').\"°C,\";\r\n	$weather.= \"\\r\\n\".$sttc5.\"Комната5:\".hex2bin(\'F09F8CA1\').gg(\'tempD5.temp\').\"°C,\";\r\n	$weather.=    \"\\r\\n\".$sttc6.\"Комната6:\".hex2bin(\'F09F8CA1\').gg(\'tempD6.temp\').\"°C,\";\r\n	$weather.=\"\\r\\n\".$sttc7.\"Комната7:\".hex2bin(\'F09F8CA1\').gg(\'tempD7.temp\').\"°C,\";\r\n 	$weather.=\"\\r\\n\".$sttc8.\"Комната8:\".hex2bin(\'F09F8CA1\').gg(\'tempD8.temp\').\"°C,\";\r\n 	$weather.=  \"\\r\\n\".$sttc10.\"Комната9:\".hex2bin(\'F09F8CA1\').gg(\'tempD10.temp\').\"°C,\";\r\n\r\n	$this->sendMessageToUser($chat_id, $weather, $option1);\r\n	$skip = true;\r\n}\r\necho $text;\r\n$pos = strripos($text , \"как пройти\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,$p1.\" \".$p2.\" \".$p2.\" \".$p1.\" \".$p2.\" \".$p1.\" \".$p4.\" \".$p5);\r\n 	$skip = true;\r\n}\r\n\r\n//показать меню\r\necho $text;\r\n$pos = strripos($text , \"Меню\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите действие:\",$option1);\r\n 	$skip = true;\r\n}\r\necho $text;\r\n$pos = strripos($text , \"меню\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите действие:\",$option1);\r\n 	$skip = true;\r\n}\r\n','','2018-03-17 21:07:36'),(490,'pattern10',0,'','','2018-04-09 21:05:35'),(470,'pattern11',0,'','','2018-03-17 21:11:12'),(483,'object191_method140',0,'$command=mb_strtolower($params[\'command\']);\r\n\r\n$short_command=\'\';\r\n$dt=recognizeTime($command,$short_command);\r\n\r\nif (preg_match(\'/скажи сколько врем/is\',$command)) {\r\n if ($dt>0) {\r\n  addScheduledJob(\"command\".$dt,\"processCommand(\'\".$short_command.\"\');\",$dt);\r\n  say(\'Задача принята\',2);\r\n  return;\r\n }\r\n global $voicemode;\r\n $voicemode=\'on\';\r\n say(\'Сейчас \'.timeNow(),2);\r\n} elseif (preg_match(\'/сколько время/is\',$command)) {\r\n if ($dt>0) {\r\n  addScheduledJob(\"command\".$dt,\"processCommand(\'\".$short_command.\"\');\",$dt);\r\n  say(\'Задача принята\');\r\n  echo $short_command;\r\n  return;\r\n }\r\n say(\'Сейчас \'.timeNow(),2);\r\n} elseif (preg_match(\'/повтори (.+)/is\',$command,$m) || preg_match(\'/скажи (.+)/is\',$command,$m)) {\r\n if ($dt>0) {\r\n  addScheduledJob(\"command\".$dt,\"processCommand(\'\".$short_command.\"\');\",$dt);\r\n  say(\'Задача принята\',2);\r\n  return;\r\n }\r\n global $voicemode;\r\n $voicemode=\'on\';\r\n say($m[1],2);\r\n} else {\r\n //say(\'Неизвестная команда...\',2);\r\n}','','2018-03-17 23:35:11'),(484,'pattern12',0,'','','2018-03-17 23:37:29'),(479,'pattern13',0,'','','2018-03-17 22:06:14'),(488,'command152',0,'','','2018-03-18 23:52:30'),(492,'script35',0,'$tek = gg(\"tempP1\");\r\n$tek = $tek-1;\r\nsg(\"tempP1\", $tek);','','2020-01-27 19:47:49'),(494,'script36',0,'$tek = gg(\"tempP1\");\r\n$tek = $tek+1;\r\nsg(\"tempP1\", $tek);','','2020-01-27 19:56:29'),(495,'script37',0,'$tek = gg(\"tempP2\");\r\n$tek = $tek+1;\r\nsg(\"tempP2\", $tek);','','2020-01-27 20:11:10'),(496,'script38',0,'$tek = gg(\"tempP3\");\r\n$tek = $tek+1;\r\nsg(\"tempP3\", $tek);','','2020-01-27 20:11:28'),(497,'script39',0,'$tek = gg(\"tempP2\");\r\n$tek = $tek-1;\r\nsg(\"tempP2\", $tek);','','2020-01-27 20:11:51'),(498,'script40',0,'$tek = gg(\"tempP3\");\r\n$tek = $tek-1;\r\nsg(\"tempP3\", $tek);','','2020-01-27 20:12:13'),(502,'method207',0,'$temp_s=$this->getProperty(\'tu\');\r\n$temp_s=$temp_s+1;\r\n$this->setProperty(\'tu\',$temp_s);','','2020-01-27 21:29:28'),(503,'script41',0,'$tek = gg(\"tempP4\");\r\n$tek = $tek-1;\r\nsg(\"tempP4\", $tek);','','2020-01-27 22:38:50'),(504,'script42',0,'$tek = gg(\"tempP4\");\r\n$tek = $tek+1;\r\nsg(\"tempP4\", $tek);','','2020-01-27 22:39:20'),(508,'command139',0,'','','2020-01-28 17:33:13'),(509,'command140',0,'','','2020-01-28 17:34:04'),(510,'command141',0,'','','2020-01-28 17:35:14'),(514,'command145',0,'','','2020-01-28 17:40:43'),(515,'command146',0,'','','2020-01-28 17:41:21'),(519,'script30',0,'// $pom - количество помещений\r\n$pom = 10;\r\n// $pom1 - номер помещения которое открыто при\r\n// закрытии всех клапанов\r\n$pom1 = 8;\r\n// если возможно перекрытие всех клапанов\r\n// то $clall больше i на 1, иначе $clall = i;\r\n$clall = 10;\r\nfor ($i = 1; $i <= $pom; $i++) {\r\n	$tempcab[1]=gg(\"tempD\".$i.\".temp\");\r\n  	if (gg(\"Econom\")) {\r\n  		$tempstab[1]=gg(\"EnergoMinTemp\");\r\n  	}else{\r\n  		$tempstab[1]=gg(\"tempD\".$i.\".tu\");\r\n  	}\r\n	if($tempstab[1]<$tempcab[1]){\r\n		sg(\"clapan\".$i.\".status\", \"1\");\r\n     	$clall++;\r\n	}else{\r\n		sg(\"clapan\".$i.\".status\", \"0\");\r\n	}\r\n}\r\nif($clall==$pom){\r\n sg(\"clapan\".$pom1.\".status\", \"0\");\r\n}\r\n// управление реле, команды для разных реле смотреть\r\n// в скрипте scene_switch\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 1 \".gg(\"clapan1.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 2 \".gg(\"clapan2.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 4 \".gg(\"clapan3.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 8 \".gg(\"clapan4.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 16 \".gg(\"clapan5.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 32 \".gg(\"clapan6.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 128 \".gg(\"clapan7.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 256 \".gg(\"clapan8.status\"));\r\n\r\n','','2020-01-28 17:48:38');
/*!40000 ALTER TABLE `blockly_code` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `btdevices`
--

DROP TABLE IF EXISTS `btdevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `btdevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `MAC` varchar(255) NOT NULL DEFAULT '',
  `LOG` text NOT NULL,
  `LAST_FOUND` datetime DEFAULT NULL,
  `FIRST_FOUND` datetime DEFAULT NULL,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `USER_ID` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `btdevices`
--

LOCK TABLES `btdevices` WRITE;
/*!40000 ALTER TABLE `btdevices` DISABLE KEYS */;
INSERT INTO `btdevices` VALUES (3,'Устройство: n/a','3c:97:0e:c6:c9:fe','Device found 2018/02/10 20:24:27\n','2018-02-10 20:33:59','2018-02-10 20:24:27',0,0),(4,'Устройство: Lenovo A536','74:04:2b:70:58:9f','Device found 2018/02/12 17:38:37\n','2018-02-18 11:32:11','2018-02-12 17:38:37',0,0),(5,'Устройство: ZTE Blade GF3','4c:16:f1:6e:b4:df','Device found 2018/02/13 16:04:10\n','2018-02-18 11:32:11','2018-02-13 16:04:10',0,0),(6,'Устройство: n/a','fc:ff:1a:b4:7f:e2','Device found 2018/02/16 08:31:55\n','2018-02-18 11:32:11','2018-02-16 08:31:55',0,0),(7,'Устройство: n/a','80:61:8f:a1:ab:3e','Device found 2018/02/17 15:40:18\n','2018-02-18 11:32:11','2018-02-17 15:40:18',0,0);
/*!40000 ALTER TABLE `btdevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cached_values`
--

DROP TABLE IF EXISTS `cached_values`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cached_values` (
  `KEYWORD` char(100) NOT NULL,
  `DATAVALUE` char(255) NOT NULL,
  `EXPIRE` datetime NOT NULL,
  PRIMARY KEY (`KEYWORD`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cached_values`
--

LOCK TABLES `cached_values` WRITE;
/*!40000 ALTER TABLE `cached_values` DISABLE KEYS */;
INSERT INTO `cached_values` VALUES ('MJD:ThisComputer.cycle_pingDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_pingControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_skypeDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_skypeControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_wscacheDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_wscacheControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_cronDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_cronControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_mainDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_mainControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_mysensorDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_mysensorControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_onewireDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_onewireControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_connectDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_connectControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_telegramDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_telegramControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_energomeraDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_energomeraControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_phistoryDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_phistoryControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_xiaomihomeDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_xiaomihomeControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_rss_channelsDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_rss_channelsControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_mqttDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_mqttControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_db_saveDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_db_saveControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_rssDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_rssControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_webvarsDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_webvarsControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_schedulerDisabled','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_schedulerControl','','2020-01-28 00:49:49'),('MJD:ThisComputer.cycle_onewire_starredDisabled','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_onewire_starredControl','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_execsDisabled','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_execsControl','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_X101_skypeDisabled','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_X101_skypeControl','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_yandexweatherDisabled','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_yandexweatherControl','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_websocketsDisabled','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_websocketsControl','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_statesDisabled','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_statesControl','','2020-01-28 00:49:50'),('MJD:ThisComputer.cycle_pingRun','1580231723','2020-01-28 20:16:23'),('MJD:ThisComputer.cycle_skypeRun','','2020-01-28 00:49:53'),('MJD:ThisComputer.cycle_wscacheRun','1580231731','2020-01-28 20:16:31'),('MJD:ThisComputer.cycle_cronRun','1580231731','2020-01-28 20:16:31'),('MJD:ThisComputer.cycle_mainRun','1580231729','2020-01-28 20:16:29'),('MJD:ThisComputer.cycle_mysensorRun','','2020-01-28 00:49:53'),('MJD:ThisComputer.cycle_onewireRun','','2020-01-28 00:49:53'),('MJD:Switch2.status','0','2020-01-28 20:12:16'),('MJD:ThisComputer.cycle_connectRun','','2020-01-28 00:49:53'),('MJD:Switch1.status','0','2020-01-28 16:59:01'),('MJD:ThisComputer.cycle_telegramRun','1580231731','2020-01-28 20:16:31'),('MJD:ThisComputer.cycle_energomeraRun','','2020-01-28 00:49:53'),('MJD:Switch3.status','0','2020-01-28 00:49:51'),('MJD:Switch4.status','0','2020-01-28 00:49:51'),('MJD:ThisComputer.cycle_phistoryRun','1580231731','2020-01-28 20:16:31'),('MJD:ThisComputer.cycle_xiaomihomeRun','1580231729','2020-01-28 20:16:29'),('MJD:Switch5.status','0','2020-01-28 00:49:52'),('MJD:ThisComputer.cycle_rss_channelsRun','1580231725','2020-01-28 20:16:25'),('MJD:Switch7.status','0','2020-01-28 00:49:52'),('MJD:ThisComputer.cycle_webvarsRun','1580231726','2020-01-28 20:16:26'),('MJD:Switch6.status','0','2020-01-28 00:49:52'),('MJD:ThisComputer.cycle_db_saveRun','1580231731','2020-01-28 20:16:31'),('MJD:ThisComputer.cycle_mqttRun','1580231730','2020-01-28 20:16:30'),('MJD:ThisComputer.cycle_rssRun','1580231725','2020-01-28 20:16:25'),('MJD:ThisComputer.cycle_schedulerRun','1580231728','2020-01-28 20:16:28'),('MJD:ThisComputer.runCronUpdater','20:15','2020-01-28 20:16:10'),('MJD:ThisComputer.phistory_queue_limit','','2020-01-28 00:49:52'),('MJD:clapan1.status','1','2020-01-28 20:16:00'),('MJD:ThisComputer.cycle_statesRun','1580231725','2020-01-28 20:16:25'),('MJD:ThisComputer.cycle_execsRun','1580231723','2020-01-28 20:16:23'),('MJD:ThisComputer.cycle_onewire_starredRun','','2020-01-28 00:49:53'),('MJD:ThisComputer.cycle_yandexweatherRun','1580231731','2020-01-28 20:16:31'),('MJD:clapan2.status','0','2020-01-28 20:16:00'),('MJD:ThisComputer.cycle_websocketsRun','1580231731','2020-01-28 20:16:31'),('MJD:ThisComputer.cycle_X101_skypeRun','','2020-01-28 00:49:53'),('MJD:Security.stateColor','green','2020-01-28 00:49:52'),('MJD:clapan3.status','1','2020-01-28 20:16:00'),('MJD:ThisComputer.phistory_queue_problem','','2020-01-28 00:49:52'),('MJD:clapan4.status','0','2020-01-28 20:16:00'),('MJD:System.stateColor','green','2020-01-28 00:49:52'),('MJD:ThisComputer.timeNow','20:15','2020-01-28 20:16:00'),('MJD:yw_mycity.temp','-10','2020-01-28 19:50:33'),('MJD:ThisComputer.DayOfWeekTXT','','2020-01-28 00:49:52'),('MJD:Communication.stateColor','green','2020-01-28 00:49:52'),('MJD:ThisComputer.DayOfMonthNum','','2020-01-28 00:49:52'),('MJD:ThisComputer.MonthTXTalt','','2020-01-28 00:49:52'),('MJD:yw_mycity.wind_speed','4.1','2020-01-28 19:50:33'),('MJD:yw_mycity.humidity','83','2020-01-28 19:50:33'),('MJD:tempD1.temp','23','2020-01-28 00:49:52'),('MJD:tempD3.temp','20','2020-01-28 00:49:52'),('MJD:ThisComputer.tempP1','22','2020-01-28 01:59:27'),('MJD:ThisComputer.tempP3','19','2020-01-28 01:40:09'),('MJD:tempD4.temp','24','2020-01-28 00:49:52'),('MJD:ThisComputer.tempP4','21','2020-01-28 01:00:53'),('MJD:tempD2.temp','22','2020-01-28 00:49:52'),('MJD:ThisComputer.WSClientsTotal','11','2020-01-28 20:16:31'),('MJD:ThisComputer.sysdate','','2020-01-28 00:49:53'),('MJD:vologda.now',' 19:49','2020-01-28 19:50:33'),('MJD:vologda.forecast_0_date','28-01-2020','2020-01-28 19:50:33'),('MJD:vologda.forecast_1_date','29-01-2020','2020-01-28 19:50:33'),('MJD:vologda.forecast_2_date','30-01-2020','2020-01-28 19:50:33'),('MJD:vologda.forecast_3_date','31-01-2020','2020-01-28 19:50:33'),('MJD:vologda.ID','2','2020-01-28 19:50:33'),('MJD:yw_mycity.ID','2','2020-01-28 19:50:33'),('MJD:vologda.CID','21','2020-01-28 19:50:33'),('MJD:yw_mycity.CID','21','2020-01-28 19:50:33'),('MJD:vologda.mycity','1','2020-01-28 19:50:33'),('MJD:yw_mycity.mycity','1','2020-01-28 19:50:33'),('MJD:vologda.locality_name','Вологда','2020-01-28 19:50:33'),('MJD:yw_mycity.locality_name','Вологда','2020-01-28 19:50:33'),('MJD:vologda.district_name','','2020-01-28 19:50:33'),('MJD:yw_mycity.district_name','','2020-01-28 19:50:33'),('MJD:vologda.TITLE','vologda','2020-01-28 19:50:33'),('MJD:yw_mycity.TITLE','vologda','2020-01-28 19:50:33'),('MJD:vologda.DESCRIPTION','28.01.2020 19:49','2020-01-28 19:50:33'),('MJD:yw_mycity.DESCRIPTION','28.01.2020 19:49','2020-01-28 19:50:33'),('MJD:vologda.temp','-10','2020-01-28 19:50:33'),('MJD:vologda.feels_like','-16','2020-01-28 19:50:33'),('MJD:yw_mycity.feels_like','-16','2020-01-28 19:50:33'),('MJD:yw_mycity.trandtemp','=','2020-01-28 19:50:33'),('MJD:vologda.condition','overcast','2020-01-28 19:50:33'),('MJD:yw_mycity.trandtempfa','fa-pause-circle','2020-01-28 19:50:33'),('MJD:yw_mycity.condition','overcast','2020-01-28 19:50:33'),('MJD:yw_mycity.trandtemp-3','-10','2020-01-28 19:50:33'),('MJD:yw_mycity.pressure_mm','749','2020-01-28 19:50:33'),('MJD:vologda.wind_speed','4.1','2020-01-28 19:50:33'),('MJD:yw_mycity.trandpres','down','2020-01-28 19:50:33'),('MJD:yw_mycity.trandpresfa','fa-arrow-circle-down','2020-01-28 19:50:33'),('MJD:vologda.wind_dir','se','2020-01-28 19:50:33'),('MJD:yw_mycity.lastcondition','overcast','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_0_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:yw_mycity.wind_dir','se','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_1_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:yw_mycity.trandhum','down','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_2_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:vologda.pressure_mm','749','2020-01-28 19:50:33'),('MJD:yw_mycity.conditionrus','пасмурно','2020-01-28 19:50:33'),('MJD:yw_mycity.trandhumfa','fa-arrow-circle-down','2020-01-28 19:50:33'),('MJD:yw_mycity.condition1rus','пасмурно, небольшой снег','2020-01-28 19:50:33'),('MJD:yw_mycity.trandwind_speed','=','2020-01-28 19:50:33'),('MJD:yw_mycity.condition2rus','пасмурно, небольшой снег','2020-01-28 19:50:33'),('MJD:vologda.humidity','83','2020-01-28 19:50:33'),('MJD:yw_mycity.condition3rus','пасмурно, небольшой снег','2020-01-28 19:50:33'),('MJD:vologda.uv_index','0','2020-01-28 19:50:33'),('MJD:yw_mycity.uv_index','0','2020-01-28 19:50:33'),('MJD:vologda.forecast_1_day_temp_avg','-7','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_1_day_temp_avg','-7','2020-01-28 19:50:33'),('MJD:vologda.forecast_2_day_temp_avg','-5','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_2_day_temp_avg','-5','2020-01-28 19:50:33'),('MJD:vologda.forecast_3_day_temp_avg','-3','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_3_day_temp_avg','-3','2020-01-28 19:50:33'),('MJD:vologda.forecast_4_day_temp_avg','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_4_day_temp_avg','','2020-01-28 19:50:33'),('MJD:vologda.forecast_5_day_temp_avg','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_5_day_temp_avg','','2020-01-28 19:50:33'),('MJD:vologda.forecast_6_day_temp_avg','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_6_day_temp_avg','','2020-01-28 19:50:33'),('MJD:vologda.forecast_7_day_temp_avg','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_7_day_temp_avg','','2020-01-28 19:50:33'),('MJD:vologda.forecast_1_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:vologda.forecast_2_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:vologda.forecast_3_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_3_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:vologda.forecast_4_daycondition','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_4_daycondition','','2020-01-28 19:50:33'),('MJD:vologda.forecast_5_daycondition','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_5_daycondition','','2020-01-28 19:50:33'),('MJD:vologda.forecast_6_daycondition','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_6_daycondition','','2020-01-28 19:50:33'),('MJD:vologda.forecast_7_daycondition','','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_7_daycondition','','2020-01-28 19:50:33'),('MJD:vologda.forecast_0_morningcondition','overcast','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_0_morningcondition','overcast','2020-01-28 19:50:33'),('MJD:vologda.forecast_0_daycondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:vologda.forecast_0_eveningcondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:yw_mycity.forecast_0_eveningcondition','overcast-and-light-snow','2020-01-28 19:50:33'),('MJD:vologda.forecast_0_nightcondition','clear','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_nightcondition','clear','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_morning_temp_avg','-15','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_morning_temp_avg','-15','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_day_temp_avg','-11','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_day_temp_avg','-11','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_evening_temp_avg','-9','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_evening_temp_avg','-9','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_night_temp_avg','-18','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_night_temp_avg','-18','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_morning_wind_speed','3.5','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_morning_wind_speed','3.5','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_day_wind_speed','4','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_day_wind_speed','4','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_evening_wind_speed','4.1','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_evening_wind_speed','4.1','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_night_wind_speed','2','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_night_wind_speed','2','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_morning_wind_dir','se','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_morning_wind_dir','se','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_day_wind_dir','se','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_day_wind_dir','se','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_evening_wind_dir','se','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_evening_wind_dir','se','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_night_wind_dir','se','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_night_wind_dir','se','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_morning_pressure_mm','753','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_morning_pressure_mm','753','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_day_pressure_mm','751','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_day_pressure_mm','751','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_evening_pressure_mm','749','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_evening_pressure_mm','749','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_night_short_pressure_mm','753','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_night_short_pressure_mm','753','2020-01-28 19:50:34'),('MJD:vologda.day','','2020-01-28 19:50:34'),('MJD:yw_mycity.day','','2020-01-28 19:50:34'),('MJD:vologda.date','','2020-01-28 19:50:34'),('MJD:yw_mycity.date','','2020-01-28 19:50:34'),('MJD:vologda.date_ts','','2020-01-28 19:50:34'),('MJD:yw_mycity.date_ts','','2020-01-28 19:50:34'),('MJD:vologda.daytime','n','2020-01-28 19:50:34'),('MJD:yw_mycity.daytime','n','2020-01-28 19:50:34'),('MJD:vologda.season','winter','2020-01-28 19:50:34'),('MJD:yw_mycity.season','winter','2020-01-28 19:50:34'),('MJD:vologda.polar','','2020-01-28 19:50:34'),('MJD:yw_mycity.polar','','2020-01-28 19:50:34'),('MJD:vologda.soil_temp','-2','2020-01-28 19:50:34'),('MJD:yw_mycity.soil_temp','-2','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_sunrise','08:40','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_sunrise','08:40','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_sunset','16:27','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_sunset','16:27','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_week','5','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_week','5','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_rise_begin','07:53','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_rise_begin','07:53','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_set_end','17:14','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_set_end','17:14','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_moon_code','','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_moon_code','','2020-01-28 19:50:34'),('MJD:vologda.forecast_0_moon_text','','2020-01-28 19:50:34'),('MJD:yw_mycity.forecast_0_moon_text','','2020-01-28 19:50:34'),('MJD:ThisComputer.started_time','1580161739','2020-01-28 00:49:59'),('MJD:ThisComputer.Serial','340050344314203d040e','2020-01-28 00:49:58'),('MJD:ThisComputer.tempP2','22','2020-01-28 16:58:52'),('MJD:ThisComputer.uptime','69990','2020-01-28 20:16:29'),('MJD:ThisComputer.uptimeText','19h 26m','2020-01-28 20:16:29'),('MJD:ClockChime.time','2020-01-28 20:15:00','2020-01-28 20:16:00'),('MJD:ThisComputer.timeH','20','2020-01-28 20:16:00'),('MJD:ThisComputer.timeM','15','2020-01-28 20:16:00'),('MJD:ThisComputer.Econom','0','2020-01-28 00:50:00'),('MJD:tempD5.temp','21','2020-01-28 00:50:00'),('MJD:ThisComputer.tempP5','22','2020-01-28 00:50:00'),('MJD:clapan5.status','1','2020-01-28 20:16:00'),('MJD:tempD6.temp','23','2020-01-28 00:50:00'),('MJD:ThisComputer.tempP6','21','2020-01-28 00:50:00'),('MJD:clapan6.status','1','2020-01-28 20:16:00'),('MJD:tempD7.temp','22','2020-01-28 00:50:00'),('MJD:ThisComputer.tempP7','21','2020-01-28 00:50:00'),('MJD:clapan7.status','1','2020-01-28 20:16:00'),('MJD:tempD8.temp','','2020-01-28 00:50:00'),('MJD:ThisComputer.tempP8','22','2020-01-28 00:50:00'),('MJD:clapan8.status','0','2020-01-28 20:16:00'),('MJD:tempD9.temp','','2020-01-28 00:50:00'),('MJD:ThisComputer.tempP9','22','2020-01-28 00:50:00'),('MJD:clapan9.status','0','2020-01-28 20:16:00'),('MJD:tempD10.temp','','2020-01-28 00:50:00'),('MJD:ThisComputer.tempP10','22','2020-01-28 00:50:00'),('MJD:clapan10.status','0','2020-01-28 20:16:00'),('MJD:Security.stateDetails','','2020-01-28 00:50:00'),('MJD:System.stateDetails','','2020-01-28 00:50:00'),('MJD:Communication.stateDetails','','2020-01-28 00:50:00'),('MJD:ThisComputer.somebodyHomeText','','2020-01-28 00:50:00'),('MJD:ThisComputer.HideLeftPanelAdmin','','2020-01-28 00:50:14'),('MJD:key.2','Спальня','2020-01-28 01:00:36'),('MJD:myobject.coord1','55.752220','2020-01-28 01:01:00'),('MJD:ow_setting.updateTime','3','2020-01-28 01:01:00'),('MJD:ow_setting.countTime','3','2020-01-28 20:01:00'),('MJD:ThisComputer.SunRiseTime','07:18','2020-01-28 20:01:00'),('MJD:ow_city.id','472459','2020-01-28 01:01:00'),('MJD:ow_setting.api_key','c29bbadbdebec9469a16540b97ca3bf0','2020-01-28 01:01:00'),('MJD:ThisComputer.SunSetTime','15:40','2020-01-28 20:01:00'),('MJD:ow_setting.api_method','16d','2020-01-28 01:01:00'),('MJD:ow_setting.ow_round','0','2020-01-28 01:01:00'),('MJD:ThisComputer.LongTagTime','08:22','2020-01-28 20:01:00'),('MJD:ThisComputer.TransitTime','11:29','2020-01-28 20:01:00'),('MJD:ThisComputer.Chicivil_beginTime','06:37','2020-01-28 20:01:00'),('MJD:ThisComputer.civil_endTime','16:22','2020-01-28 20:01:00'),('MJD:ow_fact.temperature','-10','2020-01-28 19:01:00'),('MJD:ow_fact.weather_type','небольшой снег','2020-01-28 19:01:00'),('MJD:ow_fact.wind_direction','143','2020-01-28 19:01:00'),('MJD:ow_fact.wind_direction_text','ЮВ','2020-01-28 19:01:00'),('MJD:ow_fact.wind_direction_full','Юго-Восток','2020-01-28 19:01:00'),('MJD:ow_fact.wind_speed','5','2020-01-28 19:01:00'),('MJD:ow_fact.humidity','90','2020-01-28 19:01:00'),('MJD:ow_fact.pressure','1016','2020-01-28 19:01:01'),('MJD:ow_fact.pressure_mmhg','762','2020-01-28 19:01:01'),('MJD:ow_fact.image','13n','2020-01-28 19:01:01'),('MJD:ow_fact.clouds','100','2020-01-28 19:01:01'),('MJD:ow_fact.rain','','2020-01-28 19:01:01'),('MJD:ow_fact.condCode','600','2020-01-28 19:01:01'),('MJD:ow_city.data_update','28.01.2020 18:58:26 MSK 2020','2020-01-28 19:01:01'),('MJD:ow_city.lat','59.218700','2020-01-28 01:01:01'),('MJD:ow_city.lon','39.888599','2020-01-28 01:01:01'),('MJD:ow_fact.sunrise','1580189981','2020-01-28 19:01:01'),('MJD:ow_fact.sunset','1580218008','2020-01-28 19:01:01'),('MJD:ow_fact.day_length','28027','2020-01-28 19:01:01'),('MJD:ow_fact.transit','1580203995','2020-01-28 19:01:01'),('MJD:ow_fact.civil_twilight_begin','1580187161','2020-01-28 19:01:01'),('MJD:ow_fact.civil_twilight_end','1580220829','2020-01-28 19:01:01'),('MJD:ow_day0.date','28.01.2020','2020-01-28 19:01:01'),('MJD:ow_day0.temperature','-10','2020-01-28 19:01:01'),('MJD:ow_day0.temp_morn','-10','2020-01-28 19:01:01'),('MJD:ow_day0.temp_day','-10','2020-01-28 19:01:01'),('MJD:ow_day0.temp_eve','-10','2020-01-28 19:01:01'),('MJD:ow_day0.temp_night','-10','2020-01-28 19:01:01'),('MJD:ow_day0.temp_min','-10','2020-01-28 19:01:01'),('MJD:ow_day0.temp_max','-10','2020-01-28 19:01:01'),('MJD:ow_day0.weather_type','небольшой снег','2020-01-28 19:01:01'),('MJD:ow_day0.wind_direction','143','2020-01-28 19:01:01'),('MJD:ow_day0.wind_direction_text','ЮВ','2020-01-28 19:01:01'),('MJD:ow_day0.wind_direction_full','Юго-Восток','2020-01-28 19:01:01'),('MJD:ow_day0.wind_speed','5','2020-01-28 19:01:01'),('MJD:ow_day0.humidity','90','2020-01-28 19:01:01'),('MJD:ow_day0.pressure','1016','2020-01-28 19:01:01'),('MJD:ow_day0.pressure_mmhg','762','2020-01-28 19:01:01'),('MJD:ow_day0.image','13d','2020-01-28 19:01:01'),('MJD:ow_day0.clouds','100','2020-01-28 19:01:01'),('MJD:ow_day0.rain','0','2020-01-28 19:01:01'),('MJD:ow_day0.snow','0.44','2020-01-28 19:01:01'),('MJD:ow_day0.condCode','600','2020-01-28 19:01:01'),('MJD:ow_day0.sunrise','1580189981','2020-01-28 19:01:01'),('MJD:ow_day0.sunset','1580218008','2020-01-28 19:01:01'),('MJD:ow_day0.day_length','28027','2020-01-28 19:01:01'),('MJD:ow_day0.transit','1580203995','2020-01-28 19:01:01'),('MJD:ow_day0.civil_twilight_begin','1580187161','2020-01-28 19:01:01'),('MJD:ow_day0.civil_twilight_end','1580220829','2020-01-28 19:01:01'),('MJD:ow_day1.date','29.01.2020','2020-01-28 19:01:01'),('MJD:ow_day1.temperature','-10','2020-01-28 19:01:01'),('MJD:ow_day1.temp_morn','-11','2020-01-28 19:01:01'),('MJD:ow_day1.temp_day','-8','2020-01-28 19:01:01'),('MJD:ow_day1.temp_eve','-10','2020-01-28 19:01:01'),('MJD:ow_day1.temp_night','-10','2020-01-28 19:01:01'),('MJD:ow_day1.temp_min','-11','2020-01-28 19:01:01'),('MJD:ow_day1.temp_max','-7','2020-01-28 19:01:01'),('MJD:ow_day1.weather_type','небольшой снег','2020-01-28 19:01:01'),('MJD:ow_day1.wind_direction','127','2020-01-28 19:01:01'),('MJD:ow_day1.wind_direction_text','ЮВ','2020-01-28 19:01:01'),('MJD:ow_day1.wind_direction_full','Юго-Восток','2020-01-28 19:01:01'),('MJD:ow_day1.wind_speed','3','2020-01-28 19:01:01'),('MJD:ow_day1.humidity','90','2020-01-28 19:01:01'),('MJD:ow_day1.pressure','1013','2020-01-28 19:01:01'),('MJD:ow_day1.pressure_mmhg','760','2020-01-28 19:01:01'),('MJD:ow_day1.image','13d','2020-01-28 19:01:01'),('MJD:ow_day1.clouds','100','2020-01-28 19:01:01'),('MJD:ow_day1.rain','0','2020-01-28 19:01:01'),('MJD:ow_day1.snow','0','2020-01-28 19:01:01'),('MJD:ow_day1.condCode','600','2020-01-28 19:01:01'),('MJD:ow_day1.sunrise','1580276255','2020-01-28 19:01:01'),('MJD:ow_day1.sunset','1580304557','2020-01-28 19:01:01'),('MJD:ow_day1.day_length','28302','2020-01-28 19:01:01'),('MJD:ow_day1.transit','1580290406','2020-01-28 19:01:01'),('MJD:ow_day1.civil_twilight_begin','1580273452','2020-01-28 19:01:01'),('MJD:ow_day1.civil_twilight_end','1580307360','2020-01-28 19:01:01'),('MJD:ow_day2.date','30.01.2020','2020-01-28 19:01:01'),('MJD:ow_day2.temperature','-5','2020-01-28 19:01:01'),('MJD:ow_day2.temp_morn','-7','2020-01-28 19:01:01'),('MJD:ow_day2.temp_day','-5','2020-01-28 19:01:01'),('MJD:ow_day2.temp_eve','-5','2020-01-28 19:01:01'),('MJD:ow_day2.temp_night','-5','2020-01-28 19:01:01'),('MJD:ow_day2.temp_min','-7','2020-01-28 19:01:01'),('MJD:ow_day2.temp_max','-4','2020-01-28 19:01:01'),('MJD:ow_day2.weather_type','снег','2020-01-28 19:01:01'),('MJD:ow_day2.wind_direction','99','2020-01-28 19:01:01'),('MJD:ow_day2.wind_direction_text','В','2020-01-28 19:01:01'),('MJD:ow_day2.wind_direction_full','Восток','2020-01-28 19:01:01'),('MJD:ow_day2.wind_speed','4','2020-01-28 19:01:01'),('MJD:ow_day2.humidity','92','2020-01-28 19:01:01'),('MJD:ow_day2.pressure','1010','2020-01-28 19:01:01'),('MJD:ow_day2.pressure_mmhg','758','2020-01-28 19:01:01'),('MJD:ow_day2.image','13d','2020-01-28 19:01:01'),('MJD:ow_day2.clouds','100','2020-01-28 19:01:01'),('MJD:ow_day2.rain','0','2020-01-28 19:01:01'),('MJD:ow_day2.snow','1.68','2020-01-28 19:01:01'),('MJD:ow_day2.condCode','601','2020-01-28 19:01:01'),('MJD:ow_day2.sunrise','1580362527','2020-01-28 19:01:01'),('MJD:ow_day2.sunset','1580391106','2020-01-28 19:01:01'),('MJD:ow_day2.day_length','28579','2020-01-28 19:01:01'),('MJD:ow_day2.transit','1580376817','2020-01-28 19:01:01'),('MJD:ow_day2.civil_twilight_begin','1580359740','2020-01-28 19:01:01'),('MJD:ow_day2.civil_twilight_end','1580393893','2020-01-28 19:01:01'),('MJD:ow_day3.date','31.01.2020','2020-01-28 19:01:01'),('MJD:ow_day3.temperature','-3','2020-01-28 19:01:01'),('MJD:ow_day3.temp_morn','-4','2020-01-28 19:01:01'),('MJD:ow_day3.temp_day','-2','2020-01-28 19:01:01'),('MJD:ow_day3.temp_eve','-3','2020-01-28 19:01:01'),('MJD:ow_day3.temp_night','-5','2020-01-28 19:01:01'),('MJD:ow_day3.temp_min','-5','2020-01-28 19:01:01'),('MJD:ow_day3.temp_max','-2','2020-01-28 19:01:01'),('MJD:ow_day3.weather_type','небольшой снег','2020-01-28 19:01:01'),('MJD:ow_day3.wind_direction','132','2020-01-28 19:01:01'),('MJD:ow_day3.wind_direction_text','ЮВ','2020-01-28 19:01:01'),('MJD:ow_day3.wind_direction_full','Юго-Восток','2020-01-28 19:01:01'),('MJD:ow_day3.wind_speed','3','2020-01-28 19:01:01'),('MJD:ow_day3.humidity','91','2020-01-28 19:01:01'),('MJD:ow_day3.pressure','1002','2020-01-28 19:01:01'),('MJD:ow_day3.pressure_mmhg','752','2020-01-28 19:01:01'),('MJD:ow_day3.image','13d','2020-01-28 19:01:01'),('MJD:ow_day3.clouds','99','2020-01-28 19:01:01'),('MJD:ow_day3.rain','0','2020-01-28 19:01:01'),('MJD:ow_day3.snow','0.76','2020-01-28 19:01:01'),('MJD:ow_day3.condCode','600','2020-01-28 19:01:01'),('MJD:ow_day3.sunrise','1580448796','2020-01-28 19:01:01'),('MJD:ow_day3.sunset','1580477656','2020-01-28 19:01:01'),('MJD:ow_day3.day_length','28860','2020-01-28 19:01:01'),('MJD:ow_day3.transit','1580463226','2020-01-28 19:01:01'),('MJD:ow_day3.civil_twilight_begin','1580446026','2020-01-28 19:01:01'),('MJD:ow_day3.civil_twilight_end','1580480427','2020-01-28 19:01:01'),('MJD:ow_day4.date','01.02.2020','2020-01-28 19:01:01'),('MJD:ow_day4.temperature','-8','2020-01-28 19:01:01'),('MJD:ow_day4.temp_morn','-8','2020-01-28 19:01:01'),('MJD:ow_day4.temp_day','-5','2020-01-28 19:01:01'),('MJD:ow_day4.temp_eve','-8','2020-01-28 19:01:01'),('MJD:ow_day4.temp_night','-5','2020-01-28 19:01:01'),('MJD:ow_day4.temp_min','-9','2020-01-28 19:01:01'),('MJD:ow_day4.temp_max','-5','2020-01-28 19:01:01'),('MJD:ow_day4.weather_type','пасмурно','2020-01-28 19:01:01'),('MJD:ow_day4.wind_direction','29','2020-01-28 19:01:01'),('MJD:ow_day4.wind_direction_text','ССВ','2020-01-28 19:01:01'),('MJD:ow_day4.wind_direction_full','Северо-Северо-Восток','2020-01-28 19:01:01'),('MJD:ow_day4.wind_speed','0','2020-01-28 19:01:01'),('MJD:ow_day4.humidity','93','2020-01-28 19:01:01'),('MJD:ow_day4.pressure','1003','2020-01-28 19:01:01'),('MJD:ow_day4.pressure_mmhg','752','2020-01-28 19:01:01'),('MJD:ow_day4.image','04d','2020-01-28 19:01:02'),('MJD:ow_day4.clouds','91','2020-01-28 19:01:02'),('MJD:ow_day4.rain','0','2020-01-28 19:01:02'),('MJD:ow_day4.snow','0','2020-01-28 19:01:02'),('MJD:ow_day4.condCode','804','2020-01-28 19:01:02'),('MJD:ow_day4.sunrise','1580535063','2020-01-28 19:01:02'),('MJD:ow_day4.sunset','1580564207','2020-01-28 19:01:02'),('MJD:ow_day4.day_length','29144','2020-01-28 19:01:02'),('MJD:ow_day4.transit','1580549635','2020-01-28 19:01:02'),('MJD:ow_day4.civil_twilight_begin','1580532309','2020-01-28 19:01:02'),('MJD:ow_day4.civil_twilight_end','1580566961','2020-01-28 19:01:02'),('MJD:ow_day5.date','02.02.2020','2020-01-28 19:01:02'),('MJD:ow_day5.temperature','-1','2020-01-28 19:01:02'),('MJD:ow_day5.temp_morn','-6','2020-01-28 19:01:02'),('MJD:ow_day5.temp_day','-2','2020-01-28 19:01:02'),('MJD:ow_day5.temp_eve','-1','2020-01-28 19:01:02'),('MJD:ow_day5.temp_night','-1','2020-01-28 19:01:02'),('MJD:ow_day5.temp_min','-6','2020-01-28 19:01:02'),('MJD:ow_day5.temp_max','-1','2020-01-28 19:01:02'),('MJD:ow_day5.weather_type','небольшой снег','2020-01-28 19:01:02'),('MJD:ow_day5.wind_direction','143','2020-01-28 19:01:02'),('MJD:ow_day5.wind_direction_text','ЮВ','2020-01-28 19:01:02'),('MJD:ow_day5.wind_direction_full','Юго-Восток','2020-01-28 19:01:02'),('MJD:ow_day5.wind_speed','4','2020-01-28 19:01:02'),('MJD:ow_day5.humidity','93','2020-01-28 19:01:02'),('MJD:ow_day5.pressure','1003','2020-01-28 19:01:02'),('MJD:ow_day5.pressure_mmhg','752','2020-01-28 19:01:02'),('MJD:ow_day5.image','13d','2020-01-28 19:01:02'),('MJD:ow_day5.clouds','100','2020-01-28 19:01:02'),('MJD:ow_day5.rain','0','2020-01-28 19:01:02'),('MJD:ow_day5.snow','0.56','2020-01-28 19:01:02'),('MJD:ow_day5.condCode','600','2020-01-28 19:01:02'),('MJD:ow_day5.sunrise','1580621328','2020-01-28 19:01:02'),('MJD:ow_day5.sunset','1580650758','2020-01-28 19:01:02'),('MJD:ow_day5.day_length','29430','2020-01-28 19:01:02'),('MJD:ow_day5.transit','1580636043','2020-01-28 19:01:02'),('MJD:ow_day5.civil_twilight_begin','1580618590','2020-01-28 19:01:02'),('MJD:ow_day5.civil_twilight_end','1580653496','2020-01-28 19:01:02'),('MJD:ow_day6.date','03.02.2020','2020-01-28 19:01:02'),('MJD:ow_day6.temperature','-1','2020-01-28 19:01:02'),('MJD:ow_day6.temp_morn','-1','2020-01-28 19:01:02'),('MJD:ow_day6.temp_day','-1','2020-01-28 19:01:02'),('MJD:ow_day6.temp_eve','-1','2020-01-28 19:01:02'),('MJD:ow_day6.temp_night','-2','2020-01-28 19:01:02'),('MJD:ow_day6.temp_min','-2','2020-01-28 19:01:02'),('MJD:ow_day6.temp_max','-0','2020-01-28 19:01:02'),('MJD:ow_day6.weather_type','снег','2020-01-28 19:01:02'),('MJD:ow_day6.wind_direction','136','2020-01-28 19:01:02'),('MJD:ow_day6.wind_direction_text','ЮВ','2020-01-28 19:01:02'),('MJD:ow_day6.wind_direction_full','Юго-Восток','2020-01-28 19:01:02'),('MJD:ow_day6.wind_speed','4','2020-01-28 19:01:02'),('MJD:ow_day6.humidity','95','2020-01-28 19:01:02'),('MJD:ow_day6.pressure','994','2020-01-28 19:01:02'),('MJD:ow_day6.pressure_mmhg','746','2020-01-28 19:01:02'),('MJD:ow_day6.image','13d','2020-01-28 19:01:02'),('MJD:ow_day6.clouds','100','2020-01-28 19:01:02'),('MJD:ow_day6.rain','0','2020-01-28 19:01:02'),('MJD:ow_day6.snow','2.89','2020-01-28 19:01:02'),('MJD:ow_day6.condCode','601','2020-01-28 19:01:02'),('MJD:ow_day6.sunrise','1580707591','2020-01-28 19:01:02'),('MJD:ow_day6.sunset','1580737309','2020-01-28 19:01:02'),('MJD:ow_day6.day_length','29718','2020-01-28 19:01:02'),('MJD:ow_day6.transit','1580722450','2020-01-28 19:01:02'),('MJD:ow_day6.civil_twilight_begin','1580704868','2020-01-28 19:01:02'),('MJD:ow_day6.civil_twilight_end','1580740032','2020-01-28 19:01:02'),('MJD:ow_setting.updScript','','2020-01-28 01:01:02'),('MJD:ow_setting.ow_ws_active','0','2020-01-28 01:01:02'),('MJD:ThisComputer.DateD','28','2020-01-28 01:01:02'),('MJD:ThisComputer.timeHH','20','2020-01-28 20:01:00'),('MJD:exchange_rate.eurobuy','26.9','2020-01-28 20:01:01'),('MJD:exchange_rate.date1','2020-01-28 20:00:01','2020-01-28 20:01:01'),('MJD:exchange_rate.eurosale','27.2','2020-01-28 20:01:01'),('MJD:exchange_rate.usdbuy','24.5','2020-01-28 20:01:01'),('MJD:exchange_rate.usdsale','24.8','2020-01-28 20:01:01'),('MJD:exchange_rate.rurbuy','0.36','2020-01-28 20:01:01'),('MJD:exchange_rate.rursale','0.4','2020-01-28 20:01:01'),('MJD:exchange_rate.dollarrur','62.34','2020-01-28 20:01:01'),('MJD:exchange_rate.eurorur','68.78','2020-01-28 20:01:01'),('MJD:exchange_rate.date2','2020-01-28 20:00:01','2020-01-28 20:01:01'),('MJD:exchange_rate.usdnbu','24.6','2020-01-28 20:01:01'),('MJD:exchange_rate.euronbu','27.12','2020-01-28 20:01:01'),('MJD:exchange_rate.rurnbu','0.39','2020-01-28 20:01:01'),('MJD:exchange_rate.date3','2020-01-28 20:00:01','2020-01-28 20:01:01'),('MJD:exchange_rate.date4','2020-01-28 20:00:02','2020-01-28 20:01:02'),('MJD:exchange_rate.kztusd','380.84','2020-01-28 20:01:02'),('MJD:exchange_rate.kzteur','419.5','2020-01-28 20:01:02'),('MJD:exchange_rate.dollarbyn','2.1283','2020-01-28 20:01:02'),('MJD:exchange_rate.eurobyn','2.3454','2020-01-28 20:01:02'),('MJD:exchange_rate.date5','2020-01-28 20:00:02','2020-01-28 20:01:02'),('MJD:ThisComputer.clockChimeEnabled','','2020-01-28 08:01:00'),('MJD:key.1','Зал','2020-01-28 16:59:01'),('MJD:Gateway1.color','56ea09','2020-01-28 17:17:21'),('MJD:Gateway1.status','1','2020-01-28 17:17:21'),('MJD:Rgb01.color','ea0606','2020-01-28 17:17:21'),('MJD:Rgb01.status','1','2020-01-28 17:17:21'),('MJD:Switch8.status','0','2020-01-28 17:33:46'),('MJD:Switch9.status','0','2020-01-28 17:33:46'),('MJD:Switch10.status','0','2020-01-28 17:33:46'),('MJD:Switch11.status','0','2020-01-28 17:33:46'),('MJD:Switch12.status','0','2020-01-28 17:33:46'),('MJD:Switch13.status','0','2020-01-28 17:33:46'),('MJD:Switch14.status','0','2020-01-28 17:33:46'),('MJD:Switch16.status','0','2020-01-28 17:33:46'),('MJD:Switch15.status','0','2020-01-28 17:33:46'),('MJD:ThisComputer.EnergoMinTemp','15','2020-01-28 17:44:34'),('MJD:Gateway1.brightness','42','2020-01-28 17:33:46'),('MJD:ThisComputer.volumeMediaLevel','','2020-01-28 17:43:43'),('MJD:ThisComputer.volumeLevel','100','2020-01-28 17:43:43'),('MJD:RadioSetting.VolumeLevel','100','2020-01-28 17:43:55'),('MJD:RadioSetting.LastStationID','37','2020-01-28 17:43:55'),('MJD:key.3','Детская','2020-01-28 17:43:55'),('MJD:key.4','Кухня','2020-01-28 17:43:55'),('MJD:key.5','5','2020-01-28 17:43:55'),('MJD:key.6','6','2020-01-28 17:43:55'),('MJD:key.7','7','2020-01-28 17:43:55'),('MJD:key.8','8','2020-01-28 17:43:55'),('MJD:key.9','9','2020-01-28 17:43:55'),('MJD:key.10','10','2020-01-28 17:43:55'),('MJD:key.11','11','2020-01-28 17:43:55'),('MJD:key.12','12','2020-01-28 17:43:55'),('MJD:key.13','13','2020-01-28 17:43:55'),('MJD:key.14','14','2020-01-28 17:43:55'),('MJD:key.16','16','2020-01-28 17:43:55'),('MJD:key.15','15','2020-01-28 17:43:55'),('MJD:Gateway1.colorSaved','56ea09','2020-01-28 17:43:55'),('MJD:tempD1.tu','22','2020-01-28 19:59:22'),('MJD:tempD2.tu','23','2020-01-28 20:12:03'),('MJD:tempD3.tu','19','2020-01-28 19:11:37'),('MJD:tempD4.tu','25','2020-01-28 19:12:13'),('MJD:tempD5.tu','20','2020-01-28 19:41:09'),('MJD:tempD6.tu','22','2020-01-28 19:41:03'),('MJD:tempD7.tu','20','2020-01-28 17:44:23'),('MJD:tempD8.tu','20','2020-01-28 17:44:25'),('MJD:tempD9.tu','20','2020-01-28 17:44:27'),('MJD:tempD10.tu','21','2020-01-28 17:44:29'),('MJD:ow_fact.reelFeel','','2020-01-28 17:52:37'),('MJD:ow_day1.name','','2020-01-28 17:52:37'),('MJD:ow_day2.name','','2020-01-28 17:52:37'),('MJD:ow_day3.name','','2020-01-28 17:52:37'),('MJD:ow_day4.name','','2020-01-28 17:52:37'),('MJD:ow_day5.name','','2020-01-28 17:52:37'),('MJD:ow_fact.wind_direction_my','','2020-01-28 17:52:38'),('MJD:ThisComputer.Day','вторник','2020-01-28 17:52:38'),('MJD:ThisComputer.Date','28.01.2020','2020-01-28 17:52:38'),('MJD:ow_day1.wind_direction_my','','2020-01-28 17:52:38'),('MJD:ow_day2.wind_direction_my','','2020-01-28 17:52:38'),('MJD:ow_day3.wind_direction_my','','2020-01-28 17:52:38'),('MJD:ThisComputer.reelFeel','-0','2020-01-28 17:52:38'),('MJD:ThisComputer.monthShrt','ЯНВ','2020-01-28 17:52:38'),('MJD:TodoList.StreamingCodeScene','(too big)','2020-01-28 17:52:40'),('MJD:ow_city.name','Vologda','2020-01-28 17:52:38'),('MJD:ThisComputer.securityMode','0','2020-01-28 17:52:38'),('MJD:ow_day0.wind_direction_my','','2020-01-28 17:52:38'),('MJD:ThisComputer.TempOutside','','2020-01-28 17:52:39'),('MJD:ThisComputer.Month','января','2020-01-28 20:05:49');
/*!40000 ALTER TABLE `cached_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cached_ws`
--

DROP TABLE IF EXISTS `cached_ws`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cached_ws` (
  `PROPERTY` char(100) NOT NULL,
  `DATAVALUE` varchar(20000) NOT NULL,
  `POST_ACTION` char(100) NOT NULL,
  `ADDED` datetime NOT NULL,
  PRIMARY KEY (`PROPERTY`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cached_ws`
--

LOCK TABLES `cached_ws` WRITE;
/*!40000 ALTER TABLE `cached_ws` DISABLE KEYS */;
INSERT INTO `cached_ws` VALUES ('ThisComputer.cycle_websocketsRun','1580231731','PostProperty','2020-01-28 20:15:31'),('ThisComputer.WSClientsTotal','11','PostProperty','2020-01-28 20:15:31'),('ThisComputer.cycle_wscacheRun','1580231731','PostProperty','2020-01-28 20:15:31'),('ThisComputer.cycle_telegramRun','1580231731','PostProperty','2020-01-28 20:15:31');
/*!40000 ALTER TABLE `cached_ws` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar_categories`
--

DROP TABLE IF EXISTS `calendar_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar_categories` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `ACTIVE` int(255) NOT NULL DEFAULT '0',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `ICON` varchar(70) NOT NULL DEFAULT '',
  `AT_CALENDAR` tinyint(1) NOT NULL DEFAULT '0',
  `CALENDAR_COLOR` int(11) NOT NULL DEFAULT '0',
  `HOLIDAYS` tinyint(1) NOT NULL DEFAULT '0',
  `WORKDAYS` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar_categories`
--

LOCK TABLES `calendar_categories` WRITE;
/*!40000 ALTER TABLE `calendar_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar_events`
--

DROP TABLE IF EXISTS `calendar_events`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar_events` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  `NOTES` text,
  `DUE` date DEFAULT NULL,
  `ADDED` datetime DEFAULT NULL,
  `DONE_WHEN` datetime DEFAULT NULL,
  `IS_TASK` int(3) NOT NULL DEFAULT '0',
  `IS_DONE` int(3) NOT NULL DEFAULT '0',
  `IS_NODATE` int(3) NOT NULL DEFAULT '0',
  `IS_REPEATING` int(3) NOT NULL DEFAULT '0',
  `REPEAT_TYPE` int(3) NOT NULL DEFAULT '0',
  `WEEK_DAYS` varchar(255) NOT NULL DEFAULT '',
  `IS_REPEATING_AFTER` int(3) NOT NULL DEFAULT '0',
  `REPEAT_IN` int(10) NOT NULL DEFAULT '0',
  `USER_ID` int(10) NOT NULL DEFAULT '0',
  `LOCATION_ID` int(10) NOT NULL DEFAULT '0',
  `CALENDAR_CATEGORY_ID` int(10) NOT NULL DEFAULT '0',
  `DONE_SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `DONE_CODE` text,
  `LOG` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar_events`
--

LOCK TABLES `calendar_events` WRITE;
/*!40000 ALTER TABLE `calendar_events` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar_events` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `charts`
--

DROP TABLE IF EXISTS `charts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `charts` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `SUBTITLE` varchar(255) NOT NULL DEFAULT '',
  `TYPE` varchar(255) NOT NULL DEFAULT '',
  `THEME` varchar(255) NOT NULL DEFAULT '',
  `HISTORY_DEPTH` int(10) NOT NULL DEFAULT '0',
  `HISTORY_TYPE` int(3) NOT NULL DEFAULT '1',
  `HIGHCHARTS_SETUP` text,
  `HIGHCHARTS_CONFIG` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `charts`
--

LOCK TABLES `charts` WRITE;
/*!40000 ALTER TABLE `charts` DISABLE KEYS */;
INSERT INTO `charts` VALUES (2,'CPU_temp','','','',0,1,NULL,NULL),(3,'CPU_load1','','','',0,1,NULL,NULL),(4,'CPU_load5','','','',0,1,NULL,NULL),(5,'CPU_load15','','','skies',0,1,NULL,NULL);
/*!40000 ALTER TABLE `charts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `charts_data`
--

DROP TABLE IF EXISTS `charts_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `charts_data` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `TYPE` varchar(50) NOT NULL DEFAULT '',
  `UNIT` varchar(50) NOT NULL DEFAULT '',
  `CHART_ID` int(10) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(100) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(100) NOT NULL DEFAULT '',
  `SETTINGS` text,
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `charts_data`
--

LOCK TABLES `charts_data` WRITE;
/*!40000 ALTER TABLE `charts_data` DISABLE KEYS */;
INSERT INTO `charts_data` VALUES (2,'SoC','','solidgauge','°C',2,'ThisComputer','pctemp','min:0, max:100,\r\n            plotBands: [{\r\n                from: 0,\r\n                to: 40,\r\n                color: \'#55BF3B\' // green\r\n            }, {\r\n                from: 40,\r\n                to: 60,\r\n                color: \'#DDDF0D\' // yellow\r\n            }, {\r\n                from: 60,\r\n                to: 100,\r\n                color: \'#DF5353\' // red\r\n            }],\r\n            stops: [\r\n                [0.4, \'#55BF3B\'], // green\r\n                [0.6, \'#DDDF0D\'], // yellow\r\n                [1, \'#DF5353\'] // red\r\n            ]',0),(3,'1 min','','solidgauge','',3,'ThisComputer','cpu_load1','min:0, max:3,\r\n            plotBands: [{\r\n                from: 0,\r\n                to: 1,\r\n                color: \'#55BF3B\' // green\r\n            }, {\r\n                from: 1,\r\n                to: 2,\r\n                color: \'#DDDF0D\' // yellow\r\n            }, {\r\n                from: 2,\r\n                to: 3,\r\n                color: \'#DF5353\' // red\r\n            }],\r\n            stops: [\r\n                [0.333, \'#55BF3B\'], // green\r\n                [0.666, \'#DDDF0D\'], // yellow\r\n                [1, \'#DF5353\'] // red\r\n            ]',0),(4,'5 min','','solidgauge','',4,'ThisComputer','cpu_load5','min:0, max:3,\r\n            plotBands: [{\r\n                from: 0,\r\n                to: 1,\r\n                color: \'#55BF3B\' // green\r\n            }, {\r\n                from: 1,\r\n                to: 2,\r\n                color: \'#DDDF0D\' // yellow\r\n            }, {\r\n                from: 2,\r\n                to: 3,\r\n                color: \'#DF5353\' // red\r\n            }],\r\n            stops: [\r\n                [0.333, \'#55BF3B\'], // green\r\n                [0.666, \'#DDDF0D\'], // yellow\r\n                [1, \'#DF5353\'] // red\r\n            ]',0),(5,'15 min','','solidgauge','',5,'ThisComputer','cpu_load15','min:0, max:3,\r\n            plotBands: [{\r\n                from: 0,\r\n                to: 1,\r\n                color: \'#55BF3B\' // green\r\n            }, {\r\n                from: 1,\r\n                to: 2,\r\n                color: \'#DDDF0D\' // yellow\r\n            }, {\r\n                from: 2,\r\n                to: 3,\r\n                color: \'#DF5353\' // red\r\n            }],\r\n            stops: [\r\n                [0.333, \'#55BF3B\'], // green\r\n                [0.666, \'#DDDF0D\'], // yellow\r\n                [1, \'#DF5353\'] // red\r\n            ]',0);
/*!40000 ALTER TABLE `charts_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `classes`
--

DROP TABLE IF EXISTS `classes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `classes` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PARENT_ID` int(10) NOT NULL DEFAULT '0',
  `SUB_LIST` text,
  `PARENT_LIST` text,
  `NOLOG` int(3) NOT NULL DEFAULT '0',
  `DESCRIPTION` text,
  `TEMPLATE` text,
  PRIMARY KEY (`ID`),
  KEY `PARENT_ID` (`PARENT_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=83 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `classes`
--

LOCK TABLES `classes` WRITE;
/*!40000 ALTER TABLE `classes` DISABLE KEYS */;
INSERT INTO `classes` VALUES (12,'Skype',0,'12','0',0,'',NULL),(19,'tempSensors',0,'19','0',0,'',NULL),(7,'Timer',0,'7','0',1,'',NULL),(18,'BlueToothDevice',0,'18','0',0,'',NULL),(9,'USBDevice',0,'9','0',0,'',NULL),(10,'Computer',0,'10','0',0,'',''),(20,'WeatherStations',0,'20','0',0,'',NULL),(21,'systemStates',0,'21','0',0,'',NULL),(22,'keySensors',0,'23','0',0,'',NULL),(23,'inhouseMovementSensors',22,'23','22',0,'',NULL),(24,'OperationalModes',0,'24','0',0,'',NULL),(25,'Rooms',0,'25','0',0,'Rooms/Locations',NULL),(26,'Relays',0,'29,31','0',0,'',NULL),(29,'RCSwitches',26,'29','26',0,'',NULL),(30,'humiditySensors',0,'30','0',0,'Humidity Sensors',NULL),(31,'Noolight',26,'31','26',0,'',NULL),(32,'Users',0,'32','0',0,'',NULL),(34,'Cron',0,'34','0',0,'Cron scheduler',NULL),(35,'Radio',0,'35','0',0,'Онлайн радио',NULL),(36,'SDevices',0,'37,38,39,50,66,79,40,41,42,43,44,45,55,56,57,58,59,60,61,77,51,52,53,54,78,80','0',0,'General Devices Class',NULL),(37,'SControllers',36,'38,39,50,66,79','36',0,'Controllable device',NULL),(38,'SRelays',37,'38','36,37',0,NULL,NULL),(39,'SDimmers',37,'39','36,37',0,NULL,NULL),(40,'SMotions',36,'40','36',0,NULL,NULL),(41,'SOpenClose',36,'41','36',0,NULL,NULL),(42,'SButtons',36,'42','36',0,NULL,NULL),(43,'SSensors',36,'44,45,55,56,57,58,59,60,61,77','36',0,NULL,NULL),(44,'STempSensors',43,'44','36,43',0,NULL,NULL),(45,'SHumSensors',43,'45','36,43',0,NULL,NULL),(47,'textbox',0,'47','0',0,'текстовые поля',NULL),(67,'openweather',0,'67','0',0,'Погода Open Weather Map',NULL),(48,'myclass',0,'48','0',0,'',NULL),(50,'SRGB',37,'50','36,37',0,NULL,NULL),(51,'SCameras',36,'51','36',0,NULL,NULL),(52,'SLeak',36,'52','36',0,NULL,NULL),(53,'SSmoke',36,'53','36',0,NULL,NULL),(54,'SCounters',36,'54','36',0,NULL,NULL),(55,'SStateSensors',43,'55','36,43',0,NULL,NULL),(56,'SPercentageSensors',43,'56','36,43',0,NULL,NULL),(57,'SPressureSensors',43,'57','36,43',0,NULL,NULL),(58,'SPowerSensors',43,'58','36,43',0,NULL,NULL),(59,'SVoltageSensors',43,'59','36,43',0,NULL,NULL),(60,'SCurrentSensors',43,'60','36,43',0,NULL,NULL),(61,'SLightSensors',43,'61','36,43',0,NULL,NULL),(62,'tempSens',0,'62','0',0,'датчики температуры, давления, влажности',''),(63,'tempClap',0,'63','0',0,'термический сервопривод клапана',''),(64,'energomera',0,'64','0',0,'Переменные модуля Energomera',NULL),(65,'GPSLocations',0,'65','0',0,NULL,NULL),(66,'SThermostats',37,'66','36,37',0,NULL,NULL),(68,'ToDo',0,'68','0',0,'',''),(69,'ExchangeRates',0,'69','0',0,'[\"\\u041a\\u0443\\u0440\\u0441 \\u0432\\u0430\\u043b\\u044e\\u0442\"]',NULL),(70,'Xiaomi',0,'71,72,73,74,75,76','0',0,'',NULL),(71,'TempSensor',70,'71','70',0,'датчики температуры, влажности и давления',NULL),(72,'MotionSensor',70,'72','70',0,'датчики движения',NULL),(73,'MagnetSensor',70,'73','70',0,'датчики дверей',NULL),(74,'LeakSensor',70,'74','70',0,'датчики протечки',NULL),(75,'CubieSensor',70,'75','70',0,'магические кубы',NULL),(76,'Gateway',70,'76','70',0,'Шлюзы',NULL),(77,'SGeneralSensors',43,'77','36,43',0,NULL,NULL),(78,'SHTML',36,'78','36',0,NULL,NULL),(79,'SGroups',37,'79','36,37',0,NULL,NULL),(80,'SOpenable',36,'80','36',0,NULL,NULL),(81,'YandexWeather',0,'81','0',0,NULL,NULL),(82,'TempUst',0,'82','0',0,'установки температуры',NULL);
/*!40000 ALTER TABLE `classes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `collections`
--

DROP TABLE IF EXISTS `collections`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `collections` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PATH` varchar(255) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `collections`
--

LOCK TABLES `collections` WRITE;
/*!40000 ALTER TABLE `collections` DISABLE KEYS */;
/*!40000 ALTER TABLE `collections` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commands`
--

DROP TABLE IF EXISTS `commands`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commands` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `COMMAND` varchar(255) NOT NULL DEFAULT '',
  `URL` varchar(255) NOT NULL DEFAULT '',
  `WIDTH` int(10) NOT NULL DEFAULT '0',
  `HEIGHT` int(10) NOT NULL DEFAULT '0',
  `PARENT_ID` int(10) NOT NULL DEFAULT '0',
  `SUB_LIST` text,
  `PARENT_LIST` text,
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `WINDOW` varchar(255) NOT NULL DEFAULT '',
  `AUTOSTART` int(3) NOT NULL DEFAULT '0',
  `TYPE` char(50) NOT NULL DEFAULT '',
  `MIN_VALUE` float NOT NULL DEFAULT '0',
  `MAX_VALUE` float NOT NULL DEFAULT '0',
  `CUR_VALUE` varchar(255) NOT NULL DEFAULT '',
  `STEP_VALUE` float NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `ONCHANGE_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `ONCHANGE_METHOD` varchar(255) NOT NULL DEFAULT '',
  `ICON` varchar(50) NOT NULL DEFAULT '',
  `DATA` text,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `AUTO_UPDATE` int(10) NOT NULL DEFAULT '0',
  `CODE` text,
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  `EXT_ID` int(10) NOT NULL DEFAULT '0',
  `VISIBLE_DELAY` int(10) NOT NULL DEFAULT '0',
  `INLINE` int(3) NOT NULL DEFAULT '0',
  `SUB_PRELOAD` int(3) NOT NULL DEFAULT '0',
  `RENDER_TITLE` varchar(255) NOT NULL DEFAULT '',
  `RENDER_DATA` text,
  `RENDER_UPDATED` datetime DEFAULT NULL,
  `SMART_REPEAT` int(3) NOT NULL DEFAULT '0',
  `READ_ONLY` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=154 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commands`
--

LOCK TABLES `commands` WRITE;
/*!40000 ALTER TABLE `commands` DISABLE KEYS */;
INSERT INTO `commands` VALUES (82,'<#LANG_GENERAL_EVENTS_LOG#>','','',0,0,0,'82','0',30,'',0,'label',0,0,'',0,'','','','','','',0,0,'','',0,0,0,0,'История событий','','2015-12-03 14:42:25',0,0),(74,'<#LANG_GENERAL_EVENTS_LOG#> (code)','','',0,0,0,'74','0',20,'',0,'custom',0,0,'0',0,'','','','','','<div style=\"text-shadow:none;font-weight:normal;\">[#module name=\"shoutbox\" limit=\"10\" reverse=\"1\" mobile=\"1\"#]</div>',0,60,'','',0,0,0,0,'История событий (code)','<!-- begin of file inner_code --><div style=\"text-shadow:none;font-weight:normal;\"><!-- begin of file ./templates/shoutbox/shoutbox.html -->\n\r\n<!-- Frontend -->\r\n \n\r\n <!-- action usual -->\r\n <!-- table shouts search -->\r\n \r\n  \n<!-- table shouts search -->\n<!-- results -->\n\n<div class=\"shout_box\">  <!-- begin shout_box -->\n\n<!-- search results (list) -->\n<div id=\"shoutboxContent\" class=\"shout_content\">\n<span>20:01 <b>Алиса</b>: Статус связи восстановился на Зелёный</span><br><span>19:52 <b>Елена</b>: Буквально через 10 мин.</span><br><span>19:51 <b>Елена</b>: Добрый вечер, Сергей!</span><br><span>19:51 <b>Алиса</b>: Нет доступа в Интернет</span><br><span>19:51 <b>Алиса</b>: Статус связи изменился на Жёлтый.</span><br><hr size=1><b>2018-03-17</b><br><span>23:36 <b>Admin</b>: Привет</span><br><span>23:36 <b>Admin</b>: Выключить свет</span><br><span>23:35 <b>Admin</b>: Выключи свет</span><br><span>23:35 <b>Алиса</b>: Сейчас 23 часа 35 минут</span><br><span>23:35 <b>Admin</b>: Сколько время</span><br>\n</div>\n<!-- / search results (list) -->\n<!-- / results -->\n\n\n<div class=\"shout_form\">\n<form action=\"/nf.php?pd=pz_pz_YXBwbGljYXRpb246e2FjdGlvbj1tZW51fQ%3D%3Dpz_&md=shoutbox&inst=&\" name=\"frmShoutBoxMsg\" method=\"get\" style=\"margin:0px\" onSubmit=\'return false;\'>\n<input type=\"text\" name=\"message\" class=\"shout_input\" placeholder=\"Команда\"><input type=\"submit\" name=\"submit\" value=\"Отправить\" onClick=\"return sendShoutMessage();\"  class=\"shout_button\">\n<input type=\"hidden\" name=\"pd\" value=\"pz_pz_YXBwbGljYXRpb246e2FjdGlvbj1tZW51fQ%3D%3Dpz_\">\n<input type=\"hidden\" name=\"md\" value=\"shoutbox\">\n<input type=\"hidden\" name=\"inst\" value=\"\">\n</FORM><!-- modified -->\n</div>\n\n</div> <!-- end shout_box -->\n<script language=\"javascript\">\n\nvar shoutTimer;\n\n function updateShoutContent() {\n  clearTimeout(shoutTimer);\n\n  var url=\"/popup/shoutbox.html?\";\n\n   url=url+\'&limit=10&getdata=1&reverse=1\';\n   $.ajax({\n    url: url,\n    }).done(function(data) { \n     if (data!=\'\') {\n      old_data=$(\'#shoutboxContent\').html();\n      if (old_data!=data) {\n       $(\'#shoutboxContent\').html(data);\n      }\n     }\n\n  \n  shoutTimer=setTimeout(\"updateShoutContent(\'\', \'\');\", 10000);\n  \n\n\n    });\n\n }\n\n function sendShoutMessage() {\n  if (document.frmShoutBoxMsg.message.value == \'\') return false; \n  var msg=URLencode(document.frmShoutBoxMsg.message.value);\n  document.frmShoutBoxMsg.message.value=\'\';\n  var url=\"/popup/shoutbox.html?\";\n  url=url+\'&limit=10&msg=\'+msg;\n  $.ajax({\n   url: url,\n   }).done(function(data) { \n    if (data!=\'OK\' && data!=\'\') {\n     $(\'#shoutboxContent\').html(data);\n    }\n   });\n  return false;\n }\n</script>\n\n\n<script language=\"javascript\">\n  updateShoutContent();\n</script>\n\r\n \r\n <!-- / table shouts search -->\r\n <!-- table shouts edit -->\r\n \r\n <!-- / table shouts edit -->\r\n <!-- table shouts view --> \r\n \r\n <!-- / table shouts view -->\r\n\r\n\r\n\r\n<!-- end of file ./templates/shoutbox/shoutbox.html --></div><!-- end of file inner_code -->','2018-03-18 20:21:37',0,0),(137,'Настройки','','',0,0,0,'148,149,150,139,140,141,142,143,144,145,146,147','0',10,'',0,'',0,0,'',0,'','','','','','',0,0,'','',0,0,0,1,'Настройки','','2017-10-28 20:11:57',0,0),(106,'<#LANG_GENERAL_CONTROL#>','','',0,0,0,'108,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,151,152','0',40,'',0,'',0,0,'',0,'','','','','','',0,0,'','',0,0,0,1,'Управление','','2015-12-03 14:42:25',0,0),(97,'State','','',0,0,0,'97','0',60,'',0,'custom',0,0,'',0,'','','','','','<big style=\"font-size:24px\">%ThisComputer.timeNow%</big>\r\n\r\n<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\"> %Security.stateDetails%\r\n<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\"> %System.stateDetails%\r\n<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\"> %Communication.stateDetails%\r\n<br/>\r\n%ThisComputer.somebodyHomeText%<br/>\r\n\r\n ',0,10,'','',0,0,0,0,'State','<big style=\"font-size:24px\">23:52</big>\r\n\r\n<img src=\"/img/icons/status/lock_32_green.png\" align=\"absmiddle\"> \r\n<img src=\"/img/icons/status/system_32_green.png\" align=\"absmiddle\"> \r\n<img src=\"/img/icons/status/network_32_green.png\" align=\"absmiddle\"> \r\n<br/>\r\n<br/>\r\n','2018-03-18 23:52:35',0,0),(108,'%key.1%','','',0,0,106,'108','106',160,'',0,'switch',0,0,'0',0,'Switch1','status','','refresh','','',0,300,'','',0,0,0,0,'Зал','','2018-03-17 02:40:52',0,0),(118,'%key.2%','','',0,0,106,'118','106',150,'',0,'switch',0,0,'0',0,'Switch2','status','','refresh','','',0,300,'','',0,0,0,0,'Спальня','','2018-03-17 02:40:52',0,0),(119,'%key.3%','','',0,0,106,'119','106',140,'',0,'switch',0,0,'0',0,'Switch3','status','','refresh','','',0,300,'','',0,0,0,0,'Детская','','2018-03-17 02:40:52',0,0),(120,'%key.4%','','',0,0,106,'120','106',130,'',0,'switch',0,0,'0',0,'Switch4','status','','refresh','','',0,300,'','',0,0,0,0,'Кухня','','2018-03-17 02:40:52',0,0),(121,'%key.5%','','',0,0,106,'121','106',120,'',0,'switch',0,0,'0',0,'Switch5','status','','refresh','','',0,300,'','',0,0,0,0,'5','','2017-04-11 14:07:05',0,0),(122,'%key.6%','','',0,0,106,'122','106',110,'',0,'switch',0,0,'0',0,'Switch6','status','','refresh','','',0,300,'','',0,0,0,0,'6','','2017-04-11 14:07:05',0,0),(123,'%key.7%','','',0,0,106,'123','106',100,'',0,'switch',0,0,'0',0,'Switch7','status','','refresh','','',0,300,'','',0,0,0,0,'7','','2017-04-11 14:07:05',0,0),(124,'%key.8%','','',0,0,106,'124','106',90,'',0,'switch',0,0,'0',0,'Switch8','status','','refresh','','',0,300,'','',0,0,0,0,'8','','2017-04-11 14:07:05',0,0),(125,'%key.9%','','',0,0,106,'125','106',80,'',0,'switch',0,0,'0',0,'Switch9','status','','refresh','','',0,300,'','',0,0,0,0,'9','','2017-04-11 14:07:05',0,0),(126,'%key.10%','','',0,0,106,'126','106',70,'',0,'switch',0,0,'0',0,'Switch10','status','','refresh','','',0,300,'','',0,0,0,0,'10','','2017-04-11 14:07:05',0,0),(127,'%key.11%','','',0,0,106,'127','106',60,'',0,'switch',0,0,'0',0,'Switch11','status','','refresh','','',0,300,'','',0,0,0,0,'11','','2017-04-11 14:07:05',0,0),(128,'%key.12%','','',0,0,106,'128','106',50,'',0,'switch',0,0,'0',0,'Switch12','status','','refresh','','',0,300,'','',0,0,0,0,'12','','2017-04-11 14:07:05',0,0),(129,'%key.13%','','',0,0,106,'129','106',40,'',0,'switch',0,0,'0',0,'Switch13','status','','refresh','','',0,300,'','',0,0,0,0,'13','','2017-04-11 14:07:05',0,0),(130,'%key.14%','','',0,0,106,'130','106',30,'',0,'switch',0,0,'0',0,'Switch14','status','','refresh','','',0,300,'','',0,0,0,0,'14','','2017-04-11 14:07:05',0,0),(131,'%key.15%','','',0,0,106,'131','106',10,'',0,'switch',0,0,'0',0,'Switch15','status','','refresh','','',0,300,'','',0,0,0,0,'15','','2017-04-11 14:07:05',0,0),(132,'%key.16%','','',0,0,106,'132','106',20,'',0,'switch',0,0,'0',0,'Switch16','status','','refresh','','',0,300,'','',0,0,0,0,'16','','2017-04-11 14:07:05',0,0),(148,'Комната 9','','',0,0,137,'148','137',30,'',0,'sliderbox',12,25,'20',1,'tempD9','tu','','','','',0,0,'','',0,0,0,0,'Комната 9','','2017-10-28 20:11:57',0,0),(149,'t экономии','','',0,0,137,'149','137',10,'',0,'sliderbox',12,25,'15',1,'ThisComputer','EnergoMinTemp','','','','',0,0,'','',0,0,0,0,'t экономии','','2017-10-28 20:28:04',0,0),(150,'режим экономии','','',0,0,137,'150','137',0,'',0,'switch',0,0,'0',0,'ThisComputer','Econom','','','','',0,0,'','',0,0,0,0,'режим экономии','','2017-10-28 20:28:04',0,0),(139,'Комната 1','','',0,0,137,'139','137',110,'',0,'sliderbox',12,25,'22',1,'tempD1','tu','','','','',0,0,'','',0,0,0,0,'Комната 1','','2017-10-28 20:11:57',0,0),(140,'Комната 2','','',0,0,137,'140','137',100,'',0,'sliderbox',12,25,'23',1,'tempD2','tu','','','','',0,0,'','',0,0,0,0,'Комната 2','','2017-10-28 20:11:57',0,0),(141,'Комната 3','','',0,0,137,'141','137',90,'',0,'sliderbox',12,25,'19',1,'tempD3','tu','','','','',0,0,'','',0,0,0,0,'Комната 3','','2017-10-28 20:11:57',0,0),(142,'Комната 4','','',0,0,137,'142','137',80,'',0,'sliderbox',12,25,'25',1,'tempD4','tu','','','','',0,0,'','',0,0,0,0,'Комната 4','','2017-10-28 20:11:57',0,0),(143,'Комната 5','','',0,0,137,'143','137',70,'',0,'sliderbox',12,25,'20',1,'tempD5','tu','','','','',0,0,'','',0,0,0,0,'Комната 5','','2017-10-28 20:11:57',0,0),(144,'Комната 6','','',0,0,137,'144','137',60,'',0,'sliderbox',12,25,'22',1,'tempD6','tu','','','','',0,0,'','',0,0,0,0,'Комната 6','','2017-10-28 20:11:57',0,0),(145,'Комната 7','','',0,0,137,'145','137',50,'',0,'sliderbox',12,25,'20',1,'tempD7','tu','','','','',0,0,'','',0,0,0,0,'Комната 7','','2017-10-28 20:11:57',0,0),(146,'Комната 8','','',0,0,137,'146','137',40,'',0,'sliderbox',12,25,'20',1,'tempD8','tu','','','','',0,0,'','',0,0,0,0,'Комната 8','','2017-10-28 20:11:57',0,0),(147,'Комната 10','','',0,0,137,'147','137',20,'',0,'sliderbox',12,25,'21',1,'tempD10','tu','','','','',0,0,'','',0,0,0,0,'Комната 10','','2017-10-28 20:11:57',0,0),(151,'RGB','','',0,0,106,'151','106',0,'',0,'object',0,0,'',0,'Gateway1','','','','',NULL,0,0,NULL,'sdevice2',0,0,0,0,'RGB','<script src=\'/js/spectrum/spectrum.min.js\'></script>\r\n<link rel=\'stylesheet\' href=\'/js/spectrum/spectrum.min.css\' />\r\n<link rel=\'stylesheet\' href=\'/css/devices.css\' />\r\n<div class=\"controller-widget\">\r\n    <div class=\"controller-light on\"></div>\r\n    <div class=\"controller-text\" style=\'display:block;cursor:pointer;\' onClick=\'callMethod(\"%Gateway1.turnOff\");\'>RGB</div>\r\n    <div class=\"controller-text\" style=\'display:none;cursor:pointer;\' onClick=\'callMethod(\"%Gateway1.turnOn\");\'>RGB</div>\r\n<div>\r\n    <input type=\"text\" id=\"color277\" value=\"da09ea\" onChange=\'callMethod(\"%Gateway1.setColor\",\"color=\"+encodeURIComponent(this.value));\'/>\r\n</div>\r\n<script>\r\n    $(\"#color277\").spectrum({\r\n        preferredFormat: \"hex\",\r\n        showInput: true,\r\n        chooseText: \"OK\",\r\n        cancelText: \"Отмена\"\r\n    });\r\n</script>\r\n</div>\r\n','2018-03-18 23:52:36',0,0),(152,'яркость','','',0,0,106,'152','106',0,'',0,'sliderbox',0,100,'42',1,'Gateway1','brightness','','','',NULL,0,0,'','',0,0,0,0,'яркость',NULL,'2018-03-18 23:52:36',0,0),(153,'radio','','',0,0,0,'153','0',50,'',0,'custom',0,0,'',0,'','','','','','[#module name=\"app_radio\" mode=\"menu\"#] ',0,0,'','',0,0,0,0,'',NULL,NULL,0,0);
/*!40000 ALTER TABLE `commands` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `country`
--

DROP TABLE IF EXISTS `country`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `country` (
  `COUNTRY_ID` int(10) NOT NULL,
  `COUNTRY_GUID` varchar(48) NOT NULL,
  `COUNTRY_NAME` varchar(64) NOT NULL,
  `LM_DATE` datetime NOT NULL,
  `COUNTRY_CODE` varchar(8) DEFAULT NULL,
  `COUNTRY_PHONE_CODE` varchar(8) DEFAULT NULL,
  `LATITUDE` float(18,5) DEFAULT NULL,
  `LONGITUDE` float(18,5) DEFAULT NULL,
  PRIMARY KEY (`COUNTRY_ID`),
  KEY `AK_COUNTRY__GUID` (`COUNTRY_GUID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `country`
--

LOCK TABLES `country` WRITE;
/*!40000 ALTER TABLE `country` DISABLE KEYS */;
INSERT INTO `country` VALUES (1,'25459617-F4D3-EB0A-6777-2D7CB5F876B9','Andorra','2015-04-14 12:09:36','AD','376',NULL,NULL),(2,'24E45AEB-7FD7-783A-2008-F5A35CA064F7','United Arab Emirates','2015-04-14 12:09:36','AE','971',NULL,NULL),(3,'3F039DE6-2908-4731-96FE-041E04A7E962','Afghanistan','2015-04-14 12:09:36','AF','93',NULL,NULL),(4,'F1FEB2CF-618A-59D0-0DDC-B4F8B4ED976E','Antigua and Barbuda','2015-04-14 12:09:36','AG','1268',NULL,NULL),(5,'909E8639-771A-D2CD-4405-7A8368A9D04A','Anguilla','2015-04-14 12:09:36','AI','1264',NULL,NULL),(6,'35173F09-0E98-0C3E-77A6-2AD8F8F5DE89','Albania','2015-04-14 12:09:36','AL','355',NULL,NULL),(7,'632C5757-664D-108D-802F-3F62E78F41B9','Armenia','2015-04-14 12:09:36','AM','374',NULL,NULL),(8,'33C045E6-E7F0-6886-FE2D-46C5EAA79042','Angola','2015-04-14 12:09:36','AO','244',NULL,NULL),(9,'8E7E291E-B21C-ABAC-7791-4733C412D3CA','Argentina','2015-04-14 12:09:36','AR','54',NULL,NULL),(10,'F4EC01D6-D793-EE6C-58EA-D66DABE0E15F','American Samoa','2015-04-14 12:09:36','AS','1684',NULL,NULL),(11,'DA24D62E-C926-A91D-E11A-96AAD3E5DDE1','Austria','2015-04-14 12:09:36','AT','43',NULL,NULL),(12,'F193E97D-B13C-9506-D976-CCB52BC864BF','Australia','2015-04-14 12:09:36','AU','61',NULL,NULL),(13,'363B89ED-E346-3EEE-67E1-77A9ACA104BE','Aruba','2015-04-14 12:09:36','AW','297',NULL,NULL),(14,'0129859C-6BC4-C7C6-F0E7-212E8BFFE04F','Åland Islands','2015-04-14 12:09:36','AX','358',NULL,NULL),(15,'96C23A30-8A7D-D545-6E33-1EF6070EAA2A','Azerbaijan','2015-04-14 12:09:36','AZ','994',NULL,NULL),(16,'1C37B968-7D44-2AED-7171-116232E0376F','Bosnia and Herzegovina','2015-04-14 12:09:36','BA','387',NULL,NULL),(17,'784A4C7F-8B44-353A-8B27-996E1B38791C','Barbados','2015-04-14 12:09:36','BB','1246',NULL,NULL),(18,'735D20D8-45D8-B861-6B2B-9F1B22F86447','Bangladesh','2015-04-14 12:09:36','BD','880',NULL,NULL),(19,'3B71F5B5-2AC2-9154-404D-191ABFBC4729','Belgium','0000-00-00 00:00:00','2015-04-','32',NULL,NULL),(20,'B5CB258B-4F64-D109-E9D5-60A78ED0A637','Burkina Faso','2015-04-14 12:09:36','BF','226',NULL,NULL),(21,'1B6E6DAD-F17E-C6C0-61A4-41B20394BDBE','Bulgaria','2015-04-14 12:09:36','BG','359',NULL,NULL),(22,'6AB06D58-6177-06A7-0937-AA363E22FE30','Bahrain','2015-04-14 12:09:36','BH','973',NULL,NULL),(23,'D1581E51-B2B3-8078-F5EC-8463B5484393','Burundi','2015-04-14 12:09:36','BI','257',NULL,NULL),(24,'28966864-22F6-35BD-5145-1B79E5FE95C0','Benin','2015-04-14 12:09:36','BJ','229',NULL,NULL),(25,'A0910149-4E0D-D1EF-9280-90C7CA4F713A','Saint Barthelemy','2015-04-14 12:09:36','BL','590',NULL,NULL),(26,'D10E4FAB-B35B-36E2-1B11-BD87D19D493E','Bermuda','2015-04-14 12:09:36','BM','1441',NULL,NULL),(27,'2EF66919-5A42-5E57-9540-254370BCFA7F','Brunei','2015-04-14 12:09:36','BN','673',NULL,NULL),(28,'B17DC404-815D-16D1-3EE6-01CFF6108DA6','Bolivia','2015-04-14 12:09:36','BO','597',NULL,NULL),(29,'1677F424-62EB-CDCA-59AE-82E6BE4CD643','Bonaire, Sint Eustatius and Saba','2015-04-14 12:09:36','BQ','599',NULL,NULL),(30,'364A13CD-9DD4-EB69-B481-CAF5C67AD0F3','Brazil','2015-04-14 12:09:36','BR','55',NULL,NULL),(31,'3287034B-9EF0-21E6-290F-4C1435488B14','Bahamas','2015-04-14 12:09:36','BS','1242',NULL,NULL),(32,'3ECFA6CC-B473-444F-60B2-F2C325726A59','Bhutan','2015-04-14 12:09:36','BT','975',NULL,NULL),(33,'5CB7E864-AA89-D6A6-6483-5A0B4BF4ECE7','Botswana','2015-04-14 12:09:36','BW','267',NULL,NULL),(34,'549B645E-602C-E8DC-E661-0BC58B872507','Belarus','2015-04-14 12:09:36','BY','375',NULL,NULL),(35,'6EBC4137-4D87-7153-6380-1917E5AB5CC8','Belize','2015-04-14 12:09:36','BZ','501',NULL,NULL),(36,'62B9E5BF-CD36-7BF9-8C86-7145E0BB87C3','Canada','2015-04-14 12:09:36','CA','1',NULL,NULL),(37,'CE623909-C6BB-FBDB-AAC4-E93B1905A157','Cocos (Keeling) Islands','2015-04-14 12:09:36','CC','61',NULL,NULL),(38,'EE5B1165-2914-906F-FC6F-CAAE4D346925','Democratic Republic of the Congo','2015-04-14 12:09:36','CD','243',NULL,NULL),(39,'2DAEE215-8156-00B0-9BCF-2A11D900E923','Central African Republic','2015-04-14 12:09:36','CF','236',NULL,NULL),(40,'EDADCB74-E7C3-1081-29BA-4F59B60FF6B2','Republic of the Congo','2015-04-14 12:09:36','CG','242',NULL,NULL),(41,'5024DE57-E5BB-5A9D-917D-26A1749B8D60','Switzerland','2015-04-14 12:09:36','CH','41',NULL,NULL),(42,'ABA5802C-8FE2-211F-8002-BB96E7A364DB','Ivory Coast','2015-04-14 12:09:36','CI','225',NULL,NULL),(43,'00C8EB2B-8085-1D54-BE4D-35EF87A255E6','Cook Islands','2015-04-14 12:09:36','CK','682',NULL,NULL),(44,'834BD2B5-93D2-17A7-91BE-CE4DEEC43366','Chile','2015-04-14 12:09:36','CL','56',NULL,NULL),(45,'28A21890-3B5D-8B00-9EBE-DED06FA1ECFB','Cameroon','2015-04-14 12:09:36','CM','237',NULL,NULL),(46,'CE0E5440-B3C0-12A5-1BA3-2387A270C634','China','2015-04-14 12:09:36','CN','86',NULL,NULL),(47,'622727AA-9C09-1CBB-9C8F-5F23E4F6E7AF','Colombia','2015-04-14 12:09:36','CO','57',NULL,NULL),(48,'D3860772-0731-CCE8-3F3C-8DFC229DA443','Costa Rica','2015-04-14 12:09:36','CR','506',NULL,NULL),(49,'A394D714-E73A-8327-EB0C-C1A03AD5B75C','Cuba','2015-04-14 12:09:36','CU','53',NULL,NULL),(50,'38DE8E73-B254-F18B-098D-FA063DB064DE','Cape Verde','2015-04-14 12:09:36','CV','238',NULL,NULL),(51,'E05C1047-00F5-9447-4AA4-F4D231A60CDF','Christmas Island','2015-04-14 12:09:36','CX','61',NULL,NULL),(52,'E29DE5EF-A293-9921-DB69-1AE56C94789C','Curaçao','2015-04-14 12:09:36','CW','',NULL,NULL),(53,'91F38946-68B4-F218-A93C-87F8018AD49A','Cyprus','2015-04-14 12:09:36','CY','357',NULL,NULL),(54,'673F53C2-5C02-9B22-E956-29879756BF15','Czech Republic','2015-04-14 12:09:36','CZ','420',NULL,NULL),(55,'60C952C3-0504-DC75-9E1D-499EC374B0F0','Germany','2015-04-14 12:09:36','DE','49',NULL,NULL),(56,'1A3A54C9-F2E1-3E5F-079C-999D110E8EEC','Djibouti','2015-04-14 12:09:36','DJ','253',NULL,NULL),(57,'7547B15D-E21A-4A2E-5F9B-1DC727C53F4A','Denmark','2015-04-14 12:09:36','DK','45',NULL,NULL),(58,'7E2CF84D-1879-374A-6A41-F03318A3FB25','Dominica','2015-04-14 12:09:36','DM','1767',NULL,NULL),(59,'A07E10D2-DB62-436D-E203-A884ED728CBC','Dominican Republic','2015-04-14 12:09:36','DO','1809',NULL,NULL),(60,'6CFEBD8D-4ADA-B4FF-9160-90D0C2B2118E','Algeria','2015-04-14 12:09:36','DZ','213',NULL,NULL),(61,'BC4A1696-47D1-2617-ECF6-824BADEF4C4E','Ecuador','2015-04-14 12:09:36','EC','593',NULL,NULL),(62,'AFF8DFA6-F5EE-6A43-DC59-8213D20E198A','Estonia','2015-04-14 12:09:36','EE','372',NULL,NULL),(63,'ED2AC84C-40C7-F14D-378E-16EB10094294','Egypt','2015-04-14 12:09:36','EG','20',NULL,NULL),(64,'25C7A12B-226A-8989-F33B-98FEAB37B18F','Western Sahara','2015-04-14 12:09:36','EH','',NULL,NULL),(65,'0C0F61A7-CED3-882E-440F-0B8B6ED939DB','Eritrea','2015-04-14 12:09:36','ER','291',NULL,NULL),(66,'81387FC3-0AD1-42E7-241E-2AA939641B95','Spain','2015-04-14 12:09:36','ES','34',NULL,NULL),(67,'7D8BD697-9E59-4861-4BE9-61A8AD8B4936','Ethiopia','2015-04-14 12:09:36','ET','251',NULL,NULL),(68,'561A54FF-8F65-8B92-483E-2DBE528429A4','Finland','2015-04-14 12:09:36','FI','358',NULL,NULL),(69,'4D930C83-DEFD-ADEA-0D64-501B4E4911CF','Fiji','2015-04-14 12:09:36','FJ','679',NULL,NULL),(70,'3EF989F2-6700-B8DA-F2B5-B4A831B30BCD','Falkland Islands','2015-04-14 12:09:36','FK','500',NULL,NULL),(71,'6E21E535-BF55-E53C-3CAC-7C2B621EF05B','Micronesia','2015-04-14 12:09:36','FM','691',NULL,NULL),(72,'25F1AC03-B255-50A9-654C-E043D61E7DA1','Faroe Islands','2015-04-14 12:09:36','FO','298',NULL,NULL),(73,'06A3DB9C-B358-74A7-BBA2-99F760FDE24E','France','2015-04-14 12:09:36','FR','33',NULL,NULL),(74,'7D2D339B-5568-2B6C-28F6-1CAD95AE685E','Gabon','2015-04-14 12:09:36','GA','241',NULL,NULL),(75,'73D1D5BB-571F-08E7-2A4F-4AB63AA9793C','United Kingdom','2015-04-14 12:09:36','GB','44',NULL,NULL),(76,'52764C53-FF3F-BA7C-14BF-7E6262C26BB6','Grenada','2015-04-14 12:09:36','GD','1473',NULL,NULL),(77,'ABAFEB9B-9DB0-5261-4625-53C6A32A8392','Georgia','2015-04-14 12:09:36','GE','995',NULL,NULL),(78,'93A6ABF8-C217-B219-0AEF-F63F51330113','French Guiana','2015-04-14 12:09:36','GF','',NULL,NULL),(79,'DD5B81B6-DF46-6B93-40DD-32B63B1C4482','Guernsey','2015-04-14 12:09:36','GG','',NULL,NULL),(80,'AE89DC78-DD22-0165-1F4A-37757DC2C6A6','Ghana','2015-04-14 12:09:36','GH','233',NULL,NULL),(81,'691A673C-A72B-45C6-EBA5-AE4D48128B0C','Gibraltar','2015-04-14 12:09:36','GI','350',NULL,NULL),(82,'E1C9DDCE-DFC6-C80E-9E6D-2CFACD5A3EF3','Greenland','2015-04-14 12:09:36','GL','299',NULL,NULL),(83,'DC6434F3-07BD-D0AF-5EF1-021830DD761A','Gambia','2015-04-14 12:09:36','GM','220',NULL,NULL),(84,'0EB68AA9-0863-564B-E8B9-7BE51B19C627','Guinea','2015-04-14 12:09:36','GN','224',NULL,NULL),(85,'64BAD731-A2B6-D774-4382-6A3F69041EB2','Guadeloupe ','2015-04-14 12:09:36','GP','',NULL,NULL),(86,'72FFFB07-88AA-6CA5-C9A1-664AAE69E39F','Equatorial Guinea','2015-04-14 12:09:36','GQ','240',NULL,NULL),(87,'EBC8E95D-EFA7-A62F-E9D0-1230876D82AD','Greece','2015-04-14 12:09:36','GR','30',NULL,NULL),(88,'589A3D09-2DAA-54DD-B119-8A8D0CD9E9B1','South Georgia and the South Sandwich Islands','2015-04-14 12:09:36','GS','',NULL,NULL),(89,'6119B99F-E4B7-0B13-45F3-293FD0A84862','Guatemala','2015-04-14 12:09:36','GT','502',NULL,NULL),(90,'6BC5F673-1D11-85D4-FF9E-3C43604EC2D0','Guam','2015-04-14 12:09:36','GU','1671',NULL,NULL),(91,'D94C617D-E792-CAAF-2E00-5A8EEA208C8C','Guinea-Bissau','2015-04-14 12:09:36','GW','245',NULL,NULL),(92,'9313337B-D700-D83C-CA29-5F48D8726308','Guyana','2015-04-14 12:09:36','GY','592',NULL,NULL),(93,'CEFBA783-88BA-FFDE-77F3-43B3FF801484','Hong Kong','2015-04-14 12:09:36','HK','852',NULL,NULL),(94,'CBA2E631-D4D1-B735-81D3-5DAC86AE8C76','Honduras','2015-04-14 12:09:36','HN','504',NULL,NULL),(95,'FEA02A43-5185-C6A7-A26C-935578D43E6D','Croatia','2015-04-14 12:09:36','HR','385',NULL,NULL),(96,'02927AD4-8894-FE99-C9DD-E0E7F4DC63B1','Haiti','2015-04-14 12:09:36','HT','509',NULL,NULL),(97,'42405C6A-097F-BAF2-93A6-86513986110A','Hungary','2015-04-14 12:09:36','HU','36',NULL,NULL),(98,'79798E7A-4327-469A-5EC1-81319DDC1E90','Indonesia','2015-04-14 12:09:36','ID','62',NULL,NULL),(99,'2A8985F3-8891-5685-A0FF-972A5DF8620B','Ireland','2015-04-14 12:09:36','IE','353',NULL,NULL),(100,'EEBDEB95-6B76-B2B0-F2C9-2BFB1499E9FD','Israel','2015-04-14 12:09:36','IL','972',NULL,NULL),(101,'71739793-0365-6479-F9A2-9B6F57239816','Isle of Man','2015-04-14 12:09:36','IM','44',NULL,NULL),(102,'18AC27F9-4025-C8CF-DA36-36004B0C5CF3','India','2015-04-14 12:09:36','IN','91',NULL,NULL),(103,'01BB783C-2123-8D92-36E3-397F1E9D5F7D','Iraq','2015-04-14 12:09:36','IQ','964',NULL,NULL),(104,'422B82CA-FC9F-6FFF-151E-E342CBD26A32','Iran','2015-04-14 12:09:36','IR','98',NULL,NULL),(105,'CD0DAF28-6A3C-0CE3-1A06-218A7AA11408','Iceland','2015-04-14 12:09:36','IS','354',NULL,NULL),(106,'8BA4B4DC-9E82-331B-7EE2-6577413FCFDE','Italy','2015-04-14 12:09:36','IT','39',NULL,NULL),(107,'D8777867-1C0B-ACF1-337A-6DD4B68B902B','Jersey','2015-04-14 12:09:36','JE','',NULL,NULL),(108,'0DEFE08A-DFF2-7222-F6BC-C10BB2C2B3E3','Jamaica','2015-04-14 12:09:36','JM','1876',NULL,NULL),(109,'8864615C-5A8F-56C1-262C-97CB8739E154','Jordan','2015-04-14 12:09:36','JO','962',NULL,NULL),(110,'A8DFE7EB-BA50-DF73-C88A-EB7A83636C98','Japan','2015-04-14 12:09:36','JP','81',NULL,NULL),(111,'D6F5CF13-36E4-E7D7-A6AE-32D622E2E905','Kenya','2015-04-14 12:09:36','KE','254',NULL,NULL),(112,'6C1BE74C-56D3-ADFE-B75E-4DD174378C3B','Kyrgyzstan','2015-04-14 12:09:36','KG','996',NULL,NULL),(113,'88F59F28-C9DC-F8B5-0AA3-6EE2F5BA2680','Cambodia','2015-04-14 12:09:36','KH','855',NULL,NULL),(114,'221ACA06-D996-AA61-8EF8-A883B5EF088D','Kiribati','2015-04-14 12:09:36','KI','686',NULL,NULL),(115,'50711EC0-9C17-A53D-C8D5-7BFCB17B9F74','Comoros','2015-04-14 12:09:36','KM','269',NULL,NULL),(116,'5A63C8A4-AED9-E465-C42D-6B35D815788E','Saint Kitts and Nevis','2015-04-14 12:09:36','KN','1869',NULL,NULL),(117,'E2231181-F5A7-9C0D-A07D-DF498953BDB7','North Korea','2015-04-14 12:09:36','KP','850',NULL,NULL),(118,'51E443A4-BBB7-45B3-BCCB-5D900AAC9A10','South Korea','2015-04-14 12:09:36','KR','82',NULL,NULL),(119,'163246AC-AF1E-7EF1-ABD7-CA7C76048C0D','Kuwait','2015-04-14 12:09:36','KW','965',NULL,NULL),(120,'627EF7AE-33FA-CBB0-5165-B69DE5D88639','Cayman Islands','2015-04-14 12:09:36','KY','1345',NULL,NULL),(121,'4AF2B679-80E6-AE7A-6F8C-E30BB82170CB','Kazakhstan','2015-04-14 12:09:36','KZ','7',NULL,NULL),(122,'5B49382E-7792-4FB2-5841-BDF46D215FB1','Laos','2015-04-14 12:09:36','LA','856',NULL,NULL),(123,'4F9A2D48-4692-A93C-6A6C-A450F6B15B52','Lebanon','2015-04-14 12:09:36','LB','961',NULL,NULL),(124,'A969C15C-FDB8-B9BF-7A70-CA0B20F6E746','Saint Lucia','2015-04-14 12:09:36','LC','1758',NULL,NULL),(125,'D3A607AA-9E18-3D77-0504-8FB3762B08E9','Liechtenstein','2015-04-14 12:09:36','LI','423',NULL,NULL),(126,'08186EF5-A816-5F3F-6334-2ACAFFC1036F','Sri Lanka','2015-04-14 12:09:36','LK','94',NULL,NULL),(127,'FEB0132D-0FA3-0A05-3088-59E88DFB6FCC','Liberia','2015-04-14 12:09:36','LR','231',NULL,NULL),(128,'D82F3778-BA0B-F2D7-87F1-F455816C0B10','Lesotho','2015-04-14 12:09:36','LS','266',NULL,NULL),(129,'ACC7107B-FEE4-C49E-AB16-5BBADE9707BB','Lithuania','2015-04-14 12:09:36','LT','370',NULL,NULL),(130,'D46FBEE9-CA64-2513-460C-6DE7B82E70AD','Luxembourg','2015-04-14 12:09:36','LU','352',NULL,NULL),(131,'EF9EF912-DBDC-2A60-3ABA-8F6413AB376C','Latvia','2015-04-14 12:09:36','LV','371',NULL,NULL),(132,'331657A7-D80A-E3D9-306B-7B04580BE97A','Libya','2015-04-14 12:09:36','LY','218',NULL,NULL),(133,'6F6551A5-A0D2-9614-2570-DB098D41795B','Morocco','2015-04-14 12:09:36','MA','212',NULL,NULL),(134,'D2C3C719-CFEF-92F9-1C75-4674404E2129','Monaco','2015-04-14 12:09:36','MC','377',NULL,NULL),(135,'AF24CA6E-08CF-9103-A408-198419511606','Moldova','2015-04-14 12:09:36','MD','373',NULL,NULL),(136,'0B9CDE3D-E309-F36C-6C92-7A5A3CDB5C78','Montenegro','2015-04-14 12:09:36','ME','382',NULL,NULL),(137,'7E7C60D7-8187-45FF-5856-FD4FE0A9F7F2','Saint Martin','2015-04-14 12:09:36','MF','1599',NULL,NULL),(138,'D0D90087-2CB8-BBF9-A0A7-7B9F83F0842A','Madagascar','2015-04-14 12:09:36','MG','261',NULL,NULL),(139,'2148A143-2703-2688-50AC-4D449CC478C6','Marshall Islands','2015-04-14 12:09:36','MH','692',NULL,NULL),(140,'4EDCA486-8363-D905-2223-0DD536C64FB1','Macedonia','2015-04-14 12:09:36','MK','389',NULL,NULL),(141,'D10BC835-779F-63B5-CD7F-77715C93EF5B','Mali','2015-04-14 12:09:36','ML','223',NULL,NULL),(142,'C6DE57ED-3F9E-5ECE-BED8-750D635B32D6','Burma (Myanmar)','2015-04-14 12:09:36','MM','95',NULL,NULL),(143,'79B936B1-2C70-1B2B-CF22-5DF0EDA7BFF6','Mongolia','2015-04-14 12:09:36','MN','976',NULL,NULL),(144,'340E0027-3A88-B6EF-1389-9830FF0111A1','Macau','2015-04-14 12:09:36','MO','853',NULL,NULL),(145,'79F9CD19-DD9D-215E-C834-6896D595D1DB','Northern Mariana Islands','2015-04-14 12:09:36','MP','1670',NULL,NULL),(146,'82B9D34C-D138-D44F-C78F-66E27B0B9DB5','Martinique','2015-04-14 12:09:36','MQ','',NULL,NULL),(147,'DE5DF1CD-0634-464F-0417-6E78249A9EFF','Mauritania','2015-04-14 12:09:36','MR','222',NULL,NULL),(148,'6185D85F-EFD1-F321-5C88-FD92070CC6F9','Montserrat','2015-04-14 12:09:36','MS','1664',NULL,NULL),(149,'E06F0201-CA6B-EF55-EE95-7422AE9455EA','Malta','2015-04-14 12:09:36','MT','356',NULL,NULL),(150,'FB9AE8C0-1A45-2E86-6787-73467681C533','Mauritius','2015-04-14 12:09:36','MU','230',NULL,NULL),(151,'CCCFD4DB-F847-EFB5-A954-95C3E84C8810','Maldives','2015-04-14 12:09:36','MV','960',NULL,NULL),(152,'BAD2B0BE-60A9-CBF1-8650-F709F3F71937','Malawi','2015-04-14 12:09:36','MW','265',NULL,NULL),(153,'8FB4F911-221D-C172-CD4A-2E3DDFC91E31','Mexico','2015-04-14 12:09:36','MX','52',NULL,NULL),(154,'21DE1250-CA05-4ABE-5402-5AF7CEDEF190','Malaysia','2015-04-14 12:09:36','MY','60',NULL,NULL),(155,'05CBFC51-7A5E-C473-BD2D-64E99EEF31AE','Mozambique','2015-04-14 12:09:36','MZ','258',NULL,NULL),(156,'0CAA4FA5-DC6D-601A-001C-6D44E0DC5317','Namibia','2015-04-14 12:09:36','NA','264',NULL,NULL),(157,'66330F5B-F3BC-C59D-E138-81AD487DCF5E','New Caledonia','2015-04-14 12:09:36','NC','687',NULL,NULL),(158,'D691B3AE-3239-514F-3A7C-82167837EA79','Niger','2015-04-14 12:09:36','NE','227',NULL,NULL),(159,'0F9225AD-F626-4D0B-6201-E299B8BD215A','Norfolk Island','2015-04-14 12:09:36','NF','',NULL,NULL),(160,'146B312A-59D0-71F1-FE10-6DF2E9FF3B13','Nigeria','2015-04-14 12:09:36','NG','234',NULL,NULL),(161,'D1B612B1-9C6B-C0FA-D185-9EF37FDD5B6B','Nicaragua','2015-04-14 12:09:36','NI','505',NULL,NULL),(162,'DBAE55F1-92C1-618E-32DD-FCFBCA5287F2','Netherlands','2015-04-14 12:09:36','NL','31',NULL,NULL),(163,'AA1566AC-5FBB-4165-5297-E3D1F56D23A2','Norway','2015-04-14 12:09:36','NO','47',NULL,NULL),(164,'4BF12324-809E-BB44-C6B9-B7FCA9DC0160','Nepal','2015-04-14 12:09:36','NP','977',NULL,NULL),(165,'BE8F1645-08F9-9FBD-5885-1C0C6BC93848','Niue','2015-04-14 12:09:36','NU','683',NULL,NULL),(166,'8761839C-0257-21D2-C497-382E5888F299','New Zealand','2015-04-14 12:09:36','NZ','64',NULL,NULL),(167,'8AAA2CE8-5DDF-EE89-F73E-4757ED7AC246','Oman','2015-04-14 12:09:36','OM','968',NULL,NULL),(168,'CFFD5046-148C-6ED1-B68E-7A0FD7C591B7','Panama','2015-04-14 12:09:36','PA','507',NULL,NULL),(169,'CBF62F2B-70CD-EA41-2256-E45675C78C03','Peru','2015-04-14 12:09:36','PE','51',NULL,NULL),(170,'6503A050-3EA4-38FA-FCE8-992DCE1B590B','French Polynesia','2015-04-14 12:09:36','PF','689',NULL,NULL),(171,'BA0C9E60-2EFE-AD8E-C0E7-29FCA7267DF5','Papua New Guinea','2015-04-14 12:09:36','PG','675',NULL,NULL),(172,'88E336DC-5D75-752D-C77F-93A42D5B7C03','Philippines','2015-04-14 12:09:36','PH','63',NULL,NULL),(173,'55FE4DF8-9BB2-126B-1F00-4334F8F7C640','Pakistan','2015-04-14 12:09:36','PK','92',NULL,NULL),(174,'91DD425D-10F6-0FAC-73D3-5E3F5EFC86A2','Poland','2015-04-14 12:09:36','PL','48',NULL,NULL),(175,'24354927-BE69-9B63-7324-7AE896674FF6','Saint Pierre and Miquelon','2015-04-14 12:09:36','PM','508',NULL,NULL),(176,'A21AA655-6CF5-A7A2-0CF3-374E511B7516','Pitcairn Islands','2015-04-14 12:09:36','PN','870',NULL,NULL),(177,'7A0DF8B2-C5EC-FC58-9FC4-63FEC95F2DB9','Puerto Rico','2015-04-14 12:09:36','PR','1',NULL,NULL),(178,'2BEE3A29-B3C8-7FE8-95F5-5DA81ECE0E75','State of Palestine','2015-04-14 12:09:36','PS','',NULL,NULL),(179,'3BB8EFB5-BB65-F239-28B9-9B38E8FE83AE','Portugal','2015-04-14 12:09:36','PT','351',NULL,NULL),(180,'7DFEFB58-159B-34CE-7B6E-5F5F74C0ED0B','Palau','2015-04-14 12:09:36','PW','680',NULL,NULL),(181,'4E63C338-52F7-D693-39C8-6D9B09ECD5A8','Paraguay','2015-04-14 12:09:36','PY','595',NULL,NULL),(182,'20319E02-E2D1-2FB9-B2B9-7CF8B7506DDF','Qatar','2015-04-14 12:09:36','QA','974',NULL,NULL),(183,'0DF59336-53F1-F7C7-AB18-8DBF084DA125','Réunion','2015-04-14 12:09:36','RE','',NULL,NULL),(184,'E40912F1-CC15-4F2A-D8D1-FDC335CBC8CA','Romania','2015-04-14 12:09:36','RO','40',NULL,NULL),(185,'38AC3FA4-283A-B36C-DC3D-1B59E7052A25','Serbia','2015-04-14 12:09:36','RS','381',NULL,NULL),(186,'18A6D74E-6BE8-4CC8-8473-28EF91B436B2','Russia','2015-04-14 12:09:36','RU','7',NULL,NULL),(187,'5E1EAB16-2E2F-39D3-0B0E-BF709AC39056','Rwanda','2015-04-14 12:09:36','RW','250',NULL,NULL),(188,'FDAB4E51-45A0-E5DF-1152-5DEAEC73C3AB','Saudi Arabia','2015-04-14 12:09:36','SA','966',NULL,NULL),(189,'CF21FB5C-9723-94F7-9F2B-F45CCAFC260D','Solomon Islands','2015-04-14 12:09:36','SB','677',NULL,NULL),(190,'93C95D15-F10E-B87A-81DE-E9AAD84FC53A','Seychelles','2015-04-14 12:09:36','SC','248',NULL,NULL),(191,'16302452-E1A6-D22C-5C99-133C48B5C980','Sudan','2015-04-14 12:09:36','SD','249',NULL,NULL),(192,'472AA972-37BF-1FCF-5B13-03EAE9434088','Sweden','2015-04-14 12:09:36','SE','46',NULL,NULL),(193,'B2251D82-D868-DEAE-C811-4064951956F7','Singapore','2015-04-14 12:09:36','SG','65',NULL,NULL),(194,'F453E634-1155-9BCD-D903-08BEEC64C0A8','Saint Helena','2015-04-14 12:09:36','SH','290',NULL,NULL),(195,'B3D4C1FF-8E1D-DEEE-9A1A-39C83008F889','Slovenia','2015-04-14 12:09:36','SI','386',NULL,NULL),(196,'8BF3EE1A-9967-AEDD-BA78-17C4087B28D9','Svalbard','2015-04-14 12:09:36','SJ','',NULL,NULL),(197,'6FFA1E78-2CB2-B1CF-9D58-E0C9DEDA18AC','Slovakia','2015-04-14 12:09:36','SK','421',NULL,NULL),(198,'D6A4C632-C93A-839F-B09E-5480C4FAF1AD','Sierra Leone','2015-04-14 12:09:36','SL','232',NULL,NULL),(199,'3DF96067-1DB6-B7CC-84B9-BAB7101F7131','San Marino','2015-04-14 12:09:36','SM','378',NULL,NULL),(200,'2F0BC615-1C65-C7AA-47E8-9B5CA054D867','Senegal','2015-04-14 12:09:36','SN','221',NULL,NULL),(201,'C561F1FE-B072-5973-1DEC-F67D965DE27E','Somalia','2015-04-14 12:09:36','SO','252',NULL,NULL),(202,'0775258C-EDC1-135D-E35C-01BD85F45F29','Suriname','2015-04-14 12:09:36','SR','597',NULL,NULL),(203,'AD0BAC3A-1DA4-23DA-0010-431A279304BE','Sao Tome and Principe','2015-04-14 12:09:36','SS','239',NULL,NULL),(204,'A4BDF3BD-B7F1-1B9B-CD98-A0C78ED53511','El Salvador','2015-04-14 12:09:36','ST','503',NULL,NULL),(205,'F4CEADD9-25F5-45F2-2E19-5B1795CE9D69','El Salvador','2015-04-14 12:09:36','SV','503',NULL,NULL),(206,'46AD5507-C8B7-9F6D-571A-9E6E1C044CD6','Sint Maarten','2015-04-14 12:09:36','SX','',NULL,NULL),(207,'3B28BF51-D190-F7CE-1BBA-49F72481AE3B','Syria','2015-04-14 12:09:36','SY','963',NULL,NULL),(208,'1C48EC65-1073-25CD-5F53-7E4D22282B1B','Swaziland','2015-04-14 12:09:36','SZ','268',NULL,NULL),(209,'D3C33017-0BAE-B451-1190-B5A9A6D81265','Turks and Caicos Islands','2015-04-14 12:09:36','TC','1649',NULL,NULL),(210,'436517D3-FF50-05BE-04A4-6314683C29BF','Chad','2015-04-14 12:09:36','TD','235',NULL,NULL),(211,'373E212C-A17A-3D03-ACB3-588E2ECE1120','French Southern Territories','2015-04-14 12:09:36','TF','',NULL,NULL),(212,'1DD74013-D596-D740-60F5-E007CFE9EE59','Togo','2015-04-14 12:09:36','TG','228',NULL,NULL),(213,'BF1DDCD3-0F3A-A81E-0508-910B20ED3822','Thailand','2015-04-14 12:09:36','TH','66',NULL,NULL),(214,'FB3A6E3C-53A9-CD6C-0F7C-302AB483B4BD','Tajikistan','2015-04-14 12:09:36','TJ','992',NULL,NULL),(215,'C343A6AB-0FAD-E093-7AF3-9589F5E58F64','Timor-Leste','2015-04-14 12:09:36','TL','670',NULL,NULL),(216,'DD3F11FD-CE04-AE45-D4DF-CB1324DDE122','Turkmenistan','2015-04-14 12:09:36','TM','993',NULL,NULL),(217,'0AEF23A3-F684-B964-4D93-B507C40B66B4','Tunisia','2015-04-14 12:09:36','TN','216',NULL,NULL),(218,'A0662AD7-4934-E321-563F-6476311DD70C','Tonga','2015-04-14 12:09:36','TO','676',NULL,NULL),(219,'5D0ECEE1-03F5-6D19-F5F3-F07F186DDF04','Turkey','2015-04-14 12:09:36','TR','90',NULL,NULL),(220,'F468D4C0-D571-5462-D0F1-6F0E4064AF46','Trinidad and Tobago','2015-04-14 12:09:36','TT','1868',NULL,NULL),(221,'BD92ECEC-C1D0-2516-23BF-75D5C2B05988','Tuvalu','2015-04-14 12:09:36','TV','688',NULL,NULL),(222,'C378CD23-31C4-6D56-EBA9-C38D38F74068','Taiwan','2015-04-14 12:09:36','TW','886',NULL,NULL),(223,'11BAD1B7-D5B5-6F57-AE04-F483B2DEDAAB','Tanzania','2015-04-14 12:09:36','TZ','255',NULL,NULL),(224,'4E7C6962-8A60-18F5-6380-6178B1BD4D1A','Ukraine','2015-04-14 12:09:36','UA','380',NULL,NULL),(225,'2795DDE4-B42F-E010-4444-6F9AD1F42E87','Uganda','2015-04-14 12:09:36','UG','256',NULL,NULL),(226,'EF77733B-A972-EC78-8799-0BACF0ABF529','United States','2015-04-14 12:09:36','US','1',NULL,NULL),(227,'B1395F88-00C0-939B-DDFA-9DCBFB467EA4','Uruguay','2015-04-14 12:09:36','UY','598',NULL,NULL),(228,'81E0BAA8-C899-C67F-9A1C-7F93971F181D','Uzbekistan','2015-04-14 12:09:36','UZ','998',NULL,NULL),(229,'2ED293A8-00CF-E7F0-CA85-771A46E9F0B1','Holy See (Vatican City)','2015-04-14 12:09:36','VA','39',NULL,NULL),(230,'B34513B1-18A0-6F0F-9F93-5EBF96B73ADB','Saint Vincent and the Grenadines','2015-04-14 12:09:36','VC','1784',NULL,NULL),(231,'B4F3DA05-56D3-25AE-F8A9-8506B67C9004','Venezuela','2015-04-14 12:09:36','VE','58',NULL,NULL),(232,'301B703B-B60C-4652-FB06-19CD778F0C74','British Virgin Islands','2015-04-14 12:09:36','VG','1284',NULL,NULL),(233,'C4ECE65F-CDFC-F50E-DCD9-3DB7CAB7C95E','US Virgin Islands','2015-04-14 12:09:36','VI','1340',NULL,NULL),(234,'C7245281-9AEA-4F60-73E4-0582061C77E9','Vietnam','2015-04-14 12:09:36','VN','84',NULL,NULL),(235,'BD92A44B-875F-79D2-3E12-D5175612D928','Vanuatu','2015-04-14 12:09:36','VU','678',NULL,NULL),(236,'E325ABAA-4150-836C-061D-6679EFEF3595','Wallis and Futuna','2015-04-14 12:09:36','WF','681',NULL,NULL),(237,'D8432DE9-535D-E306-0741-835AC0420A5B','Samoa','2015-04-14 12:09:36','WS','685',NULL,NULL),(238,'B133FA3B-7130-B4AF-373E-DEB720102D9B','Kosovo','2015-04-14 12:09:36','XK','',NULL,NULL),(239,'3ABF1436-FAE0-3FD9-8948-501028332B17','Yemen','2015-04-14 12:09:36','YE','967',NULL,NULL),(240,'7FA28C16-AE62-FBC2-7CEF-A5E4B71B826A','Mayotte','2015-04-14 12:09:36','YT','262',NULL,NULL),(241,'38690943-EB49-39BB-09C7-1F987A3DDB85','South Africa','2015-04-14 12:09:36','ZA','27',NULL,NULL),(242,'99795989-6422-28FE-D1A6-054605E86075','Zambia','2015-04-14 12:09:36','ZM','260',NULL,NULL),(243,'A6852D18-8C62-9B94-7F4B-2E65FE64EE88','Zimbabwe','2015-04-14 12:09:36','ZW','263',NULL,NULL);
/*!40000 ALTER TABLE `country` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devices`
--

DROP TABLE IF EXISTS `devices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `TYPE` varchar(100) NOT NULL DEFAULT '',
  `LINKED_OBJECT` varchar(100) NOT NULL DEFAULT '',
  `LOCATION_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  `SUBTYPE` varchar(100) NOT NULL DEFAULT '',
  `ENDPOINT_MODULE` varchar(255) NOT NULL DEFAULT '',
  `ENDPOINT_NAME` varchar(255) NOT NULL DEFAULT '',
  `ENDPOINT_TITLE` varchar(255) NOT NULL DEFAULT '',
  `ROLES` varchar(100) NOT NULL DEFAULT '',
  `FAVORITE` int(3) unsigned NOT NULL DEFAULT '0',
  `ALT_TITLES` varchar(255) NOT NULL DEFAULT '',
  `SYSTEM_DEVICE` int(3) unsigned NOT NULL DEFAULT '0',
  `CLICKED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devices`
--

LOCK TABLES `devices` WRITE;
/*!40000 ALTER TABLE `devices` DISABLE KEYS */;
INSERT INTO `devices` VALUES (1,'rgb','rgb','Rgb01',0,'','','','','','',0,'',0,NULL),(2,'RGB','rgb','Gateway1',0,'','','','','','',0,'',0,NULL);
/*!40000 ALTER TABLE `devices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devices_groups`
--

DROP TABLE IF EXISTS `devices_groups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devices_groups` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `SYS_NAME` varchar(100) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `APPLY_TYPES` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devices_groups`
--

LOCK TABLES `devices_groups` WRITE;
/*!40000 ALTER TABLE `devices_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `devices_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devices_linked`
--

DROP TABLE IF EXISTS `devices_linked`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devices_linked` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `DEVICE1_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `DEVICE2_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `LINK_TYPE` varchar(100) NOT NULL DEFAULT '',
  `LINK_SETTINGS` text,
  `COMMENT` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devices_linked`
--

LOCK TABLES `devices_linked` WRITE;
/*!40000 ALTER TABLE `devices_linked` DISABLE KEYS */;
/*!40000 ALTER TABLE `devices_linked` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devices_scheduler_points`
--

DROP TABLE IF EXISTS `devices_scheduler_points`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `devices_scheduler_points` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `LINKED_METHOD` varchar(255) NOT NULL DEFAULT '',
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `SET_TIME` varchar(50) NOT NULL DEFAULT '',
  `SET_DAYS` varchar(50) NOT NULL DEFAULT '',
  `DEVICE_ID` int(10) NOT NULL DEFAULT '0',
  `ACTIVE` int(3) NOT NULL DEFAULT '1',
  `LATEST_RUN` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devices_scheduler_points`
--

LOCK TABLES `devices_scheduler_points` WRITE;
/*!40000 ALTER TABLE `devices_scheduler_points` DISABLE KEYS */;
/*!40000 ALTER TABLE `devices_scheduler_points` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `elements`
--

DROP TABLE IF EXISTS `elements`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `elements` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `SCENE_ID` int(10) NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `TYPE` varchar(255) NOT NULL DEFAULT '',
  `TOP` int(10) NOT NULL DEFAULT '0',
  `LEFT` int(255) NOT NULL DEFAULT '0',
  `WIDTH` int(255) NOT NULL DEFAULT '0',
  `HEIGHT` int(255) NOT NULL DEFAULT '0',
  `CROSS_SCENE` int(3) NOT NULL DEFAULT '0',
  `BACKGROUND` int(3) NOT NULL DEFAULT '1',
  `JAVASCRIPT` text,
  `CSS` text,
  `DX` int(10) NOT NULL DEFAULT '0',
  `DY` int(10) NOT NULL DEFAULT '0',
  `LINKED_ELEMENT_ID` int(10) NOT NULL DEFAULT '0',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `CSS_STYLE` varchar(255) NOT NULL DEFAULT '',
  `POSITION_TYPE` int(3) NOT NULL DEFAULT '0',
  `CONTAINER_ID` int(10) NOT NULL DEFAULT '0',
  `S3D_SCENE` varchar(255) NOT NULL DEFAULT '',
  `SMART_REPEAT` int(3) NOT NULL DEFAULT '0',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(255) NOT NULL DEFAULT '',
  `WIZARD_DATA` text,
  `EASY_CONFIG` int(3) NOT NULL DEFAULT '0',
  `APPEAR_ANIMATION` int(3) NOT NULL DEFAULT '0',
  `DEVICE_ID` int(10) NOT NULL DEFAULT '0',
  `CLASS_TEMPLATE` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=533 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `elements`
--

LOCK TABLES `elements` WRITE;
/*!40000 ALTER TABLE `elements` DISABLE KEYS */;
INSERT INTO `elements` VALUES (155,7,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','/* -----------------------------------------------------------------------*/\r\n/* панель1  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-one {\r\n box-sizing: border-box;\r\n color: White;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 400px;\r\n height: 200px;\r\n -moz-border-radius: 0px 10px 10px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 10px 10px 10px 10px;\r\n}\r\n\r\nbutton3_1 \r\n{\r\ndisplay: block;\r\n  font-size: 1em;\r\n  text-align: center;\r\n}\r\n\r\nbutton3_2\r\n{\r\n    background: #f2f6f8; /* Цвет фона */\r\n    border: 1px solid #7a7b7e; /* Параметры рамки */\r\n    width: 100px; /* Ширина кнопки */\r\n    height: 100px; /* Высота */\r\n    border-radius: 50px;\r\n   }\r\n\r\n.circle{\r\nopacity:0;\r\n width:100px;\r\n height:100px;\r\n display:block;\r\n border-radius:50px;\r\n -moz-border-radius:50px;\r\n -webkit-border-radius:50px;\r\n -khtml-border-radius:50px;\r\n font-size:20px; color:#fff;\r\n line-height:100px;\r\n text-align:center;\r\n background:#000\r\n}\r\n\r\n.circle:hover {\r\nopacity:0.7;\r\nwidth:100px;\r\n height:100px;\r\n display:block;\r\n border-radius:50px;\r\n -moz-border-radius:50px;\r\n -webkit-border-radius:50px;\r\n -khtml-border-radius:50px;\r\n font-size:20px; color:#fff;\r\n line-height:100px;\r\n text-align:center;\r\n background:#000\r\n}',0,0,0,10000,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(37,3,'panel-time','html',5,-3,350,100,0,0,'','',0,0,0,230,'default',0,0,'',0,'','','','','',0,0,0,''),(38,3,'weather','html',4,2,100,100,0,0,'','',0,0,0,280,'default',0,0,'',0,'','','','','',0,0,0,''),(40,3,'sustem_status','html',115,5,0,0,0,0,'','',0,0,0,240,'default',0,0,'',0,'','','','','',0,0,0,''),(41,3,'1','html',145,5,110,0,0,0,'','',0,0,0,110,'default',0,0,'',0,'','','','','',0,0,0,''),(42,3,'4','html',190,5,110,0,0,0,'','',0,0,0,100,'default',0,0,'',0,'','','','','',0,0,0,''),(43,3,'2','html',145,120,110,0,0,0,'','',0,0,0,80,'default',0,0,'',0,'','','','','',0,0,0,''),(44,3,'5','html',190,120,110,0,0,0,'','',0,0,0,70,'default',0,0,'',0,'','','','','',0,0,0,''),(45,3,'3','html',145,235,110,0,0,0,'','',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(46,3,'6','html',190,235,110,0,0,0,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(47,3,'7','html',235,5,110,0,0,0,'','',0,0,0,90,'default',0,0,'',0,'','','','','',0,0,0,''),(48,3,'10','html',280,5,110,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(49,3,'8','html',235,120,110,0,0,0,'','',0,0,0,60,'default',0,0,'',0,'','','','','',0,0,0,''),(50,3,'11','html',280,120,110,0,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(51,3,'9','html',235,235,110,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(52,3,'выкл всё','html',370,235,110,0,0,0,'','',0,0,0,120,'default',0,0,'',0,'','','','','',0,0,0,''),(66,3,'12','html',280,235,110,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(65,3,'13','html',325,5,110,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(55,3,'day1','html',482,52,0,0,0,0,'','',0,0,0,220,'default',0,0,'',0,'','','','','',0,0,0,''),(56,3,'day1_img','html',505,0,50,37,0,0,'','',0,0,0,200,'default',0,0,'',0,'','','','','',0,0,0,''),(36,3,'general_CSS (only CSS)','html',1,490,0,0,0,0,'','//@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_126 { animation: fortime 1s ease-out; } /* - блок времени */\r\n\r\n.element_28 { animation: forweather 1.6s ease-out; } /* - блок погоды */\r\n\r\n.element_29 { animation: forweather 1.4s ease-out; } /* - блок STATUS SYSTEM  */\r\n\r\n.element_61 { animation: forshowing 1.2s ease-out; } /* - блок отображения - panel-showing1 */\r\n.element_62 { animation: forshowing 1.4s ease-out; } /* - блок отображения - panel-showing2 */\r\n.element_63 { animation: forshowing 1.6s ease-out; } /* - блок отображения - panel-showing3 */\r\n.element_64 { animation: forshowing 1.8s ease-out; } /* - блок отображения - panel-showing4 */\r\n\r\n.element_88 {animation: forlog 1.2s ease-out; } /* - ,блок отображения - log_alice */\r\n\r\n.element_46  { animation: forfunctions 1s ease-out; }  /*  - блок - panel-functions1 */\r\n.element_47  { animation: forfunctions 1.2s ease-out; } /*  - блок - panel-functions2 */\r\n.element_48  { animation: forfunctions 1.1s ease-out; } /*  - блок - panel-functions3 */\r\n.element_49  { animation: forfunctions 1.4s ease-out; } /*  - блок - panel-functions4 */\r\n.element_50  { animation: forfunctions 1.3s ease-out; } /*  - блок - panel-functions5 */\r\n.element_51  { animation: forfunctions 1.5s ease-out; } /*  - блок - panel-functions6 */\r\n/* ------------------------------------------------------------------------------------------------------------------------------------------- */\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* кнопки */ \r\n/* -----------------------------------------------------------------------*/\r\n\r\n/* общий  вид для кнопок*/\r\nbutton1,\r\nbutton2\r\n{\r\n display: block;\r\n  font-size: 1.1em;\r\n  font-weight: bold;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  padding: 10px 15px;\r\n  color: #ccc;\r\n  border-radius: 7.5px;\r\n  text-shadow: 0 -1px 0 #000;\r\n  box-shadow: 0 1px 0 #666, 0 5px 0 #444, 0 6px 6px rgba(0,0,0,0.6);\r\n  cursor: pointer;\r\n  -webkit-transition: all 150ms ease;\r\n  transition: all 150ms ease;\r\n}\r\n\r\n/*цвет и анимация свечения кнопки вкл*/\r\nbutton1 \r\n{\r\nbackground-color: #126be0;\r\n  background: -webkit-linear-gradient(#0d448c, #126be0);\r\n  background: linear-gradient(#0d448c, #126be0);\r\n-webkit-animation: pulsate 0s linear infinite;\r\n  animation: pulsate 0.s linear infinite;\r\n}\r\n\r\n/* цвет кнопки выкл*/\r\nbutton2 \r\n{\r\n  background-color: #555;\r\n  background: -webkit-linear-gradient(#888, #555);\r\n  background: linear-gradient(#888, #555);\r\n}\r\n\r\n\r\n/* анимация при наведении на кнопку вкл и при наведении на текст кнопки вкл*/\r\nbutton1:hover,\r\nbutton1:focus\r\n{\r\n  -webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 0.5s linear infinite;\r\n}\r\n/*карта анимации пульсации текста*/\r\n@-webkit-keyframes pulsate \r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n@keyframes pulsate\r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n/*карта анимации нажатия на кнопку*/\r\nbutton1:active,\r\nbutton2:active\r\n{\r\n  color: #fff;\r\n  text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff;\r\n  box-shadow: 0 1px 0 #666, 0 2px 0 #444, 0 2px 2px rgba(0,0,0,0.9);\r\n  -webkit-transform: translateY(3px);\r\n  transform: translateY(3px);\r\n  -webkit-animation: none;\r\n  animation: none;\r\n}\r\n\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - log_alice */ \r\n/* -----------------------------------------------------------------------*/\r\n .element_88 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - status_system_icons */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_94 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 2px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/*  контейнер - temp_home_1_floor и humidity_home_1_floor */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_109,\r\n.element_140 {\r\ndisplay: table;\r\n}\r\n.element_109 .fa,\r\n.element_109 .texttemp,\r\n.element_140 .fa,\r\n.element_140 .texttemp\r\n {\r\n        display: table-cell;\r\n        font-size: 28px;\r\n       /* font-weight: bold;*/\r\n        line-height: 1;\r\n        padding: 0 5px 0 0;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-weather {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n  position: absolute;\r\n /* top: 0px; */\r\n/*  right: 0px; */\r\n  width: 480px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  -moz-border-radius: 10px 0px 0px 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 10px;\r\n}\r\n.panel-weather .location {\r\nbackground-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 10px 0px 0px 0px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 0px;\r\n}\r\n\r\n.panel-weather img {\r\n  width: 96px;\r\n  margin: 10px 50px 0 0;\r\n}\r\n.panel-weather .temp-weather {\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 96px;\r\n  line-height: 1.4;\r\n}\r\n.panel-weather .temp-weather .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 32px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.panel-weather .text-weather {\r\n font-family: arial;\r\n font-weight: 200;\r\n  font-size: 22px;\r\n  line-height: 1.4;\r\n margin: 0 0 4px 0;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* панель времени  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-time {\r\n box-sizing: border-box;\r\n color: White;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 350px;\r\n -moz-border-radius: 0px 10px 10px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 10px 10px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-time .time {\r\n font-size: 85px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n}\r\n.panel-time .time .blnk {\r\n font-size: 85px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\nanimation: blink 1s ease infinite;\r\n}\r\n.panel-time .date {\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 0px 0px 10px 0px;\r\n  -webkit-border-radius: 0px;\r\n  border-radius: 0px 0px 10px 0px;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки отображения данных  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-showing1,\r\n.panel-showing2,\r\n.panel-showing3,\r\n.panel-showing4  {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n  position: absolute;\r\n  width: 480px;\r\n  overflow: hidden;\r\n  cursor: pointer;\r\n  background-color: initial;\r\n}\r\n.panel-showing1 ul,\r\n.panel-showing2 ul,\r\n.panel-showing3 ul,\r\n.panel-showing4 ul {\r\n  padding: 0;\r\n}\r\n.panel-showing1 ul li,\r\n.panel-showing2 ul li,\r\n.panel-showing3 ul li,\r\n.panel-showing4 ul li {\r\n  padding: 0;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1, \r\n.panel-showing1 ul li .title, \r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_1, \r\n.panel-showing2 ul li .title, \r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_1, \r\n.panel-showing3 ul li .title, \r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_1, \r\n.panel-showing4 ul li .title, \r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  display: inline-block;\r\n  font-size: 20px;\r\n  line-height: 1.6;\r\n  padding: 3px 8px;\r\n font-family: monospace;\r\n font-weight: lighter;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1,\r\n.panel-showing2 ul li .sense_snowing_1,\r\n.panel-showing3 ul li .sense_snowing_1,\r\n.panel-showing4 ul li .sense_snowing_1 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  color: white;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n\r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 40, 40, 0.6);\r\n  color: rgba(190, 190, 190, 1);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки кнопок функций */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-functions {\r\n box-sizing: border-box;\r\n color: white;\r\n /* background-color: rgba(0, 0, 0, 0.4); */\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.panel-functions .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 10px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 40px;\r\n  -webkit-border-radius: 40px;\r\n  border-radius: 40px;\r\n}\r\n.panel-functions .icon .fa {\r\n margin: -5px 0px 0px -2px;\r\n font-size: 52px;\r\n}\r\n.panel-functions .icon .title {\r\n  font-size: 8px;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  /* display: none; */\r\n}\r\n/* ------------------------------------------------------------------------ */\r\n\r\ntim6 {\r\n    font-size: 8pt;\r\n\r\n   }\r\n',0,0,0,10000,'default',0,0,'',0,'','','','','',0,0,0,''),(57,3,'day2_img','html',505,114,50,37,0,0,'','',0,0,0,170,'default',0,0,'',0,'','','','','',0,0,0,''),(58,3,'day2','html',483,163,0,0,0,0,'','',0,0,0,180,'default',0,0,'',0,'','','','','',0,0,0,''),(59,3,'day3_img','html',505,233,50,37,0,0,'','',0,0,0,140,'default',0,0,'',0,'','','','','',0,0,0,''),(60,3,'day3','html',483,282,0,0,0,0,'','',0,0,0,150,'default',0,0,'',0,'','','','','',0,0,0,''),(61,3,'day1_p','html',480,0,0,0,0,0,'','',0,0,0,190,'default',0,0,'',0,'','','','','',0,0,0,''),(62,3,'day2_p','html',484,111,0,0,0,0,'','',0,0,0,160,'default',0,0,'',0,'','','','','',0,0,0,''),(63,3,'day3_p','html',482,227,0,0,0,0,'','',0,0,0,130,'default',0,0,'',0,'','','','','',0,0,0,''),(64,3,'panel2','html',455,0,350,100,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(67,3,'14','html',325,120,110,0,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(68,3,'15','html',325,235,110,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(69,3,'16','html',370,5,110,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(99,5,'time','html',-5,10,1050,370,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(100,5,'date','html',337,650,400,75,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(101,5,'temp_day','html',343,2,230,120,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(102,5,'fact_weather','html',337,247,400,30,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(103,5,'fact_img','html',369,244,180,135,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(104,5,'st1','html',335,2,60,16,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(105,5,'day','html',414,800,250,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(106,5,'fact','html',385,429,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(108,5,'day1','html',513,345,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(109,5,'day1_img','html',527,242,100,75,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(110,5,'day2_img','html',529,508,100,75,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(111,5,'day2','html',513,611,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(112,5,'day3_img','html',529,775,100,75,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(113,5,'day3','html',513,878,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(154,5,'5','html',620,580,130,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(116,5,'day1_p','html',502,244,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(117,5,'day2_p','html',504,504,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(118,5,'day3_p','html',504,764,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(98,5,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','@font-face {\r\nfont-family:\"S7\";\r\nsrc:url(\"../../cms/scenes/imm/fonts/S7.ttf\") format(\"truetype\");\r\nfont-weight:normal;\r\nfont-style:normal;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n.time {\r\n font-size: 430px;\r\n line-height: 1;\r\n text-align: center;\r\n font-family: S7;\r\n font-weight: normal;\r\ncolor: lime;\r\n}\r\n.time .blnk {\r\n font-size: 430 px;\r\n line-height: 1;\r\n text-align: center;\r\n font-family: S7;\r\n font-weight: normal;\r\ncolor: lime;\r\nanimation: blink 1s ease infinite;\r\n}\r\n\r\ntim {\r\n    font-family: S7;\r\n    font-size: 100pt;\r\n    color: lime; \r\n   }\r\ntim2 {\r\n    font-family: S7;\r\n    font-size: 60pt;\r\n    color: lime; \r\n   }\r\ntim3 {\r\n    font-family: S7;\r\n    font-size: 20pt;\r\n    color: lime; \r\n   }\r\ntim4 {\r\n    font-family: S7;\r\n    font-size: 30pt;\r\n    color: lime; \r\n    text-align: right;\r\n   }\r\ntim5 {\r\n    font-family: S7;\r\n    font-size: 20pt;\r\n    color: lime; \r\n   }\r\ntim6 {\r\n    font-family: S7;\r\n    font-size: 16pt;\r\n    color: lime; \r\n   }\r\ntim7 {\r\n    font-family: S7;\r\n    font-size: 8pt;\r\n    color: lime; \r\n   }\r\n\r\n\r\n\r\n/*цвет вкл*/\r\nbutton1_1 \r\n{\r\ndisplay: block;\r\n  font-size: 1.5em;\r\n  font-family: S7;\r\n  font-weight: bold;\r\n  text-align: center;\r\n  padding: 10px 15px;\r\n  color: black;\r\n  border-style: solid;\r\n  border-color: lime;\r\n  border-radius: 7.5px;\r\n  border-width: 2px;\r\n  background-color: lime;\r\n}\r\n\r\n/* цвет кнопки выкл*/\r\nbutton1_2 \r\n{\r\n display: block;\r\n  font-size: 1.5em;\r\n  font-family: S7;\r\n  font-weight: bold;\r\n  text-align: center;\r\n  padding: 10px 15px;\r\n  color:  lime;\r\n  border-style: solid;\r\n  border-color: lime;\r\n  border-radius: 7.5px;\r\n  border-width: 2px;\r\n  background-color: black;\r\n}\r\n',0,0,0,10000,'default',0,0,'',0,'','','','','',0,0,0,''),(121,5,'2','html',618,150,130,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(122,5,'3','html',618,295,130,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(120,5,'1','html',618,8,130,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(123,5,'4','html',620,441,130,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(153,5,'sun','html',465,14,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(156,7,'panel1','html',37,52,400,200,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(157,7,'1','html',73,80,50,50,0,0,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(158,7,'2','html',78,151,50,50,0,0,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(159,7,'3','html',75,214,50,50,0,0,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(209,9,'panel-showing4','html',158,0,480,52,0,0,'','',0,0,0,974,'default',0,195,'',0,'','','','',NULL,0,0,0,''),(208,9,'panel-showing3','html',104,0,480,52,0,0,'','',0,0,0,976,'default',0,195,'',0,'','','','',NULL,0,0,0,''),(194,9,'functions','container',440,0,1022,158,0,1,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(195,9,'showing','container',222,0,480,210,0,0,'','',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(196,9,'panel-time','html',18,-2,480,200,0,0,'','',0,0,0,60,'default',0,0,'',0,'','','','','',0,0,0,''),(197,9,'status_Security','html',0,150,32,32,0,0,'','',0,0,0,958,'default',0,192,'',0,'','','','',NULL,0,0,0,''),(198,9,'status_System','html',0,190,32,32,0,0,'','',0,0,0,957,'default',0,192,'',0,'','','','',NULL,0,0,0,''),(199,9,'status_Communication','html',0,230,32,32,0,0,'','',0,0,0,956,'default',0,192,'',0,'','','','',NULL,0,0,0,''),(200,9,'function_1','html',20,32,120,120,0,0,'','',0,0,0,968,'default',0,194,'',0,'','','','',NULL,0,0,0,''),(201,9,'function_2','html',20,200,120,120,0,0,'','',0,0,0,967,'default',0,194,'',0,'','','','',NULL,0,0,0,''),(202,9,'function_3','html',20,368,120,120,0,0,'','',0,0,0,966,'default',0,194,'',0,'','','','',NULL,0,0,0,''),(203,9,'function_4','html',20,536,120,120,0,0,'','',0,0,0,965,'default',0,194,'',0,'','','','',NULL,0,0,0,''),(204,9,'function_6','html',20,872,120,120,0,0,'','',0,0,0,963,'default',0,194,'',0,'','','','',NULL,0,0,0,''),(205,9,'function_5','html',20,704,120,120,0,0,'','',0,0,0,964,'default',0,194,'',0,'','','','',NULL,0,0,0,''),(206,9,'panel-showing1','html',0,0,480,52,0,0,'','',0,0,0,980,'default',0,195,'',0,'','','','',NULL,0,0,0,''),(207,9,'panel-showing2','html',52,0,480,52,0,0,'','',0,0,0,978,'default',0,195,'',0,'','','','',NULL,0,0,0,''),(192,9,'status_system_icons','container',224,543,474,32,0,1,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(193,9,'general_CSS (only CSS)','html',1,490,0,0,0,0,'','/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n\r\n.element_196 { animation: fortime 1s ease-out; } /* - блок времени */\r\n.element_189 { animation: forweather 1.6s ease-out; } /* - блок погоды */\r\n.element_192 { animation: forweather 1.4s ease-out; } /* - блок STATUS SYSTEM  */\r\n.element_206 { animation: forshowing 1.2s ease-out; } /* - блок отображения - panel-showing1 */\r\n.element_207 { animation: forshowing 1.4s ease-out; } /* - блок отображения - panel-showing2 */\r\n.element_208 { animation: forshowing 1.6s ease-out; } /* - блок отображения - panel-showing3 */\r\n.element_209 { animation: forshowing 1.8s ease-out; } /* - блок отображения - panel-showing4 */\r\n.element_190 {animation: forlog 1.2s ease-out; } /* - ,блок отображения - log_alice */\r\n.element_200  { animation: forfunctions 1s ease-out; }  /*  - блок - panel-functions1 */\r\n.element_201  { animation: forfunctions 1.2s ease-out; } /*  - блок - panel-functions2 */\r\n.element_202  { animation: forfunctions 1.1s ease-out; } /*  - блок - panel-functions3 */\r\n.element_203  { animation: forfunctions 1.4s ease-out; } /*  - блок - panel-functions4 */\r\n.element_204 { animation: forfunctions 1.3s ease-out; } /*  - блок - panel-functions5 */\r\n.element_205  { animation: forfunctions 1.5s ease-out; } /*  - блок - panel-functions6 */\r\n/* ------------------------------------------------------------------------------------------------------------------------------------------- */\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* кнопки */ \r\n/* -----------------------------------------------------------------------*/\r\n\r\n/* общий  вид для кнопок*/\r\nbutton1,\r\nbutton2\r\n{\r\n display: block;\r\n  font-size: 1.1em;\r\n  font-weight: bold;\r\n  text-transform: uppercase;\r\n  padding: 10px 15px;\r\n  color: #ccc;\r\n  border-radius: 7.5px;\r\n  text-shadow: 0 -1px 0 #000;\r\n  box-shadow: 0 1px 0 #666, 0 5px 0 #444, 0 6px 6px rgba(0,0,0,0.6);\r\n  cursor: pointer;\r\n  -webkit-transition: all 150ms ease;\r\n  transition: all 150ms ease;\r\n}\r\n\r\n/*цвет и анимация свечения кнопки вкл*/\r\nbutton1 \r\n{\r\nbackground-color: #126be0;\r\n  background: -webkit-linear-gradient(#0d448c, #126be0);\r\n  background: linear-gradient(#0d448c, #126be0);\r\n-webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 05.s linear infinite;\r\n}\r\n\r\n/* цвет кнопки выкл*/\r\nbutton2 \r\n{\r\n  background-color: #555;\r\n  background: -webkit-linear-gradient(#888, #555);\r\n  background: linear-gradient(#888, #555);\r\n}\r\n\r\n/* анимация при наведении на кнопку вкл и при наведении на текст кнопки вкл*/\r\nbutton1:hover,\r\nbutton1:focus\r\n{\r\n  -webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 0.5s linear infinite;\r\n}\r\n/*карта анимации пульсации текста*/\r\n@-webkit-keyframes pulsate \r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n@keyframes pulsate\r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n/*карта анимации нажатия на кнопку*/\r\nbutton1:active,\r\nbutton2:active\r\n{\r\n  color: #fff;\r\n  text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff;\r\n  box-shadow: 0 1px 0 #666, 0 2px 0 #444, 0 2px 2px rgba(0,0,0,0.9);\r\n  -webkit-transform: translateY(3px);\r\n  transform: translateY(3px);\r\n  -webkit-animation: none;\r\n  animation: none;\r\n}\r\n\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - log_alice */ \r\n/* -----------------------------------------------------------------------*/\r\n .element_88 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - status_system_icons */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_94 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 2px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/*  контейнер - temp_home_1_floor и humidity_home_1_floor */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_109,\r\n.element_140 {\r\ndisplay: table;\r\n}\r\n.element_109 .fa,\r\n.element_109 .texttemp,\r\n.element_140 .fa,\r\n.element_140 .texttemp\r\n {\r\n        display: table-cell;\r\n        font-size: 28px;\r\n       /* font-weight: bold;*/\r\n        line-height: 1;\r\n        padding: 0 5px 0 0;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-weather {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n  position: absolute;\r\n /* top: 0px; */\r\n/*  right: 0px; */\r\n  width: 480px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  -moz-border-radius: 10px 0px 0px 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 10px;\r\n}\r\n.panel-weather .location {\r\nbackground-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 10px 0px 0px 0px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 0px;\r\n}\r\n\r\n.panel-weather img {\r\n  width: 96px;\r\n  margin: 10px 50px 0 0;\r\n}\r\n.panel-weather .temp-weather {\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 96px;\r\n  line-height: 1.4;\r\n}\r\n.panel-weather .temp-weather .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 32px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.panel-weather .text-weather {\r\n font-family: arial;\r\n font-weight: 200;\r\n  font-size: 22px;\r\n  line-height: 1.4;\r\n margin: 0 0 4px 0;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* панель времени  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-time {\r\n box-sizing: border-box;\r\n color: White;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 480px;\r\n -moz-border-radius: 0px 10px 10px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 10px 10px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-time .time {\r\n font-size: 140px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n}\r\n.panel-time .time .blnk {\r\n font-size: 140px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\nanimation: blink 1s ease infinite;\r\n}\r\n.panel-time .date {\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 0px 0px 10px 0px;\r\n  -webkit-border-radius: 0px;\r\n  border-radius: 0px 0px 10px 0px;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки отображения данных  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-showing1,\r\n.panel-showing2,\r\n.panel-showing3,\r\n.panel-showing4  {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n  position: absolute;\r\n  width: 480px;\r\n  overflow: hidden;\r\n  cursor: pointer;\r\n  background-color: initial;\r\n}\r\n.panel-showing1 ul,\r\n.panel-showing2 ul,\r\n.panel-showing3 ul,\r\n.panel-showing4 ul {\r\n  padding: 0;\r\n}\r\n.panel-showing1 ul li,\r\n.panel-showing2 ul li,\r\n.panel-showing3 ul li,\r\n.panel-showing4 ul li {\r\n  padding: 0;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1, \r\n.panel-showing1 ul li .title, \r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_1, \r\n.panel-showing2 ul li .title, \r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_1, \r\n.panel-showing3 ul li .title, \r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_1, \r\n.panel-showing4 ul li .title, \r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  display: inline-block;\r\n  font-size: 20px;\r\n  line-height: 1.6;\r\n  padding: 3px 8px;\r\n font-family: monospace;\r\n font-weight: lighter;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1,\r\n.panel-showing2 ul li .sense_snowing_1,\r\n.panel-showing3 ul li .sense_snowing_1,\r\n.panel-showing4 ul li .sense_snowing_1 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  color: white;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n\r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 40, 40, 0.6);\r\n  color: rgba(190, 190, 190, 1);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки кнопок функций */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-functions {\r\n box-sizing: border-box;\r\n color: white;\r\n /* background-color: rgba(0, 0, 0, 0.4); */\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.panel-functions .icon {\r\n  margin: 0;\r\n  width: 82px;\r\n  height: 82px;\r\n  padding: 10px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px;\r\n}\r\n.panel-functions .icon .fa {\r\n margin: 7px 0px 0px 0px;\r\n font-size: 70px;\r\n}\r\n.panel-functions .icon .title {\r\n  font-size: 8px;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  /* display: none; */\r\n}\r\n/* ------------------------------------------------------------------------ */',0,0,0,90,'default',0,0,'',0,'','','','','',0,0,0,''),(189,9,'panel-weather','html',20,543,480,200,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(190,9,'log_alice','html',270,543,477,140,0,1,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(191,9,'all_animations_cart (only CSS)','html',0,485,0,0,0,0,'','/* мигалка */\r\n@keyframes blink {\r\n  0% { opacity: 0; }\r\n  100% { opacity: 1; }\r\n}\r\n/* ---------------------------------------------------------- */\r\n\r\n/*  карта анимации блока времени  */\r\n@keyframes fortime  {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока погоды  */\r\n@keyframes forweather {\r\n  0% { transform: translateY(350px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока log_alise  */\r\n@keyframes forlog {\r\n  0% { transform: translateY(300px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока функций  1 2 3 4 5 6*/\r\n@keyframes forfunctions {\r\n  0% { transform: translateY(-320px); }\r\n  45% { transform: translateY(18px); }\r\n  65% { transform: translateY(-20px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блоков отображений 1 2 3 4  */\r\n@keyframes forshowing {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n',0,0,0,80,'default',0,0,'',0,'','','','','',0,0,0,''),(210,10,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_400 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_401 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_138 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сейчас */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-now {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 480px;\r\n  height: 260px;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-now .mainInfo {\r\n  text-align: center;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-now .mainInfo img {\r\n  display: block;\r\n  margin: auto;\r\n  height: 160px;\r\n  padding-right: 20px;\r\n}\r\n\r\n.panel-now .mainInfo .temp {\r\n  display: block;\r\n  font-size: 80px;\r\n  line-height: 0.8;\r\n  margin-bottom: 12px;\r\n  margin-top: -10px;\r\n}\r\n\r\n.panel-now .mainInfo .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-now .mainInfo .temp .degree {\r\n  margin-left: 5px;\r\n  font-size: 46px;\r\n  line-height: 2.5rem;\r\n  font-weight: 400;\r\n  vertical-align: top;\r\n}\r\n\r\n.panel-now .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n\r\n.panel-now .row .info {\r\n  /*flex: ;*/\r\n  text-align: center;\r\n}\r\n\r\n.panel-now .row .info i {\r\n  margin-right: 8px;\r\n  color: #ff6f4d;\r\n  font-size: 20px;\r\n}\r\n\r\n.panel-now .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 20px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сегодня */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-today {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 135px;\r\n  height: 120px;\r\n  /*background-color: rgba(0, 0, 0, 0.5);*/\r\n  /*-moz-border-radius: 0 05px;\r\n  -webkit-border-radius: 5px;*/\r\n  border-radius: 0 0 0 0;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-today .box {\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-today .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 18px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 3px rgba(0, 0, 0, 0.6);\r\n}\r\n.panel-today .box img {\r\n  display: block;\r\n  height: 55px;\r\n  margin: 0 0 0 37px;\r\n}\r\n.panel-today .box .temp {\r\n  font-size: 22px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  margin: 0 0 -2px 0;\r\n}\r\n.panel-today .box .temp .separator {\r\n  margin: 0 1px;\r\n  opacity: 0.4;\r\n}\r\n.panel-today .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-today .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 1.5;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}\r\n.panel-today .box .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  border-top: 2px solid rgba(0, 0, 0, 0.4);\r\n}\r\n.panel-today .box .row .info {\r\n  /*flex: ;*/\r\n    text-align: center;\r\n  margin: 0px 0 0 0;\r\n}\r\n\r\n.panel-today .box .row .info i {\r\n  margin-right: 2px;\r\n  color: #ff6f4d;\r\n  font-size: 10px;\r\n}\r\n\r\n.panel-today .box .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 10px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель  локация*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-location {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  right: 0px;\r\n  width: 250px;\r\n  height: 150px;\r\n  text-align: left;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.9);\r\n  /*-moz-border-radius: 5px;\r\n  -webkit-border-radius: 5px;\r\n  border-radius: 5px;*/\r\n  background-color: initial;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-location .icon {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 76px;\r\n  line-height: 1.2;\r\n  padding: 0 10px 0 0;\r\n}\r\n\r\n.panel-location .title {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 32px;\r\n  line-height: 1;\r\n  margin-right: 15px;\r\n}\r\n\r\n.panel-location .title span {\r\n  display: block;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панели прогноза погоды*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-forecast {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  bottom: 0;\r\n  width: 140px;\r\n  height: 150px;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  /* display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  justify-content: space-between;*/\r\n}\r\n\r\n.panel-forecast .box {\r\n /* flex: 1;*/\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-forecast .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 26px;\r\n  line-height: 1.2;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-forecast .box img {\r\n  display: block;\r\n  height: 75px;\r\n  margin: 0 10px 0 32px; \r\n}\r\n\r\n.panel-forecast .box .temp {\r\n  font-size: 26px;\r\n  line-height: 0.6;\r\n  font-weight: 600;\r\n  text-align: center;\r\n}\r\n\r\n.panel-forecast .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-forecast .box .temp .separator {\r\n  margin: 0 3px;\r\n  opacity: 0.4;\r\n}\r\n\r\n.panel-forecast .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 0.1;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(211,10,'back_button','html',10,20,40,40,0,0,'','',0,0,0,1001,'default',0,0,'',0,'','','','','',0,0,0,''),(212,10,'heading','html',10,80,924,40,0,1,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(213,10,'cont1','container',60,20,984,530,0,0,'','',0,0,0,990,'default',0,0,'',0,'','','','','',0,0,0,''),(214,10,'panel-now','html',114,0,400,200,0,0,'','',0,0,0,50,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(215,10,'panel-location','html',16,63,200,100,0,0,'','',0,0,0,60,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(216,10,'panel_today_1','html',250,534,135,120,0,0,'','',0,0,0,40,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(217,10,'panel-forecast1','html',380,0,140,150,0,0,'','',0,0,0,130,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(218,10,'panel_today_2','html',250,669,135,120,0,0,'','',0,0,0,30,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(219,10,'panel_today_3','html',250,804,135,120,0,0,'','',0,0,0,20,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(220,10,'panel-forecast2','html',380,140,140,150,0,0,'','',0,0,0,120,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(221,10,'panel-forecast3','html',380,280,140,150,0,0,'','',0,0,0,110,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(222,10,'panel-forecast4','html',380,420,140,150,0,0,'','',0,0,0,100,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(223,10,'panel-forecast5','html',380,560,140,150,0,0,'','',0,0,0,90,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(224,10,'panel-forecast6','html',380,700,140,150,0,0,'','',0,0,0,80,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(225,10,'panel-forecast7','html',380,840,140,150,0,0,'','',0,0,0,70,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(226,10,'chart','html',7,560,350,210,0,0,'','',0,0,0,10,'default',0,213,'',0,'','','','',NULL,0,0,0,''),(231,11,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_229 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_230 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_138 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сейчас */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-now {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 480px;\r\n  height: 260px;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-now .mainInfo {\r\n  text-align: center;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-now .mainInfo img {\r\n  display: block;\r\n  margin: auto;\r\n  height: 160px;\r\n  padding-right: 20px;\r\n}\r\n\r\n.panel-now .mainInfo .temp {\r\n  display: block;\r\n  font-size: 80px;\r\n  line-height: 0.8;\r\n  margin-bottom: 12px;\r\n  margin-top: -10px;\r\n}\r\n\r\n.panel-now .mainInfo .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-now .mainInfo .temp .degree {\r\n  margin-left: 5px;\r\n  font-size: 46px;\r\n  line-height: 2.5rem;\r\n  font-weight: 400;\r\n  vertical-align: top;\r\n}\r\n\r\n.panel-now .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n\r\n.panel-now .row .info {\r\n  /*flex: ;*/\r\n  text-align: center;\r\n}\r\n\r\n.panel-now .row .info i {\r\n  margin-right: 8px;\r\n  color: #ff6f4d;\r\n  font-size: 20px;\r\n}\r\n\r\n.panel-now .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 20px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сегодня */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-today {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 135px;\r\n  height: 120px;\r\n  /*background-color: rgba(0, 0, 0, 0.5);*/\r\n  /*-moz-border-radius: 0 05px;\r\n  -webkit-border-radius: 5px;*/\r\n  border-radius: 0 0 0 0;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-today .box {\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-today .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 18px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 3px rgba(0, 0, 0, 0.6);\r\n}\r\n.panel-today .box img {\r\n  display: block;\r\n  height: 55px;\r\n  margin: 0 0 0 37px;\r\n}\r\n.panel-today .box .temp {\r\n  font-size: 22px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  margin: 0 0 -2px 0;\r\n}\r\n.panel-today .box .temp .separator {\r\n  margin: 0 1px;\r\n  opacity: 0.4;\r\n}\r\n.panel-today .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-today .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 1.5;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}\r\n.panel-today .box .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  border-top: 2px solid rgba(0, 0, 0, 0.4);\r\n}\r\n.panel-today .box .row .info {\r\n  /*flex: ;*/\r\n    text-align: center;\r\n  margin: 0px 0 0 0;\r\n}\r\n\r\n.panel-today .box .row .info i {\r\n  margin-right: 2px;\r\n  color: #ff6f4d;\r\n  font-size: 10px;\r\n}\r\n\r\n.panel-today .box .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 10px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель  локация*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-location {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  right: 0px;\r\n  width: 250px;\r\n  height: 150px;\r\n  text-align: left;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.9);\r\n  /*-moz-border-radius: 5px;\r\n  -webkit-border-radius: 5px;\r\n  border-radius: 5px;*/\r\n  background-color: initial;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-location .icon {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 76px;\r\n  line-height: 1.2;\r\n  padding: 0 10px 0 0;\r\n}\r\n\r\n.panel-location .title {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 32px;\r\n  line-height: 1;\r\n  margin-right: 15px;\r\n}\r\n\r\n.panel-location .title span {\r\n  display: block;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панели прогноза погоды*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-forecast {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  bottom: 0;\r\n  width: 140px;\r\n  height: 150px;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  /* display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  justify-content: space-between;*/\r\n}\r\n\r\n.panel-forecast .box {\r\n /* flex: 1;*/\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-forecast .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 26px;\r\n  line-height: 1.2;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-forecast .box img {\r\n  display: block;\r\n  height: 75px;\r\n  margin: 0 10px 0 32px; \r\n}\r\n\r\n.panel-forecast .box .temp {\r\n  font-size: 26px;\r\n  line-height: 0.6;\r\n  font-weight: 600;\r\n  text-align: center;\r\n}\r\n\r\n.panel-forecast .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-forecast .box .temp .separator {\r\n  margin: 0 3px;\r\n  opacity: 0.4;\r\n}\r\n\r\n.panel-forecast .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 0.1;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(234,11,'gorod','menuitem',50,5,205,50,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','{\"MENU_ITEM_ID\":136}',0,0,0,''),(236,7,'key1','html',360,440,0,0,0,0,'','body {\r\n  background-color:#eee;\r\n  text-align:center;\r\n  padding:85px 0;\r\n}\r\n\r\n.toggle {\r\n  position:relative;\r\n  display:inline-block;\r\n  width:40px;\r\n  height:60px;\r\n  background-color:#bbb;\r\n  -webkit-border-radius:4px;\r\n  -moz-border-radius:4px;\r\n  border-radius:4px;\r\n  text-align:center;\r\n}\r\n\r\n.toggle input {\r\n  width:100%;\r\n  height:100%;\r\n  margin:0 0;\r\n  padding:0 0;\r\n  position:absolute;\r\n  top:0;\r\n  right:0;\r\n  bottom:0;\r\n  left:0;\r\n  z-index:2;\r\n  cursor:pointer;\r\n  opacity:0;\r\n  filter:alpha(opacity=0);\r\n}\r\n\r\n.toggle label {\r\n  display:block;\r\n  position:absolute;\r\n  top:1px;\r\n  right:1px;\r\n  bottom:1px;\r\n  left:1px;\r\n  background-image:-webkit-linear-gradient(top,#fff 0%,#ddd 50%,#fff 50%,#eee 100%);\r\n  background-image:-moz-linear-gradient(top,#fff 0%,#ddd 50%,#fff 50%,#eee 100%);\r\n  background-image:-ms-linear-gradient(top,#fff 0%,#ddd 50%,#fff 50%,#eee 100%);\r\n  background-image:-o-linear-gradient(top,#fff 0%,#ddd 50%,#fff 50%,#eee 100%);\r\n  background-image:linear-gradient(top,#fff 0%,#ddd 50%,#fff 50%,#eee 100%);\r\n  -webkit-box-shadow:0 2px 3px rgba(0,0,0,0.4),\r\n    inset 0 -1px 1px #888,\r\n    inset 0 -5px 1px #bbb,\r\n    inset 0 -6px 0 white;\r\n  -moz-box-shadow:0 2px 3px rgba(0,0,0,0.4),\r\n    inset 0 -1px 1px #888,\r\n    inset 0 -5px 1px #bbb,\r\n    inset 0 -6px 0 white;\r\n  box-shadow:0 2px 3px rgba(0,0,0,0.4),\r\n    inset 0 -1px 1px #888,\r\n    inset 0 -5px 1px #bbb,\r\n    inset 0 -6px 0 white;\r\n  -webkit-border-radius:3px;\r\n  -moz-border-radius:3px;\r\n  border-radius:3px;\r\n  font:normal 11px Arial,Sans-Serif;\r\n  color:#666;\r\n  text-shadow:0 1px 0 white;\r\n  cursor:text;\r\n}\r\n\r\n.toggle label:before {\r\n  content:attr(data-off);\r\n  position:absolute;\r\n  top:6px;\r\n  right:0;\r\n  left:0;\r\n  z-index:4;\r\n}\r\n\r\n.toggle label:after {\r\n  content:attr(data-on);\r\n  position:absolute;\r\n  right:0;\r\n  bottom:11px;\r\n  left:0;\r\n  color:#666;\r\n  text-shadow:0 -1px 0 #eee;\r\n}\r\n\r\n.toggle input:checked + label {\r\n  background-image:-webkit-linear-gradient(top,#eee 0%,#ccc 50%,#fff 50%,#eee 100%);\r\n  background-image:-moz-linear-gradient(top,#eee 0%,#ccc 50%,#fff 50%,#eee 100%);\r\n  background-image:-ms-linear-gradient(top,#eee 0%,#ccc 50%,#fff 50%,#eee 100%);\r\n  background-image:-o-linear-gradient(top,#eee 0%,#ccc 50%,#fff 50%,#eee 100%);\r\n  background-image:linear-gradient(top,#eee 0%,#ccc 50%,#fff 50%,#eee 100%);\r\n  -webkit-box-shadow:0 0 1px rgba(0,0,0,0.4),\r\n    inset 0 1px 7px -1px #ccc,\r\n    inset 0 5px 1px #fafafa,\r\n    inset 0 6px 0 white;\r\n  -moz-box-shadow:0 0 1px rgba(0,0,0,0.4),\r\n    inset 0 1px 7px -1px #ccc,\r\n    inset 0 5px 1px #fafafa,\r\n    inset 0 6px 0 white;\r\n  box-shadow:0 0 1px rgba(0,0,0,0.4),\r\n    inset 0 1px 7px -1px #ccc,\r\n    inset 0 5px 1px #fafafa,\r\n    inset 0 6px 0 white;\r\n}\r\n\r\n.toggle input:checked:hover + label {\r\n  -webkit-box-shadow:0 1px 3px rgba(0,0,0,0.4),\r\n    inset 0 1px 7px -1px #ccc,\r\n    inset 0 5px 1px #fafafa,\r\n    inset 0 6px 0 white;\r\n  -moz-box-shadow:0 1px 3px rgba(0,0,0,0.4),\r\n    inset 0 1px 7px -1px #ccc,\r\n    inset 0 5px 1px #fafafa,\r\n    inset 0 6px 0 white;\r\n  box-shadow:0 1px 3px rgba(0,0,0,0.4),\r\n    inset 0 1px 7px -1px #ccc,\r\n    inset 0 5px 1px #fafafa,\r\n    inset 0 6px 0 white;\r\n}\r\n\r\n.toggle input:checked + label:before {\r\n  z-index:1;\r\n  top:11px;\r\n}\r\n\r\n.toggle input:checked + label:after {\r\n  bottom:9px;\r\n  color:#aaa;\r\n  text-shadow:none;\r\n  z-index:4;\r\n}\r\n',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(229,11,'back_button','html',10,20,40,40,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(230,11,'heading','html',10,80,924,40,0,1,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(241,11,'Setting','html',76,806,200,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(242,11,'webmin','html',131,806,200,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(243,11,'phpmyadmin','html',181,806,200,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(268,13,'wind','html',260,210,0,0,0,0,'','',0,0,0,0,'default',0,253,'',0,'','','','',NULL,0,0,0,''),(249,13,'top_panel','container',0,0,599,65,0,0,'','',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(250,13,'winddirection_CSS','html',0,0,0,0,0,0,'','@import url(http://fonts.googleapis.com/css?family=Dosis:200,400,500,600);\r\n.compass {\r\n  display: block;\r\n  width: 132px;\r\n  height: 132px;\r\n  border-radius: 100%;\r\n  box-shadow: 0 0 10px rgba(0, 0, 0, .85);\r\n  position: absolute;\r\n  font-family: \'Dosis\';\r\n  color: #555;\r\n  text-shadow: 1px 1px 1px white;\r\n  .arrow {\r\n    width: 100%;\r\n    height: 100%;\r\n    display: block;\r\n    position: absolute;\r\n    top: 0;\r\n    &:after {\r\n      content: \"\";\r\n      width: 0;\r\n      height: 0;\r\n      border-left: 5px solid transparent;\r\n      border-right: 5px solid transparent;\r\n      border-bottom: 10px solid red;\r\n      position: absolute;\r\n      top: -6px;\r\n      left: 50%;\r\n      margin-left: -5px;\r\n      z-index: 99;\r\n    }\r\n    &.nne { transform: rotate(22.5deg); }\r\n    &.ne { transform: rotate(45deg); }\r\n    &.ene { transform: rotate(67.5deg); }\r\n    &.e { transform: rotate(90deg); }\r\n    &.ese { transform: rotate(112.5deg); }\r\n    &.se { transform: rotate(135deg); }\r\n    &.sse { transform: rotate(157.5deg); }\r\n    &.s { transform: rotate(180deg); }\r\n    &.ssw { transform: rotate(202.5deg); }\r\n    &.sw { transform: rotate(-135deg); }\r\n    &.wsw { transform: rotate(-114.5deg); }\r\n    &.w { transform: rotate(-90deg); }\r\n    &.wnw { transform: rotate(-69.5deg); }\r\n    &.nw { transform: rotate(-45deg); }\r\n    &.nnw { transform: rotate(-24.5deg);}\r\n  }\r\n}',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(251,13,'prognoz-panel','container',612,42,510,296,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(252,13,'general_CSS','html',0,488,0,0,0,0,'','#body_background{\r\nbackground-image: url(/cms/scenes/weather/bg/weatherBg_%ow_day0.image%.jpg);\r\nwidth: 600px;\r\n}\r\n\r\n.rotate {\r\n-webkit-transform: rotate(%ow_fact.wind_direction%deg);\r\n-moz-transform: rotate(%ow_fact.wind_direction%deg);\r\n-ms-transform: rotate(%ow_fact.wind_direction%deg);\r\n} \r\n\r\n.panel-time {\r\n box-sizing: border-box;\r\n color: Black;\r\n width: 146px;\r\n height: 56px;\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n -moz-border-radius: 0px 0px 0px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 0px 0px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-time .timeH, .panel-time .timeM{\r\n font-size: 50px;\r\n letter-spacing: 7px;\r\n color: black;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 700;\r\n width: 73px;\r\n text-align: right;\r\n}\r\n.panel-time .timeH{\r\n// display:inline-block;\r\n position: absolute;\r\n}\r\n.panel-time .timeM{\r\n position: absolute;\r\n margin-left: 78px;\r\n}\r\n.panel-time .digitShade{\r\n position: absolute;\r\n width: 145px;\r\n height: 55px;\r\n z-index: 100;\r\n background-image: url(/cms/scenes/weather/elements/digitShade2.png);\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель даты*/\r\n/* -----------------------------------------------------------------------*/\r\n.panel-date {\r\n box-sizing: border-box;\r\n color: Black;\r\n //background-color: rgba(0, 0, 0, 0.4);\r\n //text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 155px;\r\n height: 56px;\r\n -moz-border-radius: 0px 0px 0px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 0px 0px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-date .date {\r\n position: absolute;\r\n width: 73px;\r\n font-size: 50px;\r\n letter-spacing: 7px;\r\n color: black;\r\n line-height: 1.1;\r\n text-align: right;\r\n font-family: arial;\r\n font-weight: 700;\r\n}\r\n.panel-date .day{\r\n position: absolute;\r\n margin: 11px 0px 0px 78px;\r\n font-size: 16px;\r\n line-height: 1.1;\r\n color: white;\r\n text-align: left;\r\n font-family: arial;\r\n font-weight: 700;\r\n}\r\n.panel-date .month{\r\n position: absolute;\r\n margin: 28px 0px 0px 78px;\r\n font-size: 30px;\r\n line-height: 1.1;\r\n color: white;\r\n text-align: left;\r\n font-family: arial;\r\n font-weight: 700;\r\n}\r\n.panel-date .digitShade{\r\n position: absolute;\r\n width: 68px;\r\n height: 55px;\r\n z-index: 100;\r\n background-image: url(/cms/scenes/weather/elements/digitShade.png);\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  сейчас */\r\n/* -----------------------------------------------------------------------*/\r\n.current-panel{\r\n box-sizing: border-box;\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n  position: absolute;\r\n /* top: 0px; */\r\n/*  right: 0px; */\r\n  width: 510px;\r\n  height: 245px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  -moz-border-radius: 10px 0px 0px 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 10px;\r\n}\r\n.current-block img {\r\n position: absolute;\r\n  width: 175px;\r\n  margin: 10px 168px;\r\n}\r\n.current-block .temp{\r\n position: absolute;\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 86px;\r\n  line-height: 1;\r\n  margin: 15px 10px;\r\n}\r\n.current-block .temp .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 40px;\r\n  line-height: 1;\r\n  vertical-align: top;\r\n}\r\n.current-block .weather-type{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 28px;\r\n  line-height: 1.4;\r\n margin: 10px 0px 0px 343px;\r\nwidth: 155px\r\n}\r\n\r\n.current-temps{\r\n  position: absolute;\r\n  width: 510px;\r\n padding-left: 10px;\r\n}\r\n.current-temps .max, .current-temps .min, .current-temps .day{\r\n  margin-top: 116px;\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  vertical-align: top;\r\n  font-size: 26px;\r\n  line-height: 1.4;\r\n position: absolute;\r\n}\r\n.current-temps .min{\r\nmargin-left: 110px\r\n}\r\n.current-temps .day{\r\nwidth: 155px;\r\nmargin: 116px 0px 0px 343px;\r\ntext-align: center;\r\n}\r\n.current-temps .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 12px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.current-temps .temp-diff{\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 14px;\r\n  line-height: 1.4;\r\n}\r\n.current_wind .speed{\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 30px;\r\n  line-height: 1;\r\n  width: 132px;\r\n text-align: center;\r\n margin-top: 47px;\r\n}\r\n.current_wind .kmh{\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 14px;\r\n  line-height: 1;\r\n  width: 132px;\r\n text-align: center;\r\n}\r\n.current_icons{\r\n  position: absolute;\r\n  width: 510px;\r\n  height: 75px;\r\n  padding-left: 10px;\r\n}\r\n.current_icons div{\r\n  position: relative;\r\n  width: 98px;\r\n  height: 75px;\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  text-align: center;\r\n  font-size: 16px;\r\n  line-height: 1;\r\n}\r\n\r\n\r\n.days {\r\nwidth: 110px;\r\nheight: 280px;\r\ntext-align: center;\r\n}\r\n.days img {\r\n position: absolute;\r\n margin-top: 45px;\r\n width: 110px;\r\n display: block;\r\n}\r\n.days .d_name {\r\n position: absolute;\r\n font-family: arial;\r\n font-weight: 600;\r\n font-size: 28px;\r\n line-height: 1.4;\r\n width: 110px;\r\n}\r\n.days .weather-type{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 400;\r\n font-size: 20px;\r\n line-height: 1;\r\n margin-top: 115px;\r\n width: 110px;\r\n}\r\n.days .max, .days .min{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n font-size: 32px;\r\n line-height: 1.4;\r\n width: 110px;\r\n}\r\n.days .max {\r\n margin-top: 170px;\r\n}\r\n.days .min {\r\n margin-top: 220;\r\n}\r\n.days .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 18px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(253,13,'current-panel','container',120,42,510,397,0,0,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(254,13,'day2','html',10,136,110,260,0,0,'','',0,0,0,30,'default',0,251,'',0,'','','','','',0,0,0,''),(255,13,'day3','html',10,266,110,260,0,0,'','',0,0,0,20,'default',0,251,'',0,'','','','','',0,0,0,''),(256,13,'day4','html',10,392,110,260,0,0,'','',0,0,0,10,'default',0,251,'',0,'','','','','',0,0,0,''),(257,13,'day1','html',10,10,110,260,0,0,'','',0,0,0,40,'default',0,251,'',0,'','','','','',0,0,0,''),(258,13,'icons','html',170,0,510,75,0,0,'','',0,0,0,30,'default',0,253,'',0,'','','','','',0,0,0,''),(259,13,'panel-date','html',270,350,155,58,0,0,'','',0,0,0,20,'default',0,253,'',0,'','','','','',0,0,0,''),(260,13,'current-block','html',10,0,510,0,0,0,'','',0,0,0,40,'default',0,253,'',0,'','','','','',0,0,0,''),(261,13,'current-wind','html',240,192,132,132,0,0,'','@import url(http://fonts.googleapis.com/css?family=Dosis:200,400,500,600);\r\n.compass {\r\n  display: block;\r\n  width: 100px;\r\n  height: 100px;\r\n  border-radius: 100%;\r\n  box-shadow: 0 0 10px rgba(0, 0, 0, .85);\r\n  position: relative;\r\n  font-family: \'Dosis\';\r\n  color: #555;\r\n  text-shadow: 1px 1px 1px white;\r\n  .arrow {\r\n    width: 100%;\r\n    height: 100%;\r\n    display: block;\r\n    position: absolute;\r\n    top: 0;\r\n    &:after {\r\n      content: \"\";\r\n      width: 0;\r\n      height: 0;\r\n      border-left: 5px solid transparent;\r\n      border-right: 5px solid transparent;\r\n      border-bottom: 10px solid red;\r\n      position: absolute;\r\n      top: -6px;\r\n      left: 50%;\r\n      margin-left: -5px;\r\n      z-index: 99;\r\n    }\r\n    &.nne { transform: rotate(22.5deg); }\r\n    &.ne { transform: rotate(45deg); }\r\n    &.ene { transform: rotate(67.5deg); }\r\n    &.e { transform: rotate(90deg); }\r\n    &.ese { transform: rotate(112.5deg); }\r\n    &.se { transform: rotate(135deg); }\r\n    &.sse { transform: rotate(157.5deg); }\r\n    &.s { transform: rotate(180deg); }\r\n    &.ssw { transform: rotate(202.5deg); }\r\n    &.sw { transform: rotate(-135deg); }\r\n    &.wsw { transform: rotate(-114.5deg); }\r\n    &.w { transform: rotate(-90deg); }\r\n    &.wnw { transform: rotate(-69.5deg); }\r\n    &.nw { transform: rotate(-45deg); }\r\n    &.nnw { transform: rotate(-24.5deg);}\r\n  }\r\n}',0,0,0,50,'default',0,253,'',0,'','','','','',0,0,0,''),(262,13,'compass','html',242,193,132,132,0,0,'','',0,0,0,60,'default',0,253,'',0,'','','','','',0,0,0,''),(263,13,'panel-time','html',270,20,146,56,0,0,'','',0,0,0,10,'default',0,253,'',0,'','','','','',0,0,0,''),(264,13,'image','img',0,0,0,0,0,0,'','',0,0,0,0,'default',0,249,'',0,'','','','',NULL,0,0,0,''),(265,13,'image2','img',0,0,0,0,0,0,'','',0,0,0,0,'default',0,253,'',0,'','','','',NULL,0,0,0,''),(267,13,'image3','img',0,0,0,0,0,0,'','',0,0,0,0,'default',0,251,'',0,'','','','',NULL,0,0,0,''),(269,15,'panel-showing2','html',52,0,480,52,0,0,'','',0,0,0,978,'default',0,141,'',0,'','','','','',0,0,0,''),(270,15,'panel-showing3','html',104,0,480,52,0,0,'','',0,0,0,976,'default',0,141,'',0,'','','','','',0,0,0,''),(271,15,'panel-showing4','html',158,0,480,52,0,0,'','',0,0,0,974,'default',0,141,'',0,'','','','','',0,0,0,''),(272,15,'function_1','html',20,32,120,120,0,0,'','',0,0,0,968,'default',0,145,'',0,'','','','','',0,0,0,''),(273,15,'icons','html',166,11,510,175,0,0,'','',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(274,15,'day2','html',10,136,110,260,0,0,'','',0,0,0,0,'default',0,224,'',0,'','','','','',0,0,0,''),(275,15,'day3','html',10,266,110,260,0,0,'','',0,0,0,0,'default',0,224,'',0,'','','','','',0,0,0,''),(276,15,'day4','html',10,392,110,260,0,0,'','',0,0,0,0,'default',0,224,'',0,'','','','','',0,0,0,''),(277,15,'current-block','html',5,15,510,0,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(278,15,'day1','html',10,10,110,260,0,0,'','',0,0,0,0,'default',0,224,'',0,'','','','','',0,0,0,''),(279,15,'strelca','html',209,208,122,122,0,0,'','',0,0,0,60,'default',0,0,'',0,'','','','','',0,0,0,''),(280,15,'compass','html',200,203,122,122,0,0,'','',0,0,0,80,'default',0,0,'',0,'','','','','',0,0,0,''),(281,15,'general_CSS','html',0,488,0,0,0,0,'','/* -----------------------------------------------------------------------*/\r\n/* панель погоды  прогноз*/\r\n/* -----------------------------------------------------------------------*/\r\n.titl-max {\r\n    top: 102px;\r\n    position: absolute;\r\n    left: 120px;\r\n}\r\n.titl-min {\r\n    top: 102px;\r\n    position: absolute;\r\n    left: 200px;\r\n}\r\n.days {\r\nwidth: 280px;\r\nheight: 70px;\r\ntext-align: center;\r\n}\r\n.days img {\r\nposition: absolute;\r\n    width: 100px;\r\n    display: block;\r\n    top: 50px;\r\n}\r\n.days .d_name {\r\n    position: absolute;\r\n    font-family: arial;\r\n    font-weight: 600;\r\n    font-size: 22px;\r\n    line-height: 1.4;\r\n    width: 110px;\r\n    top: 90px;\r\n    left: -80px;\r\n    text-align: left;\r\ncolor: #65e426;\r\n}\r\n.days .weather-type{\r\n position: absolute;\r\n    font-family: arial;\r\n    font-weight: 400;\r\n    font-size: 25px;\r\n    margin-top: 55px;\r\n    left: 75px;\r\n    height: 10px;\r\n    width: 220;\r\n}\r\n.days .max, .days .min{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n font-size: 32px;\r\n line-height: 1.4;\r\n width: 110px;\r\n}\r\n.days .max {\r\n    margin-top: 170px;\r\n    font-size: 18px;\r\n    top: -76px;\r\n    left: 118px;\r\n}\r\n.days .min {\r\n    margin-top: 170px;\r\n    font-size: 18px;\r\n    top: -76px;\r\n    left: 188px;\r\n}\r\n.days .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 18px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  сейчас */\r\n/* -----------------------------------------------------------------------*/\r\n\r\n.current-block img {\r\n position: absolute;\r\n  width: 175px;\r\n  margin: 10px 168px;\r\n}\r\n.current-block .temp{\r\n position: absolute;\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 86px;\r\n  line-height: 1;\r\n  margin: 15px 10px;\r\ncolor: yellow;\r\n}\r\n.current-block .temp .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 40px;\r\n  line-height: 1;\r\n  vertical-align: top;\r\n}\r\n.current-block .weather-type{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 28px;\r\n  line-height: 1.4;\r\n margin: 10px 0px 0px 343px;\r\nwidth: 155px;\r\ncolor: yellow;\r\n}\r\n\r\n.current-temps{\r\n  position: absolute;\r\n  width: 510px;\r\n padding-left: 10px;\r\n}\r\n.current-temps .max, .current-temps .min, .current-temps .day{\r\n  margin-top: 116px;\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  vertical-align: top;\r\n  font-size: 26px;\r\n  line-height: 1.4;\r\n position: absolute;\r\n}\r\n.current-temps .min{\r\nmargin-left: 110px\r\n}\r\n.current-temps .day{\r\nwidth: 200px;\r\nmargin: 116px 0px 0px 343px;\r\ntext-align: center;\r\nleft: -40px;\r\n}\r\n.current-temps .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 12px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.current-temps .temp-diff{\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 14px;\r\n  line-height: 1.4;\r\n}\r\n.current_wind .speed{\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 30px;\r\n  line-height: 1;\r\n  width: 132px;\r\n text-align: center;\r\n margin-top: 47px;\r\n}\r\n.current_wind .kmh{\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 14px;\r\n  line-height: 1;\r\n  width: 132px;\r\n text-align: center;\r\n}\r\n.current_icons{\r\n  position: absolute;\r\n  width: 510px;\r\n  height: 75px;\r\n  padding-left: 10px;\r\n}\r\n.current_icons div{\r\n  position: relative;\r\n  width: 98px;\r\n  height: 75px;\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  text-align: center;\r\n  font-size: 16px;\r\n  line-height: 1;\r\n}\r\n\r\n\r\n\r\n.hum {\r\n    top: 100px;\r\n}\r\n.preci {\r\n    top: 100px;\r\n}\r\n.press {\r\n    top: 25px;\r\n    left: -30;\r\n}\r\n.vis {\r\n    top: 25px;\r\n    left: 30;\r\n}\r\n .rotate {\r\n-webkit-transform: rotate(%ow_fact.wind_direction%deg);\r\n-moz-transform: rotate(%ow_fact.wind_direction%deg);\r\n-ms-transform: rotate(%ow_fact.wind_direction%deg);\r\n} ',0,0,0,70,'default',0,0,'',0,'','','','','',0,0,0,''),(282,15,'day1','html',-53,617,0,0,0,0,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(283,15,'day2','html',15,617,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(284,15,'day3','html',84,617,0,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(285,15,'day4','html',153,617,0,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(286,15,'day5','html',222,617,0,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(338,17,'fon','html',0,0,0,0,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(339,17,'winddirection_CSS','html',0,0,0,0,0,0,'','@import url(http://fonts.googleapis.com/css?family=Dosis:200,400,500,600);\r\n.compass {\r\n  display: block;\r\n  width: 79px;\r\n  height: 79px;\r\n  border-radius: 100%;\r\n  box-shadow: 0 0 10px rgba(0, 0, 0, .85);\r\n  position: absolute;\r\n  font-family: \'Dosis\';\r\n  color: #555;\r\n  text-shadow: 1px 1px 1px white;\r\n  .arrow {\r\n    width: 100%;\r\n    height: 100%;\r\n    display: block;\r\n    position: absolute;\r\n    top: 0;\r\n    &:after {\r\n      content: \"\";\r\n      width: 0;\r\n      height: 0;\r\n      border-left: 5px solid transparent;\r\n      border-right: 5px solid transparent;\r\n      border-bottom: 10px solid red;\r\n      position: absolute;\r\n      top: -6px;\r\n      left: 50%;\r\n      margin-left: -5px;\r\n      z-index: 99;\r\n    }\r\n    &.nne { transform: rotate(22.5deg); }\r\n    &.ne { transform: rotate(45deg); }\r\n    &.ene { transform: rotate(67.5deg); }\r\n    &.e { transform: rotate(90deg); }\r\n    &.ese { transform: rotate(112.5deg); }\r\n    &.se { transform: rotate(135deg); }\r\n    &.sse { transform: rotate(157.5deg); }\r\n    &.s { transform: rotate(180deg); }\r\n    &.ssw { transform: rotate(202.5deg); }\r\n    &.sw { transform: rotate(-135deg); }\r\n    &.wsw { transform: rotate(-114.5deg); }\r\n    &.w { transform: rotate(-90deg); }\r\n    &.wnw { transform: rotate(-69.5deg); }\r\n    &.nw { transform: rotate(-45deg); }\r\n    &.nnw { transform: rotate(-24.5deg);}\r\n  }\r\n}',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(340,17,'prognoz-panel','container',501,43,309,30,0,0,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(341,17,'general_CSS','html',0,488,0,0,0,0,'','#body_background{\r\nbackground-image: url(/cms/scenes/weather/bg2/weatherBg_%ow_day0.image%.jpg);\r\nwidth: 360px;\r\n}\r\n\r\n\r\n.rotate {\r\n-webkit-transform: rotate(%ow_fact.wind_direction%deg);\r\n-moz-transform: rotate(%ow_fact.wind_direction%deg);\r\n-ms-transform: rotate(%ow_fact.wind_direction%deg);\r\n} \r\n\r\n.panel-time {\r\n box-sizing: border-box;\r\n color: Black;\r\n width: 87px;\r\n height: 33px;\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n -moz-border-radius: 0px 0px 0px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 0px 0px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-time .timeH, .panel-time .timeM{\r\n font-size: 30px;\r\n letter-spacing: 7px;\r\n color: black;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 420;\r\n width: 43px;\r\n text-align: right;\r\n}\r\n.panel-time .timeH{\r\n// display:inline-block;\r\n position: absolute;\r\n}\r\n.panel-time .timeM{\r\n position: absolute;\r\n margin-left: 47px;\r\n}\r\n.panel-time .digitShade{\r\n position: absolute;\r\n width: 87px;\r\n height: 33px;\r\n z-index: 100;\r\n background-image: url(/cms/scenes/weather/elements/digitShade2.png);\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель даты*/\r\n/* -----------------------------------------------------------------------*/\r\n.panel-date {\r\n box-sizing: border-box;\r\n color: Black;\r\n //background-color: rgba(0, 0, 0, 0.4);\r\n //text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 93px;\r\n height: 33px;\r\n -moz-border-radius: 0px 0px 0px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 0px 0px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-date .date {\r\n position: absolute;\r\n width: 43px;\r\n font-size: 30px;\r\n letter-spacing: 7px;\r\n color: black;\r\n line-height: 1.1;\r\n text-align: right;\r\n font-family: arial;\r\n font-weight: 420;\r\n}\r\n.panel-date .day{\r\n position: absolute;\r\n margin: 2px 0px 0px 46px;\r\n font-size: 10px;\r\n line-height: 1.1;\r\n color: white;\r\n text-align: left;\r\n font-family: arial;\r\n font-weight: 420;\r\n}\r\n.panel-date .month{\r\n position: absolute;\r\n margin: 13px 0px 0px 46px;\r\n font-size: 18px;\r\n line-height: 1.1;\r\n color: white;\r\n text-align: left;\r\n font-family: arial;\r\n font-weight: 420;\r\n}\r\n.panel-date .digitShade{\r\n position: absolute;\r\n width: 40px;\r\n height: 33px;\r\n z-index: 100;\r\n background-image: url(/cms/scenes/weather/elements/digitShade.png);\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  сейчас */\r\n/* -----------------------------------------------------------------------*/\r\n.current-panel{\r\n box-sizing: border-box;\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n  position: absolute;\r\n /* top: 0px; */\r\n/*  right: 0px; */\r\n  width: 306px;\r\n  height: 147px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  -moz-border-radius: 10px 0px 0px 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 10px;\r\n}\r\n.current-block img {\r\n position: absolute;\r\n  width: 105px;\r\n  margin: 6px 100px;\r\n}\r\n.current-block .temp{\r\n position: absolute;\r\n  font-family: arial;\r\n  font-weight: 360;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 51px;\r\n  line-height: 1;\r\n  margin: 15px 10px;\r\n}\r\n.current-block .temp .degree {\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 24px;\r\n  line-height: 1;\r\n  vertical-align: top;\r\n}\r\n.current-block .weather-type{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 16px;\r\n  line-height: 1.4;\r\n margin: 6px 0px 0px 205px;\r\nwidth: 93px\r\n}\r\n\r\n.current-temps{\r\n  position: absolute;\r\n  width: 306px;\r\n padding-left: 10px;\r\n}\r\n.current-temps .max, .current-temps .min, .current-temps .day{\r\n  margin-top: 68px;\r\n  font-family: arial;\r\n  font-weight: 360;\r\n  vertical-align: top;\r\n  font-size: 15px;\r\n  line-height: 1.4;\r\n position: absolute;\r\n}\r\n.current-temps .min{\r\nmargin-left: 66px\r\n}\r\n.current-temps .day{\r\nwidth: 93px;\r\nmargin: 68px 0px 0px 205px;\r\ntext-align: center;\r\n}\r\n.current-temps .degree {\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 8px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.current-temps .temp-diff{\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 9px;\r\n  line-height: 1.4;\r\n}\r\n.current_wind .speed{\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 18px;\r\n  line-height: 1;\r\n  width: 79px;\r\n text-align: center;\r\n margin-top: 28px;\r\n}\r\n.current_wind .kmh{\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 10px;\r\n  line-height: 1;\r\n  width: 79px;\r\n text-align: center;\r\n}\r\n.current_icons{\r\n  position: absolute;\r\n  width: 306px;\r\n  height: 45px;\r\n  padding-left: 10px;\r\n}\r\n.current_icons div{\r\n  position: relative;\r\n  width: 58px;\r\n  height: 45px;\r\n  font-family: arial;\r\n  font-weight: 360;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  text-align: center;\r\n  font-size: 10px;\r\n  line-height: 1;\r\n}\r\n\r\n\r\n.days {\r\nwidth: 66px;\r\nheight: 168px;\r\ntext-align: center;\r\n}\r\n.days img {\r\n position: absolute;\r\n margin-top: 27px;\r\n width: 66px;\r\n display: block;\r\n}\r\n.days .d_name {\r\n position: absolute;\r\n font-family: arial;\r\n font-weight: 360;\r\n font-size: 16px;\r\n line-height: 1.4;\r\n width: 66px;\r\n}\r\n.days .weather-type{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 240;\r\n font-size: 12px;\r\n line-height: 1;\r\n margin-top: 69px;\r\n width: 66px;\r\n}\r\n.days .max, .days .min{\r\n position: absolute;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 360;\r\n font-size: 19px;\r\n line-height: 1.4;\r\n width: 66px;\r\n}\r\n.days .max {\r\n margin-top: 102px;\r\n}\r\n.days .min {\r\n margin-top: 124;\r\n}\r\n.days .degree {\r\n font-family: arial;\r\n font-weight: 360;\r\n  font-size: 11px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}',0,0,0,80,'default',0,0,'',0,'','','','','',0,0,0,''),(361,17,'img3','html',-165,-20,309,181,0,0,'','',0,0,0,0,'default',0,340,'',0,'','','','',NULL,0,0,0,''),(342,17,'current-panel','container',131,2,309,238,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(344,17,'day2','html',-158,66,66,156,0,0,'','',0,0,0,30,'default',0,340,'',0,'','','','','',0,0,0,''),(345,17,'day3','html',-158,138,66,156,0,0,'','',0,0,0,20,'default',0,340,'',0,'','','','','',0,0,0,''),(346,17,'day4','html',-158,214,66,156,0,0,'','',0,0,0,10,'default',0,340,'',0,'','','','','',0,0,0,''),(347,17,'day1','html',-158,-12,66,156,0,0,'','',0,0,0,40,'default',0,340,'',0,'','','','','',0,0,0,''),(349,17,'icons','html',19,20,309,50,0,0,'','',0,0,0,50,'default',0,342,'',0,'','','','','',0,0,0,''),(350,17,'panel-date','html',92,235,93,34,0,0,'','',0,0,0,40,'default',0,342,'',0,'','','','','',0,0,0,''),(351,17,'current-block','html',-72,26,309,0,0,0,'','',0,0,0,60,'default',0,342,'',0,'','','','','',0,0,0,''),(352,17,'current-wind','html',240,192,47,47,0,0,'','@import url(http://fonts.googleapis.com/css?family=Dosis:200,400,500,600);\r\n.compass {\r\n  display: block;\r\n  width: 66px;\r\n  height: 66px;\r\n  border-radius: 100%;\r\n  box-shadow: 0 0 10px rgba(0, 0, 0, .85);\r\n  position: relative;\r\n  font-family: \'Dosis\';\r\n  color: #555;\r\n  text-shadow: 1px 1px 1px white;\r\n  .arrow {\r\n    width: 100%;\r\n    height: 100%;\r\n    display: block;\r\n    position: absolute;\r\n    top: 0;\r\n    &:after {\r\n      content: \"\";\r\n      width: 0;\r\n      height: 0;\r\n      border-left: 5px solid transparent;\r\n      border-right: 5px solid transparent;\r\n      border-bottom: 10px solid red;\r\n      position: absolute;\r\n      top: -6px;\r\n      left: 50%;\r\n      margin-left: -5px;\r\n      z-index: 99;\r\n    }\r\n    &.nne { transform: rotate(22.5deg); }\r\n    &.ne { transform: rotate(45deg); }\r\n    &.ene { transform: rotate(67.5deg); }\r\n    &.e { transform: rotate(90deg); }\r\n    &.ese { transform: rotate(112.5deg); }\r\n    &.se { transform: rotate(135deg); }\r\n    &.sse { transform: rotate(157.5deg); }\r\n    &.s { transform: rotate(180deg); }\r\n    &.ssw { transform: rotate(202.5deg); }\r\n    &.sw { transform: rotate(-135deg); }\r\n    &.wsw { transform: rotate(-114.5deg); }\r\n    &.w { transform: rotate(-90deg); }\r\n    &.wnw { transform: rotate(-69.5deg); }\r\n    &.nw { transform: rotate(-45deg); }\r\n    &.nnw { transform: rotate(-24.5deg);}\r\n  }\r\n}',0,0,0,70,'default',0,342,'',0,'','','','','',0,0,0,''),(353,17,'compass','html',69,140,79,79,0,0,'','',0,0,0,80,'default',0,342,'',0,'','','','','',0,0,0,''),(354,17,'panel-time','html',92,38,87,33,0,0,'','',0,0,0,30,'default',0,342,'',0,'','','','','',0,0,0,''),(356,17,'wind','html',82,149,0,0,0,0,'','',0,0,0,20,'default',0,342,'',0,'','','','',NULL,0,0,0,''),(357,17,'top_panel','container',0,0,359,56,0,0,'','',0,0,0,70,'default',0,0,'',0,'','','','','',0,0,0,''),(358,17,'top_img','html',0,0,0,0,0,0,'','',0,0,0,60,'default',0,357,'',0,'','','','',NULL,0,0,0,''),(359,17,'img2','html',-73,26,0,0,0,0,'','',0,0,0,10,'default',0,342,'',0,'','','','',NULL,0,0,0,''),(362,18,'Время','html',0,0,1000,600,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(363,18,'term','img',320,60,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(364,18,'vlajn','img',410,40,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(365,18,'Температура','html',310,135,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(366,18,'Влажность','html',400,135,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(367,18,'davl','img',410,650,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(368,18,'Давление','html',405,740,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(369,18,'home_temp','img',315,650,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(370,18,'Температура в спальне','html',310,740,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(371,18,'Погодные условия','html',300,370,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(372,18,'css','html',0,0,0,0,0,0,'','   @font-face {\r\nfont-family: Digital;\r\nsrc: url(/cms/scenes/Digital.ttf);\r\n}\r\n\r\n.time_t {\r\n    font-family: \'Digital\';\r\n    color: #bedd44;\r\n    margin-top: -40px; \r\n    margin-left:170px; \r\n   }\r\n\r\ncenter {\r\n    color: #bedd44;\r\n   font-size: 15px;\r\n   }\r\n\r\n.mess {\r\n    text-align:  center;\r\n    width:1024px;\r\n    color: #bedd44;\r\n    margin-top: 20px; \r\n    margin-left:10px; \r\n   }\r\n\r\n.temp_t {\r\n    font-family: \'Digital\';\r\n    color: #bedd44;\r\n   }',0,0,0,10000,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(374,7,'term','html',52,1118,0,0,0,0,'','.GaugeMeter {\r\n  position: Relative;\r\n  text-align: Center;\r\n  overflow: Hidden;\r\n  cursor: Default;\r\n  display: inline-block;\r\n}\r\n\r\n.GaugeMeter SPAN, .GaugeMeter B {\r\n  width: 54%;\r\n  position: Absolute;\r\n  text-align: Center;\r\n  display: Inline-Block;\r\n  color: RGBa(0,0,0,.8);\r\n  font-weight: 100;\r\n  font-family: \"Open Sans\", Arial;\r\n  overflow: Hidden;\r\n  white-space: NoWrap;\r\n  text-overflow: Ellipsis;\r\n  margin: 0 23%;\r\n}\r\n\r\n.GaugeMeter[data-style=\"Semi\"] B {\r\n  width: 80%;\r\n  margin: 0 10%;\r\n}\r\n\r\n.GaugeMeter S, .GaugeMeter U {\r\n  text-decoration: None;\r\n  font-size: .60em;\r\n  font-weight: 200;\r\n  opacity: .6;\r\n}\r\n\r\n.GaugeMeter B {\r\n  color: #000;\r\n  font-weight: 200;\r\n  opacity: .8;\r\n}\r\n.GCont {\r\nbackground-color: #000;\r\nopacity: .8;\r\nborder-radius: 30px;\r\nborder:1px solid #777;\r\n} ',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(399,20,'2','html',499,520,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(400,20,'back_button','html',10,20,40,40,0,0,'','',0,0,0,60,'default',0,0,'',0,'','','','','',0,0,0,''),(401,20,'heading','html',10,80,1329,40,0,1,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(398,20,'1','html',504,698,0,0,0,0,'','',0,0,0,30,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(393,20,'general_CSS (only CSS)','html',1,490,0,0,0,0,'','/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_211 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_212 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_138 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сейчас */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-now {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 480px;\r\n  height: 260px;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-now .mainInfo {\r\n  text-align: center;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-now .mainInfo img {\r\n  display: block;\r\n  margin: auto;\r\n  height: 160px;\r\n  padding-right: 20px;\r\n}\r\n\r\n.panel-now .mainInfo .temp {\r\n  display: block;\r\n  font-size: 80px;\r\n  line-height: 0.8;\r\n  margin-bottom: 12px;\r\n  margin-top: -10px;\r\n}\r\n\r\n.panel-now .mainInfo .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-now .mainInfo .temp .degree {\r\n  margin-left: 5px;\r\n  font-size: 46px;\r\n  line-height: 2.5rem;\r\n  font-weight: 400;\r\n  vertical-align: top;\r\n}\r\n\r\n.panel-now .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n\r\n.panel-now .row .info {\r\n  /*flex: ;*/\r\n  text-align: center;\r\n}\r\n\r\n.panel-now .row .info i {\r\n  margin-right: 8px;\r\n  color: #ff6f4d;\r\n  font-size: 20px;\r\n}\r\n\r\n.panel-now .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 20px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сегодня */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-today {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 135px;\r\n  height: 120px;\r\n  /*background-color: rgba(0, 0, 0, 0.5);*/\r\n  /*-moz-border-radius: 0 05px;\r\n  -webkit-border-radius: 5px;*/\r\n  border-radius: 0 0 0 0;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-today .box {\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-today .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 18px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 3px rgba(0, 0, 0, 0.6);\r\n}\r\n.panel-today .box img {\r\n  display: block;\r\n  height: 55px;\r\n  margin: 0 0 0 37px;\r\n}\r\n.panel-today .box .temp {\r\n  font-size: 22px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  margin: 0 0 -2px 0;\r\n}\r\n.panel-today .box .temp .separator {\r\n  margin: 0 1px;\r\n  opacity: 0.4;\r\n}\r\n.panel-today .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-today .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 1.5;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}\r\n.panel-today .box .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  border-top: 2px solid rgba(0, 0, 0, 0.4);\r\n}\r\n.panel-today .box .row .info {\r\n  /*flex: ;*/\r\n    text-align: center;\r\n  margin: 0px 0 0 0;\r\n}\r\n\r\n.panel-today .box .row .info i {\r\n  margin-right: 2px;\r\n  color: #ff6f4d;\r\n  font-size: 10px;\r\n}\r\n\r\n.panel-today .box .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 10px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель  локация*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-location {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  right: 0px;\r\n  width: 250px;\r\n  height: 150px;\r\n  text-align: left;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.9);\r\n  /*-moz-border-radius: 5px;\r\n  -webkit-border-radius: 5px;\r\n  border-radius: 5px;*/\r\n  background-color: initial;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-location .icon {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 76px;\r\n  line-height: 1.2;\r\n  padding: 0 10px 0 0;\r\n}\r\n\r\n.panel-location .title {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 32px;\r\n  line-height: 1;\r\n  margin-right: 15px;\r\n}\r\n\r\n.panel-location .title span {\r\n  display: block;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панели прогноза погоды*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-forecast {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  bottom: 0;\r\n  width: 140px;\r\n  height: 150px;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  /* display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  justify-content: space-between;*/\r\n}\r\n\r\n.panel-forecast .box {\r\n /* flex: 1;*/\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-forecast .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 26px;\r\n  line-height: 1.2;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-forecast .box img {\r\n  display: block;\r\n  height: 75px;\r\n  margin: 0 10px 0 32px; \r\n}\r\n\r\n.panel-forecast .box .temp {\r\n  font-size: 26px;\r\n  line-height: 0.6;\r\n  font-weight: 600;\r\n  text-align: center;\r\n}\r\n\r\n.panel-forecast .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-forecast .box .temp .separator {\r\n  margin: 0 3px;\r\n  opacity: 0.4;\r\n}\r\n\r\n.panel-forecast .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 0.1;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}',0,0,0,70,'default',0,0,'',0,'','','','','',0,0,0,''),(402,20,'3','html',267,358,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(403,20,'4','html',277,704,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(397,20,'plane','html',57,165,1100,640,0,0,'','',0,0,0,10,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(396,20,'all_animations_cart (only CSS)','html',0,485,0,0,0,0,'','/* мигалка */\r\n@keyframes blink {\r\n  0% { opacity: 0; }\r\n  100% { opacity: 1; }\r\n}\r\n/* ---------------------------------------------------------- */\r\n\r\n/*  карта анимации блока времени  */\r\n@keyframes fortime  {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока погоды  */\r\n@keyframes forweather {\r\n  0% { transform: translateY(350px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока log_alise  */\r\n@keyframes forlog {\r\n  0% { transform: translateY(300px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока функций  1 2 3 4 5 6*/\r\n@keyframes forfunctions {\r\n  0% { transform: translateY(-320px); }\r\n  45% { transform: translateY(18px); }\r\n  65% { transform: translateY(-20px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блоков отображений 1 2 3 4  */\r\n@keyframes forshowing {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(414,21,'back_button','html',10,20,40,40,0,0,'','',0,0,0,1001,'default',0,0,'',0,'','','','','',0,0,0,''),(415,21,'heading','html',10,80,924,40,0,1,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(416,21,'cont1','container',60,20,984,530,0,1,'','',0,0,0,990,'default',0,0,'',0,'','','','','',0,0,0,''),(417,21,'todo_app','html',0,0,960,528,0,0,'%TodoList.JS%','%TodoList.sceneCSS%',0,0,0,0,'default',0,416,'',0,'','','','',NULL,0,0,0,''),(413,21,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','//@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_414 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_415 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_415 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n\r\n',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(427,22,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_133 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_134 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_134 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили pie диаграммы */\r\n/* -----------------------------------------------------------------------*/\r\n.container {\r\n  display: inline-block;\r\n  margin: 30px 20px;\r\n}\r\n.container .label-text {\r\n  display: block;\r\n  text-align: center;\r\n  font-size: 20px;\r\n  font-weight: bold;\r\n  margin-bottom: 15px;\r\n}\r\n\r\n.pie-wrapper {\r\n  position: relative;\r\n  width: 200px;\r\n  height: 100px;\r\n  overflow: hidden;\r\n}\r\n.pie-wrapper .arc, .pie-wrapper:before {\r\n  content: \'\';\r\n  width: 200px;\r\n  height: 100px;\r\n  position: absolute;\r\n  -ms-transform-origin: 50% 0%;\r\n  -webkit-transform-origin: 50% 0%;\r\n  transform-origin: 50% 0%;\r\n  left: 0;\r\n  box-sizing: border-box;\r\n}\r\n.pie-wrapper:before {\r\n  border: 50px solid #E8E8E8;\r\n  border-bottom: none;\r\n  top: 0;\r\n  z-index: 1;\r\n  border-radius: 300px 300px 0 0;\r\n}\r\n.pie-wrapper .arc {\r\n  border: 50px solid #FF5700;\r\n  border-top: none;\r\n  border-radius: 0 0 300px 300px;\r\n  top: 100%;\r\n  z-index: 2;\r\n}\r\n.pie-wrapper .arc::before {\r\n  content: \"\";\r\n  height: 1px;\r\n  width: 5px;\r\n  position: absolute;\r\n  top: 0px;\r\n}\r\n.pie-wrapper .score {\r\n  color: #ffffff;\r\n  font-size: 28px;\r\n  display: block;\r\n  width: 200px;\r\n  text-align: center;\r\n  margin-top: 70px;\r\n}\r\n\r\n.arc[data-value=\"1\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(1.8deg);\r\n  -ms-transform: rotate(1.8deg);\r\n  -webkit-transform: rotate(1.8deg);\r\n  transform: rotate(1.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"1\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"1\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"2\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(3.6deg);\r\n  -ms-transform: rotate(3.6deg);\r\n  -webkit-transform: rotate(3.6deg);\r\n  transform: rotate(3.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"2\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"2\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"3\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(5.4deg);\r\n  -ms-transform: rotate(5.4deg);\r\n  -webkit-transform: rotate(5.4deg);\r\n  transform: rotate(5.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"3\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"3\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"4\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(7.2deg);\r\n  -ms-transform: rotate(7.2deg);\r\n  -webkit-transform: rotate(7.2deg);\r\n  transform: rotate(7.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"4\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"4\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"5\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(9deg);\r\n  -ms-transform: rotate(9deg);\r\n  -webkit-transform: rotate(9deg);\r\n  transform: rotate(9deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"5\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"5\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"6\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(10.8deg);\r\n  -ms-transform: rotate(10.8deg);\r\n  -webkit-transform: rotate(10.8deg);\r\n  transform: rotate(10.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"6\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"6\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"7\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(12.6deg);\r\n  -ms-transform: rotate(12.6deg);\r\n  -webkit-transform: rotate(12.6deg);\r\n  transform: rotate(12.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"7\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"7\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"8\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(14.4deg);\r\n  -ms-transform: rotate(14.4deg);\r\n  -webkit-transform: rotate(14.4deg);\r\n  transform: rotate(14.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"8\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"8\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"9\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(16.2deg);\r\n  -ms-transform: rotate(16.2deg);\r\n  -webkit-transform: rotate(16.2deg);\r\n  transform: rotate(16.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"9\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"9\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"10\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(18deg);\r\n  -ms-transform: rotate(18deg);\r\n  -webkit-transform: rotate(18deg);\r\n  transform: rotate(18deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"10\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"10\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"11\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(19.8deg);\r\n  -ms-transform: rotate(19.8deg);\r\n  -webkit-transform: rotate(19.8deg);\r\n  transform: rotate(19.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"11\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"11\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"12\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(21.6deg);\r\n  -ms-transform: rotate(21.6deg);\r\n  -webkit-transform: rotate(21.6deg);\r\n  transform: rotate(21.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"12\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"12\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"13\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(23.4deg);\r\n  -ms-transform: rotate(23.4deg);\r\n  -webkit-transform: rotate(23.4deg);\r\n  transform: rotate(23.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"13\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"13\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"14\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(25.2deg);\r\n  -ms-transform: rotate(25.2deg);\r\n  -webkit-transform: rotate(25.2deg);\r\n  transform: rotate(25.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"14\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"14\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"15\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(27deg);\r\n  -ms-transform: rotate(27deg);\r\n  -webkit-transform: rotate(27deg);\r\n  transform: rotate(27deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"15\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"15\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"16\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(28.8deg);\r\n  -ms-transform: rotate(28.8deg);\r\n  -webkit-transform: rotate(28.8deg);\r\n  transform: rotate(28.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"16\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"16\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"17\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(30.6deg);\r\n  -ms-transform: rotate(30.6deg);\r\n  -webkit-transform: rotate(30.6deg);\r\n  transform: rotate(30.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"17\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"17\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"18\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(32.4deg);\r\n  -ms-transform: rotate(32.4deg);\r\n  -webkit-transform: rotate(32.4deg);\r\n  transform: rotate(32.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"18\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"18\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"19\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(34.2deg);\r\n  -ms-transform: rotate(34.2deg);\r\n  -webkit-transform: rotate(34.2deg);\r\n  transform: rotate(34.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"19\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"19\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"20\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(36deg);\r\n  -ms-transform: rotate(36deg);\r\n  -webkit-transform: rotate(36deg);\r\n  transform: rotate(36deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"20\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"20\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"21\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(37.8deg);\r\n  -ms-transform: rotate(37.8deg);\r\n  -webkit-transform: rotate(37.8deg);\r\n  transform: rotate(37.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"21\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"21\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"22\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(39.6deg);\r\n  -ms-transform: rotate(39.6deg);\r\n  -webkit-transform: rotate(39.6deg);\r\n  transform: rotate(39.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"22\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"22\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"23\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(41.4deg);\r\n  -ms-transform: rotate(41.4deg);\r\n  -webkit-transform: rotate(41.4deg);\r\n  transform: rotate(41.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"23\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"23\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"24\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(43.2deg);\r\n  -ms-transform: rotate(43.2deg);\r\n  -webkit-transform: rotate(43.2deg);\r\n  transform: rotate(43.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"24\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"24\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"25\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(45deg);\r\n  -ms-transform: rotate(45deg);\r\n  -webkit-transform: rotate(45deg);\r\n  transform: rotate(45deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"25\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"25\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"26\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(46.8deg);\r\n  -ms-transform: rotate(46.8deg);\r\n  -webkit-transform: rotate(46.8deg);\r\n  transform: rotate(46.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"26\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"26\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"27\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(48.6deg);\r\n  -ms-transform: rotate(48.6deg);\r\n  -webkit-transform: rotate(48.6deg);\r\n  transform: rotate(48.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"27\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"27\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"28\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(50.4deg);\r\n  -ms-transform: rotate(50.4deg);\r\n  -webkit-transform: rotate(50.4deg);\r\n  transform: rotate(50.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"28\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"28\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"29\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(52.2deg);\r\n  -ms-transform: rotate(52.2deg);\r\n  -webkit-transform: rotate(52.2deg);\r\n  transform: rotate(52.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"29\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"29\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"30\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(54deg);\r\n  -ms-transform: rotate(54deg);\r\n  -webkit-transform: rotate(54deg);\r\n  transform: rotate(54deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"30\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"30\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"31\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(55.8deg);\r\n  -ms-transform: rotate(55.8deg);\r\n  -webkit-transform: rotate(55.8deg);\r\n  transform: rotate(55.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"31\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"31\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"32\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(57.6deg);\r\n  -ms-transform: rotate(57.6deg);\r\n  -webkit-transform: rotate(57.6deg);\r\n  transform: rotate(57.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"32\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"32\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"33\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(59.4deg);\r\n  -ms-transform: rotate(59.4deg);\r\n  -webkit-transform: rotate(59.4deg);\r\n  transform: rotate(59.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"33\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"33\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"34\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(61.2deg);\r\n  -ms-transform: rotate(61.2deg);\r\n  -webkit-transform: rotate(61.2deg);\r\n  transform: rotate(61.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"34\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"34\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"35\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(63deg);\r\n  -ms-transform: rotate(63deg);\r\n  -webkit-transform: rotate(63deg);\r\n  transform: rotate(63deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"35\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"35\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"36\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(64.8deg);\r\n  -ms-transform: rotate(64.8deg);\r\n  -webkit-transform: rotate(64.8deg);\r\n  transform: rotate(64.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"36\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"36\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"37\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(66.6deg);\r\n  -ms-transform: rotate(66.6deg);\r\n  -webkit-transform: rotate(66.6deg);\r\n  transform: rotate(66.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"37\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"37\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"38\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(68.4deg);\r\n  -ms-transform: rotate(68.4deg);\r\n  -webkit-transform: rotate(68.4deg);\r\n  transform: rotate(68.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"38\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"38\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"39\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(70.2deg);\r\n  -ms-transform: rotate(70.2deg);\r\n  -webkit-transform: rotate(70.2deg);\r\n  transform: rotate(70.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"39\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"39\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"40\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(72deg);\r\n  -ms-transform: rotate(72deg);\r\n  -webkit-transform: rotate(72deg);\r\n  transform: rotate(72deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"40\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"40\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"41\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(73.8deg);\r\n  -ms-transform: rotate(73.8deg);\r\n  -webkit-transform: rotate(73.8deg);\r\n  transform: rotate(73.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"41\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"41\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"42\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(75.6deg);\r\n  -ms-transform: rotate(75.6deg);\r\n  -webkit-transform: rotate(75.6deg);\r\n  transform: rotate(75.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"42\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"42\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"43\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(77.4deg);\r\n  -ms-transform: rotate(77.4deg);\r\n  -webkit-transform: rotate(77.4deg);\r\n  transform: rotate(77.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"43\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"43\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"44\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(79.2deg);\r\n  -ms-transform: rotate(79.2deg);\r\n  -webkit-transform: rotate(79.2deg);\r\n  transform: rotate(79.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"44\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"44\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"45\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(81deg);\r\n  -ms-transform: rotate(81deg);\r\n  -webkit-transform: rotate(81deg);\r\n  transform: rotate(81deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"45\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"45\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"46\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(82.8deg);\r\n  -ms-transform: rotate(82.8deg);\r\n  -webkit-transform: rotate(82.8deg);\r\n  transform: rotate(82.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"46\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"46\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"47\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(84.6deg);\r\n  -ms-transform: rotate(84.6deg);\r\n  -webkit-transform: rotate(84.6deg);\r\n  transform: rotate(84.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"47\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"47\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"48\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(86.4deg);\r\n  -ms-transform: rotate(86.4deg);\r\n  -webkit-transform: rotate(86.4deg);\r\n  transform: rotate(86.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"48\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"48\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"49\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(88.2deg);\r\n  -ms-transform: rotate(88.2deg);\r\n  -webkit-transform: rotate(88.2deg);\r\n  transform: rotate(88.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"49\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"49\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"50\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(90deg);\r\n  -ms-transform: rotate(90deg);\r\n  -webkit-transform: rotate(90deg);\r\n  transform: rotate(90deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"50\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"50\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"51\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(91.8deg);\r\n  -ms-transform: rotate(91.8deg);\r\n  -webkit-transform: rotate(91.8deg);\r\n  transform: rotate(91.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"51\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"51\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"52\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(93.6deg);\r\n  -ms-transform: rotate(93.6deg);\r\n  -webkit-transform: rotate(93.6deg);\r\n  transform: rotate(93.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"52\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"52\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"53\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(95.4deg);\r\n  -ms-transform: rotate(95.4deg);\r\n  -webkit-transform: rotate(95.4deg);\r\n  transform: rotate(95.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"53\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"53\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"54\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(97.2deg);\r\n  -ms-transform: rotate(97.2deg);\r\n  -webkit-transform: rotate(97.2deg);\r\n  transform: rotate(97.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"54\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"54\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"55\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(99deg);\r\n  -ms-transform: rotate(99deg);\r\n  -webkit-transform: rotate(99deg);\r\n  transform: rotate(99deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"55\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"55\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"56\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(100.8deg);\r\n  -ms-transform: rotate(100.8deg);\r\n  -webkit-transform: rotate(100.8deg);\r\n  transform: rotate(100.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"56\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"56\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"57\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(102.6deg);\r\n  -ms-transform: rotate(102.6deg);\r\n  -webkit-transform: rotate(102.6deg);\r\n  transform: rotate(102.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"57\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"57\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"58\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(104.4deg);\r\n  -ms-transform: rotate(104.4deg);\r\n  -webkit-transform: rotate(104.4deg);\r\n  transform: rotate(104.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"58\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"58\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"59\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(106.2deg);\r\n  -ms-transform: rotate(106.2deg);\r\n  -webkit-transform: rotate(106.2deg);\r\n  transform: rotate(106.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"59\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"59\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"60\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(108deg);\r\n  -ms-transform: rotate(108deg);\r\n  -webkit-transform: rotate(108deg);\r\n  transform: rotate(108deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"60\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"60\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"61\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(109.8deg);\r\n  -ms-transform: rotate(109.8deg);\r\n  -webkit-transform: rotate(109.8deg);\r\n  transform: rotate(109.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"61\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"61\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"62\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(111.6deg);\r\n  -ms-transform: rotate(111.6deg);\r\n  -webkit-transform: rotate(111.6deg);\r\n  transform: rotate(111.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"62\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"62\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"63\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(113.4deg);\r\n  -ms-transform: rotate(113.4deg);\r\n  -webkit-transform: rotate(113.4deg);\r\n  transform: rotate(113.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"63\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"63\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"64\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(115.2deg);\r\n  -ms-transform: rotate(115.2deg);\r\n  -webkit-transform: rotate(115.2deg);\r\n  transform: rotate(115.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"64\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"64\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"65\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(117deg);\r\n  -ms-transform: rotate(117deg);\r\n  -webkit-transform: rotate(117deg);\r\n  transform: rotate(117deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"65\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"65\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"66\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(118.8deg);\r\n  -ms-transform: rotate(118.8deg);\r\n  -webkit-transform: rotate(118.8deg);\r\n  transform: rotate(118.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"66\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"66\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"67\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(120.6deg);\r\n  -ms-transform: rotate(120.6deg);\r\n  -webkit-transform: rotate(120.6deg);\r\n  transform: rotate(120.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"67\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"67\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"68\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(122.4deg);\r\n  -ms-transform: rotate(122.4deg);\r\n  -webkit-transform: rotate(122.4deg);\r\n  transform: rotate(122.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"68\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"68\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"69\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(124.2deg);\r\n  -ms-transform: rotate(124.2deg);\r\n  -webkit-transform: rotate(124.2deg);\r\n  transform: rotate(124.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"69\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"69\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"70\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(126deg);\r\n  -ms-transform: rotate(126deg);\r\n  -webkit-transform: rotate(126deg);\r\n  transform: rotate(126deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"70\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"70\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"71\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(127.8deg);\r\n  -ms-transform: rotate(127.8deg);\r\n  -webkit-transform: rotate(127.8deg);\r\n  transform: rotate(127.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"71\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"71\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"72\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(129.6deg);\r\n  -ms-transform: rotate(129.6deg);\r\n  -webkit-transform: rotate(129.6deg);\r\n  transform: rotate(129.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"72\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"72\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"73\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(131.4deg);\r\n  -ms-transform: rotate(131.4deg);\r\n  -webkit-transform: rotate(131.4deg);\r\n  transform: rotate(131.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"73\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"73\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"74\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(133.2deg);\r\n  -ms-transform: rotate(133.2deg);\r\n  -webkit-transform: rotate(133.2deg);\r\n  transform: rotate(133.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"74\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"74\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"75\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(135deg);\r\n  -ms-transform: rotate(135deg);\r\n  -webkit-transform: rotate(135deg);\r\n  transform: rotate(135deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"75\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"75\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"76\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(136.8deg);\r\n  -ms-transform: rotate(136.8deg);\r\n  -webkit-transform: rotate(136.8deg);\r\n  transform: rotate(136.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"76\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"76\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"77\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(138.6deg);\r\n  -ms-transform: rotate(138.6deg);\r\n  -webkit-transform: rotate(138.6deg);\r\n  transform: rotate(138.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"77\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"77\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"78\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(140.4deg);\r\n  -ms-transform: rotate(140.4deg);\r\n  -webkit-transform: rotate(140.4deg);\r\n  transform: rotate(140.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"78\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"78\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"79\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(142.2deg);\r\n  -ms-transform: rotate(142.2deg);\r\n  -webkit-transform: rotate(142.2deg);\r\n  transform: rotate(142.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"79\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"79\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"80\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(144deg);\r\n  -ms-transform: rotate(144deg);\r\n  -webkit-transform: rotate(144deg);\r\n  transform: rotate(144deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"80\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"80\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"81\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(145.8deg);\r\n  -ms-transform: rotate(145.8deg);\r\n  -webkit-transform: rotate(145.8deg);\r\n  transform: rotate(145.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"81\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"81\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"82\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(147.6deg);\r\n  -ms-transform: rotate(147.6deg);\r\n  -webkit-transform: rotate(147.6deg);\r\n  transform: rotate(147.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"82\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"82\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"83\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(149.4deg);\r\n  -ms-transform: rotate(149.4deg);\r\n  -webkit-transform: rotate(149.4deg);\r\n  transform: rotate(149.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"83\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"83\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"84\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(151.2deg);\r\n  -ms-transform: rotate(151.2deg);\r\n  -webkit-transform: rotate(151.2deg);\r\n  transform: rotate(151.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"84\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"84\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"85\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(153deg);\r\n  -ms-transform: rotate(153deg);\r\n  -webkit-transform: rotate(153deg);\r\n  transform: rotate(153deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"85\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"85\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"86\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(154.8deg);\r\n  -ms-transform: rotate(154.8deg);\r\n  -webkit-transform: rotate(154.8deg);\r\n  transform: rotate(154.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"86\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"86\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"87\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(156.6deg);\r\n  -ms-transform: rotate(156.6deg);\r\n  -webkit-transform: rotate(156.6deg);\r\n  transform: rotate(156.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"87\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"87\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"88\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(158.4deg);\r\n  -ms-transform: rotate(158.4deg);\r\n  -webkit-transform: rotate(158.4deg);\r\n  transform: rotate(158.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"88\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"88\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"89\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(160.2deg);\r\n  -ms-transform: rotate(160.2deg);\r\n  -webkit-transform: rotate(160.2deg);\r\n  transform: rotate(160.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"89\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"89\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"90\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(162deg);\r\n  -ms-transform: rotate(162deg);\r\n  -webkit-transform: rotate(162deg);\r\n  transform: rotate(162deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"90\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"90\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"91\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(163.8deg);\r\n  -ms-transform: rotate(163.8deg);\r\n  -webkit-transform: rotate(163.8deg);\r\n  transform: rotate(163.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"91\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"91\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"92\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(165.6deg);\r\n  -ms-transform: rotate(165.6deg);\r\n  -webkit-transform: rotate(165.6deg);\r\n  transform: rotate(165.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"92\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"92\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"93\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(167.4deg);\r\n  -ms-transform: rotate(167.4deg);\r\n  -webkit-transform: rotate(167.4deg);\r\n  transform: rotate(167.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"93\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"93\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"94\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(169.2deg);\r\n  -ms-transform: rotate(169.2deg);\r\n  -webkit-transform: rotate(169.2deg);\r\n  transform: rotate(169.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"94\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"94\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"95\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(171deg);\r\n  -ms-transform: rotate(171deg);\r\n  -webkit-transform: rotate(171deg);\r\n  transform: rotate(171deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"95\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"95\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"96\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(172.8deg);\r\n  -ms-transform: rotate(172.8deg);\r\n  -webkit-transform: rotate(172.8deg);\r\n  transform: rotate(172.8deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"96\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"96\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"97\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(174.6deg);\r\n  -ms-transform: rotate(174.6deg);\r\n  -webkit-transform: rotate(174.6deg);\r\n  transform: rotate(174.6deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"97\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"97\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"98\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(176.4deg);\r\n  -ms-transform: rotate(176.4deg);\r\n  -webkit-transform: rotate(176.4deg);\r\n  transform: rotate(176.4deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"98\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"98\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"99\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(178.2deg);\r\n  -ms-transform: rotate(178.2deg);\r\n  -webkit-transform: rotate(178.2deg);\r\n  transform: rotate(178.2deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"99\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"99\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"100\"] {\r\n  -moz-animation: fill 2s;\r\n  -webkit-animation: fill 2s;\r\n  animation: fill 2s;\r\n  -moz-transform: rotate(180deg);\r\n  -ms-transform: rotate(180deg);\r\n  -webkit-transform: rotate(180deg);\r\n  transform: rotate(180deg);\r\n  transition: All 5s ease;\r\n  border-color: #FF5700;\r\n}\r\n.arc[data-value=\"100\"]:after {\r\n  content: \'\';\r\n  position: absolute;\r\n  left: -40px;\r\n  top: 5px;\r\n}\r\n.arc[data-value=\"100\"]::before {\r\n  background-color: #FF5700;\r\n}\r\n\r\n.arc[data-value=\"1\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"1\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"2\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"2\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"3\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"3\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"4\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"4\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"5\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"5\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"6\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"6\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"7\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"7\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"8\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"8\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"9\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"9\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"10\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"10\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"11\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"11\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"12\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"12\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"13\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"13\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"14\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"14\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"15\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"15\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"16\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"16\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"17\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"17\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"18\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"18\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"19\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"19\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"20\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"20\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"21\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"21\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"22\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"22\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"23\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"23\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"24\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"24\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"25\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"25\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"26\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"26\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"27\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"27\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"28\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"28\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"29\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"29\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"30\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"30\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"31\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"31\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"32\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"32\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"33\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"33\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"34\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"34\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"35\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"35\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"36\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"36\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"37\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"37\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"38\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"38\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"39\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"39\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"40\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"40\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"41\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"41\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"42\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"42\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"43\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"43\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"44\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"44\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"45\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"45\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"46\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"46\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"47\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"47\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"48\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"48\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"49\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"49\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"50\"] {\r\n  border-color: #00B0F0;\r\n}\r\n.arc[data-value=\"50\"]::before {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n.arc[data-value=\"45\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"45\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"46\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"46\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"47\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"47\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"48\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"48\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"49\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"49\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"50\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"50\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"51\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"51\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"52\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"52\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"53\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"53\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"54\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"54\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.arc[data-value=\"55\"] {\r\n  border-color: #00D765;\r\n}\r\n.arc[data-value=\"55\"]::before {\r\n  background-color: #00D765;\r\n}\r\n\r\n.legend {\r\n  display: inline-block;\r\n  width: 150px;\r\n  vertical-align: text-bottom;\r\n  margin-left: 100px;\r\n  background-color: #ccc;\r\n}\r\n.legend span {\r\n  width: 20px;\r\n  height: 20px;\r\n  display: inline-block;\r\n  margin: 0 10px 0 20px;\r\n}\r\n.legend span.orange {\r\n  background-color: #FF5700;\r\n}\r\n.legend span.green {\r\n  background-color: #00D765;\r\n}\r\n.legend span.blue {\r\n  background-color: #00B0F0;\r\n}\r\n\r\n@-moz-keyframes fill {\r\n  0% {\r\n    -moz-transform: rotate(0deg);\r\n    transform: rotate(0deg);\r\n    border-color: #00B0F0;\r\n  }\r\n  50% {\r\n    -moz-transform: rotate(180deg);\r\n    transform: rotate(180deg);\r\n    border-color: #FF5700;\r\n  }\r\n}\r\n@-webkit-keyframes fill {\r\n  0% {\r\n    -webkit-transform: rotate(0deg);\r\n    transform: rotate(0deg);\r\n    border-color: #00B0F0;\r\n  }\r\n  50% {\r\n    -webkit-transform: rotate(180deg);\r\n    transform: rotate(180deg);\r\n    border-color: #FF5700;\r\n  }\r\n}\r\n@keyframes fill {\r\n  0% {\r\n    -moz-transform: rotate(0deg);\r\n    -ms-transform: rotate(0deg);\r\n    -webkit-transform: rotate(0deg);\r\n    transform: rotate(0deg);\r\n    border-color: #00B0F0;\r\n  }\r\n  50% {\r\n    -moz-transform: rotate(180deg);\r\n    -ms-transform: rotate(180deg);\r\n    -webkit-transform: rotate(180deg);\r\n    transform: rotate(180deg);\r\n    border-color: #FF5700;\r\n  }\r\n}\r\n',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(428,22,'back_button','html',10,20,40,40,0,0,'','',0,0,0,1001,'default',0,0,'',0,'','','','','',0,0,0,''),(429,22,'heading','html',10,80,924,40,0,1,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(430,22,'cont_chart1','container',60,20,984,530,0,1,'','',0,0,0,200,'default',0,0,'',0,'','','','','',0,0,0,''),(431,22,'name_1','html',0,0,984,25,0,1,'','',0,0,0,250,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(432,22,'chart_1','html',27,28,275,210,0,0,'','',0,0,0,99,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(433,22,'chart_2','html',26,670,275,210,0,0,'','',0,0,0,98,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(434,22,'name_2','html',254,0,984,25,0,1,'','',0,0,0,150,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(435,22,'chart_3','html',281,38,275,210,0,0,'','',0,0,0,89,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(436,22,'chart_4','html',281,673,275,210,0,0,'','',0,0,0,88,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(437,22,'pie_temp_home','html',23,372,0,0,0,0,'','',0,0,0,0,'default',0,430,'',0,'','','','',NULL,0,0,0,''),(438,23,'panel-showing4','html',198,-2,480,40,0,0,'','',0,0,0,974,'default',0,441,'',0,'','','','',NULL,0,0,0,''),(459,24,'panel-showing4','html',158,0,480,52,0,0,'','',0,0,0,974,'default',0,462,'',0,'','','','',NULL,0,0,0,''),(440,23,'functions','container',534,-1,1440,158,0,1,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(441,23,'showing','container',222,0,480,171,0,0,'','',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(442,23,'panel-time','html',28,-2,480,200,0,0,'','',0,0,0,60,'default',0,0,'',0,'','','','','',0,0,0,''),(484,23,'panel-showing3','html',134,-2,480,52,0,0,'','',0,0,0,976,'default',0,441,'',0,'','','','',NULL,0,0,0,''),(446,23,'function_1','html',20,32,120,120,0,0,'','',0,0,0,968,'default',0,440,'',0,'','','','',NULL,0,0,0,''),(447,23,'function_2','html',20,200,120,120,0,0,'','',0,0,0,967,'default',0,440,'',0,'','','','',NULL,0,0,0,''),(448,23,'function_3','html',20,368,120,120,0,0,'','',0,0,0,966,'default',0,440,'',0,'','','','',NULL,0,0,0,''),(449,23,'function_4','html',20,536,120,120,0,0,'','',0,0,0,965,'default',0,440,'',0,'','','','',NULL,0,0,0,''),(450,23,'function_6','html',20,857,120,120,0,0,'','',0,0,0,963,'default',0,440,'',0,'','','','',NULL,0,0,0,''),(451,23,'function_5','html',20,704,120,120,0,0,'','',0,0,0,964,'default',0,440,'',0,'','','','',NULL,0,0,0,''),(452,23,'panel-showing1','html',24,-2,480,40,0,0,'','',0,0,0,980,'default',0,441,'',0,'','','','',NULL,0,0,0,''),(453,23,'panel-showing2','html',81,-2,480,40,0,0,'','',0,0,0,978,'default',0,441,'',0,'','','','',NULL,0,0,0,''),(460,24,'panel-showing3','html',104,0,480,52,0,0,'','',0,0,0,976,'default',0,462,'',0,'','','','',NULL,0,0,0,''),(455,23,'general_CSS (only CSS)','html',1,490,0,0,0,0,'','/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n\r\n.element_196 { animation: fortime 1s ease-out; } /* - блок времени */\r\n.element_189 { animation: forweather 1.6s ease-out; } /* - блок погоды */\r\n.element_192 { animation: forweather 1.4s ease-out; } /* - блок STATUS SYSTEM  */\r\n.element_206 { animation: forshowing 1.2s ease-out; } /* - блок отображения - panel-showing1 */\r\n.element_207 { animation: forshowing 1.4s ease-out; } /* - блок отображения - panel-showing2 */\r\n.element_208 { animation: forshowing 1.6s ease-out; } /* - блок отображения - panel-showing3 */\r\n.element_209 { animation: forshowing 1.8s ease-out; } /* - блок отображения - panel-showing4 */\r\n.element_190 {animation: forlog 1.2s ease-out; } /* - ,блок отображения - log_alice */\r\n.element_200  { animation: forfunctions 1s ease-out; }  /*  - блок - panel-functions1 */\r\n.element_201  { animation: forfunctions 1.2s ease-out; } /*  - блок - panel-functions2 */\r\n.element_202  { animation: forfunctions 1.1s ease-out; } /*  - блок - panel-functions3 */\r\n.element_203  { animation: forfunctions 1.4s ease-out; } /*  - блок - panel-functions4 */\r\n.element_204 { animation: forfunctions 1.3s ease-out; } /*  - блок - panel-functions5 */\r\n.element_205  { animation: forfunctions 1.5s ease-out; } /*  - блок - panel-functions6 */\r\n/* ------------------------------------------------------------------------------------------------------------------------------------------- */\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* кнопки */ \r\n/* -----------------------------------------------------------------------*/\r\n\r\n/* общий  вид для кнопок*/\r\nbutton1,\r\nbutton2\r\n{\r\n display: block;\r\n  font-size: 1.1em;\r\n  font-weight: bold;\r\n  text-transform: uppercase;\r\n  padding: 10px 15px;\r\n  color: #ccc;\r\n  border-radius: 7.5px;\r\n  text-shadow: 0 -1px 0 #000;\r\n  box-shadow: 0 1px 0 #666, 0 5px 0 #444, 0 6px 6px rgba(0,0,0,0.6);\r\n  cursor: pointer;\r\n  -webkit-transition: all 150ms ease;\r\n  transition: all 150ms ease;\r\n}\r\n\r\n/*цвет и анимация свечения кнопки вкл*/\r\nbutton1 \r\n{\r\nbackground-color: #126be0;\r\n  background: -webkit-linear-gradient(#0d448c, #126be0);\r\n  background: linear-gradient(#0d448c, #126be0);\r\n-webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 05.s linear infinite;\r\n}\r\n\r\n/* цвет кнопки выкл*/\r\nbutton2 \r\n{\r\n  background-color: #555;\r\n  background: -webkit-linear-gradient(#888, #555);\r\n  background: linear-gradient(#888, #555);\r\n}\r\n\r\n/* анимация при наведении на кнопку вкл и при наведении на текст кнопки вкл*/\r\nbutton1:hover,\r\nbutton1:focus\r\n{\r\n  -webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 0.5s linear infinite;\r\n}\r\n/*карта анимации пульсации текста*/\r\n@-webkit-keyframes pulsate \r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n@keyframes pulsate\r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n/*карта анимации нажатия на кнопку*/\r\nbutton1:active,\r\nbutton2:active\r\n{\r\n  color: #fff;\r\n  text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff;\r\n  box-shadow: 0 1px 0 #666, 0 2px 0 #444, 0 2px 2px rgba(0,0,0,0.9);\r\n  -webkit-transform: translateY(3px);\r\n  transform: translateY(3px);\r\n  -webkit-animation: none;\r\n  animation: none;\r\n}\r\n\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - log_alice */ \r\n/* -----------------------------------------------------------------------*/\r\n .element_88 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - status_system_icons */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_94 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 2px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/*  контейнер - temp_home_1_floor и humidity_home_1_floor */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_109,\r\n.element_140 {\r\ndisplay: table;\r\n}\r\n.element_109 .fa,\r\n.element_109 .texttemp,\r\n.element_140 .fa,\r\n.element_140 .texttemp\r\n {\r\n        display: table-cell;\r\n        font-size: 28px;\r\n       /* font-weight: bold;*/\r\n        line-height: 1;\r\n        padding: 0 5px 0 0;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-weather {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n  position: absolute;\r\n /* top: 0px; */\r\n/*  right: 0px; */\r\n  width: 480px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  -moz-border-radius: 10px 0px 0px 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 10px;\r\n}\r\n.panel-weather .location {\r\nbackground-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 10px 0px 0px 0px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 0px;\r\n}\r\n\r\n.panel-weather img {\r\n  width: 96px;\r\n  margin: 10px 50px 0 0;\r\n}\r\n.panel-weather .temp-weather {\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 96px;\r\n  line-height: 1.4;\r\n}\r\n.panel-weather .temp-weather .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 32px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.panel-weather .text-weather {\r\n font-family: arial;\r\n font-weight: 200;\r\n  font-size: 22px;\r\n  line-height: 1.4;\r\n margin: 0 0 4px 0;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* панель времени  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-time {\r\n box-sizing: border-box;\r\n color: White;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 480px;\r\n -moz-border-radius: 0px 10px 10px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 10px 10px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-time .time {\r\n font-size: 140px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n}\r\n.panel-time .time .blnk {\r\n font-size: 140px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\nanimation: blink 1s ease infinite;\r\n}\r\n.panel-time .date {\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 0px 0px 10px 0px;\r\n  -webkit-border-radius: 0px;\r\n  border-radius: 0px 0px 10px 0px;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки отображения данных  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-showing1,\r\n.panel-showing2,\r\n.panel-showing3,\r\n.panel-showing4  {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n  position: absolute;\r\n  width: 480px;\r\n  overflow: hidden;\r\n  cursor: pointer;\r\n  background-color: initial;\r\n}\r\n.panel-showing1 ul,\r\n.panel-showing2 ul,\r\n.panel-showing3 ul,\r\n.panel-showing4 ul {\r\n  padding: 0;\r\n}\r\n.panel-showing1 ul li,\r\n.panel-showing2 ul li,\r\n.panel-showing3 ul li,\r\n.panel-showing4 ul li {\r\n  padding: 0;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1, \r\n.panel-showing1 ul li .title, \r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing1 ul li .sense_snowing_4,\r\n.panel-showing1 ul li .sense_snowing_3, \r\n.panel-showing2 ul li .sense_snowing_1, \r\n.panel-showing2 ul li .title, \r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_4,\r\n.panel-showing2 ul li .sense_snowing_3, \r\n.panel-showing3 ul li .sense_snowing_1, \r\n.panel-showing3 ul li .title, \r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_4,\r\n.panel-showing3 ul li .sense_snowing_3, \r\n.panel-showing4 ul li .sense_snowing_1, \r\n.panel-showing4 ul li .title, \r\n.panel-showing4 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_4,\r\n.panel-showing4 ul li .sense_snowing_3  {\r\n  display: inline-block;\r\n  font-size: 20px;\r\n  line-height: 1.6;\r\n  padding: 3px 8px;\r\n font-family: monospace;\r\n font-weight: lighter;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1,\r\n.panel-showing2 ul li .sense_snowing_1,\r\n.panel-showing3 ul li .sense_snowing_1,\r\n.panel-showing4 ul li .sense_snowing_1 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  color: white;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n.panel-showing1 ul li .sense_snowing_3,\r\n.panel-showing2 ul li .sense_snowing_3,\r\n.panel-showing3 ul li .sense_snowing_3,\r\n.panel-showing4 ul li .sense_snowing_3 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: red;\r\n  color: white;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n.panel-showing1 ul li .sense_snowing_4,\r\n.panel-showing2 ul li .sense_snowing_4,\r\n.panel-showing3 ul li .sense_snowing_4,\r\n.panel-showing4 ul li .sense_snowing_4 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: blue;\r\n  color: white;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n\r\n\r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 40, 40, 0.6);\r\n  color: rgba(190, 190, 190, 1);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки кнопок функций */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-functions {\r\n box-sizing: border-box;\r\n color: white;\r\n /* background-color: rgba(0, 0, 0, 0.4); */\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.panel-functions .icon {\r\n  margin: 0;\r\n  width: 82px;\r\n  height: 82px;\r\n  padding: 10px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px;\r\n}\r\n.panel-functions .icon .fa {\r\n margin: 7px 0px 0px 0px;\r\n font-size: 70px;\r\n}\r\n.panel-functions .icon .title {\r\n  font-size: 8px;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  /* display: none; */\r\n}\r\n/* ------------------------------------------------------------------------ */',0,0,0,90,'default',0,0,'',0,'','','','','',0,0,0,''),(456,23,'panel-weather','html',28,961,480,200,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(457,23,'log_alice','html',270,962,476,196,0,1,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(458,23,'all_animations_cart (only CSS)','html',0,485,0,0,0,0,'','/* мигалка */\r\n@keyframes blink {\r\n  0% { opacity: 0; }\r\n  100% { opacity: 1; }\r\n}\r\n/* ---------------------------------------------------------- */\r\n\r\n/*  карта анимации блока времени  */\r\n@keyframes fortime  {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока погоды  */\r\n@keyframes forweather {\r\n  0% { transform: translateY(350px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока log_alise  */\r\n@keyframes forlog {\r\n  0% { transform: translateY(300px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока функций  1 2 3 4 5 6*/\r\n@keyframes forfunctions {\r\n  0% { transform: translateY(-320px); }\r\n  45% { transform: translateY(18px); }\r\n  65% { transform: translateY(-20px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блоков отображений 1 2 3 4  */\r\n@keyframes forshowing {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n',0,0,0,80,'default',0,0,'',0,'','','','','',0,0,0,''),(461,24,'functions','container',440,0,1022,158,0,1,'','',0,0,0,30,'default',0,0,'',0,'','','','','',0,0,0,''),(462,24,'showing','container',222,0,480,210,0,0,'','',0,0,0,40,'default',0,0,'',0,'','','','','',0,0,0,''),(463,24,'panel-time','html',18,-2,480,200,0,0,'','',0,0,0,60,'default',0,0,'',0,'','','','','',0,0,0,''),(464,24,'status_Security','html',0,150,32,32,0,0,'','',0,0,0,958,'default',0,475,'',0,'','','','',NULL,0,0,0,''),(465,24,'status_System','html',0,190,32,32,0,0,'','',0,0,0,957,'default',0,475,'',0,'','','','',NULL,0,0,0,''),(466,24,'status_Communication','html',0,230,32,32,0,0,'','',0,0,0,956,'default',0,475,'',0,'','','','',NULL,0,0,0,''),(467,24,'function_1','html',20,32,120,120,0,0,'','',0,0,0,968,'default',0,461,'',0,'','','','',NULL,0,0,0,''),(468,24,'function_2','html',20,200,120,120,0,0,'','',0,0,0,967,'default',0,461,'',0,'','','','',NULL,0,0,0,''),(469,24,'function_3','html',20,368,120,120,0,0,'','',0,0,0,966,'default',0,461,'',0,'','','','',NULL,0,0,0,''),(470,24,'function_4','html',20,536,120,120,0,0,'','',0,0,0,965,'default',0,461,'',0,'','','','',NULL,0,0,0,''),(471,24,'function_6','html',20,872,120,120,0,0,'','',0,0,0,963,'default',0,461,'',0,'','','','',NULL,0,0,0,''),(472,24,'function_5','html',20,704,120,120,0,0,'','',0,0,0,964,'default',0,461,'',0,'','','','',NULL,0,0,0,''),(473,24,'panel-showing1','html',0,0,480,52,0,0,'','',0,0,0,980,'default',0,462,'',0,'','','','',NULL,0,0,0,''),(474,24,'panel-showing2','html',52,0,480,52,0,0,'','',0,0,0,978,'default',0,462,'',0,'','','','',NULL,0,0,0,''),(475,24,'status_system_icons','container',224,543,474,32,0,1,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(476,24,'general_CSS (only CSS)','html',1,490,0,0,0,0,'','/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n\r\n.element_196 { animation: fortime 1s ease-out; } /* - блок времени */\r\n.element_189 { animation: forweather 1.6s ease-out; } /* - блок погоды */\r\n.element_192 { animation: forweather 1.4s ease-out; } /* - блок STATUS SYSTEM  */\r\n.element_206 { animation: forshowing 1.2s ease-out; } /* - блок отображения - panel-showing1 */\r\n.element_207 { animation: forshowing 1.4s ease-out; } /* - блок отображения - panel-showing2 */\r\n.element_208 { animation: forshowing 1.6s ease-out; } /* - блок отображения - panel-showing3 */\r\n.element_209 { animation: forshowing 1.8s ease-out; } /* - блок отображения - panel-showing4 */\r\n.element_190 {animation: forlog 1.2s ease-out; } /* - ,блок отображения - log_alice */\r\n.element_200  { animation: forfunctions 1s ease-out; }  /*  - блок - panel-functions1 */\r\n.element_201  { animation: forfunctions 1.2s ease-out; } /*  - блок - panel-functions2 */\r\n.element_202  { animation: forfunctions 1.1s ease-out; } /*  - блок - panel-functions3 */\r\n.element_203  { animation: forfunctions 1.4s ease-out; } /*  - блок - panel-functions4 */\r\n.element_204 { animation: forfunctions 1.3s ease-out; } /*  - блок - panel-functions5 */\r\n.element_205  { animation: forfunctions 1.5s ease-out; } /*  - блок - panel-functions6 */\r\n/* ------------------------------------------------------------------------------------------------------------------------------------------- */\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* кнопки */ \r\n/* -----------------------------------------------------------------------*/\r\n\r\n/* общий  вид для кнопок*/\r\nbutton1,\r\nbutton2\r\n{\r\n display: block;\r\n  font-size: 1.1em;\r\n  font-weight: bold;\r\n  text-transform: uppercase;\r\n  padding: 10px 15px;\r\n  color: #ccc;\r\n  border-radius: 7.5px;\r\n  text-shadow: 0 -1px 0 #000;\r\n  box-shadow: 0 1px 0 #666, 0 5px 0 #444, 0 6px 6px rgba(0,0,0,0.6);\r\n  cursor: pointer;\r\n  -webkit-transition: all 150ms ease;\r\n  transition: all 150ms ease;\r\n}\r\n\r\n/*цвет и анимация свечения кнопки вкл*/\r\nbutton1 \r\n{\r\nbackground-color: #126be0;\r\n  background: -webkit-linear-gradient(#0d448c, #126be0);\r\n  background: linear-gradient(#0d448c, #126be0);\r\n-webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 05.s linear infinite;\r\n}\r\n\r\n/* цвет кнопки выкл*/\r\nbutton2 \r\n{\r\n  background-color: #555;\r\n  background: -webkit-linear-gradient(#888, #555);\r\n  background: linear-gradient(#888, #555);\r\n}\r\n\r\n/* анимация при наведении на кнопку вкл и при наведении на текст кнопки вкл*/\r\nbutton1:hover,\r\nbutton1:focus\r\n{\r\n  -webkit-animation: pulsate 0.5s linear infinite;\r\n  animation: pulsate 0.5s linear infinite;\r\n}\r\n/*карта анимации пульсации текста*/\r\n@-webkit-keyframes pulsate \r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n@keyframes pulsate\r\n{\r\n  0%   { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n  50%  { color: #fff; text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff; }\r\n  100% { color: #ddd; text-shadow: 0 -1px 0 #000; }\r\n}\r\n/*карта анимации нажатия на кнопку*/\r\nbutton1:active,\r\nbutton2:active\r\n{\r\n  color: #fff;\r\n  text-shadow: 0 -1px 0 #444, 0 0 5px #ffd, 0 0 8px #fff;\r\n  box-shadow: 0 1px 0 #666, 0 2px 0 #444, 0 2px 2px rgba(0,0,0,0.9);\r\n  -webkit-transform: translateY(3px);\r\n  transform: translateY(3px);\r\n  -webkit-animation: none;\r\n  animation: none;\r\n}\r\n\r\n\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - log_alice */ \r\n/* -----------------------------------------------------------------------*/\r\n .element_88 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* контейнер - status_system_icons */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_94 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px 0px 0px 10px;\r\npadding: 2px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/*  контейнер - temp_home_1_floor и humidity_home_1_floor */ \r\n/* -----------------------------------------------------------------------*/\r\n.element_109,\r\n.element_140 {\r\ndisplay: table;\r\n}\r\n.element_109 .fa,\r\n.element_109 .texttemp,\r\n.element_140 .fa,\r\n.element_140 .texttemp\r\n {\r\n        display: table-cell;\r\n        font-size: 28px;\r\n       /* font-weight: bold;*/\r\n        line-height: 1;\r\n        padding: 0 5px 0 0;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* панель погоды  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-weather {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n  position: absolute;\r\n /* top: 0px; */\r\n/*  right: 0px; */\r\n  width: 480px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  -moz-border-radius: 10px 0px 0px 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 10px;\r\n}\r\n.panel-weather .location {\r\nbackground-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 10px 0px 0px 0px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px 0px 0px 0px;\r\n}\r\n\r\n.panel-weather img {\r\n  width: 96px;\r\n  margin: 10px 50px 0 0;\r\n}\r\n.panel-weather .temp-weather {\r\n  font-family: arial;\r\n  font-weight: 600;\r\n  display: inline-block;\r\n  vertical-align: top;\r\n  font-size: 96px;\r\n  line-height: 1.4;\r\n}\r\n.panel-weather .temp-weather .degree {\r\n font-family: arial;\r\n font-weight: 600;\r\n  font-size: 32px;\r\n  line-height: 1.4;\r\n  vertical-align: top;\r\n}\r\n.panel-weather .text-weather {\r\n font-family: arial;\r\n font-weight: 200;\r\n  font-size: 22px;\r\n  line-height: 1.4;\r\n margin: 0 0 4px 0;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* панель времени  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-time {\r\n box-sizing: border-box;\r\n color: White;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n\r\n/* выше общее */\r\n position: absolute;\r\n top: 0px;\r\n width: 480px;\r\n -moz-border-radius: 0px 10px 10px 0px;\r\n -webkit-border-radius: 0px;\r\n border-radius: 0px 10px 10px 0px;\r\n /* animation: fortime 1s ease-out;*/\r\n}\r\n.panel-time .time {\r\n font-size: 140px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\n}\r\n.panel-time .time .blnk {\r\n font-size: 140px;\r\n line-height: 1.1;\r\n text-align: center;\r\n font-family: arial;\r\n font-weight: 600;\r\nanimation: blink 1s ease infinite;\r\n}\r\n.panel-time .date {\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  font-size: 22px;\r\n  line-height: 1.2;\r\n  text-align: center;\r\n font-family: arial;\r\n font-weight: 100;\r\n  -moz-border-radius: 0px 0px 10px 0px;\r\n  -webkit-border-radius: 0px;\r\n  border-radius: 0px 0px 10px 0px;\r\n}\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки отображения данных  */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-showing1,\r\n.panel-showing2,\r\n.panel-showing3,\r\n.panel-showing4  {\r\n box-sizing: border-box;\r\n color: white;\r\n background-color: rgba(0, 0, 0, 0.4);\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n  position: absolute;\r\n  width: 480px;\r\n  overflow: hidden;\r\n  cursor: pointer;\r\n  background-color: initial;\r\n}\r\n.panel-showing1 ul,\r\n.panel-showing2 ul,\r\n.panel-showing3 ul,\r\n.panel-showing4 ul {\r\n  padding: 0;\r\n}\r\n.panel-showing1 ul li,\r\n.panel-showing2 ul li,\r\n.panel-showing3 ul li,\r\n.panel-showing4 ul li {\r\n  padding: 0;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1, \r\n.panel-showing1 ul li .title, \r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_1, \r\n.panel-showing2 ul li .title, \r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_1, \r\n.panel-showing3 ul li .title, \r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_1, \r\n.panel-showing4 ul li .title, \r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  display: inline-block;\r\n  font-size: 20px;\r\n  line-height: 1.6;\r\n  padding: 3px 8px;\r\n font-family: monospace;\r\n font-weight: lighter;\r\n}\r\n.panel-showing1 ul li .sense_snowing_1,\r\n.panel-showing2 ul li .sense_snowing_1,\r\n.panel-showing3 ul li .sense_snowing_1,\r\n.panel-showing4 ul li .sense_snowing_1 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 233, 233, 0.6);\r\n  color: white;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n\r\n.panel-showing1 ul li .sense_snowing_0,\r\n.panel-showing2 ul li .sense_snowing_0,\r\n.panel-showing3 ul li .sense_snowing_0,\r\n.panel-showing4 ul li .sense_snowing_0 {\r\n  float: right;\r\n  width: 180px;\r\n  text-align: center;\r\n  font-family: monospace;\r\n  font-weight: lighter;\r\n  background-color: rgba(0, 40, 40, 0.6);\r\n  color: rgba(190, 190, 190, 1);\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* блоки кнопок функций */\r\n/* -----------------------------------------------------------------------*/\r\n.panel-functions {\r\n box-sizing: border-box;\r\n color: white;\r\n /* background-color: rgba(0, 0, 0, 0.4); */\r\n /* text-shadow: 0 0 4px rgba(0, 0, 0, 0.4); */\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.panel-functions .icon {\r\n  margin: 0;\r\n  width: 82px;\r\n  height: 82px;\r\n  padding: 10px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px;\r\n}\r\n.panel-functions .icon .fa {\r\n margin: 7px 0px 0px 0px;\r\n font-size: 70px;\r\n}\r\n.panel-functions .icon .title {\r\n  font-size: 8px;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  /* display: none; */\r\n}\r\n/* ------------------------------------------------------------------------ */',0,0,0,90,'default',0,0,'',0,'','','','','',0,0,0,''),(477,24,'panel-weather','html',20,543,480,200,0,0,'','',0,0,0,50,'default',0,0,'',0,'','','','','',0,0,0,''),(478,24,'log_alice','html',270,543,477,140,0,1,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(479,24,'all_animations_cart (only CSS)','html',0,485,0,0,0,0,'','/* мигалка */\r\n@keyframes blink {\r\n  0% { opacity: 0; }\r\n  100% { opacity: 1; }\r\n}\r\n/* ---------------------------------------------------------- */\r\n\r\n/*  карта анимации блока времени  */\r\n@keyframes fortime  {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока погоды  */\r\n@keyframes forweather {\r\n  0% { transform: translateY(350px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока log_alise  */\r\n@keyframes forlog {\r\n  0% { transform: translateY(300px); }\r\n  45% { transform: translateY(-20px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока функций  1 2 3 4 5 6*/\r\n@keyframes forfunctions {\r\n  0% { transform: translateY(-320px); }\r\n  45% { transform: translateY(18px); }\r\n  65% { transform: translateY(-20px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блоков отображений 1 2 3 4  */\r\n@keyframes forshowing {\r\n  0% { transform: translateX(-480px); }\r\n  45% { transform: translateX(63px); }\r\n  65% { transform: translateX(-30px); }\r\n  100% { transform: translateX(0px); }\r\n}\r\n',0,0,0,80,'default',0,0,'',0,'','','','','',0,0,0,''),(480,23,'status_system_icons','container',230,961,480,32,0,1,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(481,23,'status_Security','html',0,150,32,32,0,0,'','',0,0,0,958,'default',0,480,'',0,'','','','',NULL,0,0,0,''),(482,23,'status_System','html',0,190,32,32,0,0,'','',0,0,0,957,'default',0,480,'',0,'','','','',NULL,0,0,0,''),(483,23,'status_Communication','html',0,230,32,32,0,0,'','',0,0,0,956,'default',0,480,'',0,'','','','',NULL,0,0,0,''),(485,25,'back_button','html',10,20,40,40,0,0,'','',0,0,0,1001,'default',0,0,'',0,'','','','','',0,0,0,''),(486,25,'heading','html',10,80,1329,40,0,1,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(487,25,'cont1','container',60,20,1389,642,0,1,'','',0,0,0,990,'default',0,0,'',0,'','','','','',0,0,0,''),(488,25,'todo_app','html',0,0,1389,642,0,0,'%TodoList.JS%','%TodoList.sceneCSS%',0,0,0,0,'default',0,487,'',0,'','','','',NULL,0,0,0,''),(489,25,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','//@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n\r\n/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_414 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_415 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_415 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n\r\n',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(490,26,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_400 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_401 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_138 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сейчас */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-now {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 480px;\r\n  height: 260px;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-now .mainInfo {\r\n  text-align: center;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-now .mainInfo img {\r\n  display: block;\r\n  margin: auto;\r\n  height: 160px;\r\n  padding-right: 20px;\r\n}\r\n\r\n.panel-now .mainInfo .temp {\r\n  display: block;\r\n  font-size: 80px;\r\n  line-height: 0.8;\r\n  margin-bottom: 12px;\r\n  margin-top: -10px;\r\n}\r\n\r\n.panel-now .mainInfo .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-now .mainInfo .temp .degree {\r\n  margin-left: 5px;\r\n  font-size: 46px;\r\n  line-height: 2.5rem;\r\n  font-weight: 400;\r\n  vertical-align: top;\r\n}\r\n\r\n.panel-now .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n\r\n.panel-now .row .info {\r\n  /*flex: ;*/\r\n  text-align: center;\r\n}\r\n\r\n.panel-now .row .info i {\r\n  margin-right: 8px;\r\n  color: #ff6f4d;\r\n  font-size: 20px;\r\n}\r\n\r\n.panel-now .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 20px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сегодня */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-today {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 135px;\r\n  height: 120px;\r\n  /*background-color: rgba(0, 0, 0, 0.5);*/\r\n  /*-moz-border-radius: 0 05px;\r\n  -webkit-border-radius: 5px;*/\r\n  border-radius: 0 0 0 0;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-today .box {\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-today .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 18px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 3px rgba(0, 0, 0, 0.6);\r\n}\r\n.panel-today .box img {\r\n  display: block;\r\n  height: 55px;\r\n  margin: 0 0 0 37px;\r\n}\r\n.panel-today .box .temp {\r\n  font-size: 22px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  margin: 0 0 -2px 0;\r\n}\r\n.panel-today .box .temp .separator {\r\n  margin: 0 1px;\r\n  opacity: 0.4;\r\n}\r\n.panel-today .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-today .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 1.5;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}\r\n.panel-today .box .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  border-top: 2px solid rgba(0, 0, 0, 0.4);\r\n}\r\n.panel-today .box .row .info {\r\n  /*flex: ;*/\r\n    text-align: center;\r\n  margin: 0px 0 0 0;\r\n}\r\n\r\n.panel-today .box .row .info i {\r\n  margin-right: 2px;\r\n  color: #ff6f4d;\r\n  font-size: 10px;\r\n}\r\n\r\n.panel-today .box .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 10px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель  локация*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-location {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  right: 0px;\r\n  width: 250px;\r\n  height: 150px;\r\n  text-align: left;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.9);\r\n  /*-moz-border-radius: 5px;\r\n  -webkit-border-radius: 5px;\r\n  border-radius: 5px;*/\r\n  background-color: initial;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-location .icon {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 76px;\r\n  line-height: 1.2;\r\n  padding: 0 10px 0 0;\r\n}\r\n\r\n.panel-location .title {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 32px;\r\n  line-height: 1;\r\n  margin-right: 15px;\r\n}\r\n\r\n.panel-location .title span {\r\n  display: block;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панели прогноза погоды*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-forecast {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  bottom: 0;\r\n  width: 140px;\r\n  height: 150px;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  /* display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  justify-content: space-between;*/\r\n}\r\n\r\n.panel-forecast .box {\r\n /* flex: 1;*/\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-forecast .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 26px;\r\n  line-height: 1.2;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-forecast .box img {\r\n  display: block;\r\n  height: 75px;\r\n  margin: 0 10px 0 32px; \r\n}\r\n\r\n.panel-forecast .box .temp {\r\n  font-size: 26px;\r\n  line-height: 0.6;\r\n  font-weight: 600;\r\n  text-align: center;\r\n}\r\n\r\n.panel-forecast .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-forecast .box .temp .separator {\r\n  margin: 0 3px;\r\n  opacity: 0.4;\r\n}\r\n\r\n.panel-forecast .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 0.1;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(491,26,'back_button','html',10,20,40,40,0,0,'','',0,0,0,1001,'default',0,0,'',0,'','','','','',0,0,0,''),(492,26,'heading','html',10,80,1329,40,0,1,'','',0,0,0,1000,'default',0,0,'',0,'','','','','',0,0,0,''),(493,26,'cont1','container',60,20,984,530,0,0,'','',0,0,0,990,'default',0,0,'',0,'','','','','',0,0,0,''),(494,26,'panel-now','html',139,0,400,200,0,0,'','',0,0,0,50,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(495,26,'panel-location','html',16,63,200,100,0,0,'','',0,0,0,60,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(496,26,'panel_today_1','html',275,539,135,120,0,0,'','',0,0,0,40,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(497,26,'panel-forecast1','html',450,0,140,150,0,0,'','',0,0,0,130,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(498,26,'panel_today_2','html',275,676,135,120,0,0,'','',0,0,0,30,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(499,26,'panel_today_3','html',275,813,135,120,0,0,'','',0,0,0,20,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(500,26,'panel-forecast2','html',450,142,140,150,0,0,'','',0,0,0,120,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(501,26,'panel-forecast3','html',450,284,140,150,0,0,'','',0,0,0,110,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(502,26,'panel-forecast4','html',450,426,140,150,0,0,'','',0,0,0,100,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(503,26,'panel-forecast5','html',450,568,140,150,0,0,'','',0,0,0,90,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(504,26,'panel-forecast6','html',450,710,140,150,0,0,'','',0,0,0,80,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(505,26,'panel-forecast7','html',450,852,140,150,0,0,'','',0,0,0,70,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(506,26,'chart','html',11,569,350,210,0,0,'','',0,0,0,10,'default',0,493,'',0,'','','','',NULL,0,0,0,''),(507,26,'chart2','html',8,1023,350,210,0,0,'','',0,0,0,10,'default',0,493,'',0,'','','','','',0,0,0,''),(508,26,'chart3','html',220,1023,350,210,0,0,'','',0,0,0,10,'default',0,493,'',0,'','','','','',0,0,0,''),(509,26,'chart4','html',431,1023,350,210,0,0,'','',0,0,0,10,'default',0,493,'',0,'','','','','',0,0,0,''),(510,27,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_229 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_230 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_138 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сейчас */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-now {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 480px;\r\n  height: 260px;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-now .mainInfo {\r\n  text-align: center;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-now .mainInfo img {\r\n  display: block;\r\n  margin: auto;\r\n  height: 160px;\r\n  padding-right: 20px;\r\n}\r\n\r\n.panel-now .mainInfo .temp {\r\n  display: block;\r\n  font-size: 80px;\r\n  line-height: 0.8;\r\n  margin-bottom: 12px;\r\n  margin-top: -10px;\r\n}\r\n\r\n.panel-now .mainInfo .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-now .mainInfo .temp .degree {\r\n  margin-left: 5px;\r\n  font-size: 46px;\r\n  line-height: 2.5rem;\r\n  font-weight: 400;\r\n  vertical-align: top;\r\n}\r\n\r\n.panel-now .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n\r\n.panel-now .row .info {\r\n  /*flex: ;*/\r\n  text-align: center;\r\n}\r\n\r\n.panel-now .row .info i {\r\n  margin-right: 8px;\r\n  color: #ff6f4d;\r\n  font-size: 20px;\r\n}\r\n\r\n.panel-now .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 20px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сегодня */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-today {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 135px;\r\n  height: 120px;\r\n  /*background-color: rgba(0, 0, 0, 0.5);*/\r\n  /*-moz-border-radius: 0 05px;\r\n  -webkit-border-radius: 5px;*/\r\n  border-radius: 0 0 0 0;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-today .box {\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-today .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 18px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 3px rgba(0, 0, 0, 0.6);\r\n}\r\n.panel-today .box img {\r\n  display: block;\r\n  height: 55px;\r\n  margin: 0 0 0 37px;\r\n}\r\n.panel-today .box .temp {\r\n  font-size: 22px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  margin: 0 0 -2px 0;\r\n}\r\n.panel-today .box .temp .separator {\r\n  margin: 0 1px;\r\n  opacity: 0.4;\r\n}\r\n.panel-today .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-today .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 1.5;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}\r\n.panel-today .box .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  border-top: 2px solid rgba(0, 0, 0, 0.4);\r\n}\r\n.panel-today .box .row .info {\r\n  /*flex: ;*/\r\n    text-align: center;\r\n  margin: 0px 0 0 0;\r\n}\r\n\r\n.panel-today .box .row .info i {\r\n  margin-right: 2px;\r\n  color: #ff6f4d;\r\n  font-size: 10px;\r\n}\r\n\r\n.panel-today .box .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 10px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель  локация*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-location {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  right: 0px;\r\n  width: 250px;\r\n  height: 150px;\r\n  text-align: left;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.9);\r\n  /*-moz-border-radius: 5px;\r\n  -webkit-border-radius: 5px;\r\n  border-radius: 5px;*/\r\n  background-color: initial;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-location .icon {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 76px;\r\n  line-height: 1.2;\r\n  padding: 0 10px 0 0;\r\n}\r\n\r\n.panel-location .title {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 32px;\r\n  line-height: 1;\r\n  margin-right: 15px;\r\n}\r\n\r\n.panel-location .title span {\r\n  display: block;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панели прогноза погоды*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-forecast {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  bottom: 0;\r\n  width: 140px;\r\n  height: 150px;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  /* display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  justify-content: space-between;*/\r\n}\r\n\r\n.panel-forecast .box {\r\n /* flex: 1;*/\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-forecast .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 26px;\r\n  line-height: 1.2;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-forecast .box img {\r\n  display: block;\r\n  height: 75px;\r\n  margin: 0 10px 0 32px; \r\n}\r\n\r\n.panel-forecast .box .temp {\r\n  font-size: 26px;\r\n  line-height: 0.6;\r\n  font-weight: 600;\r\n  text-align: center;\r\n}\r\n\r\n.panel-forecast .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-forecast .box .temp .separator {\r\n  margin: 0 3px;\r\n  opacity: 0.4;\r\n}\r\n\r\n.panel-forecast .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 0.1;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(517,28,'general_CSS (only CSS)','html',0,0,0,0,0,0,'','/* ---------------------------------------------------------- */\r\n/*  карта анимации блока heading и back */\r\n@keyframes forheading {\r\n  0% { transform: translateY(500px); }\r\n  45% { transform: translateY(-8px); }\r\n  65% { transform: translateY(10px); }\r\n 100% { transform: translateY(0px); }\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* ОБЩЕЕ СОБРАНИЕ КОДА ДЛЯ АНИМАЦИИ */\r\n/* -----------------------------------------------------------------------*/\r\n.element_229 { animation: forheading 1.2s ease-out; } /* - блок back */\r\n.element_230 { animation: forheading 1.6s ease-out; } /* - блок handing */\r\n\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для heading*/\r\n/* -----------------------------------------------------------------------*/\r\n .element_138 {\r\n-moz-border-radius: 10px 0px 0px 10px;\r\n-webkit-border-radius: 10px;\r\nborder-radius: 10px;\r\n}\r\n/* -----------------------------------------------------------------------*/\r\n/* стили для кнопки BACK*/\r\n/* -----------------------------------------------------------------------*/\r\n.backbutton {\r\n box-sizing: border-box;\r\n color: white;\r\n position: absolute;\r\n  width: 100%;\r\n  bottom: 0px;\r\n  padding: 0px;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n.backbutton .icon {\r\n  margin: 0;\r\n  width: 40px;\r\n  height: 40px;\r\n  padding: 0px;\r\n  text-align: center;\r\n  cursor: pointer;\r\n  /* border: 9px solid rgba(0, 233, 233, 0.6);\r\n  -moz-border-radius: 82px;\r\n  -webkit-border-radius: 82px;\r\n  border-radius: 82px; */\r\n}\r\n.backbutton  .icon .fa {\r\n margin: 0px 0px 0px 0px;\r\n font-size: 40px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сейчас */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-now {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 480px;\r\n  height: 260px;\r\n  -moz-border-radius: 10px;\r\n  -webkit-border-radius: 10px;\r\n  border-radius: 10px;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-now .mainInfo {\r\n  text-align: center;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-now .mainInfo img {\r\n  display: block;\r\n  margin: auto;\r\n  height: 160px;\r\n  padding-right: 20px;\r\n}\r\n\r\n.panel-now .mainInfo .temp {\r\n  display: block;\r\n  font-size: 80px;\r\n  line-height: 0.8;\r\n  margin-bottom: 12px;\r\n  margin-top: -10px;\r\n}\r\n\r\n.panel-now .mainInfo .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-now .mainInfo .temp .degree {\r\n  margin-left: 5px;\r\n  font-size: 46px;\r\n  line-height: 2.5rem;\r\n  font-weight: 400;\r\n  vertical-align: top;\r\n}\r\n\r\n.panel-now .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n}\r\n\r\n.panel-now .row .info {\r\n  /*flex: ;*/\r\n  text-align: center;\r\n}\r\n\r\n.panel-now .row .info i {\r\n  margin-right: 8px;\r\n  color: #ff6f4d;\r\n  font-size: 20px;\r\n}\r\n\r\n.panel-now .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 20px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель погода сегодня */\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-today {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  left: 0px;\r\n  width: 135px;\r\n  height: 120px;\r\n  /*background-color: rgba(0, 0, 0, 0.5);*/\r\n  /*-moz-border-radius: 0 05px;\r\n  -webkit-border-radius: 5px;*/\r\n  border-radius: 0 0 0 0;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-today .box {\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-today .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 18px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 3px rgba(0, 0, 0, 0.6);\r\n}\r\n.panel-today .box img {\r\n  display: block;\r\n  height: 55px;\r\n  margin: 0 0 0 37px;\r\n}\r\n.panel-today .box .temp {\r\n  font-size: 22px;\r\n  line-height: 1.3;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  margin: 0 0 -2px 0;\r\n}\r\n.panel-today .box .temp .separator {\r\n  margin: 0 1px;\r\n  opacity: 0.4;\r\n}\r\n.panel-today .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-today .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 1.5;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}\r\n.panel-today .box .row {\r\n  display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  border-top: 2px solid rgba(0, 0, 0, 0.4);\r\n}\r\n.panel-today .box .row .info {\r\n  /*flex: ;*/\r\n    text-align: center;\r\n  margin: 0px 0 0 0;\r\n}\r\n\r\n.panel-today .box .row .info i {\r\n  margin-right: 2px;\r\n  color: #ff6f4d;\r\n  font-size: 10px;\r\n}\r\n\r\n.panel-today .box .row .info .value {\r\n  font-weight: 600;\r\n  font-size: 10px;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панель  локация*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-location {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  top: 0px;\r\n  right: 0px;\r\n  width: 250px;\r\n  height: 150px;\r\n  text-align: left;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.9);\r\n  /*-moz-border-radius: 5px;\r\n  -webkit-border-radius: 5px;\r\n  border-radius: 5px;*/\r\n  background-color: initial;\r\n  font-family: arial;\r\n}\r\n\r\n.panel-location .icon {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 76px;\r\n  line-height: 1.2;\r\n  padding: 0 10px 0 0;\r\n}\r\n\r\n.panel-location .title {\r\n  display: inline-block;\r\n  text-align: center;\r\n  font-size: 32px;\r\n  line-height: 1;\r\n  margin-right: 15px;\r\n}\r\n\r\n.panel-location .title span {\r\n  display: block;\r\n}\r\n/* ----------------------------------------------------------- */\r\n/* панели прогноза погоды*/\r\n/* ----------------------------------------------------------- */\r\n\r\n.panel-forecast {\r\n  box-sizing: border-box;\r\n  color: white;\r\n  background-color: rgba(0, 0, 0, 0.4);\r\n  text-shadow: 0 0 4px rgba(0, 0, 0, 0.4);\r\n  position: absolute;\r\n  bottom: 0;\r\n  width: 140px;\r\n  height: 150px;\r\n  background-color: rgba(0, 0, 0, 0.5);\r\n  /* display: -webkit-flex;\r\n  display: flex;\r\n  align-items: center;\r\n  justify-content: space-around;\r\n  justify-content: space-between;*/\r\n}\r\n\r\n.panel-forecast .box {\r\n /* flex: 1;*/\r\n  height: 100%;\r\n  border-right: 3px solid rgba(0, 0, 0, 0.3);\r\n}\r\n\r\n.panel-forecast .box .title {\r\n  background-color: rgba(0, 0, 0, 0.2);\r\n  font-size: 26px;\r\n  line-height: 1.2;\r\n  font-weight: 600;\r\n  text-align: center;\r\n  text-transform: uppercase;\r\n  color: #ff6f4d;\r\n  text-shadow: 1px 1px 4px rgba(0, 0, 0, 0.6);\r\n}\r\n\r\n.panel-forecast .box img {\r\n  display: block;\r\n  height: 75px;\r\n  margin: 0 10px 0 32px; \r\n}\r\n\r\n.panel-forecast .box .temp {\r\n  font-size: 26px;\r\n  line-height: 0.6;\r\n  font-weight: 600;\r\n  text-align: center;\r\n}\r\n\r\n.panel-forecast .box .temp .value {\r\n  font-weight: 600;\r\n}\r\n\r\n.panel-forecast .box .temp .separator {\r\n  margin: 0 3px;\r\n  opacity: 0.4;\r\n}\r\n\r\n.panel-forecast .box .temp .degree {\r\n  margin-left: 2px;\r\n  font-size: 12px;\r\n  line-height: 0.1;\r\n  font-weight: 300;\r\n  vertical-align: top;\r\n}',0,0,0,2000,'default',0,0,'',0,'','','','','',0,0,0,''),(512,27,'back_button','html',10,20,40,40,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(513,27,'heading','html',10,80,1329,40,0,1,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(514,27,'Setting','html',66,1206,200,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(515,27,'webmin','html',126,1206,200,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(516,27,'phpmyadmin','html',186,1206,200,40,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','','',0,0,0,''),(518,28,'back_button','html',10,20,40,40,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(519,28,'heading','html',10,80,1329,40,0,1,'','',0,0,0,10,'default',0,0,'',0,'','','','','',0,0,0,''),(523,28,'GPS','html',0,0,1300,600,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(524,23,'radio','html',30,520,403,333,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(525,20,'temp1','html',0,0,0,0,0,0,'','',0,0,0,0,'default',0,0,'',0,'','','','',NULL,0,0,0,''),(527,20,'5','html',112,1010,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(528,20,'6','html',315,1045,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(529,20,'7','html',497,872,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,''),(530,20,'8','html',95,410,0,0,0,0,'','',0,0,0,20,'default',0,0,'',0,'','','','','',0,0,0,'');
/*!40000 ALTER TABLE `elements` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `elm_states`
--

DROP TABLE IF EXISTS `elm_states`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `elm_states` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ELEMENT_ID` int(10) NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `IMAGE` varchar(255) NOT NULL DEFAULT '',
  `HTML` text,
  `IS_DYNAMIC` int(3) NOT NULL DEFAULT '0',
  `CURRENT_STATE` int(3) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CONDITION` int(3) NOT NULL DEFAULT '0',
  `CONDITION_VALUE` varchar(255) NOT NULL DEFAULT '',
  `CONDITION_ADVANCED` text,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `SWITCH_SCENE` int(3) NOT NULL DEFAULT '0',
  `CURRENT_STATUS` int(3) NOT NULL DEFAULT '0',
  `ACTION_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `ACTION_METHOD` varchar(255) NOT NULL DEFAULT '',
  `MENU_ITEM_ID` int(10) NOT NULL DEFAULT '0',
  `WINDOW_POSX` int(10) NOT NULL DEFAULT '0',
  `WINDOW_POSY` int(10) NOT NULL DEFAULT '0',
  `WINDOW_WIDTH` int(10) NOT NULL DEFAULT '0',
  `WINDOW_HEIGHT` int(10) NOT NULL DEFAULT '0',
  `HOMEPAGE_ID` int(10) NOT NULL DEFAULT '0',
  `EXT_URL` varchar(255) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `CODE` text,
  `OPEN_SCENE_ID` int(10) NOT NULL DEFAULT '0',
  `S3D_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `S3D_CAMERA` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=591 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `elm_states`
--

LOCK TABLES `elm_states` WRITE;
/*!40000 ALTER TABLE `elm_states` DISABLE KEYS */;
INSERT INTO `elm_states` VALUES (191,157,'on','','<button3_1><img src=\"/cms/scenes/imm/icon/lamp4_on.png\" alt=\"on\" width=\"50\" height=\"50\"></img><br/>\r\n %key.1%</button3_1>',1,0,'Switch1','status',1,'1','',0,0,0,'Switch1','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(190,157,'off','','<button3_1><img src=\"/cms/scenes/imm/icon/lamp4_off.png\" alt=\"off\" width=\"50\" height=\"50\"></img><br/>\r\n%key.1%</button3_1>',1,1,'Switch1','status',1,'0','',0,0,0,'Switch1','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(81,60,'fact','','<i class=\"fa fa-thermometer-empty\"></i> %ow_day3.temperature% °C<br/>\r\n<i class=\"fa fa-paper-plane-o\"></i> %ow_day3.wind_speed% км/ч <br/>\r\n<i class=\"fa fa-arrows\"></i> %ow_day3.wind_direction_my%<br/>\r\n<i class=\"fa fa-sort-amount-asc\"></i> %ow_day3.pressure_mmhg% ммрс<br/>\r\n<i class=\"fa fa-tint\"></i> %ow_day3.humidity% &#37;<br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(72,51,'выкл','','<button2>%key.9%</button2>',1,1,'Switch9','status',1,'0','',0,0,0,'Switch9','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(73,52,'default','','<button2>выкл.всё</button2>',0,1,'Switch4','status',1,'0','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(88,66,'выкл','','<button2>%key.12%</button2>',1,1,'Switch12','status',1,'0','',0,0,0,'Switch12','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(89,66,'вкл','','<button1>%key.12%</button1>',1,0,'Switch12','status',1,'1','',0,0,0,'Switch12','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(90,67,'вкл','','<button1>%key.14%</button1>',1,0,'Switch14','status',1,'1','',0,0,0,'Switch14','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(86,65,'вкл','','<button1>%key.13%</button1>',1,0,'Switch13','status',1,'1','',0,0,0,'Switch13','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(87,65,'выкл','','<button2>%key.13%</button2>',1,1,'Switch13','status',1,'0','',0,0,0,'Switch13','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(76,55,'fact','','<i class=\"fa fa-thermometer-empty\"></i> %ow_day1.temperature% °C<br/>\r\n<i class=\"fa fa-paper-plane-o\"></i> %ow_day1.wind_speed% км/ч <br/>\r\n<i class=\"fa fa-arrows\"></i> %ow_day1.wind_direction_my%<br/>\r\n<i class=\"fa fa-sort-amount-asc\"></i> %ow_day1.pressure_mmhg% ммрс<br/>\r\n<i class=\"fa fa-tint\"></i> %ow_day1.humidity% &#37;<br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(77,56,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_day1.image%.svg\" width=\"50pt\" height=\"37pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(78,57,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_day2.image%.svg\" width=\"50pt\" height=\"37pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(79,58,'fact','','<i class=\"fa fa-thermometer-empty\"></i> %ow_day2.temperature% °C<br/>\r\n<i class=\"fa fa-paper-plane-o\"></i> %ow_day2.wind_speed% км/ч <br/>\r\n<i class=\"fa fa-arrows\"></i> %ow_day2.wind_direction_my%<br/>\r\n<i class=\"fa fa-sort-amount-asc\"></i> %ow_day2.pressure_mmhg% ммрс<br/>\r\n<i class=\"fa fa-tint\"></i> %ow_day2.humidity% &#37;<br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(55,43,'вкл','','<button1>%key.2%</button1>',1,1,'Switch2','status',1,'1','',0,0,0,'Switch2','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(54,42,'выкл','','<button2>%key.4%</button2>',1,1,'Switch4','status',1,'0','',0,0,0,'Switch4','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(53,42,'вкл','','<button1>%key.4%</button1>',1,0,'Switch4','status',1,'1','',0,0,0,'Switch4','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(52,41,'выкл','','<button2>%key.1%</button2>',1,1,'Switch1','status',1,'0','',0,0,0,'Switch1','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(51,41,'вкл','','<button1>%key.1%</button1>',1,0,'Switch1','status',1,'1','',0,0,0,'Switch1','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(46,36,'default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(47,37,'Default','','<div class=\"panel-time\">\r\n    <div class=\"time\">    %ThisComputer.timeH%<span class=\"blnk\">:</span>%ThisComputer.timeM%</div>\r\n    <br/>\r\n    <div class=\"date\">%ThisComputer.Day%, %ThisComputer.Date%</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(50,40,'default','','<img height=\"12\" width=\"12\" src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">\r\n<img height=\"12\" width=\"12\" src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\"> \r\n<img height=\"12\" width=\"12\" src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(48,38,'default','','<div class=\"mainInfo\">\r\n      <img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\" width=\"50pt\" height=\"37pt\" />\r\n      <div class=\"temp\"><span class=\"value\">%ow_fact.temperature%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n    <div class=\"row\">\r\n      <div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_fact.wind_speed% км/ч</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_fact.wind_direction_my%</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_fact.humidity% &#37;</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_fact.pressure_mmhg% мм рт.ст.</span></div>\r\n    </div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(80,59,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_day3.image%.svg\" width=\"50pt\" height=\"37pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(69,50,'вкл','','<button1>%key.11%</button1>',1,0,'Switch11','status',1,'1','',0,0,0,'Switch11','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(70,50,'выкл','','<button2>%key.11%</button2>',1,1,'Switch11','status',1,'0','',0,0,0,'Switch11','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(71,51,'вкл','','<button1>%key.9%</button1>',1,0,'Switch9','status',1,'1','',0,0,0,'Switch9','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(68,49,'выкл','','<button2>%key.8%</button2>',1,1,'Switch8','status',1,'0','',0,0,0,'Switch8','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(63,47,'вкл','','<button1>%key.7%</button1>',1,0,'Switch7','status',1,'1','',0,0,0,'Switch7','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(64,47,'выкл','','<button2>%key.7%</button2>',1,1,'Switch7','status',1,'0','',0,0,0,'Switch7','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(65,48,'вкл','','<button1>%key.10%</button1>',1,0,'Switch10','status',1,'1','',0,0,0,'Switch10','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(66,48,'выкл','','<button2>%key.10%</button2>',1,1,'Switch10','status',1,'0','',0,0,0,'Switch10','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(67,49,'вкл','','<button1>%key.8%</button1>',1,0,'Switch8','status',1,'1','',0,0,0,'Switch8','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(58,44,'выкл','','<button2>%key.5%</button2>',1,1,'Switch5','status',1,'0','',0,0,0,'Switch5','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(59,45,'вкл','','<button1>%key.3%</button1>',1,0,'Switch3','status',1,'1','',0,0,0,'Switch3','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(60,45,'выкл','','<button2>%key.3%</button2>',1,1,'Switch3','status',1,'0','',0,0,0,'Switch3','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(61,46,'вкл','','<button1>%key.6%</button1>',1,0,'Switch6','status',1,'1','',0,0,0,'Switch6','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(62,46,'выкл','','<button2>%key.6%</button2>',1,1,'Switch6','status',1,'0','',0,0,0,'Switch6','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(56,43,'выкл','','<button2>%key.2%</button2>',1,0,'Switch2','status',1,'0','',0,0,0,'Switch2','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(57,44,'вкл','','<button1>%key.5%</button1>',1,0,'Switch5','status',1,'1','',0,0,0,'Switch5','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(82,61,'default','','Завтра',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(83,62,'default','','%ow_day2.date%',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(84,63,'default','','%ow_day3.date%',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(85,64,'Default','','<div class=\"panel-time\">\r\n<div class=\"time\">  <br/>  </div>\r\n\r\n   \r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(91,67,'выкл','','<button2>%key.14%</button2>',1,1,'Switch14','status',1,'0','',0,0,0,'Switch14','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(92,68,'выкл','','<button2>%key.15%</button2>',1,1,'Switch15','status',1,'0','',0,0,0,'Switch15','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(93,68,'вкл','','<button1>%key.15%</button1>',1,0,'Switch15','status',1,'1','',0,0,0,'Switch15','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(94,69,'вкл','','<button1>%key.16%</button1>',1,0,'Switch16','status',1,'1','',0,0,0,'Switch16','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(95,69,'выкл','','<button2>%key.16%</button2>',1,1,'Switch16','status',1,'0','',0,0,0,'Switch16','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(135,110,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_day2.image%.svg\" width=\"100pt\" height=\"75pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(136,111,'fact','','<tim6>&#9205 %ow_day2.temperature% °C</tim6><br/>\r\n<tim6>&#9207 %ow_day2.wind_speed% км/ч %ow_day2.wind_direction_my%</tim6><br/>\r\n<tim6>&#9206 %ow_day2.pressure_mmhg% мм рт.ст.</tim6><br/>\r\n<tim6>&#9201 %ow_day2.humidity% &#37;</tim6><br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(133,108,'fact','','<tim6>&#9205 %ow_day1.temperature% °C</tim6><br/>\r\n<tim6>&#9207 %ow_day1.wind_speed% км/ч %ow_day1.wind_direction_my%</tim6><br/>\r\n<tim6>&#9206 %ow_day1.pressure_mmhg% мм рт.ст.</tim6><br/>\r\n<tim6>&#9201 %ow_day1.humidity% &#37;</tim6><br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(134,109,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_day1.image%.svg\" width=\"100pt\" height=\"75pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(131,106,'fact','','<tim5>&#9207 %ow_fact.wind_speed% км/ч</tim5> <tim5>%ow_fact.wind_direction_my%</tim5><br/>\r\n<tim5>&#9206 %ow_fact.pressure_mmhg% мм рт.ст.</tim5><br/>\r\n<tim5>&#9201 %ow_fact.humidity% &#37;</tim5><br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(130,105,'day','','<tim4>%ThisComputer.Day%</tim4>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(129,104,'st1','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" width=\"16\" height=\"16\">\r\n<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" width=\"16\" height=\"16\">\r\n<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" width=\"16\" height=\"16\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(128,103,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" width=\"180pt\" height=\"135pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(127,102,'1','','<tim3>Сейчас: %ow_fact.weather_type%</tim3>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(126,101,'temp_day','','<tim>%ow_fact.temperature%</tim>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(125,100,'date','','<tim2>%ThisComputer.date%</tim2>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(124,99,'time','','    <div class=\"time\">%ThisComputer.timeH%<span class=\"blnk\">:</span>%ThisComputer.timeM%</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(111,85,'Default','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(112,86,'Default','','<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(113,87,'Default','','<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(114,88,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/18.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(115,89,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"map\" class=\"icon\"><i class=\"fa fa-globe\"></i><span class=\"title\">маршруты</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(116,90,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/13.html\';\">\r\n 	<div data-page=\"video\" class=\"icon\"><i class=\"fa fa-eye\"></i><span class=\"title\">ВИДЕО</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(117,91,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/14.html\';\">\r\n    <div data-page=\"chart\" class=\"icon\"><i class=\"fa fa-line-chart\"></i><span class=\"title\">диаграммы</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(118,92,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/16.html\';\">\r\n    <div data-page=\"settings\" class=\"icon\"><i class=\"fa fa-cogs\"></i><span class=\"title\">Настройки</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(119,93,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/19.html\';\">\r\n    <div data-page=\"control\" class=\"icon\"><i class=\"fa fa-hand-pointer-o\"></i><span class=\"title\">управление</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(120,94,'Default','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_1\">прихожая</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(121,95,'Default','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(122,96,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(123,97,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/21.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(137,112,'fact_img','','<img src=\"/cms/scenes/imm/image/p%ow_day3.image%.svg\" width=\"100pt\" height=\"75pt\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(138,113,'fact','','<tim6>&#9205 %ow_day3.temperature% °C</tim6><br/>\r\n<tim6>&#9207 %ow_day3.wind_speed% км/ч %ow_day3.wind_direction_my%</tim6><br/>\r\n<tim6>&#9206 %ow_day3.pressure_mmhg% мм рт.ст.</tim6><br/>\r\n<tim6>&#9201 %ow_day3.humidity% &#37;</tim6><br/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(187,154,'off','','<button1_1>%key.5%</button1_1>',1,0,'Switch5','status',1,'1','',0,0,0,'Switch5','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(188,154,'on','','<button1_2>%key.5%</button1_2>',1,1,'Switch5','status',1,'0','',0,0,0,'Switch5','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(141,116,'default','','<tim6>Завтра</tim6>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(142,117,'default','','<tim6>%ow_day2.date%</tim6>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(143,118,'default','','<tim6>%ow_day3.date%</tim6>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(145,120,'off','','<button1_1 width=\"100px.\" heidht=\"20px.\">%key.1%</button1_1>',1,0,'Switch1','status',1,'1','',0,0,0,'Switch1','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(146,120,'on','','<button1_2>%key.1%</button1_2>',1,1,'Switch1','status',1,'0','',0,0,0,'Switch1','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(189,156,'default','','<div class=\"panel-one\">\r\n </div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(147,121,'off','','<button1_1>%key.2%</button1_1>',1,1,'Switch2','status',1,'1','',0,0,0,'Switch2','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(148,121,'on','','<button1_2>%key.2%</button1_2>',1,0,'Switch2','status',1,'0','',0,0,0,'Switch2','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(149,122,'off','','<button1_1>%key.3%</button1_1>',1,0,'Switch3','status',1,'1','',0,0,0,'Switch3','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(150,122,'on','','<button1_2>%key.3%</button1_2>',1,1,'Switch3','status',1,'0','',0,0,0,'Switch3','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(151,123,'off','','<button1_1>%key.4%</button1_1>',1,0,'Switch4','status',1,'1','',0,0,0,'Switch4','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(152,123,'on','','<button1_2>%key.4%</button1_2>',1,1,'Switch4','status',1,'0','',0,0,0,'Switch4','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(186,153,'default','','<tim6>\r\nНачало сумерек: %ThisComputer.Chicivil_beginTime%<br/>\r\nВосход: %ThisComputer.SunRiseTime%<br/>\r\nЗаход: %ThisComputer.SunSetTime%<br/>\r\nКонец сумерек: %ThisComputer.civil_endTime%<br/>\r\nДолгота дня: %ThisComputer.LongTagTime%<br/>\r\nВ зените: %ThisComputer.TransitTime%<br/>\r\n</tim6>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(192,158,'on','','<button3_1><img src=\"/cms/scenes/imm/icon/switch-on.png\" alt=\"on\" width=\"50\" height=\"50\"></img><br/>\r\n %key.2%</button3_1>',1,1,'Switch2','status',1,'1','',0,0,0,'Switch2','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(193,158,'off','','<button3_1><img src=\"/cms/scenes/imm/icon/switch-off.png\" alt=\"off\" width=\"50\" height=\"50\"></img><br/>\r\n%key.2%</button3_1>',1,0,'Switch2','status',1,'0','',0,0,0,'Switch2','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(194,159,'on','','<button3_1><img src=\"/cms/scenes/imm/icon/switch-on.png\" alt=\"on\" width=\"50\" height=\"50\"></img><br/>\r\n %key.3%</button3_1>',1,0,'Switch3','status',1,'1','',0,0,0,'Switch3','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(195,159,'off','','<button3_1><img src=\"/cms/scenes/imm/icon/switch-off.png\" alt=\"off\" width=\"50\" height=\"50\"></img><br/>\r\n%key.3%</button3_1>',1,1,'Switch3','status',1,'0','',0,0,0,'Switch3','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(236,199,'Default','','<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(237,200,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/10.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(231,194,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(232,195,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(233,196,'Default','','<div class=\"panel-time\">\r\n    <div class=\"time\">%ThisComputer.timeH%<span class=\"blnk\">:</span>%ThisComputer.timeM%</div>\r\n <div style=\"font-size:14px;text-align:center;\">USD&nbsp;%cbr.USD%&nbsp;&nbsp;&nbsp;EURO&nbsp;%cbr.EURO%&nbsp;&nbsp;&nbsp;CZK&nbsp;%cbr.CZK%</div>\r\n    <div class=\"date\">%ThisComputer.Day%, %ThisComputer.Date%</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(234,197,'Default','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(235,198,'Default','','<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(229,192,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(230,193,'default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(228,191,'animation_default','','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(226,189,'Default','','<div class=\"panel-weather\">\r\n    <div class=\"location\">%ow_city.name%</div>\r\n    <img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\" />\r\n    <div class=\"temp-weather\">%ow_fact.temperature%<span class=\"degree\">&deg;C</span></div>\r\n    <div class=\"text-weather\">\r\n     <i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_fact.wind_speed% км/ч</span>\r\n     <i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_fact.wind_direction_my%</span>\r\n     <i class=\"fa fa-tint\"></i><span class=\"value\">%ow_fact.humidity% &#37;</span>\r\n     <i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_fact.pressure_mmhg% мм рт.ст.</span>\r\n	</div>\r\n\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(213,176,'Default','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(214,177,'Default','','<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(215,178,'Default','','<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(216,179,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/18.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(217,180,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"map\" class=\"icon\"><i class=\"fa fa-globe\"></i><span class=\"title\">маршруты</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(218,181,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/13.html\';\">\r\n 	<div data-page=\"video\" class=\"icon\"><i class=\"fa fa-eye\"></i><span class=\"title\">ВИДЕО</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(219,182,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/14.html\';\">\r\n    <div data-page=\"chart\" class=\"icon\"><i class=\"fa fa-line-chart\"></i><span class=\"title\">диаграммы</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(220,183,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/16.html\';\">\r\n    <div data-page=\"settings\" class=\"icon\"><i class=\"fa fa-cogs\"></i><span class=\"title\">Настройки</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(221,184,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/19.html\';\">\r\n    <div data-page=\"control\" class=\"icon\"><i class=\"fa fa-hand-pointer-o\"></i><span class=\"title\">управление</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(222,185,'Default','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_1\">прихожая</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(223,186,'Default','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(224,187,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(225,188,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/21.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(227,190,'Default','','[#module name=\"shoutbox\" limit=\"5\" reverse=\"1\" mobile=\"1\"#]',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(238,201,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"map\" class=\"icon\"><i class=\"fa fa-globe\"></i><span class=\"title\">маршруты</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(239,202,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/13.html\';\">\r\n 	<div data-page=\"video\" class=\"icon\"><i class=\"fa fa-eye\"></i><span class=\"title\">ВИДЕО</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(240,203,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/14.html\';\">\r\n    <div data-page=\"chart\" class=\"icon\"><i class=\"fa fa-line-chart\"></i><span class=\"title\">диаграммы</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(241,204,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"settings\" class=\"icon\"><i class=\"fa fa-cogs\"></i><span class=\"title\">Настройки</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(242,205,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/20.html\';\">\r\n    <div data-page=\"control\" class=\"icon\"><i class=\"fa fa-hand-pointer-o\"></i><span class=\"title\">управление</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(243,206,'Default','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_1\">прихожая</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(244,207,'Default','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(245,208,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(246,209,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/21.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(247,210,'Default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(248,211,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/9.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(249,212,'Default','','<div style=\"font-size:32px;text-align:center;\">Погода</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(250,213,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(251,214,'Default','',' <div class=\"panel-now\">\r\n    <div class=\"mainInfo\">\r\n      <img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\" />\r\n      <div class=\"temp\"><span class=\"value\">%ow_fact.temperature%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n    <div class=\"row\">\r\n      <div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_fact.wind_speed% км/ч</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_fact.wind_direction_my%</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_fact.humidity% &#37;</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_fact.pressure_mmhg% мм рт.ст.</span></div>\r\n    </div>\r\n  </div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(252,215,'Default','','<div class=\"panel-location\">\r\n 	<div class=\"icon\"><i class=\"fa fa-map-marker\"></i></div>\r\n    <div class=\"title\"> <span>%ow_city.name%</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(253,216,'Default','','<div class=\"panel-today\">\r\n    <div class=\"box\">\r\n      	<div class=\"title\">сегодня</div>\r\n    	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\" />\r\n      	<div class=\"temp\"><span class=\"value\">%ow_day0.temperature%<span class=\"degree\">&deg;C</span><span class=\"separator\">/</span>%ow_day0.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n      \r\n         <div class=\"row\">\r\n        	<div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_day0.wind_speed%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_day0.wind_direction_my%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_day0.humidity%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_day0.pressure_mmhg%</span></div>\r\n     	</div>\r\n	</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(254,217,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day0.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day0.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day0.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(255,218,'Default','','<div class=\"panel-today\">\r\n    <div class=\"box\">\r\n      	<div class=\"title\">завтра</div>\r\n    	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\" />\r\n      	<div class=\"temp\"><span class=\"value\">%ow_day1.temperature%<span class=\"degree\">&deg;C</span><span class=\"separator\">/</span>%ow_day1.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n      \r\n         <div class=\"row\">\r\n        	<div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_day1.wind_speed%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_day1.wind_direction_my%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_day1.humidity%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_day1.pressure_mmhg%</span></div>\r\n     	</div>\r\n	</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(256,219,'Default','','<div class=\"panel-today\">\r\n    <div class=\"box\">\r\n      	<div class=\"title\">послезавтра</div>\r\n    	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\" />\r\n      	<div class=\"temp\"><span class=\"value\">%ow_day2.temperature%<span class=\"degree\">&deg;C</span><span class=\"separator\">/</span>%ow_day2.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n      \r\n         <div class=\"row\">\r\n        	<div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_day2.wind_speed%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_day2.wind_direction_my%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_day2.humidity%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_day2.pressure_mmhg%</span></div>\r\n     	</div>\r\n	</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(257,220,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day1.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day1.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day1.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day1.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(258,221,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day2.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day2.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day2.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day2.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(259,222,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day3.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day3.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day3.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day3.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(260,223,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day4.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day4.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day4.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day4.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(261,224,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day5.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day5.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day5.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day5.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(262,225,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day6.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day6.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day6.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day6.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(263,226,'Default','','<img src=\"/pChart/?p=ow_fact.temperature&unit=°C&type=3d&width=350&title=Сейчас: %ow_fact.temperature%°C. График за: 3 дня&gcolor=red&gtype=curve&px=10\" \r\n     style=\"-moz-border-radius: 10px 0px 0px 10px; -webkit-border-radius: 10px; border-radius: 10px; opacity:0.8;\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(268,231,'Default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(266,229,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/9.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(267,230,'Default','','<div style=\"font-size:32px;text-align:center;\">Настройки</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(272,234,'default','','<iframe src=\"/menu.html?parent=136&from_scene=1\" frameBorder=\"0\" width=\"100%\"></iframe>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(282,241,'default','','<a href=\"/admin.php\"><img src=\"/cms/scenes/imm/icon/setting.png\" alt=\"\" width=\"200pt\" height=\"40pt\"/></a>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(277,236,'default','','<span class=\"toggle\">\r\n    <input type=\"checkbox\">\r\n    <label data-off=\"&#10006;\" data-on=\"&#10004;\"></label>\r\n</span>\r\n ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(283,242,'default','','<a href=\"https://orangepipc:10000\"><img src=\"/cms/scenes/imm/icon/webmin2.png\" alt=\"\" width=\"200pt\" height=\"40pt\"/></a>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(284,243,'default','','<a href=\"/phpmyadmin\"><img src=\"/cms/scenes/imm/icon/phpmyadmin.png\" alt=\"\" width=\"200pt\" height=\"40pt\"/></a>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(288,249,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(289,251,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(290,253,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(291,254,'default','','<div class=\"days day2\">\r\n <div class=\"d_name\">%ow_day2.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day2.image%.png\" alt=\"%ow_day2.weather_type%\" title=\"%ow_day2.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day2.weather_type%</div>\r\n <div class=\"max\">%ow_day2.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day2.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(292,255,'default','','<div class=\"days day3\">\r\n <div class=\"d_name\">%ow_day3.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day3.image%.png\" alt=\"%ow_day3.weather_type%\" title=\"%ow_day3.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day3.weather_type%</div>\r\n <div class=\"max\">%ow_day3.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day3.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(293,256,'default','','<div class=\"days day4\">\r\n <div class=\"d_name\">%ow_day4.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day4.image%.png\" alt=\"%ow_day4.weather_type%\" title=\"%ow_day4.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day4.weather_type%</div>\r\n <div class=\"max\">%ow_day4.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day4.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(294,257,'default','','<div class=\"days day1\">\r\n <div class=\"d_name\">%ow_day1.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day1.image%.png\" alt=\"%ow_day1.weather_type%\" title=\"%ow_day1.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day1.weather_type%</div>\r\n <div class=\"max\">%ow_day1.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day1.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(295,258,'default','','<div class=\"current_icons\">\r\n <div class =\"hum\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_1.png\"/>\r\n  <span class=\"title\">Влажность<br/>%ow_day0.humidity% %</span>\r\n </div>\r\n <div class =\"press\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_2.png\"/>\r\n  <span class=\"title\">Давление<br/>%ow_day0.pressure_mmhg% мм</span>\r\n </div>\r\n <div class =\"wind\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_3.png\"/><br/>\r\n  <span class=\"title\">Ветер</span>\r\n </div>\r\n <div class =\"vis\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_4.png\"/>\r\n  <span class=\"title\">Облачность<br/>%ow_day0.clouds% %</span>\r\n </div>\r\n <div class =\"preci\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_5.png\"/>\r\n  <span class=\"title\">Осадки<br/>%ow_day0.rain% мм</span>\r\n </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(296,259,'default','','<div class=\"panel-date\">\r\n    <div class=\"date\">%ThisComputer.DateD%</div>\r\n    <div class=\"day\">%ThisComputer.Day%</div>\r\n    <div class=\"month\">%ThisComputer.monthShrt%</div>\r\n     <div class=\"digitShade\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(297,260,'default','','<div class=\"current-block\">\r\n    <div class=\"temp\">%ow_day0.temperature%<span class=\"degree\">&deg;</span></div>\r\n    <img src=\"/cms/scenes/weather/icons/%ow_day0.image%.png\" alt=\"%ow_day0.weather_type%\" title=\"%ow_day0.weather_type%\"/>\r\n    <div class=\"weather-type\">%ow_day0.weather_type%</div>\r\n</div>\r\n<div class=\"current-temps\">\r\n <div class=\"max\"><span class=\"temp-diff\">Макс </span>%ow_day0.temp_max%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"min\"><span class=\"temp-diff\">Мин </span>%ow_day0.temp_min%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"day\"><span class=\"temp-diff\">Чувств.как </span>%ThisComputer.reelFeel%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(298,262,'default','','<div class=\"compass\">\r\n  <div class=\"direction\">\r\n  </div>\r\n  <div class=\"arrow ne\"></div>\r\n</div>\r\n<div class=\"current_wind\">\r\n <div class=\"speed\">%ow_day0.wind_speed%</div>\r\n <div class=\"kmh\">км/ч</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(299,263,'default','','<div class=\"panel-time\">\r\n    <div class=\"timeH\">%ThisComputer.timeHH%</div>\r\n    <div class=\"timeM\">%ThisComputer.timeM%</div>\r\n    <div class=\"digitShade\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(300,264,'default','/cms/scenes/weather/elements/weather_top_panel.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(301,265,'default','/cms/scenes/weather/elements/weather_mid_panel.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(302,267,'default','/cms/scenes/weather/elements/weather_low_panel.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(303,268,'default','','<div>\r\n <img src=\"/cms/scenes/weather/elements/direction.png\" class=\"rotate\"/>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(304,269,'Default','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(305,270,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(306,271,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/21.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(307,272,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(308,273,'default','','<div class=\"current_icons\">\r\n <div class =\"hum\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_1.png\"/>\r\n  <span class=\"title\">Влажность<br/>%ow_fact.humidity% %</span>\r\n </div>\r\n <div class =\"press\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_2.png\"/>\r\n  <span class=\"title\">Давление<br/>%ow_fact.pressure_mmhg% мм</span>\r\n </div>\r\n <div class =\"wind\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_3.png\"/><br/>\r\n  <span class=\"title\"></span>\r\n </div>\r\n <div class =\"vis\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_4.png\"/>\r\n  <span class=\"title\">Облачность<br/>%ow_fact.clouds% %</span>\r\n </div>\r\n <div class =\"preci\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_5.png\"/>\r\n  <span class=\"title\">Осадки<br/>%ow_day0.rain% мм</span>\r\n </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(309,274,'default','','<div class=\"days day2\">\r\n <div class=\"d_name\">%ow_day2.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day2.image%.png\" alt=\"%ow_day2.weather_type%\" title=\"%ow_day2.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day2.weather_type%</div>\r\n <div class=\"max\">%ow_day2.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day2.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(310,275,'default','','<div class=\"days day3\">\r\n <div class=\"d_name\">%ow_day3.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day3.image%.png\" alt=\"%ow_day3.weather_type%\" title=\"%ow_day3.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day3.weather_type%</div>\r\n <div class=\"max\">%ow_day3.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day3.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(311,276,'default','','<div class=\"days day4\">\r\n <div class=\"d_name\">%ow_day4.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day4.image%.png\" alt=\"%ow_day4.weather_type%\" title=\"%ow_day4.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day4.weather_type%</div>\r\n <div class=\"max\">%ow_day4.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day4.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(312,277,'default','','<div class=\"current-block\">\r\n    <div class=\"temp\">%ow_fact.temperature%<span class=\"degree\">&deg;</span></div>\r\n    <img src=\"/cms/scenes/weather/icons/%ow_fact.image%.png\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\"/>\r\n    <div class=\"weather-type\">%ow_fact.weather_type%</div>\r\n</div>\r\n<div class=\"current-temps\">\r\n <div class=\"max\"><span class=\"temp-diff\">Макс </span>%ow_day0.temp_max%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"min\"><span class=\"temp-diff\">Мин </span>%ow_day0.temp_min%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"day\"><span class=\"temp-diff\">Чувствуется как: </span>%ow_fact.reelFeel%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(313,278,'default','','<div class=\"days day1\">\r\n <div class=\"d_name\">%ow_day1.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day1.image%.png\" alt=\"%ow_day1.weather_type%\" title=\"%ow_day1.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day1.weather_type%</div>\r\n <div class=\"max\">%ow_day1.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day1.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(314,279,'def','','<div>\r\n <img src=\"/cms/scenes/weather/elements/direction2.png\" class=\"rotate\"/>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(315,280,'default','','<div class=\"current_wind\">\r\n <div class=\"speed\">%ow_day0.wind_speed%</div>\r\n <div class=\"kmh\">км/ч</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(316,282,'def','','<div class=\"days day1\">\r\n <div class=\"d_name\">%ow_day1.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day1.image%.png\" alt=\"%ow_day1.weather_type%\" title=\"%ow_day1.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day1.weather_type%</div>\r\n <div class=\"titl-max\">макс:</div>\r\n <div class=\"max\">%ow_day1.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"titl-min\">мин:</div>\r\n <div class=\"min\">%ow_day1.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(317,283,'def','','<div class=\"days day2\">\r\n <div class=\"d_name\">%ow_day2.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day2.image%.png\" alt=\"%ow_day2.weather_type%\" title=\"%ow_day2.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day2.weather_type%</div>\r\n <div class=\"titl-max\">макс:</div>\r\n <div class=\"max\">%ow_day2.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"titl-min\">мин:</div>\r\n <div class=\"min\">%ow_day2.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(318,284,'def','','<div class=\"days day3\">\r\n <div class=\"d_name\">%ow_day3.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day3.image%.png\" alt=\"%ow_day3.weather_type%\" title=\"%ow_day3.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day3.weather_type%</div>\r\n <div class=\"titl-max\">макс:</div>\r\n <div class=\"max\">%ow_day3.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"titl-min\">мин:</div>\r\n <div class=\"min\">%ow_day3.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(319,285,'def','','<div class=\"days day4\">\r\n <div class=\"d_name\">%ow_day4.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day4.image%.png\" alt=\"%ow_day4.weather_type%\" title=\"%ow_day4.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day4.weather_type%</div>\r\n <div class=\"titl-max\">макс:</div>\r\n <div class=\"max\">%ow_day4.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"titl-min\">мин:</div>\r\n <div class=\"min\">%ow_day4.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(320,286,'def','','<div class=\"days day5\">\r\n <div class=\"d_name\">%ow_day5.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day5.image%.png\" alt=\"%ow_day5.weather_type%\" title=\"%ow_day5.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day5.weather_type%</div>\r\n <div class=\"titl-max\">макс:</div>\r\n <div class=\"max\">%ow_day5.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"titl-min\">мин:</div>\r\n <div class=\"min\">%ow_day5.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(385,338,'default','','<img src=\"/cms/scenes/weather/bg/weatherBg_%ow_day0.image%.jpg\" alt=\"\" width=\"360\" height=\"560\"/>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(386,340,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(387,342,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(403,359,'default','','<img src=\"/cms/scenes/weather/elements/weather_mid_panel.png\" alt=\"\" width=\"309\" height=\"238\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(389,344,'default','','<div class=\"days day2\">\r\n <div class=\"d_name\">%ow_day2.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day2.image%.png\" alt=\"%ow_day2.weather_type%\" title=\"%ow_day2.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day2.weather_type%</div>\r\n <div class=\"max\">%ow_day2.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day2.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(390,345,'default','','<div class=\"days day3\">\r\n <div class=\"d_name\">%ow_day3.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day3.image%.png\" alt=\"%ow_day3.weather_type%\" title=\"%ow_day3.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day3.weather_type%</div>\r\n <div class=\"max\">%ow_day3.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day3.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(391,346,'default','','<div class=\"days day4\">\r\n <div class=\"d_name\">%ow_day4.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day4.image%.png\" alt=\"%ow_day4.weather_type%\" title=\"%ow_day4.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day4.weather_type%</div>\r\n <div class=\"max\">%ow_day4.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day4.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(404,360,'default','','<img src=\"/cms/scenes/weather/elements/weather_low_panel.png\" alt=\"\" width=\"309\" height=\"181\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(381,334,'default','','<div class=\"panel-time\">\r\n    <div class=\"timeH\">%ThisComputer.timeHH%</div>\r\n    <div class=\"timeM\">%ThisComputer.timeM%</div>\r\n    <div class=\"digitShade\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(380,333,'default','','<div class=\"compass\">\r\n  <div class=\"direction\">\r\n  </div>\r\n  <div class=\"arrow ne\"></div>\r\n</div>\r\n<div class=\"current_wind\">\r\n <div class=\"speed\">%ow_day0.wind_speed%</div>\r\n <div class=\"kmh\">км/ч</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(379,331,'default','','<div class=\"current-block\">\r\n    <div class=\"temp\">%ow_day0.temperature%<span class=\"degree\">&deg;</span></div>\r\n    <img src=\"/cms/scenes/weather/icons/%ow_day0.image%.png\" alt=\"%ow_day0.weather_type%\" title=\"%ow_day0.weather_type%\"/>\r\n    <div class=\"weather-type\">%ow_day0.weather_type%</div>\r\n</div>\r\n<div class=\"current-temps\">\r\n <div class=\"max\"><span class=\"temp-diff\">Макс </span>%ow_day0.temp_max%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"min\"><span class=\"temp-diff\">Мин </span>%ow_day0.temp_min%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"day\"><span class=\"temp-diff\">Чувств.как </span>%ThisComputer.reelFeel%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(377,329,'default','','<div class=\"current_icons\">\r\n <div class =\"hum\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_1.png\"/>\r\n  <span class=\"title\">Влажность<br/>%ow_day0.humidity% %</span>\r\n </div>\r\n <div class =\"press\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_2.png\"/>\r\n  <span class=\"title\">Давление<br/>%ow_day0.pressure_mmhg% мм</span>\r\n </div>\r\n <div class =\"wind\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_3.png\"/><br/>\r\n  <span class=\"title\">Ветер</span>\r\n </div>\r\n <div class =\"vis\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_4.png\"/>\r\n  <span class=\"title\">Облачность<br/>%ow_day0.clouds% %</span>\r\n </div>\r\n <div class =\"preci\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_5.png\"/>\r\n  <span class=\"title\">Осадки<br/>%ow_day0.rain% мм</span>\r\n </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(378,330,'default','','<div class=\"panel-date\">\r\n    <div class=\"date\">%ThisComputer.DateD%</div>\r\n    <div class=\"day\">%ThisComputer.Day%</div>\r\n    <div class=\"month\">%ThisComputer.monthShrt%</div>\r\n     <div class=\"digitShade\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(372,324,'default','','<div class=\"days day2\">\r\n <div class=\"d_name\">%ow_day2.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day2.image%.png\" alt=\"%ow_day2.weather_type%\" title=\"%ow_day2.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day2.weather_type%</div>\r\n <div class=\"max\">%ow_day2.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day2.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(373,325,'default','','<div class=\"days day3\">\r\n <div class=\"d_name\">%ow_day3.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day3.image%.png\" alt=\"%ow_day3.weather_type%\" title=\"%ow_day3.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day3.weather_type%</div>\r\n <div class=\"max\">%ow_day3.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day3.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(374,326,'default','','<div class=\"days day4\">\r\n <div class=\"d_name\">%ow_day4.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day4.image%.png\" alt=\"%ow_day4.weather_type%\" title=\"%ow_day4.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day4.weather_type%</div>\r\n <div class=\"max\">%ow_day4.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day4.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(375,327,'default','','<div class=\"days day1\">\r\n <div class=\"d_name\">%ow_day1.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day1.image%.png\" alt=\"%ow_day1.weather_type%\" title=\"%ow_day1.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day1.weather_type%</div>\r\n <div class=\"max\">%ow_day1.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day1.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(383,336,'default','','<div>\r\n <img src=\"/cms/scenes/weather/elements/direction3.png\" class=\"rotate\"/>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(405,361,'default','','\r\n<img src=\"/cms/scenes/weather/elements/weather_low_panel.png\" alt=\"\" width=\"309\" height=\"181\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(392,347,'default','','<div class=\"days day1\">\r\n <div class=\"d_name\">%ow_day1.name%</div>\r\n <img src=\"/cms/scenes/weather/icons/%ow_day1.image%.png\" alt=\"%ow_day1.weather_type%\" title=\"%ow_day1.weather_type%\"/>\r\n <div class=\"weather-type\">%ow_day1.weather_type%</div>\r\n <div class=\"max\">%ow_day1.temp_max%<span class=\"degree\">&deg;</span></div>\r\n <div class=\"min\">%ow_day1.temp_min%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(394,349,'default','','<div class=\"current_icons\">\r\n <div class =\"hum\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_1.png\"/>\r\n  <span class=\"title\">Влажность<br/>%ow_day0.humidity% %</span>\r\n </div>\r\n <div class =\"press\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_2.png\"/>\r\n  <span class=\"title\">Давление<br/>%ow_day0.pressure_mmhg% мм</span>\r\n </div>\r\n <div class =\"wind\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_3.png\"/><br/>\r\n  <span class=\"title\">Ветер</span>\r\n </div>\r\n <div class =\"vis\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_4.png\"/>\r\n  <span class=\"title\">Облачность<br/>%ow_day0.clouds% %</span>\r\n </div>\r\n <div class =\"preci\">\r\n    <img src=\"/cms/scenes/weather/icons/icon_5.png\"/>\r\n  <span class=\"title\">Осадки<br/>%ow_day0.rain% мм</span>\r\n </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(395,350,'default','','<div class=\"panel-date\">\r\n    <div class=\"date\">%ThisComputer.DateD%</div>\r\n    <div class=\"day\">%ThisComputer.Day%</div>\r\n    <div class=\"month\">%ThisComputer.monthShrt%</div>\r\n     <div class=\"digitShade\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(396,351,'default','','<div class=\"current-block\">\r\n    <div class=\"temp\">%ow_day0.temperature%<span class=\"degree\">&deg;</span></div>\r\n    <img src=\"/cms/scenes/weather/icons/%ow_day0.image%.png\" alt=\"%ow_day0.weather_type%\" title=\"%ow_day0.weather_type%\"/>\r\n    <div class=\"weather-type\">%ow_day0.weather_type%</div>\r\n</div>\r\n<div class=\"current-temps\">\r\n <div class=\"max\"><span class=\"temp-diff\">Макс </span>%ow_day0.temp_max%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"min\"><span class=\"temp-diff\">Мин </span>%ow_day0.temp_min%<span class=\"degree\">&deg;</span></div>\r\n    <div class=\"day\"><span class=\"temp-diff\">Чувств.как </span>%ThisComputer.reelFeel%<span class=\"degree\">&deg;</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(397,353,'default','','<div class=\"compass\">\r\n  <div class=\"direction\">\r\n  </div>\r\n  <div class=\"arrow ne\"></div>\r\n</div>\r\n<div class=\"current_wind\">\r\n <div class=\"speed\">%ow_day0.wind_speed%</div>\r\n <div class=\"kmh\">км/ч</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(398,354,'default','','<div class=\"panel-time\">\r\n    <div class=\"timeH\">%ThisComputer.timeHH%</div>\r\n    <div class=\"timeM\">%ThisComputer.timeM%</div>\r\n    <div class=\"digitShade\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(400,356,'default','','<div>\r\n <img src=\"/cms/scenes/weather/elements/direction3.png\" class=\"rotate\"/>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(401,357,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(402,358,'default','','<img src=\"/cms/scenes/weather/elements/weather_top_panel.png\" alt=\"\" width=\"360\" height=\"39\"/>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(406,362,'1','',' <div class=\"time_t\" style=\"font-size:180px\">%ThisComputer.timeNow%</div>',0,1,'','',1,'1','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(407,362,'2','','<div class=\"mess\" style=\"font-size:80px\">%pogStation.mess%</div>',1,0,'pogStation','show',1,'2','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(408,363,'1','/cms/scenes/elements/Temperatura2.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(409,364,'1','/cms/scenes/elements/vlajn.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(410,365,'1','','<div class=\"temp_t\" style=\"font-size:48px\">%ow_fact.temperature%&degc</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(411,366,'1','',' <div class=\"temp_t\" style=\"font-size:48px\">%ow_fact.humidity%&#37;</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(412,367,'1','/cms/scenes/elements/davl.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(413,368,'1','',' <div class=\"temp_t\" style=\"font-size:48px\">%ow_fact.pressure_mmhg%</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(414,369,'1','/cms/scenes/elements/home_w2.png','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(415,370,'1','','<div class=\"temp_t\" style=\"font-size:48px\">%rx22.temp%&degC</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(416,371,'1','','<img  src=\"/cms/scenes/elements/%ow_fact.image%.png\" border=\"0\"><br>\r\n <center>сейчас</center> ',0,1,'','',1,'1','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(417,371,'2','','<img src=\"/cms/scenes/elements/%ow_day6.image%.png\" border=\"0\">\r\n  <center>завтра</center> ',1,0,'pogStation','uslovia',1,'2','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(419,374,'default','','<script src=\"/js/gaugeMeter.js\"></script>\r\n<script>$(\".GaugeMeter\").gaugeMeter();</script>\r\n<div class=\"GCont\">\r\n<div class=\"GaugeMeter\" id=\"test\" data-total=\"100\" data-used=\"%ow_fact.humidity%\"\r\n     data-text=\"<font style=\'color:White;size:12px\'>%ow_fact.humidity%</font>\"\r\n     data-append=\"<font style=\'color:white\'>%</font>\" data-prepend=\"<font style=\'color:white\'></font>\"\r\n     data-size=\"50\" data-theme=\"White\" data-back=\"RGBa(255,255,255,.2)\" data-width=\"5\" data-label=\"влажность\"\r\n     data-label_color=\"#FFF\" data-stripe=\"2\"></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(421,376,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/21.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(422,377,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(443,398,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch1','status',1,'0','',0,0,0,'Switch1','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(444,398,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch1','status',1,'1','',0,0,0,'Switch1','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(445,399,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,0,'Switch2','status',1,'0','',0,0,0,'Switch2','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(426,381,'Default','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(427,382,'Default','','<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(428,383,'Default','','<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(429,384,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/10.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(430,385,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"map\" class=\"icon\"><i class=\"fa fa-globe\"></i><span class=\"title\">маршруты</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(431,386,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/13.html\';\">\r\n 	<div data-page=\"video\" class=\"icon\"><i class=\"fa fa-eye\"></i><span class=\"title\">ВИДЕО</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(432,387,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/14.html\';\">\r\n    <div data-page=\"chart\" class=\"icon\"><i class=\"fa fa-line-chart\"></i><span class=\"title\">диаграммы</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(433,388,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"settings\" class=\"icon\"><i class=\"fa fa-cogs\"></i><span class=\"title\">Настройки</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(434,389,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/7.html\';\">\r\n    <div data-page=\"control\" class=\"icon\"><i class=\"fa fa-hand-pointer-o\"></i><span class=\"title\">управление</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(435,390,'Default','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_1\">прихожая</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(436,391,'Default','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(438,393,'default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(446,399,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,1,'Switch2','status',1,'1','',0,0,0,'Switch2','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(447,400,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/23.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(448,401,'Default','','<div style=\"font-size:32px;text-align:center;\">Управление</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(449,402,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch3','status',1,'0','',0,0,0,'Switch3','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(442,397,'default','','<img src=\"/cms/scenes/backgrounds/0084.png\" width=\"1100\" height=\"640\" alt=\"\" />',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(441,396,'animation_default','','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(450,402,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch3','status',1,'1','',0,0,0,'Switch3','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(451,403,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch4','status',1,'0','',0,0,0,'Switch4','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(452,403,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch4','status',1,'1','',0,0,0,'Switch4','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(488,432,'Default','','<img src=\"/pChart/?p=TempSensor2.temp1&unit=°C&type=4h&width=275&title=t°C на 1-м этаже за 4 часа&gcolor=red&gtype=curve&px=10\" id=\"graf1\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(489,433,'Default','','<img src=\"/pChart/?p=ESP8266009f5c09.dhth1&unit=%&type=6h&width=275&title=влажность на 1-м эт. за 4 часа&gcolor=green&gtype=curve&px=10\" id=\"graf2\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(490,434,'Default','','<div style=\"font-size:22px;text-align:center;\">Погода на улице</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(491,435,'Default','','<img src=\"/pChart/?p=ThisComputer.TempOutside&unit=°C&type=3d&width=275&title=На улице: %TempOutside%°C&gcolor=blue&gtype=curve&px=10\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(492,436,'Default','','<img src=\"/pChart/?p=ESP8266009f5c09.bmpp&unit=мм&type=3d&width=275&title=Атм.давление: %ESP8266009f5c09.bmpp% мм рт.ст.&gcolor=orange&gtype=curve&px=10\">\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(493,437,'Default','','<div class=\"container\">\r\n  <span class=\"label-text\">Температура дома</span>\r\n  <div class=\"pie-wrapper\">\r\n   \r\n     <div class=\"arc\" data-value=\"%TempSensor2.tempRoundProc%\"></div>\r\n   \r\n     <span class=\"score\">%TempSensor2.temp1%°C</span>\r\n  </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(469,417,'Default','','%TodoList.StreamingCodeScene%\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(468,416,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(467,415,'Default','','<div style=\"font-size:32px;text-align:center;\">Список выполнения задач</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(466,414,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/9.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(486,430,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(487,431,'Default','','<div style=\"font-size:22px;text-align:center;\">Климат в доме</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(485,429,'Default','','<div style=\"font-size:32px;text-align:center;\">Диаграммы</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(483,427,'Default','','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(484,428,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/10.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(494,438,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/25.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(515,459,'Default','','<div class=\"panel-showing4\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Список дел (to do)</div>\r\n        <div class=\"sense_snowing_1\" onclick=\"location.href = \'/popup/scenes/21.html\';\">открыть</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,200,56,500,500,0,'',0,'',0,'',''),(496,440,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(497,441,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(498,442,'Default','','<div class=\"panel-time\">\r\n    <div class=\"time\">%ThisComputer.timeH%<span class=\"blnk\">:</span>%ThisComputer.timeM%</div>\r\n <div style=\"font-size:14px;text-align:center;\">USD&nbsp;%cbr.USD%&nbsp;&nbsp;&nbsp;EURO&nbsp;%cbr.EURO%&nbsp;&nbsp;&nbsp;CZK&nbsp;%cbr.CZK%</div>\r\n    <div class=\"date\">%ThisComputer.Day%, %ThisComputer.Date%</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(541,452,'on','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Режим охраны</div>\r\n        <div class=\"sense_snowing_3\">вкл</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',1,0,'ThisComputer','securityMode',1,'1','',33,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(540,484,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(502,446,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/26.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(503,447,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"map\" class=\"icon\"><i class=\"fa fa-globe\"></i><span class=\"title\">маршруты</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(504,448,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/13.html\';\">\r\n 	<div data-page=\"video\" class=\"icon\"><i class=\"fa fa-eye\"></i><span class=\"title\">ВИДЕО</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(505,449,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/14.html\';\">\r\n    <div data-page=\"chart\" class=\"icon\"><i class=\"fa fa-line-chart\"></i><span class=\"title\">диаграммы</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(506,450,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/27.html\';\">\r\n    <div data-page=\"settings\" class=\"icon\"><i class=\"fa fa-cogs\"></i><span class=\"title\">Настройки</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(507,451,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/20.html\';\">\r\n    <div data-page=\"control\" class=\"icon\"><i class=\"fa fa-hand-pointer-o\"></i><span class=\"title\">управление</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(508,452,'off','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Режим охраны</div>\r\n        <div class=\"sense_snowing_1\">выкл</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',1,1,'ThisComputer','securityMode',1,'0','',33,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(509,453,'off','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Энергосбережение</div>\r\n        <div class=\"sense_snowing_1\">выкл</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',1,1,'ThisComputer','Econom',1,'0','',34,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(511,455,'default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(512,456,'Default','','<div class=\"panel-weather\">\r\n    <div class=\"location\">%ow_city.name%</div>\r\n    <img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\" />\r\n    <div class=\"temp-weather\">%ow_fact.temperature%<span class=\"degree\">&deg;C</span></div>\r\n    <div class=\"text-weather\">\r\n     <i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_fact.wind_speed% км/ч</span>\r\n     <i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_fact.wind_direction_my%</span>\r\n     <i class=\"fa fa-tint\"></i><span class=\"value\">%ow_fact.humidity% &#37;</span>\r\n     <i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_fact.pressure_mmhg% мм рт.ст.</span>\r\n	</div>\r\n\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(513,457,'Default','','[#module name=\"shoutbox\" limit=\"10\" reverse=\"1\" mobile=\"1\"#]',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(514,458,'animation_default','','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(516,460,'Default','','<div class=\"panel-showing3\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(517,461,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(518,462,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(519,463,'Default','','<div class=\"panel-time\">\r\n    <div class=\"time\">%ThisComputer.timeH%<span class=\"blnk\">:</span>%ThisComputer.timeM%</div>\r\n <div style=\"font-size:14px;text-align:center;\">USD&nbsp;%cbr.USD%&nbsp;&nbsp;&nbsp;EURO&nbsp;%cbr.EURO%&nbsp;&nbsp;&nbsp;CZK&nbsp;%cbr.CZK%</div>\r\n    <div class=\"date\">%ThisComputer.Day%, %ThisComputer.Date%</div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(520,464,'Default','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(521,465,'Default','','<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(522,466,'Default','','<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(523,467,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/10.html\';\">\r\n    <div data-page=\"weather\" class=\"icon\"><i class=\"fa fa-sun-o\"></i><span class=\"title\">погода</span></div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(524,468,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"map\" class=\"icon\"><i class=\"fa fa-globe\"></i><span class=\"title\">маршруты</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(525,469,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/13.html\';\">\r\n 	<div data-page=\"video\" class=\"icon\"><i class=\"fa fa-eye\"></i><span class=\"title\">ВИДЕО</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(526,470,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/14.html\';\">\r\n    <div data-page=\"chart\" class=\"icon\"><i class=\"fa fa-line-chart\"></i><span class=\"title\">диаграммы</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(527,471,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/11.html\';\">\r\n    <div data-page=\"settings\" class=\"icon\"><i class=\"fa fa-cogs\"></i><span class=\"title\">Настройки</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(528,472,'Default','','<div class=\"panel-functions\" onclick=\"location.href = \'/popup/scenes/20.html\';\">\r\n    <div data-page=\"control\" class=\"icon\"><i class=\"fa fa-hand-pointer-o\"></i><span class=\"title\">управление</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(529,473,'Default','','<div class=\"panel-showing1\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_1\">прихожая</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(530,474,'Default','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Нет функции</div>\r\n        <div class=\"sense_snowing_0\">нет</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(531,475,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(532,476,'default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(533,477,'Default','','<div class=\"panel-weather\">\r\n    <div class=\"location\">%ow_city.name%</div>\r\n    <img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\" />\r\n    <div class=\"temp-weather\">%ow_fact.temperature%<span class=\"degree\">&deg;C</span></div>\r\n    <div class=\"text-weather\">\r\n     <i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_fact.wind_speed% км/ч</span>\r\n     <i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_fact.wind_direction_my%</span>\r\n     <i class=\"fa fa-tint\"></i><span class=\"value\">%ow_fact.humidity% &#37;</span>\r\n     <i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_fact.pressure_mmhg% мм рт.ст.</span>\r\n	</div>\r\n\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(534,478,'Default','','[#module name=\"shoutbox\" limit=\"5\" reverse=\"1\" mobile=\"1\"#]',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(535,479,'animation_default','','',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(536,480,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(537,481,'Default','','<img src=\"/img/icons/status/lock_32_%Security.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(538,482,'Default','','<img src=\"/img/icons/status/system_32_%System.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(539,483,'Default','','<img src=\"/img/icons/status/network_32_%Communication.stateColor%.png\" align=\"absmiddle\">',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(542,453,'on','','<div class=\"panel-showing2\">\r\n    <ul>\r\n      <li>\r\n        <div class=\"title\">Энергосбережение</div>\r\n        <div class=\"sense_snowing_4\">вкл</div>\r\n      </li>\r\n    </ul>\r\n</div>\r\n',1,0,'ThisComputer','Econom',1,'1','',34,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(543,485,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/23.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(544,486,'Default','','<div style=\"font-size:32px;text-align:center;\">Список выполнения задач</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(545,487,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(546,488,'Default','','%TodoList.StreamingCodeScene%\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(547,490,'Default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(548,491,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/23.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(549,492,'Default','','<div style=\"font-size:32px;text-align:center;\">Погода</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(550,493,'','','',0,1,'','',0,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(551,494,'Default','',' <div class=\"panel-now\">\r\n    <div class=\"mainInfo\">\r\n      <img src=\"/cms/scenes/imm/image/p%ow_fact.image%.svg\" alt=\"%ow_fact.weather_type%\" title=\"%ow_fact.weather_type%\" />\r\n      <div class=\"temp\"><span class=\"value\">%ow_fact.temperature%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n    <div class=\"row\">\r\n      <div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_fact.wind_speed% км/ч</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_fact.wind_direction_my%</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_fact.humidity% &#37;</span></div>\r\n      <div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_fact.pressure_mmhg% мм рт.ст.</span></div>\r\n    </div>\r\n  </div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(552,495,'Default','','<div class=\"panel-location\">\r\n 	<div class=\"icon\"><i class=\"fa fa-map-marker\"></i></div>\r\n    <div class=\"title\"> <span>%ow_city.name%</span></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(553,496,'Default','','<div class=\"panel-today\">\r\n    <div class=\"box\">\r\n      	<div class=\"title\">сегодня</div>\r\n    	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\" />\r\n      	<div class=\"temp\"><span class=\"value\">%ow_day0.temperature%<span class=\"degree\">&deg;C</span><span class=\"separator\">/</span>%ow_day0.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n      \r\n         <div class=\"row\">\r\n        	<div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_day0.wind_speed%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_day0.wind_direction_my%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_day0.humidity%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_day0.pressure_mmhg%</span></div>\r\n     	</div>\r\n	</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(554,497,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day0.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day0.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day0.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(555,498,'Default','','<div class=\"panel-today\">\r\n    <div class=\"box\">\r\n      	<div class=\"title\">завтра</div>\r\n    	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\" />\r\n      	<div class=\"temp\"><span class=\"value\">%ow_day1.temperature%<span class=\"degree\">&deg;C</span><span class=\"separator\">/</span>%ow_day1.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n      \r\n         <div class=\"row\">\r\n        	<div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_day1.wind_speed%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_day1.wind_direction_my%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_day1.humidity%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_day1.pressure_mmhg%</span></div>\r\n     	</div>\r\n	</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(556,499,'Default','','<div class=\"panel-today\">\r\n    <div class=\"box\">\r\n      	<div class=\"title\">послезавтра</div>\r\n    	<img src=\"/cms/scenes/imm/image/p%ow_day0.image%.svg\" />\r\n      	<div class=\"temp\"><span class=\"value\">%ow_day2.temperature%<span class=\"degree\">&deg;C</span><span class=\"separator\">/</span>%ow_day2.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n      \r\n         <div class=\"row\">\r\n        	<div class=\"info\"><i class=\"fa fa-paper-plane-o\"></i><span class=\"value\">%ow_day2.wind_speed%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-arrows\"></i><span class=\"value\">%ow_day2.wind_direction_my%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-tint\"></i><span class=\"value\">%ow_day2.humidity%</span></div>\r\n        	<div class=\"info\"><i class=\"fa fa-sort-amount-asc\"></i><span class=\"value\">%ow_day2.pressure_mmhg%</span></div>\r\n     	</div>\r\n	</div>\r\n</div>\r\n',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(557,500,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day1.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day1.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day1.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day1.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(558,501,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day2.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day2.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day2.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day2.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(559,502,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day3.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day3.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day3.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day3.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(560,503,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day4.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day4.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day4.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day4.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(561,504,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day5.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day5.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day5.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day5.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(562,505,'Default','','<div class=\"panel-forecast\">\r\n    <div class=\"box\">\r\n      <div class=\"title\">%ow_day6.date%</div>\r\n      	<img src=\"/cms/scenes/imm/image/p%ow_day6.image%.svg\"/>\r\n      <div class=\"temp\"><span class=\"value\">%ow_day6.temperature%<span class=\"degree\">&deg;C</span></span><span class=\"separator\">/</span><span class=\"value\">%ow_day6.temp_night%<span class=\"degree\">&deg;C</span></span></div>\r\n    </div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(563,506,'Default','','<img src=\"/pChart/?p=ow_fact.temperature&unit=°C&type=3d&width=350&title=Сейчас: %ow_fact.temperature%°C. График за: 3 дня&gcolor=red&gtype=curve&px=10\" \r\n     style=\"-moz-border-radius: 10px 0px 0px 10px; -webkit-border-radius: 10px; border-radius: 10px; opacity:0.8;\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(564,507,'Default','','<img src=\"/pChart/?p=ow_fact.temperature&unit=°C&type=7d&width=350&title=Температура за 7 днeй&gcolor=red&gtype=curve&px=10\" \r\n     style=\"-moz-border-radius: 10px 0px 0px 10px; -webkit-border-radius: 10px; border-radius: 10px; opacity:0.8;\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(565,508,'Default','','<img src=\"/pChart/?p=ow_fact.humidity&unit=%&type=7d&width=350&title=Влажность за 7 днeй&gcolor=red&gtype=curve&px=10\" \r\n     style=\"-moz-border-radius: 10px 0px 0px 10px; -webkit-border-radius: 10px; border-radius: 10px; opacity:0.8;\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(566,509,'Default','','<img src=\"/pChart/?p=ow_fact.pressure_mmhg&unit=мм.рт.ст.&type=7d&width=350&title=Давление за 7 днeй&gcolor=red&gtype=curve&px=10\" \r\n     style=\"-moz-border-radius: 10px 0px 0px 10px; -webkit-border-radius: 10px; border-radius: 10px; opacity:0.8;\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(567,510,'Default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(574,517,'Default','','<link rel=\"stylesheet\" href=\"/cms/scenes/css/awesome/font-awesome.min.css\"> ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(569,512,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/23.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(570,513,'Default','','<div style=\"font-size:32px;text-align:center;\">Настройки</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(571,514,'default','','<a href=\"/admin.php\"><img src=\"/cms/scenes/imm/icon/setting.png\" alt=\"\" width=\"200pt\" height=\"40pt\"/></a>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(572,515,'default','','<a href=\"https://orangepipc:10000\"><img src=\"/cms/scenes/imm/icon/webmin2.png\" alt=\"\" width=\"200pt\" height=\"40pt\"/></a>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(573,516,'default','','<a href=\"/phpmyadmin\"><img src=\"/cms/scenes/imm/icon/phpmyadmin.png\" alt=\"\" width=\"200pt\" height=\"40pt\"/></a>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(575,518,'Default','','<div class=\"backbutton\" onclick=\"location.href = \'/popup/scenes/23.html\';\">\r\n    <div data-page=\"home\" class=\"icon\"><i class=\"fa fa-chevron-circle-left\"></i></div>\r\n</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(576,519,'Default','','<div style=\"font-size:32px;text-align:center;\">Маршруты</div>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(580,523,'default','','<iframe>../../../popup/app_gpstrack.html</iframe>',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(581,524,'default','','[#module name=\"app_radio\" mode=\"menu\"#] ',0,1,'','',1,'','',0,0,0,'','',0,0,0,0,0,0,'',0,'',0,'',''),(582,527,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch5','status',1,'0','',0,0,0,'Switch5','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(583,527,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch5','status',1,'1','',0,0,0,'Switch5','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(584,528,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch6','status',1,'0','',0,0,0,'Switch6','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(585,528,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch6','status',1,'1','',0,0,0,'Switch6','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(586,529,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch7','status',1,'0','',0,0,0,'Switch7','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(587,529,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch7','status',1,'1','',0,0,0,'Switch7','turnOff',0,0,0,0,0,0,'',0,'',0,'',''),(588,530,'off','','<img src=\"/cms/scenes/lamp2_off.png\" alt=\"off\" width=\"40\" height=\"40\">',1,1,'Switch8','status',1,'0','',0,0,0,'Switch8','turnOn',0,0,0,0,0,0,'',0,'',0,'',''),(589,530,'on','','<img src=\"/cms/scenes/lamp2_on.png\" alt=\"on\" width=\"40\" height=\"40\">',1,0,'Switch8','status',1,'1','',0,0,0,'Switch8','turnOff',0,0,0,0,0,0,'',0,'',0,'','');
/*!40000 ALTER TABLE `elm_states` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `engmeraval`
--

DROP TABLE IF EXISTS `engmeraval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `engmeraval` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `VAL` varchar(255) NOT NULL DEFAULT '',
  `IND` varchar(255) NOT NULL DEFAULT '',
  `OBJECT` varchar(255) NOT NULL DEFAULT '',
  `PROPERTY` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `engmeraval`
--

LOCK TABLES `engmeraval` WRITE;
/*!40000 ALTER TABLE `engmeraval` DISABLE KEYS */;
INSERT INTO `engmeraval` VALUES (1,'SNUMB()','Заводской номер счетчика','Count1','SNUMB'),(2,'VOLTA()','Действующее значение напряжения [В]','Count1','VOLTA'),(3,'CURRE()','Действующее значение тока [A]','Count1','CURRE'),(4,'POWEP()','Мгновенное значение мощности [кВт]','Count1','POWEP'),(5,'FREQU()','Значение частоты сети [Гц]','Count1','FREQU'),(6,'COS_f()','Значение коэффициента мощности','Count1','COS_f'),(7,'ET0PE()','Запрос показаний энергии','Count1','ET0PE');
/*!40000 ALTER TABLE `engmeraval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `espdevices`
--

DROP TABLE IF EXISTS `espdevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `espdevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `IDESP` varchar(100) NOT NULL DEFAULT '',
  `IP` varchar(255) NOT NULL DEFAULT '',
  `MAC` varchar(255) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `espdevices`
--

LOCK TABLES `espdevices` WRITE;
/*!40000 ALTER TABLE `espdevices` DISABLE KEYS */;
INSERT INTO `espdevices` VALUES (1,'ESP826600121b99','ESP826600121b99','192.168.1.22','','2017-05-03 23:24:41'),(2,'ESP826600f36346','ESP826600f36346','192.168.1.21','','2018-02-07 17:44:17'),(4,'ESP8266001221d6','ESP8266001221d6','192.168.1.23','','2018-02-25 13:05:29'),(6,'ESP826600da7bfc','ESP826600da7bfc','192.168.1.30','','2016-10-25 00:01:25'),(7,'ESP826600076ad9','ESP826600076ad9','192.168.1.26','','2017-04-16 12:51:39'),(8,'ESP8266001218f1','ESP8266001218f1','192.168.1.195','','2017-01-02 15:25:26'),(9,'ESP826600f3609a','ESP826600f3609a','192.168.1.108','','2017-01-02 15:24:37');
/*!40000 ALTER TABLE `espdevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `espdevices_data`
--

DROP TABLE IF EXISTS `espdevices_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `espdevices_data` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `DEVICE_ID` int(10) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(100) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(100) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(100) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=162 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `espdevices_data`
--

LOCK TABLES `espdevices_data` WRITE;
/*!40000 ALTER TABLE `espdevices_data` DISABLE KEYS */;
INSERT INTO `espdevices_data` VALUES (1,'hostname','ESP00121B99',1,'','','','2016-09-24 12:09:31'),(2,'dhtt1','23.7',1,'Esp22','dhtt1','','2017-05-03 23:22:41'),(3,'dhth1','68.9',1,'Esp22','dhth1','','2017-05-03 23:24:41'),(4,'dsw1','0.0',1,'Esp22','dsw1','','2016-10-09 15:55:18'),(5,'uptime','191280',1,'','','','2017-05-03 23:24:41'),(6,'errconn','92',1,'','','','2017-05-03 18:43:41'),(7,'wanip','192.168.1.22',1,'','','','2017-02-21 20:02:42'),(8,'freemem','11576',1,'','','','2017-05-03 19:30:41'),(9,'ver','0.1.1_16:39:31_30.10.2016',1,'','','','2016-10-30 16:43:59'),(10,'vdd','3430',1,'','','','2017-05-03 23:24:41'),(11,'rssi','-65',1,'','','','2017-05-03 23:24:41'),(12,'counter1','0.0',1,'esp_voda','esp_count1','count_plus','2017-01-04 13:29:16'),(13,'countrst1','0.0',1,'','','','2017-01-04 13:29:16'),(14,'hostname','ESP00F36346',2,'','','','2016-09-24 12:09:35'),(15,'uptime','1680',2,'','','','2018-02-07 17:44:17'),(16,'errconn','26',2,'','','','2018-02-07 17:18:17'),(17,'wanip','192.168.1.21',2,'','','','2017-02-06 00:20:11'),(18,'freemem','21360',2,'','','','2018-02-07 17:18:17'),(19,'ver','0.1.1_20:02:00_14.02.2016',2,'','','','2016-09-24 12:09:35'),(20,'vdd','3327',2,'','','','2018-02-07 17:44:17'),(21,'rssi','-64',2,'','','','2018-02-07 17:43:17'),(22,'gpiout1','0',2,'','','','2017-11-30 00:19:06'),(23,'gpiout3','0',2,'','','','2018-02-03 16:57:21'),(24,'gpiout4','0',2,'','','','2018-02-03 16:57:21'),(25,'gpiout5','0',2,'','','','2018-02-03 16:57:21'),(26,'gpiout12','1',2,'','','','2018-02-07 16:46:25'),(27,'gpiout13','0',2,'','','','2018-02-05 23:55:33'),(28,'gpiout14','0',2,'','','','2016-09-27 17:05:43'),(29,'gpiout16','0',2,'','','','2018-02-03 19:18:44'),(30,'gpiout220','1',2,'','','','2018-02-07 16:57:25'),(31,'gpiout221','0',2,'','','','2018-02-07 16:51:19'),(32,'gpiout222','0',2,'','','','2018-02-07 16:51:19'),(33,'gpiout223','0',2,'','','','2018-02-07 16:51:19'),(34,'gpiout224','0',2,'','','','2018-02-07 16:51:19'),(35,'gpiout225','0',2,'','','','2018-02-07 16:55:25'),(36,'gpiout226','0',2,'','','','2018-02-07 16:55:25'),(37,'gpiout227','0',2,'','','','2018-02-07 16:56:25'),(38,'dsw2','0.0',1,'Esp22','dsw2','','2016-10-09 15:55:18'),(39,'hostname','ESP00DA7BFD',3,'','','','2016-09-25 11:10:26'),(40,'uptime','1693200',3,'','','','2017-03-24 14:23:42'),(41,'errconn','36',3,'','','','2017-03-17 23:33:41'),(42,'wanip','192.168.1.25',3,'','','','2016-09-25 11:10:26'),(43,'freemem','13504',3,'','','','2017-03-22 15:53:43'),(44,'ver','0.1.1_20:46:22_24.09.2016',3,'','','','2016-09-25 11:10:26'),(45,'vdd','3362',3,'','','','2017-03-24 14:23:42'),(46,'rssi','-59',3,'','','','2017-03-24 13:33:42'),(47,'dsw1','24.3',3,'Esp25','dsw1','','2017-03-24 14:23:42'),(48,'hostname','ESP001221D6',4,'','','','2016-09-25 11:30:26'),(49,'dsw1','22.7',4,'Esp23','dsw1','','2017-03-24 14:23:45'),(50,'uptime','169080',4,'','','','2018-02-25 13:05:29'),(51,'errconn','25',4,'','','','2018-02-23 14:08:27'),(52,'wanip','192.168.1.23',4,'','','','2016-09-25 11:30:26'),(53,'freemem','34000',4,'','','','2018-02-25 12:22:29'),(54,'ver','0.1.1_20:36:40_31.03.2017',4,'','','','2017-03-31 22:08:52'),(55,'vdd','3349',4,'','','','2018-02-25 13:05:29'),(56,'rssi','-81',4,'','','','2018-02-25 13:05:29'),(57,'hostname','ESP001219EB',5,'','','','2016-09-25 11:40:26'),(58,'dsw1','24.4',5,'Esp24','dsw1','','2017-03-24 14:25:53'),(59,'uptime','1693440',5,'','','','2017-03-24 14:27:53'),(60,'errconn','35',5,'','','','2017-03-17 23:31:48'),(61,'wanip','192.168.1.24',5,'','','','2017-02-06 00:20:38'),(62,'freemem','13456',5,'','','','2017-03-24 14:19:53'),(63,'ver','0.1.1_20:46:22_24.09.2016',5,'','','','2016-09-25 11:40:26'),(64,'vdd','3431',5,'','','','2017-03-24 14:26:53'),(65,'rssi','-59',5,'','','','2017-03-24 14:26:53'),(66,'hostname','ESP00DA7BFC',6,'','','','2016-10-07 20:41:20'),(67,'uptime','103920',6,'','','','2016-10-25 00:01:25'),(68,'errconn','39',6,'','','','2016-10-23 19:47:25'),(69,'wanip','192.168.1.30',6,'','','','2016-10-07 20:43:26'),(70,'freemem','12464',6,'','','','2016-10-24 23:28:25'),(71,'ver','0.1.1_08:57:31_15.10.2016',6,'','','','2016-10-22 20:56:06'),(72,'vdd','3376',6,'','','','2016-10-25 00:01:25'),(73,'rssi','-72',6,'','','','2016-10-25 00:01:25'),(74,'gpiout220','1',6,'','','','2016-10-07 20:41:20'),(75,'gpiout221','0',6,'','','','2016-10-07 20:41:20'),(76,'gpiout222','0',6,'','','','2016-10-07 20:41:20'),(77,'gpiout223','0',6,'','','','2016-10-07 20:41:20'),(78,'gpiout224','0',6,'','','','2016-10-07 20:41:20'),(79,'gpiout225','0',6,'','','','2016-10-07 20:41:20'),(80,'gpiout226','0',6,'','','','2016-10-07 20:41:20'),(81,'gpiout227','0',6,'','','','2016-10-07 20:41:20'),(82,'rcdata','9365089',6,'','','','2016-10-13 19:55:36'),(83,'rcdata','7513266',2,'rcdata','rcswitch','rccode','2018-02-07 16:50:43'),(84,'counter1','0.0',6,'','','','2016-10-10 14:52:50'),(85,'countrst1','0.0',6,'','','','2016-10-10 14:52:50'),(86,'adc0','255',6,'','','','2016-10-13 20:10:30'),(87,'adc1','255',6,'','','','2016-10-13 23:48:45'),(88,'adc2','255',6,'','','','2016-10-13 23:48:45'),(89,'adc3','255',6,'','','','2016-10-13 23:48:45'),(94,'gpioint1','0',5,'Switch15','esp_status','esp_switch','2017-03-24 09:46:53'),(95,'gpioint2','0',5,'Switch8','esp_status','esp_switch','2017-03-24 14:12:53'),(96,'gpioint3','0',5,'Switch14','esp_status','esp_switch','2017-03-23 21:28:53'),(97,'gpioint4','0',5,'Switch2','esp_status','esp_switch','2016-10-19 16:40:29'),(98,'hostname','ESP00076AD9',7,'','','','2016-10-22 13:49:06'),(99,'uptime','87091',7,'','','','2017-04-16 12:51:39'),(100,'errconn','34',7,'','','','2017-04-15 12:41:07'),(101,'wanip','192.168.1.26',7,'','','','2017-02-06 00:20:12'),(102,'freemem','17256',7,'','','','2017-04-16 12:51:39'),(103,'ver','0.1.1_08:37:56_15.10.2016',7,'','','','2016-10-22 13:49:06'),(104,'vdd','3350',7,'','','','2017-04-16 12:51:39'),(105,'rssi','-67',7,'','','','2017-04-16 12:51:39'),(106,'gpioint1','0',7,'Switch7','esp_status','esp_switch','2017-04-16 08:27:07'),(107,'gpioint2','0',7,'Switch10','esp_status','esp_switch','2017-04-13 22:29:08'),(108,'gpioint3','1',7,'Switch18','esp_status','esp_switch','2017-04-16 12:51:35'),(109,'gpioint4','0',7,'Switch5','esp_status','esp_switch','2017-04-10 07:14:03'),(110,'gpioint1','0',4,'Switch18','esp_status','esp_switch','2018-02-25 12:08:29'),(111,'gpioint2','0',4,'Switch7','esp_status','esp_switch','2018-02-24 20:14:28'),(112,'gpioint1','0',6,'Switch15','esp_status','esp_switch','2016-10-24 23:28:25'),(113,'gpioint2','0',6,'Switch8','esp_status','esp_switch','2016-10-24 23:28:25'),(114,'gpioint3','0',6,'','','','2016-10-24 23:28:25'),(115,'gpioint4','0',6,'','','','2016-10-24 21:29:25'),(116,'gpiout1','0',5,'','','','2016-11-09 19:27:12'),(117,'gpiout3','1',5,'','','','2016-11-09 19:27:12'),(118,'gpiout12','1',5,'','','','2016-11-09 19:26:55'),(119,'gpiout16','0',5,'','','','2016-11-09 19:26:45'),(120,'hostname','ESP001218F1',8,'','','','2017-01-02 15:13:35'),(121,'uptime','771',8,'','','','2017-01-02 15:25:26'),(122,'errconn','9',8,'','','','2017-01-02 15:13:35'),(123,'wanip','192.168.1.195',8,'','','','2017-01-02 15:13:35'),(124,'freemem','16608',8,'','','','2017-01-02 15:21:39'),(125,'ver','0.1.1_22:47:31_30.09.2016',8,'','','','2017-01-02 15:13:35'),(126,'vdd','3275',8,'','','','2017-01-02 15:25:26'),(127,'rssi','-59',8,'','','','2017-01-02 15:25:26'),(128,'gpiout5','0',8,'','','','2017-01-02 15:25:23'),(129,'gpiout13','0',8,'','','','2017-01-02 15:13:35'),(130,'gpiout14','0',8,'','','','2017-01-02 15:25:26'),(131,'gpiout16','0',8,'','','','2017-01-02 15:25:22'),(132,'hostname','ESP00F3609A',9,'','','','2017-01-02 15:13:36'),(133,'dhtt1','254.9',9,'','','','2017-01-02 15:13:36'),(134,'dhth1','254.9',9,'','','','2017-01-02 15:13:37'),(135,'dhtt2','254.9',9,'','','','2017-01-02 15:13:37'),(136,'dhth2','254.9',9,'','','','2017-01-02 15:13:37'),(137,'uptime','720',9,'','','','2017-01-02 15:24:37'),(138,'errconn','8',9,'','','','2017-01-02 15:13:37'),(139,'wanip','192.168.1.108',9,'','','','2017-01-02 15:13:37'),(140,'freemem','14040',9,'','','','2017-01-02 15:24:37'),(141,'ver','0.1.1_22:47:31_30.09.2016',9,'','','','2017-01-02 15:13:37'),(142,'vdd','3324',9,'','','','2017-01-02 15:24:37'),(143,'rssi','-66',9,'','','','2017-01-02 15:24:37'),(144,'gpiout1','0',9,'','','','2017-01-02 15:13:37'),(145,'gpiout5','0',9,'','','','2017-01-02 15:13:37'),(146,'gpiout13','0',9,'','','','2017-01-02 15:13:37'),(147,'gpiout14','0',9,'','','','2017-01-02 15:13:37'),(148,'gpiout16','0',9,'','','','2017-01-02 15:13:37'),(149,'gpiout0','0',9,'','','','2017-01-02 15:15:37'),(150,'gpiout2','0',9,'','','','2017-01-02 15:14:37'),(151,'gpiout4','0',9,'','','','2017-01-02 15:14:37'),(152,'gpiout12','0',9,'','','','2017-01-02 15:15:37'),(153,'gpiout0','0',8,'','','','2017-01-02 15:19:35'),(154,'gpiout1','0',8,'','','','2017-01-02 15:19:35'),(155,'gpiout2','0',8,'','','','2017-01-02 15:19:35'),(156,'gpiout4','0',8,'','','','2017-01-02 15:25:23'),(157,'gpiout12','0',8,'','','','2017-01-02 15:17:35'),(158,'gpiout3','0',8,'','','','2017-01-02 15:18:35'),(159,'rcdata','1479345',8,'','','','2017-01-02 15:25:24'),(160,'rcdata','12906501',1,'rcdata','rcswitch','rccode','2017-05-03 19:17:54'),(161,'gpiout14','0',4,'','','','2017-03-31 22:28:29');
/*!40000 ALTER TABLE `espdevices_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `events`
--

DROP TABLE IF EXISTS `events`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `events` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `EVENT_TYPE` varchar(10) NOT NULL DEFAULT '',
  `TERMINAL_FROM` varchar(255) NOT NULL DEFAULT '',
  `TERMINAL_TO` varchar(255) NOT NULL DEFAULT '',
  `USER_FROM` varchar(255) NOT NULL DEFAULT '',
  `USER_TO` varchar(255) NOT NULL DEFAULT '',
  `WINDOW` varchar(255) NOT NULL DEFAULT '',
  `DETAILS` text,
  `ADDED` datetime DEFAULT NULL,
  `EXPIRE` datetime DEFAULT NULL,
  `PROCESSED` int(3) NOT NULL DEFAULT '0',
  `EVENT_NAME` varchar(255) NOT NULL DEFAULT '',
  `DESCRIPTION` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `events`
--

LOCK TABLES `events` WRITE;
/*!40000 ALTER TABLE `events` DISABLE KEYS */;
INSERT INTO `events` VALUES (1,'system','','','','','','objects','2014-09-05 13:01:00','2014-09-07 13:01:00',1,'inhouseMovement','');
/*!40000 ALTER TABLE `events` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `events_params`
--

DROP TABLE IF EXISTS `events_params`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `events_params` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `EVENT_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `events_params`
--

LOCK TABLES `events_params` WRITE;
/*!40000 ALTER TABLE `events_params` DISABLE KEYS */;
/*!40000 ALTER TABLE `events_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gpsactions`
--

DROP TABLE IF EXISTS `gpsactions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gpsactions` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `LOCATION_ID` int(10) NOT NULL DEFAULT '0',
  `USER_ID` int(10) NOT NULL DEFAULT '0',
  `ACTION_TYPE` int(255) NOT NULL DEFAULT '0',
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `CODE` text,
  `LOG` text,
  `EXECUTED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `LOCATION_ID` (`LOCATION_ID`),
  KEY `USER_ID` (`USER_ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gpsactions`
--

LOCK TABLES `gpsactions` WRITE;
/*!40000 ALTER TABLE `gpsactions` DISABLE KEYS */;
/*!40000 ALTER TABLE `gpsactions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gpsdevices`
--

DROP TABLE IF EXISTS `gpsdevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gpsdevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `USER_ID` int(10) NOT NULL DEFAULT '0',
  `LAT` varchar(255) NOT NULL DEFAULT '',
  `LON` varchar(255) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  `DEVICEID` varchar(255) NOT NULL DEFAULT '',
  `TOKEN` varchar(255) NOT NULL DEFAULT '',
  `HOME_DISTANCE` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `USER_ID` (`USER_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gpsdevices`
--

LOCK TABLES `gpsdevices` WRITE;
/*!40000 ALTER TABLE `gpsdevices` DISABLE KEYS */;
INSERT INTO `gpsdevices` VALUES (3,'New GPS Device',0,'60.0342127','37.7946292','2018-03-19 08:10:09','352449090711261','',0);
/*!40000 ALTER TABLE `gpsdevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gpslocations`
--

DROP TABLE IF EXISTS `gpslocations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gpslocations` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LAT` float NOT NULL DEFAULT '0',
  `LON` float NOT NULL DEFAULT '0',
  `RANGE` float NOT NULL DEFAULT '0',
  `VIRTUAL_USER_ID` int(10) NOT NULL DEFAULT '0',
  `IS_HOME` int(3) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gpslocations`
--

LOCK TABLES `gpslocations` WRITE;
/*!40000 ALTER TABLE `gpslocations` DISABLE KEYS */;
INSERT INTO `gpslocations` VALUES (11,'Location 1',52.9471,21.668,500,0,0,'');
/*!40000 ALTER TABLE `gpslocations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `gpslog`
--

DROP TABLE IF EXISTS `gpslog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `gpslog` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ADDED` datetime DEFAULT NULL,
  `LAT` float NOT NULL DEFAULT '0',
  `LON` float NOT NULL DEFAULT '0',
  `ALT` float NOT NULL DEFAULT '0',
  `PROVIDER` varchar(30) NOT NULL DEFAULT '',
  `SPEED` float NOT NULL DEFAULT '0',
  `BATTLEVEL` int(3) NOT NULL DEFAULT '0',
  `CHARGING` int(3) NOT NULL DEFAULT '0',
  `DEVICEID` varchar(255) NOT NULL DEFAULT '',
  `DEVICE_ID` int(10) NOT NULL DEFAULT '0',
  `LOCATION_ID` int(10) NOT NULL DEFAULT '0',
  `ACCURACY` float NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`),
  KEY `DEVICE_ID` (`DEVICE_ID`),
  KEY `LOCATION_ID` (`LOCATION_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4432 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `gpslog`
--

LOCK TABLES `gpslog` WRITE;
/*!40000 ALTER TABLE `gpslog` DISABLE KEYS */;
INSERT INTO `gpslog` VALUES (2912,'2018-03-07 22:56:45',60.0343,37.7944,107.8,'gps',0,10,0,'352449090711261',3,0,5.7),(2913,'2018-03-07 23:57:22',60.0347,37.7947,159.3,'gps',0,10,0,'352449090711261',3,0,12.6),(2914,'2018-03-08 01:03:18',60.0343,37.7952,84.7,'gps',0,9,0,'352449090711261',3,0,10),(2915,'2018-03-08 01:05:09',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2916,'2018-03-08 01:06:31',60.0343,37.7945,122.5,'gps',0,9,0,'352449090711261',3,0,14.2),(2917,'2018-03-08 01:06:32',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2918,'2018-03-08 01:07:35',60.0345,37.7942,134.5,'gps',0,9,0,'352449090711261',3,0,6),(2919,'2018-03-08 01:07:56',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2920,'2018-03-08 01:08:27',60.0344,37.7949,126.7,'gps',0,9,0,'352449090711261',3,0,11.7),(2921,'2018-03-08 01:08:28',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2922,'2018-03-08 01:09:26',60.0344,37.795,138.7,'gps',0,9,0,'352449090711261',3,0,10.3),(2923,'2018-03-08 01:09:28',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2924,'2018-03-08 01:10:54',60.0347,37.7939,161.6,'gps',0,9,0,'352449090711261',3,0,7.7),(2925,'2018-03-08 01:10:56',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2926,'2018-03-08 01:11:28',60.0343,37.7942,151.3,'gps',0,9,0,'352449090711261',3,0,7.5),(2927,'2018-03-08 01:11:29',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2928,'2018-03-08 01:12:28',60.0342,37.7953,106.2,'gps',0,9,0,'352449090711261',3,0,8.2),(2929,'2018-03-08 01:12:30',60.0342,37.7946,0,'network',0,9,0,'352449090711261',3,0,20),(2930,'2018-03-08 04:59:48',60.0345,37.794,136.7,'gps',0,7,0,'352449090711261',3,0,10.3),(2931,'2018-03-08 06:23:25',60.0342,37.7945,92.9,'gps',0,7,0,'352449090711261',3,0,9.5),(2932,'2018-03-08 06:23:26',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2933,'2018-03-08 06:25:33',60.0345,37.7945,138.1,'gps',0,7,0,'352449090711261',3,0,10.6),(2934,'2018-03-08 06:25:35',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2935,'2018-03-08 06:26:26',60.0347,37.7967,51.1,'gps',0,7,0,'352449090711261',3,0,15.1),(2936,'2018-03-08 06:26:26',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2937,'2018-03-08 06:27:04',60.0344,37.795,111.5,'gps',0,7,0,'352449090711261',3,0,12.2),(2938,'2018-03-08 06:27:04',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2939,'2018-03-08 06:27:38',60.0344,37.7946,101.9,'gps',0,7,0,'352449090711261',3,0,12.7),(2940,'2018-03-08 06:27:39',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2941,'2018-03-08 06:28:38',60.0344,37.7945,54.5,'gps',0,7,0,'352449090711261',3,0,7.9),(2942,'2018-03-08 06:28:39',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2943,'2018-03-08 06:29:36',60.0346,37.7947,149.8,'gps',0,7,0,'352449090711261',3,0,10.9),(2944,'2018-03-08 06:29:37',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20),(2945,'2018-03-08 06:45:27',60.0344,37.7949,86.4,'gps',0,7,0,'352449090711261',3,0,6.3),(2946,'2018-03-08 06:45:29',60.0342,37.7946,0,'network',0,7,0,'352449090711261',3,0,20.1),(2947,'2018-03-08 08:16:11',60.034,37.7944,97.9,'gps',0,5,0,'352449090711261',3,0,11.4),(2948,'2018-03-08 09:16:41',60.0341,37.7947,0,'network',0,3,0,'352449090711261',3,0,50),(2949,'2018-03-08 10:23:52',60.0345,37.7935,103.5,'gps',0,1,0,'352449090711261',3,0,7.9),(2950,'2018-03-08 10:24:03',60.0342,37.7946,0,'network',0,1,0,'352449090711261',3,0,20),(2951,'2018-03-08 10:24:33',60.0346,37.7942,126.9,'gps',0,1,0,'352449090711261',3,0,9.1),(2952,'2018-03-08 10:25:45',60.0342,37.7946,0,'network',0,1,1,'352449090711261',3,0,20),(2953,'2018-03-08 10:26:39',60.0345,37.7944,59.5,'gps',0,1,1,'352449090711261',3,0,7.3),(2954,'2018-03-08 10:27:32',60.0345,37.7943,135.6,'gps',0,1,1,'352449090711261',3,0,16.2),(2955,'2018-03-08 10:28:34',60.0344,37.7943,141.3,'gps',0,1,1,'352449090711261',3,0,10.4),(2956,'2018-03-08 10:29:33',60.0344,37.7944,178,'gps',0,1,1,'352449090711261',3,0,13),(2957,'2018-03-08 10:29:34',60.0342,37.7946,0,'network',0,1,1,'352449090711261',3,0,20),(2958,'2018-03-08 10:30:33',60.0344,37.795,167.8,'gps',0,1,1,'352449090711261',3,0,12.3),(2959,'2018-03-08 10:30:34',60.0342,37.7946,0,'network',0,1,1,'352449090711261',3,0,50),(2960,'2018-03-08 10:31:31',60.0343,37.7944,104.6,'gps',0,1,1,'352449090711261',3,0,6),(2961,'2018-03-08 10:32:30',60.0343,37.7943,97.6,'gps',0.13,2,1,'352449090711261',3,0,9.5),(2962,'2018-03-08 10:33:27',60.0342,37.7944,62.2,'gps',0,2,1,'352449090711261',3,0,8.9),(2963,'2018-03-08 10:34:31',60.0343,37.7944,79.3,'gps',0,2,1,'352449090711261',3,0,10.3),(2964,'2018-03-08 10:35:33',60.0345,37.794,102.2,'gps',0,2,1,'352449090711261',3,0,7),(2965,'2018-03-08 10:35:34',60.0342,37.7946,0,'network',0,2,1,'352449090711261',3,0,20),(2966,'2018-03-08 10:36:31',60.0345,37.7941,103.2,'gps',0,3,1,'352449090711261',3,0,8),(2967,'2018-03-08 10:37:32',60.0344,37.7941,98.9,'gps',0,3,1,'352449090711261',3,0,8.8),(2968,'2018-03-08 10:38:32',60.0344,37.7943,82.4,'gps',0,3,1,'352449090711261',3,0,6.9),(2969,'2018-03-08 10:39:32',60.0345,37.7941,126.5,'gps',0,4,1,'352449090711261',3,0,5.3),(2970,'2018-03-08 10:40:32',60.0345,37.794,115,'gps',0,4,1,'352449090711261',3,0,7.2),(2971,'2018-03-08 10:41:36',60.0344,37.7944,107.6,'gps',0,4,1,'352449090711261',3,0,7.9),(2972,'2018-03-08 10:42:32',60.0344,37.7944,91.5,'gps',0,4,1,'352449090711261',3,0,5.7),(2973,'2018-03-08 10:43:30',60.0345,37.7941,186.3,'gps',0.06,5,1,'352449090711261',3,0,7.7),(2974,'2018-03-08 10:44:32',60.0344,37.794,119.3,'gps',0.12,6,1,'352449090711261',3,0,7.9),(2975,'2018-03-08 10:45:35',60.0344,37.7945,89,'gps',0,7,1,'352449090711261',3,0,10),(2976,'2018-03-08 10:46:32',60.0345,37.7941,176.1,'gps',0,8,1,'352449090711261',3,0,8.7),(2977,'2018-03-08 10:47:36',60.0343,37.7943,124.7,'gps',0,9,1,'352449090711261',3,0,6.4),(2978,'2018-03-08 10:48:35',60.0344,37.7944,87.8,'gps',0,10,1,'352449090711261',3,0,5.6),(2979,'2018-03-08 10:49:32',60.0343,37.7943,119.8,'gps',0,11,1,'352449090711261',3,0,4.6),(2980,'2018-03-08 10:50:32',60.0344,37.7945,33.2,'gps',0,12,1,'352449090711261',3,0,6.9),(2981,'2018-03-08 10:51:33',60.0344,37.7944,88.6,'gps',0,12,1,'352449090711261',3,0,6.7),(2982,'2018-03-08 10:51:35',60.0342,37.7946,0,'network',0,12,1,'352449090711261',3,0,20),(2983,'2018-03-08 10:52:33',60.0343,37.7944,129.8,'gps',0.04,12,1,'352449090711261',3,0,6.6),(2984,'2018-03-08 10:52:34',60.0342,37.7946,0,'network',0,12,1,'352449090711261',3,0,20),(2985,'2018-03-08 10:53:32',60.0344,37.7943,96.4,'gps',0,12,1,'352449090711261',3,0,6),(2986,'2018-03-08 10:54:31',60.0344,37.7945,51.8,'gps',0,12,1,'352449090711261',3,0,6.6),(2987,'2018-03-08 10:55:33',60.0343,37.7944,113.4,'gps',0,12,1,'352449090711261',3,0,7),(2988,'2018-03-08 10:55:35',60.0342,37.7946,0,'network',0,12,1,'352449090711261',3,0,20),(2989,'2018-03-08 10:56:33',60.0343,37.7944,100.3,'gps',0,12,1,'352449090711261',3,0,5.7),(2990,'2018-03-08 10:56:35',60.0342,37.7946,0,'network',0,12,1,'352449090711261',3,0,20),(2991,'2018-03-08 10:57:31',60.0344,37.7943,123.2,'gps',0,12,1,'352449090711261',3,0,7.4),(2992,'2018-03-08 10:58:32',60.0343,37.7943,121.4,'gps',0,12,1,'352449090711261',3,0,6.7),(2993,'2018-03-08 10:59:32',60.0345,37.7944,89.2,'gps',0,12,1,'352449090711261',3,0,6.8),(2994,'2018-03-08 11:00:33',60.0344,37.7945,69.6,'gps',0,12,1,'352449090711261',3,0,7.1),(2995,'2018-03-08 11:00:34',60.0342,37.7946,0,'network',0,12,1,'352449090711261',3,0,20),(2996,'2018-03-08 11:01:34',60.0343,37.7943,109.1,'gps',0,12,1,'352449090711261',3,0,5.9),(2997,'2018-03-08 11:02:33',60.0343,37.7943,106.7,'gps',0,12,1,'352449090711261',3,0,6.7),(2998,'2018-03-08 11:02:34',60.0342,37.7946,0,'network',0,12,1,'352449090711261',3,0,20),(2999,'2018-03-08 11:03:35',60.0344,37.7944,93,'gps',0,12,1,'352449090711261',3,0,7.6),(3000,'2018-03-08 11:04:33',60.0344,37.7943,96.2,'gps',0,12,1,'352449090711261',3,0,7.1),(3001,'2018-03-08 11:08:11',60.0344,37.7944,99.2,'gps',0,13,1,'352449090711261',3,0,6.2),(3002,'2018-03-08 11:08:31',60.0343,37.7943,113.1,'gps',0,13,1,'352449090711261',3,0,6.2),(3003,'2018-03-08 11:09:33',60.0343,37.7943,123.8,'gps',0,13,1,'352449090711261',3,0,7.5),(3004,'2018-03-08 11:09:35',60.0342,37.7946,0,'network',0,13,1,'352449090711261',3,0,20),(3005,'2018-03-08 11:10:32',60.0343,37.7943,100.3,'gps',0,14,1,'352449090711261',3,0,6.8),(3006,'2018-03-08 11:11:32',60.0344,37.7944,93.6,'gps',0,14,1,'352449090711261',3,0,6.6),(3007,'2018-03-08 11:11:33',60.0342,37.7946,0,'network',0,14,1,'352449090711261',3,0,20),(3008,'2018-03-08 11:12:33',60.0343,37.7945,89.5,'gps',0,15,1,'352449090711261',3,0,8.3),(3009,'2018-03-08 11:12:35',60.0342,37.7946,0,'network',0,15,1,'352449090711261',3,0,20),(3010,'2018-03-08 11:13:32',60.0343,37.7944,104.2,'gps',0,16,1,'352449090711261',3,0,5.5),(3011,'2018-03-08 11:14:31',60.0343,37.7945,31.5,'gps',0,16,1,'352449090711261',3,0,7.4),(3012,'2018-03-08 11:15:34',60.0343,37.7944,96.9,'gps',0,16,1,'352449090711261',3,0,6),(3013,'2018-03-08 11:16:35',60.0345,37.7946,162.7,'gps',0,17,1,'352449090711261',3,0,8.3),(3014,'2018-03-08 11:20:18',60.0346,37.7945,156.5,'gps',0,17,1,'352449090711261',3,0,9.8),(3015,'2018-03-08 11:20:45',60.0346,37.7945,123.4,'gps',0,17,1,'352449090711261',3,0,7.7),(3016,'2018-03-08 11:20:45',60.0343,37.7947,0,'network',0,17,1,'352449090711261',3,0,50),(3017,'2018-03-08 11:21:35',60.0346,37.7946,169.3,'gps',0,17,1,'352449090711261',3,0,11.6),(3018,'2018-03-08 11:21:37',60.0342,37.7947,0,'network',0,17,1,'352449090711261',3,0,50),(3019,'2018-03-08 11:22:38',60.0344,37.7943,125,'gps',0,17,1,'352449090711261',3,0,9.5),(3020,'2018-03-08 11:28:07',60.0342,37.7938,-37.4,'gps',0,22,1,'352449090711261',3,0,12.5),(3021,'2018-03-08 11:28:08',60.0342,37.7946,0,'network',0,22,1,'352449090711261',3,0,20),(3022,'2018-03-08 11:28:36',60.0346,37.7946,242.8,'gps',0,22,1,'352449090711261',3,0,9.4),(3023,'2018-03-08 11:29:38',60.0343,37.7943,118.6,'gps',0,22,0,'352449090711261',3,0,8.2),(3024,'2018-03-08 11:30:33',60.0345,37.7944,100.6,'gps',0,22,0,'352449090711261',3,0,13.2),(3025,'2018-03-08 11:31:41',60.0342,37.7931,321.6,'gps',0,22,0,'352449090711261',3,0,13.5),(3026,'2018-03-08 11:32:49',60.0342,37.7946,0,'network',0,22,0,'352449090711261',3,0,24.9),(3027,'2018-03-08 11:33:48',60.0342,37.7946,0,'network',0,22,0,'352449090711261',3,0,50),(3028,'2018-03-08 11:34:37',60.034,37.7936,138.3,'gps',0,22,1,'352449090711261',3,0,15.7),(3029,'2018-03-08 11:35:40',60.0344,37.7949,96.2,'gps',0,22,1,'352449090711261',3,0,15.5),(3030,'2018-03-08 11:36:38',60.0344,37.7941,132,'gps',0,22,1,'352449090711261',3,0,12.9),(3031,'2018-03-08 11:37:38',60.0344,37.7948,103.2,'gps',0,23,1,'352449090711261',3,0,16.9),(3032,'2018-03-08 11:38:36',60.0346,37.7948,129.2,'gps',0,23,1,'352449090711261',3,0,14.7),(3033,'2018-03-08 11:39:42',60.0345,37.7938,131.4,'gps',0,24,1,'352449090711261',3,0,13.7),(3034,'2018-03-08 11:40:36',60.0341,37.7941,116.7,'gps',0,25,1,'352449090711261',3,0,10.5),(3035,'2018-03-08 11:40:37',60.0342,37.7946,0,'network',0,25,1,'352449090711261',3,0,50),(3036,'2018-03-08 11:41:38',60.0344,37.7943,114.7,'gps',0,25,1,'352449090711261',3,0,16),(3037,'2018-03-08 11:42:39',60.0342,37.7943,110.3,'gps',0,25,1,'352449090711261',3,0,13),(3038,'2018-03-08 11:43:40',60.0346,37.795,107.3,'gps',0,25,1,'352449090711261',3,0,8.1),(3039,'2018-03-08 11:44:39',60.0341,37.7944,99.8,'gps',0,25,1,'352449090711261',3,0,11.1),(3040,'2018-03-08 11:45:48',60.0342,37.7946,0,'network',0,26,1,'352449090711261',3,0,50),(3041,'2018-03-08 11:46:40',60.034,37.7933,125.9,'gps',0,27,1,'352449090711261',3,0,16.4),(3042,'2018-03-08 11:47:40',60.0345,37.7941,160.4,'gps',0,28,1,'352449090711261',3,0,13.6),(3043,'2018-03-08 11:48:48',60.0342,37.7946,0,'network',0,28,1,'352449090711261',3,0,50),(3044,'2018-03-08 11:49:48',60.0342,37.7946,0,'network',0,28,1,'352449090711261',3,0,50),(3045,'2018-03-08 11:50:40',60.034,37.7932,123,'gps',0,28,1,'352449090711261',3,0,16.9),(3046,'2018-03-08 11:51:39',60.0348,37.7948,119.5,'gps',0,28,1,'352449090711261',3,0,14.5),(3047,'2018-03-08 11:52:48',60.0342,37.7946,0,'network',0,28,1,'352449090711261',3,0,50),(3048,'2018-03-08 11:53:37',60.0347,37.7941,143.1,'gps',0,29,1,'352449090711261',3,0,15.4),(3049,'2018-03-08 11:54:36',60.0345,37.7941,120.1,'gps',0,29,1,'352449090711261',3,0,13.4),(3050,'2018-03-08 11:55:42',60.0354,37.7951,167.9,'gps',0,30,1,'352449090711261',3,0,15.3),(3051,'2018-03-08 11:56:35',60.0346,37.7943,134.7,'gps',0,30,1,'352449090711261',3,0,11),(3052,'2018-03-08 11:56:37',60.0342,37.7946,0,'network',0,30,1,'352449090711261',3,0,50),(3053,'2018-03-08 11:57:44',60.0345,37.7945,117.2,'gps',0,30,1,'352449090711261',3,0,10.5),(3054,'2018-03-08 11:58:35',60.0344,37.7945,108.9,'gps',0,30,1,'352449090711261',3,0,10.1),(3055,'2018-03-08 11:58:37',60.0342,37.7946,0,'network',0,30,1,'352449090711261',3,0,50),(3056,'2018-03-08 11:59:35',60.034,37.7955,55.5,'gps',0,31,1,'352449090711261',3,0,10.2),(3057,'2018-03-08 11:59:37',60.0342,37.7946,0,'network',0,31,1,'352449090711261',3,0,50),(3058,'2018-03-08 12:00:35',60.0343,37.7943,102.2,'gps',0,32,1,'352449090711261',3,0,10.7),(3059,'2018-03-08 12:00:37',60.0342,37.7946,0,'network',0,32,1,'352449090711261',3,0,50),(3060,'2018-03-08 12:01:35',60.0345,37.7943,123.9,'gps',0,33,1,'352449090711261',3,0,8),(3061,'2018-03-08 12:01:37',60.0342,37.7946,0,'network',0,33,1,'352449090711261',3,0,50),(3062,'2018-03-08 12:02:37',60.0343,37.7948,110.1,'gps',0,34,1,'352449090711261',3,0,16.3),(3063,'2018-03-08 12:03:35',60.0348,37.7936,172.8,'gps',0,34,1,'352449090711261',3,0,16.8),(3064,'2018-03-08 12:03:37',60.0342,37.7946,0,'network',0,34,1,'352449090711261',3,0,50),(3065,'2018-03-08 12:04:37',60.0346,37.7941,135.7,'gps',0,34,1,'352449090711261',3,0,17),(3066,'2018-03-08 12:05:35',60.0345,37.7939,111.5,'gps',0,34,1,'352449090711261',3,0,7.5),(3067,'2018-03-08 12:05:37',60.0342,37.7946,0,'network',0,34,1,'352449090711261',3,0,50),(3068,'2018-03-08 12:06:47',60.0344,37.7945,133.8,'gps',0,34,1,'352449090711261',3,0,5.4),(3069,'2018-03-08 12:07:32',60.0345,37.7943,133.8,'gps',0,35,1,'352449090711261',3,0,7.4),(3070,'2018-03-08 12:08:34',60.0342,37.795,133.8,'gps',0,36,1,'352449090711261',3,0,8.7),(3071,'2018-03-08 12:09:34',60.0344,37.7947,133.8,'gps',0,37,1,'352449090711261',3,0,8.6),(3072,'2018-03-08 12:10:32',60.0344,37.7945,133.8,'gps',0,37,1,'352449090711261',3,0,9),(3073,'2018-03-08 12:11:34',60.0346,37.7939,133.8,'gps',0,37,1,'352449090711261',3,0,6),(3074,'2018-03-08 12:12:31',60.0345,37.7943,154,'gps',0,38,1,'352449090711261',3,0,14.8),(3075,'2018-03-08 12:13:33',60.0343,37.7945,102.2,'gps',0,39,1,'352449090711261',3,0,15.7),(3076,'2018-03-08 12:14:32',60.0345,37.7943,145.1,'gps',0,40,1,'352449090711261',3,0,14.5),(3077,'2018-03-08 12:15:32',60.0341,37.7948,68.8,'gps',0,41,1,'352449090711261',3,0,12.9),(3078,'2018-03-08 12:16:32',60.0343,37.7944,88,'gps',0,42,1,'352449090711261',3,0,13.4),(3079,'2018-03-08 12:17:32',60.0346,37.7942,145.2,'gps',0,43,1,'352449090711261',3,0,13.4),(3080,'2018-03-08 12:18:34',60.034,37.7946,50,'gps',0,43,1,'352449090711261',3,0,11.1),(3081,'2018-03-08 12:19:32',60.0343,37.7943,103.3,'gps',0,43,1,'352449090711261',3,0,11.5),(3082,'2018-03-08 12:20:37',60.0344,37.7947,119,'gps',0,43,1,'352449090711261',3,0,15.2),(3083,'2018-03-08 12:21:35',60.0343,37.7946,96.9,'gps',0,44,1,'352449090711261',3,0,10.6),(3084,'2018-03-08 12:22:34',60.0345,37.7939,131,'gps',0,45,1,'352449090711261',3,0,16.9),(3085,'2018-03-08 12:23:32',60.0343,37.7948,123.9,'gps',0,46,1,'352449090711261',3,0,17),(3086,'2018-03-08 12:24:32',60.0342,37.7945,116.6,'gps',0,47,1,'352449090711261',3,0,16.9),(3087,'2018-03-08 12:25:34',60.0343,37.7941,111.7,'gps',0,48,1,'352449090711261',3,0,11.2),(3088,'2018-03-08 12:26:34',60.0344,37.7941,130.5,'gps',0,48,1,'352449090711261',3,0,15.2),(3089,'2018-03-08 12:27:32',60.0343,37.7947,122.1,'gps',0,48,1,'352449090711261',3,0,16),(3090,'2018-03-08 12:28:34',60.0341,37.7942,62,'gps',0,49,1,'352449090711261',3,0,14.9),(3091,'2018-03-08 12:29:33',60.0342,37.7948,92.7,'gps',0,50,1,'352449090711261',3,0,15.1),(3092,'2018-03-08 12:30:34',60.0342,37.7942,88,'gps',0,51,1,'352449090711261',3,0,11.3),(3093,'2018-03-08 12:31:41',60.0355,37.7944,452.7,'gps',0,52,1,'352449090711261',3,0,14.5),(3094,'2018-03-08 12:31:43',60.0342,37.7947,0,'network',0,52,1,'352449090711261',3,0,50),(3095,'2018-03-08 12:33:16',60.0341,37.7952,75.1,'gps',0,52,1,'352449090711261',3,0,10.7),(3096,'2018-03-08 12:34:15',60.0343,37.7946,105.3,'gps',0,52,1,'352449090711261',3,0,10.4),(3097,'2018-03-08 12:34:34',60.0344,37.7951,149,'gps',0,54,1,'352449090711261',3,0,15.4),(3098,'2018-03-08 12:36:34',60.0341,37.7942,42.2,'gps',0,56,1,'352449090711261',3,0,8.1),(3099,'2018-03-08 12:36:36',60.0342,37.7947,0,'network',0,56,1,'352449090711261',3,0,50),(3100,'2018-03-08 12:37:17',60.0343,37.7948,68.3,'gps',0,56,1,'352449090711261',3,0,11),(3101,'2018-03-08 12:38:20',60.0344,37.7944,112.1,'gps',0,57,1,'352449090711261',3,0,12.4),(3102,'2018-03-08 12:38:22',60.0342,37.7947,0,'network',0,57,1,'352449090711261',3,0,50),(3103,'2018-03-08 12:38:47',60.0342,37.7946,0,'network',0,57,1,'352449090711261',3,0,20.4),(3104,'2018-03-08 12:39:38',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,20),(3105,'2018-03-08 12:40:37',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,20),(3106,'2018-03-08 12:41:38',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,26.4),(3107,'2018-03-08 12:43:10',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,24.9),(3108,'2018-03-08 12:43:40',60.0342,37.7957,81.6,'gps',0,57,0,'352449090711261',3,0,11.4),(3109,'2018-03-08 12:43:42',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,20),(3110,'2018-03-08 12:44:41',60.0343,37.7941,113.1,'gps',0,57,0,'352449090711261',3,0,9.5),(3111,'2018-03-08 12:44:43',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,20),(3112,'2018-03-08 12:46:10',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,26.4),(3113,'2018-03-08 14:01:52',59.9021,37.6722,0,'network',0,50,0,'352449090711261',3,0,20),(3114,'2018-03-08 15:01:18',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,104.1),(3115,'2018-03-08 15:01:59',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,72.9),(3116,'2018-03-08 15:04:09',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,82.5),(3117,'2018-03-08 15:05:18',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,60),(3118,'2018-03-08 15:05:55',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,20.4),(3119,'2018-03-08 15:07:10',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,20),(3120,'2018-03-08 15:08:43',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,30),(3121,'2018-03-08 15:09:56',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,20),(3122,'2018-03-08 15:13:10',59.9021,37.6722,0,'network',0,47,0,'352449090711261',3,0,20),(3123,'2018-03-08 15:53:50',59.9021,37.6722,0,'network',0,45,0,'352449090711261',3,0,20),(3124,'2018-03-08 15:54:17',59.9021,37.6722,0,'network',0,45,0,'352449090711261',3,0,20),(3125,'2018-03-08 17:14:29',59.9021,37.6722,0,'network',0,43,0,'352449090711261',3,0,20),(3126,'2018-03-08 18:14:51',59.9021,37.6722,0,'network',0,39,0,'352449090711261',3,0,23.6),(3127,'2018-03-08 19:15:27',59.9021,37.6722,0,'network',0,37,0,'352449090711261',3,0,30),(3128,'2018-03-08 19:30:33',59.9021,37.6722,0,'network',0,37,0,'352449090711261',3,0,30),(3129,'2018-03-08 19:45:37',59.9021,37.6722,0,'network',0,37,0,'352449090711261',3,0,34.4),(3130,'2018-03-09 00:17:23',59.9021,37.6722,0,'network',0,26,0,'352449090711261',3,0,20),(3131,'2018-03-09 02:03:22',59.9021,37.6722,0,'network',0,22,0,'352449090711261',3,0,20),(3132,'2018-03-09 03:18:53',59.9021,37.6722,0,'network',0,18,0,'352449090711261',3,0,20),(3133,'2018-03-09 03:34:00',59.9021,37.6722,0,'network',0,17,0,'352449090711261',3,0,20),(3134,'2018-03-09 04:19:17',59.9021,37.6722,0,'network',0,15,0,'352449090711261',3,0,20),(3135,'2018-03-09 05:19:39',59.9021,37.6722,0,'network',0,11,0,'352449090711261',3,0,20),(3136,'2018-03-09 05:49:53',59.9021,37.6722,0,'network',0,10,0,'352449090711261',3,0,20),(3137,'2018-03-09 06:35:11',59.9021,37.6722,0,'network',0,9,0,'352449090711261',3,0,20),(3138,'2018-03-09 08:05:44',59.9021,37.6722,0,'network',0,6,0,'352449090711261',3,0,20),(3139,'2018-03-12 07:45:03',60.0342,37.7946,0,'network',0,4,1,'352449090711261',3,0,20),(3140,'2018-03-12 07:45:47',60.0342,37.7946,0,'network',0,4,1,'352449090711261',3,0,20),(3141,'2018-03-12 07:47:12',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3142,'2018-03-12 07:47:45',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3143,'2018-03-12 07:48:45',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3144,'2018-03-12 07:50:26',60.034,37.795,-14.5,'gps',0,4,0,'352449090711261',3,0,10.8),(3145,'2018-03-12 07:50:28',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3146,'2018-03-12 07:50:59',60.0343,37.7948,-14.5,'gps',0,4,0,'352449090711261',3,0,5.4),(3147,'2018-03-12 07:51:01',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3148,'2018-03-12 08:01:17',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3149,'2018-03-12 08:02:17',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3150,'2018-03-12 08:03:26',60.0342,37.7955,-14.3,'gps',0,4,0,'352449090711261',3,0,6),(3151,'2018-03-12 08:03:28',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3152,'2018-03-12 08:05:48',60.0349,37.7958,-12.7,'gps',0,4,0,'352449090711261',3,0,4.8),(3153,'2018-03-12 08:05:50',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3154,'2018-03-12 08:11:41',60.0343,37.7953,-14,'gps',0,4,0,'352449090711261',3,0,6),(3155,'2018-03-12 08:14:17',60.0342,37.7952,-14.4,'gps',0,4,0,'352449090711261',3,0,5.7),(3156,'2018-03-12 08:14:29',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3157,'2018-03-12 08:14:53',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,20),(3158,'2018-03-12 08:15:53',60.0342,37.7946,0,'network',0,4,1,'352449090711261',3,0,20),(3159,'2018-03-12 08:16:53',60.0342,37.7946,0,'network',0,4,0,'352449090711261',3,0,30),(3160,'2018-03-12 13:45:48',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,22.5),(3161,'2018-03-12 13:46:31',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,30),(3162,'2018-03-12 13:47:11',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,20.4),(3163,'2018-03-12 13:48:07',60.0345,37.7946,-14.5,'gps',0,97,0,'352449090711261',3,0,9.4),(3164,'2018-03-12 13:49:07',60.0342,37.7945,-14,'gps',0,97,0,'352449090711261',3,0,6.4),(3165,'2018-03-12 13:50:41',60.0342,37.7946,-14.1,'gps',0,97,0,'352449090711261',3,0,6.7),(3166,'2018-03-12 13:50:43',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,20),(3167,'2018-03-12 13:51:11',60.0348,37.7947,-11.3,'gps',0,97,0,'352449090711261',3,0,4.7),(3168,'2018-03-12 13:52:08',60.0347,37.794,-13.9,'gps',0,97,0,'352449090711261',3,0,5.9),(3169,'2018-03-12 13:57:25',60.034,37.795,-14.2,'gps',0,97,0,'352449090711261',3,0,6.5),(3170,'2018-03-12 14:35:56',60.0341,37.7938,-13.1,'gps',0,95,0,'352449090711261',3,0,5.6),(3171,'2018-03-12 14:36:07',60.0342,37.7946,0,'network',0,95,0,'352449090711261',3,0,24.9),(3172,'2018-03-12 14:36:46',60.0342,37.7946,0,'network',0,95,0,'352449090711261',3,0,52.4),(3173,'2018-03-12 14:37:45',60.0342,37.7946,0,'network',0,95,0,'352449090711261',3,0,20),(3174,'2018-03-12 14:38:45',60.0342,37.7946,0,'network',0,95,0,'352449090711261',3,0,21.6),(3175,'2018-03-12 14:40:12',60.0342,37.7946,0,'network',0,95,0,'352449090711261',3,0,22.5),(3176,'2018-03-12 14:40:45',60.0342,37.7946,0,'network',0,94,0,'352449090711261',3,0,20.1),(3177,'2018-03-12 14:43:09',60.0342,37.7946,0,'network',0,94,0,'352449090711261',3,0,22.5),(3178,'2018-03-12 14:47:20',60.0346,37.7949,0,'network',0,94,0,'352449090711261',3,0,39.575),(3179,'2018-03-12 14:48:05',60.0345,37.7947,0,'network',0,94,0,'352449090711261',3,0,33.376),(3180,'2018-03-12 14:48:46',60.0344,37.7946,0,'network',0,94,0,'352449090711261',3,0,38.155),(3181,'2018-03-12 14:51:09',60.0342,37.7948,0,'network',0,94,0,'352449090711261',3,0,52.4),(3182,'2018-03-12 14:52:21',60.034,37.7934,-13.1,'gps',0,94,0,'352449090711261',3,0,5.8),(3183,'2018-03-12 14:52:23',60.0342,37.7946,0,'network',0,94,0,'352449090711261',3,0,42.5),(3184,'2018-03-12 15:01:22',60.0342,37.7946,0,'network',0,93,0,'352449090711261',3,0,28.1),(3185,'2018-03-12 15:02:23',60.0342,37.7946,0,'network',0,93,0,'352449090711261',3,0,24.9),(3186,'2018-03-12 15:03:23',60.0342,37.7946,0,'network',0,93,0,'352449090711261',3,0,24.9),(3187,'2018-03-12 15:04:24',60.0342,37.7946,0,'network',0,93,0,'352449090711261',3,0,30),(3188,'2018-03-12 15:05:23',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(3189,'2018-03-12 15:06:23',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(3190,'2018-03-12 15:08:36',60.0342,37.794,-14.4,'gps',0,92,0,'352449090711261',3,0,7.2),(3191,'2018-03-12 15:08:38',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(3192,'2018-03-12 15:09:46',60.0346,37.7947,-14.5,'gps',0,92,0,'352449090711261',3,0,4.6),(3193,'2018-03-12 15:09:48',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(3194,'2018-03-12 15:10:22',60.0346,37.7946,-14.5,'gps',0,92,0,'352449090711261',3,0,5.8),(3195,'2018-03-12 15:10:24',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(3196,'2018-03-12 15:11:10',60.0344,37.7944,-36.4,'gps',4.13,92,0,'352449090711261',3,0,4.2),(3197,'2018-03-12 15:11:22',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,32.1),(3198,'2018-03-12 15:12:24',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,20.9),(3199,'2018-03-12 15:14:10',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,20.9),(3200,'2018-03-12 15:14:41',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,20.9),(3201,'2018-03-12 15:16:09',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,21.6),(3202,'2018-03-12 15:17:47',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,20.4),(3203,'2018-03-12 15:18:23',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,21.6),(3204,'2018-03-12 15:19:23',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,42.5),(3205,'2018-03-12 15:20:23',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,24.9),(3206,'2018-03-12 15:21:22',60.0342,37.7937,-14.5,'gps',0,91,0,'352449090711261',3,0,5.3),(3207,'2018-03-12 15:22:22',60.0343,37.7938,-14.5,'gps',0,91,0,'352449090711261',3,0,5.4),(3208,'2018-03-12 15:23:21',60.0343,37.7943,-14.5,'gps',0,91,0,'352449090711261',3,0,5.5),(3209,'2018-03-12 15:23:23',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,20.4),(3210,'2018-03-12 15:24:24',60.0342,37.7948,0,'network',0,91,0,'352449090711261',3,0,64.1),(3211,'2018-03-12 15:25:23',60.0342,37.7946,0,'network',0,91,0,'352449090711261',3,0,24.9),(3212,'2018-03-12 15:42:20',60.0344,37.7944,31.3,'gps',0,89,0,'352449090711261',3,0,7.9),(3213,'2018-03-12 15:42:22',60.0342,37.7946,0,'network',0,89,0,'352449090711261',3,0,20.4),(3214,'2018-03-12 15:42:50',60.0341,37.7941,-12.9,'gps',0,89,0,'352449090711261',3,0,5.5),(3215,'2018-03-12 15:47:53',60.0343,37.7942,61.8,'gps',0,89,0,'352449090711261',3,0,6.6),(3216,'2018-03-12 15:48:05',60.0342,37.7946,0,'network',0,89,0,'352449090711261',3,0,42.5),(3217,'2018-03-12 15:48:23',60.0342,37.7946,0,'network',0,89,0,'352449090711261',3,0,23.6),(3218,'2018-03-12 15:49:24',60.0342,37.7946,0,'network',0,89,0,'352449090711261',3,0,20.9),(3219,'2018-03-12 15:50:23',60.0342,37.7946,0,'network',0,89,0,'352449090711261',3,0,20.4),(3220,'2018-03-12 15:51:23',60.0342,37.7946,0,'network',0,89,0,'352449090711261',3,0,20),(3221,'2018-03-12 15:54:29',60.0349,37.7942,-13.7,'gps',0,88,0,'352449090711261',3,0,5.1),(3222,'2018-03-12 15:54:31',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(3223,'2018-03-12 15:55:09',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(3224,'2018-03-12 16:01:11',60.0341,37.7942,65.3,'gps',0,88,0,'352449090711261',3,0,8.3),(3225,'2018-03-12 16:09:13',60.0347,37.7935,-14.4,'gps',0,87,0,'352449090711261',3,0,4.5),(3226,'2018-03-12 16:09:26',60.0342,37.7946,0,'network',0,87,0,'352449090711261',3,0,20),(3227,'2018-03-12 16:09:56',60.0342,37.7938,-13.7,'gps',0,87,0,'352449090711261',3,0,7.9),(3228,'2018-03-12 16:11:33',60.0343,37.7941,-14.4,'gps',0,87,0,'352449090711261',3,0,6.1),(3229,'2018-03-12 16:11:35',60.0342,37.7946,0,'network',0,87,0,'352449090711261',3,0,23.6),(3230,'2018-03-12 16:12:09',60.0342,37.7946,0,'network',0,87,0,'352449090711261',3,0,20.9),(3231,'2018-03-12 16:13:32',60.0344,37.7947,-12.5,'gps',0,87,0,'352449090711261',3,0,5.1),(3232,'2018-03-12 16:13:34',60.0341,37.7947,0,'network',0,87,0,'352449090711261',3,0,50),(3233,'2018-03-12 16:32:39',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3234,'2018-03-12 16:42:34',60.0342,37.7943,-13.4,'gps',0.15,86,0,'352449090711261',3,0,6.6),(3235,'2018-03-12 16:42:36',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20.1),(3236,'2018-03-12 17:00:44',60.0341,37.7945,-14.3,'gps',0,86,0,'352449090711261',3,0,6.7),(3237,'2018-03-12 17:00:45',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20.9),(3238,'2018-03-12 17:01:16',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,36.9),(3239,'2018-03-12 17:02:54',60.0343,37.7947,-14.4,'gps',0,86,0,'352449090711261',3,0,4.8),(3240,'2018-03-12 17:02:56',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3241,'2018-03-12 17:03:20',60.0341,37.7945,-14.4,'gps',0,86,0,'352449090711261',3,0,5.1),(3242,'2018-03-12 17:03:21',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3243,'2018-03-12 17:04:20',60.034,37.7945,-14.4,'gps',0,86,0,'352449090711261',3,0,6.1),(3244,'2018-03-12 17:04:22',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3245,'2018-03-12 17:07:51',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3246,'2018-03-12 17:08:37',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3247,'2018-03-12 17:11:09',60.0338,37.7945,-14.5,'gps',0,86,0,'352449090711261',3,0,6.7),(3248,'2018-03-12 17:11:11',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3249,'2018-03-12 17:25:16',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3250,'2018-03-12 17:25:28',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3251,'2018-03-12 17:25:44',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3252,'2018-03-12 17:26:56',60.0338,37.7948,-14.4,'gps',0,86,0,'352449090711261',3,0,7),(3253,'2018-03-12 17:26:58',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3254,'2018-03-12 17:27:46',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20.4),(3255,'2018-03-12 17:28:44',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,28.1),(3256,'2018-03-12 17:29:45',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3257,'2018-03-12 17:30:44',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3258,'2018-03-12 17:31:45',60.0342,37.7946,0,'network',0,86,0,'352449090711261',3,0,20),(3259,'2018-03-12 17:32:59',60.0342,37.7946,0,'network',0,85,0,'352449090711261',3,0,20),(3260,'2018-03-12 17:33:45',60.0342,37.7946,0,'network',0,85,0,'352449090711261',3,0,20),(3261,'2018-03-12 17:34:52',60.0335,37.7947,-14.3,'gps',0,85,0,'352449090711261',3,0,7.1),(3262,'2018-03-12 17:34:54',60.0342,37.7946,0,'network',0,85,0,'352449090711261',3,0,20),(3263,'2018-03-12 17:37:45',60.034,37.7948,-14.5,'gps',0,85,0,'352449090711261',3,0,4),(3264,'2018-03-12 17:37:47',60.0342,37.7946,0,'network',0,85,0,'352449090711261',3,0,20),(3265,'2018-03-12 17:40:09',60.0337,37.7946,-14.4,'gps',0,85,0,'352449090711261',3,0,6.5),(3266,'2018-03-12 17:40:21',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3267,'2018-03-12 17:41:23',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3268,'2018-03-12 17:43:29',60.0338,37.7939,-14.4,'gps',0,84,0,'352449090711261',3,0,5.5),(3269,'2018-03-12 17:43:31',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3270,'2018-03-12 17:43:51',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3271,'2018-03-12 17:44:21',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3272,'2018-03-12 17:45:23',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3273,'2018-03-12 17:48:30',60.0339,37.7947,-52.9,'gps',0,84,0,'352449090711261',3,0,6.8),(3274,'2018-03-12 17:48:32',60.0342,37.7946,0,'network',0,84,0,'352449090711261',3,0,20),(3275,'2018-03-12 18:09:24',60.0342,37.7946,0,'network',0,83,0,'352449090711261',3,0,20),(3276,'2018-03-12 18:10:24',60.0342,37.7946,0,'network',0,83,0,'352449090711261',3,0,20),(3277,'2018-03-12 18:11:35',60.0342,37.7946,0,'network',0,83,0,'352449090711261',3,0,20),(3278,'2018-03-12 18:12:25',60.0342,37.7946,0,'network',0,83,0,'352449090711261',3,0,20),(3279,'2018-03-12 18:14:27',60.0339,37.7944,-14.5,'gps',0,83,0,'352449090711261',3,0,6.3),(3280,'2018-03-12 18:14:29',60.0342,37.7946,0,'network',0,83,0,'352449090711261',3,0,20),(3281,'2018-03-12 18:15:09',60.0342,37.7946,0,'network',0,83,0,'352449090711261',3,0,20),(3282,'2018-03-12 18:26:39',60.0339,37.7944,40.6,'gps',0,82,0,'352449090711261',3,0,5.2),(3283,'2018-03-12 18:27:11',60.0342,37.7946,0,'network',0,82,0,'352449090711261',3,0,20),(3284,'2018-03-12 18:28:11',60.0342,37.7946,0,'network',0,82,0,'352449090711261',3,0,20),(3285,'2018-03-12 18:29:13',60.0342,37.7946,0,'network',0,82,0,'352449090711261',3,0,20),(3286,'2018-03-12 18:30:14',60.0336,37.7953,-14.5,'gps',0,82,0,'352449090711261',3,0,6.4),(3287,'2018-03-12 18:30:15',60.0342,37.7946,0,'network',0,82,0,'352449090711261',3,0,20),(3288,'2018-03-12 18:31:35',60.0342,37.7946,0,'network',0,82,0,'352449090711261',3,0,20),(3289,'2018-03-12 18:32:12',60.0342,37.7946,0,'network',0,82,0,'352449090711261',3,0,20),(3290,'2018-03-12 18:33:12',60.0342,37.7946,0,'network',0,81,0,'352449090711261',3,0,39.6),(3291,'2018-03-12 18:34:12',60.0342,37.7946,0,'network',0,81,0,'352449090711261',3,0,20),(3292,'2018-03-12 18:35:26',60.0327,37.7945,-14.3,'gps',16.48,81,0,'352449090711261',3,0,8.2),(3293,'2018-03-12 18:35:28',60.0342,37.7946,0,'network',0,81,0,'352449090711261',3,0,50),(3294,'2018-03-12 19:03:07',60.0337,37.7951,-54.2,'gps',0,80,0,'352449090711261',3,0,5.3),(3295,'2018-03-12 19:03:24',60.0342,37.7946,0,'network',0,80,0,'352449090711261',3,0,20),(3296,'2018-03-12 19:04:25',60.0342,37.7946,0,'network',0,80,0,'352449090711261',3,0,42.5),(3297,'2018-03-12 19:05:24',60.0342,37.7946,0,'network',0,80,0,'352449090711261',3,0,20.1),(3298,'2018-03-12 19:06:24',60.0342,37.7946,0,'network',0,80,0,'352449090711261',3,0,20),(3299,'2018-03-12 19:09:31',60.0339,37.7949,32.4,'gps',0,80,0,'352449090711261',3,0,6.3),(3300,'2018-03-12 19:09:33',60.0342,37.7946,0,'network',0,80,0,'352449090711261',3,0,20),(3301,'2018-03-12 19:15:34',60.0337,37.7951,-3.6,'gps',0,79,0,'352449090711261',3,0,6.4),(3302,'2018-03-12 19:59:59',60.0343,37.7956,-8,'gps',0,79,0,'352449090711261',3,0,5.6),(3303,'2018-03-12 20:00:08',60.0342,37.7959,17,'gps',0,79,0,'352449090711261',3,0,8.1),(3304,'2018-03-12 20:01:03',60.0342,37.7946,0,'network',0,79,0,'352449090711261',3,0,22.5),(3305,'2018-03-12 20:03:25',60.034,37.7942,-14.5,'gps',0,79,0,'352449090711261',3,0,3.8),(3306,'2018-03-12 20:03:27',60.0343,37.7947,0,'network',0,79,0,'352449090711261',3,0,50),(3307,'2018-03-12 20:04:02',60.0341,37.795,-13.8,'gps',0,79,0,'352449090711261',3,0,4.3),(3308,'2018-03-12 20:04:04',60.0342,37.795,0,'network',0,79,0,'352449090711261',3,0,50),(3309,'2018-03-12 20:37:23',60.0341,37.795,-22,'gps',0,79,0,'352449090711261',3,0,5.4),(3310,'2018-03-12 20:37:36',60.0342,37.7946,0,'network',0,79,0,'352449090711261',3,0,36.9),(3311,'2018-03-12 20:38:09',60.0342,37.7946,0,'network',0,79,0,'352449090711261',3,0,36.9),(3312,'2018-03-12 20:39:09',60.0342,37.7946,0,'network',0,79,0,'352449090711261',3,0,26.4),(3313,'2018-03-12 21:05:49',60.0342,37.7946,0,'network',0,78,0,'352449090711261',3,0,23.6),(3314,'2018-03-12 21:06:43',60.0342,37.7946,0,'network',0,78,0,'352449090711261',3,0,34.4),(3315,'2018-03-12 21:07:43',60.0342,37.7946,0,'network',0,78,0,'352449090711261',3,0,20.4),(3316,'2018-03-12 21:09:09',60.0342,37.7946,0,'network',0,78,0,'352449090711261',3,0,20.1),(3317,'2018-03-12 21:10:31',60.0341,37.7946,-14.6,'gps',0,78,0,'352449090711261',3,0,6.7),(3318,'2018-03-12 21:10:33',60.0342,37.7946,0,'network',0,78,0,'352449090711261',3,0,30),(3319,'2018-03-12 21:12:09',60.0342,37.7946,0,'network',0,78,0,'352449090711261',3,0,28.1),(3320,'2018-03-12 21:27:07',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,22.5),(3321,'2018-03-12 21:27:59',60.034,37.7942,-14.4,'gps',0,76,0,'352449090711261',3,0,5.7),(3322,'2018-03-12 21:29:02',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,30),(3323,'2018-03-12 21:30:02',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,42.5),(3324,'2018-03-12 21:31:03',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,34.4),(3325,'2018-03-12 21:32:04',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,20.9),(3326,'2018-03-12 21:33:03',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,34.4),(3327,'2018-03-12 21:34:02',60.034,37.7943,-14.4,'gps',0,76,0,'352449090711261',3,0,6.9),(3328,'2018-03-12 21:34:03',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,26.4),(3329,'2018-03-12 21:35:06',60.0343,37.7944,-14.4,'gps',0,76,0,'352449090711261',3,0,5.1),(3330,'2018-03-12 21:35:08',60.0343,37.7949,0,'network',0,76,0,'352449090711261',3,0,50),(3331,'2018-03-12 21:36:07',60.0342,37.7937,-14.2,'gps',0,76,0,'352449090711261',3,0,4.7),(3332,'2018-03-12 21:36:09',60.0342,37.7946,0,'network',0,76,0,'352449090711261',3,0,28.1),(3333,'2018-03-12 22:37:40',60.0343,37.7949,85.4,'gps',0.17,75,0,'352449090711261',3,0,4.6),(3334,'2018-03-12 22:37:42',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,28.1),(3335,'2018-03-12 22:57:40',60.0342,37.7942,-14.5,'gps',0,75,0,'352449090711261',3,0,4.2),(3336,'2018-03-12 22:57:42',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,32.1),(3337,'2018-03-12 22:58:40',60.0341,37.7935,-14.5,'gps',2.31,75,0,'352449090711261',3,0,4.1),(3338,'2018-03-12 22:58:42',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,32.1),(3339,'2018-03-12 22:59:15',60.0342,37.7943,-14.5,'gps',0,75,0,'352449090711261',3,0,4.7),(3340,'2018-03-12 22:59:16',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,32.1),(3341,'2018-03-12 23:00:36',60.034,37.7943,-14.5,'gps',0.5,75,0,'352449090711261',3,0,5.1),(3342,'2018-03-12 23:00:38',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,28.1),(3343,'2018-03-12 23:01:27',60.0341,37.7935,-14.5,'gps',0,75,0,'352449090711261',3,0,4.5),(3344,'2018-03-12 23:01:29',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,30),(3345,'2018-03-12 23:02:55',60.0344,37.7973,-14.6,'gps',0,75,0,'352449090711261',3,0,5.8),(3346,'2018-03-12 23:02:57',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,28.1),(3347,'2018-03-12 23:03:37',60.0341,37.7969,-12.6,'gps',1.09,75,0,'352449090711261',3,0,6.7),(3348,'2018-03-12 23:03:39',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,30),(3349,'2018-03-12 23:06:21',60.034,37.7941,-12.9,'gps',0,75,0,'352449090711261',3,0,8.1),(3350,'2018-03-12 23:06:23',60.0342,37.7946,0,'network',0,75,0,'352449090711261',3,0,28.1),(3351,'2018-03-13 02:26:23',60.0335,37.7946,-14.5,'gps',0,68,0,'352449090711261',3,0,4.6),(3352,'2018-03-13 03:11:49',60.0338,37.7944,-11,'gps',0,67,0,'352449090711261',3,0,6.1),(3353,'2018-03-13 03:24:14',60.034,37.7941,85.3,'gps',0,67,0,'352449090711261',3,0,7),(3354,'2018-03-13 03:25:17',60.0342,37.7941,-14.3,'gps',0,67,0,'352449090711261',3,0,6.7),(3355,'2018-03-13 03:26:16',60.0342,37.7943,-14.3,'gps',0,67,0,'352449090711261',3,0,5.3),(3356,'2018-03-13 03:42:08',60.0341,37.7939,47.7,'gps',0,67,0,'352449090711261',3,0,5.7),(3357,'2018-03-13 06:29:05',60.0343,37.795,-14.3,'gps',0,61,0,'352449090711261',3,0,6.9),(3358,'2018-03-13 06:59:15',60.0344,37.7951,74.3,'gps',0,60,0,'352449090711261',3,0,5),(3359,'2018-03-13 07:14:23',60.0343,37.7952,-104.1,'gps',0,60,0,'352449090711261',3,0,6.7),(3360,'2018-03-13 07:21:43',60.0345,37.7951,-52.9,'gps',0,60,0,'352449090711261',3,0,4.7),(3361,'2018-03-13 07:21:55',60.0342,37.7946,0,'network',0,60,0,'352449090711261',3,0,20),(3362,'2018-03-13 07:22:22',60.0345,37.7951,-14.5,'gps',0,60,0,'352449090711261',3,0,5.8),(3363,'2018-03-13 07:25:18',60.0344,37.7952,96.7,'gps',0,60,0,'352449090711261',3,0,6.9),(3364,'2018-03-13 07:26:20',60.0344,37.7951,-14.3,'gps',0,60,0,'352449090711261',3,0,7.6),(3365,'2018-03-13 07:26:22',60.0342,37.7946,0,'network',0,60,0,'352449090711261',3,0,20),(3366,'2018-03-13 07:32:12',60.0343,37.7952,113.8,'gps',0,60,0,'352449090711261',3,0,6.9),(3367,'2018-03-13 07:37:39',60.0343,37.7979,-14.5,'gps',0,60,0,'352449090711261',3,0,20.7),(3368,'2018-03-13 07:37:50',60.0343,37.7954,-14.3,'gps',0,60,0,'352449090711261',3,0,6.3),(3369,'2018-03-13 07:38:23',60.0342,37.7946,0,'network',0,60,0,'352449090711261',3,0,22.5),(3370,'2018-03-13 07:39:23',60.0342,37.7946,0,'network',0,60,0,'352449090711261',3,0,30),(3371,'2018-03-13 07:40:24',60.0342,37.7946,0,'network',0,60,0,'352449090711261',3,0,23.6),(3372,'2018-03-13 07:41:23',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,24.9),(3373,'2018-03-13 07:42:23',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,45.6),(3374,'2018-03-13 07:43:24',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,24.9),(3375,'2018-03-13 07:44:39',60.0343,37.7953,-14.5,'gps',0,58,0,'352449090711261',3,0,6.2),(3376,'2018-03-13 07:44:40',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,36.9),(3377,'2018-03-13 07:47:07',60.0344,37.7954,-14.5,'gps',0,58,0,'352449090711261',3,0,4.9),(3378,'2018-03-13 07:47:09',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20.1),(3379,'2018-03-13 07:57:19',60.0343,37.7953,33.9,'gps',0,58,0,'352449090711261',3,0,6.7),(3380,'2018-03-13 07:58:22',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20),(3381,'2018-03-13 08:01:58',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20.4),(3382,'2018-03-13 08:02:23',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20.1),(3383,'2018-03-13 08:04:14',60.0339,37.7942,108.6,'gps',0.25,58,0,'352449090711261',3,0,5.6),(3384,'2018-03-13 15:52:53',60.0343,37.7956,73.7,'gps',0,35,0,'352449090711261',3,0,8.3),(3385,'2018-03-13 16:01:09',60.0341,37.7953,-12.9,'gps',0,35,0,'352449090711261',3,0,4.6),(3386,'2018-03-13 16:01:20',60.0343,37.7953,-14.3,'gps',0,35,0,'352449090711261',3,0,6.3),(3387,'2018-03-13 16:01:22',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,28.1),(3388,'2018-03-13 16:02:08',60.0343,37.7954,-14.2,'gps',0,35,0,'352449090711261',3,0,6.1),(3389,'2018-03-13 16:02:10',60.0343,37.795,0,'network',0,35,0,'352449090711261',3,0,50),(3390,'2018-03-13 16:03:20',60.0343,37.7962,-11.5,'gps',0,35,0,'352449090711261',3,0,5.8),(3391,'2018-03-13 16:03:22',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,32.1),(3392,'2018-03-13 16:04:19',60.0343,37.7956,-14.4,'gps',0,35,0,'352449090711261',3,0,5),(3393,'2018-03-13 16:05:26',60.0342,37.7954,-14.4,'gps',0,35,0,'352449090711261',3,0,4.6),(3394,'2018-03-13 16:05:28',60.0343,37.7947,0,'network',0,35,0,'352449090711261',3,0,50),(3395,'2018-03-13 17:05:32',60.0342,37.7945,116.8,'gps',0,35,0,'352449090711261',3,0,6.2),(3396,'2018-03-13 17:05:33',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,50),(3397,'2018-03-13 17:06:11',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,20),(3398,'2018-03-13 17:07:11',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,23.6),(3399,'2018-03-13 17:08:11',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,20),(3400,'2018-03-13 17:55:34',60.0338,37.7944,76.9,'gps',0,33,0,'352449090711261',3,0,6.9),(3401,'2018-03-13 17:55:45',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3402,'2018-03-13 17:56:43',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3403,'2018-03-13 17:58:40',60.0341,37.7942,-11.9,'gps',0,33,0,'352449090711261',3,0,4.9),(3404,'2018-03-13 17:58:41',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3405,'2018-03-13 17:59:23',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3406,'2018-03-13 17:59:40',60.0339,37.7945,-14.3,'gps',0,33,0,'352449090711261',3,0,6.9),(3407,'2018-03-13 18:00:41',60.0338,37.7946,-14.4,'gps',0,33,0,'352449090711261',3,0,7.2),(3408,'2018-03-13 18:01:43',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3409,'2018-03-13 18:02:45',60.0343,37.7942,-13.9,'gps',0,33,0,'352449090711261',3,0,6.6),(3410,'2018-03-13 18:02:47',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3411,'2018-03-13 18:04:23',60.0343,37.795,-12.1,'gps',0,33,0,'352449090711261',3,0,5.6),(3412,'2018-03-13 18:04:25',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3413,'2018-03-13 18:05:22',60.0339,37.7943,-14.4,'gps',0,33,0,'352449090711261',3,0,6.6),(3414,'2018-03-13 18:05:23',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3415,'2018-03-13 18:36:21',60.0342,37.7946,0,'network',0,32,0,'352449090711261',3,0,20),(3416,'2018-03-13 18:37:17',60.034,37.7945,-14.5,'gps',0,32,0,'352449090711261',3,0,6.1),(3417,'2018-03-13 18:38:18',60.0341,37.7942,-14.5,'gps',0,32,0,'352449090711261',3,0,6.2),(3418,'2018-03-13 18:39:16',60.0343,37.7945,-14.2,'gps',0,32,0,'352449090711261',3,0,6),(3419,'2018-03-13 18:40:19',60.034,37.7945,-14.5,'gps',0,32,0,'352449090711261',3,0,6.4),(3420,'2018-03-13 18:47:11',60.034,37.7946,34.7,'gps',0,32,0,'352449090711261',3,0,6.4),(3421,'2018-03-13 19:13:57',60.034,37.7946,-2.3,'gps',0,31,0,'352449090711261',3,0,6.4),(3422,'2018-03-13 19:14:09',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,26.4),(3423,'2018-03-13 19:15:07',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,20),(3424,'2018-03-13 19:16:08',60.0339,37.7947,-14.2,'gps',0,31,0,'352449090711261',3,0,6.2),(3425,'2018-03-13 19:16:09',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,20.1),(3426,'2018-03-13 19:17:08',60.034,37.7945,-14.5,'gps',0,31,0,'352449090711261',3,0,6.2),(3427,'2018-03-13 19:17:10',60.0343,37.7946,0,'network',0,31,0,'352449090711261',3,0,50),(3428,'2018-03-13 19:52:57',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,39.6),(3429,'2018-03-13 19:53:49',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,20.4),(3430,'2018-03-13 19:54:48',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,20.1),(3431,'2018-03-13 19:56:29',60.0341,37.7944,-12.2,'gps',0,31,0,'352449090711261',3,0,4.2),(3432,'2018-03-13 19:56:32',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,20.1),(3433,'2018-03-13 19:58:51',60.0351,37.7941,57.5,'gps',4.17,31,0,'352449090711261',3,0,5.3),(3434,'2018-03-13 19:58:55',60.0342,37.7946,0,'network',0,31,0,'352449090711261',3,0,20.1),(3435,'2018-03-13 20:32:42',60.0336,37.7943,-14.5,'gps',0,30,0,'352449090711261',3,0,7.1),(3436,'2018-03-13 20:32:54',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20),(3437,'2018-03-13 20:33:34',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20),(3438,'2018-03-13 20:35:58',60.033,37.7948,-14.5,'gps',1.83,30,0,'352449090711261',3,0,5.2),(3439,'2018-03-13 20:36:00',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20),(3440,'2018-03-13 20:36:25',60.0335,37.7942,-15,'gps',0,30,0,'352449090711261',3,0,5),(3441,'2018-03-13 20:36:27',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20),(3442,'2018-03-13 20:38:21',60.0335,37.7946,-14.1,'gps',0,30,0,'352449090711261',3,0,4.7),(3443,'2018-03-13 20:38:21',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20),(3444,'2018-03-13 20:38:33',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20),(3445,'2018-03-13 20:39:34',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,20.9),(3446,'2018-03-13 20:40:34',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,26.4),(3447,'2018-03-13 20:42:09',60.0342,37.7946,0,'network',0,30,0,'352449090711261',3,0,22.5),(3448,'2018-03-13 20:49:51',60.0334,37.7949,-14.4,'gps',0,30,0,'352449090711261',3,0,5.2),(3449,'2018-03-13 21:03:52',60.0342,37.7946,-25.9,'gps',0,29,0,'352449090711261',3,0,4.7),(3450,'2018-03-13 21:04:03',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20.9),(3451,'2018-03-13 21:04:59',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,23.6),(3452,'2018-03-13 21:05:59',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,24.9),(3453,'2018-03-13 21:10:29',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20),(3454,'2018-03-13 21:10:59',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20.9),(3455,'2018-03-13 21:12:00',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20.4),(3456,'2018-03-13 21:13:09',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20.9),(3457,'2018-03-13 21:14:20',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20.9),(3458,'2018-03-13 21:15:10',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,20.9),(3459,'2018-03-13 21:16:10',60.0342,37.7946,0,'network',0,29,0,'352449090711261',3,0,23.6),(3460,'2018-03-13 21:32:07',60.0341,37.7951,49.4,'gps',0,28,0,'352449090711261',3,0,4.8),(3461,'2018-03-13 21:35:57',60.0343,37.7945,-13.8,'gps',0,28,0,'352449090711261',3,0,4.5),(3462,'2018-03-13 21:36:09',60.0342,37.7946,0,'network',0,28,0,'352449090711261',3,0,20.1),(3463,'2018-03-13 21:36:37',60.0342,37.7946,0,'network',0,28,0,'352449090711261',3,0,20.4),(3464,'2018-03-13 21:37:41',60.0342,37.7945,-14.1,'gps',0,28,0,'352449090711261',3,0,5.4),(3465,'2018-03-13 21:37:43',60.0343,37.7949,0,'network',0,28,0,'352449090711261',3,0,50),(3466,'2018-03-13 21:38:35',60.0341,37.7946,-13.9,'gps',0,28,0,'352449090711261',3,0,6.6),(3467,'2018-03-13 21:39:48',60.0342,37.7947,-14.4,'gps',0,28,0,'352449090711261',3,0,6.8),(3468,'2018-03-13 21:40:34',60.0341,37.7956,-13.4,'gps',0,28,0,'352449090711261',3,0,5.3),(3469,'2018-03-13 21:41:32',60.034,37.7955,-13.1,'gps',0,28,0,'352449090711261',3,0,5.6),(3470,'2018-03-13 21:43:49',60.0342,37.7951,-13.5,'gps',0,28,0,'352449090711261',3,0,6.5),(3471,'2018-03-13 21:44:34',60.0341,37.7951,-13.9,'gps',0,28,0,'352449090711261',3,0,5.6),(3472,'2018-03-13 21:49:51',60.0341,37.7951,-14.3,'gps',0,28,0,'352449090711261',3,0,6.8),(3473,'2018-03-14 00:02:21',60.0339,37.795,-14.4,'gps',0,25,0,'352449090711261',3,0,6.4),(3474,'2018-03-14 00:13:11',60.0342,37.7947,83.5,'gps',0,25,0,'352449090711261',3,0,5.8),(3475,'2018-03-14 00:13:19',60.034,37.7946,-14.2,'gps',0,25,0,'352449090711261',3,0,5.3),(3476,'2018-03-14 00:14:16',60.034,37.7946,-14.2,'gps',0,25,0,'352449090711261',3,0,5.6),(3477,'2018-03-14 01:48:21',60.0341,37.7942,135.7,'gps',0,23,0,'352449090711261',3,0,4.9),(3478,'2018-03-14 02:48:45',60.0343,37.7939,98.3,'gps',0,22,0,'352449090711261',3,0,5.5),(3479,'2018-03-14 04:04:34',60.0343,37.7939,103.1,'gps',0,21,0,'352449090711261',3,0,5.9),(3480,'2018-03-14 04:19:44',60.0343,37.7942,88.5,'gps',0.1,21,0,'352449090711261',3,0,7.3),(3481,'2018-03-14 04:30:14',60.0343,37.7946,30.6,'gps',0,21,0,'352449090711261',3,0,6.1),(3482,'2018-03-14 04:31:15',60.0343,37.7948,-13.9,'gps',0,21,0,'352449090711261',3,0,6.1),(3483,'2018-03-14 04:32:17',60.0345,37.7954,-13.4,'gps',0.63,21,0,'352449090711261',3,0,8.1),(3484,'2018-03-14 04:33:13',60.0346,37.7961,-13.8,'gps',0,21,0,'352449090711261',3,0,6.2),(3485,'2018-03-14 04:34:14',60.0345,37.7952,-14.1,'gps',0,21,0,'352449090711261',3,0,6.1),(3486,'2018-03-14 04:50:14',60.0344,37.7951,37.7,'gps',0,20,0,'352449090711261',3,0,6.1),(3487,'2018-03-14 06:51:30',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,20.9),(3488,'2018-03-14 06:52:18',60.0344,37.7961,-14.4,'gps',0,16,0,'352449090711261',3,0,6.7),(3489,'2018-03-14 07:02:13',60.0342,37.7952,-32.5,'gps',0,16,0,'352449090711261',3,0,6.7),(3490,'2018-03-14 07:08:58',60.0343,37.7952,-23.4,'gps',0,16,0,'352449090711261',3,0,4.7),(3491,'2018-03-14 07:09:09',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,20),(3492,'2018-03-14 07:09:54',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,20.4),(3493,'2018-03-14 07:10:55',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,20),(3494,'2018-03-14 07:12:09',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,20),(3495,'2018-03-14 07:12:55',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,32.1),(3496,'2018-03-14 07:13:54',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,26.4),(3497,'2018-03-14 07:14:55',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,20),(3498,'2018-03-14 07:17:24',60.0342,37.796,-14.3,'gps',0,16,0,'352449090711261',3,0,5.7),(3499,'2018-03-14 07:17:25',60.0342,37.7946,0,'network',0,16,0,'352449090711261',3,0,28.1),(3500,'2018-03-14 07:18:45',60.0342,37.7953,-14.1,'gps',0,15,0,'352449090711261',3,0,4.9),(3501,'2018-03-14 07:18:47',60.0342,37.7946,0,'network',0,15,0,'352449090711261',3,0,36.9),(3502,'2018-03-14 07:24:14',60.0342,37.7953,11.5,'gps',0,15,0,'352449090711261',3,0,4.9),(3503,'2018-03-14 07:27:43',60.0342,37.7946,0,'network',0,15,0,'352449090711261',3,0,30),(3504,'2018-03-14 07:28:24',60.0342,37.7946,0,'network',0,15,0,'352449090711261',3,0,22.5),(3505,'2018-03-14 07:29:19',60.0343,37.7952,-14.2,'gps',0,15,1,'352449090711261',3,0,6.2),(3506,'2018-03-14 07:30:20',60.0343,37.7955,-14.5,'gps',0,15,1,'352449090711261',3,0,7.4),(3507,'2018-03-14 07:33:17',60.0344,37.7956,22,'gps',0,15,1,'352449090711261',3,0,5.2),(3508,'2018-03-14 07:34:13',60.0345,37.7953,-14.5,'gps',0,15,1,'352449090711261',3,0,5.5),(3509,'2018-03-14 07:35:16',60.0344,37.7949,-14.3,'gps',0,15,1,'352449090711261',3,0,5.3),(3510,'2018-03-14 07:36:19',60.0344,37.7946,-14.4,'gps',0,15,1,'352449090711261',3,0,4.7),(3511,'2018-03-14 07:36:21',60.0342,37.7946,0,'network',0,15,1,'352449090711261',3,0,20),(3512,'2018-03-14 07:37:18',60.0344,37.7951,-14.4,'gps',0,15,1,'352449090711261',3,0,5.7),(3513,'2018-03-14 07:37:20',60.0342,37.7946,0,'network',0,15,1,'352449090711261',3,0,20),(3514,'2018-03-14 07:38:16',60.0344,37.7946,-14.5,'gps',0,15,1,'352449090711261',3,0,6),(3515,'2018-03-14 07:39:31',60.0345,37.7953,-14.5,'gps',0,16,1,'352449090711261',3,0,7.5),(3516,'2018-03-14 07:39:33',60.0342,37.7946,0,'network',0,16,1,'352449090711261',3,0,20),(3517,'2018-03-14 07:41:16',60.0344,37.7942,-14.4,'gps',0,17,1,'352449090711261',3,0,5.5),(3518,'2018-03-14 07:42:20',60.0345,37.7946,-14.6,'gps',0,18,1,'352449090711261',3,0,5.8),(3519,'2018-03-14 07:42:21',60.0342,37.7946,0,'network',0,18,1,'352449090711261',3,0,20),(3520,'2018-03-14 07:43:20',60.0345,37.7952,-14.3,'gps',0,19,1,'352449090711261',3,0,5.7),(3521,'2018-03-14 07:43:22',60.0342,37.7946,0,'network',0,19,1,'352449090711261',3,0,50),(3522,'2018-03-14 07:44:16',60.0343,37.7951,-14.4,'gps',0,20,1,'352449090711261',3,0,6.4),(3523,'2018-03-14 07:45:19',60.0343,37.7943,-14.2,'gps',0,21,1,'352449090711261',3,0,6),(3524,'2018-03-14 07:45:20',60.0342,37.7946,0,'network',0,21,1,'352449090711261',3,0,20),(3525,'2018-03-14 07:47:02',60.0343,37.7949,-14.4,'gps',0,23,1,'352449090711261',3,0,6.2),(3526,'2018-03-14 07:47:31',60.0342,37.7946,0,'network',0,23,1,'352449090711261',3,0,24.9),(3527,'2018-03-14 07:48:23',60.0342,37.7946,0,'network',0,24,1,'352449090711261',3,0,23.6),(3528,'2018-03-14 07:51:10',60.0342,37.7946,0,'network',0,24,1,'352449090711261',3,0,28.1),(3529,'2018-03-14 07:51:39',60.0342,37.7946,0,'network',0,24,1,'352449090711261',3,0,24.9),(3530,'2018-03-14 07:52:23',60.0342,37.7946,0,'network',0,24,1,'352449090711261',3,0,24.9),(3531,'2018-03-14 07:58:33',60.0342,37.7946,0,'network',0,27,0,'352449090711261',3,0,20.9),(3532,'2018-03-14 07:59:24',60.0342,37.7946,0,'network',0,27,0,'352449090711261',3,0,28.1),(3533,'2018-03-14 08:00:23',60.0342,37.7946,0,'network',0,27,1,'352449090711261',3,0,42.5),(3534,'2018-03-14 08:03:05',60.0354,37.7942,-1,'gps',0,27,1,'352449090711261',3,0,10.2),(3535,'2018-03-14 08:04:42',60.035,37.7946,17.5,'gps',0,27,1,'352449090711261',3,0,8.3),(3536,'2018-03-14 08:04:44',60.0342,37.7946,0,'network',0,27,1,'352449090711261',3,0,30),(3537,'2018-03-15 20:33:21',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,20.1),(3538,'2018-03-15 20:35:08',60.0342,37.7946,0,'network',0,35,0,'352449090711261',3,0,20.1),(3539,'2018-03-15 21:01:45',60.0342,37.7946,0,'network',0,34,0,'352449090711261',3,0,20),(3540,'2018-03-15 21:02:44',60.0342,37.7946,0,'network',0,34,0,'352449090711261',3,0,20),(3541,'2018-03-15 21:04:59',60.0348,37.7957,-14.7,'gps',0,34,0,'352449090711261',3,0,4.4),(3542,'2018-03-15 21:05:01',60.0342,37.7946,0,'network',0,34,0,'352449090711261',3,0,20),(3543,'2018-03-15 21:05:52',60.034,37.7949,35.8,'gps',0,34,0,'352449090711261',3,0,5.6),(3544,'2018-03-15 21:05:53',60.0342,37.7946,0,'network',0,34,0,'352449090711261',3,0,20),(3545,'2018-03-15 21:06:19',60.0342,37.7955,-13.9,'gps',0,34,0,'352449090711261',3,0,5.5),(3546,'2018-03-15 21:06:21',60.0342,37.7946,0,'network',0,34,0,'352449090711261',3,0,20),(3547,'2018-03-15 21:21:55',60.0342,37.7946,0,'network',0,33,0,'352449090711261',3,0,20),(3548,'2018-03-15 21:59:48',60.0343,37.7956,60.5,'gps',0,33,0,'352449090711261',3,0,5.1),(3549,'2018-03-15 22:00:00',60.0345,37.7957,-14.3,'gps',0,33,0,'352449090711261',3,0,5.3),(3550,'2018-03-15 22:00:24',60.0343,37.7951,-14.1,'gps',0,33,1,'352449090711261',3,0,6.7),(3551,'2018-03-15 22:01:20',60.0344,37.7957,7.5,'gps',0,33,1,'352449090711261',3,0,6),(3552,'2018-03-15 22:02:18',60.0344,37.7956,-14.2,'gps',0,33,1,'352449090711261',3,0,6.5),(3553,'2018-03-15 22:03:20',60.0341,37.7943,-11.6,'gps',0,33,1,'352449090711261',3,0,5.4),(3554,'2018-03-15 22:04:18',60.0342,37.7952,-14.1,'gps',0,33,1,'352449090711261',3,0,6.8),(3555,'2018-03-15 22:06:14',60.0343,37.7963,-13.3,'gps',0,34,1,'352449090711261',3,0,5.6),(3556,'2018-03-15 22:07:13',60.0345,37.7953,-14.3,'gps',0,34,1,'352449090711261',3,0,7.3),(3557,'2018-03-15 22:08:17',60.0346,37.7952,-12,'gps',0,34,1,'352449090711261',3,0,5.5),(3558,'2018-03-15 22:08:19',60.0342,37.7946,0,'network',0,34,1,'352449090711261',3,0,20),(3559,'2018-03-15 22:10:14',60.0348,37.7952,-14.2,'gps',0,34,1,'352449090711261',3,0,5.8),(3560,'2018-03-15 22:10:22',60.0349,37.7953,-9.4,'gps',0,34,1,'352449090711261',3,0,4.9),(3561,'2018-03-15 22:11:19',60.0347,37.795,-3.7,'gps',0,34,1,'352449090711261',3,0,5.8),(3562,'2018-03-15 22:12:18',60.0339,37.7953,-13.5,'gps',0,34,1,'352449090711261',3,0,6.4),(3563,'2018-03-15 22:13:20',60.0344,37.7956,-14.2,'gps',0,34,1,'352449090711261',3,0,6.5),(3564,'2018-03-15 22:14:18',60.0342,37.7949,-14.1,'gps',0,34,1,'352449090711261',3,0,6.3),(3565,'2018-03-15 22:15:17',60.0344,37.7954,-14.2,'gps',0,35,1,'352449090711261',3,0,6.8),(3566,'2018-03-15 22:20:25',60.0344,37.795,68.4,'gps',0,38,1,'352449090711261',3,0,6.5),(3567,'2018-03-15 22:23:14',60.0347,37.7954,-14.1,'gps',0,40,1,'352449090711261',3,0,5.8),(3568,'2018-03-15 22:24:18',60.0344,37.7952,-13.4,'gps',0,41,1,'352449090711261',3,0,4.7),(3569,'2018-03-15 22:24:20',60.0342,37.7946,0,'network',0,41,1,'352449090711261',3,0,50),(3570,'2018-03-15 22:25:15',60.0347,37.7955,-12.1,'gps',0,42,1,'352449090711261',3,0,6.7),(3571,'2018-03-15 22:25:35',60.0344,37.7951,-13.6,'gps',0,43,1,'352449090711261',3,0,6.5),(3572,'2018-03-15 22:26:20',60.0341,37.7947,-11.8,'gps',0,43,1,'352449090711261',3,0,5.4),(3573,'2018-03-15 22:27:19',60.0341,37.7946,-14.3,'gps',0,44,1,'352449090711261',3,0,6.7),(3574,'2018-03-15 22:28:24',60.0341,37.7948,-13.1,'gps',0,45,1,'352449090711261',3,0,6),(3575,'2018-03-15 22:28:26',60.0342,37.7946,0,'network',0,45,1,'352449090711261',3,0,50),(3576,'2018-03-15 22:29:23',60.0344,37.7959,-10.5,'gps',0,46,1,'352449090711261',3,0,6.3),(3577,'2018-03-15 22:29:25',60.0342,37.7946,0,'network',0,46,1,'352449090711261',3,0,50),(3578,'2018-03-15 22:31:16',60.0344,37.795,-13.2,'gps',0,48,1,'352449090711261',3,0,6.3),(3579,'2018-03-15 22:32:13',60.0342,37.7955,-14.1,'gps',0,49,1,'352449090711261',3,0,7.8),(3580,'2018-03-15 22:33:13',60.0342,37.795,-14,'gps',0,50,1,'352449090711261',3,0,7),(3581,'2018-03-15 22:34:13',60.0341,37.7956,-13.2,'gps',0,51,1,'352449090711261',3,0,7),(3582,'2018-03-15 22:34:50',60.0341,37.796,-13.5,'gps',0,52,1,'352449090711261',3,0,7.5),(3583,'2018-03-15 22:39:42',60.0341,37.7947,-13.9,'gps',0,56,1,'352449090711261',3,0,4.4),(3584,'2018-03-15 22:39:44',60.0342,37.7946,0,'network',0,56,1,'352449090711261',3,0,50),(3585,'2018-03-15 22:40:19',60.034,37.7957,-12.9,'gps',0,57,1,'352449090711261',3,0,5.5),(3586,'2018-03-15 22:48:25',60.034,37.7964,-12.6,'gps',0,62,1,'352449090711261',3,0,4.8),(3587,'2018-03-15 22:48:27',60.0342,37.7946,0,'network',0,62,1,'352449090711261',3,0,50),(3588,'2018-03-15 22:49:25',60.0342,37.7962,-13.6,'gps',0,63,1,'352449090711261',3,0,5.1),(3589,'2018-03-15 22:49:27',60.0342,37.7946,0,'network',0,63,1,'352449090711261',3,0,50),(3590,'2018-03-15 22:50:28',60.0343,37.7951,-14.5,'gps',0,64,1,'352449090711261',3,0,6.1),(3591,'2018-03-15 22:50:30',60.0342,37.7946,0,'network',0,64,1,'352449090711261',3,0,50),(3592,'2018-03-15 22:51:26',60.034,37.7961,-13.7,'gps',0,65,1,'352449090711261',3,0,7.5),(3593,'2018-03-15 22:51:28',60.0342,37.7946,0,'network',0,65,1,'352449090711261',3,0,50),(3594,'2018-03-15 22:52:20',60.0341,37.7965,-13.6,'gps',0,65,1,'352449090711261',3,0,6),(3595,'2018-03-15 22:53:21',60.0338,37.7953,-12.9,'gps',0,65,1,'352449090711261',3,0,6),(3596,'2018-03-15 22:58:55',60.0344,37.7951,105.6,'gps',0,66,1,'352449090711261',3,0,4.8),(3597,'2018-03-15 22:58:57',60.0342,37.7946,0,'network',0,66,1,'352449090711261',3,0,50),(3598,'2018-03-15 22:59:21',60.0341,37.7957,49.9,'gps',0,66,1,'352449090711261',3,0,5.6),(3599,'2018-03-15 23:00:20',60.0338,37.7958,-13.7,'gps',0,67,1,'352449090711261',3,0,6.4),(3600,'2018-03-15 23:01:23',60.0337,37.7952,-12,'gps',0,68,1,'352449090711261',3,0,9.2),(3601,'2018-03-15 23:01:25',60.0342,37.7946,0,'network',0,68,1,'352449090711261',3,0,50),(3602,'2018-03-15 23:02:19',60.0338,37.7956,-13.2,'gps',0,69,1,'352449090711261',3,0,7),(3603,'2018-03-15 23:10:52',60.0342,37.7955,69.7,'gps',0,75,1,'352449090711261',3,0,6.2),(3604,'2018-03-15 23:11:32',60.0343,37.7956,-13.9,'gps',0,75,1,'352449090711261',3,0,5.7),(3605,'2018-03-15 23:11:33',60.0342,37.7946,0,'network',0,75,1,'352449090711261',3,0,50),(3606,'2018-03-15 23:12:19',60.0338,37.796,-13.8,'gps',0,76,1,'352449090711261',3,0,6),(3607,'2018-03-15 23:14:02',60.0306,37.7912,8.7,'gps',1.33,76,1,'352449090711261',3,0,4.5),(3608,'2018-03-15 23:14:28',60.0325,37.7944,-13.1,'gps',0,76,1,'352449090711261',3,0,6.3),(3609,'2018-03-15 23:14:30',60.0342,37.7946,0,'network',0,76,1,'352449090711261',3,0,50),(3610,'2018-03-15 23:15:19',60.0334,37.7951,-12.5,'gps',0,76,1,'352449090711261',3,0,6.9),(3611,'2018-03-15 23:16:19',60.0333,37.7949,-13.8,'gps',0,76,1,'352449090711261',3,0,6.6),(3612,'2018-03-15 23:17:20',60.0332,37.7952,-14.1,'gps',0,76,1,'352449090711261',3,0,6),(3613,'2018-03-15 23:22:53',60.0336,37.7949,20,'gps',0,79,1,'352449090711261',3,0,5.9),(3614,'2018-03-15 23:23:19',60.0337,37.7951,0.1,'gps',0,79,1,'352449090711261',3,0,5.2),(3615,'2018-03-15 23:24:19',60.0334,37.7951,-14.3,'gps',0,80,1,'352449090711261',3,0,7.5),(3616,'2018-03-15 23:25:22',60.0333,37.795,-14.6,'gps',0,81,1,'352449090711261',3,0,5.4),(3617,'2018-03-15 23:25:24',60.0342,37.7946,0,'network',0,81,1,'352449090711261',3,0,20),(3618,'2018-03-15 23:26:19',60.0332,37.7948,-14.5,'gps',0,81,1,'352449090711261',3,0,7.5),(3619,'2018-03-15 23:27:20',60.0334,37.7942,-4.3,'gps',0,82,1,'352449090711261',3,0,6.2),(3620,'2018-03-15 23:28:25',60.0332,37.7945,-14.5,'gps',0,82,1,'352449090711261',3,0,5.4),(3621,'2018-03-15 23:28:27',60.0342,37.7946,0,'network',0,82,1,'352449090711261',3,0,20),(3622,'2018-03-15 23:29:19',60.0334,37.7947,-14.3,'gps',0,83,1,'352449090711261',3,0,7.1),(3623,'2018-03-15 23:34:58',60.0335,37.795,-18.7,'gps',0,87,1,'352449090711261',3,0,5.9),(3624,'2018-03-15 23:35:00',60.0342,37.7946,0,'network',0,87,1,'352449090711261',3,0,50),(3625,'2018-03-15 23:39:10',60.0342,37.7945,133,'gps',0,88,1,'352449090711261',3,0,5.4),(3626,'2018-03-15 23:39:12',60.0342,37.7946,0,'network',0,88,1,'352449090711261',3,0,50),(3627,'2018-03-15 23:39:38',60.0346,37.7955,-13.7,'gps',0,88,1,'352449090711261',3,0,5.8),(3628,'2018-03-15 23:40:19',60.0344,37.7948,-12.2,'gps',0,89,1,'352449090711261',3,0,5.6),(3629,'2018-03-15 23:41:19',60.0338,37.7947,-14.3,'gps',0,89,1,'352449090711261',3,0,5.8),(3630,'2018-03-15 23:46:52',60.0341,37.7934,108.3,'gps',0,92,1,'352449090711261',3,0,5.2),(3631,'2018-03-15 23:47:19',60.0343,37.7924,-14.1,'gps',1.48,92,1,'352449090711261',3,0,9.4),(3632,'2018-03-15 23:48:19',60.0343,37.7935,-13.5,'gps',0,92,1,'352449090711261',3,0,6.8),(3633,'2018-03-15 23:49:21',60.0343,37.7942,-14,'gps',0,92,1,'352449090711261',3,0,5.7),(3634,'2018-03-15 23:50:22',60.0344,37.7939,-14.4,'gps',0,93,1,'352449090711261',3,0,4.6),(3635,'2018-03-15 23:50:24',60.0342,37.7946,0,'network',0,93,1,'352449090711261',3,0,20),(3636,'2018-03-15 23:51:19',60.0342,37.793,-14.4,'gps',0,93,1,'352449090711261',3,0,5.7),(3637,'2018-03-15 23:52:18',60.0342,37.794,-14.4,'gps',0,93,1,'352449090711261',3,0,6.4),(3638,'2018-03-15 23:53:19',60.0344,37.7942,-14.2,'gps',0,94,1,'352449090711261',3,0,6.5),(3639,'2018-03-15 23:54:19',60.0344,37.7941,-10.3,'gps',0,94,1,'352449090711261',3,0,5.4),(3640,'2018-03-16 00:00:37',60.0342,37.7946,0,'network',0,96,1,'352449090711261',3,0,50),(3641,'2018-03-16 00:01:21',60.0342,37.7933,-14.2,'gps',0,97,1,'352449090711261',3,0,4.7),(3642,'2018-03-16 00:01:23',60.0342,37.7946,0,'network',0,97,1,'352449090711261',3,0,50),(3643,'2018-03-16 00:02:14',60.0342,37.7943,-11.2,'gps',0,97,1,'352449090711261',3,0,5.8),(3644,'2018-03-16 00:03:14',60.0342,37.7942,-13.2,'gps',0,97,1,'352449090711261',3,0,5.2),(3645,'2018-03-16 00:04:15',60.0342,37.7941,-12.7,'gps',0,97,1,'352449090711261',3,0,5),(3646,'2018-03-16 00:05:12',60.0342,37.7936,-14.2,'gps',0,98,1,'352449090711261',3,0,5.8),(3647,'2018-03-16 00:06:16',60.0343,37.7946,114.7,'gps',0,98,1,'352449090711261',3,0,12.6),(3648,'2018-03-16 00:07:16',60.0343,37.7943,94.6,'gps',0,98,1,'352449090711261',3,0,6.4),(3649,'2018-03-16 00:08:15',60.0343,37.7939,95.8,'gps',0.11,98,1,'352449090711261',3,0,5.6),(3650,'2018-03-16 00:09:16',60.0342,37.794,50.2,'gps',0,99,1,'352449090711261',3,0,5.3),(3651,'2018-03-16 00:09:24',60.034,37.794,15.6,'gps',0,99,1,'352449090711261',3,0,5.9),(3652,'2018-03-16 00:11:24',60.0342,37.7939,-9.2,'gps',0,99,1,'352449090711261',3,0,6.2),(3653,'2018-03-16 00:13:13',60.0342,37.7943,84,'gps',0,99,1,'352449090711261',3,0,6.5),(3654,'2018-03-16 00:14:15',60.034,37.7943,-13,'gps',0,100,1,'352449090711261',3,0,5.2),(3655,'2018-03-16 00:15:14',60.034,37.7939,-4.7,'gps',0,100,1,'352449090711261',3,0,5.8),(3656,'2018-03-16 00:16:13',60.034,37.794,-14.4,'gps',0,100,1,'352449090711261',3,0,6.3),(3657,'2018-03-16 00:17:13',60.034,37.794,14.6,'gps',0,100,1,'352449090711261',3,0,6.5),(3658,'2018-03-16 00:18:13',60.0341,37.7934,-13.7,'gps',0,100,1,'352449090711261',3,0,12.1),(3659,'2018-03-16 00:19:14',60.0341,37.7946,25,'gps',0,100,1,'352449090711261',3,0,7.3),(3660,'2018-03-16 00:20:14',60.0342,37.7939,-13.9,'gps',0,100,1,'352449090711261',3,0,6.4),(3661,'2018-03-16 00:21:15',60.0341,37.7939,-14.4,'gps',0,100,1,'352449090711261',3,0,6.1),(3662,'2018-03-16 00:22:13',60.034,37.7938,-14.2,'gps',0,100,1,'352449090711261',3,0,7.5),(3663,'2018-03-16 00:23:14',60.0342,37.7941,-14.3,'gps',0,100,1,'352449090711261',3,0,6.7),(3664,'2018-03-16 00:24:14',60.0341,37.7936,-13.2,'gps',0,100,1,'352449090711261',3,0,5.8),(3665,'2018-03-16 00:25:15',60.0339,37.7939,5.2,'gps',0,100,1,'352449090711261',3,0,5),(3666,'2018-03-16 00:26:15',60.0339,37.7941,43.9,'gps',0,100,1,'352449090711261',3,0,6.6),(3667,'2018-03-16 00:27:13',60.034,37.794,26.4,'gps',0,100,1,'352449090711261',3,0,7.4),(3668,'2018-03-16 00:28:14',60.0341,37.794,32.8,'gps',0,100,1,'352449090711261',3,0,6.5),(3669,'2018-03-16 00:29:14',60.0339,37.7947,-13.8,'gps',0,100,1,'352449090711261',3,0,7.2),(3670,'2018-03-16 00:29:20',60.0333,37.7946,-14.4,'gps',0,100,1,'352449090711261',3,0,7.5),(3671,'2018-03-16 00:31:14',60.0338,37.7947,-13.6,'gps',0,100,1,'352449090711261',3,0,6.6),(3672,'2018-03-16 00:32:14',60.0335,37.7943,-13.7,'gps',0,100,1,'352449090711261',3,0,7.3),(3673,'2018-03-16 00:33:15',60.0336,37.7945,-12.8,'gps',0,100,1,'352449090711261',3,0,8.8),(3674,'2018-03-16 00:34:14',60.0329,37.7937,-14.4,'gps',0,100,1,'352449090711261',3,0,6.9),(3675,'2018-03-16 00:35:13',60.033,37.7944,-14.5,'gps',0,100,1,'352449090711261',3,0,8.2),(3676,'2018-03-16 00:36:13',60.0341,37.7976,-14,'gps',0,100,1,'352449090711261',3,0,13.1),(3677,'2018-03-16 00:37:14',60.0336,37.7951,-13.6,'gps',0,100,1,'352449090711261',3,0,6),(3678,'2018-03-16 00:39:07',60.0339,37.7948,-12.8,'gps',0,100,1,'352449090711261',3,0,6.1),(3679,'2018-03-16 00:39:19',60.0335,37.7945,-13.8,'gps',0,100,1,'352449090711261',3,0,5.4),(3680,'2018-03-16 00:41:14',60.0335,37.7951,-13.9,'gps',0,100,1,'352449090711261',3,0,5.6),(3681,'2018-03-16 00:42:14',60.0334,37.7949,-14,'gps',0,100,1,'352449090711261',3,0,5.4),(3682,'2018-03-16 00:43:14',60.0334,37.795,-13.9,'gps',0,100,1,'352449090711261',3,0,5.4),(3683,'2018-03-16 00:44:16',60.0336,37.7949,-13.7,'gps',0,100,1,'352449090711261',3,0,5),(3684,'2018-03-16 00:45:14',60.0339,37.7953,24,'gps',0,100,1,'352449090711261',3,0,7.4),(3685,'2018-03-16 00:46:14',60.0341,37.795,26.8,'gps',0,100,1,'352449090711261',3,0,5.4),(3686,'2018-03-16 00:47:16',60.0341,37.7954,50.6,'gps',0,100,1,'352449090711261',3,0,5),(3687,'2018-03-16 00:48:13',60.0337,37.7948,-9.8,'gps',0,100,1,'352449090711261',3,0,5.7),(3688,'2018-03-16 00:49:13',60.0338,37.7946,-9.5,'gps',0,100,1,'352449090711261',3,0,6.9),(3689,'2018-03-16 00:50:24',60.0335,37.7939,-8.4,'gps',0,100,1,'352449090711261',3,0,7),(3690,'2018-03-16 00:50:26',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3691,'2018-03-16 00:51:13',60.0339,37.7984,-14.4,'gps',0,100,1,'352449090711261',3,0,9.3),(3692,'2018-03-16 00:52:16',60.0342,37.797,-9.4,'gps',0,100,1,'352449090711261',3,0,6.5),(3693,'2018-03-16 00:53:13',60.034,37.7968,-14.3,'gps',0,100,1,'352449090711261',3,0,10.9),(3694,'2018-03-16 00:54:13',60.034,37.7944,-13.6,'gps',0,100,1,'352449090711261',3,0,7.2),(3695,'2018-03-16 00:55:21',60.0338,37.7959,-14.1,'gps',0,100,1,'352449090711261',3,0,7.1),(3696,'2018-03-16 00:55:23',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3697,'2018-03-16 00:56:14',60.034,37.7956,-13.5,'gps',0,100,1,'352449090711261',3,0,6.5),(3698,'2018-03-16 00:56:23',60.034,37.7956,-13.5,'gps',0,100,1,'352449090711261',3,0,5.2),(3699,'2018-03-16 00:58:14',60.0339,37.796,-13,'gps',0,100,1,'352449090711261',3,0,9.1),(3700,'2018-03-16 00:59:16',60.0341,37.7973,-14,'gps',0,100,1,'352449090711261',3,0,8.6),(3701,'2018-03-16 01:00:14',60.0337,37.7954,-13.9,'gps',0,100,1,'352449090711261',3,0,9.3),(3702,'2018-03-16 01:01:15',60.0339,37.7955,-14.4,'gps',0,100,1,'352449090711261',3,0,5.7),(3703,'2018-03-16 01:02:15',60.0343,37.7962,11.6,'gps',0,100,1,'352449090711261',3,0,6.2),(3704,'2018-03-16 01:03:35',60.0343,37.7952,72.5,'gps',0,100,1,'352449090711261',3,0,4.2),(3705,'2018-03-16 01:03:37',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3706,'2018-03-16 01:04:19',60.0342,37.7945,72.6,'gps',0,100,1,'352449090711261',3,0,7.2),(3707,'2018-03-16 01:05:20',60.0342,37.7949,-14.2,'gps',0,100,1,'352449090711261',3,0,7.7),(3708,'2018-03-16 01:07:18',60.0342,37.7943,-14.5,'gps',0,100,1,'352449090711261',3,0,7.9),(3709,'2018-03-16 01:07:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3710,'2018-03-16 01:08:15',60.0342,37.7955,-14.2,'gps',0,100,1,'352449090711261',3,0,6.4),(3711,'2018-03-16 01:13:21',60.0342,37.7946,50,'gps',0,100,1,'352449090711261',3,0,5.9),(3712,'2018-03-16 01:13:22',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3713,'2018-03-16 01:14:19',60.0339,37.7954,-14,'gps',0,100,1,'352449090711261',3,0,4.8),(3714,'2018-03-16 01:14:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3715,'2018-03-16 01:15:17',60.0337,37.7953,-12.6,'gps',0,100,1,'352449090711261',3,0,5),(3716,'2018-03-16 01:15:25',60.0337,37.7955,-13.6,'gps',0,100,1,'352449090711261',3,0,4.9),(3717,'2018-03-16 01:16:20',60.0345,37.7959,-13,'gps',0,100,1,'352449090711261',3,0,6.5),(3718,'2018-03-16 01:17:20',60.0345,37.795,-14,'gps',0,100,1,'352449090711261',3,0,6.1),(3719,'2018-03-16 01:19:16',60.0346,37.794,-13.3,'gps',0,100,1,'352449090711261',3,0,5.9),(3720,'2018-03-16 01:20:16',60.0345,37.7941,-13.5,'gps',0,100,1,'352449090711261',3,0,8.8),(3721,'2018-03-16 01:21:26',60.0346,37.7956,-10.5,'gps',0,100,1,'352449090711261',3,0,4.8),(3722,'2018-03-16 01:21:28',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3723,'2018-03-16 01:22:14',60.0343,37.7944,-10.2,'gps',0,100,1,'352449090711261',3,0,8.6),(3724,'2018-03-16 01:23:21',60.0346,37.7949,-13.4,'gps',0,100,1,'352449090711261',3,0,5.3),(3725,'2018-03-16 01:23:23',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3726,'2018-03-16 01:25:15',60.0343,37.7947,-9.8,'gps',0,100,1,'352449090711261',3,0,7.4),(3727,'2018-03-16 01:26:14',60.0342,37.7952,-14.4,'gps',0,100,1,'352449090711261',3,0,5.7),(3728,'2018-03-16 01:27:21',60.0344,37.795,-14,'gps',0,100,1,'352449090711261',3,0,4.8),(3729,'2018-03-16 01:27:23',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3730,'2018-03-16 01:28:21',60.0346,37.7948,-13.8,'gps',0,100,1,'352449090711261',3,0,4.6),(3731,'2018-03-16 01:28:23',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3732,'2018-03-16 01:29:17',60.0344,37.7948,-13.9,'gps',0,100,1,'352449090711261',3,0,5.7),(3733,'2018-03-16 01:29:28',60.0342,37.7944,-13.7,'gps',0,100,1,'352449090711261',3,0,6.1),(3734,'2018-03-16 01:29:30',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3735,'2018-03-16 01:31:36',60.0341,37.7947,-14.4,'gps',0,100,1,'352449090711261',3,0,4.2),(3736,'2018-03-16 01:31:38',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(3737,'2018-03-16 01:32:35',60.0338,37.7936,-14.5,'gps',0,100,1,'352449090711261',3,0,7.7),(3738,'2018-03-16 01:32:37',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3739,'2018-03-16 01:34:16',60.0341,37.7947,-14.4,'gps',0,100,1,'352449090711261',3,0,6.5),(3740,'2018-03-16 01:35:18',60.0341,37.7947,-14.2,'gps',0,100,1,'352449090711261',3,0,5),(3741,'2018-03-16 01:35:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3742,'2018-03-16 01:36:18',60.0344,37.7954,-11.6,'gps',0,100,1,'352449090711261',3,0,5.6),(3743,'2018-03-16 01:36:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3744,'2018-03-16 01:37:19',60.0346,37.795,-13.7,'gps',0,100,1,'352449090711261',3,0,4.8),(3745,'2018-03-16 01:37:21',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3746,'2018-03-16 01:38:17',60.0344,37.7949,-13.4,'gps',0,100,1,'352449090711261',3,0,5.6),(3747,'2018-03-16 01:38:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(3748,'2018-03-16 01:39:11',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3749,'2018-03-16 01:40:23',60.0347,37.7955,-13.8,'gps',0,100,1,'352449090711261',3,0,4.4),(3750,'2018-03-16 01:40:25',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3751,'2018-03-16 01:41:20',60.0342,37.7945,-13.3,'gps',0,100,1,'352449090711261',3,0,4.3),(3752,'2018-03-16 01:41:22',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3753,'2018-03-16 01:42:15',60.0343,37.7951,-13.2,'gps',0,100,1,'352449090711261',3,0,6.6),(3754,'2018-03-16 01:43:17',60.0344,37.7952,-14.3,'gps',0,100,1,'352449090711261',3,0,5.4),(3755,'2018-03-16 01:43:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3756,'2018-03-16 01:44:14',60.0342,37.7945,-14.4,'gps',0,100,1,'352449090711261',3,0,5.8),(3757,'2018-03-16 01:45:19',60.0342,37.7949,-14.4,'gps',0,100,1,'352449090711261',3,0,5),(3758,'2018-03-16 01:45:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3759,'2018-03-16 01:46:23',60.0341,37.7949,-14.2,'gps',0,100,1,'352449090711261',3,0,4.5),(3760,'2018-03-16 01:46:25',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3761,'2018-03-16 01:47:14',60.0342,37.7944,-14.4,'gps',0,100,1,'352449090711261',3,0,6.3),(3762,'2018-03-16 01:48:17',60.0343,37.7947,-14.4,'gps',0,100,1,'352449090711261',3,0,5.4),(3763,'2018-03-16 01:48:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3764,'2018-03-16 01:49:16',60.0342,37.7943,-14.3,'gps',0,100,1,'352449090711261',3,0,6.2),(3765,'2018-03-16 01:50:17',60.0343,37.7949,-14.2,'gps',0,100,1,'352449090711261',3,0,5.8),(3766,'2018-03-16 01:50:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3767,'2018-03-16 01:51:14',60.0341,37.795,-14,'gps',0,100,1,'352449090711261',3,0,7.8),(3768,'2018-03-16 01:52:14',60.0339,37.7956,-13.3,'gps',0,100,1,'352449090711261',3,0,6.6),(3769,'2018-03-16 01:53:13',60.0339,37.7955,-13.3,'gps',0,100,1,'352449090711261',3,0,7.1),(3770,'2018-03-16 01:54:25',60.034,37.7955,-13.1,'gps',0,100,1,'352449090711261',3,0,7.3),(3771,'2018-03-16 01:56:15',60.0336,37.7962,-12.7,'gps',0,100,1,'352449090711261',3,0,10.2),(3772,'2018-03-16 01:57:13',60.0336,37.796,-13.3,'gps',0,100,1,'352449090711261',3,0,7.9),(3773,'2018-03-16 01:58:31',60.0347,37.7962,-14.2,'gps',0,100,1,'352449090711261',3,0,7.7),(3774,'2018-03-16 01:58:33',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3775,'2018-03-16 01:59:17',60.0336,37.7957,-9.2,'gps',0,100,1,'352449090711261',3,0,9.7),(3776,'2018-03-16 01:59:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3777,'2018-03-16 02:00:30',60.035,37.7965,-14.1,'gps',0,100,1,'352449090711261',3,0,7.6),(3778,'2018-03-16 02:00:32',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3779,'2018-03-16 02:01:53',60.0345,37.7959,-13.4,'gps',0,100,1,'352449090711261',3,0,5.5),(3780,'2018-03-16 02:01:55',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(3781,'2018-03-16 02:02:22',60.034,37.796,-12.8,'gps',0,100,1,'352449090711261',3,0,6),(3782,'2018-03-16 02:04:18',60.0339,37.796,-13.3,'gps',0,100,1,'352449090711261',3,0,5.9),(3783,'2018-03-16 02:04:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3784,'2018-03-16 02:05:14',60.0338,37.796,-12.1,'gps',0,100,1,'352449090711261',3,0,7.6),(3785,'2018-03-16 02:06:13',60.0336,37.7966,-13.6,'gps',0,100,1,'352449090711261',3,0,7.8),(3786,'2018-03-16 02:07:13',60.0336,37.7966,-13.6,'gps',0,100,1,'352449090711261',3,0,7.8),(3787,'2018-03-16 02:08:16',60.034,37.7963,-13.8,'gps',0,100,1,'352449090711261',3,0,5.8),(3788,'2018-03-16 02:09:25',60.0333,37.7961,-12.3,'gps',0,100,1,'352449090711261',3,0,5.1),(3789,'2018-03-16 02:09:27',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3790,'2018-03-16 02:10:44',60.0334,37.7969,-10,'gps',0,100,1,'352449090711261',3,0,5),(3791,'2018-03-16 02:11:13',60.0337,37.7964,-13.9,'gps',0,100,1,'352449090711261',3,0,7.9),(3792,'2018-03-16 02:12:13',60.034,37.7958,-14,'gps',0,100,1,'352449090711261',3,0,7.7),(3793,'2018-03-16 02:13:13',60.0337,37.7955,-14,'gps',0,100,1,'352449090711261',3,0,7.3),(3794,'2018-03-16 02:14:14',60.0336,37.7959,-14.1,'gps',0,100,1,'352449090711261',3,0,7.6),(3795,'2018-03-16 02:15:14',60.0336,37.7958,-14.2,'gps',0,100,1,'352449090711261',3,0,7.6),(3796,'2018-03-16 02:16:14',60.0335,37.7958,-14.1,'gps',0,100,1,'352449090711261',3,0,7.6),(3797,'2018-03-16 02:16:20',60.0334,37.7961,-14.2,'gps',0,100,1,'352449090711261',3,0,7.8),(3798,'2018-03-16 02:17:20',60.0337,37.7949,56.1,'gps',0,100,1,'352449090711261',3,0,7.8),(3799,'2018-03-16 02:19:13',60.0335,37.7961,-14.2,'gps',0,100,1,'352449090711261',3,0,8),(3800,'2018-03-16 02:20:14',60.0335,37.796,-14,'gps',0,100,1,'352449090711261',3,0,6.5),(3801,'2018-03-16 02:21:14',60.0334,37.796,-14.1,'gps',0,100,1,'352449090711261',3,0,7.7),(3802,'2018-03-16 02:22:13',60.0333,37.796,-14.1,'gps',0,100,1,'352449090711261',3,0,7.6),(3803,'2018-03-16 02:23:13',60.0334,37.7953,-14.1,'gps',0,100,1,'352449090711261',3,0,7.2),(3804,'2018-03-16 02:24:14',60.0336,37.7957,-2.2,'gps',6.72,100,1,'352449090711261',3,0,5.7),(3805,'2018-03-16 02:25:12',60.0336,37.7951,-11.8,'gps',0.33,100,1,'352449090711261',3,0,6.4),(3806,'2018-03-16 02:27:47',60.0334,37.7955,-14.4,'gps',0,100,1,'352449090711261',3,0,6.2),(3807,'2018-03-16 02:29:14',60.0334,37.7967,-14.5,'gps',0,100,1,'352449090711261',3,0,12.2),(3808,'2018-03-16 02:30:14',60.0335,37.7962,-11,'gps',0,100,1,'352449090711261',3,0,10.9),(3809,'2018-03-16 02:31:14',60.0334,37.7964,-14.5,'gps',0.19,100,1,'352449090711261',3,0,9.9),(3810,'2018-03-16 02:32:12',60.0338,37.794,-14.4,'gps',0.29,100,1,'352449090711261',3,0,9.7),(3811,'2018-03-16 02:33:13',60.0336,37.7946,-13.8,'gps',0.32,100,1,'352449090711261',3,0,12.3),(3812,'2018-03-16 02:34:12',60.0337,37.7948,-14.5,'gps',0.29,100,1,'352449090711261',3,0,9.9),(3813,'2018-03-16 02:35:11',60.0335,37.7954,-14.5,'gps',0.1,100,1,'352449090711261',3,0,7.1),(3814,'2018-03-16 02:36:13',60.0336,37.7953,-14.2,'gps',0.28,100,1,'352449090711261',3,0,7.5),(3815,'2018-03-16 02:37:12',60.0339,37.7943,-12,'gps',0.18,100,1,'352449090711261',3,0,6.5),(3816,'2018-03-16 02:38:13',60.0339,37.7942,-12.1,'gps',0.08,100,1,'352449090711261',3,0,6.1),(3817,'2018-03-16 02:40:11',60.0336,37.7951,-14.5,'gps',0.46,100,1,'352449090711261',3,0,7.1),(3818,'2018-03-16 02:41:14',60.0336,37.7952,-14.4,'gps',0,100,1,'352449090711261',3,0,7.9),(3819,'2018-03-16 02:42:13',60.0336,37.795,-14.4,'gps',0,100,1,'352449090711261',3,0,8.2),(3820,'2018-03-16 02:42:19',60.0336,37.795,-14.4,'gps',0,100,1,'352449090711261',3,0,8.2),(3821,'2018-03-16 02:44:13',60.0336,37.7948,-14.3,'gps',0,100,1,'352449090711261',3,0,5),(3822,'2018-03-16 02:45:13',60.0336,37.7951,-14.4,'gps',0,100,1,'352449090711261',3,0,6.6),(3823,'2018-03-16 02:46:13',60.0337,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,6.9),(3824,'2018-03-16 02:47:13',60.0336,37.7951,-14.4,'gps',0,100,1,'352449090711261',3,0,6),(3825,'2018-03-16 02:48:14',60.0337,37.795,-14.2,'gps',0,100,1,'352449090711261',3,0,5.5),(3826,'2018-03-16 02:49:12',60.0337,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,7),(3827,'2018-03-16 02:50:11',60.0337,37.7949,-14.5,'gps',0.16,100,1,'352449090711261',3,0,7.1),(3828,'2018-03-16 02:51:11',60.0337,37.7951,-14.5,'gps',1.07,100,1,'352449090711261',3,0,6.8),(3829,'2018-03-16 02:52:11',60.0338,37.7951,-14.5,'gps',0.34,100,1,'352449090711261',3,0,6.8),(3830,'2018-03-16 02:53:11',60.0337,37.7951,-14.4,'gps',0.23,100,1,'352449090711261',3,0,6.8),(3831,'2018-03-16 02:54:11',60.0337,37.795,-14.5,'gps',0,100,1,'352449090711261',3,0,7),(3832,'2018-03-16 02:55:13',60.0342,37.7948,64.9,'gps',0,100,1,'352449090711261',3,0,6.5),(3833,'2018-03-16 02:56:12',60.034,37.7949,-14.2,'gps',0,100,1,'352449090711261',3,0,6.3),(3834,'2018-03-16 02:57:12',60.0339,37.795,-14.5,'gps',0,100,1,'352449090711261',3,0,6.7),(3835,'2018-03-16 02:57:17',60.0339,37.795,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(3836,'2018-03-16 02:59:15',60.0338,37.7956,-14.4,'gps',0,100,1,'352449090711261',3,0,5.5),(3837,'2018-03-16 03:00:12',60.0339,37.795,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(3838,'2018-03-16 03:01:13',60.0339,37.7955,-14.5,'gps',0,100,1,'352449090711261',3,0,9.2),(3839,'2018-03-16 03:02:13',60.034,37.7964,-13.8,'gps',0,100,1,'352449090711261',3,0,8.4),(3840,'2018-03-16 03:02:19',60.0342,37.7953,47.1,'gps',0,100,1,'352449090711261',3,0,11.6),(3841,'2018-03-16 03:04:14',60.034,37.7954,-11.8,'gps',0,100,1,'352449090711261',3,0,10.3),(3842,'2018-03-16 03:05:13',60.034,37.7953,-14.2,'gps',0,100,1,'352449090711261',3,0,6.9),(3843,'2018-03-16 03:06:15',60.0344,37.7947,-9.9,'gps',0.34,100,1,'352449090711261',3,0,4.9),(3844,'2018-03-16 03:07:12',60.0342,37.7954,-14.2,'gps',0.19,100,1,'352449090711261',3,0,6.7),(3845,'2018-03-16 03:08:12',60.0342,37.7954,-14.2,'gps',0,100,1,'352449090711261',3,0,6.7),(3846,'2018-03-16 03:09:12',60.0342,37.7954,-14.3,'gps',2.08,100,1,'352449090711261',3,0,6.8),(3847,'2018-03-16 03:10:12',60.0342,37.7973,-14.2,'gps',0,100,1,'352449090711261',3,0,6.8),(3848,'2018-03-16 03:11:12',60.0342,37.7957,-14.2,'gps',0,100,1,'352449090711261',3,0,6.9),(3849,'2018-03-16 03:12:13',60.0344,37.7949,-14.3,'gps',0,100,1,'352449090711261',3,0,10.5),(3850,'2018-03-16 03:13:13',60.0343,37.7956,-14.4,'gps',0,100,1,'352449090711261',3,0,7.9),(3851,'2018-03-16 03:14:15',60.0341,37.7962,-12.1,'gps',4.98,100,1,'352449090711261',3,0,6.3),(3852,'2018-03-16 03:15:15',60.034,37.795,-14.2,'gps',0,100,1,'352449090711261',3,0,6.7),(3853,'2018-03-16 03:16:13',60.0344,37.796,-11.4,'gps',0,100,1,'352449090711261',3,0,6.1),(3854,'2018-03-16 03:17:14',60.0344,37.796,-13.3,'gps',0,100,1,'352449090711261',3,0,5.6),(3855,'2018-03-16 03:18:11',60.0342,37.7957,-14.5,'gps',0,100,1,'352449090711261',3,0,7),(3856,'2018-03-16 03:18:15',60.0342,37.7958,-14.4,'gps',0,100,1,'352449090711261',3,0,7.2),(3857,'2018-03-16 03:20:12',60.0345,37.7976,-14.4,'gps',0.35,100,1,'352449090711261',3,0,6),(3858,'2018-03-16 03:21:15',60.0344,37.7942,-13.7,'gps',0.45,100,1,'352449090711261',3,0,6.6),(3859,'2018-03-16 03:22:13',60.0344,37.7948,-13.1,'gps',0.34,100,1,'352449090711261',3,0,7.2),(3860,'2018-03-16 03:23:11',60.0341,37.7975,-14.4,'gps',0.17,100,1,'352449090711261',3,0,6.8),(3861,'2018-03-16 03:24:13',60.0343,37.7957,-13.7,'gps',0.3,100,1,'352449090711261',3,0,9.3),(3862,'2018-03-16 03:25:12',60.0343,37.7959,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(3863,'2018-03-16 03:26:12',60.0344,37.7959,-14.3,'gps',0,100,1,'352449090711261',3,0,6.5),(3864,'2018-03-16 03:27:13',60.0345,37.7953,-13.7,'gps',0.28,100,1,'352449090711261',3,0,5.8),(3865,'2018-03-16 03:28:13',60.0345,37.7961,-14.3,'gps',0,100,1,'352449090711261',3,0,5.7),(3866,'2018-03-16 03:29:12',60.0345,37.7959,-14.2,'gps',0,100,1,'352449090711261',3,0,6),(3867,'2018-03-16 03:30:11',60.0345,37.7957,-14.3,'gps',0.8,100,1,'352449090711261',3,0,6.2),(3868,'2018-03-16 03:31:12',60.0345,37.796,-14.2,'gps',0,100,1,'352449090711261',3,0,6.6),(3869,'2018-03-16 03:32:12',60.0345,37.7958,-14.3,'gps',0,100,1,'352449090711261',3,0,6.5),(3870,'2018-03-16 03:33:12',60.0345,37.7959,-14.4,'gps',0.5,100,1,'352449090711261',3,0,6.7),(3871,'2018-03-16 03:34:12',60.0344,37.796,-14.4,'gps',0.65,100,1,'352449090711261',3,0,6.7),(3872,'2018-03-16 03:35:12',60.0345,37.7963,-13.3,'gps',0.32,100,1,'352449090711261',3,0,6),(3873,'2018-03-16 03:36:13',60.0343,37.7949,-13.6,'gps',0.32,100,1,'352449090711261',3,0,7.6),(3874,'2018-03-16 03:37:13',60.0343,37.7946,-13.9,'gps',0,100,1,'352449090711261',3,0,9.7),(3875,'2018-03-16 03:38:11',60.0344,37.7957,-14.4,'gps',0.15,100,1,'352449090711261',3,0,6.8),(3876,'2018-03-16 03:39:12',60.0343,37.7951,-12.9,'gps',0.73,100,1,'352449090711261',3,0,5.9),(3877,'2018-03-16 03:40:12',60.0343,37.798,-14,'gps',0.09,100,1,'352449090711261',3,0,6.1),(3878,'2018-03-16 03:41:10',60.0344,37.7958,-14.5,'gps',0,100,1,'352449090711261',3,0,7.3),(3879,'2018-03-16 03:42:10',60.0344,37.7958,-14.5,'gps',0.35,100,1,'352449090711261',3,0,7.3),(3880,'2018-03-16 03:43:11',60.0344,37.7958,-14.4,'gps',0.35,100,1,'352449090711261',3,0,7),(3881,'2018-03-16 03:44:11',60.0343,37.7967,-14.5,'gps',0,100,1,'352449090711261',3,0,6.7),(3882,'2018-03-16 03:45:10',60.0343,37.796,-14.4,'gps',0.18,100,1,'352449090711261',3,0,7.2),(3883,'2018-03-16 03:46:10',60.0344,37.7959,-14.4,'gps',0.28,100,1,'352449090711261',3,0,7.1),(3884,'2018-03-16 03:47:10',60.0344,37.7959,-14.5,'gps',0.49,100,1,'352449090711261',3,0,7.3),(3885,'2018-03-16 03:48:12',60.0343,37.7961,-14.1,'gps',1.4,100,1,'352449090711261',3,0,6.6),(3886,'2018-03-16 03:49:11',60.0343,37.7963,-14.1,'gps',0.71,100,1,'352449090711261',3,0,6.9),(3887,'2018-03-16 03:50:11',60.0343,37.7962,-14.5,'gps',0.11,100,1,'352449090711261',3,0,6.8),(3888,'2018-03-16 03:51:11',60.0343,37.7963,-14.4,'gps',0.73,100,1,'352449090711261',3,0,6.8),(3889,'2018-03-16 03:52:11',60.0344,37.7954,-13.9,'gps',1.03,100,1,'352449090711261',3,0,6.6),(3890,'2018-03-16 03:53:11',60.0343,37.7962,-14.3,'gps',0.24,100,1,'352449090711261',3,0,6.9),(3891,'2018-03-16 03:54:11',60.0343,37.7962,-14.4,'gps',0.31,100,1,'352449090711261',3,0,6.9),(3892,'2018-03-16 03:55:10',60.0343,37.7962,-14.4,'gps',0.78,100,1,'352449090711261',3,0,7.2),(3893,'2018-03-16 03:56:10',60.0343,37.7961,-14.4,'gps',0.25,100,1,'352449090711261',3,0,7.3),(3894,'2018-03-16 03:56:14',60.0343,37.7962,-14.4,'gps',0.1,100,1,'352449090711261',3,0,8),(3895,'2018-03-16 03:58:10',60.0343,37.7962,-14.4,'gps',0.96,100,1,'352449090711261',3,0,7.3),(3896,'2018-03-16 03:59:11',60.0343,37.7951,-11.9,'gps',1.29,100,1,'352449090711261',3,0,6.1),(3897,'2018-03-16 04:00:12',60.0342,37.7962,-14.2,'gps',0.02,100,1,'352449090711261',3,0,6.7),(3898,'2018-03-16 04:01:10',60.0342,37.7961,-14.4,'gps',0.29,100,1,'352449090711261',3,0,7.2),(3899,'2018-03-16 04:02:11',60.0343,37.7961,-14.3,'gps',0.3,100,1,'352449090711261',3,0,7.2),(3900,'2018-03-16 04:03:11',60.0342,37.796,-14.5,'gps',0.48,100,1,'352449090711261',3,0,7.2),(3901,'2018-03-16 04:04:12',60.0342,37.7961,-14.5,'gps',0.29,100,1,'352449090711261',3,0,6.9),(3902,'2018-03-16 04:05:11',60.0342,37.7961,-14.4,'gps',0.05,100,1,'352449090711261',3,0,7),(3903,'2018-03-16 04:06:12',60.0339,37.7957,-12.6,'gps',0.39,100,1,'352449090711261',3,0,8.7),(3904,'2018-03-16 04:07:12',60.0339,37.7953,-12.6,'gps',0.41,100,1,'352449090711261',3,0,8.7),(3905,'2018-03-16 04:08:10',60.0342,37.7959,-14.5,'gps',0.12,100,1,'352449090711261',3,0,7.3),(3906,'2018-03-16 04:09:11',60.0342,37.7961,-14.2,'gps',0.43,100,1,'352449090711261',3,0,6.9),(3907,'2018-03-16 04:09:14',60.0342,37.7959,-14.5,'gps',0.37,100,1,'352449090711261',3,0,8.4),(3908,'2018-03-16 04:11:11',60.0342,37.796,-14.4,'gps',0.05,100,1,'352449090711261',3,0,7),(3909,'2018-03-16 04:12:11',60.0342,37.796,-14.4,'gps',0.19,100,1,'352449090711261',3,0,7),(3910,'2018-03-16 04:12:15',60.0341,37.796,-14.3,'gps',0.82,100,1,'352449090711261',3,0,7.2),(3911,'2018-03-16 04:14:12',60.0341,37.7961,-14.1,'gps',0.47,100,1,'352449090711261',3,0,6.8),(3912,'2018-03-16 04:15:11',60.0341,37.7961,-14.1,'gps',0.29,100,1,'352449090711261',3,0,6.8),(3913,'2018-03-16 04:16:13',60.0339,37.7963,-13.6,'gps',0.67,100,1,'352449090711261',3,0,5.2),(3914,'2018-03-16 04:17:12',60.034,37.7962,-13.9,'gps',0,100,1,'352449090711261',3,0,6.2),(3915,'2018-03-16 04:18:13',60.0337,37.7964,-13.5,'gps',0.56,100,1,'352449090711261',3,0,6.5),(3916,'2018-03-16 04:19:13',60.0337,37.7963,-13.7,'gps',0.1,100,1,'352449090711261',3,0,7.1),(3917,'2018-03-16 04:20:11',60.034,37.7964,-14.2,'gps',0.11,100,1,'352449090711261',3,0,6.8),(3918,'2018-03-16 04:21:12',60.0338,37.7962,-13.9,'gps',0.21,100,1,'352449090711261',3,0,5.7),(3919,'2018-03-16 04:22:10',60.034,37.7962,-14.4,'gps',0,100,1,'352449090711261',3,0,7.3),(3920,'2018-03-16 04:23:10',60.034,37.7962,-14.5,'gps',0,100,1,'352449090711261',3,0,7.3),(3921,'2018-03-16 04:24:11',60.0339,37.7964,-14.3,'gps',0,100,1,'352449090711261',3,0,7),(3922,'2018-03-16 04:25:11',60.0338,37.7964,-14.1,'gps',0,100,1,'352449090711261',3,0,6.7),(3923,'2018-03-16 04:26:12',60.0339,37.7965,-14.2,'gps',0.1,100,1,'352449090711261',3,0,6.8),(3924,'2018-03-16 04:27:12',60.0337,37.7966,-13.9,'gps',0.12,100,1,'352449090711261',3,0,5.5),(3925,'2018-03-16 04:28:12',60.0337,37.7966,-14.1,'gps',0.28,100,1,'352449090711261',3,0,5.6),(3926,'2018-03-16 04:29:12',60.0337,37.7964,-14.3,'gps',0,100,1,'352449090711261',3,0,5.6),(3927,'2018-03-16 04:30:11',60.0338,37.7964,-14.3,'gps',0.43,100,1,'352449090711261',3,0,6.7),(3928,'2018-03-16 04:31:11',60.0337,37.7965,-14.2,'gps',0.36,100,1,'352449090711261',3,0,6.4),(3929,'2018-03-16 04:32:12',60.0337,37.7966,-14.2,'gps',0.16,100,1,'352449090711261',3,0,5.9),(3930,'2018-03-16 04:33:12',60.0337,37.7966,-14.3,'gps',0.33,100,1,'352449090711261',3,0,6.3),(3931,'2018-03-16 04:34:12',60.0337,37.7965,-14.3,'gps',0.48,100,1,'352449090711261',3,0,6.5),(3932,'2018-03-16 04:37:48',60.0338,37.7966,16.9,'gps',0,100,1,'352449090711261',3,0,6),(3933,'2018-03-16 04:40:14',60.0336,37.7966,-14.3,'gps',0,100,1,'352449090711261',3,0,6.8),(3934,'2018-03-16 04:43:12',60.0336,37.7962,-14.3,'gps',0.11,100,1,'352449090711261',3,0,5.7),(3935,'2018-03-16 04:44:12',60.0336,37.7962,-14.4,'gps',0.22,100,1,'352449090711261',3,0,6.1),(3936,'2018-03-16 04:45:12',60.0337,37.7964,-14.5,'gps',0,100,1,'352449090711261',3,0,6.3),(3937,'2018-03-16 04:45:17',60.0337,37.7965,-14.6,'gps',0,100,1,'352449090711261',3,0,6.6),(3938,'2018-03-16 04:47:13',60.0336,37.7963,-14.4,'gps',0,100,1,'352449090711261',3,0,7.4),(3939,'2018-03-16 04:48:14',60.0337,37.7964,-14.5,'gps',0,100,1,'352449090711261',3,0,7.4),(3940,'2018-03-16 04:49:13',60.0338,37.7956,-14.6,'gps',0,100,1,'352449090711261',3,0,6.6),(3941,'2018-03-16 04:50:13',60.0338,37.7954,-14.6,'gps',0,100,1,'352449090711261',3,0,6.2),(3942,'2018-03-16 04:51:12',60.0338,37.7961,-14.5,'gps',0,100,1,'352449090711261',3,0,6.4),(3943,'2018-03-16 04:53:12',60.0338,37.7958,-14.6,'gps',0,100,1,'352449090711261',3,0,5.8),(3944,'2018-03-16 04:54:13',60.0337,37.7958,-14.6,'gps',0,100,1,'352449090711261',3,0,5.5),(3945,'2018-03-16 04:55:14',60.0337,37.796,-14.5,'gps',0,100,1,'352449090711261',3,0,7.4),(3946,'2018-03-16 04:56:13',60.0338,37.7949,-14.4,'gps',0.21,100,1,'352449090711261',3,0,5.5),(3947,'2018-03-16 04:56:17',60.0338,37.7959,-14.5,'gps',0,100,1,'352449090711261',3,0,7.3),(3948,'2018-03-16 04:58:13',60.0337,37.7958,-14.4,'gps',0.09,100,1,'352449090711261',3,0,7.3),(3949,'2018-03-16 04:59:13',60.0337,37.7958,-14.4,'gps',0.11,100,1,'352449090711261',3,0,6.9),(3950,'2018-03-16 05:00:12',60.0337,37.7955,-14.4,'gps',0.11,100,1,'352449090711261',3,0,5.8),(3951,'2018-03-16 05:01:13',60.0338,37.7955,-14.6,'gps',0,100,1,'352449090711261',3,0,5.7),(3952,'2018-03-16 05:02:14',60.0337,37.7955,-14,'gps',0,100,1,'352449090711261',3,0,5.6),(3953,'2018-03-16 05:02:19',60.0337,37.7957,-14.5,'gps',0,100,1,'352449090711261',3,0,6.3),(3954,'2018-03-16 05:03:18',60.0338,37.7955,-14.6,'gps',0,100,1,'352449090711261',3,0,6.4),(3955,'2018-03-16 05:05:14',60.0339,37.7955,-14.5,'gps',0,100,1,'352449090711261',3,0,7.1),(3956,'2018-03-16 05:06:20',60.0338,37.7955,-14.5,'gps',0,100,1,'352449090711261',3,0,5.6),(3957,'2018-03-16 05:08:13',60.0338,37.7947,-14.5,'gps',0,100,1,'352449090711261',3,0,5.8),(3958,'2018-03-16 05:09:13',60.0338,37.7948,-14.6,'gps',0,100,1,'352449090711261',3,0,6.2),(3959,'2018-03-16 05:10:13',60.0338,37.7951,-14.5,'gps',0,100,1,'352449090711261',3,0,6.8),(3960,'2018-03-16 05:11:13',60.0337,37.7955,-14.4,'gps',0,100,1,'352449090711261',3,0,7.2),(3961,'2018-03-16 05:12:13',60.0337,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,6.8),(3962,'2018-03-16 05:13:13',60.0338,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,6.7),(3963,'2018-03-16 05:14:14',60.0338,37.7949,-14.4,'gps',0,100,1,'352449090711261',3,0,6.2),(3964,'2018-03-16 05:15:14',60.0338,37.7951,-14.5,'gps',0,100,1,'352449090711261',3,0,6.2),(3965,'2018-03-16 05:16:13',60.0339,37.7947,-14.6,'gps',0,100,1,'352449090711261',3,0,6.7),(3966,'2018-03-16 05:17:13',60.0338,37.7944,-14.5,'gps',0,100,1,'352449090711261',3,0,6.4),(3967,'2018-03-16 05:18:15',60.0338,37.7949,-14.4,'gps',0,100,1,'352449090711261',3,0,6.3),(3968,'2018-03-16 05:19:27',60.0335,37.7949,-15.8,'gps',3.15,100,1,'352449090711261',3,0,4.5),(3969,'2018-03-16 05:19:29',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(3970,'2018-03-16 05:20:14',60.0339,37.7945,-14.5,'gps',0,100,1,'352449090711261',3,0,6.7),(3971,'2018-03-16 05:21:14',60.0338,37.7946,-14.5,'gps',0,100,1,'352449090711261',3,0,5.7),(3972,'2018-03-16 05:22:14',60.034,37.7949,-14.3,'gps',0,100,1,'352449090711261',3,0,6.3),(3973,'2018-03-16 05:23:14',60.0339,37.7947,-14.5,'gps',0,100,1,'352449090711261',3,0,7.9),(3974,'2018-03-16 05:24:14',60.0338,37.7947,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(3975,'2018-03-16 05:25:15',60.034,37.7947,-14,'gps',0,100,1,'352449090711261',3,0,7.1),(3976,'2018-03-16 05:26:15',60.0338,37.7947,-14.4,'gps',0,100,1,'352449090711261',3,0,6.3),(3977,'2018-03-16 05:27:16',60.0337,37.7945,-14.2,'gps',0,100,1,'352449090711261',3,0,5.5),(3978,'2018-03-16 05:28:14',60.0338,37.7946,-14.2,'gps',0,100,1,'352449090711261',3,0,6.1),(3979,'2018-03-16 05:28:22',60.0339,37.7942,-12.3,'gps',0,100,1,'352449090711261',3,0,4.9),(3980,'2018-03-16 05:30:14',60.0338,37.7937,-11.6,'gps',0,100,1,'352449090711261',3,0,5.4),(3981,'2018-03-16 05:31:15',60.0338,37.7943,-14.3,'gps',0,100,1,'352449090711261',3,0,6.1),(3982,'2018-03-16 05:32:15',60.0338,37.7944,-14.3,'gps',0,100,1,'352449090711261',3,0,6.1),(3983,'2018-03-16 05:33:16',60.0337,37.7944,-14.3,'gps',0,100,1,'352449090711261',3,0,6.1),(3984,'2018-03-16 05:34:15',60.0338,37.7944,-14.2,'gps',0,100,1,'352449090711261',3,0,5.7),(3985,'2018-03-16 05:35:12',60.0338,37.7944,-14.5,'gps',0,100,1,'352449090711261',3,0,6.5),(3986,'2018-03-16 05:36:11',60.0339,37.7953,-14.5,'gps',0,100,1,'352449090711261',3,0,7),(3987,'2018-03-16 05:37:11',60.0338,37.7947,-14.5,'gps',0,100,1,'352449090711261',3,0,6.8),(3988,'2018-03-16 05:38:11',60.0338,37.7945,-14.6,'gps',0,100,1,'352449090711261',3,0,6.8),(3989,'2018-03-16 05:39:12',60.0339,37.7951,-13.4,'gps',0,100,1,'352449090711261',3,0,6.5),(3990,'2018-03-16 05:39:17',60.0338,37.7944,-14.4,'gps',0,100,1,'352449090711261',3,0,6.6),(3991,'2018-03-16 05:41:13',60.0339,37.7946,-14.1,'gps',0,100,1,'352449090711261',3,0,6.9),(3992,'2018-03-16 05:42:12',60.0342,37.7956,-13.2,'gps',0.14,100,1,'352449090711261',3,0,6.3),(3993,'2018-03-16 05:43:11',60.0338,37.7948,-14.4,'gps',0.77,100,1,'352449090711261',3,0,7.3),(3994,'2018-03-16 05:44:12',60.0339,37.7949,-14.1,'gps',0,100,1,'352449090711261',3,0,6.8),(3995,'2018-03-16 05:45:12',60.0339,37.7951,-13.9,'gps',0.77,100,1,'352449090711261',3,0,6.6),(3996,'2018-03-16 05:46:12',60.0341,37.7955,-13.6,'gps',0.16,100,1,'352449090711261',3,0,6.6),(3997,'2018-03-16 05:47:11',60.0342,37.7953,-14,'gps',0,100,1,'352449090711261',3,0,6.8),(3998,'2018-03-16 05:48:13',60.034,37.7958,-13.8,'gps',0,100,1,'352449090711261',3,0,6.9),(3999,'2018-03-16 05:49:13',60.034,37.7959,-14.2,'gps',0,100,1,'352449090711261',3,0,6.8),(4000,'2018-03-16 05:50:13',60.0343,37.7957,-13.9,'gps',0,100,1,'352449090711261',3,0,7.3),(4001,'2018-03-16 05:51:15',60.0343,37.7948,90.5,'gps',0,100,1,'352449090711261',3,0,5.2),(4002,'2018-03-16 05:52:14',60.0342,37.7952,-11.4,'gps',0,100,1,'352449090711261',3,0,5.1),(4003,'2018-03-16 05:53:12',60.0342,37.7952,-14.3,'gps',0,100,1,'352449090711261',3,0,6.6),(4004,'2018-03-16 05:54:13',60.0342,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,7),(4005,'2018-03-16 05:55:14',60.0343,37.7952,-14.5,'gps',0,100,1,'352449090711261',3,0,6),(4006,'2018-03-16 05:56:13',60.0342,37.795,-14.5,'gps',0,100,1,'352449090711261',3,0,7.3),(4007,'2018-03-16 05:57:13',60.0344,37.7953,-14.4,'gps',0,100,1,'352449090711261',3,0,7.4),(4008,'2018-03-16 05:58:13',60.0343,37.7953,-14.4,'gps',0,100,1,'352449090711261',3,0,6.9),(4009,'2018-03-16 05:59:14',60.0345,37.7951,-14.5,'gps',0,100,1,'352449090711261',3,0,6.1),(4010,'2018-03-16 06:00:16',60.0344,37.795,-14.5,'gps',0,100,1,'352449090711261',3,0,5.3),(4011,'2018-03-16 06:01:14',60.0344,37.7953,-13.1,'gps',0,100,1,'352449090711261',3,0,5.4),(4012,'2018-03-16 06:02:13',60.0344,37.7956,-14,'gps',0,100,1,'352449090711261',3,0,7.1),(4013,'2018-03-16 06:03:15',60.0343,37.7949,-13.4,'gps',0,100,1,'352449090711261',3,0,5.3),(4014,'2018-03-16 06:04:13',60.0344,37.7953,-14.4,'gps',0,100,1,'352449090711261',3,0,7.5),(4015,'2018-03-16 06:05:14',60.0344,37.7948,-14.5,'gps',0,100,1,'352449090711261',3,0,5.8),(4016,'2018-03-16 06:06:13',60.0344,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,6.7),(4017,'2018-03-16 06:07:17',60.0344,37.795,-14.5,'gps',0,100,1,'352449090711261',3,0,5.3),(4018,'2018-03-16 06:07:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4019,'2018-03-16 06:08:13',60.0345,37.796,-14.2,'gps',0,100,1,'352449090711261',3,0,6.6),(4020,'2018-03-16 06:09:13',60.0345,37.796,-13.5,'gps',0,100,1,'352449090711261',3,0,6.1),(4021,'2018-03-16 06:10:14',60.0343,37.794,-14.5,'gps',0,100,1,'352449090711261',3,0,5.4),(4022,'2018-03-16 06:11:17',60.0343,37.7948,-14.4,'gps',0,100,1,'352449090711261',3,0,5.5),(4023,'2018-03-16 06:11:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4024,'2018-03-16 06:12:14',60.0344,37.796,-12.7,'gps',0,100,1,'352449090711261',3,0,5.9),(4025,'2018-03-16 06:12:21',60.0345,37.7959,-12.7,'gps',0,100,1,'352449090711261',3,0,5.9),(4026,'2018-03-16 06:14:13',60.0344,37.7948,-14.5,'gps',0,100,1,'352449090711261',3,0,6.6),(4027,'2018-03-16 06:15:15',60.0343,37.7949,-12.2,'gps',0,100,1,'352449090711261',3,0,5.2),(4028,'2018-03-16 06:16:15',60.034,37.7953,-9.1,'gps',0,100,1,'352449090711261',3,0,5.6),(4029,'2018-03-16 06:17:12',60.0343,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,6.5),(4030,'2018-03-16 06:18:13',60.0342,37.7949,-11,'gps',0,100,1,'352449090711261',3,0,6.1),(4031,'2018-03-16 06:19:14',60.0341,37.7949,2.1,'gps',0,100,1,'352449090711261',3,0,5.6),(4032,'2018-03-16 06:20:13',60.0339,37.7948,-11.7,'gps',0,100,1,'352449090711261',3,0,6),(4033,'2018-03-16 06:21:16',60.0343,37.7947,-14.5,'gps',0,100,1,'352449090711261',3,0,5),(4034,'2018-03-16 06:22:14',60.0342,37.7953,-10.3,'gps',0,100,1,'352449090711261',3,0,6.3),(4035,'2018-03-16 06:23:14',60.0343,37.7951,60.1,'gps',0,100,1,'352449090711261',3,0,10.6),(4036,'2018-03-16 06:23:22',60.034,37.7959,-14.5,'gps',0,100,1,'352449090711261',3,0,11.7),(4037,'2018-03-16 06:25:14',60.0343,37.794,-14.4,'gps',0,100,1,'352449090711261',3,0,11.2),(4038,'2018-03-16 06:25:26',60.0342,37.7939,-14.5,'gps',0,100,1,'352449090711261',3,0,11.5),(4039,'2018-03-16 06:27:14',60.0344,37.7943,130,'gps',0,100,1,'352449090711261',3,0,6),(4040,'2018-03-16 06:28:11',60.0341,37.795,-14.2,'gps',0,100,1,'352449090711261',3,0,6.8),(4041,'2018-03-16 06:28:17',60.0343,37.795,-14.3,'gps',0,100,1,'352449090711261',3,0,6.4),(4042,'2018-03-16 06:30:11',60.0341,37.795,-14.2,'gps',0,100,1,'352449090711261',3,0,6.7),(4043,'2018-03-16 06:31:12',60.0342,37.7948,-14.4,'gps',0,100,1,'352449090711261',3,0,6.8),(4044,'2018-03-16 06:32:13',60.0342,37.7943,-14.3,'gps',0,100,1,'352449090711261',3,0,6.9),(4045,'2018-03-16 06:32:20',60.0343,37.7938,-14.2,'gps',0,100,1,'352449090711261',3,0,5.9),(4046,'2018-03-16 06:33:20',60.0344,37.7941,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(4047,'2018-03-16 06:35:14',60.0342,37.7942,96,'gps',0,100,1,'352449090711261',3,0,6),(4048,'2018-03-16 06:36:15',60.0344,37.7949,-14.2,'gps',0,100,1,'352449090711261',3,0,6),(4049,'2018-03-16 06:37:13',60.0344,37.7955,-13.6,'gps',0,100,1,'352449090711261',3,0,6.6),(4050,'2018-03-16 06:38:14',60.0342,37.795,-11.2,'gps',0,100,1,'352449090711261',3,0,7.6),(4051,'2018-03-16 06:39:13',60.0346,37.7955,-14.4,'gps',0,100,1,'352449090711261',3,0,9.7),(4052,'2018-03-16 06:40:14',60.0341,37.7958,-14.5,'gps',0,100,1,'352449090711261',3,0,8.1),(4053,'2018-03-16 06:41:13',60.0342,37.7966,-14.5,'gps',0,100,1,'352449090711261',3,0,13.1),(4054,'2018-03-16 06:42:13',60.0342,37.7958,-14.5,'gps',0,100,1,'352449090711261',3,0,10.8),(4055,'2018-03-16 06:43:18',60.0339,37.796,-11,'gps',0,100,1,'352449090711261',3,0,8.5),(4056,'2018-03-16 06:43:20',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4057,'2018-03-16 06:44:17',60.0341,37.7951,-14.4,'gps',0,100,1,'352449090711261',3,0,5.7),(4058,'2018-03-16 06:44:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4059,'2018-03-16 06:45:14',60.0342,37.7953,-14.5,'gps',0,100,1,'352449090711261',3,0,7.8),(4060,'2018-03-16 06:46:15',60.0342,37.7951,-14.4,'gps',0,100,1,'352449090711261',3,0,5.8),(4061,'2018-03-16 06:47:20',60.0342,37.796,-14.6,'gps',0,100,1,'352449090711261',3,0,4.8),(4062,'2018-03-16 06:47:22',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4063,'2018-03-16 06:48:13',60.0341,37.7949,-13.7,'gps',0,100,1,'352449090711261',3,0,5.8),(4064,'2018-03-16 06:49:14',60.0342,37.7952,-13.4,'gps',0,100,1,'352449090711261',3,0,5.2),(4065,'2018-03-16 06:50:17',60.0343,37.7961,-14.3,'gps',0,100,1,'352449090711261',3,0,5.2),(4066,'2018-03-16 06:50:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4067,'2018-03-16 06:51:14',60.0342,37.7955,-14.5,'gps',0,100,1,'352449090711261',3,0,7.4),(4068,'2018-03-16 06:52:15',60.0342,37.7956,-14.5,'gps',0,100,1,'352449090711261',3,0,6),(4069,'2018-03-16 06:53:14',60.0341,37.7955,-13,'gps',0,100,1,'352449090711261',3,0,6.5),(4070,'2018-03-16 06:54:16',60.0341,37.7953,-14.4,'gps',0,100,1,'352449090711261',3,0,5.9),(4071,'2018-03-16 06:55:13',60.0341,37.7952,-14.4,'gps',0,100,1,'352449090711261',3,0,7.6),(4072,'2018-03-16 06:56:14',60.0341,37.795,-11.6,'gps',0,100,1,'352449090711261',3,0,6.1),(4073,'2018-03-16 06:59:16',60.0343,37.796,-13.9,'gps',0,100,1,'352449090711261',3,0,9.2),(4074,'2018-03-16 07:00:14',60.0344,37.796,-14.5,'gps',0,100,1,'352449090711261',3,0,11.4),(4075,'2018-03-16 07:01:13',60.0344,37.7958,-14.5,'gps',0,100,1,'352449090711261',3,0,11.6),(4076,'2018-03-16 07:02:13',60.0344,37.7949,-14.3,'gps',0,100,1,'352449090711261',3,0,11.8),(4077,'2018-03-16 07:03:19',60.0343,37.7951,-14.5,'gps',0,100,1,'352449090711261',3,0,7.1),(4078,'2018-03-16 07:04:19',60.0341,37.7957,-14.2,'gps',0,100,1,'352449090711261',3,0,7.1),(4079,'2018-03-16 07:07:14',60.0341,37.7947,-14.4,'gps',0,100,1,'352449090711261',3,0,5.5),(4080,'2018-03-16 07:08:13',60.0341,37.795,-13.8,'gps',0,100,1,'352449090711261',3,0,6),(4081,'2018-03-16 07:09:14',60.0344,37.7968,-14.1,'gps',0,100,1,'352449090711261',3,0,5.8),(4082,'2018-03-16 07:10:14',60.0343,37.7966,-14.2,'gps',0,100,1,'352449090711261',3,0,6.2),(4083,'2018-03-16 07:11:13',60.0344,37.7961,-10.3,'gps',0,100,1,'352449090711261',3,0,6.1),(4084,'2018-03-16 07:12:13',60.0342,37.7957,-2.7,'gps',0,100,1,'352449090711261',3,0,5.9),(4085,'2018-03-16 07:13:14',60.0342,37.7956,-3.9,'gps',0,100,1,'352449090711261',3,0,5.8),(4086,'2018-03-16 07:14:14',60.034,37.7955,-9.4,'gps',0,100,1,'352449090711261',3,0,5.9),(4087,'2018-03-16 07:15:12',60.034,37.7949,-14.4,'gps',0,100,1,'352449090711261',3,0,6.5),(4088,'2018-03-16 07:16:12',60.034,37.7952,-14.4,'gps',0,100,1,'352449090711261',3,0,6.5),(4089,'2018-03-16 07:17:12',60.0341,37.7951,-14.5,'gps',0,100,1,'352449090711261',3,0,6.8),(4090,'2018-03-16 07:18:14',60.0342,37.7952,-10,'gps',0,100,1,'352449090711261',3,0,5.9),(4091,'2018-03-16 07:19:13',60.0339,37.7937,-14.4,'gps',0,100,1,'352449090711261',3,0,6.5),(4092,'2018-03-16 07:20:15',60.0344,37.7949,-10.1,'gps',0,100,1,'352449090711261',3,0,5.7),(4093,'2018-03-16 07:21:14',60.0342,37.795,-14.3,'gps',0,100,1,'352449090711261',3,0,6.3),(4094,'2018-03-16 07:22:14',60.0342,37.7946,71.8,'gps',0,100,1,'352449090711261',3,0,5.6),(4095,'2018-03-16 07:23:14',60.0342,37.7949,63.6,'gps',0,100,1,'352449090711261',3,0,7.9),(4096,'2018-03-16 07:24:14',60.0343,37.7949,-14.3,'gps',0,100,1,'352449090711261',3,0,5.9),(4097,'2018-03-16 07:25:16',60.0344,37.7948,-14.4,'gps',0,100,1,'352449090711261',3,0,4.7),(4098,'2018-03-16 07:26:14',60.0344,37.7949,-14.4,'gps',0,100,1,'352449090711261',3,0,5.2),(4099,'2018-03-16 07:27:14',60.0344,37.7949,-12.1,'gps',0,100,1,'352449090711261',3,0,5),(4100,'2018-03-16 07:28:16',60.0343,37.7949,-14.4,'gps',0,100,1,'352449090711261',3,0,5.2),(4101,'2018-03-16 07:29:15',60.0344,37.7949,-12,'gps',0,100,1,'352449090711261',3,0,5.7),(4102,'2018-03-16 07:30:17',60.0343,37.7948,-14.4,'gps',0,100,1,'352449090711261',3,0,6.5),(4103,'2018-03-16 07:30:19',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,50),(4104,'2018-03-16 07:31:21',60.0342,37.7948,-14.1,'gps',0,100,1,'352449090711261',3,0,6.6),(4105,'2018-03-16 07:31:23',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(4106,'2018-03-16 07:32:31',60.0343,37.7951,-14.4,'gps',0,100,1,'352449090711261',3,0,4.6),(4107,'2018-03-16 07:32:33',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(4108,'2018-03-16 07:33:14',60.0344,37.795,-14.3,'gps',0,100,1,'352449090711261',3,0,5.7),(4109,'2018-03-16 07:34:14',60.0344,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,5.8),(4110,'2018-03-16 07:35:14',60.0344,37.7949,-14.5,'gps',0,100,1,'352449090711261',3,0,5.7),(4111,'2018-03-16 07:36:14',60.0343,37.7961,-14.1,'gps',0,100,1,'352449090711261',3,0,5.3),(4112,'2018-03-16 07:37:13',60.0342,37.7951,-14.3,'gps',0,100,1,'352449090711261',3,0,6.4),(4113,'2018-03-16 07:38:12',60.0343,37.7951,-14.3,'gps',0,100,1,'352449090711261',3,0,6.5),(4114,'2018-03-16 07:39:12',60.0341,37.795,-13.9,'gps',0,100,1,'352449090711261',3,0,6.3),(4115,'2018-03-16 07:40:12',60.0341,37.796,-14.2,'gps',0,100,1,'352449090711261',3,0,6.5),(4116,'2018-03-16 07:41:13',60.0342,37.7953,-14.4,'gps',0,100,1,'352449090711261',3,0,6.6),(4117,'2018-03-16 07:42:13',60.034,37.7955,-14.3,'gps',0,100,1,'352449090711261',3,0,6.4),(4118,'2018-03-16 07:43:12',60.0341,37.7954,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(4119,'2018-03-16 07:44:15',60.0342,37.7947,-9.9,'gps',0,100,1,'352449090711261',3,0,5.1),(4120,'2018-03-16 07:45:16',60.0343,37.7948,-13.6,'gps',0,100,1,'352449090711261',3,0,4.8),(4121,'2018-03-16 07:45:23',60.0341,37.7947,-14.1,'gps',0,100,1,'352449090711261',3,0,6.4),(4122,'2018-03-16 07:47:14',60.0339,37.7958,-14.1,'gps',4.02,100,1,'352449090711261',3,0,6.3),(4123,'2018-03-16 07:48:12',60.0341,37.7952,-14.4,'gps',0,100,1,'352449090711261',3,0,6.7),(4124,'2018-03-16 07:49:14',60.0341,37.7954,-14.1,'gps',8.39,100,1,'352449090711261',3,0,6.3),(4125,'2018-03-16 07:50:14',60.0341,37.7954,-14.1,'gps',0,100,1,'352449090711261',3,0,7.5),(4126,'2018-03-16 07:51:15',60.034,37.795,-14,'gps',0,100,1,'352449090711261',3,0,6.1),(4127,'2018-03-16 07:52:14',60.0342,37.7931,-14.1,'gps',0,100,1,'352449090711261',3,0,5.2),(4128,'2018-03-16 07:53:14',60.034,37.7945,-14.2,'gps',0,100,1,'352449090711261',3,0,5.4),(4129,'2018-03-16 07:54:13',60.034,37.7948,-14.4,'gps',0,100,1,'352449090711261',3,0,6.5),(4130,'2018-03-16 07:55:20',60.0341,37.7947,-14.2,'gps',0,100,1,'352449090711261',3,0,6.4),(4131,'2018-03-16 07:57:21',60.0337,37.7948,-14.2,'gps',0,100,1,'352449090711261',3,0,4.7),(4132,'2018-03-16 07:57:23',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(4133,'2018-03-16 07:58:28',60.0337,37.7948,-14.1,'gps',0,100,1,'352449090711261',3,0,3.9),(4134,'2018-03-16 07:58:30',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,20),(4135,'2018-03-16 07:59:15',60.0338,37.7945,-13.9,'gps',0,100,1,'352449090711261',3,0,5.2),(4136,'2018-03-16 08:00:16',60.0339,37.7946,-14.4,'gps',0,100,1,'352449090711261',3,0,4.9),(4137,'2018-03-16 08:01:06',60.0342,37.7946,0,'network',0,100,1,'352449090711261',3,0,24.9),(4138,'2018-03-16 08:01:22',60.0342,37.7946,0,'network',0,100,0,'352449090711261',3,0,20.4),(4139,'2018-03-16 08:02:25',60.0342,37.7946,0,'network',0,100,0,'352449090711261',3,0,20),(4140,'2018-03-16 08:04:40',60.0341,37.7948,-14.4,'gps',0,100,0,'352449090711261',3,0,8.1),(4141,'2018-03-16 08:04:42',60.0342,37.7946,0,'network',0,100,0,'352449090711261',3,0,20),(4142,'2018-03-16 08:05:45',60.0339,37.7944,-14.5,'gps',0,99,0,'352449090711261',3,0,6.7),(4143,'2018-03-16 08:05:46',60.0342,37.7946,0,'network',0,99,0,'352449090711261',3,0,20),(4144,'2018-03-16 08:11:27',60.0342,37.7946,0,'network',0,99,0,'352449090711261',3,0,20),(4145,'2018-03-16 08:14:27',60.0342,37.7946,0,'network',0,99,0,'352449090711261',3,0,20),(4146,'2018-03-16 13:57:27',60.0338,37.7942,22.8,'gps',0,81,0,'352449090711261',3,0,4.7),(4147,'2018-03-16 13:57:28',60.0342,37.7946,0,'network',0,81,0,'352449090711261',3,0,20.1),(4148,'2018-03-16 14:13:00',60.034,37.7944,-17.5,'gps',0,81,0,'352449090711261',3,0,9.6),(4149,'2018-03-16 14:43:09',60.0342,37.7946,0,'network',0,81,0,'352449090711261',3,0,20),(4150,'2018-03-16 14:49:20',60.0347,37.7948,200,'gps',0,81,0,'352449090711261',3,0,10.2),(4151,'2018-03-16 14:49:33',60.0342,37.7946,0,'network',0,81,0,'352449090711261',3,0,20),(4152,'2018-03-16 16:06:20',59.9021,37.6722,0,'network',0,79,0,'352449090711261',3,0,20),(4153,'2018-03-16 17:52:39',59.9021,37.6722,0,'network',0,76,0,'352449090711261',3,0,20),(4154,'2018-03-16 18:07:51',59.9021,37.6722,0,'network',0,76,0,'352449090711261',3,0,20),(4155,'2018-03-16 18:22:58',59.9021,37.6722,0,'network',0,75,0,'352449090711261',3,0,20),(4156,'2018-03-16 19:23:20',59.9021,37.6722,0,'network',0,74,0,'352449090711261',3,0,20),(4157,'2018-03-16 19:38:29',59.9021,37.6722,0,'network',0,72,0,'352449090711261',3,0,20),(4158,'2018-03-16 21:24:38',59.9021,37.6722,0,'network',0,71,0,'352449090711261',3,0,20),(4159,'2018-03-16 21:39:43',59.9021,37.6722,0,'network',0,70,0,'352449090711261',3,0,20),(4160,'2018-03-17 22:04:10',59.9021,37.6722,0,'network',0,22,0,'352449090711261',3,0,20),(4161,'2018-03-17 23:19:56',59.9021,37.6722,0,'network',0,19,0,'352449090711261',3,0,20),(4162,'2018-03-18 02:06:28',59.9021,37.6722,0,'network',0,13,0,'352449090711261',3,0,20),(4163,'2018-03-18 04:07:18',59.9021,37.6722,0,'network',0,10,0,'352449090711261',3,0,20),(4164,'2018-03-18 04:37:31',59.9021,37.6722,0,'network',0,9,0,'352449090711261',3,0,20),(4165,'2018-03-18 04:52:37',59.9021,37.6722,0,'network',0,8,0,'352449090711261',3,0,20),(4166,'2018-03-18 05:22:49',59.9021,37.6722,0,'network',0,8,0,'352449090711261',3,0,20),(4167,'2018-03-18 06:08:13',59.9021,37.6722,0,'network',0,6,0,'352449090711261',3,0,20),(4168,'2018-03-18 08:24:48',59.9021,37.6722,0,'network',0,3,0,'352449090711261',3,0,20),(4169,'2018-03-18 08:55:32',59.9021,37.6722,0,'network',0,2,0,'352449090711261',3,0,20),(4170,'2018-03-18 12:15:28',60.0342,37.7947,0,'network',0,64,0,'352449090711261',3,0,50),(4171,'2018-03-18 12:16:15',60.0336,37.7941,-13.8,'gps',0,64,0,'352449090711261',3,0,11.5),(4172,'2018-03-18 12:17:22',60.0342,37.7946,0,'network',0,64,0,'352449090711261',3,0,20.1),(4173,'2018-03-18 12:18:20',60.0342,37.7946,0,'network',0,64,0,'352449090711261',3,0,20.9),(4174,'2018-03-18 12:19:22',60.0342,37.7946,0,'network',0,64,0,'352449090711261',3,0,20),(4175,'2018-03-18 12:20:22',60.0342,37.7946,0,'network',0,64,0,'352449090711261',3,0,60),(4176,'2018-03-18 12:21:22',60.0342,37.7946,0,'network',0,64,0,'352449090711261',3,0,28.1),(4177,'2018-03-18 12:22:22',60.0346,37.7943,0,'network',0,64,0,'352449090711261',3,0,29.936),(4178,'2018-03-18 12:23:27',60.0345,37.7943,0,'network',0,63,0,'352449090711261',3,0,28.156),(4179,'2018-03-18 12:24:22',60.0345,37.7943,0,'network',0,63,0,'352449090711261',3,0,41.848),(4180,'2018-03-18 12:25:24',60.0342,37.7946,0,'network',0,63,0,'352449090711261',3,0,30),(4181,'2018-03-18 12:26:27',60.0342,37.7942,-14.3,'gps',0,62,0,'352449090711261',3,0,4.8),(4182,'2018-03-18 13:05:16',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20.9),(4183,'2018-03-18 13:06:17',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20),(4184,'2018-03-18 13:07:18',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20),(4185,'2018-03-18 13:11:00',60.034,37.7937,-13.8,'gps',0,58,0,'352449090711261',3,0,5.3),(4186,'2018-03-18 13:11:02',60.0342,37.7946,0,'network',0,58,0,'352449090711261',3,0,20.9),(4187,'2018-03-18 13:56:42',60.0342,37.7946,0,'network',0,57,0,'352449090711261',3,0,22.5),(4188,'2018-03-18 14:38:46',60.0343,37.7945,0,'network',0,55,1,'352449090711261',3,0,51.189),(4189,'2018-03-18 14:39:42',60.0343,37.7945,0,'network',0,55,1,'352449090711261',3,0,50.878),(4190,'2018-03-18 14:40:54',60.0339,37.7935,-14.5,'gps',0,55,1,'352449090711261',3,0,6.1),(4191,'2018-03-18 14:40:56',60.0343,37.7945,0,'network',0,55,1,'352449090711261',3,0,50.878),(4192,'2018-03-18 14:41:54',60.0342,37.7939,-14.2,'gps',0,55,1,'352449090711261',3,0,4.5),(4193,'2018-03-18 14:41:56',60.0343,37.7945,0,'network',0,56,1,'352449090711261',3,0,50.783),(4194,'2018-03-18 14:42:48',60.0341,37.794,-14.3,'gps',0,56,1,'352449090711261',3,0,7),(4195,'2018-03-18 14:42:49',60.0344,37.7942,0,'network',0,56,1,'352449090711261',3,0,59.883),(4196,'2018-03-18 14:46:08',60.0342,37.7946,0,'network',0,57,1,'352449090711261',3,0,50.023),(4197,'2018-03-18 14:47:08',60.0343,37.7946,0,'network',0,57,1,'352449090711261',3,0,50.497),(4198,'2018-03-18 14:47:56',60.0342,37.794,-14.5,'gps',0,57,1,'352449090711261',3,0,5.2),(4199,'2018-03-18 14:47:58',60.0343,37.7946,0,'network',0,57,1,'352449090711261',3,0,50.417),(4200,'2018-03-18 14:49:05',60.0342,37.7938,-14.5,'gps',0,58,1,'352449090711261',3,0,4.8),(4201,'2018-03-18 14:49:06',60.0343,37.7946,0,'network',0,58,1,'352449090711261',3,0,50.417),(4202,'2018-03-18 14:50:08',60.0342,37.7946,0,'network',0,58,1,'352449090711261',3,0,20),(4203,'2018-03-18 14:50:54',60.0342,37.7946,-14.5,'gps',0,58,1,'352449090711261',3,0,4.7),(4204,'2018-03-18 14:50:55',60.0342,37.7946,0,'network',0,58,1,'352449090711261',3,0,20),(4205,'2018-03-18 14:52:08',60.0343,37.7945,0,'network',0,58,1,'352449090711261',3,0,50.878),(4206,'2018-03-18 14:52:51',60.034,37.7947,-14.5,'gps',0,58,1,'352449090711261',3,0,4.8),(4207,'2018-03-18 14:52:52',60.0343,37.7944,0,'network',0,58,1,'352449090711261',3,0,53.358),(4208,'2018-03-18 14:53:54',60.034,37.7947,-14.5,'gps',0,58,1,'352449090711261',3,0,4.8),(4209,'2018-03-18 14:53:56',60.0343,37.7944,0,'network',0,58,1,'352449090711261',3,0,53.474),(4210,'2018-03-18 14:54:47',60.0344,37.7945,-14.5,'gps',0,58,1,'352449090711261',3,0,4.8),(4211,'2018-03-18 14:54:49',60.0343,37.7945,0,'network',0,58,1,'352449090711261',3,0,51.189),(4212,'2018-03-18 14:55:50',60.0341,37.7943,-14.6,'gps',0,60,1,'352449090711261',3,0,4.7),(4213,'2018-03-18 14:55:52',60.0343,37.7945,0,'network',0,60,1,'352449090711261',3,0,50.567),(4214,'2018-03-18 14:56:57',60.0342,37.7946,-14.4,'gps',0,61,1,'352449090711261',3,0,4.6),(4215,'2018-03-18 14:56:59',60.0342,37.7946,0,'network',0,61,1,'352449090711261',3,0,20),(4216,'2018-03-18 14:58:08',60.0342,37.7946,0,'network',0,61,1,'352449090711261',3,0,20),(4217,'2018-03-18 14:58:58',60.0344,37.7939,-14.6,'gps',0,61,1,'352449090711261',3,0,4.9),(4218,'2018-03-18 14:59:00',60.0343,37.7945,0,'network',0,61,1,'352449090711261',3,0,50.878),(4219,'2018-03-18 14:59:51',60.0343,37.7944,-14.6,'gps',0,61,1,'352449090711261',3,0,4.7),(4220,'2018-03-18 14:59:52',60.0342,37.7946,0,'network',0,61,1,'352449090711261',3,0,20),(4221,'2018-03-18 15:05:20',60.0341,37.7943,20.1,'gps',0,63,1,'352449090711261',3,0,5.8),(4222,'2018-03-18 15:05:22',60.0342,37.7946,0,'network',0,63,1,'352449090711261',3,0,20),(4223,'2018-03-18 15:06:08',60.0342,37.7946,0,'network',0,64,1,'352449090711261',3,0,20),(4224,'2018-03-18 15:07:08',60.0344,37.7942,0,'network',0,64,1,'352449090711261',3,0,59.883),(4225,'2018-03-18 15:08:17',60.0342,37.7932,-14.5,'gps',0,64,1,'352449090711261',3,0,5.4),(4226,'2018-03-18 15:08:19',60.0342,37.7946,0,'network',0,64,1,'352449090711261',3,0,20),(4227,'2018-03-18 15:09:24',60.0344,37.7941,-14.8,'gps',0,65,1,'352449090711261',3,0,4.8),(4228,'2018-03-18 15:09:26',60.0344,37.7943,0,'network',0,65,1,'352449090711261',3,0,57.486),(4229,'2018-03-18 15:10:24',60.0346,37.7947,-15.2,'gps',0,65,1,'352449090711261',3,0,4.7),(4230,'2018-03-18 15:10:26',60.0344,37.7943,0,'network',0,65,1,'352449090711261',3,0,58.288),(4231,'2018-03-18 15:11:23',60.0343,37.7935,-14.5,'gps',0,65,1,'352449090711261',3,0,4.7),(4232,'2018-03-18 15:11:25',60.0343,37.7945,0,'network',0,65,1,'352449090711261',3,0,51.728),(4233,'2018-03-18 15:14:08',60.0342,37.7946,0,'network',0,65,1,'352449090711261',3,0,20),(4234,'2018-03-18 15:16:08',60.0344,37.7942,0,'network',0,66,1,'352449090711261',3,0,58.7),(4235,'2018-03-18 15:17:08',60.0342,37.7942,-14.1,'gps',0,66,1,'352449090711261',3,0,4.1),(4236,'2018-03-18 15:17:47',60.0343,37.7942,-14.2,'gps',0,66,1,'352449090711261',3,0,4.7),(4237,'2018-03-18 15:17:49',60.0343,37.7945,0,'network',0,66,1,'352449090711261',3,0,50.635),(4238,'2018-03-18 15:18:44',60.0343,37.7942,-14.5,'gps',0,66,1,'352449090711261',3,0,5.9),(4239,'2018-03-18 15:18:45',60.0342,37.7946,0,'network',0,66,1,'352449090711261',3,0,20),(4240,'2018-03-18 15:20:08',60.0342,37.7946,0,'network',0,66,1,'352449090711261',3,0,20),(4241,'2018-03-18 15:20:48',60.0345,37.7938,-14.5,'gps',0,66,1,'352449090711261',3,0,4.8),(4242,'2018-03-18 15:20:49',60.0342,37.7946,0,'network',0,66,1,'352449090711261',3,0,20),(4243,'2018-03-18 15:24:07',60.0343,37.7941,58.4,'gps',0,69,1,'352449090711261',3,0,6.7),(4244,'2018-03-18 15:25:56',60.0345,37.7942,-13.9,'gps',0,71,1,'352449090711261',3,0,6.6),(4245,'2018-03-18 15:30:12',60.0344,37.7941,90.2,'gps',0,74,1,'352449090711261',3,0,6.8),(4246,'2018-03-18 15:35:19',60.0343,37.794,92.4,'gps',0,76,1,'352449090711261',3,0,6.7),(4247,'2018-03-18 15:35:37',60.0343,37.7942,-14.3,'gps',0,76,1,'352449090711261',3,0,6.8),(4248,'2018-03-18 15:36:43',60.0343,37.7941,-14.5,'gps',0,76,1,'352449090711261',3,0,6.4),(4249,'2018-03-18 15:36:45',60.0344,37.7943,0,'network',0,76,1,'352449090711261',3,0,56.316),(4250,'2018-03-18 15:38:17',60.0341,37.7945,-14.4,'gps',0,76,1,'352449090711261',3,0,4.6),(4251,'2018-03-18 15:38:19',60.0343,37.7945,0,'network',0,76,1,'352449090711261',3,0,50.402),(4252,'2018-03-18 15:38:46',60.0342,37.7955,-12.6,'gps',0,76,1,'352449090711261',3,0,5.1),(4253,'2018-03-18 15:42:47',60.0341,37.7949,57.5,'gps',0,77,1,'352449090711261',3,0,6.7),(4254,'2018-03-18 15:43:36',60.0343,37.7945,-14.3,'gps',0,78,1,'352449090711261',3,0,6.8),(4255,'2018-03-18 15:44:39',60.0345,37.7939,-14.2,'gps',0,78,1,'352449090711261',3,0,6.9),(4256,'2018-03-18 15:45:42',60.0343,37.7943,0,'network',0,78,1,'352449090711261',3,0,29.622),(4257,'2018-03-18 15:46:43',60.0343,37.7945,0,'network',0,78,1,'352449090711261',3,0,50.051),(4258,'2018-03-18 15:47:42',60.0343,37.7945,0,'network',0,78,1,'352449090711261',3,0,50.352),(4259,'2018-03-18 15:48:42',60.0342,37.7945,0,'network',0,79,1,'352449090711261',3,0,50.588),(4260,'2018-03-18 15:49:42',60.0342,37.7946,0,'network',0,79,1,'352449090711261',3,0,20),(4261,'2018-03-18 15:50:38',60.0345,37.7951,-14,'gps',0,79,1,'352449090711261',3,0,7.3),(4262,'2018-03-18 15:51:42',60.0344,37.7942,0,'network',0,79,1,'352449090711261',3,0,63.342),(4263,'2018-03-18 15:52:42',60.0342,37.7946,0,'network',0,80,1,'352449090711261',3,0,20),(4264,'2018-03-18 15:53:42',60.0342,37.7946,0,'network',0,80,1,'352449090711261',3,0,20),(4265,'2018-03-18 15:54:38',60.0347,37.7946,-14.2,'gps',0,80,1,'352449090711261',3,0,7.5),(4266,'2018-03-18 15:55:39',60.0344,37.7946,-14.2,'gps',0,80,1,'352449090711261',3,0,7),(4267,'2018-03-18 15:56:42',60.0342,37.7946,0,'network',0,81,1,'352449090711261',3,0,20),(4268,'2018-03-18 15:57:38',60.0347,37.7955,-10.8,'gps',0,81,1,'352449090711261',3,0,6.1),(4269,'2018-03-18 15:58:41',60.0343,37.7944,-13.8,'gps',0,81,1,'352449090711261',3,0,6.4),(4270,'2018-03-18 15:58:42',60.0344,37.7943,0,'network',0,81,1,'352449090711261',3,0,56.124),(4271,'2018-03-18 15:59:38',60.0344,37.794,-1.2,'gps',0,81,1,'352449090711261',3,0,6),(4272,'2018-03-18 16:00:42',60.0345,37.7945,-14.4,'gps',0,81,1,'352449090711261',3,0,6.8),(4273,'2018-03-18 16:01:42',60.0342,37.7946,0,'network',0,82,1,'352449090711261',3,0,20),(4274,'2018-03-18 16:02:43',60.0343,37.7945,0,'network',0,82,1,'352449090711261',3,0,50.409),(4275,'2018-03-18 16:03:42',60.0343,37.7945,0,'network',0,82,1,'352449090711261',3,0,50.908),(4276,'2018-03-18 16:04:42',60.0342,37.7946,0,'network',0,82,1,'352449090711261',3,0,20),(4277,'2018-03-18 16:05:42',60.0344,37.7942,0,'network',0,82,1,'352449090711261',3,0,57.696),(4278,'2018-03-18 16:06:42',60.0344,37.7943,0,'network',0,83,1,'352449090711261',3,0,56.124),(4279,'2018-03-18 16:07:42',60.0344,37.7943,0,'network',0,83,1,'352449090711261',3,0,56.999),(4280,'2018-03-18 16:08:42',60.0344,37.7943,0,'network',0,83,1,'352449090711261',3,0,56.001),(4281,'2018-03-18 16:09:42',60.0342,37.7946,0,'network',0,83,1,'352449090711261',3,0,20),(4282,'2018-03-18 16:10:42',60.0343,37.7946,0,'network',0,83,1,'352449090711261',3,0,50.147),(4283,'2018-03-18 16:11:42',60.0342,37.7946,0,'network',0,83,1,'352449090711261',3,0,20),(4284,'2018-03-18 16:12:42',60.0342,37.7946,0,'network',0,83,1,'352449090711261',3,0,20),(4285,'2018-03-18 16:13:42',60.0342,37.7946,0,'network',0,84,1,'352449090711261',3,0,20),(4286,'2018-03-18 16:14:42',60.0342,37.7946,0,'network',0,84,1,'352449090711261',3,0,20),(4287,'2018-03-18 16:15:42',60.0344,37.7943,0,'network',0,84,1,'352449090711261',3,0,56.124),(4288,'2018-03-18 16:16:42',60.0344,37.7943,0,'network',0,84,1,'352449090711261',3,0,59.037),(4289,'2018-03-18 16:17:40',60.0341,37.7949,-14,'gps',0,84,1,'352449090711261',3,0,10.7),(4290,'2018-03-18 16:18:42',60.0342,37.7946,0,'network',0,84,1,'352449090711261',3,0,20),(4291,'2018-03-18 16:19:42',60.0342,37.7946,0,'network',0,85,1,'352449090711261',3,0,20),(4292,'2018-03-18 16:20:42',60.0342,37.7946,0,'network',0,85,1,'352449090711261',3,0,20),(4293,'2018-03-18 16:21:42',60.0344,37.7943,0,'network',0,85,1,'352449090711261',3,0,58.144),(4294,'2018-03-18 16:22:42',60.0342,37.7946,0,'network',0,85,1,'352449090711261',3,0,20),(4295,'2018-03-18 16:23:42',60.0342,37.7946,0,'network',0,86,1,'352449090711261',3,0,20),(4296,'2018-03-18 16:24:42',60.0344,37.7942,0,'network',0,86,1,'352449090711261',3,0,59.883),(4297,'2018-03-18 16:25:42',60.0342,37.7946,0,'network',0,86,1,'352449090711261',3,0,20),(4298,'2018-03-18 16:26:42',60.0342,37.7946,0,'network',0,86,1,'352449090711261',3,0,20),(4299,'2018-03-18 16:27:42',60.0344,37.7942,0,'network',0,87,1,'352449090711261',3,0,58.392),(4300,'2018-03-18 16:28:42',60.0342,37.7946,0,'network',0,87,1,'352449090711261',3,0,20),(4301,'2018-03-18 16:29:42',60.0342,37.7946,0,'network',0,87,1,'352449090711261',3,0,20),(4302,'2018-03-18 16:30:42',60.0342,37.7946,0,'network',0,88,1,'352449090711261',3,0,20),(4303,'2018-03-18 16:31:42',60.0342,37.7946,0,'network',0,88,1,'352449090711261',3,0,20),(4304,'2018-03-18 16:32:42',60.0344,37.7943,0,'network',0,88,1,'352449090711261',3,0,56.21),(4305,'2018-03-18 16:33:42',60.0344,37.7943,0,'network',0,89,1,'352449090711261',3,0,58.012),(4306,'2018-03-18 16:34:41',60.0352,37.7941,-14.6,'gps',0,89,1,'352449090711261',3,0,8.4),(4307,'2018-03-18 16:35:55',60.0352,37.794,-14.4,'gps',0,89,1,'352449090711261',3,0,6.8),(4308,'2018-03-18 16:35:57',60.0342,37.7946,0,'network',0,89,1,'352449090711261',3,0,20),(4309,'2018-03-18 16:36:40',60.0348,37.7942,-14.5,'gps',0,89,1,'352449090711261',3,0,5.7),(4310,'2018-03-18 16:37:41',60.0344,37.7949,-14.3,'gps',0,90,1,'352449090711261',3,0,6.8),(4311,'2018-03-18 16:37:42',60.0342,37.7946,0,'network',0,90,1,'352449090711261',3,0,20),(4312,'2018-03-18 16:38:39',60.0347,37.7944,-14.3,'gps',0,90,1,'352449090711261',3,0,6.3),(4313,'2018-03-18 16:39:42',60.0342,37.7946,0,'network',0,90,1,'352449090711261',3,0,20),(4314,'2018-03-18 16:40:39',60.0342,37.7944,-15,'gps',0,90,1,'352449090711261',3,0,6.3),(4315,'2018-03-18 16:41:38',60.0342,37.7943,-14.2,'gps',0,91,1,'352449090711261',3,0,7),(4316,'2018-03-18 16:42:42',60.0344,37.7942,0,'network',0,91,1,'352449090711261',3,0,59.994),(4317,'2018-03-18 16:43:42',60.0341,37.7943,-14.2,'gps',0,91,1,'352449090711261',3,0,4.9),(4318,'2018-03-18 16:44:41',60.034,37.7943,-14.3,'gps',0,92,1,'352449090711261',3,0,4.9),(4319,'2018-03-18 16:45:40',60.0341,37.7945,-14.2,'gps',0,92,1,'352449090711261',3,0,5.6),(4320,'2018-03-18 16:46:42',60.0344,37.7943,0,'network',0,92,1,'352449090711261',3,0,56.124),(4321,'2018-03-18 16:47:42',60.0342,37.7946,0,'network',0,92,1,'352449090711261',3,0,20),(4322,'2018-03-18 16:48:42',60.0344,37.7942,0,'network',0,92,1,'352449090711261',3,0,60.391),(4323,'2018-03-18 16:49:42',60.0344,37.7942,0,'network',0,93,1,'352449090711261',3,0,60.391),(4324,'2018-03-18 16:50:42',60.0344,37.7942,0,'network',0,93,1,'352449090711261',3,0,59.98),(4325,'2018-03-18 16:51:42',60.0344,37.7942,0,'network',0,93,1,'352449090711261',3,0,59.741),(4326,'2018-03-18 16:52:40',60.034,37.7945,-14.5,'gps',0,93,1,'352449090711261',3,0,5.8),(4327,'2018-03-18 16:53:42',60.0342,37.7946,0,'network',0,94,1,'352449090711261',3,0,20),(4328,'2018-03-18 16:54:38',60.034,37.7944,-14.5,'gps',0,94,1,'352449090711261',3,0,7.5),(4329,'2018-03-18 16:55:39',60.0339,37.7944,-14.4,'gps',0,94,1,'352449090711261',3,0,6.3),(4330,'2018-03-18 16:56:42',60.0342,37.7946,0,'network',0,94,1,'352449090711261',3,0,20),(4331,'2018-03-18 16:57:42',60.0342,37.7946,0,'network',0,94,1,'352449090711261',3,0,20),(4332,'2018-03-18 16:58:44',60.0344,37.7942,0,'network',0,95,1,'352449090711261',3,0,60.645),(4333,'2018-03-18 16:59:42',60.0342,37.7946,0,'network',0,95,1,'352449090711261',3,0,20),(4334,'2018-03-18 17:00:42',60.0344,37.7942,0,'network',0,95,1,'352449090711261',3,0,57.696),(4335,'2018-03-18 17:01:42',60.0342,37.7946,0,'network',0,95,1,'352449090711261',3,0,20),(4336,'2018-03-18 17:02:42',60.0344,37.7943,0,'network',0,96,1,'352449090711261',3,0,57.706),(4337,'2018-03-18 17:03:42',60.0342,37.7946,0,'network',0,96,1,'352449090711261',3,0,20),(4338,'2018-03-18 17:04:42',60.0338,37.794,-14.2,'gps',0,96,1,'352449090711261',3,0,6.6),(4339,'2018-03-18 17:05:42',60.0344,37.7942,0,'network',0,96,1,'352449090711261',3,0,60.391),(4340,'2018-03-18 17:06:42',60.0344,37.7943,0,'network',0,96,1,'352449090711261',3,0,58.523),(4341,'2018-03-18 17:07:42',60.0342,37.7946,0,'network',0,96,1,'352449090711261',3,0,20),(4342,'2018-03-18 17:08:42',60.0344,37.7942,0,'network',0,97,1,'352449090711261',3,0,60.532),(4343,'2018-03-18 17:09:42',60.0344,37.7942,0,'network',0,97,1,'352449090711261',3,0,59.741),(4344,'2018-03-18 17:10:42',60.0344,37.7942,0,'network',0,97,1,'352449090711261',3,0,59.645),(4345,'2018-03-18 17:11:42',60.0344,37.7943,0,'network',0,97,1,'352449090711261',3,0,57.569),(4346,'2018-03-18 17:12:42',60.0342,37.7946,0,'network',0,97,1,'352449090711261',3,0,20),(4347,'2018-03-18 17:13:42',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,24.9),(4348,'2018-03-18 17:14:45',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,26.4),(4349,'2018-03-18 17:17:08',60.0342,37.7946,0,'network',0,97,0,'352449090711261',3,0,20),(4350,'2018-03-18 19:50:13',60.0341,37.7943,122.8,'gps',0,93,0,'352449090711261',3,0,6.9),(4351,'2018-03-18 20:20:44',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(4352,'2018-03-18 20:46:53',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,22.5),(4353,'2018-03-18 20:47:43',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20.1),(4354,'2018-03-18 20:50:43',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(4355,'2018-03-18 20:52:40',60.0336,37.796,3.2,'gps',0,92,0,'352449090711261',3,0,9),(4356,'2018-03-18 20:52:42',60.0342,37.7946,0,'network',0,92,0,'352449090711261',3,0,20),(4357,'2018-03-18 21:10:16',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,24.9),(4358,'2018-03-18 21:48:30',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,20),(4359,'2018-03-18 21:49:24',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,20.4),(4360,'2018-03-18 21:51:08',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,20.1),(4361,'2018-03-18 21:52:08',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,20.1),(4362,'2018-03-18 21:53:08',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,20.1),(4363,'2018-03-18 21:58:36',60.0342,37.7946,0,'network',0,90,0,'352449090711261',3,0,20.9),(4364,'2018-03-18 22:31:04',60.035,37.7956,50.2,'gps',0,88,0,'352449090711261',3,0,4.4),(4365,'2018-03-18 22:31:07',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4366,'2018-03-18 22:32:08',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4367,'2018-03-18 22:32:58',60.0333,37.7951,-14.3,'gps',3.01,88,0,'352449090711261',3,0,4.4),(4368,'2018-03-18 22:33:00',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4369,'2018-03-18 22:33:50',60.0341,37.7965,-14,'gps',0,88,0,'352449090711261',3,0,5.5),(4370,'2018-03-18 22:33:52',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4371,'2018-03-18 22:34:50',60.0336,37.7954,-13.9,'gps',3.47,88,0,'352449090711261',3,0,4.7),(4372,'2018-03-18 22:34:52',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4373,'2018-03-18 22:36:08',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4374,'2018-03-18 22:37:08',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4375,'2018-03-18 22:38:08',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4376,'2018-03-18 22:38:53',60.0342,37.7946,0,'network',0,88,0,'352449090711261',3,0,20),(4377,'2018-03-18 23:24:12',60.0342,37.7946,0,'network',0,87,0,'352449090711261',3,0,20),(4378,'2018-03-18 23:39:20',60.0342,37.7946,0,'network',0,87,0,'352449090711261',3,0,20),(4379,'2018-03-19 00:24:37',60.034,37.7941,60.8,'gps',0,87,0,'352449090711261',3,0,5.8),(4380,'2018-03-19 05:29:18',60.0341,37.7938,82.7,'gps',0,70,0,'352449090711261',3,0,7.5),(4381,'2018-03-19 05:29:20',60.0342,37.7946,0,'network',0,70,0,'352449090711261',3,0,20),(4382,'2018-03-19 06:09:06',60.0342,37.7942,144.4,'gps',0,70,0,'352449090711261',3,0,6.7),(4383,'2018-03-19 06:09:41',60.0341,37.7943,-14.4,'gps',0,70,0,'352449090711261',3,0,6.6),(4384,'2018-03-19 06:09:43',60.0342,37.7946,0,'network',0,70,0,'352449090711261',3,0,20.1),(4385,'2018-03-19 06:12:07',60.0344,37.7954,-12.8,'gps',0,70,0,'352449090711261',3,0,4.6),(4386,'2018-03-19 06:14:08',60.0342,37.7946,0,'network',0,70,0,'352449090711261',3,0,20.1),(4387,'2018-03-19 06:23:38',60.0327,37.7964,150.9,'gps',0,69,0,'352449090711261',3,0,8),(4388,'2018-03-19 06:23:40',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4389,'2018-03-19 06:24:51',60.0343,37.7953,-14.2,'gps',0,69,0,'352449090711261',3,0,4.1),(4390,'2018-03-19 06:24:53',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4391,'2018-03-19 06:25:26',60.0342,37.7951,-14.1,'gps',0,69,0,'352449090711261',3,0,6.5),(4392,'2018-03-19 06:25:28',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4393,'2018-03-19 06:27:00',60.0348,37.7949,-10.4,'gps',0,69,0,'352449090711261',3,0,6.6),(4394,'2018-03-19 06:27:02',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4395,'2018-03-19 06:28:24',60.0345,37.7957,-14.2,'gps',0,69,0,'352449090711261',3,0,5.2),(4396,'2018-03-19 06:28:26',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4397,'2018-03-19 06:29:28',60.0345,37.7957,-14.2,'gps',0,69,0,'352449090711261',3,0,4.6),(4398,'2018-03-19 06:29:29',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4399,'2018-03-19 06:44:46',60.0341,37.7949,-14.5,'gps',0,69,0,'352449090711261',3,0,6.6),(4400,'2018-03-19 06:44:48',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4401,'2018-03-19 07:05:45',60.0345,37.7947,64.4,'gps',0,69,0,'352449090711261',3,0,5.9),(4402,'2018-03-19 07:05:47',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4403,'2018-03-19 07:06:44',60.0345,37.7951,-14.4,'gps',0,69,0,'352449090711261',3,0,4.3),(4404,'2018-03-19 07:06:46',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4405,'2018-03-19 07:12:04',60.0345,37.7949,-14.4,'gps',0,69,0,'352449090711261',3,0,6.6),(4406,'2018-03-19 07:12:06',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4407,'2018-03-19 07:13:07',60.0344,37.7947,-14.4,'gps',0,69,0,'352449090711261',3,0,7.2),(4408,'2018-03-19 07:13:09',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4409,'2018-03-19 07:14:08',60.0342,37.7946,0,'network',0,69,0,'352449090711261',3,0,20.1),(4410,'2018-03-19 07:27:33',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4411,'2018-03-19 07:28:25',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4412,'2018-03-19 07:31:40',60.0339,37.7951,-14.2,'gps',0,68,0,'352449090711261',3,0,6.3),(4413,'2018-03-19 07:31:42',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4414,'2018-03-19 07:37:28',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4415,'2018-03-19 07:39:43',60.0349,37.794,-14.5,'gps',0,68,0,'352449090711261',3,0,7.5),(4416,'2018-03-19 07:39:54',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,36.9),(4417,'2018-03-19 07:40:44',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,36.9),(4418,'2018-03-19 07:41:35',60.034,37.7947,-14.5,'gps',0,68,0,'352449090711261',3,0,4.9),(4419,'2018-03-19 07:43:17',60.0344,37.7942,-14.4,'gps',0,68,0,'352449090711261',3,0,4),(4420,'2018-03-19 07:44:29',60.0339,37.7942,-14.5,'gps',0,68,0,'352449090711261',3,0,6.5),(4421,'2018-03-19 07:44:30',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20.1),(4422,'2018-03-19 07:45:22',60.0341,37.7944,-14.5,'gps',0,68,0,'352449090711261',3,0,6.3),(4423,'2018-03-19 07:45:24',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20.4),(4424,'2018-03-19 07:51:13',60.0339,37.7944,-4.8,'gps',0,68,0,'352449090711261',3,0,6.8),(4425,'2018-03-19 08:02:11',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4426,'2018-03-19 08:02:43',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20.1),(4427,'2018-03-19 08:03:43',60.0344,37.7943,0,'network',0,68,0,'352449090711261',3,0,55.988),(4428,'2018-03-19 08:04:43',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,23.6),(4429,'2018-03-19 08:05:42',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4430,'2018-03-19 08:06:45',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20),(4431,'2018-03-19 08:10:09',60.0342,37.7946,0,'network',0,68,0,'352449090711261',3,0,20);
/*!40000 ALTER TABLE `gpslog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ADDED` datetime DEFAULT NULL,
  `OBJECT_ID` int(10) NOT NULL DEFAULT '0',
  `METHOD_ID` int(10) NOT NULL DEFAULT '0',
  `VALUE_ID` int(10) NOT NULL DEFAULT '0',
  `OLD_VALUE` varchar(255) NOT NULL DEFAULT '',
  `NEW_VALUE` varchar(255) NOT NULL DEFAULT '',
  `DETAILS` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2521 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `history`
--

LOCK TABLES `history` WRITE;
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
/*!40000 ALTER TABLE `history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ignore_updates`
--

DROP TABLE IF EXISTS `ignore_updates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ignore_updates` (
  `ID` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ignore_updates`
--

LOCK TABLES `ignore_updates` WRITE;
/*!40000 ALTER TABLE `ignore_updates` DISABLE KEYS */;
/*!40000 ALTER TABLE `ignore_updates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `jobs`
--

DROP TABLE IF EXISTS `jobs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `jobs` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `COMMANDS` text NOT NULL,
  `RUNTIME` datetime DEFAULT NULL,
  `EXPIRE` datetime DEFAULT NULL,
  `PROCESSED` int(3) NOT NULL DEFAULT '0',
  `STARTED` datetime DEFAULT NULL,
  `EXPIRED` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4575391 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `jobs`
--

LOCK TABLES `jobs` WRITE;
/*!40000 ALTER TABLE `jobs` DISABLE KEYS */;
INSERT INTO `jobs` VALUES (4575390,'restartWebSocket','sg(\"cycle_websocketsRun\",\"\");sg(\"cycle_websocketsControl\",\"restart\");','2020-01-28 20:20:31','2020-01-28 20:50:31',0,NULL,0);
/*!40000 ALTER TABLE `jobs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `layouts`
--

DROP TABLE IF EXISTS `layouts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `layouts` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `TYPE` varchar(255) NOT NULL DEFAULT '',
  `CODE` text,
  `APP` varchar(255) NOT NULL DEFAULT '',
  `URL` char(255) NOT NULL DEFAULT '',
  `DETAILS` text,
  `REFRESH` int(10) NOT NULL DEFAULT '0',
  `ICON` varchar(50) NOT NULL DEFAULT '',
  `HIDDEN` int(3) NOT NULL DEFAULT '0',
  `BACKGROUND_IMAGE` varchar(255) NOT NULL DEFAULT '',
  `THEME` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=20 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `layouts`
--

LOCK TABLES `layouts` WRITE;
/*!40000 ALTER TABLE `layouts` DISABLE KEYS */;
INSERT INTO `layouts` VALUES (6,'<#LANG_APP_PRODUCTS#>',70,'app','','app_products','','',0,'',0,'',''),(7,'<#LANG_MODULE_SCENES#>',550,'app','','scenes','','',0,'',0,'',''),(8,'<#LANG_WELCOME_GREETING#>',1000,'html','<p><a href=\"/popup/scenes/3.html\">Дроид меню</a></p>\r\n<p><a href=\"/popup/scenes/5.html\">Tablet Clock</a></p>\r\n<p><a href=\"/popup/scenes/9.html\">Главная</a></p>\r\n<p><a href=\"/popup/scenes/15.html\">Погода горизонтальная</a></p>\r\n<p><a href=\"/popup/scenes/13.html\">Погода</a></p>\r\n<p><a href=\"/dashui/\">dashui</a></p>','','','',0,'',0,'',''),(9,'<#LANG_APP_CALENDAR#>',100,'app','','app_calendar','','',0,'',0,'',''),(10,'<#LANG_APP_MEDIA_BROWSER#>',200,'app','','app_mediabrowser','','',0,'',0,'',''),(12,'GPS',0,'app','','app_gpstrack','','',0,'',0,'',''),(13,'Panel',0,'dashboard',NULL,'','',NULL,0,'',1,'',''),(16,'Показания',0,'html','<body onload=\"init()\">\r\n<table width=\"100%\" border=\"0\">\r\n<tr> \r\n<td width=\"20%\" >\r\nЧасы \r\n</td>\r\n<td width=\"20%\" >\r\nТемпература Дом\r\n</td>\r\n<td width=\"60%\" >\r\nТемпература Улица\r\n</td> \r\n</tr>\r\n <tr> \r\n<td width=\"20%\" >\r\n<canvas id=\"canvasClock1\" width=\"201\" height=\"201\"></canvas> \r\n</td>\r\n<td width=\"20%\" >\r\n<canvas id=\"canvasTin\" width=\"201\" height=\"201\"></canvas>\r\n</td>\r\n<td width=\"60%\" >\r\n<canvas id=\"canvasTout\" width=\"201\" height=\"201\"></canvas>\r\n</td> \r\n</tr>\r\n<tr> \r\n<td width=\"20%\" >\r\nВетер, направление \r\n</td>\r\n<td width=\"20%\" >\r\nВетер, скорость\r\n</td>\r\n<td width=\"60%\" >\r\nДавление\r\n</td> \r\n</tr>\r\n\r\n <tr> \r\n<td width=\"20%\" >\r\n<canvas id=\"canvasWindDir1\" width=\"201\" height=\"201\"></canvas>\r\n</td>\r\n<td width=\"20%\" >\r\n<canvas id=\"canvasWindSpeed\" width=\"201\" height=\"201\"></canvas>\r\n</td>\r\n<td width=\"60%\" >\r\n<canvas id=\"canvasRadialPress\" width=\"201\" height=\"201\"></canvas>\r\n</td> \r\n</tr> \r\n</table>\r\n \r\n\r\n \r\n<script>\r\n    var scroll = false;\r\n    var RadialTin;\r\n    var RadialTout;\r\n    var windDir1;\r\n    var windSpeed;\r\n    var RadialPress;\r\n    var odometer1, n = 999997.7;\r\n    function init() {\r\n        // Initialzing gauge\r\n         // Define some sections\r\n        var sections = [steelseries.Section(-15, 15, \'rgba(0, 0, 220, 0.3)\'),\r\n                        steelseries.Section(15, 25, \'rgba(0, 220, 0, 0.3)\'),\r\n                        steelseries.Section(-30, -15, \'rgba(220, 220, 0, 0.3)\'),\r\n                        steelseries.Section(25, 30, \'rgba(220, 220, 0, 0.3)\') ],\r\n\r\n            // Define one area\r\n            areas = [steelseries.Section(30, 40, \'rgba(220, 0, 0, 0.3)\'),\r\n                     steelseries.Section(-40, -30, \'rgba(220, 0, 0, 0.3)\'),],\r\n\r\n            sect_pr  = [steelseries.Section(745, 755, \'rgba(0, 220, 0, 0.3)\'),\r\n                        steelseries.Section(735, 745, \'rgba(220, 220, 0, 0.3)\'),\r\n                        steelseries.Section(755, 775, \'rgba(220, 220, 0, 0.3)\') ],\r\n\r\n            areas_pr = [steelseries.Section(700, 735, \'rgba(220, 0, 0, 0.3)\'),\r\n                        steelseries.Section(775, 800, \'rgba(220, 0, 0, 0.3)\'),],\r\n\r\n         clock1 = new steelseries.Clock(\'canvasClock1\', {\r\n                            width: 201,\r\n                            height: 201\r\n                            });\r\n\r\n        windDir1 = new steelseries.WindDirection(\'canvasWindDir1\', {\r\n                            size: 201,\r\n                            trendVisible: true,\r\n                            lcdVisible: true\r\n                            });\r\n        RadialTin = new steelseries.Radial(\'canvasTin\', {\r\n                            gaugeType: steelseries.GaugeType.TYPE4,\r\n                            size: 201,\r\n                            section: sections,\r\n                            area: areas,\r\n                            minValue:-30,\r\n                            maxValue:30,\r\n                            titleString: \"Температура\",\r\n                            unitString: \"Градусы\",\r\n                            threshold: 25,\r\n                            lcdVisible: true\r\n                        });\r\n        RadialTout = new steelseries.Radial(\'canvasTout\', {\r\n                            gaugeType: steelseries.GaugeType.TYPE4,\r\n                            size: 201,\r\n                            section: sections,\r\n                            area: areas,\r\n                            minValue:-40,\r\n                            maxValue:40,\r\n                            titleString: \"Температура\",\r\n                            unitString: \"Градусы\",\r\n                            threshold: 25,\r\n                            lcdVisible: true\r\n                        });\r\n        windSpeed = new steelseries.Radial(\'canvasWindSpeed\', {\r\n                            gaugeType: steelseries.GaugeType.TYPE2,\r\n                            size: 201,\r\n                            //section: sections,\r\n                            //area: areas,\r\n                            minValue: 0,\r\n                            maxValue: 20,\r\n                            titleString: \"Скорость ветра\",\r\n                            unitString: \"м/с\",\r\n                            threshold: 5,\r\n                            lcdVisible: true\r\n                        });\r\n        RadialPress = new steelseries.Radial(\'canvasRadialPress\', {\r\n                            gaugeType: steelseries.GaugeType.TYPE4,\r\n                            size: 201,\r\n                            section: sect_pr,\r\n                            area: areas_pr,\r\n                            minValue:700,\r\n                            maxValue:800,\r\n                            titleString: \"Атм давление\",\r\n                            unitString: \"мм рт ст\",\r\n                            threshold: 765,\r\n                            lcdVisible: true\r\n                        });\r\n       clock1.setBackgroundColor(steelseries.BackgroundColor.WHITE);\r\n       windDir1.setBackgroundColor(steelseries.BackgroundColor.WHITE);\r\n       RadialTout.setBackgroundColor(steelseries.BackgroundColor.WHITE);\r\n       RadialTin.setBackgroundColor(steelseries.BackgroundColor.WHITE);\r\n       windSpeed.setBackgroundColor(steelseries.BackgroundColor.WHITE);\r\n       RadialPress.setBackgroundColor(steelseries.BackgroundColor.WHITE);\r\n\r\n        // Start the update\r\n        setInterval(function(){ setDirValue(windDir1); }, 3000);\r\n        setInterval(function(){ live_upd(\"/pChart/?op=value&p=ow_fact.temperature\", RadialTout); },6000);\r\n        setInterval(function(){ live_upd(\"/pChart/?op=value&p=ws.tempInside\", RadialTin); },7000);\r\n        setInterval(function(){ live_upd(\"/pChart/?op=value&p=ow_fact.wind_speed\", windSpeed);}, 1500);\r\n        setInterval(function(){ live_upd(\"/pChart/?op=value&p=ow_fact.pressure_mmhg\", RadialPress); },12000);\r\n\r\n}\r\n    function setDirValue(gauge) {\r\n             var url=\"/pChart/?op=value&p=ow_fact.wind_direction\";\r\n             $.ajax({\r\n             url: url,\r\n             }).done(function(data) { \r\n              if (data!=\'\') {gauge.setValueAnimatedLatest(parseFloat(data));}\r\n             }); \r\n             url=\"/pChart/?op=value&p=ws.windavgBearing\";\r\n              $.ajax({\r\n             url: url,\r\n             }).done(function(data) { \r\n              if (data!=\'\') {gauge.setValueAnimatedAverage(parseFloat(data));}\r\n             });\r\n    }\r\n    function live_upd(url,gauge) {\r\n             $.ajax({\r\n             url: url,\r\n             }).done(function(data) { \r\n              if (data!=\'\') {gauge.setValueAnimated(parseFloat(data));}\r\n             });\r\n     }\r\n\r\n\r\n\r\n</script>\r\n\r\n \r\n<script src=\"../SteelSeries/tween-min.js\"></script>\r\n<script src=\"../SteelSeries/steelseries-min.js\"></script>\r\n </body>\r\n','','',NULL,0,'',0,'',''),(17,'gauge',0,'html','<script async src=\"/js/gauge.min.js\"></script>\r\n\r\n<canvas data-type=\"linear-gauge\"\r\n        data-width=\"100\"\r\n        data-height=\"400\"\r\n        data-border-radius=\"20\"\r\n        data-borders=\"0\"\r\n        data-bar-stroke-width=\"20\"\r\n        data-minor-ticks=\"10\"\r\n        data-major-ticks=\"0,10,20,30,40,50,60,70,80,90,100\"\r\n        data-value=\"22.3\"\r\n        data-units=\"°C\"\r\n        data-color-value-box-shadow=\"false\"\r\n></canvas>\r\n\r\n<canvas data-type=\"radial-gauge\"\r\n        data-width=\"200\"\r\n        data-height=\"200\"\r\n        data-units=\"Km/h\"\r\n        data-title=\"false\"\r\n        data-value=\"0\"\r\n        data-min-value=\"0\"\r\n        data-max-value=\"220\"\r\n        data-major-ticks=\"0,20,40,60,80,100,120,140,160,180,200,220\"\r\n        data-minor-ticks=\"2\"\r\n        data-stroke-ticks=\"false\"\r\n        data-highlights=\'[\r\n            { \"from\": 0, \"to\": 50, \"color\": \"rgba(0,255,0,.15)\" },\r\n            { \"from\": 50, \"to\": 100, \"color\": \"rgba(255,255,0,.15)\" },\r\n            { \"from\": 100, \"to\": 150, \"color\": \"rgba(255,30,0,.25)\" },\r\n            { \"from\": 150, \"to\": 200, \"color\": \"rgba(255,0,225,.25)\" },\r\n            { \"from\": 200, \"to\": 220, \"color\": \"rgba(0,0,255,.25)\" }\r\n        ]\'\r\n        data-color-plate=\"#222\"\r\n        data-color-major-ticks=\"#f5f5f5\"\r\n        data-color-minor-ticks=\"#ddd\"\r\n        data-color-title=\"#fff\"\r\n        data-color-units=\"#ccc\"\r\n        data-color-numbers=\"#eee\"\r\n        data-color-needle-start=\"rgba(240, 128, 128, 1)\"\r\n        data-color-needle-end=\"rgba(255, 160, 122, .9)\"\r\n        data-value-box=\"true\"\r\n        data-animation-rule=\"bounce\"\r\n        data-animation-duration=\"500\"\r\n        data-font-value=\"Led\"\r\n        data-animated-value=\"true\"\r\n></canvas>\r\n','','',NULL,0,'',0,'',''),(19,'ToDo',0,'app','','','',NULL,0,'',0,'','');
/*!40000 ALTER TABLE `layouts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `locations`
--

DROP TABLE IF EXISTS `locations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `locations` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `locations`
--

LOCK TABLES `locations` WRITE;
/*!40000 ALTER TABLE `locations` DISABLE KEYS */;
INSERT INTO `locations` VALUES (1,'Kitchen',0),(4,'Livingroom',0),(6,'Hall',0),(7,'Bathroom',0),(8,'Toilet',0),(10,'Child\'s bedroom',0);
/*!40000 ALTER TABLE `locations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `log4php_log`
--

DROP TABLE IF EXISTS `log4php_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `log4php_log` (
  `timestamp` datetime DEFAULT NULL,
  `logger` varchar(256) DEFAULT NULL,
  `level` varchar(32) DEFAULT NULL,
  `message` varchar(4000) DEFAULT NULL,
  `thread` int(11) DEFAULT NULL,
  `file` varchar(255) DEFAULT NULL,
  `line` varchar(10) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `log4php_log`
--

LOCK TABLES `log4php_log` WRITE;
/*!40000 ALTER TABLE `log4php_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `log4php_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `media_favorites`
--

DROP TABLE IF EXISTS `media_favorites`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `media_favorites` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PATH` varchar(255) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LIST_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `COLLECTION_ID` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `media_favorites`
--

LOCK TABLES `media_favorites` WRITE;
/*!40000 ALTER TABLE `media_favorites` DISABLE KEYS */;
INSERT INTO `media_favorites` VALUES (2,'./music/Beyonce - Beyonce (2013)/','music/Beyonce - Beyonce (2013)',0,9);
/*!40000 ALTER TABLE `media_favorites` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `media_history`
--

DROP TABLE IF EXISTS `media_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `media_history` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PATH` varchar(255) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LIST_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `COLLECTION_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `PLAYED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `media_history`
--

LOCK TABLES `media_history` WRITE;
/*!40000 ALTER TABLE `media_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `media_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `methods`
--

DROP TABLE IF EXISTS `methods`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `methods` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `OBJECT_ID` int(10) NOT NULL DEFAULT '0',
  `CLASS_ID` int(10) NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `DESCRIPTION` text,
  `CODE` text,
  `CALL_PARENT` int(3) NOT NULL DEFAULT '0',
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `EXECUTED` datetime DEFAULT NULL,
  `EXECUTED_PARAMS` varchar(255) DEFAULT NULL,
  `EXECUTED_SRC` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`),
  KEY `OBJECT_ID` (`OBJECT_ID`),
  KEY `CLASS_ID` (`CLASS_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=209 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `methods`
--

LOCK TABLES `methods` WRITE;
/*!40000 ALTER TABLE `methods` DISABLE KEYS */;
INSERT INTO `methods` VALUES (1,0,1,'KeyPressed','событие, возникающее при нажатии на кнопку','$this->setProperty(\"lastTimePressed\",time());',0,0,NULL,NULL,NULL),(23,0,11,'say','','echo \"notify: \".utf2win($params[\'say\']).\"<br>\";\r\n$say=utf2win($params[\'say\']);\r\n$say=str_replace(\' \',\'..\',$say);\r\necho (\'\"c:\\\\program files\\\\Growl for windows\\\\growlnotify.com\" /t:Alice \'.$say.\'\');\r\nexec(\'\"c:\\\\program files\\\\Growl for windows\\\\growlnotify.com\" /t:Alice \'.$say.\'\');',0,0,NULL,NULL,NULL),(14,0,7,'onNewMinute','','',0,0,'2020-01-28 20:15:00','{\"no_session\":\"1\",\"ORIGINAL_OBJECT_TITLE\":\"ClockChime\"}','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(15,0,7,'onNewHour','','//START openweather module\n                  $updateTime = gg(\'ow_setting.updateTime\');\n                  if($updateTime > 0)\n                  {\n                     $count = gg(\'ow_setting.countTime\');\n                     if($count >= $updateTime)\n                     {\n                        include_once(DIR_MODULES . \'app_openweather/app_openweather.class.php\');\n                        $app_openweather = new app_openweather();\n                        $app_openweather->get_weather(gg(\'ow_city.id\'));\n                        sg(\'ow_setting.countTime\', 1);\n                     }\n                     else\n                     {\n                        $count++;\n                        sg(\'ow_setting.countTime\', $count);\n                     }\n                  }\n               // END openweather module',0,0,'2020-01-28 20:00:00','{\"no_session\":\"1\",\"ORIGINAL_OBJECT_TITLE\":\"ClockChime\"}','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(16,0,9,'Connected','','',0,0,NULL,NULL,NULL),(55,0,18,'Lost','','',0,0,NULL,NULL,NULL),(18,6,0,'onNewMinute','','//получение времени\r\n$h=(int)date(\'G\',time());\r\n$m=date(\'i\',time());\r\n$d=date(\'d.m.Y\');\r\n//часы с нулем впереди\r\nif($h<10)\r\n{$h1=\"0\".$h;} \r\nelse \r\n{$h1=$h;}; \r\n//---------------\r\nif (isWeekDay()) {\r\n\r\n}\r\n//каждую минуту\r\n setGlobal(\"ThisComputer.timeH\",$h);\r\n setGlobal(\"ThisComputer.timeM\",$m);\r\n\r\n\r\nif (($h>=8) && getGlobal(\'clockChimeEnabled\')) {\r\n if ($m==\"00\") {\r\n//   say(timeNow(),1);\r\n }\r\n}\r\n// в час ночи\r\nif (($h=1) ) {\r\n if ($m==\"00\") {\r\n   runScript(\"voshod\");\r\n }\r\n}\r\n\r\n\r\n\r\n\r\nsetGlobal(\'timeNow\',date(\'H:i\'));\r\nrunScript(\"Econom\");\r\n',1,0,'2020-01-28 20:15:00','{\"no_session\":\"1\"}','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(19,4,0,'Connected','','if ($params[\'serial\']==\'\' && $params[\'devname\']!=\'\') {\r\n $params[\'serial\']=$params[\'devname\'];\r\n}\r\n\r\n$device=SQLSelectOne(\"SELECT * FROM usbdevices WHERE SERIAL LIKE \'\".$params[\'serial\'].\"\'\");\r\nif (!$device[\'ID\']) {\r\n // new device connected\r\n //say(\"Подключено новое устройство\",1);\r\n $device=array();\r\n $device[\'SERIAL\']=$params[\'serial\'];\r\n $device[\'TITLE\']=\'устройство \'.$params[\'devname\'];\r\n $device[\'FIRST_FOUND\']=date(\'Y-m-d H:i:s\');\r\n $device[\'LAST_FOUND\']=date(\'Y-m-d H:i:s\');\r\n $device[\'LOG\'].=$device[\'FIRST_FOUND\'].\' подключено (впервые)\'.\"\\n\";\r\n $device[\'ID\']=SQLInsert(\'usbdevices\',$device);\r\n} else {\r\n // device already in our database\r\n //say(\"Подключено \".$device[\'TITLE\'],1);\r\n if ($device[\'USER_ID\']) {\r\n  $user=SQLSelectOne(\"SELECT * FROM users WHERE ID=\'\".$device[\'USER_ID\'].\"\'\");\r\n  if ($user[\'ID\']) {\r\n    //$user[\'NAME\']; // теперь мы знаем имя пользователя, связанного с этим устройством\r\n  }\r\n }\r\n $device[\'LAST_FOUND\']=date(\'Y-m-d H:i:s\');\r\n $device[\'LOG\']=$device[\'LAST_FOUND\'].\' подключено\'.\"\\n\".$device[\'LOG\'];\r\n SQLUpdate(\'usbdevices\',$device);\r\n if ($device[\'SCRIPT_ID\']!=\'\') {\r\n  runScript($device[\'SCRIPT_ID\'],$params);\r\n } elseif ($device[\'SCRIPT\']!=\'\') {\r\n  eval($device[\'SCRIPT\']);\r\n }\r\n}',1,0,NULL,NULL,NULL),(141,0,10,'powerConnected','','',0,0,'0000-00-00 00:00:00','',NULL),(142,0,10,'powerDisconnected','','',0,0,'0000-00-00 00:00:00','',NULL),(143,0,10,'VolumeLevelChanged','','$volume=round(65535*$params[\'VALUE\']/100);\r\n$this->setProperty(\'volumeLevel\',$params[\'VALUE\']);\r\nsafe_exec(\'..\\\\apps\\\\nircmd\\\\nircmdc setsysvolume \'.$volume);\r\nsay(\"Изменилась громкость до \".$params[\'VALUE\'].\" процентов\");',0,0,'2014-07-31 21:15:03','a:3:{s:5:\"VALUE\";s:2:\"90\";s:4:\"HOST\";s:9:\"localhost\";s:21:\"ORIGINAL_OBJECT_TITLE\";s:12:\"ThisComputer\";}',NULL),(31,0,12,'onNewMessage','','',0,0,NULL,NULL,NULL),(32,0,12,'onStatusChange','','',0,0,NULL,NULL,NULL),(33,10,0,'onStatusChange',NULL,'echo \"status received: \".$params[\'status\'];',1,0,NULL,NULL,NULL),(34,10,0,'onNewMessage','',' global $voicemode;\r\n $voicemode=\'off\';\r\n processCommand($params[\'message\']);',1,0,NULL,NULL,NULL),(54,0,18,'Found','','',0,0,NULL,NULL,NULL),(56,13,0,'Found','','// new device\r\n\r\n$tm=registeredEventTime(\'btcall\'); \r\nif ((time()-$tm)>60 || $tm<0) {\r\n registerEvent(\'btcall\'); \r\n}\r\n\r\n\r\nif ($params[\'new\']) {\r\n //say(\'Обнаружено новое блютуз устройство\');\r\n}\r\nif ($params[\'user\']!=\'\') {\r\n //say($params[\'user\'].\' где-то рядом\');\r\n}',1,0,NULL,NULL,NULL),(57,13,0,'Lost','','// device lost\r\n',1,1,NULL,NULL,NULL),(59,0,21,'checkState','',' ',0,0,'2020-01-28 20:15:25','{\"ORIGINAL_OBJECT_TITLE\":\"Communication\"}',''),(60,0,21,'stateChanged','','',0,0,'2020-01-27 16:29:05','{\"STATE\":\"green\",\"ORIGINAL_OBJECT_TITLE\":\"Communication\"}',NULL),(61,0,22,'statusChanged','','if ($params[\'status\']) {\r\n $this->setProperty(\'status\',$params[\'status\']);\r\n}\r\n$this->setProperty(\'updatedTimestamp\',time());\r\n\r\n$this->setProperty(\"alive\",1);\r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=12*60*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout);',0,0,'0000-00-00 00:00:00','',NULL),(62,0,23,'statusChanged','','$this->setProperty(\'status\',$params[\'status\']); // выставляем статус сенсора\r\n$this->setProperty(\'updatedTimestamp\',time()); // выставляем время срабатывания сенсора\r\n\r\n$this->setProperty(\'alive\',1);\r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=24*60*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout);\r\n\r\nif ($params[\'status\']) {\r\n \r\n $this->setProperty(\'motionDetected\',1);\r\n clearTimeOut($this->object_title.\'_detected\'); \r\n setTimeOut($this->object_title.\'_detected\',\"setGlobal(\'\".$this->object_title.\".motionDetected\',0);\",30);\r\n\r\n $linked_room=$this->getProperty(\'LinkedRoom\');\r\n if ($linked_room!=\'\') {\r\n  callMethod($linked_room.\'.onActivity\');\r\n }\r\n\r\n if ($this->object_title==\'sensorMovement3\' || $this->object_title==\'sensorMovementRemote1\' || $this->object_title==\'sensorMovementRemote2\') {\r\n  //|| $this->object_title==\'sensorMovement5\'\r\n  return; // не реагируем на движение в спальне, по ip-сенсорам и по сенсору на втром этаже\r\n }\r\n\r\n ClearTimeOut(\"nobodyHome\"); \r\n SetTimeOut(\"nobodyHome\",\"callMethod(\'NobodyHomeMode.activate\');\", 1*60*60); // выполняем если целый час никого не было\r\n\r\n if (getGlobal(\'NobodyHomeMode.active\')) {\r\n  callMethod(\'NobodyHomeMode.deactivate\');\r\n }\r\n\r\n $last_register=registeredEventTime(\'inhouseMovement\'); // проверяем когда в последний раз срабатывало событие \"движение внутри дома\"\r\n  registerEvent(\'inhouseMovement\',$this->name,2); // регистрируем событие \"движение внутри дома\" \r\n  if (timeBetween(\'05:00\', \'12:00\') && ((time()-$last_register)>2*60*60)) {\r\n   runScript(\'Greeting\'); // запускаем скрипт \"доброе утро\"\r\n  }\r\n}',0,0,'2014-09-05 13:00:59','a:5:{s:2:\"op\";s:1:\"m\";s:6:\"object\";s:13:\"MotionSensor4\";s:1:\"m\";s:13:\"statusChanged\";s:6:\"status\";s:1:\"1\";s:21:\"ORIGINAL_OBJECT_TITLE\";s:13:\"MotionSensor4\";}',NULL),(63,0,24,'modeChanged','','$this->setProperty(\"updated\",time());\r\n$this->setProperty(\"updatedTime\",date(\'H:i\'));\r\nif ($this->getProperty(\'active\')) {\r\n say(\"Режим \".$this->getProperty(\'title\').\" активирован.\");\r\n} else {\r\n say(\"Режим \".$this->getProperty(\'title\').\" выключен.\");\r\n}',0,0,'2017-12-03 14:47:01','{\"object\":\"DarknessMode\",\"op\":\"m\",\"m\":\"modeChanged\",\"PROPERTY\":\"active\",\"NEW_VALUE\":\"1\",\"OLD_VALUE\":\"0\",\"SOURCE\":\"\",\"ORIGINAL_OBJECT_TITLE\":\"DarknessMode\"}',NULL),(64,0,24,'activate','','$this->setProperty(\'active\',1);',0,0,'2017-12-03 14:47:01','{\"ORIGINAL_OBJECT_TITLE\":\"DarknessMode\"}',NULL),(65,0,24,'deactivate','','$this->setProperty(\'active\',0);',0,0,'2017-11-13 08:00:00','{\"ORIGINAL_OBJECT_TITLE\":\"NightMode\"}',NULL),(66,0,25,'onActivity','Rooms Activity','$latestActivity=$this->getProperty(\'LatestActivity\');\r\n$this->setProperty(\'LatestActivity\',time());\r\n$this->setProperty(\'LatestActivityTime\',date(\'H:i\'));\r\n\r\n$this->setProperty(\'SomebodyHere\',1);\r\n$ot=$this->object_title;\r\nif ($this->getProperty(\"IdleDelay\")) {\r\n $activity_timeout=(int)$this->getProperty(\"IdleDelay\");\r\n} else {\r\n $activity_timeout=10*60;\r\n}\r\nclearTimeOut($ot.\"_activity_timeout\");\r\nsetTimeOut($ot.\"_activity_timeout\",\"callMethod(\'\".$ot.\".onIdle\');\",$activity_timeout);\r\n$this->callMethod(\"updateActivityStatus\");\r\n\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/Rooms_onActivity.php\');\n/* end injection of {SDevices} */',0,0,'2014-09-05 13:01:00','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:10:\"Kinderroom\";}',NULL),(67,0,25,'onIdle','Rooms Idle','$this->setProperty(\'SomebodyHere\',0);\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/Rooms_onIdle.php\');\n/* end injection of {SDevices} */',0,0,'2014-09-05 12:24:46','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:10:\"Kinderroom\";}',NULL),(68,0,26,'refresh','','$status=$this->getProperty(\"status\");\r\nif ($status) {\r\n $this->callMethod(\'turnOn\');\r\n} else {\r\n $this->callMethod(\'turnOff\');\r\n}',0,0,'2020-01-28 00:13:57','{\"VALUE\":\"1\",\"OLD_VALUE\":\"0\",\"ORIGINAL_OBJECT_TITLE\":\"Switch2\"}','/ajax/commands.html?op=value_changed&item_id=118&new_value=1'),(69,0,26,'switch','','$status=$this->getProperty(\"status\");\r\nif ($status) {\r\n $this->callMethod(\'turnOff\');\r\n} else {\r\n $this->callMethod(\'turnOn\');\r\n}',0,0,'2020-01-28 20:11:16','{\"ORIGINAL_OBJECT_TITLE\":\"Switch2\"}','/ajax/plans.html?op=click&id=1'),(70,0,26,'turnOff','','$this->setProperty(\"status\",0);\r\nrunScript(\"scene_switch\",array(\"nameobj\"=>$this->object_title));\r\n',0,0,'2020-01-28 20:11:16','{\"ORIGINAL_OBJECT_TITLE\":\"Switch2\"}','/ajax/plans.html?op=click&id=1'),(71,0,26,'turnOn','','$this->setProperty(\"status\",1);\r\nrunScript(\"scene_switch\",array(\"nameobj\"=>$this->object_title));\r\n',0,0,'2020-01-28 20:11:14','{\"ORIGINAL_OBJECT_TITLE\":\"Switch2\"}','/ajax/plans.html?op=click&id=1'),(72,0,19,'tempChanged','','//$params[\'t\']\r\n $this->setProperty(\"updated\",time());\r\n $this->setProperty(\"updatedTime\",date(\"H:i\",time()));\r\n $this->setProperty(\"alive\",1); \r\n \r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=30*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout); \r\n\r\nif (!isset($params[\'t\'])) {\r\n return;\r\n}\r\n\r\n\r\n$old_temp=$this->getProperty(\'temp\');\r\n$t=round($params[\'t\'],1);\r\n\r\nif ($t>110) return;\r\n\r\n$this->setProperty(\'temp\',$t);\r\nif ($params[\'uptime\']) {\r\n $this->setProperty(\'uptime\',$params[\'uptime\']);\r\n}\r\n\r\nif ($t>$old_temp) {\r\n $d=1;\r\n} elseif ($t<$old_temp) {\r\n $d=-1;\r\n} else {\r\n $d=0;\r\n}\r\n$this->setProperty(\'direction\',$d);\r\n\r\n$linked_room=$this->getProperty(\"LinkedRoom\");\r\nif ($linked_room) {\r\n setGlobal($linked_room.\'.Temperature\',$t);\r\n}',0,0,'2014-09-05 12:54:30','a:2:{s:1:\"t\";d:22.5;s:21:\"ORIGINAL_OBJECT_TITLE\";s:12:\"TempSensor03\";}',NULL),(73,17,0,'checkState','','$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\n$cycles=array(\'states\'=>\'states\',\'main\'=>\'main\',\'execs\'=>\'exec\',\'scheduler\'=>\'scheduler\');\r\nforeach($cycles as $k=>$v) {\r\n $tm=getGlobal(\'ThisComputer.cycle_\'.$k.\'Run\');\r\n if (time()-$tm>5*60) {\r\n  $red_state=1;\r\n  $details[]=$v.\" \".LANG_GENERAL_CYCLE.\" \".LANG_GENERAL_STOPPED.\".\";\r\n }\r\n}\r\n\r\n$cycles=array(\'ping\'=>\'ping\',\'webvars\'=>\'webvars\');\r\nforeach($cycles as $k=>$v) {\r\n $tm=getGlobal(\'ThisComputer.cycle_\'.$k.\'Run\');\r\n if (time()-$tm>10*60) {\r\n  $yellow_state=1;\r\n  $details[]=$v.\" \".LANG_GENERAL_CYCLE.\" \".LANG_GENERAL_STOPPED.\".\";  \r\n }\r\n}\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  //say(LANG_GENERAL_SYSTEM_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  //say(implode(\". \",$details));\r\n } else {\r\n // say(LANG_GENERAL_SYSTEM_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}\r\n/* begin injection of {SDevices} */\r\nrequire(DIR_MODULES.\'devices/system_checkstate.php\');\r\n/* end injection of {SDevices} */',1,0,'2020-01-28 20:15:25','',''),(74,18,0,'checkState','','$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\nif (!isOnline(\'Internet\')) {\r\n $yellow_state=1;\r\n $details[]=LANG_GENERAL_NO_INTERNET_ACCESS;\r\n}\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(LANG_GENERAL_COMMUNICATION_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(LANG_GENERAL_COMMUNICATION_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}',1,0,'2020-01-28 20:15:25','',''),(75,16,0,'checkState','','$details=array();\r\n$red_state=0;\r\n$yellow_state=0;\r\n\r\nif ($red_state) {\r\n $state=\'red\';\r\n $state_title=LANG_GENERAL_RED; \r\n} elseif ($yellow_state) {\r\n $state=\'yellow\';\r\n $state_title=LANG_GENERAL_YELLOW;  \r\n} else {\r\n $state=\'green\';\r\n $state_title=LANG_GENERAL_GREEN;   \r\n}\r\n\r\n$new_details=implode(\". \",$details);\r\nif ($this->getProperty(\"stateDetails\")!=$new_details) {\r\n $this->setProperty(\'stateDetails\',$new_details);\r\n}\r\n\r\nif ($this->getProperty(\'stateColor\')!=$state) {\r\n $this->setProperty(\'stateColor\',$state);\r\n $this->setProperty(\'stateTitle\',$state_title);\r\n if ($state!=\'green\') {\r\n  say(LANG_GENERAL_SECURITY_STATE.\" \".LANG_GENERAL_CHANGED_TO.\" \".$state_title.\".\");\r\n  say(implode(\". \",$details));\r\n } else {\r\n  say(LANG_GENERAL_SECURITY_STATE.\" \".LANG_GENERAL_RESTORED_TO.\" \".$state_title);\r\n }\r\n $this->callMethod(\'stateChanged\');\r\n}',1,0,'2020-01-28 20:15:25','',''),(137,0,10,'WakedUp','','',0,0,'0000-00-00 00:00:00','',NULL),(138,0,10,'onIdle','','',0,0,'0000-00-00 00:00:00','',NULL),(139,0,10,'StartUp','','',0,0,'2020-01-28 00:48:59','{\"ORIGINAL_OBJECT_TITLE\":\"ThisComputer\"}',''),(140,0,10,'commandReceived','получение новой команды','',0,0,'2018-09-25 10:46:28','{\"command\":\"fhhg\",\"ORIGINAL_OBJECT_TITLE\":\"ThisComputer\"}',NULL),(86,0,29,'turnOn','','$code1=$this->getProperty(\'Code1\');\r\n$code2=$this->getProperty(\'Code2\');\r\nsafe_exec(\"c:\\_majordomo\\apps\\arduino_gw\\arduino_gw.exe rcon$code1:$code2;\");\r\n$this->setProperty(\"status\",1);',0,0,'2014-08-27 23:28:35','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:7:\"OutletB\";}',NULL),(81,47,0,'activate','','setGlobal(\'minMsgLevel\',\'2\');\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/nightmode_activate.php\');\n/* end injection of {SDevices} */',1,0,'2017-11-12 20:00:00','',NULL),(82,47,0,'deactivate','','setGlobal(\'minMsgLevel\',\'1\');\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/nightmode_deactivate.php\');\n/* end injection of {SDevices} */',1,0,'2017-11-13 08:00:00','',NULL),(85,0,29,'turnOff','','$code1=$this->getProperty(\'Code1\');\r\n$code2=$this->getProperty(\'Code2\');\r\nsafe_exec(\"c:\\_majordomo\\apps\\arduino_gw\\arduino_gw.exe rcoff$code1:$code2;\");\r\n$this->setProperty(\"status\",0);',0,0,'2014-08-27 23:28:01','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:7:\"OutletB\";}',NULL),(88,0,25,'updateActivityStatus','Update activity status','$rooms=getObjectsByClass(\"Rooms\");\r\n$total=count($rooms);\r\nfor($i=0;$i<$total;$i++) {\r\n $rooms[$i][\'room\']=getGlobal($rooms[$i][\'TITLE\'].\'.Title\');\r\n if (!$rooms[$i][\'room\']) {\r\n  $rooms[$i][\'room\']=$rooms[$i][\'TITLE\'];\r\n } \r\n $rooms[$i][\'active\']=getGlobal($rooms[$i][\'TITLE\'].\'.SomebodyHere\');\r\n $rooms[$i][\'time\']=getGlobal($rooms[$i][\'TITLE\'].\'.LatestActivity\'); \r\n $rooms[$i][\'diff\']=time()-$rooms[$i][\'time\'];\r\n} \r\n\r\nfunction cmp($a, $b)\r\n{\r\n    if ($a[\'diff\'] == $b[\'diff\']) {\r\n        return 0;\r\n    }\r\n    return ($a[\'diff\'] < $b[\'diff\']) ? -1 : 1;\r\n}\r\nusort($rooms,\"cmp\");\r\n\r\nif (!$rooms[0][\'active\']) {\r\n $somebodyHomeText=\"Никого нет дома. Были в \".date(\'H:i\',$rooms[0][\'time\']).\" (\".$rooms[0][\'room\'].\")\";\r\n} else {\r\n $res_rooms=array();\r\n for($i=0;$i<$total;$i++) {\r\n  if ($rooms[$i][\'active\']) {\r\n   $res_rooms[]=$rooms[$i][\'room\'];\r\n  } \r\n }\r\n $somebodyHomeText=\"Кто-то дома: \".implode(\", \",$res_rooms); \r\n}\r\nsetGlobal(\'somebodyHomeText\',$somebodyHomeText);\r\n//echo \"Updated\";\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/Rooms_updateActivityStatus.php\');\n/* end injection of {SDevices} */',0,0,'2014-09-05 13:01:00','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:10:\"Kinderroom\";}',NULL),(87,0,30,'humChanged','','//$params[\'t\']\r\n $this->setProperty(\"updated\",time());\r\n $this->setProperty(\"updatedTime\",date(\"H:i\",time()));\r\n $this->setProperty(\"alive\",1); \r\n \r\n$ot=$this->object_title;\r\n$alive_timeout=(int)$this->getProperty(\"aliveTimeOut\");\r\nif (!$alive_timeout) {\r\n $alive_timeout=30*60;\r\n}\r\nclearTimeOut($ot.\"_alive\");\r\nsetTimeOut($ot.\"_alive\",\"sg(\'\".$ot.\".alive\',0);\",$alive_timeout); \r\n\r\nif (!isset($params[\'h\'])) {\r\n return;\r\n}\r\n\r\n\r\n$old_temp=$this->getProperty(\'humidity\');\r\n$t=round($params[\'h\'],1);\r\n\r\nif ($t>100) return;\r\n\r\n$this->setProperty(\'humidity\',$t);\r\nif ($params[\'uptime\']) {\r\n $this->setProperty(\'uptime\',$params[\'uptime\']);\r\n}\r\n\r\nif ($t>$old_temp) {\r\n $d=1;\r\n} elseif ($t<$old_temp) {\r\n $d=-1;\r\n} else {\r\n $d=0;\r\n}\r\n$this->setProperty(\'direction\',$d);\r\n\r\n$linked_room=$this->getProperty(\"LinkedRoom\");\r\nif ($linked_room) {\r\n setGlobal($linked_room.\'.Humidity\',$t);\r\n}',0,0,'2014-09-05 12:54:30','a:2:{s:1:\"h\";i:42;s:21:\"ORIGINAL_OBJECT_TITLE\";s:11:\"humSensor03\";}',NULL),(89,0,31,'sendCommand','','$cmdline=\'\"c:\\Program Files\\nooLite\\nooLite.exe\" -api \'.$params[\'command\'];\r\n$last_called=gg(\'NoolightCommandSend\');\r\n$min_delay=3;\r\n$now=time();\r\nif (($now-$last_called)>$min_delay) {\r\n //safe_exec($cmdline);\r\n $last_callled=$now; \r\n sg(\'NoolightCommandSend\',$last_called);\r\n DebMes(\"Noolite instant exec: \".$cmdline);\r\n system($cmdline);\r\n //exec($cmdline);\r\n} else {\r\n if ($last_callled<$now) {\r\n  $last_callled=$now;\r\n }\r\n $last_called+=$min_delay;\r\n sg(\'NoolightCommandSend\',$last_called);\r\n DebMes(\"Noolite scheduled job for \".date(\'H:i:s\',$last_called));\r\n AddScheduledJob(\"noolight\".md5($cmdline),\"safe_exec(\'\".$cmdline.\"\');\",$last_called);\r\n}\r\n\r\n',0,0,'2014-09-05 11:01:41','a:2:{s:7:\"command\";s:8:\"-off_ch2\";s:21:\"ORIGINAL_OBJECT_TITLE\";s:4:\"noo2\";}',NULL),(90,0,31,'turnOff','','$this->setProperty(\"status\",0);\r\n//safe_exec(\'\"c:\\Program Files\\nooLite\\noolite.exe\" -api -off_ch\'.$this->getProperty(\"channel\"));\r\n$this->callMethod(\"sendCommand\",array(\'command\'=>\'-off_ch\'.$this->getProperty(\"channel\")));',0,0,'2014-09-05 11:01:41','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:4:\"noo2\";}',NULL),(91,0,31,'turnOn','','$this->setProperty(\"status\",1);\r\n$this->callMethod(\"sendCommand\",array(\'command\'=>\'-on_ch\'.$this->getProperty(\"channel\")));',0,0,'2014-09-05 11:01:30','a:1:{s:21:\"ORIGINAL_OBJECT_TITLE\";s:4:\"noo2\";}',NULL),(92,0,32,'alarm','','',0,0,NULL,NULL,NULL),(93,0,32,'goingHome','','',0,0,NULL,NULL,NULL),(94,0,32,'gotHome','','',0,0,NULL,NULL,NULL),(95,0,32,'Moving','','',0,0,NULL,NULL,NULL),(96,0,32,'outOfHome','','',0,0,NULL,NULL,NULL),(103,0,34,'Run','Исполняемый метод','$this->setProperty(\'LastRun\',date(\'Y-m-d H:i:s\'));',0,0,NULL,NULL,NULL),(104,0,34,'Update','Обновление задачи','$name=\'Cron_\'.$this->object_title;\nSQLExec(\"DELETE FROM jobs WHERE title=\'\".$name.\"\'\");',0,0,'2016-12-17 11:17:55','a:4:{s:8:\"PROPERTY\";s:6:\"Enable\";s:9:\"NEW_VALUE\";s:1:\"1\";s:9:\"OLD_VALUE\";s:1:\"0\";s:21:\"ORIGINAL_OBJECT_TITLE\";s:3:\"vlc\";}',NULL),(106,76,0,'Control','','include_once(DIR_MODULES.\'app_radio/app_radio.class.php\');\n$app_radio=new app_radio();\n\nif(is_array($params))\n{\n	if(isset($params[\'sta\'])) $app_radio->change_station($params[\'sta\'],$app_radio);\n	if(isset($params[\'cmd\'])) $app_radio->control($params[\'cmd\']);\n	if(isset($params[\'vol\'])) $app_radio->set_volume($params[\'vol\'],$app_radio);\n}\nelse\n{\n	if($params==\'play\' || $params==\'stop\')  $app_radio->control($params);\n	else if(strpos($params, \"vol\")===0) $app_radio->set_volume((int)substr($params,3),$app_radio);\n	else if(strpos($params, \"sta:\")===0) $app_radio->change_station(substr($params,4),$app_radio);\n}\n/* begin injection of {app_radio} */\ninclude_once(DIR_MODULES.\'app_radio/app_radio.class.php\');\n$app_radio = new app_radio();\n\nif(is_array($params)) {\n    foreach($params as $key=>$value) {\n        switch((string)$key) {\n            case \'sta\': $app_radio->change_station($params[\'sta\'], $app_radio); break;\n            case \'cmd\': $app_radio->control($params[\'cmd\']); break;\n            case \'vol\': $app_radio->set_volume($params[\'vol\'], $app_radio); break;\n            default:\n                if($value == \'play\' || $value == \'stop\') $app_radio->control($value);\n                elseif(strpos($value, \'vol\') === 0) $app_radio->set_volume((int)substr($value, 3), $app_radio);\n                elseif(strpos($value, \'sta:\') === 0) $app_radio->change_station(substr($value, 4), $app_radio);\n        }\n    }\n}\n/* end injection of {app_radio} */',0,0,NULL,NULL,NULL),(107,0,36,'statusUpdated','Status updated event','require(DIR_MODULES.\'devices/SDevices_statusUpdated.php\');',0,0,'2018-03-19 00:20:30','{\"object\":\"Gateway1\",\"op\":\"m\",\"m\":\"statusUpdated\",\"PROPERTY\":\"status\",\"NEW_VALUE\":\"1\",\"OLD_VALUE\":\"1\",\"SOURCE\":\"\",\"ORIGINAL_OBJECT_TITLE\":\"Gateway1\"}',NULL),(108,0,36,'logicAction','Logic Action','require(DIR_MODULES.\'devices/SDevices_logicAction.php\');',0,0,NULL,NULL,NULL),(109,20,0,'activate',NULL,'\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/nobodyhomemode_activate.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(110,20,0,'deactivate',NULL,'\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/nobodyhomemode_deactivate.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(111,0,37,'turnOn','Включить','require(DIR_MODULES.\'devices/SControllers_turnOn.php\');',0,0,NULL,NULL,NULL),(112,0,37,'turnOff','Выключить','require(DIR_MODULES.\'devices/SControllers_turnOff.php\');',0,0,NULL,NULL,NULL),(113,0,37,'switch','Switch','require(DIR_MODULES.\'devices/SControllers_switch.php\');',0,0,NULL,NULL,NULL),(114,0,39,'levelUpdated','Level Updated','require(DIR_MODULES.\'devices/SDimmers_levelUpdated.php\');',0,0,NULL,NULL,NULL),(115,0,39,'turnOn','Включить','require(DIR_MODULES.\'devices/SDimmers_turnOn.php\');',0,0,NULL,NULL,NULL),(116,0,39,'turnOff','Выключить','require(DIR_MODULES.\'devices/SDimmers_turnOff.php\');',0,0,NULL,NULL,NULL),(117,0,40,'motionDetected','Motion Detected','require(DIR_MODULES.\'devices/SMotions_motionDetected.php\');',0,0,NULL,NULL,NULL),(118,0,41,'statusUpdated','Status updated event','require(DIR_MODULES.\'devices/SOpenClose_statusUpdated.php\');',0,0,NULL,NULL,NULL),(119,0,42,'pressed','Нажать','require(DIR_MODULES.\'devices/SButtons_pressed.php\');',0,0,NULL,NULL,NULL),(120,0,43,'valueUpdated','Value Updated','require(DIR_MODULES.\'devices/SSensors_valueUpdated.php\');',0,0,NULL,NULL,NULL),(121,6,0,'onNewHour',NULL,'$h=(int)date(\'G\',time());\r\n\r\nif (gg(\'ThisComputer.DateD\')!=date(\"d\", time())) {\r\n\r\n$day[0]=\"воскресенье\";\r\n$day[1]=\"понедельник\";\r\n$day[2]=\"вторник\";\r\n$day[3]=\"среда\";\r\n$day[4]=\"четверг\";\r\n$day[5]=\"пятница\";\r\n$day[6]=\"суббота\";\r\n\r\n$month[1]=\"января\";\r\n$monthAlt[1]=\"ЯНВАРЬ\";\r\n$monthShrt[1]=\"ЯНВ\";\r\n$month[2]=\"февраля\";\r\n$monthAlt[2]=\"ФЕВРАЛЬ\";\r\n$monthShrt[2]=\"ФЕВ\";\r\n$month[3]=\"марта\";\r\n$monthAlt[3]=\"МАРТ\";\r\n$monthShrt[3]=\"МАРТ\";\r\n$month[4]=\"апреля\";\r\n$monthAlt[4]=\"АПРЕЛЬ\";\r\n$monthShrt[4]=\"АПР\";\r\n$month[5]=\"мая\";\r\n$monthAlt[5]=\"МАЙ\";\r\n$monthShrt[5]=\"МАЙ\";\r\n$month[6]=\"июня\";\r\n$monthAlt[6]=\"ИЮНЬ\";\r\n$monthShrt[6]=\"ИЮНЬ\";\r\n$month[7]=\"июля\";\r\n$monthAlt[7]=\"ИЮЛЬ\";\r\n$monthShrt[7]=\"ИЮЛЬ\";\r\n$month[8]=\"августа\";\r\n$monthAlt[8]=\"АВГУСТ\";\r\n$monthShrt[8]=\"АВГ\";\r\n$month[9]=\"сентября\";\r\n$monthAlt[9]=\"СЕНТЯБРЬ\"; \r\n$monthShrt[9]=\"СЕН\"; \r\n$month[10]=\"октября\";\r\n$monthAlt[10]=\"ОКТЯБРЬ\";\r\n$monthShrt[10]=\"ОКТ\";\r\n$month[11]=\"ноября\";\r\n$monthAlt[11]=\"НОЯБРЬ\";\r\n$monthShrt[11]=\"НБР\";\r\n$month[12]=\"декабря\";\r\n$monthAlt[12]=\"ДЕКАБРЬ\";\r\n$monthShrt[12]=\"ДЕК\";\r\n\r\nsg(\"ThisComputer.DateD\",date( \"d\", time()));\r\nsg(\"ThisComputer.DateM\",date( \"m\", time()));\r\nsg(\"ThisComputer.DateY\",date( \"Y\", time()));\r\nsg(\"ThisComputer.Date\",date( \"d.m.Y\", time()));\r\nsg(\"ThisComputer.Day\",$day[date(\"w\")]);\r\nsg(\"ThisComputer.Month\",$month[date(\"n\")]);\r\nsg(\"ThisComputer.MonthAlt\",$monthAlt[date(\"n\")]);\r\nsg(\"ThisComputer.MonthShrt\",$monthShrt[date(\"n\")]);\r\n} \r\n\r\n$h=(int)date(\'G\',time());\r\n//часы с нулем впереди\r\nif($h<10)\r\n{$h1=\"0\".$h;} \r\nelse \r\n{$h1=$h;}; \r\nsg(\"ThisComputer.timeHH\",$h1);',1,0,'2020-01-28 20:00:00','{\"no_session\":\"1\"}','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(122,0,36,'setUpdatedText','Change updated text','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SDevices_setUpdatedText.php\');\n/* end injection of {SDevices} */',0,0,'2018-03-19 00:20:30','{\"ORIGINAL_OBJECT_TITLE\":\"Gateway1\"}',NULL),(123,19,0,'activate',NULL,'\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/econommode_activate.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(124,19,0,'deactivate',NULL,'\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/econommode_deactivate.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(125,0,50,'colorUpdated','Color Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SRGB_colorUpdated.php\');\n/* end injection of {SDevices} */',0,0,'2018-03-19 11:22:18','{\"object\":\"Gateway1\",\"op\":\"m\",\"m\":\"colorUpdated\",\"PROPERTY\":\"color\",\"NEW_VALUE\":\"56ea09\",\"OLD_VALUE\":\"56ea09\",\"SOURCE\":\"\",\"ORIGINAL_OBJECT_TITLE\":\"Gateway1\"}',NULL),(126,0,50,'setColor','Color Set','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SRGB_setColor.php\');\n/* end injection of {SDevices} */',0,0,'2018-03-19 00:20:30','{\"method\":\"%Gateway1.setColor\",\"color\":\"#56ea09\",\"ORIGINAL_OBJECT_TITLE\":\"Gateway1\"}',NULL),(127,0,50,'turnOn','Включить','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SRGB_turnOn.php\');\n/* end injection of {SDevices} */',0,0,'2018-03-19 00:20:30','{\"object\":\"Gateway1\",\"op\":\"m\",\"m\":\"turnOn\",\"ORIGINAL_OBJECT_TITLE\":\"Gateway1\"}',NULL),(128,0,50,'turnOff','Выключить','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SRGB_turnOff.php\');\n/* end injection of {SDevices} */',0,0,'2018-03-18 23:10:32','{\"object\":\"Gateway1\",\"op\":\"m\",\"m\":\"turnOff\",\"ORIGINAL_OBJECT_TITLE\":\"Gateway1\"}',NULL),(129,0,51,'motionDetected','Motion Detected','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCameras_motionDetected.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(130,0,51,'updatePreview','Update preview code','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCameras_updatePreview.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(131,0,51,'takeSnapshot','Takes snapshot','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCameras_takeSnapshot.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(132,0,52,'statusUpdated','Status updated event','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SLeak_statusUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(133,0,53,'statusUpdated','Status updated event','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSmoke_statusUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(134,0,54,'valueUpdated','Data Value updated event','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCounters_valueUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(135,0,62,'tempChanged','вызывается при изменении температуры','//$params[\'t\']\r\n$old_temp=$this->getProperty(\'temp\');\r\n$t=round($params[\'t\']*2)/2;\r\n$this->setProperty(\'temp\',$t);\r\nif ($t>$old_temp) {\r\n $d=1;\r\n} elseif ($t<$old_temp) {\r\n $d=-1;\r\n} else {\r\n $d=0;\r\n}\r\n$this->setProperty(\'direction\',$d);\r\n$this->setProperty(\"updated\",time());\r\n$this->setProperty(\"updatedTime\",date(\"d.m.Y H:i\",time()));\r\n',0,0,'2017-10-28 19:48:22','a:2:{s:1:\"t\";d:55.700000000000003;s:21:\"ORIGINAL_OBJECT_TITLE\";s:7:\"tempD30\";}',NULL),(136,0,62,'tempChanged2','','//$params[\'t\']\r\n$old_temp=$this->getProperty(\'temp\');\r\n$t=round($params[\'t\']*2)/2;\r\n$this->setProperty(\'temp\',$t);\r\nif ($t>$old_temp) {\r\n $d=1;\r\n} elseif ($t<$old_temp) {\r\n $d=-1;\r\n} else {\r\n $d=0;\r\n}\r\n$this->setProperty(\'temp\',$t);\r\n$this->setProperty(\'direction\',$d);\r\n$this->setProperty(\"updated\",time());\r\n$this->setProperty(\"updatedTime\",date(\"d.m.Y H:i\",time()));\r\n',0,0,'2013-12-09 22:20:05','a:2:{s:1:\"t\";N;s:21:\"ORIGINAL_OBJECT_TITLE\";s:7:\"tempD11\";}',NULL),(144,191,0,'commandReceived','','$command=mb_strtolower($params[\'command\']);\r\n\r\n$short_command=\'\';\r\n$dt=recognizeTime($command,$short_command);\r\n\r\nif (preg_match(\'/скажи сколько врем/is\',$command)) {\r\n if ($dt>0) {\r\n  addScheduledJob(\"command\".$dt,\"processCommand(\'\".$short_command.\"\');\",$dt);\r\n  say(\'Задача принята\',2);\r\n  return;\r\n }\r\n global $voicemode;\r\n $voicemode=\'on\';\r\n say(\'Сейчас \'.timeNow(),2);\r\n} elseif (preg_match(\'/сколько время/is\',$command)) {\r\n if ($dt>0) {\r\n  addScheduledJob(\"command\".$dt,\"processCommand(\'\".$short_command.\"\');\",$dt);\r\n  say(\'Задача принята\');\r\n  echo $short_command;\r\n  return;\r\n }\r\n say(\'Сейчас \'.timeNow(),2);\r\n} elseif (preg_match(\'/повтори (.+)/is\',$command,$m) || preg_match(\'/скажи (.+)/is\',$command,$m)) {\r\n if ($dt>0) {\r\n  addScheduledJob(\"command\".$dt,\"processCommand(\'\".$short_command.\"\');\",$dt);\r\n  say(\'Задача принята\',2);\r\n  return;\r\n }\r\n global $voicemode;\r\n $voicemode=\'on\';\r\n say($m[1],2);\r\n} else {\r\n //say(\'Неизвестная команда...\',2);\r\n}',1,0,'2018-09-25 10:46:28','{\"command\":\"fhhg\"}',NULL),(145,191,0,'powerDisconnected','','say(\"Отключено питание\");',1,0,'0000-00-00 00:00:00','',NULL),(146,0,65,'userEntered',NULL,'//$params[\"USER_OBJECT\"]\n',0,0,NULL,NULL,NULL),(147,0,65,'userLeft',NULL,'//$params[\"USER_OBJECT\"]\n',0,0,NULL,NULL,NULL),(148,0,32,'enteredLocation',NULL,'//$params[\"LOCATION_OBJECT\"], $params[\"LOCATION\"]\n',0,0,NULL,NULL,NULL),(149,0,32,'leftLocation',NULL,'//$params[\"LOCATION_OBJECT\"], $params[\"LOCATION\"]\n',0,0,NULL,NULL,NULL),(150,23,0,'activate',NULL,'\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/darknessmode_activate.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(151,23,0,'deactivate',NULL,'\n/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/darknessmode_deactivate.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(152,0,66,'valueUpdated','Value Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_valueUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(153,0,66,'statusUpdated','Status Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_statusUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(154,0,66,'tempUp','Increase target temperature','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_tempUp.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(155,0,66,'tempDown','Descrease target temperature','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_tempDown.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(156,0,68,'install','метод для первоначальной инсталляции, запустить один первый раз, ver 3.20','',0,0,'2018-03-09 12:42:47','{\"object\":\"TodoList\",\"op\":\"m\",\"m\":\"install\",\"ORIGINAL_OBJECT_TITLE\":\"TodoList\"}',NULL),(157,244,0,'install','','// ******************************************************************\r\n// *    TO DO app   -  by Vovix  -  09.12.2017 г.     -    v 3.20   *\r\n// ******************************************************************\r\n\r\n// создадим класс, объекты и свойства\r\naddClass(\'ToDo\');\r\naddClassObject(\'ToDo\',\'TodoList\');\r\naddClassProperty(\'ToDo\',\'StreamingCodeMenu\'); // HTML для меню\r\naddClassProperty(\'ToDo\',\'StreamingCodeScene\'); // HTML для сцен\r\naddClassProperty(\'ToDo\',\'menuCSS\'); // CSS для меню\r\naddClassProperty(\'ToDo\',\'sceneCSS\'); // CSS для сцены\r\naddClassProperty(\'ToDo\',\'JS\'); // общий код javascript\r\naddClassProperty(\'ToDo\',\'sayTodo\'); // настройка проговаривания (также зависит от общего уровня системы)\r\n// например: при TodoList.sayTodo = 0 - проговаривания нет,  далее уровень произношения устанавливается \r\n// по принципу TodoList.sayTodo минус 2, т.е. при равном 1 будет -1, при 2 будет 0, при 3 будет 1 и т.д.\r\naddClassProperty(\'ToDo\',\'todo\'); // сам лист to do\r\n\r\n// \r\n$this->setProperty(\'todo\', \'- to do list by Vovix -|-installed, ver 3.20\');\r\n$this->setProperty(\'sayTodo\', \'2\'); // при ThisComputer.minMsgLevel = 0 будет говорить\r\n\r\n$menuCSS=\'\r\n@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n \r\n#item194 { /* здесь item194 - это номер ID пункта меню в котором он размещен - меняйте на свой! */\r\n padding: 0;\r\n }\r\n \r\n#list {\r\n  position: relative;\r\n /* width: calc(100% + 40px); */\r\n /* margin: 0 -20px 0 -20px; */\r\n width: 100%;\r\n margin: 0;\r\n \r\n}\r\n#list .new {\r\n width: 100%;\r\n height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n }\r\n \r\n#list .new #newtask {\r\n  float: left;\r\n  width: calc(100% - 76px);\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  background: #333333;\r\n  text-indent: 8px;\r\n}\r\n\r\n#list .new input {\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 14px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  text-shadow: none;\r\n}\r\n\r\n#list .new #newtask::-webkit-input-placeholder {\r\n  color: rgba(255, 255, 255, 0.5);\r\n}\r\n\r\n#list .new button {\r\n  cursor: pointer;\r\n  float: right;\r\n  width: 76px;\r\n  height: 50px;\r\n  padding: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  margin: -9px 0 0 0;\r\n  background: #111111;\r\n  font-size: 24px;\r\n  color: #FFF;\r\n}\r\n\r\n#list .list .item {\r\n  clear: both;\r\n  width: 100%;\r\n  height: 38px;\r\n margin: 0;\r\n }\r\n\r\n#list .list .item span {\r\n  cursor: default;\r\n  float: left;\r\n  width: calc(100% - 76px);\r\n  height: 20px;\r\n  padding: 9px 0 0 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: transparent;\r\n  text-indent: 8px;\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 14px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  text-shadow: none;\r\n  text-overflow: ellipsis;\r\n  overflow: hidden;\r\n  white-space: nowrap;\r\n  }\r\n\r\n#list .list .item span.checked {\r\n  opacity: .5;\r\n  text-decoration: line-through;\r\n}\r\n\r\n#list .list .item .rightblock {\r\n  float: right;\r\n  width: 76px;\r\n  height: 38px;\r\n  padding: 0;\r\n  margin: 0;\r\n }\r\n\r\n#list .list .item .rightblock button {\r\n cursor: pointer;\r\n  float: left;\r\n  width: 38px;\r\n  height: 38px;\r\n  padding: 0px;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  background: rgba(0,0,0,0.1);\r\n  font-size: 20px;\r\n  color: #FFF;  \r\n}\r\n\';\r\n\r\n$this->setProperty(\'menuCSS\', $menuCSS);\r\n\r\n$sceneCSS=\'\r\n@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n\r\n#list {\r\n  position: relative;\r\n width: 100%;\r\n max-height: 528px;\r\n overflow: auto;\r\n margin: 0;\r\n}\r\n\r\n#list .new #newtask {\r\n  float: left;\r\n  width: calc(100% - 100px);\r\n  height: 100px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: #333333;\r\n  line-height: 50px;\r\n  text-indent: 25px;\r\n}\r\n\r\n#list .new input {\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 28px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  text-shadow: 0px;\r\n\r\n}\r\n\r\n\r\n#list .new #newtask::-webkit-input-placeholder {\r\n  color: rgba(255, 255, 255, 0.5);\r\n}\r\n#list .new button {\r\n  cursor: pointer;\r\n  float: right;\r\n  width: 100px;\r\n  height: 100px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  background: #111111;\r\n  font-size: 84px;\r\n  color: #FFF;\r\n}\r\n#list .list .item {\r\n  clear: both;\r\n  width: 100%;\r\n  height: 50px;\r\n  margin: 0;\r\n  padding: 5px 0 0 0;\r\n}\r\n#list .list .item span {\r\n  cursor: default;\r\n  float: left;\r\n  width: calc(100% - 150px);\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: transparent;\r\n  text-indent: 25px;\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 28px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  text-overflow: ellipsis;\r\n  overflow: hidden;\r\n  white-space: nowrap;\r\n  \r\n}\r\n#list .list .item span.checked {\r\n  opacity: .5;\r\n  text-decoration: line-through;\r\n}\r\n#list .list .item .rightblock {\r\n  float: right;\r\n  padding: 0;\r\n  margin: -2px 0 0 0;\r\n}\r\n#list .list .item button{\r\n cursor: pointer;\r\n  float: left;\r\n  width: 50px;\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  box-shadow: 0 0 3px rgba(0,0,0,0.2);\r\n  background: rgba(0,0,0,0.1);\r\n  font-size: 32px;\r\n  color: #FFF;  \r\n}\r\n\';\r\n\r\n$this->setProperty(\'sceneCSS\', $sceneCSS);\r\n\r\n$JS=\'\r\nfunction btnRunClicked() {\r\n    var newtask = $(\"#newtask\").val(),\r\n		ni = $(\"div.item\").length + 1;\r\n		\r\n	$(\"#newtask\").val(\"\");\r\n	\r\n    if (newtask) {\r\n		var task1 = String(newtask);\r\n		var codItem1 = \\\'<div class=\"item\" id=\"taskbox_\\\' + ni + \\\'\" style =\"background: hsl(\\\' + (190+ni*6) + \\\',73%,50%);\">\\\';\r\n		var codItem2 = \\\'<span id=\"task_\\\' + ni + \\\'\">\\\' + task1 + \\\'</span>\\\';\r\n  		var codItem3 = \\\'<div class=\"rightblock\"><button id=\"check_\\\' + ni + \\\'\" class=\"check fa fa-check ui-btn ui-shadow ui-corner-all\" onClick=\"checkClicked(\\\' + ni +\\\');\"></button>\\\';\r\n		var codItem4 = \\\'<button id=\"delete_\\\' + ni + \\\'\" class=\"delete fa fa-times ui-btn ui-shadow ui-corner-all\" onClick=\"deleteClicked(\\\' + ni + \\\');\"></button></div></div>\\\';\r\n \r\n		$.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"new\", task:newtask } );\r\n		setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n 		$(codItem1 + codItem2 + codItem3 + codItem4).appendTo(\"div.list\");\r\n		return false;\r\n    } \r\n} \r\n\r\nfunction checkClicked(ctask) {\r\n    if (ctask) {\r\n        $.get( \"/objects/\", { object:\"TodoList\", op:\"m\",m:\"check\", task:ctask } );\r\n		$(\"#task_\"+ctask).toggleClass(\"checked\");\r\n                setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n        return false;\r\n    } \r\n}   \r\n\r\nfunction deleteClicked(dtask) {\r\n    if (dtask) {\r\n        $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"delete\", task:dtask } );\r\n		$(\"#taskbox_\"+dtask).remove();\r\n               setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n        return false;\r\n    } \r\n}\r\n\';\r\n\r\n$this->setProperty(\'JS\', $JS);\r\n\r\n\r\n$view=\'\r\n// МЕТОД view - подготовка кода для отображения\r\n\r\n$todo = $this->getProperty(\"todo\");\r\n\r\n// установим внутреннюю кодировку символов\r\nmb_internal_encoding(\"UTF-8\");\r\n\r\n$td = explode(\"|\", $todo);\r\n\r\n$str_cod = \\\'<div id=\"list\">\r\n   <div class=\"new\">\r\n      <input id=\"newtask\" placeholder=\"New Item\" type=\"text\">\r\n      <button onClick=\"btnRunClicked();\" class=\"fa fa-plus\"></button>\r\n   </div>\r\n   <div class=\"list\">\\\';\r\n\r\n	for($i = 1; $i < sizeof($td); $i++) {\r\n     		     \r\n     		// выделим и сохраним первый символ\r\n     		$check = mb_substr($td[$i], 0, 1);\r\n\r\n               \r\n     		// обрежем строку, не будем отображать первый символ + или -\r\n     		$task = mb_substr($td[$i], 1);\r\n            		\r\n     		// начинаем формировать код hsl(196,\\\'.(73-24*(($i-1)%2)).\\\'%,50%)\r\n 	$str_cod = $str_cod.\\\'\r\n\r\n               <div class=\"item\" id=\"taskbox_\\\'.$i.\\\'\" style =\"background: hsl(\\\'.(190+$i*6).\\\',73%,50%);\">\r\n               \r\n               <span id=\"task_\\\'.$i.\\\'\"\\\';\r\n               \r\n               // если певый символ \"+\" то значит задание \"выполнено\"\r\n     		if ($check == \"+\") {\r\n     			$str_cod = $str_cod.\\\' class=\"checked\"\\\';\r\n     		}\r\n     			$str_cod = $str_cod.\\\'>\\\'.$task.\\\'</span>\\\';\r\n\r\n  			$str_cod = $str_cod.\\\'\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_\\\'.$i.\\\'\" class=\"check fa fa-check\" onClick=\"checkClicked(\\\'.$i.\\\');\"></button>\r\n                 <button id=\"delete_\\\'.$i.\\\'\" class=\"delete fa fa-times\" onClick=\"deleteClicked(\\\'.$i.\\\');\"></button>\r\n               </div>\r\n            </div>\\\';\r\n	}\r\n$str_cod = $str_cod.\\\'\r\n   </div>\r\n</div>\\\';\r\n\r\n// записываем получившийся код\r\n$this->setProperty(\"StreamingCodeScene\",$str_cod);\r\n\r\n$str_cod_css = \"<style>\".$this->getProperty(\"menuCSS\").\"</style>\";\r\n$str_cod_js = \"<script type=\\\'text/javascript\\\'>\".$this->getProperty(\"JS\").\"</script>\";\r\n$str_cod = $str_cod_css.$str_cod_js.$str_cod;\r\n$this->setProperty(\"StreamingCodeMenu\",$str_cod);\r\n\';\r\n\r\naddClassMethod(\'ToDo\', \'view\', $view);\r\n\r\n$check=\'\r\n// МЕТОД check\r\n\r\n$todo = $this->getProperty(\"todo\");\r\n\r\n// установим внутреннюю кодировку символов\r\nmb_internal_encoding(\"UTF-8\");\r\n\r\n$td = explode(\"|\", $todo);\r\n\r\nif (isset($params[\"task\"])) {\r\n    \r\n 	$ct = $params[\"task\"];\r\n\r\n    for($i = 0; ($i < sizeof($td)); $i++) {\r\n\r\n     		// выделим и сохраним первый символ\r\n     		$check = mb_substr($td[$i], 0, 1);\r\n                  \r\n     		// обрежем строку, не будем отображать первый символ + или -\r\n     		$task = mb_substr($td[$i], 1);\r\n \r\n         // если совпадает номер строки \r\n         if ($i == $ct) {\r\n              // инвентируем check\r\n              $check = ($check == \"+\") ? \"-\" : \"+\";\r\n          	  $tcheck = ($check == \"+\") ? \"&quot;выполненно&quot;\" : \"&quot;не выполнено&quot;\";\r\n              $sayTodo = gg(\"TodoList.sayTodo\");\r\n 			  	if ($sayTodo) { \r\n         	  		say (\"Todo задача: \".$task.\" - отмечена как \".$tcheck,($sayTodo-2));\r\n    			}	 \r\n          \r\n         }\r\n              $td[$i] = $check.$task;\r\n   \r\n    }\r\n$todo = implode(\"|\", $td);\r\n$this->setProperty(\"todo\", $todo);\r\n}\r\n// выполним подготовку для отображения\r\ncallMethod(\"TodoList.view\");\r\n\';\r\n\r\naddClassMethod(\'ToDo\', \'check\', $check);\r\n\r\n$delete = \'\r\n// МЕТОД delete\r\n\r\n$todo = $this->getProperty(\"todo\");\r\n$dt = $params[\"task\"]; // получаем номер строки на удаление\r\n$td = explode(\"|\", $todo); // Считываем всё в массив \r\n\r\nfor($i = 0; $i < sizeof($td); $i++) { \r\n if($i == $dt) {\r\n   \r\n  $sayTodo = gg(\"TodoList.sayTodo\");\r\n 	if ($sayTodo) { \r\n         say (\"Из листа todo удалена задача: \".mb_substr($td[$i], 1).\"\",($sayTodo-2));\r\n    }\r\n  \r\n  unset($td[$i]);\r\n }\r\n}\r\n\r\n$todo = implode(\"|\", $td);\r\n$this->setProperty(\"todo\", $todo);\r\n\r\n\r\n// выполним подготовку для отображения\r\ncallMethod(\"TodoList.view\");\r\n\';\r\n\r\naddClassMethod(\'ToDo\', \'delete\', $delete);\r\n\r\n$new = \'\r\n// МЕТОД new\r\n\r\nif (isset($params[\"task\"])) {\r\n\r\n	$todo = $this->getProperty(\"todo\");\r\n\r\n	$mytask = \"-\".$params[\"task\"]; // строка задачи\r\n\r\n 	$sayTodo = gg(\"TodoList.sayTodo\");\r\n 	if ($sayTodo) { \r\n         say (\"В лист todo добавлена задача: \".$params[\"task\"].\"\",($sayTodo-2));\r\n    }	\r\n \r\n	$todo = $todo.\"|\".$mytask; // добавляем с разделителем \r\n\r\n	$this->setProperty(\"todo\", $todo);\r\n    // выполним подготовку для отображения\r\n    callMethod(\"TodoList.view\");\r\n\r\n}\r\n\';\r\n\r\naddClassMethod(\'ToDo\', \'new\', $new);\r\n\r\n\r\n// выполним подготовку для отображения\r\ncallMethod(\"TodoList.view\");\r\n',1,0,'2018-03-09 12:42:47','{\"object\":\"TodoList\",\"op\":\"m\",\"m\":\"install\"}',NULL),(158,0,68,'view',NULL,'\r\n// МЕТОД view - подготовка кода для отображения\r\n\r\n$todo = $this->getProperty(\"todo\");\r\n\r\n// установим внутреннюю кодировку символов\r\nmb_internal_encoding(\"UTF-8\");\r\n\r\n$td = explode(\"|\", $todo);\r\n\r\n$str_cod = \'<div id=\"list\">\r\n   <div class=\"new\">\r\n      <input id=\"newtask\" placeholder=\"New Item\" type=\"text\">\r\n      <button onClick=\"btnRunClicked();\" class=\"fa fa-plus\"></button>\r\n   </div>\r\n   <div class=\"list\">\';\r\n\r\n	for($i = 1; $i < sizeof($td); $i++) {\r\n     		     \r\n     		// выделим и сохраним первый символ\r\n     		$check = mb_substr($td[$i], 0, 1);\r\n\r\n               \r\n     		// обрежем строку, не будем отображать первый символ + или -\r\n     		$task = mb_substr($td[$i], 1);\r\n            		\r\n     		// начинаем формировать код hsl(196,\'.(73-24*(($i-1)%2)).\'%,50%)\r\n 	$str_cod = $str_cod.\'\r\n\r\n               <div class=\"item\" id=\"taskbox_\'.$i.\'\" style =\"background: hsl(\'.(190+$i*6).\',73%,50%);\">\r\n               \r\n               <span id=\"task_\'.$i.\'\"\';\r\n               \r\n               // если певый символ \"+\" то значит задание \"выполнено\"\r\n     		if ($check == \"+\") {\r\n     			$str_cod = $str_cod.\' class=\"checked\"\';\r\n     		}\r\n     			$str_cod = $str_cod.\'>\'.$task.\'</span>\';\r\n\r\n  			$str_cod = $str_cod.\'\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_\'.$i.\'\" class=\"check fa fa-check\" onClick=\"checkClicked(\'.$i.\');\"></button>\r\n                 <button id=\"delete_\'.$i.\'\" class=\"delete fa fa-times\" onClick=\"deleteClicked(\'.$i.\');\"></button>\r\n               </div>\r\n            </div>\';\r\n	}\r\n$str_cod = $str_cod.\'\r\n   </div>\r\n</div>\';\r\n\r\n// записываем получившийся код\r\n$this->setProperty(\"StreamingCodeScene\",$str_cod);\r\n\r\n$str_cod_css = \"<style>\".$this->getProperty(\"menuCSS\").\"</style>\";\r\n$str_cod_js = \"<script type=\'text/javascript\'>\".$this->getProperty(\"JS\").\"</script>\";\r\n$str_cod = $str_cod_css.$str_cod_js.$str_cod;\r\n$this->setProperty(\"StreamingCodeMenu\",$str_cod);\r\n',0,0,'2018-03-09 13:08:19','{\"ORIGINAL_OBJECT_TITLE\":\"TodoList\"}',NULL),(159,0,68,'check',NULL,'\r\n// МЕТОД check\r\n\r\n$todo = $this->getProperty(\"todo\");\r\n\r\n// установим внутреннюю кодировку символов\r\nmb_internal_encoding(\"UTF-8\");\r\n\r\n$td = explode(\"|\", $todo);\r\n\r\nif (isset($params[\"task\"])) {\r\n    \r\n 	$ct = $params[\"task\"];\r\n\r\n    for($i = 0; ($i < sizeof($td)); $i++) {\r\n\r\n     		// выделим и сохраним первый символ\r\n     		$check = mb_substr($td[$i], 0, 1);\r\n                  \r\n     		// обрежем строку, не будем отображать первый символ + или -\r\n     		$task = mb_substr($td[$i], 1);\r\n \r\n         // если совпадает номер строки \r\n         if ($i == $ct) {\r\n              // инвентируем check\r\n              $check = ($check == \"+\") ? \"-\" : \"+\";\r\n          	  $tcheck = ($check == \"+\") ? \"&quot;выполненно&quot;\" : \"&quot;не выполнено&quot;\";\r\n              $sayTodo = gg(\"TodoList.sayTodo\");\r\n 			  	if ($sayTodo) { \r\n         	  		say (\"Todo задача: \".$task.\" - отмечена как \".$tcheck,($sayTodo-2));\r\n    			}	 \r\n          \r\n         }\r\n              $td[$i] = $check.$task;\r\n   \r\n    }\r\n$todo = implode(\"|\", $td);\r\n$this->setProperty(\"todo\", $todo);\r\n}\r\n// выполним подготовку для отображения\r\ncallMethod(\"TodoList.view\");\r\n',0,0,'2018-03-09 13:08:18','{\"object\":\"TodoList\",\"op\":\"m\",\"m\":\"check\",\"task\":\"4\",\"ORIGINAL_OBJECT_TITLE\":\"TodoList\"}',NULL),(160,0,68,'delete',NULL,'\r\n// МЕТОД delete\r\n\r\n$todo = $this->getProperty(\"todo\");\r\n$dt = $params[\"task\"]; // получаем номер строки на удаление\r\n$td = explode(\"|\", $todo); // Считываем всё в массив \r\n\r\nfor($i = 0; $i < sizeof($td); $i++) { \r\n if($i == $dt) {\r\n   \r\n  $sayTodo = gg(\"TodoList.sayTodo\");\r\n 	if ($sayTodo) { \r\n         say (\"Из листа todo удалена задача: \".mb_substr($td[$i], 1).\"\",($sayTodo-2));\r\n    }\r\n  \r\n  unset($td[$i]);\r\n }\r\n}\r\n\r\n$todo = implode(\"|\", $td);\r\n$this->setProperty(\"todo\", $todo);\r\n\r\n\r\n// выполним подготовку для отображения\r\ncallMethod(\"TodoList.view\");\r\n',0,0,'2018-03-09 13:00:30','{\"object\":\"TodoList\",\"op\":\"m\",\"m\":\"delete\",\"task\":\"1\",\"ORIGINAL_OBJECT_TITLE\":\"TodoList\"}',NULL),(161,0,68,'new',NULL,'\r\n// МЕТОД new\r\n\r\nif (isset($params[\"task\"])) {\r\n\r\n	$todo = $this->getProperty(\"todo\");\r\n\r\n	$mytask = \"-\".$params[\"task\"]; // строка задачи\r\n\r\n 	$sayTodo = gg(\"TodoList.sayTodo\");\r\n 	if ($sayTodo) { \r\n         say (\"В лист todo добавлена задача: \".$params[\"task\"].\"\",($sayTodo-2));\r\n    }	\r\n \r\n	$todo = $todo.\"|\".$mytask; // добавляем с разделителем \r\n\r\n	$this->setProperty(\"todo\", $todo);\r\n    // выполним подготовку для отображения\r\n    callMethod(\"TodoList.view\");\r\n\r\n}\r\n',0,0,'2018-03-09 13:07:30','{\"object\":\"TodoList\",\"op\":\"m\",\"m\":\"new\",\"task\":\"\\u043e\\u0442\\u043c\\u0435\\u0442\\u0438\\u0442\\u044c 8 \\u043c\\u0430\\u0440\\u0442\\u0430\",\"ORIGINAL_OBJECT_TITLE\":\"TodoList\"}',NULL),(162,278,0,'logicAction',NULL,NULL,0,0,NULL,NULL,NULL),(163,0,51,'takeSeries','Takes image series','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCameras_takeSeries.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(164,0,54,'valueWorkUpdated','Work Value updated event','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCounters_valueWorkUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(165,0,58,'valueUpdated','Value Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SPowerSensors_valueUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(166,0,58,'loadStatusChanged','Load Status Changed','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SPowerSensors_loadStatusChanged.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(167,0,39,'levelWorkUpdated','Level Work Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SDimmers_levelWorkUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(168,0,54,'refreshStats','Refreshes daily/monthly stats','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SCounters_refreshStats.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(169,0,35,'Control',NULL,'',0,0,NULL,NULL,NULL),(170,0,66,'switchEnable','Switch Enable','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_switchEnable.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(171,0,66,'enable','Enable','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_enable.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(172,0,66,'disable','Режим: Выкл','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_disable.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(173,0,36,'keepAlive','Alive update','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SDevices_keepAlive.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(174,0,79,'turnOn','Включить','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SGroups_turnOn.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(175,0,79,'turnOff','Выключить','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SGroups_turnOff.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(176,0,79,'switch','Switch','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SGroups_switch.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(177,0,79,'statusUpdated','Status Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SGroups_statusUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(178,0,66,'setTargetTemperature','Set target temperature','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_setTargetTemperature.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(179,0,66,'turnOn','Режим: Обычный','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_turnOn.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(180,0,66,'turnOff','Режим: Эко','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SThermostats_turnOff.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(181,0,39,'setLevel','Set brightness level','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SDimmers_setLevel.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(182,0,39,'statusUpdated','Status Updated','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SDimmers_statusUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(183,0,40,'blockSensor','Блокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SMotions_blockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(184,0,40,'unblockSensor','Разблокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SMotions_unblockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(185,0,41,'blockSensor','Блокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SOpenClose_blockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(186,0,41,'unblockSensor','Разблокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SOpenClose_unblockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(187,0,80,'statusUpdated','Status updated event','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SOpenable_statusUpdated.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(188,0,80,'switch','Switch','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SOpenable_switch.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(189,0,80,'open','Open','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SOpenable_open.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(190,0,80,'close','Close','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SOpenable_close.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(191,0,52,'alert','Sensor alert','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SLeak_alert.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(192,0,52,'blockSensor','Блокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SLeak_blockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(193,0,52,'unblockSensor','Разблокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SLeak_unblockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(194,0,53,'alert','Sensor alert','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSmoke_alert.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(195,0,53,'blockSensor','Блокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSmoke_blockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(196,0,53,'unblockSensor','Разблокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSmoke_unblockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(197,0,43,'alert','Sensor alert','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSensors_alert.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(198,0,43,'blockSensor','Блокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSensors_blockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(199,0,43,'unblockSensor','Разблокировать датчик','/* begin injection of {SDevices} */\nrequire(DIR_MODULES.\'devices/SSensors_unblockSensor.php\');\n/* end injection of {SDevices} */',0,0,NULL,NULL,NULL),(200,0,81,'OnChange',NULL,'SQLUpdate(\"objects\", array(\"ID\"=>$this->id, \"DESCRIPTION\"=>gg(\"sysdate\").\" \".gg(\"timenow\"))); ',0,0,'2020-01-28 19:49:33','{\"PROPERTY\":\"now\",\"NEW_VALUE\":\" 19:49\",\"OLD_VALUE\":\" 19:19\",\"no_session\":\"1\",\"ORIGINAL_OBJECT_TITLE\":\"vologda\"}','/api.php/method/vologda.OnChange?PROPERTY=now&NEW_VALUE= 19:49&OLD_VALUE= 19:19&SOURCE=&m_c_s[0]=vologda.OnChange.d0ae3da2c1885a371f1667a12406ce1d&no_session=1'),(201,0,81,'ChangeCondition',NULL,'///',0,0,'2020-01-28 19:49:33','{\"PROPERTY\":\"condition\",\"NEW_VALUE\":\"overcast\",\"OLD_VALUE\":\"overcast-and-light-snow\",\"no_session\":\"1\",\"ORIGINAL_OBJECT_TITLE\":\"vologda\"}','/api.php/method/vologda.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=vologda.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(202,0,81,'Changetemp',NULL,'\nrequire(DIR_MODULES.\"yandexweather/changetemp.php\");',0,0,'2020-01-28 19:49:33','{\"PROPERTY\":\"temp\",\"NEW_VALUE\":\"-10\",\"OLD_VALUE\":\"-10\",\"no_session\":\"1\",\"ORIGINAL_OBJECT_TITLE\":\"yw_mycity\"}','/api.php/method/yw_mycity.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=yw_mycity.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(203,0,81,'updatetitle',NULL,'\n$sqlQuery = \"SELECT pvalues.*, objects.TITLE as OBJECT_TITLE, properties.TITLE as PROPERTY_TITLE\n               FROM pvalues\n               JOIN objects ON pvalues.OBJECT_ID = objects.id\n               JOIN properties ON pvalues.PROPERTY_ID = properties.id\n              WHERE pvalues.PROPERTY_NAME != CONCAT_WS(\'.\', objects.TITLE, properties.TITLE)\";\n\n$data = SQLSelect($sqlQuery); \n$total = count($data); \nfor ($i = 0; $i < $total; $i++)\n{ $objectProperty = $data[$i][\"OBJECT_TITLE\"] . \".\" . $data[$i][\"PROPERTY_TITLE\"];\n $sqlQuery = \"SELECT * FROM pvalues WHERE ID =\".$data[$i][\'ID\'] ;\n $rec = SQLSelectOne($sqlQuery); \n $rec[\'PROPERTY_NAME\'] = $data[$i][\"OBJECT_TITLE\"] . \".\" . $data[$i][\"PROPERTY_TITLE\"]; SQLUpdate(\"pvalues\", $rec); } \n\n$data = SQLSelect($sqlQuery); \n$total = count($data); \nfor ($i = 0; $i < $total; $i++)\n{ $objectProperty = $data[$i][\"OBJECT_TITLE\"] . \".\" . $data[$i][\"PROPERTY_TITLE\"];\n $sqlQuery = \"SELECT * FROM pvalues WHERE ID =\".$data[$i][\"ID\"] ;\n $rec = SQLSelectOne($sqlQuery); $rec[\"PROPERTY_NAME\"] = $data[$i][\"OBJECT_TITLE\"] . \".\" . $data[$i][\"PROPERTY_TITLE\"]; SQLUpdate(\"pvalues\", $rec); } \n',0,0,'2020-01-27 15:33:03','{\"ORIGINAL_OBJECT_TITLE\":\"yw_mycity\"}','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(204,0,81,'sayweather',NULL,'include_once(DIR_MODULES . \"yandexweather/yandexweather.class.php\"); $yw = new yandexweather(); $yw->sayweather(); ',0,0,NULL,NULL,NULL),(205,0,81,'sayforecast',NULL,'include_once(DIR_MODULES . \"yandexweather/yandexweather.class.php\"); $yw = new yandexweather(); $yw->sayforecast(); ',0,0,NULL,NULL,NULL),(206,279,0,'ChangeCondition',NULL,'\nif(($this->object_title==\"yw_mycity\") and ($this->getProperty(\"condition\")<>\"\"))\n{\n//require(DIR_MODULES.\"yandexweather/ywext.inc.php\");\ninclude_once(DIR_MODULES.\"yandexweather/ywext.inc.php\");\n \n$lastcondition=gg(\"yw_mycity.lastcondition\");\n$conditioneng=gg(\"yw_mycity.condition\");\n$condition1eng=gg(\"yw_mycity.forecast_0_daycondition\");  \n$condition2eng=gg(\"yw_mycity.forecast_1_daycondition\");  \n$condition3eng=gg(\"yw_mycity.forecast_2_daycondition\");    \n\n $condition=getconditionrusincl($conditioneng);\n$condition1=getconditionrusincl($condition1eng);    \n$condition2=getconditionrusincl($condition2eng);        \n$condition3=getconditionrusincl($condition3eng);        \n\nsg(\"yw_mycity.conditionrus\",$condition); \n    \nsg(\"yw_mycity.condition1rus\",$condition1) ;     \nsg(\"yw_mycity.condition2rus\",$condition2) ;     \nsg(\"yw_mycity.condition3rus\",$condition3) ;         \n\n$cmd_rec = SQLSelectOne(\"SELECT VALUE FROM yaweather_config where parametr=\'ENABLE_EVENTS\'\");\n$ee=$cmd_rec[\'VALUE\'];\n \n$cmd_rec = SQLSelectOne(\"SELECT VALUE FROM yaweather_config where parametr=\'MSG_LEVEL\'\");\n$msglevel=$cmd_rec[\'VALUE\'];\n \n$cmd_rec = SQLSelectOne(\"SELECT VALUE FROM yaweather_config where parametr=\'LASTCONDITION\'\");\n$lastcondition=$cmd_rec[\'VALUE\'];\n\n \n//say($ee.\":\".$this->getProperty(\"condition\").\':\'.$lastcondition,$msglevel); \n//say($ee.\":\".getObject(\'yw_mycity\')->getProperty(\'condition\').\':\'.$lastcondition,$msglevel);  \n// say($ee.\":\".$params[\'NEW_VALUE\'].\':\'.$lastcondition,$msglevel);  \n //getObject(\'yw_mycity\')->getProperty(\'condition\');\n\n //if (($ee==\"1\") && ($this->getProperty(\"condition\")!=$lastcondition)) {\nif (($ee==\"1\") && ($params[\'NEW_VALUE\']!=$lastcondition) && ($condition!=\"0\")) { \n   \n  say(\" На улице \".$condition,$msglevel); \n}\n}\nsg(\"yw_mycity.lastcondition\",$this->getProperty(\"condition\"));\n//$cmd_rec = SQLSelectOne(\"update yaweather_config set value=\'\".$this->getProperty(\"condition\").\"\' where parametr=\'LASTCONDITION\'\");		   	   	   	\nSQLexec(\"update yaweather_config set value=\'\".$params[\'NEW_VALUE\'].\"\' where parametr=\'LASTCONDITION\'\");	\n\n',0,0,'2020-01-28 19:49:33','{\"PROPERTY\":\"condition\",\"NEW_VALUE\":\"overcast\",\"OLD_VALUE\":\"overcast-and-light-snow\",\"no_session\":\"1\"}','/api.php/method/yw_mycity.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=yw_mycity.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(207,0,62,'tu_plus','установка температуры +1','$temp_s=$this->getProperty(\'tu\');\r\n$temp_s=$temp_s+1;\r\n$this->setProperty(\'tu\',$temp_s);',0,0,'2020-01-28 20:11:03','{\"ORIGINAL_OBJECT_TITLE\":\"tempD2\"}','/ajax/plans.html?op=click&id=12'),(208,0,62,'tu_minus','установка температуры -1','$temp_s=$this->getProperty(\'tu\');\r\n$temp_s=$temp_s-1;\r\n$this->setProperty(\'tu\',$temp_s);',0,0,'2020-01-28 19:58:22','{\"ORIGINAL_OBJECT_TITLE\":\"tempD1\"}','/ajax/plans.html?op=click&id=10');
/*!40000 ALTER TABLE `methods` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `modbusdevices`
--

DROP TABLE IF EXISTS `modbusdevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `modbusdevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `HOST` varchar(255) NOT NULL DEFAULT '',
  `PROTOCOL` char(5) NOT NULL DEFAULT 'UDP',
  `PORT` int(10) NOT NULL DEFAULT '0',
  `DEVICE_ID` int(10) NOT NULL DEFAULT '0',
  `REQUEST_TYPE` varchar(10) NOT NULL DEFAULT '',
  `REQUEST_START` int(10) NOT NULL DEFAULT '0',
  `REQUEST_TOTAL` int(10) NOT NULL DEFAULT '0',
  `RESPONSE_CONVERT` varchar(10) NOT NULL DEFAULT '',
  `DATA` text,
  `CHECK_LATEST` datetime DEFAULT NULL,
  `CHECK_NEXT` datetime DEFAULT NULL,
  `POLLPERIOD` int(10) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `LOG` text NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `modbusdevices`
--

LOCK TABLES `modbusdevices` WRITE;
/*!40000 ALTER TABLE `modbusdevices` DISABLE KEYS */;
/*!40000 ALTER TABLE `modbusdevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mqtt`
--

DROP TABLE IF EXISTS `mqtt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mqtt` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LOCATION_ID` int(10) NOT NULL DEFAULT '0',
  `UPDATED` datetime DEFAULT NULL,
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `PATH` varchar(255) NOT NULL DEFAULT '',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `PATH_WRITE` varchar(255) NOT NULL DEFAULT '',
  `QOS` int(3) NOT NULL DEFAULT '0',
  `RETAIN` int(3) NOT NULL DEFAULT '0',
  `DISP_FLAG` int(3) NOT NULL DEFAULT '0',
  `REPLACE_LIST` varchar(255) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(255) NOT NULL DEFAULT '',
  `READONLY` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mqtt`
--

LOCK TABLES `mqtt` WRITE;
/*!40000 ALTER TABLE `mqtt` DISABLE KEYS */;
/*!40000 ALTER TABLE `mqtt` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mqtt_queue`
--

DROP TABLE IF EXISTS `mqtt_queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mqtt_queue` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PATH` varchar(255) NOT NULL,
  `VALUE` varchar(255) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mqtt_queue`
--

LOCK TABLES `mqtt_queue` WRITE;
/*!40000 ALTER TABLE `mqtt_queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `mqtt_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `msbins`
--

DROP TABLE IF EXISTS `msbins`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `msbins` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `VER` varchar(255) NOT NULL DEFAULT '',
  `BIN` longblob,
  `CRC` char(4) DEFAULT NULL,
  `BLOKS` char(4) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `msbins`
--

LOCK TABLES `msbins` WRITE;
/*!40000 ALTER TABLE `msbins` DISABLE KEYS */;
/*!40000 ALTER TABLE `msbins` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `msgates`
--

DROP TABLE IF EXISTS `msgates`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `msgates` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `ACTIVE` int(3) unsigned NOT NULL DEFAULT '1',
  `GTYPE` int(10) NOT NULL DEFAULT '0',
  `URL` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `msgates`
--

LOCK TABLES `msgates` WRITE;
/*!40000 ALTER TABLE `msgates` DISABLE KEYS */;
INSERT INTO `msgates` VALUES (1,'Main',1,0,':');
/*!40000 ALTER TABLE `msgates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `msnodes`
--

DROP TABLE IF EXISTS `msnodes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `msnodes` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NID` int(10) NOT NULL,
  `PID` int(10) NOT NULL,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `BATTERY` varchar(32) NOT NULL DEFAULT '',
  `HEARTBEAT` datetime DEFAULT NULL,
  `SKETCH` varchar(32) NOT NULL DEFAULT '',
  `VER` varchar(32) NOT NULL DEFAULT '',
  `PROT` varchar(32) NOT NULL DEFAULT '',
  `FIRMWARE` int(10) NOT NULL DEFAULT '-1',
  `BAT_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `BAT_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `HEARTBEAT_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `HEARTBEAT_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `LOCATION_ID` int(10) NOT NULL DEFAULT '0',
  `LASTREBOOT` datetime DEFAULT NULL,
  `DEVTYPE` int(10) DEFAULT '0',
  `BOOTVER` varchar(255) NOT NULL DEFAULT '',
  `GID` int(10) NOT NULL DEFAULT '1',
  `REPEATER` int(10) DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `msnodes`
--

LOCK TABLES `msnodes` WRITE;
/*!40000 ALTER TABLE `msnodes` DISABLE KEYS */;
/*!40000 ALTER TABLE `msnodes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `msnodesens`
--

DROP TABLE IF EXISTS `msnodesens`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `msnodesens` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NID` int(10) NOT NULL,
  `SID` int(10) NOT NULL,
  `SUBTYPE` int(10) NOT NULL,
  `INFO` varchar(255) NOT NULL DEFAULT '',
  `GID` int(10) NOT NULL DEFAULT '1',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `msnodesens`
--

LOCK TABLES `msnodesens` WRITE;
/*!40000 ALTER TABLE `msnodesens` DISABLE KEYS */;
/*!40000 ALTER TABLE `msnodesens` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `msnodestate`
--

DROP TABLE IF EXISTS `msnodestate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `msnodestate` (
  `GID` int(10) NOT NULL DEFAULT '1',
  `NID` int(10) NOT NULL,
  `State` varchar(32) DEFAULT NULL,
  `last` bigint(20) NOT NULL,
  PRIMARY KEY (`NID`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `msnodestate`
--

LOCK TABLES `msnodestate` WRITE;
/*!40000 ALTER TABLE `msnodestate` DISABLE KEYS */;
/*!40000 ALTER TABLE `msnodestate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `msnodeval`
--

DROP TABLE IF EXISTS `msnodeval`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `msnodeval` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NID` int(10) NOT NULL,
  `SID` int(10) NOT NULL,
  `SUBTYPE` int(10) NOT NULL,
  `VAL` varchar(32) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(100) NOT NULL DEFAULT '',
  `ACK` int(3) unsigned NOT NULL DEFAULT '0',
  `REQ` int(3) unsigned NOT NULL DEFAULT '0',
  `GID` int(10) NOT NULL DEFAULT '1',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `msnodeval`
--

LOCK TABLES `msnodeval` WRITE;
/*!40000 ALTER TABLE `msnodeval` DISABLE KEYS */;
/*!40000 ALTER TABLE `msnodeval` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mssendstack`
--

DROP TABLE IF EXISTS `mssendstack`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mssendstack` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `GID` int(10) NOT NULL DEFAULT '1',
  `NID` int(10) NOT NULL,
  `SID` int(10) NOT NULL,
  `MType` int(10) NOT NULL,
  `ACK` int(10) NOT NULL,
  `SUBTYPE` int(10) NOT NULL,
  `MESSAGE` varchar(32) NOT NULL,
  `EXPIRE` bigint(20) NOT NULL,
  `SENDRX` int(10) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mssendstack`
--

LOCK TABLES `mssendstack` WRITE;
/*!40000 ALTER TABLE `mssendstack` DISABLE KEYS */;
/*!40000 ALTER TABLE `mssendstack` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `myblocks`
--

DROP TABLE IF EXISTS `myblocks`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `myblocks` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `CATEGORY_ID` int(10) NOT NULL DEFAULT '0',
  `BLOCK_TYPE` char(10) NOT NULL DEFAULT '',
  `BLOCK_COLOR` int(10) NOT NULL DEFAULT '0',
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `myblocks`
--

LOCK TABLES `myblocks` WRITE;
/*!40000 ALTER TABLE `myblocks` DISABLE KEYS */;
/*!40000 ALTER TABLE `myblocks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `myblocks_categories`
--

DROP TABLE IF EXISTS `myblocks_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `myblocks_categories` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `myblocks_categories`
--

LOCK TABLES `myblocks_categories` WRITE;
/*!40000 ALTER TABLE `myblocks_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `myblocks_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter`
--

DROP TABLE IF EXISTS `newsletter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `newsletter` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `EMAIL` varchar(255) NOT NULL DEFAULT '',
  `LIST` varchar(255) NOT NULL DEFAULT '',
  `ADDED` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter`
--

LOCK TABLES `newsletter` WRITE;
/*!40000 ALTER TABLE `newsletter` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `objects`
--

DROP TABLE IF EXISTS `objects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `objects` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `CLASS_ID` int(10) NOT NULL DEFAULT '0',
  `DESCRIPTION` text,
  `LOCATION_ID` int(10) NOT NULL DEFAULT '0',
  `KEEP_HISTORY` int(10) NOT NULL DEFAULT '0',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=282 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `objects`
--

LOCK TABLES `objects` WRITE;
/*!40000 ALTER TABLE `objects` DISABLE KEYS */;
INSERT INTO `objects` VALUES (4,'USBDev',9,'',0,0,''),(13,'BlueDev',18,'',0,0,''),(6,'ClockChime',7,'',0,0,''),(192,'clapan1',63,'',0,0,''),(10,'mySkype',12,'',0,0,''),(15,'ws',20,'',0,0,''),(16,'Security',21,'',0,0,''),(17,'System',21,'',0,0,''),(18,'Communication',21,'',0,0,''),(19,'EconomMode',24,'',0,0,''),(20,'NobodyHomeMode',24,'',0,0,''),(21,'SecurityArmedMode',24,'',0,0,''),(22,'GuestsMode',24,'',0,0,''),(23,'DarknessMode',24,'',0,0,''),(24,'Livingroom',25,'',4,0,''),(26,'TempSensor01',19,'',1,0,''),(28,'Bedroom',25,'',5,0,''),(29,'Kitchen',25,'',1,0,''),(30,'Hall',25,'',6,0,''),(53,'Bathroom',25,'',7,0,''),(47,'NightMode',24,'',0,0,''),(52,'humSensor01',30,'',1,0,''),(51,'MotionSensor1',23,'',6,0,''),(54,'Kinderroom',25,'',10,0,''),(55,'Toilet',25,'',8,0,''),(68,'admin',32,'',0,0,''),(74,'Switch1',26,'',0,3,''),(76,'RadioSetting',35,'Настройки',0,0,''),(77,'Switch2',26,'',0,0,''),(78,'Switch3',26,'',0,0,''),(79,'Switch4',26,'',0,0,''),(80,'Switch5',26,'',0,0,''),(81,'Switch6',26,'',0,0,''),(82,'Switch7',26,'',0,0,''),(83,'Switch8',26,'',0,0,''),(84,'Switch9',26,'',0,0,''),(85,'Switch10',26,'',0,0,''),(86,'Switch11',26,'',0,0,''),(87,'Switch12',26,'',0,0,''),(88,'Switch13',26,'',0,0,''),(89,'Switch14',26,'',0,0,''),(90,'Switch15',26,'',0,0,''),(91,'Switch16',26,'',0,0,''),(258,'ow_day6',67,'Forecast on 7 period(s)',0,0,''),(257,'ow_day5',67,'Forecast on 6 period(s)',0,0,''),(256,'ow_day4',67,'Forecast on 5 period(s)',0,0,''),(105,'key',47,'',0,0,''),(106,'myobject',48,'',0,0,''),(255,'ow_day3',67,'Forecast on 4 period(s)',0,0,''),(233,'ow_fact',67,'Текущая температура',0,0,''),(141,'vlD1',62,'датчик влажности',0,0,''),(142,'tempD2',62,'',0,0,''),(143,'tempD3',62,'',0,0,''),(144,'tempD4',62,'',0,0,''),(145,'tempD5',62,'',0,0,''),(146,'tempD6',62,'',0,0,''),(147,'tempD7',62,'',0,0,''),(148,'tempD8',62,'',0,0,''),(149,'tempD9',62,'',0,0,''),(150,'tempD10',62,'',0,0,''),(151,'tempD11',62,'',0,0,''),(152,'temp_tmp',62,'временный объект',0,0,''),(153,'tempUlica1',62,'Температура с интернета',0,0,''),(154,'tempDavl',62,'атмосферное давление',0,0,''),(155,'tempVl',62,'влажность',0,0,''),(156,'tempUlica2',62,'температура улицы',0,0,''),(157,'tempUlica3',62,'',0,0,''),(158,'tempD12',62,'',0,0,''),(159,'tempD13',62,'',0,0,''),(160,'tempD14',62,'',0,0,''),(161,'tempD15',62,'',0,0,''),(162,'tempD16',62,'',0,0,''),(163,'tempD17',62,'',0,0,''),(164,'tempD18',62,'',0,0,''),(165,'tempD19',62,'',0,0,''),(166,'tempD20',62,'',0,0,''),(167,'vlD2',62,'датчик влажности',0,0,''),(168,'vlD3',62,'датчик влажности',0,0,''),(169,'vlD4',62,'датчик влажности',0,0,''),(170,'vlD5',62,'датчик влажности',0,0,''),(171,'DavlD1',62,'датчик давления',0,0,''),(172,'DavlD2',62,'датчик давления',0,0,''),(173,'DavlD3',62,'датчик давления',0,0,''),(174,'vlD6',62,'датчик влажности',0,0,''),(175,'tempD1',62,'',0,0,''),(176,'vlD7',62,'датчик влажности',0,0,''),(177,'vlD8',62,'датчик влажности',0,0,''),(178,'vlD9',62,'датчик влажности',0,0,''),(179,'vlD10',62,'датчик влажности',0,0,''),(180,'vlD11',62,'датчик влажности',0,0,''),(181,'vlD12',62,'датчик влажности',0,0,''),(182,'vlD13',62,'датчик влажности',0,0,''),(183,'vlD14',62,'датчик влажности',0,0,''),(184,'vlD15',62,'датчик влажности',0,0,''),(185,'vlD16',62,'датчик влажности',0,0,''),(186,'vlD17',62,'датчик влажности',0,0,''),(187,'vlD18',62,'датчик влажности',0,0,''),(188,'vlD19',62,'датчик влажности',0,0,''),(189,'vlD20',62,'датчик влажности',0,0,''),(190,'tempD30',62,'',0,0,''),(191,'ThisComputer',10,'',0,0,''),(193,'clapan2',63,'',0,0,''),(194,'clapan3',63,'',0,0,''),(195,'clapan4',63,'',0,0,''),(196,'clapan5',63,'',0,0,''),(197,'clapan6',63,'',0,0,''),(198,'clapan7',63,'',0,0,''),(199,'clapan8',63,'',0,0,''),(200,'clapan9',63,'',0,0,''),(201,'clapan10',63,'',0,0,''),(202,'clapan11',63,'',0,0,''),(203,'klap1',63,'',0,0,''),(204,'k2',63,'',0,0,''),(205,'k3',63,'',0,0,''),(206,'k4',63,'',0,0,''),(207,'k5',63,'',0,0,''),(208,'rele1',63,'',0,0,''),(209,'rele2',63,'',0,0,''),(210,'rele3',63,'',0,0,''),(211,'rele4',63,'',0,0,''),(212,'clapan17',63,'',0,0,''),(213,'clapan12',63,'',0,0,''),(214,'clapan13',63,'',0,0,''),(215,'clapan14',63,'',0,0,''),(216,'clapan15',63,'',0,0,''),(217,'clapan16',63,'',0,0,''),(218,'clapan18',63,'',0,0,''),(219,'clapan19',63,'',0,0,''),(220,'clapan20',63,'',0,0,''),(221,'Count1',64,'',0,0,''),(232,'ow_ws',67,'Погодная станция (экспорт)',0,0,''),(231,'ow_setting',67,'Настройки',0,0,''),(230,'ow_city',67,'Местоположение',0,0,''),(254,'ow_day2',67,'Forecast on 3 period(s)',0,0,''),(253,'ow_day1',67,'Forecast on 2 period(s)',0,0,''),(252,'ow_day0',67,'Forecast on 1 period(s)',0,0,''),(244,'TodoList',68,'',0,0,''),(259,'Switch17',26,'',0,0,''),(260,'Switch18',26,'',0,0,''),(261,'Switch19',26,'',0,0,''),(262,'Switch20',26,'',0,0,''),(263,'Switch21',26,'',0,0,''),(264,'Switch22',26,'',0,0,''),(265,'Switch23',26,'',0,0,''),(266,'Switch24',26,'',0,0,''),(267,'Sergey',32,'Сергей',0,0,''),(268,'Irina',32,'Ирина',0,0,''),(269,'Elena',32,'Елена',0,0,''),(270,'exchange_rate',69,'Курс валют',0,0,''),(271,'WLeak1',74,'датчик протечки',0,0,''),(272,'Motion1',72,'датчик движения',0,0,''),(273,'Temp1',71,'датчик температура, влажности и давления',0,0,''),(274,'Temp2',71,'датчик температуры и влажности',0,0,''),(275,'Magnet1',73,'датчик дверей, окон',0,0,''),(276,'Cube1',75,'Магический куб',0,0,''),(277,'Gateway1',50,'RGB',0,0,'sdevice2'),(278,'Rgb01',50,'rgb',0,0,'sdevice1'),(279,'yw_mycity',81,NULL,0,0,''),(280,'moscow',81,' 15:31',0,0,''),(281,'vologda',81,' 19:49',0,0,'');
/*!40000 ALTER TABLE `objects` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `operations_queue`
--

DROP TABLE IF EXISTS `operations_queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `operations_queue` (
  `TOPIC` char(255) NOT NULL,
  `DATANAME` char(255) NOT NULL,
  `DATAVALUE` char(255) NOT NULL,
  `EXPIRE` datetime NOT NULL
) ENGINE=MEMORY DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `operations_queue`
--

LOCK TABLES `operations_queue` WRITE;
/*!40000 ALTER TABLE `operations_queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `operations_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `optimizerdata`
--

DROP TABLE IF EXISTS `optimizerdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `optimizerdata` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `CLASS_NAME` varchar(255) NOT NULL DEFAULT '',
  `OBJECT_NAME` varchar(255) NOT NULL DEFAULT '',
  `PROPERTY_NAME` varchar(255) NOT NULL DEFAULT '',
  `KEEP` varchar(255) NOT NULL DEFAULT '',
  `OPTIMIZE` varchar(255) NOT NULL DEFAULT '',
  `LOG` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `optimizerdata`
--

LOCK TABLES `optimizerdata` WRITE;
/*!40000 ALTER TABLE `optimizerdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `optimizerdata` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `owdevices`
--

DROP TABLE IF EXISTS `owdevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `owdevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `UDID` varchar(255) NOT NULL DEFAULT '',
  `STATUS` int(3) NOT NULL DEFAULT '0',
  `CHECK_LATEST` datetime DEFAULT NULL,
  `CHECK_NEXT` datetime DEFAULT NULL,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `CODE` text,
  `ONLINE_INTERVAL` int(10) NOT NULL DEFAULT '0',
  `LOG` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `owdevices`
--

LOCK TABLES `owdevices` WRITE;
/*!40000 ALTER TABLE `owdevices` DISABLE KEYS */;
/*!40000 ALTER TABLE `owdevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `owdisplays`
--

DROP TABLE IF EXISTS `owdisplays`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `owdisplays` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `UDID` int(10) unsigned NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `ROWS` int(3) unsigned NOT NULL DEFAULT '0',
  `COLS` int(3) unsigned NOT NULL DEFAULT '0',
  `UPDATE_INTERVAL` int(10) unsigned NOT NULL DEFAULT '0',
  `VALUE` text,
  `UPDATE_LATEST` int(10) unsigned NOT NULL DEFAULT '0',
  `UPDATE_NEXT` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `owdisplays`
--

LOCK TABLES `owdisplays` WRITE;
/*!40000 ALTER TABLE `owdisplays` DISABLE KEYS */;
/*!40000 ALTER TABLE `owdisplays` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `owproperties`
--

DROP TABLE IF EXISTS `owproperties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `owproperties` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `DEVICE_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `SYSNAME` varchar(255) NOT NULL DEFAULT '',
  `PATH` varchar(255) NOT NULL DEFAULT '',
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `CHECK_LATEST` datetime DEFAULT NULL,
  `UPDATED` datetime DEFAULT NULL,
  `STARRED` int(3) unsigned NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=71 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `owproperties`
--

LOCK TABLES `owproperties` WRITE;
/*!40000 ALTER TABLE `owproperties` DISABLE KEYS */;
/*!40000 ALTER TABLE `owproperties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `patterns`
--

DROP TABLE IF EXISTS `patterns`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `patterns` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PATTERN` text,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `SCRIPT` text,
  `LOG` text,
  `TIME_LIMIT` int(245) NOT NULL DEFAULT '0',
  `EXECUTED` int(10) NOT NULL DEFAULT '0',
  `IS_CONTEXT` int(3) NOT NULL DEFAULT '0',
  `IS_COMMON_CONTEXT` int(3) NOT NULL DEFAULT '0',
  `MATCHED_CONTEXT_ID` int(10) NOT NULL DEFAULT '0',
  `TIMEOUT` int(10) NOT NULL DEFAULT '0',
  `TIMEOUT_CONTEXT_ID` int(10) NOT NULL DEFAULT '0',
  `TIMEOUT_SCRIPT` text,
  `PARENT_ID` int(10) NOT NULL DEFAULT '0',
  `IS_LAST` int(3) NOT NULL DEFAULT '0',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `SCRIPT_EXIT` text,
  `SKIPSYSTEM` int(3) NOT NULL DEFAULT '0',
  `ONETIME` int(3) NOT NULL DEFAULT '0',
  `PATTERN_TYPE` int(3) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CONDITION` int(3) NOT NULL DEFAULT '0',
  `CONDITION_VALUE` varchar(255) NOT NULL DEFAULT '',
  `LATEST_VALUE` varchar(255) NOT NULL DEFAULT '',
  `ACTIVE_STATE` int(3) NOT NULL DEFAULT '0',
  `USEMORPHY` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `patterns`
--

LOCK TABLES `patterns` WRITE;
/*!40000 ALTER TABLE `patterns` DISABLE KEYS */;
INSERT INTO `patterns` VALUES (9,'(start|play) music','',0,'runScript(\'playFavoriteMusic\');','',0,1409904443,0,0,0,0,0,'',0,0,0,NULL,0,0,0,'','',0,'','',0,0),(8,'report system state','',21,'','2014-09-05 12:07:19 Pattern matched\n',0,1409908039,0,0,0,0,0,'',0,0,0,NULL,0,0,0,'','',0,'','',0,0),(10,'Привет','(П|п)ривет',0,'say (\"Привет! Пообщаемся?\",2);','2019-12-17 11:14:41 Pattern matched\n2019-12-17 10:28:16 Pattern matched\n2019-12-17 10:28:03 Pattern matched\n2019-12-17 10:20:26 Pattern matched\n2019-12-17 10:20:14 Pattern matched\n2018-09-25 10:46:33 Pattern matched\n2018-09-25 10:31:01 Pattern matched\n2018-09-18 23:33:38 Pattern matched\n2018-09-18 23:28:52 Pattern matched\n2018-04-09 22:44:15 Pattern matched\n2018-04-09 22:25:49 Pattern matched\n2018-04-09 21:11:51 Pattern matched\n2018-04-09 21:06:09 Pattern matched\n2018-03-17 23:33:41 Pattern matched\n2018-03-17 22:19:33 Pattern matched\n2018-03-17 22:15:02 Pattern matched\n2018-03-17 22:11:52 Pattern matched\n2018-03-17 21:49:05 Pattern matched\n2018-03-17 21:41:52 Pattern matched\n2018-03-17 21:39:59 Pattern matched\n2018-03-17 21:10:40 Pattern matched\n',0,1576570481,1,0,0,0,0,'',0,0,0,'',0,0,0,'','',0,'','',0,0);
/*!40000 ALTER TABLE `patterns` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `performance_log`
--

DROP TABLE IF EXISTS `performance_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `performance_log` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `OPERATION` varchar(255) NOT NULL DEFAULT '',
  `COUNTER` int(10) NOT NULL DEFAULT '0',
  `TIMEUSED` float NOT NULL DEFAULT '0',
  `SOURCE` char(10) NOT NULL DEFAULT '',
  `ADDED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `performance_log`
--

LOCK TABLES `performance_log` WRITE;
/*!40000 ALTER TABLE `performance_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `performance_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `phistory`
--

DROP TABLE IF EXISTS `phistory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `phistory` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `VALUE_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `ADDED` datetime DEFAULT NULL,
  `VALUE` varchar(255) NOT NULL,
  `SOURCE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `VALUE_ID` (`VALUE_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=12709 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `phistory`
--

LOCK TABLES `phistory` WRITE;
/*!40000 ALTER TABLE `phistory` DISABLE KEYS */;
INSERT INTO `phistory` VALUES (905,1535,'2018-01-12 22:00:02','-13',''),(904,1517,'2018-01-13 02:00:02','-10',''),(903,1499,'2018-01-12 22:00:02','-18',''),(902,1480,'2018-01-12 22:00:02','-9',''),(901,1461,'2018-01-13 02:00:02','-8',''),(900,1442,'2018-01-13 04:00:01','-10',''),(899,1423,'2018-01-12 22:00:01','-7',''),(898,740,'2018-01-12 22:00:01','-7',''),(897,1535,'2018-01-12 21:00:02','-13',''),(892,1442,'2018-01-12 21:00:01','-10',''),(893,1461,'2018-01-12 21:00:01','-8',''),(894,1480,'2018-01-12 21:00:02','-9',''),(895,1499,'2018-01-12 21:00:02','-18',''),(896,1517,'2018-01-12 21:00:02','-10',''),(891,1423,'2018-01-12 21:00:01','-7',''),(890,740,'2018-01-12 21:00:00','-7',''),(906,740,'2018-01-13 01:00:01','-8',''),(907,1423,'2018-01-13 01:00:01','-9',''),(908,1480,'2018-01-13 01:00:02','-10',''),(909,1499,'2018-01-13 01:00:02','-15',''),(910,1535,'2018-01-13 01:00:02','-10',''),(911,740,'2018-01-13 02:00:01','-8',''),(912,1423,'2018-01-13 02:00:01','-8',''),(913,1480,'2018-01-13 02:00:02','-10',''),(914,1499,'2018-01-13 05:00:02','-15',''),(915,1535,'2018-01-13 05:00:02','-10',''),(916,740,'2018-01-13 04:00:01','-9',''),(917,1423,'2018-01-13 04:00:01','-9',''),(918,1461,'2018-01-13 04:00:02','-10',''),(919,1480,'2018-01-13 04:00:02','-8',''),(920,1517,'2018-01-13 04:00:02','-14',''),(921,740,'2018-01-13 08:00:01','-9',''),(922,1423,'2018-01-13 05:00:01','-14',''),(923,1442,'2018-01-13 05:00:01','-9',''),(924,1461,'2018-01-13 05:00:01','-10',''),(925,1480,'2018-01-13 05:00:02','-8',''),(926,1517,'2018-01-13 05:00:02','-14',''),(927,1423,'2018-01-13 07:00:01','-9',''),(928,1442,'2018-01-13 07:00:01','-10',''),(929,1461,'2018-01-13 07:00:01','-8',''),(930,1480,'2018-01-13 07:00:02','-15',''),(931,1499,'2018-01-13 07:00:02','-14',''),(932,1517,'2018-01-13 07:00:02','-10',''),(933,1535,'2018-01-13 07:00:02','-11',''),(934,1423,'2018-01-13 08:00:01','-9',''),(935,1442,'2018-01-13 08:00:01','-10',''),(936,1461,'2018-01-13 08:00:01','-8',''),(937,1480,'2018-01-13 08:00:02','-15',''),(938,1499,'2018-01-13 08:00:02','-14',''),(939,1517,'2018-01-13 08:00:02','-10',''),(940,1535,'2018-01-13 08:00:02','-11',''),(945,1822,'2018-03-09 15:00:03','-7.1',''),(946,1831,'2018-03-09 15:00:04','2.52',''),(947,1832,'2018-03-09 15:00:04','86',''),(948,1834,'2018-03-09 15:00:04','762.57',''),(949,1847,'2018-03-09 15:00:04','-9.8',''),(950,1856,'2018-03-09 15:00:04','4.33',''),(951,1857,'2018-03-09 15:00:04','84',''),(952,1859,'2018-03-09 15:00:04','763.9',''),(953,1872,'2018-03-09 15:00:04','-11.1',''),(954,1881,'2018-03-09 15:00:04','4.93',''),(955,1882,'2018-03-09 15:00:04','87',''),(956,1884,'2018-03-09 15:00:04','764.56',''),(957,1897,'2018-03-09 15:00:04','-9.1',''),(958,1906,'2018-03-09 15:00:04','4.96',''),(959,1907,'2018-03-09 15:00:04','90',''),(960,1909,'2018-03-09 15:00:04','765.34',''),(961,1922,'2018-03-09 15:00:04','-10.3',''),(962,1931,'2018-03-09 15:00:04','5.96',''),(963,1933,'2018-03-09 15:00:04','763.12',''),(964,1946,'2018-03-09 15:00:05','-5.7',''),(965,1955,'2018-03-09 15:00:05','6.59',''),(966,1957,'2018-03-09 15:00:05','758.4',''),(967,1970,'2018-03-09 15:00:05','3.9',''),(968,1979,'2018-03-09 15:00:05','3.71',''),(969,1981,'2018-03-09 15:00:05','756.08',''),(9403,1613,'2020-01-18 10:00:00','766',''),(974,1822,'2018-03-09 16:00:26','-7.1',''),(975,1831,'2018-03-09 16:00:26','2.52',''),(976,1832,'2018-03-09 16:00:26','86',''),(977,1834,'2018-03-09 16:00:26','762.57',''),(978,1847,'2018-03-09 16:00:26','-9.8',''),(979,1856,'2018-03-10 05:00:15','4.33',''),(980,1857,'2018-03-10 05:00:15','84',''),(981,1859,'2018-03-10 05:00:15','763.9',''),(982,1872,'2018-03-09 16:00:26','-11.1',''),(983,1881,'2018-03-10 05:00:15','4.93',''),(984,1882,'2018-03-10 05:00:15','87',''),(985,1884,'2018-03-10 05:00:15','764.56',''),(986,1897,'2018-03-09 16:00:26','-9.1',''),(987,1906,'2018-03-10 05:00:15','4.96',''),(988,1907,'2018-03-10 05:00:15','90',''),(989,1909,'2018-03-10 05:00:15','765.34',''),(990,1922,'2018-03-09 16:00:26','-10.3',''),(991,1931,'2018-03-09 23:00:03','5.96',''),(992,1933,'2018-03-09 23:00:03','763.12',''),(993,1946,'2018-03-09 16:00:26','-5.7',''),(994,1955,'2018-03-09 23:00:03','6.59',''),(995,1957,'2018-03-09 23:00:03','758.4',''),(996,1970,'2018-03-09 16:00:27','3.9',''),(997,1979,'2018-03-09 23:00:04','3.71',''),(998,1981,'2018-03-09 23:00:04','756.08',''),(9405,1613,'2020-01-18 11:00:01','765',''),(1007,1822,'2018-03-09 20:00:04','-14',''),(1008,1831,'2018-03-09 20:00:04','3.05',''),(1009,1832,'2018-03-09 20:00:04','74',''),(1010,1834,'2018-03-09 20:00:05','762.6',''),(1011,1847,'2018-03-09 20:00:05','-10',''),(1012,1872,'2018-03-09 20:00:05','-10.3',''),(1013,1897,'2018-03-09 20:00:05','-8.4',''),(1014,1922,'2018-03-09 20:00:05','-11.2',''),(1015,1946,'2018-03-09 20:00:05','-4.8',''),(1016,1970,'2018-03-09 20:00:06','2',''),(9503,1611,'2020-01-18 19:00:01','93',''),(1021,1822,'2018-03-09 22:00:03','-14',''),(1022,1831,'2018-03-09 22:00:04','3.66',''),(1023,1832,'2018-03-09 22:00:04','79',''),(1024,1834,'2018-03-09 22:00:04','763.06',''),(1025,1847,'2018-03-09 23:00:02','-10',''),(1026,1872,'2018-03-09 23:00:03','-10.3',''),(1027,1897,'2018-03-09 23:00:03','-8.4',''),(1028,1922,'2018-03-09 23:00:03','-11.2',''),(1029,1946,'2018-03-09 23:00:03','-4.8',''),(1030,1970,'2018-03-09 23:00:03','2',''),(9424,1613,'2020-01-18 16:00:01','765',''),(1035,1822,'2018-03-09 23:00:02','-17.3',''),(1036,1831,'2018-03-09 23:00:02','3.66',''),(1037,1832,'2018-03-09 23:00:02','79',''),(1038,1834,'2018-03-09 23:00:02','763.06',''),(9425,2020,'2020-01-18 14:00:01','3',''),(1043,1822,'2018-03-10 01:00:18','-17.3',''),(1044,1831,'2018-03-10 01:00:18','2.03',''),(1045,1832,'2018-03-10 01:00:18','62',''),(1046,1834,'2018-03-10 01:00:18','763.29',''),(1047,1847,'2018-03-10 01:00:18','-13.1',''),(1048,1872,'2018-03-10 01:00:19','-12.5',''),(1049,1897,'2018-03-10 01:00:19','-8.6',''),(1050,1922,'2018-03-10 01:00:19','-6',''),(1051,1931,'2018-03-10 01:00:19','8.21',''),(1052,1933,'2018-03-10 01:00:19','762.04',''),(1053,1946,'2018-03-10 01:00:19','-2.1',''),(1054,1955,'2018-03-10 01:00:19','8.23',''),(1055,1957,'2018-03-10 01:00:19','758.51',''),(1056,1970,'2018-03-10 01:00:19','-2.3',''),(1057,1979,'2018-03-10 01:00:19','5.75',''),(1058,1981,'2018-03-10 01:00:19','760.83',''),(9428,2047,'2020-01-19 10:00:07','5',''),(1063,1822,'2018-03-10 02:00:01','-16.8',''),(1064,1831,'2018-03-10 02:00:01','2.03',''),(1065,1832,'2018-03-10 02:00:01','62',''),(1066,1834,'2018-03-10 02:00:01','763.29',''),(1067,1847,'2018-03-10 02:00:01','-13.1',''),(1068,1872,'2018-03-10 02:00:02','-12.5',''),(1069,1897,'2018-03-10 02:00:02','-8.6',''),(1070,1922,'2018-03-10 02:00:02','-6',''),(1071,1931,'2018-03-10 05:00:15','8.21',''),(1072,1933,'2018-03-10 05:00:15','762.04',''),(1073,1946,'2018-03-10 02:00:02','-2.1',''),(1074,1955,'2018-03-10 05:00:16','8.23',''),(1075,1957,'2018-03-10 05:00:16','758.51',''),(1076,1970,'2018-03-10 02:00:02','-2.3',''),(1077,1979,'2018-03-10 05:00:16','5.75',''),(1078,1981,'2018-03-10 05:00:16','760.83',''),(9475,1610,'2020-01-18 17:00:02','4',''),(1083,1822,'2018-03-10 04:00:01','-15.9',''),(1084,1831,'2018-03-10 04:00:01','4.23',''),(1085,1834,'2018-03-10 04:00:01','762.39',''),(1086,1847,'2018-03-10 04:00:02','-16.6',''),(1087,1872,'2018-03-10 04:00:02','-15.2',''),(1088,1897,'2018-03-10 04:00:02','-11.8',''),(1089,1922,'2018-03-10 04:00:02','-9.7',''),(1090,1946,'2018-03-10 04:00:02','-4.7',''),(1091,1970,'2018-03-10 04:00:03','-2.1',''),(9483,2074,'2020-01-18 23:00:02','5',''),(1096,1822,'2018-03-10 05:00:15','-15.9',''),(1097,1831,'2018-03-10 05:00:15','4.23',''),(1098,1834,'2018-03-10 05:00:15','762.39',''),(1099,1847,'2018-03-10 05:00:15','-16.5',''),(1100,1872,'2018-03-10 05:00:15','-15.2',''),(1101,1897,'2018-03-10 05:00:15','-11.8',''),(1102,1922,'2018-03-10 05:00:15','-9.7',''),(1103,1946,'2018-03-10 05:00:16','-4.7',''),(1104,1970,'2018-03-10 05:00:16','-2.1',''),(9430,2077,'2020-01-18 14:00:01','763',''),(1109,1822,'2018-03-10 07:00:09','-16.6',''),(1110,1831,'2018-03-10 07:00:09','4.33',''),(1111,1832,'2018-03-10 07:00:09','84',''),(1112,1834,'2018-03-10 07:00:09','763.9',''),(1113,1847,'2018-03-10 07:00:09','-15.2',''),(1114,1856,'2018-03-10 07:00:09','4.93',''),(1115,1857,'2018-03-10 07:00:09','87',''),(1116,1859,'2018-03-10 07:00:09','764.56',''),(1117,1872,'2018-03-10 07:00:09','-11.8',''),(1118,1881,'2018-03-10 07:00:10','4.96',''),(1119,1882,'2018-03-10 07:00:10','90',''),(1120,1884,'2018-03-10 07:00:10','765.34',''),(1121,1897,'2018-03-10 07:00:10','-9.7',''),(1122,1906,'2018-03-10 07:00:10','8.21',''),(1123,1909,'2018-03-10 07:00:10','762.04',''),(1124,1922,'2018-03-10 07:00:10','-4.7',''),(1125,1931,'2018-03-10 07:00:10','8.23',''),(1126,1933,'2018-03-10 07:00:10','758.51',''),(1127,1946,'2018-03-10 07:00:10','-2.1',''),(1128,1955,'2018-03-10 07:00:10','5.75',''),(1129,1957,'2018-03-10 07:00:10','760.83',''),(1130,1970,'2018-03-10 07:00:10','-3.2',''),(1131,1979,'2018-03-10 07:00:10','5.1',''),(1132,1981,'2018-03-10 07:00:10','762.69',''),(9415,2382,'2020-01-18 11:00:02','86',''),(1137,1822,'2018-03-10 08:00:08','-14.6',''),(1138,1831,'2018-03-10 11:00:01','4.33',''),(1139,1832,'2018-03-10 11:00:02','84',''),(1140,1834,'2018-03-10 11:00:02','763.9',''),(1141,1847,'2018-03-10 11:00:02','-15.2',''),(1142,1856,'2018-03-10 11:00:02','4.93',''),(1143,1857,'2018-03-11 05:00:09','87',''),(1144,1859,'2018-03-10 11:00:02','764.56',''),(1145,1872,'2018-03-10 11:00:02','-11.8',''),(1146,1881,'2018-03-10 11:00:02','4.96',''),(1147,1882,'2018-03-10 11:00:02','90',''),(1148,1884,'2018-03-10 11:00:02','765.34',''),(1149,1897,'2018-03-10 11:00:02','-9.7',''),(1150,1906,'2018-03-10 11:00:02','8.21',''),(1151,1909,'2018-03-10 11:00:02','762.04',''),(1152,1922,'2018-03-10 11:00:02','-4.7',''),(1153,1931,'2018-03-10 23:00:09','8.23',''),(1154,1933,'2018-03-10 23:00:09','758.51',''),(1155,1946,'2018-03-10 11:00:03','-2.1',''),(1156,1955,'2018-03-10 23:00:09','5.75',''),(1157,1957,'2018-03-10 23:00:09','760.83',''),(1158,1970,'2018-03-10 11:00:03','-3.2',''),(1159,1979,'2018-03-10 23:00:09','5.1',''),(1160,1981,'2018-03-10 23:00:09','762.69',''),(9463,2128,'2020-01-18 16:00:02','8',''),(9524,2117,'2020-01-18 22:00:16','-4',''),(1169,1822,'2018-03-10 11:00:01','-9.8',''),(9434,2104,'2020-01-18 14:00:01','748',''),(1174,1822,'2018-03-10 13:00:03','-8.2',''),(1175,1831,'2018-03-10 13:00:04','3.9',''),(1176,1832,'2018-03-10 13:00:04','79',''),(1177,1834,'2018-03-10 13:00:04','763.33',''),(1178,1847,'2018-03-10 13:00:04','-10.2',''),(1179,1856,'2018-03-10 13:00:04','5',''),(1180,1859,'2018-03-10 13:00:04','764.71',''),(1181,1872,'2018-03-10 13:00:04','-6.2',''),(1182,1881,'2018-03-10 13:00:04','4.49',''),(1183,1882,'2018-03-10 13:00:04','94',''),(1184,1884,'2018-03-10 13:00:04','764.08',''),(1185,1897,'2018-03-10 13:00:04','-3',''),(1186,1906,'2018-03-10 13:00:04','8',''),(1187,1907,'2018-03-10 13:00:04','89',''),(1188,1909,'2018-03-10 13:00:04','757.69',''),(1189,1922,'2018-03-10 13:00:04','-3.4',''),(1190,1946,'2018-03-10 13:00:05','-0.7',''),(1191,1970,'2018-03-10 13:00:05','-2.4',''),(9435,2382,'2020-01-18 14:00:02','86',''),(1196,1822,'2018-03-10 14:00:03','-6.3',''),(1197,1831,'2018-03-10 14:00:03','3.9',''),(1198,1832,'2018-03-10 14:00:03','79',''),(1199,1834,'2018-03-10 14:00:03','763.33',''),(1200,1847,'2018-03-10 17:00:01','-10.2',''),(1201,1856,'2018-03-11 05:00:09','5',''),(1202,1859,'2018-03-11 05:00:09','764.71',''),(1203,1872,'2018-03-10 17:00:01','-6.2',''),(1204,1881,'2018-03-11 05:00:09','4.49',''),(1205,1882,'2018-03-11 05:00:09','94',''),(1206,1884,'2018-03-11 05:00:09','764.08',''),(1207,1897,'2018-03-10 17:00:02','-3',''),(1208,1906,'2018-03-11 05:00:09','8',''),(1209,1907,'2018-03-11 05:00:09','89',''),(1210,1909,'2018-03-11 05:00:09','757.69',''),(1211,1922,'2018-03-10 17:00:02','-3.4',''),(1212,1946,'2018-03-10 17:00:02','-0.7',''),(1213,1970,'2018-03-10 17:00:02','-2.4',''),(9437,2383,'2020-01-18 14:00:02','75',''),(1218,1822,'2018-03-10 16:00:06','-6.3',''),(1219,1831,'2018-03-10 16:00:06','3.92',''),(1220,1832,'2018-03-10 16:00:06','85',''),(1221,1834,'2018-03-10 16:00:06','763.3',''),(9433,2102,'2020-01-18 14:00:01','96',''),(1226,1822,'2018-03-10 17:00:01','-8.7',''),(1227,1831,'2018-03-10 17:00:01','3.92',''),(1228,1832,'2018-03-10 17:00:01','85',''),(1229,1834,'2018-03-10 17:00:01','763.3',''),(9438,2156,'2020-01-18 14:00:02','748',''),(1234,1822,'2018-03-10 19:00:04','-8.7',''),(1235,1831,'2018-03-10 19:00:04','4.46',''),(1236,1832,'2018-03-10 19:00:04','82',''),(1237,1834,'2018-03-10 19:00:04','763.35',''),(1238,1847,'2018-03-10 19:00:04','-9.5',''),(1239,1872,'2018-03-10 19:00:05','-4.6',''),(1240,1897,'2018-03-10 19:00:05','-2.8',''),(1241,1922,'2018-03-10 19:00:05','-2.6',''),(1242,1946,'2018-03-10 19:00:05','-2.3',''),(1243,1970,'2018-03-10 19:00:05','-5.2',''),(9487,2101,'2020-01-19 02:00:01','7',''),(1248,1822,'2018-03-10 20:00:08','-11',''),(1249,1831,'2018-03-10 20:00:08','4.46',''),(1250,1832,'2018-03-10 20:00:08','82',''),(1251,1834,'2018-03-10 20:00:08','763.35',''),(1252,1847,'2018-03-10 23:00:08','-9.5',''),(1253,1872,'2018-03-10 23:00:09','-4.6',''),(1254,1897,'2018-03-10 23:00:09','-2.8',''),(1255,1922,'2018-03-10 23:00:09','-2.6',''),(1256,1946,'2018-03-10 23:00:09','-2.3',''),(1257,1970,'2018-03-10 23:00:09','-5.2',''),(9492,2130,'2020-01-18 23:00:02','743',''),(1262,1822,'2018-03-10 22:00:05','-11',''),(1263,1831,'2018-03-10 22:00:06','4.72',''),(1264,1832,'2018-03-10 22:00:06','80',''),(1265,1834,'2018-03-10 22:00:06','763.82',''),(9495,2383,'2020-01-18 22:00:17','78',''),(1269,1822,'2018-03-10 23:00:08','-13',''),(1270,1831,'2018-03-10 23:00:08','4.72',''),(1271,1832,'2018-03-11 02:00:06','80',''),(1272,1834,'2018-03-10 23:00:08','763.82',''),(9442,2182,'2020-01-18 14:00:02','761',''),(1276,1822,'2018-03-11 01:00:09','-13',''),(1277,1831,'2018-03-11 01:00:09','4.12',''),(1278,1834,'2018-03-11 01:00:09','764.1',''),(1279,1847,'2018-03-11 01:00:09','-10.1',''),(1280,1872,'2018-03-11 01:00:09','-6.3',''),(1281,1897,'2018-03-11 01:00:09','-2.4',''),(1282,1922,'2018-03-11 01:00:10','-5.2',''),(1283,1931,'2018-03-11 01:00:10','6.95',''),(1284,1933,'2018-03-11 01:00:10','753.75',''),(1285,1946,'2018-03-11 01:00:10','-5.4',''),(1286,1955,'2018-03-11 01:00:10','2.76',''),(1287,1957,'2018-03-11 01:00:10','753.54',''),(1288,1970,'2018-03-11 01:00:10','-8.5',''),(1289,1979,'2018-03-11 01:00:10','5.54',''),(1290,1981,'2018-03-11 01:00:10','756.9',''),(9498,2180,'2020-01-18 22:00:17','5',''),(1295,1822,'2018-03-11 02:00:05','-14.6',''),(1296,1831,'2018-03-11 02:00:06','4.12',''),(1297,1834,'2018-03-11 02:00:06','764.1',''),(1298,1847,'2018-03-11 02:00:06','-10.1',''),(1299,1872,'2018-03-11 02:00:06','-6.3',''),(1300,1897,'2018-03-11 02:00:06','-2.4',''),(1301,1922,'2018-03-11 02:00:06','-5.2',''),(1302,1931,'2018-03-11 05:00:09','6.95',''),(1303,1933,'2018-03-11 05:00:09','753.75',''),(1304,1946,'2018-03-11 02:00:06','-5.4',''),(1305,1955,'2018-03-11 05:00:09','2.76',''),(1306,1957,'2018-03-11 05:00:09','753.54',''),(1307,1970,'2018-03-11 02:00:07','-8.5',''),(1308,1979,'2018-03-11 05:00:09','5.54',''),(1309,1981,'2018-03-11 05:00:09','756.9',''),(9402,1611,'2020-01-18 10:00:00','97',''),(1314,1822,'2018-03-11 04:00:04','-13.8',''),(1315,1831,'2018-03-11 04:00:04','5.29',''),(1316,1834,'2018-03-11 04:00:04','764.16',''),(1317,1847,'2018-03-11 04:00:04','-15.3',''),(1318,1872,'2018-03-11 04:00:04','-9.5',''),(1319,1897,'2018-03-11 04:00:04','-4.1',''),(1320,1922,'2018-03-11 04:00:05','-2.4',''),(1321,1946,'2018-03-11 04:00:05','-5.3',''),(1322,1970,'2018-03-11 04:00:05','-5.2',''),(9404,1611,'2020-01-18 11:00:01','94',''),(1327,1822,'2018-03-11 05:00:08','-13.8',''),(1328,1831,'2018-03-11 05:00:08','5.29',''),(1329,1834,'2018-03-11 05:00:08','764.16',''),(1330,1847,'2018-03-11 05:00:09','-15.9',''),(1331,1872,'2018-03-11 05:00:09','-9.5',''),(1332,1897,'2018-03-11 05:00:09','-4.1',''),(1333,1922,'2018-03-11 05:00:09','-2.4',''),(1334,1946,'2018-03-11 05:00:09','-5.3',''),(1335,1970,'2018-03-11 05:00:09','-5.2',''),(9407,2021,'2020-01-18 11:00:02','94',''),(1340,1822,'2018-03-11 07:00:07','-15.3',''),(1341,1831,'2018-03-11 07:00:07','5',''),(1342,1832,'2018-03-11 07:00:07','87',''),(1343,1834,'2018-03-11 07:00:07','764.71',''),(1344,1847,'2018-03-11 07:00:07','-9.5',''),(1345,1856,'2018-03-11 07:00:07','4.49',''),(1346,1857,'2018-03-11 07:00:07','94',''),(1347,1859,'2018-03-11 07:00:07','764.08',''),(1348,1872,'2018-03-11 07:00:07','-4.1',''),(1349,1881,'2018-03-11 07:00:07','8',''),(1350,1882,'2018-03-11 07:00:07','89',''),(1351,1884,'2018-03-11 07:00:07','757.69',''),(1352,1897,'2018-03-11 07:00:08','-2.4',''),(1353,1906,'2018-03-11 07:00:08','6.95',''),(1354,1909,'2018-03-11 07:00:08','753.75',''),(1355,1922,'2018-03-11 07:00:08','-5.3',''),(1356,1931,'2018-03-11 07:00:08','2.76',''),(1357,1933,'2018-03-11 07:00:08','753.54',''),(1358,1946,'2018-03-11 07:00:08','-5.2',''),(1359,1955,'2018-03-11 07:00:08','5.54',''),(1360,1957,'2018-03-11 07:00:08','756.9',''),(1361,1970,'2018-03-11 07:00:08','-8.7',''),(1362,1979,'2018-03-11 07:00:08','4.35',''),(1363,1981,'2018-03-11 07:00:08','764.04',''),(9502,1610,'2020-01-18 19:00:01','4',''),(1368,1822,'2018-03-11 08:00:07','-13.8',''),(1369,1831,'2018-03-11 10:00:03','5',''),(1370,1832,'2018-03-11 10:00:03','87',''),(1371,1834,'2018-03-11 10:00:03','764.71',''),(1372,1847,'2018-03-11 10:00:03','-9.5',''),(1373,1856,'2018-03-11 10:00:03','4.49',''),(1374,1857,'2018-03-11 10:00:03','94',''),(1375,1859,'2018-03-11 10:00:03','764.08',''),(1376,1872,'2018-03-11 10:00:03','-4.1',''),(1377,1881,'2018-03-11 10:00:03','8',''),(1378,1882,'2018-03-11 10:00:03','89',''),(1379,1884,'2018-03-11 10:00:03','757.69',''),(1380,1897,'2018-03-11 10:00:03','-2.4',''),(1381,1906,'2018-03-11 10:00:03','6.95',''),(1382,1909,'2018-03-11 10:00:04','753.75',''),(1383,1922,'2018-03-11 10:00:04','-5.3',''),(1384,1931,'2018-03-11 23:00:03','2.76',''),(1385,1933,'2018-03-11 23:00:03','753.54',''),(1386,1946,'2018-03-11 10:00:04','-5.2',''),(1387,1955,'2018-03-11 23:00:03','5.54',''),(1388,1957,'2018-03-11 23:00:03','756.9',''),(1389,1970,'2018-03-11 10:00:04','-8.7',''),(1390,1979,'2018-03-11 23:00:03','4.35',''),(1391,1981,'2018-03-11 23:00:03','764.04',''),(9401,1610,'2020-01-18 13:00:00','3',''),(1396,1822,'2018-03-11 10:00:03','-13.8',''),(9399,1611,'2020-01-18 08:00:00','97',''),(9501,1605,'2020-01-18 19:00:01','-1',''),(1405,1822,'2018-03-11 13:00:03','-7.4',''),(1406,1831,'2018-03-11 13:00:03','4.3',''),(1407,1832,'2018-03-11 13:00:04','84',''),(1408,1834,'2018-03-11 13:00:04','763.89',''),(1409,1847,'2018-03-11 13:00:04','-4.4',''),(1410,1856,'2018-03-11 13:00:04','4.21',''),(1411,1857,'2018-03-11 13:00:04','96',''),(1412,1859,'2018-03-11 13:00:04','761.9',''),(1413,1872,'2018-03-11 13:00:04','0.5',''),(1414,1881,'2018-03-11 13:00:04','7.93',''),(1415,1882,'2018-03-11 13:00:04','93',''),(1416,1884,'2018-03-11 13:00:04','753.15',''),(1417,1897,'2018-03-11 13:00:04','0.6',''),(1418,1906,'2018-03-11 13:00:04','9.46',''),(1419,1907,'2018-03-11 13:00:04','95',''),(1420,1909,'2018-03-11 13:00:04','747.52',''),(1421,1922,'2018-03-11 13:00:04','-3.4',''),(1422,1946,'2018-03-11 13:00:04','-3.3',''),(1423,1970,'2018-03-11 13:00:05','-7.1',''),(9423,1611,'2020-01-18 13:00:00','94',''),(1428,1822,'2018-03-11 14:00:05','-6',''),(1429,1831,'2018-03-11 14:00:05','4.3',''),(1430,1832,'2018-03-11 14:00:05','84',''),(1431,1834,'2018-03-11 14:00:05','763.89',''),(1432,1847,'2018-03-11 17:00:10','-4.4',''),(1433,1856,'2018-03-12 05:00:11','4.21',''),(1434,1857,'2018-03-12 05:00:11','96',''),(1435,1859,'2018-03-12 05:00:11','761.9',''),(1436,1872,'2018-03-11 17:00:11','0.5',''),(1437,1881,'2018-03-12 05:00:12','7.93',''),(1438,1882,'2018-03-12 05:00:12','93',''),(1439,1884,'2018-03-12 05:00:12','753.15',''),(1440,1897,'2018-03-11 17:00:11','0.6',''),(1441,1906,'2018-03-12 05:00:12','9.46',''),(1442,1907,'2018-03-12 05:00:12','95',''),(1443,1909,'2018-03-12 05:00:12','747.52',''),(1444,1922,'2018-03-11 17:00:11','-3.4',''),(1445,1946,'2018-03-11 17:00:11','-3.3',''),(1446,1970,'2018-03-11 17:00:11','-7.1',''),(9421,2384,'2020-01-18 11:00:03','83',''),(1451,1822,'2018-03-11 16:00:02','-6',''),(1452,1831,'2018-03-11 16:00:02','4.59',''),(1453,1832,'2018-03-11 16:00:02','83',''),(1454,1834,'2018-03-11 16:00:02','763.81',''),(9420,2180,'2020-01-18 11:00:03','4',''),(1459,1822,'2018-03-11 17:00:10','-8.1',''),(1460,1831,'2018-03-11 17:00:10','4.59',''),(1461,1832,'2018-03-11 17:00:10','83',''),(1462,1834,'2018-03-11 17:00:10','763.81',''),(9373,2182,'2020-01-18 04:00:02','758',''),(1467,1822,'2018-03-11 19:00:04','-8.1',''),(1468,1831,'2018-03-11 19:00:04','4.66',''),(1469,1832,'2018-03-11 19:00:04','78',''),(1470,1834,'2018-03-11 19:00:04','763.44',''),(1471,1847,'2018-03-11 19:00:04','-4.2',''),(1472,1872,'2018-03-11 19:00:05','1.8',''),(1473,1897,'2018-03-11 19:00:05','2.2',''),(1474,1922,'2018-03-11 19:00:05','-4.8',''),(1475,1946,'2018-03-11 19:00:05','-6',''),(1476,1970,'2018-03-11 19:00:05','-11.4',''),(9427,2036,'2020-01-18 17:00:02','0',''),(9544,2383,'2020-01-18 23:00:02','74',''),(1485,1822,'2018-03-11 22:00:08','-9',''),(1486,1831,'2018-03-11 22:00:08','5.05',''),(1487,1832,'2018-03-11 22:00:08','84',''),(1488,1834,'2018-03-11 22:00:08','763.4',''),(1489,1847,'2018-03-11 23:00:02','-4.2',''),(1490,1872,'2018-03-11 23:00:03','1.8',''),(1491,1897,'2018-03-11 23:00:03','2.2',''),(1492,1922,'2018-03-11 23:00:03','-4.8',''),(1493,1946,'2018-03-11 23:00:03','-6',''),(1494,1970,'2018-03-11 23:00:03','-11.4',''),(9374,1611,'2020-01-18 05:00:01','96',''),(1498,1822,'2018-03-11 23:00:02','-8.9',''),(1499,1831,'2018-03-11 23:00:02','5.05',''),(1500,1832,'2018-03-12 01:00:03','84',''),(1501,1834,'2018-03-11 23:00:02','763.4',''),(9476,1611,'2020-01-18 17:00:02','93',''),(1505,1822,'2018-03-12 01:00:03','-8.9',''),(1506,1831,'2018-03-12 01:00:03','4.81',''),(1507,1834,'2018-03-12 01:00:03','762.94',''),(1508,1847,'2018-03-12 01:00:03','-5.4',''),(1509,1872,'2018-03-12 01:00:03','1',''),(1510,1897,'2018-03-12 01:00:03','2.1',''),(1511,1922,'2018-03-12 01:00:04','1.8',''),(1512,1931,'2018-03-12 01:00:04','5.31',''),(1513,1933,'2018-03-12 01:00:04','745.24',''),(1514,1946,'2018-03-12 01:00:04','1',''),(1515,1955,'2018-03-12 01:00:04','4.42',''),(1516,1957,'2018-03-12 01:00:04','752.08',''),(1517,1970,'2018-03-12 01:00:04','0.8',''),(1518,1979,'2018-03-12 01:00:04','7.95',''),(1519,1981,'2018-03-12 01:00:04','751.68',''),(9429,2075,'2020-01-18 14:00:01','87',''),(9367,2143,'2020-01-18 04:00:02','-8',''),(1532,1822,'2018-03-12 05:00:11','-12.6',''),(1533,1831,'2018-03-12 05:00:11','6.63',''),(1534,1834,'2018-03-12 05:00:11','764.04',''),(1535,1847,'2018-03-12 05:00:11','-7.6',''),(1536,1872,'2018-03-12 05:00:12','-3.7',''),(1537,1897,'2018-03-12 05:00:12','-1.3',''),(1538,1922,'2018-03-12 05:00:12','-2.1',''),(1539,1931,'2018-03-12 05:00:12','5.31',''),(1540,1933,'2018-03-12 05:00:12','745.24',''),(1541,1946,'2018-03-12 05:00:12','0.2',''),(1542,1955,'2018-03-12 05:00:12','4.42',''),(1543,1957,'2018-03-12 05:00:12','752.08',''),(1544,1970,'2018-03-12 05:00:12','1.2',''),(1545,1979,'2018-03-12 05:00:12','7.95',''),(1546,1981,'2018-03-12 05:00:13','751.68',''),(9378,2036,'2020-01-18 10:00:01','-1',''),(1555,1822,'2018-03-12 08:00:07','-6.9',''),(1556,1831,'2018-03-12 08:00:07','4.21',''),(1557,1832,'2018-03-12 08:00:07','96',''),(1558,1834,'2018-03-12 08:00:07','761.9',''),(1559,1847,'2018-03-12 08:00:07','-3.7',''),(1560,1856,'2018-03-12 08:00:07','7.93',''),(1561,1857,'2018-03-12 08:00:07','93',''),(1562,1859,'2018-03-12 08:00:07','753.15',''),(1563,1872,'2018-03-12 08:00:07','-1.3',''),(1564,1881,'2018-03-12 08:00:08','9.46',''),(1565,1882,'2018-03-12 08:00:08','95',''),(1566,1884,'2018-03-12 08:00:08','747.52',''),(1567,1897,'2018-03-12 08:00:08','-2.1',''),(1568,1906,'2018-03-12 08:00:08','5.31',''),(1569,1909,'2018-03-12 08:00:08','745.24',''),(1570,1922,'2018-03-12 08:00:08','0.2',''),(1571,1931,'2018-03-12 08:00:08','4.42',''),(1572,1933,'2018-03-12 08:00:08','752.08',''),(1573,1946,'2018-03-12 08:00:08','1.2',''),(1574,1955,'2018-03-12 08:00:08','7.95',''),(1575,1957,'2018-03-12 08:00:08','751.68',''),(1576,1970,'2018-03-12 08:00:08','0.9',''),(1577,1979,'2018-03-12 08:00:08','5.88',''),(1578,1981,'2018-03-12 08:00:08','750.96',''),(9379,2048,'2020-01-18 14:00:01','91',''),(1587,1822,'2018-03-12 11:00:07','-4.4',''),(1588,1831,'2018-03-12 11:00:07','4.21',''),(1589,1832,'2018-03-12 11:00:07','96',''),(1590,1834,'2018-03-12 11:00:07','761.9',''),(1591,1847,'2018-03-12 11:00:07','-3.7',''),(1592,1856,'2018-03-12 11:00:07','7.93',''),(1593,1857,'2018-03-12 11:00:07','93',''),(1594,1859,'2018-03-12 11:00:07','753.15',''),(1595,1872,'2018-03-12 11:00:08','-1.3',''),(1596,1881,'2018-03-12 11:00:08','9.46',''),(1597,1882,'2018-03-12 11:00:08','95',''),(1598,1884,'2018-03-12 11:00:08','747.52',''),(1599,1897,'2018-03-12 11:00:08','-2.1',''),(1600,1906,'2018-03-12 11:00:08','5.31',''),(1601,1909,'2018-03-12 11:00:08','745.24',''),(1602,1922,'2018-03-12 11:00:08','0.2',''),(1603,1931,'2018-03-12 23:00:09','4.42',''),(1604,1933,'2018-03-12 23:00:09','752.08',''),(1605,1946,'2018-03-12 11:00:08','1.2',''),(1606,1955,'2018-03-12 23:00:10','7.95',''),(1607,1957,'2018-03-12 23:00:10','751.68',''),(1608,1970,'2018-03-12 11:00:08','0.9',''),(1609,1979,'2018-03-12 23:00:10','5.88',''),(1610,1981,'2018-03-12 23:00:10','750.96',''),(9436,2130,'2020-01-18 14:00:02','740',''),(1615,1822,'2018-03-12 13:00:01','-5.2',''),(1616,1831,'2018-03-12 13:00:02','3.21',''),(1617,1832,'2018-03-12 13:00:02','94',''),(1618,1834,'2018-03-12 13:00:02','761.16',''),(1619,1847,'2018-03-12 13:00:02','0.3',''),(1620,1856,'2018-03-12 13:00:02','8.56',''),(1621,1857,'2018-03-12 13:00:02','95',''),(1622,1859,'2018-03-12 13:00:02','753.12',''),(1623,1872,'2018-03-12 13:00:02','-1.6',''),(1624,1881,'2018-03-12 13:00:02','8.97',''),(1625,1882,'2018-03-12 13:00:02','94',''),(1626,1884,'2018-03-12 13:00:02','749.66',''),(1627,1897,'2018-03-12 13:00:02','-2.9',''),(1628,1906,'2018-03-12 13:00:02','3.86',''),(1629,1907,'2018-03-12 13:00:02','87',''),(1630,1909,'2018-03-12 13:00:02','747.66',''),(1631,1922,'2018-03-12 13:00:02','-0.1',''),(1632,1946,'2018-03-12 13:00:03','2.1',''),(1633,1970,'2018-03-12 13:00:03','-1.4',''),(9432,2101,'2020-01-18 14:00:01','6',''),(9411,2077,'2020-01-18 11:00:02','763',''),(1642,1822,'2018-03-12 16:00:08','-3',''),(1643,1831,'2018-03-12 16:00:08','3.86',''),(1644,1832,'2018-03-12 16:00:08','90',''),(1645,1834,'2018-03-12 16:00:08','760.94',''),(1646,1847,'2018-03-12 16:00:08','0.3',''),(1647,1856,'2018-03-13 05:00:08','8.56',''),(1648,1857,'2018-03-13 05:00:08','95',''),(1649,1859,'2018-03-13 05:00:08','753.12',''),(1650,1872,'2018-03-12 16:00:08','-1.6',''),(1651,1881,'2018-03-13 05:00:08','8.97',''),(1652,1882,'2018-03-13 05:00:08','94',''),(1653,1884,'2018-03-13 05:00:08','749.66',''),(1654,1897,'2018-03-12 16:00:09','-2.9',''),(1655,1906,'2018-03-13 05:00:09','3.86',''),(1656,1907,'2018-03-13 05:00:09','87',''),(1657,1909,'2018-03-13 05:00:09','747.66',''),(1658,1922,'2018-03-12 16:00:09','-0.1',''),(1659,1946,'2018-03-12 16:00:09','2.1',''),(1660,1970,'2018-03-12 16:00:09','-1.4',''),(9361,2090,'2020-01-18 04:00:01','-0',''),(9456,2074,'2020-01-18 16:00:01','5',''),(9819,2077,'2020-01-20 02:00:19','743',''),(1673,1822,'2018-03-12 20:00:03','-4.4',''),(1674,1831,'2018-03-12 20:00:03','4.16',''),(1675,1832,'2018-03-12 20:00:03','87',''),(1676,1834,'2018-03-12 20:00:03','760.5',''),(1677,1847,'2018-03-12 20:00:03','1.2',''),(1678,1872,'2018-03-12 20:00:04','-1.4',''),(1679,1897,'2018-03-12 20:00:04','-6.2',''),(1680,1922,'2018-03-12 20:00:04','-1',''),(1681,1946,'2018-03-12 20:00:04','1.4',''),(1682,1970,'2018-03-12 20:00:04','-4.2',''),(9358,2063,'2020-01-18 04:00:01','1',''),(1687,1822,'2018-03-12 22:00:10','-4.4',''),(1688,1831,'2018-03-12 22:00:11','5.04',''),(1689,1832,'2018-03-12 22:00:11','88',''),(1690,1834,'2018-03-12 22:00:11','759.93',''),(1691,1847,'2018-03-12 23:00:08','1.2',''),(1692,1872,'2018-03-12 23:00:09','-1.4',''),(1693,1897,'2018-03-12 23:00:09','-6.2',''),(1694,1922,'2018-03-12 23:00:09','-1',''),(1695,1946,'2018-03-12 23:00:09','1.4',''),(1696,1970,'2018-03-12 23:00:10','-4.2',''),(9441,2384,'2020-01-18 14:00:02','83',''),(1701,1822,'2018-03-12 23:00:08','-4.2',''),(1702,1831,'2018-03-12 23:00:08','5.04',''),(1703,1832,'2018-03-12 23:00:08','88',''),(1704,1834,'2018-03-12 23:00:08','759.93',''),(9510,2063,'2020-01-18 19:00:01','-1',''),(1709,1822,'2018-03-13 01:00:07','-4.2',''),(1710,1831,'2018-03-13 01:00:07','5.83',''),(1711,1832,'2018-03-13 01:00:07','91',''),(1712,1834,'2018-03-13 01:00:07','759.11',''),(1713,1847,'2018-03-13 01:00:07','1.1',''),(1714,1872,'2018-03-13 01:00:07','-2.3',''),(1715,1897,'2018-03-13 01:00:07','-12.3',''),(1716,1922,'2018-03-13 01:00:07','-15.6',''),(1717,1931,'2018-03-13 01:00:08','6.62',''),(1718,1933,'2018-03-13 01:00:08','752.31',''),(1719,1946,'2018-03-13 01:00:08','-12.2',''),(1720,1955,'2018-03-13 01:00:08','6.73',''),(1721,1957,'2018-03-13 01:00:08','754.24',''),(1722,1970,'2018-03-13 01:00:08','-9',''),(1723,1979,'2018-03-13 01:00:08','11',''),(1724,1981,'2018-03-13 01:00:08','749.11',''),(9453,2021,'2020-01-18 16:00:01','92',''),(9452,2020,'2020-01-18 16:00:01','5',''),(1733,1822,'2018-03-13 04:00:04','-6.5',''),(1734,1831,'2018-03-13 04:00:04','4.82',''),(1735,1834,'2018-03-13 04:00:04','759.78',''),(1736,1847,'2018-03-13 04:00:04','-3.9',''),(1737,1872,'2018-03-13 04:00:04','0.2',''),(1738,1897,'2018-03-13 04:00:05','-2.4',''),(1739,1922,'2018-03-13 04:00:05','-10.7',''),(1740,1931,'2018-03-13 05:00:09','6.62',''),(1741,1933,'2018-03-13 05:00:09','752.31',''),(1742,1946,'2018-03-13 04:00:05','-15.4',''),(1743,1955,'2018-03-13 05:00:09','6.73',''),(1744,1957,'2018-03-13 05:00:09','754.24',''),(1745,1970,'2018-03-13 04:00:05','-12.7',''),(1746,1979,'2018-03-13 05:00:09','11',''),(1747,1981,'2018-03-13 05:00:09','749.11',''),(9497,2169,'2020-01-18 17:00:03','-7',''),(1752,1822,'2018-03-13 05:00:08','-6.5',''),(1753,1831,'2018-03-13 05:00:08','4.82',''),(1754,1834,'2018-03-13 05:00:08','759.78',''),(1755,1847,'2018-03-13 05:00:08','-3.4',''),(1756,1872,'2018-03-13 05:00:08','0.2',''),(1757,1897,'2018-03-13 05:00:09','-2.4',''),(1758,1922,'2018-03-13 05:00:09','-10.7',''),(1759,1946,'2018-03-13 05:00:09','-15.4',''),(1760,1970,'2018-03-13 05:00:09','-12.7',''),(9333,2063,'2020-01-18 02:00:02','-1',''),(1765,1822,'2018-03-13 07:00:13','-3.9',''),(1766,1831,'2018-03-13 07:00:13','8.56',''),(1767,1832,'2018-03-13 07:00:13','95',''),(1768,1834,'2018-03-13 07:00:13','753.12',''),(1769,1847,'2018-03-13 07:00:13','0.2',''),(1770,1856,'2018-03-13 07:00:13','8.97',''),(1771,1857,'2018-03-13 07:00:13','94',''),(1772,1859,'2018-03-13 07:00:13','749.66',''),(1773,1872,'2018-03-13 07:00:13','-2.4',''),(1774,1881,'2018-03-13 07:00:13','3.86',''),(1775,1882,'2018-03-13 07:00:13','87',''),(1776,1884,'2018-03-13 07:00:13','747.66',''),(1777,1897,'2018-03-13 07:00:14','-10.7',''),(1778,1906,'2018-03-13 07:00:14','6.62',''),(1779,1909,'2018-03-13 07:00:14','752.31',''),(1780,1922,'2018-03-13 07:00:14','-15.4',''),(1781,1931,'2018-03-13 07:00:14','6.73',''),(1782,1933,'2018-03-13 07:00:14','754.24',''),(1783,1946,'2018-03-13 07:00:14','-12.7',''),(1784,1955,'2018-03-13 07:00:14','11',''),(1785,1957,'2018-03-13 07:00:14','749.11',''),(1786,1970,'2018-03-13 07:00:14','-9.1',''),(1787,1979,'2018-03-13 07:00:14','8.24',''),(1788,1981,'2018-03-13 07:00:14','746.83',''),(9336,2077,'2020-01-18 10:00:01','765',''),(9406,2020,'2020-01-18 11:00:02','3',''),(1797,1822,'2018-03-13 10:00:10','-2',''),(1798,1831,'2018-03-13 10:00:10','8.56',''),(1799,1832,'2018-03-13 10:00:10','95',''),(1800,1834,'2018-03-13 10:00:10','753.12',''),(1801,1847,'2018-03-13 10:00:10','0.2',''),(1802,1856,'2018-03-13 10:00:10','8.97',''),(1803,1857,'2018-03-13 10:00:10','94',''),(1804,1859,'2018-03-13 10:00:10','749.66',''),(1805,1872,'2018-03-13 10:00:10','-2.4',''),(1806,1881,'2018-03-13 10:00:10','3.86',''),(1807,1882,'2018-03-14 05:00:02','87',''),(1808,1884,'2018-03-13 10:00:11','747.66',''),(1809,1897,'2018-03-13 10:00:11','-10.7',''),(1810,1906,'2018-03-13 10:00:11','6.62',''),(1811,1909,'2018-03-13 10:00:11','752.31',''),(1812,1922,'2018-03-13 10:00:11','-15.4',''),(1813,1931,'2018-03-13 23:00:08','6.73',''),(1814,1933,'2018-03-13 23:00:08','754.24',''),(1815,1946,'2018-03-13 10:00:11','-12.7',''),(1816,1955,'2018-03-13 23:00:09','11',''),(1817,1957,'2018-03-13 23:00:09','749.11',''),(1818,1970,'2018-03-13 10:00:11','-9.1',''),(1819,1979,'2018-03-13 23:00:09','8.24',''),(1820,1981,'2018-03-13 23:00:09','746.83',''),(9500,2182,'2020-01-18 22:00:17','762',''),(9337,2090,'2020-01-18 02:00:02','-1',''),(9372,2384,'2020-01-18 04:00:02','73',''),(1833,1822,'2018-03-13 14:00:10','0.7',''),(1834,1831,'2018-03-13 14:00:10','7.78',''),(1835,1832,'2018-03-13 14:00:10','94',''),(1836,1834,'2018-03-13 14:00:10','752.63',''),(1837,1847,'2018-03-13 14:00:10','0',''),(1838,1856,'2018-03-13 14:00:10','9.26',''),(1839,1857,'2018-03-13 14:00:10','96',''),(1840,1859,'2018-03-13 14:00:10','748.05',''),(1841,1872,'2018-03-13 14:00:10','-5',''),(1842,1881,'2018-03-13 14:00:10','4.87',''),(1843,1884,'2018-03-13 14:00:10','747.39',''),(1844,1897,'2018-03-13 14:00:10','-12',''),(1845,1906,'2018-03-13 14:00:10','5.55',''),(1846,1907,'2018-03-13 14:00:10','79',''),(1847,1909,'2018-03-13 14:00:10','752.58',''),(1848,1922,'2018-03-13 14:00:11','-9.4',''),(1849,1946,'2018-03-13 14:00:11','-10',''),(1850,1970,'2018-03-13 14:00:11','-6.6',''),(9371,2180,'2020-01-18 04:00:02','3',''),(1854,1822,'2018-03-13 16:00:08','0.7',''),(1855,1831,'2018-03-13 16:00:08','8.52',''),(1856,1832,'2018-03-13 16:00:08','94',''),(1857,1834,'2018-03-13 16:00:08','751.31',''),(1858,1847,'2018-03-13 23:00:08','0',''),(1859,1856,'2018-03-14 05:00:02','9.26',''),(1860,1857,'2018-03-14 05:00:02','96',''),(1861,1859,'2018-03-14 05:00:02','748.05',''),(1862,1872,'2018-03-13 16:00:09','-5',''),(1863,1881,'2018-03-14 05:00:02','4.87',''),(1864,1884,'2018-03-14 05:00:02','747.39',''),(1865,1897,'2018-03-13 16:00:09','-12',''),(1866,1906,'2018-03-14 05:00:03','5.55',''),(1867,1907,'2018-03-14 05:00:03','79',''),(1868,1909,'2018-03-14 05:00:03','752.58',''),(1869,1922,'2018-03-13 16:00:09','-9.4',''),(1870,1946,'2018-03-13 16:00:09','-10',''),(1871,1970,'2018-03-13 16:00:10','-6.6',''),(9370,2169,'2020-01-18 04:00:02','-11',''),(9426,2021,'2020-01-18 14:00:01','94',''),(1883,1822,'2018-03-13 22:00:01','3.3',''),(1884,1831,'2018-03-13 22:00:01','9.16',''),(1885,1832,'2018-03-13 22:00:01','95',''),(1886,1834,'2018-03-13 22:00:01','750.37',''),(1887,1872,'2018-03-13 22:00:02','-7.6',''),(1888,1897,'2018-03-13 22:00:02','-13.1',''),(1889,1922,'2018-03-13 22:00:02','-10.4',''),(1890,1946,'2018-03-13 22:00:02','-9.5',''),(1891,1970,'2018-03-13 22:00:02','-7.7',''),(9369,2383,'2020-01-18 04:00:02','70',''),(1896,1822,'2018-03-13 23:00:08','2',''),(1897,1831,'2018-03-13 23:00:08','9.16',''),(1898,1832,'2018-03-13 23:00:08','95',''),(1899,1834,'2018-03-13 23:00:08','750.37',''),(1900,1872,'2018-03-13 23:00:08','-7.6',''),(1901,1897,'2018-03-13 23:00:08','-13.1',''),(1902,1922,'2018-03-13 23:00:08','-10.4',''),(1903,1946,'2018-03-13 23:00:09','-9.5',''),(1904,1970,'2018-03-13 23:00:09','-7.7',''),(9368,2154,'2020-01-18 04:00:02','7',''),(1909,1822,'2018-03-14 01:00:06','2',''),(1910,1831,'2018-03-14 01:00:06','8.81',''),(1911,1832,'2018-03-14 01:00:06','99',''),(1912,1834,'2018-03-14 01:00:07','750',''),(1913,1847,'2018-03-14 01:00:07','-0.5',''),(1914,1872,'2018-03-14 01:00:07','-11.5',''),(1915,1897,'2018-03-14 01:00:07','-17',''),(1916,1922,'2018-03-14 01:00:07','-9.6',''),(1917,1931,'2018-03-14 01:00:07','7.55',''),(1918,1933,'2018-03-14 01:00:07','747.29',''),(1919,1946,'2018-03-14 01:00:07','-9.8',''),(1920,1955,'2018-03-14 01:00:08','6.56',''),(1921,1957,'2018-03-14 01:00:08','749.7',''),(1922,1970,'2018-03-14 01:00:08','-5.3',''),(1923,1979,'2018-03-14 01:00:08','6.42',''),(1924,1981,'2018-03-14 01:00:08','746.34',''),(9317,2154,'2020-01-18 01:00:02','6',''),(9417,2383,'2020-01-18 11:00:02','75',''),(1933,1822,'2018-03-14 04:00:05','-2.7',''),(1934,1831,'2018-03-14 04:00:06','9.18',''),(1935,1834,'2018-03-14 04:00:06','751.42',''),(1936,1847,'2018-03-14 04:00:06','1.2',''),(1937,1872,'2018-03-14 04:00:06','-2',''),(1938,1897,'2018-03-14 04:00:06','-15.7',''),(1939,1922,'2018-03-14 04:00:06','-8.4',''),(1940,1931,'2018-03-14 05:00:03','7.55',''),(1941,1933,'2018-03-14 05:00:03','747.29',''),(1942,1946,'2018-03-14 04:00:07','-11.3',''),(1943,1955,'2018-03-14 05:00:03','6.56',''),(1944,1957,'2018-03-14 05:00:03','749.7',''),(1945,1970,'2018-03-14 04:00:07','-7.9',''),(1946,1979,'2018-03-14 05:00:03','6.42',''),(1947,1981,'2018-03-14 05:00:03','746.34',''),(9366,2382,'2020-01-18 04:00:01','87',''),(1951,1822,'2018-03-14 05:00:02','-2.7',''),(1952,1831,'2018-03-14 05:00:02','9.18',''),(1953,1834,'2018-03-14 05:00:02','751.42',''),(1954,1847,'2018-03-14 05:00:02','1.2',''),(1955,1872,'2018-03-14 05:00:02','-2',''),(1956,1897,'2018-03-14 05:00:02','-15.7',''),(1957,1922,'2018-03-14 05:00:03','-8.4',''),(1958,1946,'2018-03-14 05:00:03','-11.3',''),(1959,1970,'2018-03-14 05:00:03','-7.9',''),(9377,2021,'2020-01-18 10:00:01','92',''),(9364,2117,'2020-01-18 04:00:01','-2',''),(1966,1822,'2018-03-14 08:00:08','0.4',''),(1967,1831,'2018-03-14 08:00:08','9.26',''),(1968,1832,'2018-03-14 08:00:08','96',''),(1969,1834,'2018-03-14 08:00:08','748.05',''),(1970,1847,'2018-03-14 08:00:08','-2',''),(1971,1856,'2018-03-14 08:00:08','4.87',''),(1972,1857,'2018-03-14 08:00:08','87',''),(1973,1859,'2018-03-14 08:00:08','747.39',''),(1974,1872,'2018-03-14 08:00:09','-15.7',''),(1975,1881,'2018-03-14 08:00:09','5.55',''),(1976,1882,'2018-03-14 08:00:09','79',''),(1977,1884,'2018-03-14 08:00:09','752.58',''),(1978,1897,'2018-03-14 08:00:09','-8.4',''),(1979,1906,'2018-03-14 08:00:09','7.55',''),(1980,1909,'2018-03-14 08:00:09','747.29',''),(1981,1922,'2018-03-14 08:00:09','-11.3',''),(1982,1931,'2018-03-14 08:00:09','6.56',''),(1983,1933,'2018-03-14 08:00:09','749.7',''),(1984,1946,'2018-03-14 08:00:09','-7.9',''),(1985,1955,'2018-03-14 08:00:09','6.42',''),(1986,1957,'2018-03-14 08:00:09','746.34',''),(1987,1970,'2018-03-14 08:00:09','-4.7',''),(1988,1979,'2018-03-14 08:00:09','2.59',''),(1989,1981,'2018-03-14 08:00:09','749.26',''),(9363,2104,'2020-01-18 04:00:01','750',''),(1993,1822,'2018-03-14 10:00:11','0.4',''),(1994,1831,'2018-03-14 10:00:11','9.26',''),(1995,1832,'2018-03-14 10:00:11','96',''),(1996,1834,'2018-03-14 10:00:11','748.05',''),(1997,1847,'2018-03-14 10:00:11','-2',''),(1998,1856,'2018-03-14 10:00:12','4.87',''),(1999,1857,'2018-03-14 10:00:12','87',''),(2000,1859,'2018-03-14 10:00:12','747.39',''),(2001,1872,'2018-03-14 10:00:12','-15.7',''),(2002,1881,'2018-03-14 10:00:12','5.55',''),(2003,1882,'2018-03-14 10:00:12','79',''),(2004,1884,'2018-03-14 10:00:12','752.58',''),(2005,1897,'2018-03-14 10:00:12','-8.4',''),(2006,1906,'2018-03-14 10:00:12','7.55',''),(2007,1909,'2018-03-14 10:00:12','747.29',''),(2008,1922,'2018-03-14 10:00:12','-11.3',''),(2009,1931,'2018-03-14 23:00:03','6.56',''),(2010,1933,'2018-03-14 23:00:03','749.7',''),(2011,1946,'2018-03-14 10:00:12','-7.9',''),(2012,1955,'2018-03-14 23:00:03','6.42',''),(2013,1957,'2018-03-14 23:00:04','746.34',''),(2014,1970,'2018-03-14 10:00:13','-4.7',''),(2015,1979,'2018-03-14 23:00:04','2.59',''),(2016,1981,'2018-03-14 23:00:04','749.26',''),(9362,2102,'2020-01-18 04:00:01','91',''),(9412,2101,'2020-01-18 11:00:02','6',''),(9310,2101,'2020-01-18 01:00:02','8',''),(2028,1822,'2018-03-14 14:00:06','0.3',''),(2029,1831,'2018-03-14 14:00:06','9.4',''),(2030,1832,'2018-03-14 14:00:06','94',''),(2031,1834,'2018-03-14 14:00:06','747.69',''),(2032,1847,'2018-03-14 14:00:06','-5.9',''),(2033,1856,'2018-03-14 14:00:07','5.85',''),(2034,1857,'2018-03-14 14:00:07','89',''),(2035,1859,'2018-03-14 14:00:07','747.32',''),(2036,1872,'2018-03-14 14:00:07','-11.8',''),(2037,1881,'2018-03-14 14:00:07','5.65',''),(2038,1882,'2018-03-14 14:00:07','78',''),(2039,1884,'2018-03-14 14:00:07','752.09',''),(2040,1897,'2018-03-14 14:00:07','-13.4',''),(2041,1906,'2018-03-14 14:00:07','4.22',''),(2042,1907,'2018-03-14 14:00:07','81',''),(2043,1909,'2018-03-14 14:00:07','756.5',''),(2044,1922,'2018-03-14 14:00:07','-11.6',''),(2045,1946,'2018-03-14 14:00:07','-4.5',''),(2046,1970,'2018-03-14 14:00:07','-1.7',''),(9311,2102,'2020-01-18 01:00:02','94',''),(2050,1822,'2018-03-14 16:00:07','0.3',''),(2051,1831,'2018-03-14 16:00:07','8.81',''),(2052,1832,'2018-03-14 23:00:03','94',''),(2053,1834,'2018-03-14 16:00:07','747.37',''),(2054,1847,'2018-03-14 17:00:07','-5.9',''),(2055,1856,'2018-03-15 05:00:01','5.85',''),(2056,1857,'2018-03-15 05:00:01','89',''),(2057,1859,'2018-03-15 05:00:01','747.32',''),(2058,1872,'2018-03-14 17:00:07','-11.8',''),(2059,1881,'2018-03-15 05:00:01','5.65',''),(2060,1882,'2018-03-15 05:00:02','78',''),(2061,1884,'2018-03-15 05:00:02','752.09',''),(2062,1897,'2018-03-14 17:00:07','-13.4',''),(2063,1906,'2018-03-15 05:00:02','4.22',''),(2064,1907,'2018-03-15 05:00:02','81',''),(2065,1909,'2018-03-15 05:00:02','756.5',''),(2066,1922,'2018-03-14 17:00:07','-11.6',''),(2067,1946,'2018-03-14 17:00:07','-4.5',''),(2068,1970,'2018-03-14 17:00:07','-1.7',''),(9360,2075,'2020-01-18 04:00:01','94',''),(2072,1822,'2018-03-14 17:00:06','0.7',''),(2073,1831,'2018-03-14 17:00:06','8.81',''),(2074,1834,'2018-03-14 17:00:06','747.37',''),(9307,2075,'2020-01-18 01:00:02','87',''),(2078,1822,'2018-03-14 19:00:02','0.7',''),(2079,1831,'2018-03-14 19:00:02','8.37',''),(2080,1834,'2018-03-14 19:00:02','746.9',''),(2081,1847,'2018-03-14 19:00:02','-9.9',''),(2082,1872,'2018-03-14 19:00:02','-13.4',''),(2083,1897,'2018-03-14 19:00:02','-13.6',''),(2084,1922,'2018-03-14 19:00:02','-14.3',''),(2085,1946,'2018-03-14 19:00:03','-4.6',''),(2086,1970,'2018-03-14 19:00:03','-4.5',''),(9319,2156,'2020-01-18 01:00:03','750',''),(2090,1822,'2018-03-14 20:00:08','1.1',''),(2091,1831,'2018-03-14 20:00:08','8.37',''),(2092,1834,'2018-03-14 20:00:08','746.9',''),(2093,1847,'2018-03-14 23:00:03','-9.9',''),(2094,1872,'2018-03-14 23:00:03','-13.4',''),(2095,1897,'2018-03-14 23:00:03','-13.6',''),(2096,1922,'2018-03-14 23:00:03','-14.3',''),(2097,1946,'2018-03-14 23:00:03','-4.6',''),(2098,1970,'2018-03-14 23:00:04','-4.5',''),(9357,2048,'2020-01-18 04:00:01','91',''),(2102,1822,'2018-03-15 01:00:05','1.1',''),(2103,1831,'2018-03-14 22:00:05','8.36',''),(2104,1834,'2018-03-14 22:00:05','746.55',''),(9440,2180,'2020-01-18 14:00:02','4',''),(2108,1831,'2018-03-14 23:00:03','8.36',''),(2109,1834,'2018-03-14 23:00:03','746.55',''),(9338,2101,'2020-01-18 10:00:01','8',''),(2113,1831,'2018-03-15 01:00:05','7.97',''),(2114,1832,'2018-03-15 01:00:06','96',''),(2115,1834,'2018-03-15 01:00:06','745.88',''),(2116,1847,'2018-03-15 01:00:06','-12.7',''),(2117,1872,'2018-03-15 01:00:06','-17',''),(2118,1897,'2018-03-15 01:00:06','-17.1',''),(2119,1922,'2018-03-15 01:00:06','-10.2',''),(2120,1931,'2018-03-15 01:00:06','5.3',''),(2121,1933,'2018-03-15 01:00:06','761.88',''),(2122,1946,'2018-03-15 01:00:06','-3.9',''),(2123,1955,'2018-03-15 01:00:07','8.46',''),(2124,1957,'2018-03-15 01:00:07','756.09',''),(2125,1970,'2018-03-15 01:00:07','-1.4',''),(2126,1979,'2018-03-15 01:00:07','7.92',''),(2127,1981,'2018-03-15 01:00:07','750.93',''),(9355,2021,'2020-01-18 04:00:01','92',''),(2132,1822,'2018-03-15 02:00:06','0.6',''),(2133,1831,'2018-03-15 02:00:06','7.97',''),(2134,1832,'2018-03-15 02:00:06','96',''),(2135,1834,'2018-03-15 02:00:06','745.88',''),(2136,1847,'2018-03-15 02:00:06','-12.7',''),(2137,1872,'2018-03-15 02:00:06','-17',''),(2138,1897,'2018-03-15 02:00:06','-17.1',''),(2139,1922,'2018-03-15 02:00:06','-10.2',''),(2140,1931,'2018-03-15 05:00:02','5.3',''),(2141,1933,'2018-03-15 05:00:02','761.88',''),(2142,1946,'2018-03-15 02:00:07','-3.9',''),(2143,1955,'2018-03-15 05:00:02','8.46',''),(2144,1957,'2018-03-15 05:00:02','756.09',''),(2145,1970,'2018-03-15 02:00:07','-1.4',''),(2146,1979,'2018-03-15 05:00:02','7.92',''),(2147,1981,'2018-03-15 05:00:02','750.93',''),(9300,2021,'2020-01-18 01:00:02','93',''),(2152,1822,'2018-03-15 04:00:01','0.1',''),(2153,1831,'2018-03-15 04:00:01','8.87',''),(2154,1834,'2018-03-15 04:00:01','747.48',''),(2155,1847,'2018-03-15 04:00:01','-2.5',''),(2156,1872,'2018-03-15 04:00:02','-12.8',''),(2157,1897,'2018-03-15 04:00:02','-18.1',''),(2158,1922,'2018-03-15 04:00:02','-17',''),(2159,1946,'2018-03-15 04:00:02','-9.3',''),(2160,1970,'2018-03-15 04:00:02','-3',''),(9341,2117,'2020-01-18 02:00:02','-4',''),(2165,1822,'2018-03-15 05:00:01','0.1',''),(2166,1831,'2018-03-15 05:00:01','8.87',''),(2167,1834,'2018-03-15 05:00:01','747.48',''),(2168,1847,'2018-03-15 05:00:01','-4.9',''),(2169,1872,'2018-03-15 05:00:01','-12.8',''),(2170,1897,'2018-03-15 05:00:02','-18.1',''),(2171,1922,'2018-03-15 05:00:02','-17',''),(2172,1946,'2018-03-15 05:00:02','-9.3',''),(2173,1970,'2018-03-15 05:00:02','-3',''),(9332,2050,'2020-01-19 23:00:21','764',''),(2178,1822,'2018-03-15 07:00:06','-2.5',''),(2179,1831,'2018-03-15 07:00:06','5.85',''),(2180,1832,'2018-03-15 07:00:06','89',''),(2181,1834,'2018-03-15 07:00:06','747.32',''),(2182,1847,'2018-03-15 07:00:06','-12.8',''),(2183,1856,'2018-03-15 07:00:06','5.65',''),(2184,1857,'2018-03-15 07:00:06','78',''),(2185,1859,'2018-03-15 07:00:06','752.09',''),(2186,1872,'2018-03-15 07:00:06','-18.1',''),(2187,1881,'2018-03-15 07:00:06','4.22',''),(2188,1882,'2018-03-15 07:00:06','81',''),(2189,1884,'2018-03-15 07:00:06','756.5',''),(2190,1897,'2018-03-15 07:00:07','-17',''),(2191,1906,'2018-03-15 07:00:07','5.3',''),(2192,1909,'2018-03-15 07:00:07','761.88',''),(2193,1922,'2018-03-15 07:00:07','-9.3',''),(2194,1931,'2018-03-15 07:00:07','8.46',''),(2195,1933,'2018-03-15 07:00:07','756.09',''),(2196,1946,'2018-03-15 07:00:07','-3',''),(2197,1955,'2018-03-15 07:00:07','7.92',''),(2198,1957,'2018-03-15 07:00:07','750.93',''),(2199,1970,'2018-03-15 07:00:07','-3.2',''),(2200,1979,'2018-03-15 07:00:07','5.72',''),(2201,1981,'2018-03-15 07:00:07','753.92',''),(9335,2075,'2020-01-18 02:00:02','87',''),(2205,1822,'2018-03-15 08:00:05','-3.8',''),(2206,1831,'2018-03-15 11:00:08','5.85',''),(2207,1832,'2018-03-15 11:00:08','89',''),(2208,1834,'2018-03-15 11:00:08','747.32',''),(2209,1847,'2018-03-15 11:00:09','-12.8',''),(2210,1856,'2018-03-15 11:00:09','5.65',''),(2211,1857,'2018-03-15 11:00:09','78',''),(2212,1859,'2018-03-15 11:00:09','752.09',''),(2213,1872,'2018-03-15 11:00:09','-18.1',''),(2214,1881,'2018-03-15 11:00:09','4.22',''),(2215,1882,'2018-03-15 11:00:09','81',''),(2216,1884,'2018-03-15 11:00:09','756.5',''),(2217,1897,'2018-03-15 11:00:09','-17',''),(2218,1906,'2018-03-15 11:00:09','5.3',''),(2219,1909,'2018-03-15 11:00:09','761.88',''),(2220,1922,'2018-03-15 11:00:09','-9.3',''),(2221,1931,'2018-03-15 22:00:17','8.46',''),(2222,1933,'2018-03-15 22:00:17','756.09',''),(2223,1946,'2018-03-15 11:00:09','-3',''),(2224,1955,'2018-03-15 22:00:17','7.92',''),(2225,1957,'2018-03-15 22:00:17','750.93',''),(2226,1970,'2018-03-15 11:00:09','-3.2',''),(2227,1979,'2018-03-15 22:00:17','5.72',''),(2228,1981,'2018-03-15 22:00:17','753.92',''),(9398,1610,'2020-01-18 08:00:00','3',''),(2232,1822,'2018-03-15 10:00:09','-3.8',''),(2233,1822,'2018-03-15 11:00:08','-5.9',''),(9499,2384,'2020-01-18 22:00:17','75',''),(9322,2384,'2020-01-18 01:00:03','67',''),(2242,1822,'2018-03-15 14:00:18','-7.6',''),(2243,1831,'2018-03-15 14:00:18','5.42',''),(2244,1832,'2018-03-15 14:00:19','88',''),(2245,1834,'2018-03-15 14:00:19','748.14',''),(2246,1847,'2018-03-15 14:00:19','-11.8',''),(2247,1856,'2018-03-15 14:00:19','5.36',''),(2248,1857,'2018-03-15 14:00:19','84',''),(2249,1859,'2018-03-15 14:00:19','752.77',''),(2250,1872,'2018-03-15 14:00:19','-14.1',''),(2251,1881,'2018-03-15 14:00:19','3.22',''),(2252,1882,'2018-03-15 14:00:19','79',''),(2253,1884,'2018-03-15 14:00:19','757.11',''),(2254,1897,'2018-03-15 14:00:19','-12.1',''),(2255,1906,'2018-03-15 14:00:19','3.17',''),(2256,1907,'2018-03-15 14:00:19','86',''),(2257,1909,'2018-03-15 14:00:19','755.49',''),(2258,1922,'2018-03-15 14:00:19','-4.4',''),(2259,1946,'2018-03-15 14:00:19','-0.8',''),(2260,1970,'2018-03-15 14:00:20','-7.5',''),(9351,2182,'2020-01-18 02:00:02','760',''),(2265,1822,'2018-03-15 16:00:05','-7.6',''),(2266,1831,'2018-03-15 16:00:05','5.88',''),(2267,1832,'2018-03-15 16:00:05','79',''),(2268,1834,'2018-03-15 16:00:05','749.01',''),(2269,1847,'2018-03-15 16:00:05','-11.8',''),(2270,1856,'2018-03-16 05:00:05','5.36',''),(2271,1857,'2018-03-16 05:00:05','84',''),(2272,1859,'2018-03-16 05:00:05','752.77',''),(2273,1872,'2018-03-15 16:00:05','-14.1',''),(2274,1881,'2018-03-16 05:00:06','3.22',''),(2275,1882,'2018-03-16 05:00:06','79',''),(2276,1884,'2018-03-16 05:00:06','757.11',''),(2277,1897,'2018-03-15 16:00:06','-12.1',''),(2278,1906,'2018-03-16 05:00:06','3.17',''),(2279,1907,'2018-03-16 05:00:06','86',''),(2280,1909,'2018-03-16 05:00:06','755.49',''),(2281,1922,'2018-03-15 16:00:06','-4.4',''),(2282,1946,'2018-03-15 16:00:06','-0.8',''),(2283,1970,'2018-03-15 16:00:06','-7.5',''),(9340,2104,'2020-01-18 02:00:02','752',''),(2292,1822,'2018-03-15 19:00:11','-9.9',''),(2293,1831,'2018-03-15 19:00:11','5.68',''),(2294,1832,'2018-03-15 19:00:11','72',''),(2295,1834,'2018-03-15 19:00:11','749.79',''),(2296,1847,'2018-03-15 19:00:11','-13.5',''),(2297,1872,'2018-03-15 19:00:11','-15.1',''),(2298,1897,'2018-03-15 19:00:11','-8.2',''),(2299,1922,'2018-03-15 19:00:12','-3.8',''),(2300,1946,'2018-03-15 19:00:12','-1.4',''),(2301,1970,'2018-03-15 19:00:12','-15.7',''),(9331,2048,'2020-01-18 02:00:02','90',''),(2306,1822,'2018-03-15 20:00:30','-11.5',''),(2307,1831,'2018-03-15 20:00:30','5.68',''),(2308,1832,'2018-03-15 20:00:30','72',''),(2309,1834,'2018-03-15 20:00:30','749.79',''),(2310,1847,'2018-03-15 22:00:16','-13.5',''),(2311,1872,'2018-03-15 22:00:16','-15.1',''),(2312,1897,'2018-03-15 22:00:17','-8.2',''),(2313,1922,'2018-03-15 22:00:17','-3.8',''),(2314,1946,'2018-03-15 22:00:17','-1.4',''),(2315,1970,'2018-03-15 22:00:17','-15.7',''),(9334,2074,'2020-01-18 02:00:02','5',''),(2320,1822,'2018-03-15 22:00:16','-11.5',''),(2321,1831,'2018-03-15 22:00:16','5.29',''),(2322,1832,'2018-03-15 22:00:16','69',''),(2323,1834,'2018-03-15 22:00:16','750.17',''),(9349,2180,'2020-01-18 02:00:02','4',''),(9321,2180,'2020-01-18 01:00:03','4',''),(2336,1822,'2018-03-16 02:00:04','-12.8',''),(2337,1831,'2018-03-16 02:00:04','4.84',''),(2338,1832,'2018-03-16 02:00:04','78',''),(2339,1834,'2018-03-16 02:00:04','750.14',''),(2340,1847,'2018-03-16 02:00:04','-17.5',''),(2341,1872,'2018-03-16 02:00:05','-18.3',''),(2342,1897,'2018-03-16 02:00:05','-6.3',''),(2343,1922,'2018-03-16 02:00:05','-9.9',''),(2344,1931,'2018-03-16 02:00:05','10.4',''),(2345,1933,'2018-03-16 02:00:05','741.16',''),(2346,1946,'2018-03-16 02:00:05','-16.7',''),(2347,1955,'2018-03-16 02:00:05','5.63',''),(2348,1957,'2018-03-16 02:00:05','749.51',''),(2349,1970,'2018-03-16 02:00:05','-23.7',''),(2350,1979,'2018-03-16 02:00:06','2.23',''),(2351,1981,'2018-03-16 02:00:06','760.19',''),(9339,2102,'2020-01-18 02:00:02','94',''),(2356,1822,'2018-03-16 04:00:06','-4.4',''),(2357,1831,'2018-03-16 04:00:06','5.89',''),(2358,1834,'2018-03-16 04:00:06','747.92',''),(2359,1847,'2018-03-16 04:00:06','-13.8',''),(2360,1872,'2018-03-16 04:00:06','-19',''),(2361,1897,'2018-03-16 04:00:06','-20.6',''),(2362,1922,'2018-03-16 04:00:07','-1.9',''),(2363,1931,'2018-03-16 05:00:06','10.4',''),(2364,1933,'2018-03-16 05:00:06','741.16',''),(2365,1946,'2018-03-16 04:00:07','-6.8',''),(2366,1955,'2018-03-16 05:00:06','5.63',''),(2367,1957,'2018-03-16 05:00:06','749.51',''),(2368,1970,'2018-03-16 04:00:07','-15.8',''),(2369,1979,'2018-03-16 05:00:06','2.23',''),(2370,1981,'2018-03-16 05:00:06','760.19',''),(9330,2036,'2020-01-18 02:00:02','0',''),(2375,1822,'2018-03-16 05:00:05','-4.4',''),(2376,1831,'2018-03-16 05:00:05','5.89',''),(2377,1834,'2018-03-16 05:00:05','747.92',''),(2378,1847,'2018-03-16 05:00:05','-14.5',''),(2379,1872,'2018-03-16 05:00:05','-19',''),(2380,1897,'2018-03-16 05:00:06','-20.6',''),(2381,1922,'2018-03-16 05:00:06','-1.9',''),(2382,1946,'2018-03-16 05:00:06','-6.8',''),(2383,1970,'2018-03-16 05:00:06','-15.8',''),(9324,1611,'2020-01-18 02:00:01','92',''),(2388,1822,'2018-03-16 07:00:05','-13.8',''),(2389,1831,'2018-03-16 07:00:05','5.36',''),(2390,1832,'2018-03-16 07:00:05','84',''),(2391,1834,'2018-03-16 07:00:05','752.77',''),(2392,1847,'2018-03-16 07:00:05','-19',''),(2393,1856,'2018-03-16 07:00:05','3.22',''),(2394,1857,'2018-03-16 07:00:05','79',''),(2395,1859,'2018-03-16 07:00:05','757.11',''),(2396,1872,'2018-03-16 07:00:05','-20.6',''),(2397,1881,'2018-03-16 07:00:05','3.17',''),(2398,1882,'2018-03-16 07:00:05','86',''),(2399,1884,'2018-03-16 07:00:05','755.49',''),(2400,1897,'2018-03-16 07:00:05','-1.9',''),(2401,1906,'2018-03-16 07:00:05','10.4',''),(2402,1909,'2018-03-16 07:00:05','741.16',''),(2403,1922,'2018-03-16 07:00:05','-6.8',''),(2404,1931,'2018-03-16 07:00:06','5.63',''),(2405,1933,'2018-03-16 07:00:06','749.51',''),(2406,1946,'2018-03-16 07:00:06','-15.8',''),(2407,1955,'2018-03-16 07:00:06','2.23',''),(2408,1957,'2018-03-16 07:00:06','760.19',''),(2409,1970,'2018-03-16 07:00:06','-19.5',''),(2410,1979,'2018-03-16 07:00:06','1.66',''),(2411,1981,'2018-03-16 07:00:06','758.34',''),(9348,2169,'2020-01-18 02:00:02','-9',''),(9295,1605,'2020-01-18 13:00:00','1',''),(9316,2143,'2020-01-18 01:00:02','-7',''),(2424,1822,'2018-03-16 11:00:16','-11.8',''),(2425,1831,'2018-03-16 11:00:17','5.36',''),(2426,1832,'2018-03-16 11:00:17','84',''),(2427,1834,'2018-03-16 11:00:17','752.77',''),(2428,1847,'2018-03-16 11:00:17','-19',''),(2429,1856,'2018-03-16 11:00:17','3.22',''),(2430,1857,'2018-03-16 11:00:17','79',''),(2431,1859,'2018-03-16 11:00:17','757.11',''),(2432,1872,'2018-03-16 11:00:17','-20.6',''),(2433,1881,'2018-03-16 11:00:17','3.17',''),(2434,1882,'2018-03-16 11:00:17','86',''),(2435,1884,'2018-03-16 11:00:17','755.49',''),(2436,1897,'2018-03-16 11:00:17','-1.9',''),(2437,1906,'2018-03-16 11:00:17','10.4',''),(2438,1909,'2018-03-16 11:00:17','741.16',''),(2439,1922,'2018-03-16 11:00:17','-6.8',''),(2440,1931,'2018-03-16 20:00:03','5.63',''),(2441,1933,'2018-03-16 20:00:03','749.51',''),(2442,1946,'2018-03-16 11:00:18','-15.8',''),(2443,1955,'2018-03-16 20:00:03','2.23',''),(2444,1957,'2018-03-16 20:00:03','760.19',''),(2445,1970,'2018-03-16 11:00:18','-19.5',''),(2446,1979,'2018-03-16 20:00:03','1.66',''),(2447,1981,'2018-03-16 20:00:03','758.34',''),(9491,2382,'2020-01-18 23:00:02','87',''),(9735,2156,'2020-01-19 22:00:12','746',''),(2456,1822,'2018-03-16 14:00:03','-14.1',''),(2457,1831,'2018-03-16 14:00:03','5.04',''),(2458,1832,'2018-03-16 14:00:03','79',''),(2459,1834,'2018-03-16 14:00:03','753.99',''),(2460,1847,'2018-03-16 14:00:03','-14',''),(2461,1856,'2018-03-16 14:00:03','4.76',''),(2462,1857,'2018-03-16 14:00:03','78',''),(2463,1859,'2018-03-16 14:00:03','757.66',''),(2464,1872,'2018-03-16 14:00:03','-10.1',''),(2465,1881,'2018-03-16 14:00:04','2.86',''),(2466,1882,'2018-03-16 14:00:04','91',''),(2467,1884,'2018-03-16 14:00:04','755.22',''),(2468,1897,'2018-03-16 14:00:04','-2.1',''),(2469,1906,'2018-03-16 14:00:04','8.27',''),(2470,1907,'2018-03-16 14:00:04','94',''),(2471,1909,'2018-03-16 14:00:04','746.61',''),(2472,1922,'2018-03-16 14:00:04','-5.3',''),(2473,1946,'2018-03-16 14:00:04','-11.2',''),(2474,1970,'2018-03-16 14:00:04','-11',''),(9320,2169,'2020-01-18 01:00:03','-9',''),(2479,1822,'2018-03-16 16:00:06','-14.1',''),(2480,1831,'2018-03-16 16:00:06','5.53',''),(2481,1832,'2018-03-16 16:00:06','78',''),(2482,1834,'2018-03-16 16:00:07','754.84',''),(2483,1847,'2018-03-16 17:00:05','-14',''),(2484,1856,'2018-03-16 20:00:02','4.76',''),(2485,1857,'2018-03-17 00:00:05','78',''),(2486,1859,'2018-03-16 20:00:02','757.66',''),(2487,1872,'2018-03-16 17:00:06','-10.1',''),(2488,1881,'2018-03-16 20:00:02','2.86',''),(2489,1882,'2018-03-17 00:00:05','91',''),(2490,1884,'2018-03-16 20:00:02','755.22',''),(2491,1897,'2018-03-16 20:00:03','-2.1',''),(2492,1906,'2018-03-16 20:00:03','8.27',''),(2493,1907,'2018-03-17 00:00:05','94',''),(2494,1909,'2018-03-16 20:00:03','746.61',''),(2495,1922,'2018-03-16 17:00:06','-5.3',''),(2496,1946,'2018-03-16 17:00:06','-11.2',''),(2497,1970,'2018-03-16 17:00:06','-11',''),(9350,2384,'2020-01-18 02:00:02','67',''),(2502,1822,'2018-03-16 17:00:05','-15.4',''),(2503,1831,'2018-03-16 17:00:05','5.53',''),(2504,1832,'2018-03-16 17:00:05','78',''),(2505,1834,'2018-03-16 17:00:05','754.84',''),(9299,2020,'2020-01-18 01:00:02','4',''),(2510,1822,'2018-03-16 20:00:02','-17.3',''),(2511,1831,'2018-03-16 20:00:02','5',''),(2512,1832,'2018-03-16 20:00:02','61',''),(2513,1834,'2018-03-16 20:00:02','755.61',''),(2514,1847,'2018-03-16 20:00:02','-13.9',''),(2515,1872,'2018-03-16 20:00:02','-8.1',''),(2516,1922,'2018-03-16 20:00:03','-10.3',''),(2517,1946,'2018-03-16 20:00:03','-20',''),(2518,1970,'2018-03-16 20:00:03','-20.4',''),(9329,2023,'2020-01-18 17:00:02','765',''),(9270,2021,'2020-01-17 20:00:02','91',''),(2527,1822,'2018-03-16 23:00:03','-18',''),(2528,1831,'2018-03-16 23:00:03','4',''),(2529,1832,'2018-03-16 23:00:03','62',''),(2530,1834,'2018-03-16 23:00:03','756',''),(2531,1847,'2018-03-16 23:00:03','-14',''),(2532,1856,'2018-03-16 23:00:03','5',''),(2533,1859,'2018-03-16 23:00:04','758',''),(2534,1872,'2018-03-16 23:00:04','-8',''),(2535,1881,'2018-03-16 23:00:04','3',''),(2536,1884,'2018-03-16 23:00:04','755',''),(2537,1897,'2018-03-16 23:00:04','-2',''),(2538,1906,'2018-03-16 23:00:04','8',''),(2539,1909,'2018-03-16 23:00:04','747',''),(2540,1922,'2018-03-16 23:00:04','-10',''),(2541,1931,'2018-03-16 23:00:04','2',''),(2542,1933,'2018-03-16 23:00:04','752',''),(2543,1946,'2018-03-16 23:00:04','-8',''),(2544,1955,'2018-03-16 23:00:04','5',''),(2545,1957,'2018-03-16 23:00:04','750',''),(2546,1970,'2018-03-16 23:00:04','-18',''),(2547,1979,'2018-03-16 23:00:05','5',''),(2548,1981,'2018-03-16 23:00:05','752',''),(9279,1611,'2020-01-17 23:00:01','91',''),(2552,1822,'2018-03-17 00:00:04','-19',''),(2553,1831,'2018-03-17 00:00:04','4',''),(2554,1832,'2018-03-17 00:00:04','62',''),(2555,1834,'2018-03-17 00:00:04','756',''),(2556,1847,'2018-03-17 00:00:05','-16',''),(2557,1856,'2018-03-17 00:00:05','5',''),(2558,1859,'2018-03-17 00:00:05','758',''),(2559,1872,'2018-03-17 00:00:05','-8',''),(2560,1881,'2018-03-17 00:00:05','3',''),(2561,1884,'2018-03-17 00:00:05','755',''),(2562,1897,'2018-03-17 00:00:05','-4',''),(2563,1906,'2018-03-17 00:00:05','8',''),(2564,1909,'2018-03-17 00:00:05','747',''),(2565,1922,'2018-03-17 00:00:05','-6',''),(2566,1931,'2018-03-17 00:00:05','2',''),(2567,1933,'2018-03-17 00:00:05','752',''),(2568,1946,'2018-03-17 00:00:05','-13',''),(2569,1955,'2018-03-17 00:00:06','5',''),(2570,1957,'2018-03-17 00:00:06','750',''),(2571,1970,'2018-03-17 00:00:06','-15',''),(2572,1979,'2018-03-17 00:00:06','5',''),(2573,1981,'2018-03-17 00:00:06','752',''),(10065,2050,'2020-01-21 03:00:01','741',''),(9859,2021,'2020-01-20 10:00:01','90',''),(9798,2104,'2020-01-20 01:00:12','752',''),(9754,2021,'2020-01-19 20:00:06','89',''),(9294,2384,'2020-01-17 23:00:05','82',''),(9269,2020,'2020-01-17 23:00:04','5',''),(9870,2128,'2020-01-20 10:00:01','4',''),(9766,1611,'2020-01-19 23:00:04','89',''),(9722,1613,'2020-01-19 17:00:00','765',''),(9655,2009,'2020-01-19 11:00:01','-1',''),(9281,2048,'2020-01-17 23:00:04','93',''),(9741,2020,'2020-01-19 19:00:17','5',''),(9604,2102,'2020-01-19 04:00:01','77',''),(9623,2063,'2020-01-19 10:00:07','0',''),(9549,1605,'2020-01-19 04:00:01','-1',''),(9519,2021,'2020-01-18 20:00:01','93',''),(9482,2063,'2020-01-18 17:00:02','-0',''),(9156,2075,'2020-01-17 10:00:22','89',''),(9280,2021,'2020-01-17 23:00:04','89',''),(9861,2047,'2020-01-20 10:00:01','8',''),(9932,2384,'2020-01-20 14:00:03','86',''),(9765,1610,'2020-01-19 23:00:04','6',''),(9293,2180,'2020-01-17 23:00:05','6',''),(9277,1605,'2020-01-17 23:00:01','1',''),(9801,2382,'2020-01-20 01:00:12','89',''),(9724,2021,'2020-01-19 17:00:01','88',''),(9671,1605,'2020-01-19 16:00:03','1',''),(9353,1613,'2020-01-18 04:00:01','765',''),(9787,2021,'2020-01-20 01:00:11','85',''),(9630,2128,'2020-01-19 10:00:07','7',''),(9739,2182,'2020-01-19 22:00:12','747',''),(9550,1611,'2020-01-19 01:00:03','87',''),(9521,2036,'2020-01-18 23:00:01','1',''),(9459,2090,'2020-01-18 16:00:02','4',''),(9447,2169,'2020-01-18 14:00:02','-9',''),(9376,2009,'2020-01-18 14:00:01','1',''),(9244,2063,'2020-01-17 23:00:04','1',''),(9816,2063,'2020-01-20 02:00:19','-6',''),(9723,2020,'2020-01-19 17:00:01','4',''),(9672,1610,'2020-01-19 13:00:00','5',''),(9551,1613,'2020-01-19 04:00:01','762',''),(9840,2063,'2020-01-20 04:00:01','-2',''),(9726,2036,'2020-01-20 02:00:19','-1',''),(9673,1611,'2020-01-19 13:00:00','91',''),(9553,2021,'2020-01-19 01:00:08','91',''),(9323,2182,'2020-01-18 01:00:03','760',''),(9863,2050,'2020-01-20 14:00:02','746',''),(9728,2048,'2020-01-19 22:00:11','84',''),(9292,2169,'2020-01-17 23:00:05','-6',''),(9755,2063,'2020-01-19 23:00:21','1',''),(9725,2023,'2020-01-19 20:00:06','765',''),(9696,2117,'2020-01-19 17:00:01','-7',''),(9674,2009,'2020-01-19 13:00:00','1',''),(9276,2021,'2020-01-17 22:00:06','90',''),(9303,2048,'2020-01-18 01:00:02','90',''),(9531,1611,'2020-01-18 23:00:01','87',''),(9571,2180,'2020-01-19 01:00:09','6',''),(9486,2090,'2020-01-18 17:00:03','4',''),(9449,1610,'2020-01-18 16:00:01','5',''),(9345,2154,'2020-01-18 02:00:02','6',''),(9249,2382,'2020-01-17 22:00:07','87',''),(9247,2077,'2020-01-17 23:00:04','764',''),(10069,2077,'2020-01-21 10:00:01','751',''),(9785,1611,'2020-01-20 01:00:11','89',''),(9342,2382,'2020-01-18 02:00:02','77',''),(9309,2090,'2020-01-18 01:00:02','-1',''),(10019,2154,'2020-01-21 00:00:02','3',''),(9716,2180,'2020-01-19 16:00:05','6',''),(9654,1611,'2020-01-19 11:00:00','91',''),(9676,2048,'2020-01-19 14:00:04','86',''),(9298,2009,'2020-01-18 01:00:02','-1',''),(9557,2075,'2020-01-19 01:00:09','95',''),(9554,2036,'2020-01-19 01:00:08','-0',''),(9490,2128,'2020-01-18 22:00:16','8',''),(9157,2077,'2020-01-17 14:00:08','765',''),(9297,1611,'2020-01-18 01:00:01','91',''),(9748,1605,'2020-01-19 22:00:02','0',''),(9784,1610,'2020-01-20 04:00:00','6',''),(9314,2382,'2020-01-18 01:00:02','77',''),(9649,1611,'2020-01-19 10:00:01','93',''),(9678,2075,'2020-01-19 14:00:04','94',''),(9328,2021,'2020-01-18 02:00:02','93',''),(9820,2090,'2020-01-20 02:00:20','-9',''),(9216,2117,'2020-01-17 22:00:07','3',''),(9805,2383,'2020-01-20 01:00:12','90',''),(9786,1613,'2020-01-20 07:00:01','763',''),(9327,2020,'2020-01-18 10:00:01','4',''),(9653,1610,'2020-01-19 11:00:00','5',''),(9612,2156,'2020-01-19 04:00:02','757',''),(9268,2009,'2020-01-17 23:00:04','2',''),(9619,1611,'2020-01-19 05:00:01','87',''),(9622,2048,'2020-01-19 10:00:07','85',''),(9572,2384,'2020-01-19 01:00:09','93',''),(9496,2156,'2020-01-18 23:00:02','752',''),(9448,1605,'2020-01-18 16:00:01','0',''),(9481,2048,'2020-01-18 22:00:16','92',''),(9480,2021,'2020-01-18 17:00:02','92',''),(9391,2383,'2020-01-18 10:00:01','70',''),(9768,2021,'2020-01-19 23:00:20','96',''),(9390,2154,'2020-01-18 14:00:02','7',''),(9864,2063,'2020-01-20 16:00:47','-2',''),(9972,1611,'2020-01-20 18:00:01','89',''),(9775,2382,'2020-01-19 23:00:21','78',''),(9679,2102,'2020-01-19 22:00:11','80',''),(9513,2169,'2020-01-18 19:00:02','-4',''),(9444,1610,'2020-01-18 14:00:01','5',''),(9810,2182,'2020-01-20 01:00:12','752',''),(9761,1613,'2020-01-19 22:00:02','764',''),(9608,2130,'2020-01-19 04:00:02','754',''),(9541,2117,'2020-01-18 23:00:02','-5',''),(9450,1611,'2020-01-18 16:00:01','92',''),(9215,2090,'2020-01-17 17:00:03','1',''),(9560,2102,'2020-01-19 01:00:09','87',''),(9555,2048,'2020-01-19 01:00:08','89',''),(9523,2090,'2020-01-18 22:00:16','1',''),(9494,2154,'2020-01-18 23:00:02','8',''),(9400,1613,'2020-01-18 08:00:00','766',''),(9347,2156,'2020-01-18 10:00:01','750',''),(9251,2154,'2020-01-17 22:00:07','7',''),(9214,2063,'2020-01-17 14:00:08','0',''),(9389,2143,'2020-01-18 14:00:02','-8',''),(9219,1611,'2020-01-17 16:00:05','90',''),(9578,2048,'2020-01-19 02:00:01','89',''),(9660,2102,'2020-01-19 11:00:01','80',''),(9446,2090,'2020-01-18 14:00:01','3',''),(9202,2102,'2020-01-17 14:00:08','94',''),(9254,2180,'2020-01-17 22:00:07','7',''),(9177,1613,'2020-01-17 08:00:05','764',''),(9865,2077,'2020-01-20 10:00:01','742',''),(9730,2075,'2020-01-19 22:00:11','91',''),(9682,2382,'2020-01-19 14:00:04','72',''),(9629,2104,'2020-01-19 14:00:04','745',''),(9443,1605,'2020-01-18 14:00:01','0',''),(9243,2048,'2020-01-17 22:00:07','95',''),(9867,2101,'2020-01-20 10:00:01','8',''),(9812,2021,'2020-01-20 02:00:19','85',''),(9731,2077,'2020-01-19 22:00:11','748',''),(9933,2182,'2020-01-20 22:00:04','757',''),(9525,2169,'2020-01-18 22:00:17','-4',''),(9422,2182,'2020-01-18 11:00:03','761',''),(9858,1611,'2020-01-20 05:00:04','89',''),(9733,2128,'2020-01-19 23:00:21','7',''),(9843,2101,'2020-01-20 04:00:01','8',''),(9576,2021,'2020-01-19 14:00:04','91',''),(9419,2169,'2020-01-18 11:00:02','-10',''),(9245,2074,'2020-01-17 23:00:04','4',''),(9922,2117,'2020-01-20 13:00:02','-5',''),(9811,1611,'2020-01-20 02:00:06','96',''),(9734,2382,'2020-01-19 22:00:11','68',''),(9290,2383,'2020-01-17 23:00:05','77',''),(9267,1611,'2020-01-17 20:00:01','90',''),(9727,2047,'2020-01-19 23:00:21','5',''),(9670,2182,'2020-01-19 11:00:02','759',''),(9628,2102,'2020-01-19 10:00:07','77',''),(9237,1605,'2020-01-17 17:00:01','2',''),(9278,1610,'2020-01-17 23:00:01','4',''),(9538,2090,'2020-01-18 23:00:02','2',''),(9489,2104,'2020-01-18 22:00:16','749',''),(9479,2020,'2020-01-18 17:00:02','5',''),(9272,2090,'2020-01-17 23:00:04','0',''),(9193,2384,'2020-01-17 11:00:02','83',''),(9869,2117,'2020-01-20 10:00:01','-7',''),(9764,1605,'2020-01-19 23:00:04','1',''),(9738,2384,'2020-01-19 22:00:12','82',''),(9289,2154,'2020-01-17 23:00:05','8',''),(9246,2075,'2020-01-17 22:00:07','89',''),(9714,2156,'2020-01-19 16:00:05','746',''),(9669,2384,'2020-01-19 11:00:02','89',''),(9760,1611,'2020-01-19 22:00:02','91',''),(9234,2180,'2020-01-17 16:00:11','7',''),(9235,2384,'2020-01-17 16:00:11','75',''),(9633,2143,'2020-01-19 11:00:01','-9',''),(9478,2009,'2020-01-18 17:00:02','0',''),(9445,1611,'2020-01-18 14:00:01','91',''),(9258,1610,'2020-01-17 22:00:01','5',''),(9804,2154,'2020-01-20 01:00:12','4',''),(9288,2130,'2020-01-17 23:00:05','752',''),(9271,2036,'2020-01-17 23:00:04','-1',''),(9783,1605,'2020-01-20 04:00:00','1',''),(9668,2180,'2020-01-19 11:00:02','4',''),(9602,2090,'2020-01-19 04:00:01','-2',''),(9601,2077,'2020-01-19 04:00:01','747',''),(9195,1611,'2020-01-17 13:00:01','93',''),(9848,2130,'2020-01-20 04:00:01','746',''),(9772,2077,'2020-01-19 23:00:21','747',''),(9343,2130,'2020-01-18 10:00:01','743',''),(9287,2382,'2020-01-17 23:00:05','94',''),(9777,2154,'2020-01-19 23:00:21','5',''),(9667,2169,'2020-01-19 11:00:02','-4',''),(9632,2130,'2020-01-19 10:00:07','754',''),(9631,2382,'2020-01-19 10:00:07','67',''),(9536,2048,'2020-01-18 23:00:01','91',''),(9418,2156,'2020-01-18 11:00:02','748',''),(9196,2021,'2020-01-17 14:00:08','93',''),(9800,2128,'2020-01-20 01:00:12','5',''),(9809,2384,'2020-01-20 01:00:12','97',''),(9818,2075,'2020-01-20 10:00:01','78',''),(9509,2036,'2020-01-18 19:00:01','1',''),(9468,2383,'2020-01-18 16:00:02','78',''),(9256,2182,'2020-01-17 23:00:05','750',''),(9813,2047,'2020-01-20 02:00:19','7',''),(9806,2156,'2020-01-20 01:00:12','753',''),(9197,2047,'2020-01-17 14:00:08','5',''),(9635,2383,'2020-01-19 10:00:08','88',''),(9073,2020,'2020-01-17 01:00:01','4',''),(9530,1610,'2020-01-19 04:00:01','5',''),(9466,2143,'2020-01-18 16:00:02','-7',''),(9206,2383,'2020-01-17 14:00:09','81',''),(10018,2130,'2020-01-21 00:00:02','751',''),(9814,2048,'2020-01-20 02:00:19','93',''),(9683,2130,'2020-01-19 23:00:21','752',''),(9218,1605,'2020-01-17 16:00:04','3',''),(9556,2074,'2020-01-19 01:00:09','7',''),(9416,2130,'2020-01-18 11:00:02','740',''),(9201,2101,'2020-01-17 22:00:07','4',''),(2975,2207,'2018-03-18 22:30:47','24.04',''),(2976,2208,'2018-03-18 22:30:47','35.83',''),(2977,2209,'2018-03-18 22:30:47','98.67',''),(2978,2210,'2018-03-18 22:30:47','740.09',''),(2979,2207,'2018-03-18 22:40:59','23.91',''),(2980,2208,'2018-03-18 22:41:00','35.6',''),(2981,2209,'2018-03-18 22:41:00','98.64',''),(2982,2210,'2018-03-18 22:41:00','739.86',''),(2983,2212,'2018-03-18 22:43:28','24.69',''),(2984,2213,'2018-03-18 22:43:28','33.11',''),(2985,2212,'2018-03-18 22:46:21','24.57',''),(2986,2213,'2018-03-18 22:46:21','33.48',''),(2987,2212,'2018-03-18 22:46:22','24.57',''),(2988,2213,'2018-03-18 22:46:22','33.48',''),(2989,2212,'2018-03-18 22:49:22','24.17',''),(2990,2213,'2018-03-18 22:49:23','33.79',''),(2991,2207,'2018-03-18 22:50:04','23.9',''),(2992,2208,'2018-03-18 22:50:04','35.48',''),(2993,2209,'2018-03-18 22:50:04','98.64',''),(2994,2210,'2018-03-18 22:50:04','739.86',''),(2995,2207,'2018-03-18 22:50:04','23.9',''),(2996,2208,'2018-03-18 22:50:04','35.48',''),(2997,2207,'2018-03-18 22:57:26','23.97',''),(2998,2208,'2018-03-18 22:57:26','34.87',''),(2999,2209,'2018-03-18 22:57:26','98.62',''),(3000,2210,'2018-03-18 22:57:26','739.71',''),(3001,2224,'2018-03-18 22:57:57','1',''),(3002,2227,'2018-03-18 22:57:57','1',''),(9185,2101,'2020-01-17 11:00:01','4',''),(9845,2117,'2020-01-20 04:00:01','-7',''),(9815,2050,'2020-01-20 02:00:19','747',''),(3011,2230,'2018-03-18 23:00:45','1',''),(3012,2233,'2018-03-18 23:00:45','1',''),(3013,2230,'2018-03-18 23:10:26','1',''),(3014,2233,'2018-03-19 00:20:30','1',''),(3015,2207,'2018-03-18 23:04:37','23.99',''),(3016,2208,'2018-03-18 23:04:37','35.62',''),(3017,2209,'2018-03-18 23:04:37','98.59',''),(3018,2210,'2018-03-18 23:04:37','739.49',''),(3019,2230,'2018-03-18 23:10:32','0',''),(3020,2230,'2018-03-18 23:10:38','1',''),(3021,2230,'2018-03-19 00:20:30','1',''),(3022,2212,'2018-03-18 23:35:45','24.7',''),(3023,2213,'2018-03-18 23:35:45','32.71',''),(3024,2207,'2018-03-18 23:39:54','24.15',''),(3025,2208,'2018-03-18 23:39:54','34.36',''),(3026,2209,'2018-03-18 23:39:54','98.56',''),(3027,2210,'2018-03-18 23:39:54','739.26',''),(3028,2207,'2018-03-18 23:41:04','24.15',''),(3029,2208,'2018-03-18 23:41:04','34.6',''),(3030,2209,'2018-03-18 23:41:04','98.57',''),(3031,2210,'2018-03-18 23:41:04','739.34',''),(3032,2208,'2018-03-18 23:41:04','34.6',''),(3033,2209,'2018-03-18 23:41:04','98.57',''),(3034,2210,'2018-03-18 23:41:04','739.34',''),(3035,2212,'2018-03-18 23:41:26','24.91',''),(3036,2213,'2018-03-18 23:41:26','32.32',''),(3037,2212,'2018-03-18 23:41:26','24.91',''),(3038,2213,'2018-03-18 23:41:26','32.32',''),(3039,2207,'2018-03-18 23:56:47','24.2',''),(3040,2208,'2018-03-18 23:56:47','33.44',''),(3041,2209,'2018-03-18 23:56:47','98.54',''),(3042,2210,'2018-03-18 23:56:47','739.11',''),(9308,2077,'2020-01-18 01:00:02','765',''),(9797,2102,'2020-01-20 02:00:20','78',''),(9993,1613,'2020-01-20 22:00:03','761',''),(9822,2104,'2020-01-20 22:00:04','752',''),(9359,2074,'2020-01-18 04:00:01','4',''),(9534,2020,'2020-01-19 14:00:04','5',''),(9518,2020,'2020-01-18 20:00:01','4',''),(9573,2182,'2020-01-19 02:00:02','758',''),(9134,2090,'2020-01-17 04:00:02','1',''),(3060,2207,'2018-03-19 00:15:31','24.07',''),(3061,2208,'2018-03-19 00:15:31','33.22',''),(3062,2209,'2018-03-19 00:15:31','98.51',''),(3063,2210,'2018-03-19 00:15:31','738.89',''),(3064,2207,'2018-03-19 00:29:53','24.06',''),(3065,2208,'2018-03-19 00:29:53','32.98',''),(3066,2209,'2018-03-19 00:29:53','98.49',''),(3067,2210,'2018-03-19 00:29:53','738.74',''),(3068,2207,'2018-03-19 00:33:24','24.1',''),(3069,2208,'2018-03-19 00:33:24','32.67',''),(3070,2209,'2018-03-19 00:33:24','98.5',''),(3071,2210,'2018-03-19 00:33:24','738.81',''),(3072,2207,'2018-03-19 00:33:24','24.1',''),(3073,2208,'2018-03-19 00:33:24','32.67',''),(3074,2209,'2018-03-19 00:33:24','98.5',''),(3075,2210,'2018-03-19 00:33:24','738.81',''),(3076,2212,'2018-03-19 00:35:25','24.99',''),(3077,2213,'2018-03-19 00:35:25','30.7',''),(3078,2212,'2018-03-19 00:35:25','24.99',''),(3079,2213,'2018-03-19 00:35:25','30.7',''),(3080,2207,'2018-03-19 00:46:37','24.06',''),(3081,2208,'2018-03-19 00:46:37','32.59',''),(3082,2209,'2018-03-19 00:46:37','98.46',''),(3083,2210,'2018-03-19 00:46:37','738.51',''),(3084,2207,'2018-03-19 01:10:52','23.93',''),(3085,2208,'2018-03-19 01:10:52','32.57',''),(3086,2209,'2018-03-19 01:10:52','98.43',''),(3087,2210,'2018-03-19 01:10:52','738.29',''),(3088,2207,'2018-03-19 01:26:34','23.73',''),(3089,2208,'2018-03-19 01:26:35','32.5',''),(3090,2209,'2018-03-19 01:26:35','98.41',''),(3091,2210,'2018-03-19 01:26:35','738.14',''),(3092,2207,'2018-03-19 01:26:45','23.73',''),(3093,2208,'2018-03-19 01:26:45','32.5',''),(3094,2209,'2018-03-19 01:26:45','98.41',''),(3095,2210,'2018-03-19 01:26:45','738.14',''),(3096,2212,'2018-03-19 01:28:08','24.83',''),(3097,2213,'2018-03-19 01:28:08','30.33',''),(3098,2212,'2018-03-19 01:28:08','24.83',''),(3099,2213,'2018-03-19 01:28:08','30.33',''),(3100,2207,'2018-03-19 01:47:09','23.57',''),(3101,2208,'2018-03-19 01:47:09','32.06',''),(3102,2209,'2018-03-19 01:47:09','98.38',''),(3103,2210,'2018-03-19 01:47:09','737.91',''),(9207,2156,'2020-01-17 22:00:07','744',''),(9795,2090,'2020-01-20 01:00:12','-9',''),(9767,1613,'2020-01-19 23:00:04','763',''),(9648,1605,'2020-01-19 10:00:01','-1',''),(9242,2047,'2020-01-18 10:00:01','4',''),(9575,2009,'2020-01-19 02:00:01','1',''),(9533,2009,'2020-01-18 23:00:01','-1',''),(9522,2063,'2020-01-19 02:00:01','-1',''),(9474,1605,'2020-01-18 17:00:02','-1',''),(9542,2128,'2020-01-18 23:00:02','7',''),(9135,2101,'2020-01-17 04:00:02','5',''),(3121,2207,'2018-03-19 02:12:34','23.57',''),(3122,2208,'2018-03-19 02:12:34','31.74',''),(3123,2209,'2018-03-19 02:12:34','98.35',''),(3124,2210,'2018-03-19 02:12:34','737.69',''),(3125,2207,'2018-03-19 02:18:55','23.5',''),(3126,2208,'2018-03-19 02:18:55','31.61',''),(3127,2209,'2018-03-19 02:18:55','98.34',''),(3128,2210,'2018-03-19 02:18:55','737.61',''),(3129,2207,'2018-03-19 02:26:37','23.5',''),(3130,2208,'2018-03-19 02:18:55','31.61',''),(3131,2209,'2018-03-19 02:18:55','98.34',''),(3132,2210,'2018-03-19 02:18:55','737.61',''),(3133,2212,'2018-03-19 02:24:37','24.69',''),(3134,2213,'2018-03-19 02:24:37','29.51',''),(3135,2212,'2018-03-19 02:24:38','24.69',''),(3136,2213,'2018-03-19 02:24:38','29.51',''),(3137,2208,'2018-03-19 02:26:37','31.5',''),(3138,2209,'2018-03-19 02:26:37','98.33',''),(3139,2210,'2018-03-19 02:26:37','737.54',''),(3140,2207,'2018-03-19 02:32:38','23.53',''),(3141,2208,'2018-03-19 02:32:38','31.42',''),(3142,2209,'2018-03-19 02:32:38','98.36',''),(3143,2210,'2018-03-19 02:32:38','737.76',''),(3144,2207,'2018-03-19 02:32:59','23.43',''),(3145,2208,'2018-03-19 02:32:59','31.51',''),(3146,2209,'2018-03-19 02:32:59','98.33',''),(3147,2210,'2018-03-19 02:32:59','737.54',''),(3148,2207,'2018-03-19 02:38:30','23.52',''),(3149,2208,'2018-03-19 02:38:30','31.41',''),(3150,2209,'2018-03-19 02:38:30','98.3',''),(3151,2210,'2018-03-19 02:38:30','737.31',''),(3152,2207,'2018-03-19 02:57:33','23.49',''),(3153,2208,'2018-03-19 02:57:33','31.07',''),(3154,2209,'2018-03-19 02:57:34','98.27',''),(3155,2210,'2018-03-19 02:57:34','737.09',''),(9200,2090,'2020-01-17 13:00:01','1',''),(9842,2090,'2020-01-20 04:00:01','-6',''),(9969,2169,'2020-01-20 16:00:47','-2',''),(3163,2207,'2018-03-19 03:16:17','23.5',''),(3164,2208,'2018-03-19 03:16:17','30.96',''),(3165,2209,'2018-03-19 03:16:17','98.26',''),(3166,2210,'2018-03-19 03:16:17','737.01',''),(3167,2207,'2018-03-19 03:19:08','23.5',''),(3168,2208,'2018-03-19 03:16:17','30.96',''),(3169,2209,'2018-03-19 03:16:17','98.26',''),(3170,2210,'2018-03-19 03:16:17','737.01',''),(3171,2208,'2018-03-19 03:19:08','30.95',''),(3172,2209,'2018-03-19 03:19:08','98.24',''),(3173,2210,'2018-03-19 03:19:08','736.86',''),(3174,2212,'2018-03-19 03:23:12','24.65',''),(3175,2213,'2018-03-19 03:23:12','28.84',''),(3176,2212,'2018-03-19 03:23:12','24.65',''),(3177,2213,'2018-03-19 03:23:12','28.84',''),(3178,2207,'2018-03-19 03:31:40','23.53',''),(3179,2208,'2018-03-19 03:31:41','30.82',''),(3180,2209,'2018-03-19 03:31:41','98.22',''),(3181,2210,'2018-03-19 03:31:41','736.71',''),(3182,2207,'2018-03-19 03:57:35','23.5',''),(3183,2208,'2018-03-19 03:57:35','30.57',''),(3184,2209,'2018-03-19 03:57:35','98.19',''),(3185,2210,'2018-03-19 03:57:35','736.49',''),(3186,2207,'2018-03-19 04:05:17','23.52',''),(3187,2208,'2018-03-19 04:05:17','30.6',''),(3188,2209,'2018-03-19 04:05:17','98.16',''),(3189,2210,'2018-03-19 04:05:17','736.26',''),(3190,2207,'2018-03-19 04:12:48','23.53',''),(3191,2208,'2018-03-19 04:12:48','30.52',''),(3192,2209,'2018-03-19 04:12:49','98.17',''),(3193,2210,'2018-03-19 04:12:49','736.34',''),(3194,2207,'2018-03-19 04:18:20','23.53',''),(3195,2208,'2018-03-19 04:12:49','30.52',''),(3196,2209,'2018-03-19 04:12:49','98.17',''),(3197,2210,'2018-03-19 04:12:49','736.34',''),(3198,2212,'2018-03-19 04:14:35','24.69',''),(3199,2213,'2018-03-19 04:14:36','28.52',''),(3200,2212,'2018-03-19 04:14:36','24.69',''),(3201,2213,'2018-03-19 04:14:36','28.52',''),(3202,2208,'2018-03-19 04:18:20','30.47',''),(3203,2209,'2018-03-19 04:18:20','98.14',''),(3204,2210,'2018-03-19 04:18:20','736.11',''),(3205,2207,'2018-03-19 04:30:32','23.6',''),(3206,2208,'2018-03-19 04:30:32','30.4',''),(3207,2209,'2018-03-19 04:30:32','98.11',''),(3208,2210,'2018-03-19 04:30:32','735.89',''),(3209,2207,'2018-03-19 04:57:17','23.55',''),(3210,2208,'2018-03-19 04:57:17','30.13',''),(3211,2209,'2018-03-19 04:57:17','98.08',''),(3212,2210,'2018-03-19 04:57:17','735.66',''),(9846,2128,'2020-01-20 04:00:01','4',''),(9887,1605,'2020-01-20 22:00:03','-1',''),(9753,2020,'2020-01-20 14:00:02','5',''),(9621,2009,'2020-01-19 08:00:01','-0',''),(9045,1610,'2020-01-16 23:00:01','4',''),(9517,2009,'2020-01-18 20:00:01','-1',''),(9512,2117,'2020-01-18 19:00:02','-4',''),(3225,2207,'2018-03-19 05:04:29','23.6',''),(3226,2208,'2018-03-19 05:04:29','30.11',''),(3227,2209,'2018-03-19 05:04:29','98.08',''),(3228,2210,'2018-03-19 05:04:29','735.66',''),(3229,2207,'2018-03-19 05:04:29','23.6',''),(3230,2208,'2018-03-19 05:04:29','30.11',''),(3231,2212,'2018-03-19 05:08:54','24.73',''),(3232,2213,'2018-03-19 05:08:54','28.24',''),(3233,2212,'2018-03-19 05:08:54','24.73',''),(3234,2213,'2018-03-19 05:08:55','28.24',''),(3235,2207,'2018-03-19 05:25:13','23.55',''),(3236,2208,'2018-03-19 05:25:13','29.9',''),(3237,2209,'2018-03-19 05:25:13','98.05',''),(3238,2210,'2018-03-19 05:25:13','735.44',''),(3239,2207,'2018-03-19 05:36:55','23.62',''),(3240,2208,'2018-03-19 05:36:55','29.85',''),(3241,2209,'2018-03-19 05:36:55','98.08',''),(3242,2210,'2018-03-19 05:36:55','735.66',''),(3243,2207,'2018-03-19 05:54:18','23.6',''),(3244,2208,'2018-03-19 05:54:18','29.72',''),(3245,2209,'2018-03-19 05:54:19','98.05',''),(3246,2210,'2018-03-19 05:54:19','735.44',''),(3247,2207,'2018-03-19 06:10:12','23.6',''),(3248,2208,'2018-03-19 05:57:09','29.78',''),(3249,2209,'2018-03-19 05:57:09','98.06',''),(3250,2210,'2018-03-19 05:57:09','735.51',''),(3251,2208,'2018-03-19 05:57:09','29.78',''),(3252,2209,'2018-03-19 05:57:09','98.06',''),(3253,2210,'2018-03-19 05:57:09','735.51',''),(3254,2212,'2018-03-19 05:59:13','24.75',''),(3255,2213,'2018-03-19 05:59:13','27.72',''),(3256,2212,'2018-03-19 05:59:13','24.75',''),(3257,2213,'2018-03-19 05:59:13','27.72',''),(10064,2048,'2020-01-21 03:00:01','80',''),(9752,2009,'2020-01-20 08:00:01','0',''),(9721,1611,'2020-01-19 17:00:00','89',''),(9647,1613,'2020-01-19 08:00:01','764',''),(9241,2021,'2020-01-17 17:00:02','90',''),(9520,2023,'2020-01-19 14:00:04','764',''),(9414,2104,'2020-01-18 11:00:02','748',''),(3270,2208,'2018-03-19 06:10:12','29.59',''),(3271,2209,'2018-03-19 06:10:12','98.08',''),(3272,2210,'2018-03-19 06:10:12','735.66',''),(3273,2207,'2018-03-19 06:40:17','23.66',''),(3274,2208,'2018-03-19 06:40:17','29.48',''),(3275,2209,'2018-03-19 06:40:18','98.05',''),(3276,2210,'2018-03-19 06:40:18','735.44',''),(3277,2207,'2018-03-19 06:54:40','23.63',''),(3278,2208,'2018-03-19 06:54:40','29.38',''),(3279,2209,'2018-03-19 06:54:40','98.06',''),(3280,2210,'2018-03-19 06:54:40','735.51',''),(3281,2207,'2018-03-19 06:54:40','23.63',''),(3282,2208,'2018-03-19 06:54:40','29.38',''),(3283,2209,'2018-03-19 06:54:40','98.06',''),(3284,2210,'2018-03-19 06:54:40','735.51',''),(3285,2212,'2018-03-19 06:56:22','24.8',''),(3286,2213,'2018-03-19 06:56:22','27.54',''),(3287,2212,'2018-03-19 06:56:22','24.8',''),(3288,2213,'2018-03-19 06:56:22','27.54',''),(3289,2207,'2018-03-19 07:46:20','23.69',''),(3290,2208,'2018-03-19 07:46:20','29.21',''),(3291,2209,'2018-03-19 07:46:20','98.05',''),(3292,2210,'2018-03-19 07:46:20','735.44',''),(3293,2207,'2018-03-19 07:46:20','23.69',''),(3294,2208,'2018-03-19 07:46:20','29.21',''),(3295,2209,'2018-03-19 07:46:20','98.05',''),(3296,2210,'2018-03-19 07:46:20','735.44',''),(3297,2212,'2018-03-19 07:48:20','24.89',''),(3298,2213,'2018-03-19 07:48:20','27.33',''),(3299,2212,'2018-03-19 07:48:21','24.89',''),(3300,2213,'2018-03-19 07:48:21','27.33',''),(9392,2169,'2020-01-18 10:00:01','-11',''),(9931,2180,'2020-01-20 14:00:03','5',''),(9857,1610,'2020-01-20 05:00:04','7',''),(9747,2169,'2020-01-19 19:00:17','-1',''),(9284,2102,'2020-01-17 23:00:04','87',''),(9344,2143,'2020-01-18 02:00:02','-7',''),(9685,2154,'2020-01-19 22:00:12','6',''),(9675,2047,'2020-01-19 14:00:04','4',''),(9617,1605,'2020-01-19 05:00:01','-0',''),(9616,2182,'2020-01-19 04:00:02','761',''),(9138,2117,'2020-01-17 04:00:02','-0',''),(9561,2104,'2020-01-19 01:00:09','743',''),(9618,1610,'2020-01-19 05:00:01','4',''),(9514,1605,'2020-01-18 20:00:01','-2',''),(9473,2182,'2020-01-18 16:00:02','762',''),(9382,2075,'2020-01-18 10:00:01','94',''),(9375,1613,'2020-01-18 05:00:01','764',''),(3326,2207,'2018-03-19 08:05:14','23.7',''),(3327,2208,'2018-03-19 08:05:14','29.05',''),(3328,2209,'2018-03-19 08:05:14','98.07',''),(3329,2210,'2018-03-19 08:05:14','735.59',''),(3330,2212,'2018-03-19 08:39:04','24.91',''),(3331,2213,'2018-03-19 08:39:04','27.05',''),(3332,2212,'2018-03-19 08:39:04','24.91',''),(3333,2213,'2018-03-19 08:39:04','27.05',''),(3334,2207,'2018-03-19 08:43:11','23.77',''),(3335,2208,'2018-03-19 08:43:11','28.84',''),(3336,2209,'2018-03-19 08:43:11','98.07',''),(3337,2210,'2018-03-19 08:43:11','735.59',''),(3338,2207,'2018-03-19 08:43:11','23.77',''),(3339,2208,'2018-03-19 08:43:11','28.84',''),(9352,1611,'2020-01-18 04:00:01','93',''),(9793,2075,'2020-01-20 01:00:12','78',''),(9782,2182,'2020-01-19 23:00:21','753',''),(9749,1610,'2020-01-19 22:00:02','5',''),(9282,2075,'2020-01-17 23:00:04','90',''),(9346,2383,'2020-01-18 02:00:02','82',''),(9713,2382,'2020-01-19 16:00:04','68',''),(9677,2063,'2020-01-19 13:00:01','3',''),(9624,2075,'2020-01-19 10:00:07','93',''),(9615,2384,'2020-01-19 04:00:02','88',''),(9090,2143,'2020-01-17 01:00:01','-3',''),(9600,2075,'2020-01-19 04:00:01','93',''),(9552,2009,'2020-01-19 01:00:08','1',''),(9548,2182,'2020-01-18 23:00:02','758',''),(9472,2384,'2020-01-18 16:00:02','75',''),(9199,2075,'2020-01-17 14:00:08','90',''),(9205,2143,'2020-01-17 17:00:03','-1',''),(3365,2207,'2018-03-19 09:29:19','23.86',''),(3366,2208,'2018-03-19 09:29:19','28.74',''),(3367,2209,'2018-03-19 09:29:19','98.05',''),(3368,2210,'2018-03-19 09:29:19','735.44',''),(3369,2207,'2018-03-19 09:35:00','23.83',''),(3370,2208,'2018-03-19 09:35:00','28.98',''),(3371,2209,'2018-03-19 09:35:01','98.07',''),(3372,2210,'2018-03-19 09:35:01','735.59',''),(3373,2207,'2018-03-19 09:35:01','23.83',''),(3374,2208,'2018-03-19 09:35:01','28.98',''),(3375,2209,'2018-03-19 09:35:01','98.07',''),(3376,2210,'2018-03-19 09:35:01','735.59',''),(3377,2212,'2018-03-19 09:38:29','25.02',''),(3378,2213,'2018-03-19 09:38:29','27.16',''),(3379,2212,'2018-03-19 09:38:29','25.02',''),(3380,2213,'2018-03-19 09:38:29','27.16',''),(3381,2207,'2018-03-19 09:47:53','23.89',''),(3382,2208,'2018-03-19 09:47:53','29.12',''),(3383,2209,'2018-03-19 09:47:54','98.08',''),(3384,2210,'2018-03-19 09:47:54','735.66',''),(3385,2212,'2018-03-19 09:56:22','25.21',''),(3386,2213,'2018-03-19 09:56:22','28.1',''),(3387,2212,'2018-03-19 09:58:07','25.78',''),(3388,2213,'2018-03-19 09:58:07','27.25',''),(3389,2212,'2018-03-19 10:00:33','26.33',''),(3390,2213,'2018-03-19 10:00:33','26.65',''),(3391,2212,'2018-03-19 10:03:59','26.83',''),(3392,2213,'2018-03-19 10:03:59','25.94',''),(3393,2212,'2018-03-19 10:09:35','27.34',''),(3394,2213,'2018-03-19 10:09:35','25.55',''),(3395,2207,'2018-03-19 10:32:01','23.76',''),(3396,2208,'2018-03-19 10:32:01','30.61',''),(3397,2209,'2018-03-19 11:18:30','98.08',''),(3398,2210,'2018-03-19 11:18:30','735.66',''),(3399,2207,'2018-03-19 10:32:01','23.76',''),(3400,2208,'2018-03-19 10:32:01','30.61',''),(3401,2212,'2018-03-19 10:34:59','27.72',''),(3402,2213,'2018-03-19 10:34:59','24.92',''),(3403,2212,'2018-03-19 10:34:59','27.72',''),(3404,2213,'2018-03-19 10:34:59','24.92',''),(3405,2212,'2018-03-19 10:57:48','28.24',''),(3406,2213,'2018-03-19 10:57:48','25.53',''),(9385,2104,'2020-01-18 10:00:01','750',''),(9794,2077,'2020-01-20 01:00:12','743',''),(9781,2384,'2020-01-19 23:00:21','90',''),(9313,2117,'2020-01-18 01:00:02','-4',''),(9306,2074,'2020-01-18 01:00:02','5',''),(9712,2128,'2020-01-19 16:00:04','7',''),(9684,2143,'2020-01-19 13:00:01','-5',''),(9625,2077,'2020-01-19 14:00:04','747',''),(9248,2102,'2020-01-17 22:00:07','93',''),(9614,2180,'2020-01-19 04:00:02','3',''),(3425,2212,'2018-03-19 11:06:44','28.75',''),(3426,2213,'2018-03-19 11:06:45','25.21',''),(3427,2207,'2018-03-19 11:18:30','24.12',''),(3428,2208,'2018-03-19 11:18:30','35.4',''),(9356,2036,'2020-01-18 04:00:01','-1',''),(9817,2074,'2020-01-20 22:00:04','6',''),(9808,2180,'2020-01-20 02:00:20','4',''),(9837,2047,'2020-01-20 04:00:01','8',''),(9381,2074,'2020-01-18 14:00:01','4',''),(9233,2169,'2020-01-17 16:00:11','-4',''),(9759,2169,'2020-01-19 23:00:21','-1',''),(9729,2063,'2020-01-19 17:00:01','4',''),(9663,2130,'2020-01-19 11:00:01','752',''),(9626,2090,'2020-01-19 17:00:01','-2',''),(9296,1610,'2020-01-18 07:00:01','4',''),(9613,2169,'2020-01-19 04:00:02','-2',''),(9080,2075,'2020-01-17 01:00:01','94',''),(9599,2063,'2020-01-19 04:00:01','0',''),(9563,2128,'2020-01-19 01:00:09','8',''),(9547,2384,'2020-01-18 23:00:02','92',''),(9471,2180,'2020-01-18 16:00:02','5',''),(9413,2102,'2020-01-18 11:00:02','96',''),(9318,2383,'2020-01-18 01:00:02','82',''),(9260,2009,'2020-01-17 19:00:02','2',''),(9839,2050,'2020-01-20 04:00:01','746',''),(9778,2383,'2020-01-19 23:00:21','89',''),(9737,2180,'2020-01-19 22:00:12','6',''),(9225,2074,'2020-01-17 16:00:11','4',''),(9291,2156,'2020-01-17 23:00:05','743',''),(9710,2077,'2020-01-19 16:00:04','748',''),(9758,2143,'2020-01-19 22:00:12','-2',''),(9661,2128,'2020-01-19 11:00:01','8',''),(9666,2156,'2020-01-19 11:00:02','753',''),(9634,2154,'2020-01-19 10:00:08','5',''),(9570,2169,'2020-01-19 01:00:09','1',''),(9094,2169,'2020-01-17 01:00:02','-6',''),(9598,2048,'2020-01-19 04:00:01','85',''),(9559,2090,'2020-01-19 01:00:09','-7',''),(9546,2180,'2020-01-18 23:00:02','7',''),(9470,2169,'2020-01-18 16:00:02','-7',''),(9460,2101,'2020-01-18 16:00:02','7',''),(9384,2102,'2020-01-18 10:00:01','91',''),(9273,2143,'2020-01-17 23:00:05','-2',''),(9176,1611,'2020-01-17 08:00:05','96',''),(9789,2048,'2020-01-20 01:00:12','93',''),(9776,2143,'2020-01-19 23:00:21','-3',''),(9769,2023,'2020-01-20 16:00:46','764',''),(9312,2104,'2020-01-18 01:00:02','752',''),(9250,2130,'2020-01-17 22:00:07','754',''),(9732,2104,'2020-01-19 22:00:11','744',''),(9709,2075,'2020-01-19 16:00:04','91',''),(9681,2128,'2020-01-19 14:00:04','8',''),(9665,2383,'2020-01-19 11:00:02','90',''),(9706,2047,'2020-01-19 16:00:04','5',''),(9611,2383,'2020-01-19 04:00:02','88',''),(9049,2021,'2020-01-16 23:00:04','96',''),(9658,2063,'2020-01-19 11:00:01','-1',''),(9736,2169,'2020-01-19 17:00:01','-2',''),(9545,2169,'2020-01-18 23:00:02','2',''),(9469,2156,'2020-01-18 16:00:02','752',''),(9467,2154,'2020-01-18 16:00:02','8',''),(9431,2090,'2020-01-18 13:00:01','3',''),(9211,2182,'2020-01-17 14:00:09','748',''),(9380,2063,'2020-01-18 14:00:01','1',''),(9240,2009,'2020-01-17 17:00:02','3',''),(9836,2036,'2020-01-20 04:00:01','-0',''),(9803,2143,'2020-01-20 01:00:12','-2',''),(9150,1611,'2020-01-17 05:00:01','93',''),(9987,2169,'2020-01-20 22:00:04','-4',''),(9745,2117,'2020-01-19 19:00:17','-8',''),(9383,2090,'2020-01-18 11:00:02','-0',''),(9253,2169,'2020-01-17 17:00:03','-4',''),(9707,2048,'2020-01-19 16:00:04','84',''),(9796,2101,'2020-01-20 01:00:12','7',''),(9664,2154,'2020-01-19 11:00:02','6',''),(9232,2383,'2020-01-17 16:00:11','79',''),(9043,2023,'2020-01-16 22:00:08','758',''),(9704,2023,'2020-01-19 16:00:04','765',''),(9529,1605,'2020-01-18 23:00:01','-1',''),(9569,2156,'2020-01-19 01:00:09','758',''),(9484,2075,'2020-01-18 22:00:16','86',''),(9410,2075,'2020-01-18 11:00:02','87',''),(9275,1611,'2020-01-17 22:00:01','90',''),(9305,2063,'2020-01-18 01:00:02','-1',''),(9191,2169,'2020-01-17 11:00:02','-2',''),(9835,2021,'2020-01-20 04:00:01','90',''),(9774,2104,'2020-01-19 23:00:21','743',''),(9274,2169,'2020-01-17 22:00:07','-5',''),(9266,2169,'2020-01-17 19:00:03','-5',''),(9743,2063,'2020-01-19 19:00:17','1',''),(9757,2117,'2020-01-19 23:00:21','-8',''),(9610,2154,'2020-01-19 04:00:02','5',''),(9252,2383,'2020-01-17 22:00:07','79',''),(9568,2383,'2020-01-19 01:00:09','92',''),(9152,2036,'2020-01-17 17:00:03','1',''),(9742,2021,'2020-01-19 19:00:17','89',''),(9535,2021,'2020-01-18 23:00:01','90',''),(9543,2143,'2020-01-18 23:00:02','-6',''),(9464,2382,'2020-01-18 16:00:02','87',''),(9792,2074,'2020-01-20 01:00:12','6',''),(9302,2036,'2020-01-18 01:00:02','0',''),(9315,2130,'2020-01-18 01:00:02','743',''),(9189,2383,'2020-01-17 11:00:01','81',''),(9962,2130,'2020-01-20 22:00:04','752',''),(9756,2090,'2020-01-19 23:00:21','-3',''),(9746,2143,'2020-01-19 19:00:17','-2',''),(9257,1605,'2020-01-17 22:00:01','2',''),(9740,2009,'2020-01-19 19:00:17','0',''),(9659,2075,'2020-01-19 11:00:01','94',''),(9802,2130,'2020-01-20 01:00:12','749',''),(9265,2143,'2020-01-17 19:00:03','-2',''),(9609,2143,'2020-01-19 04:00:02','-9',''),(9126,1611,'2020-01-17 04:00:01','96',''),(9566,2143,'2020-01-19 01:00:09','1',''),(9493,2143,'2020-01-18 22:00:17','-7',''),(9488,2102,'2020-01-18 22:00:16','89',''),(9029,1613,'2020-01-16 20:00:03','758',''),(9540,2104,'2020-01-18 23:00:02','748',''),(9439,2169,'2020-01-18 13:00:01','-9',''),(9188,2143,'2020-01-17 11:00:01','-1',''),(9971,2384,'2020-01-20 22:00:04','87',''),(9771,2075,'2020-01-19 23:00:21','93',''),(9750,1611,'2020-01-19 20:00:05','91',''),(9662,2382,'2020-01-19 11:00:01','72',''),(9194,2182,'2020-01-17 11:00:02','748',''),(9539,2102,'2020-01-18 23:00:02','95',''),(9451,2009,'2020-01-18 16:00:01','0',''),(9255,2384,'2020-01-17 22:00:07','75',''),(9860,2036,'2020-01-20 11:00:03','-0',''),(9791,2063,'2020-01-20 01:00:12','-6',''),(9720,1610,'2020-01-19 17:00:00','5',''),(9301,2023,'2020-01-18 01:00:02','765',''),(9365,2128,'2020-01-18 04:00:01','6',''),(9705,2036,'2020-01-19 16:00:04','-1',''),(9708,2063,'2020-01-19 16:00:04','4',''),(9607,2382,'2020-01-19 04:00:02','67',''),(9230,2130,'2020-01-17 16:00:11','754',''),(9565,2130,'2020-01-19 01:00:09','752',''),(9068,1605,'2020-01-17 13:00:01','1',''),(9702,2020,'2020-01-19 16:00:04','4',''),(9577,2036,'2020-01-19 14:00:04','-0',''),(9627,2101,'2020-01-19 23:00:21','6',''),(9567,2154,'2020-01-19 01:00:09','7',''),(9485,2077,'2020-01-18 23:00:02','764',''),(9149,2182,'2020-01-17 04:00:02','749',''),(9394,2384,'2020-01-18 10:00:01','73',''),(9224,2063,'2020-01-17 16:00:11','1',''),(9187,2382,'2020-01-17 11:00:01','88',''),(9862,2048,'2020-01-20 14:00:02','90',''),(9718,2182,'2020-01-19 16:00:05','747',''),(9221,2021,'2020-01-17 16:00:11','90',''),(9204,2382,'2020-01-17 14:00:08','88',''),(9703,2021,'2020-01-19 16:00:04','88',''),(9695,2063,'2020-01-19 14:00:04','3',''),(9790,2050,'2020-01-20 01:00:12','747',''),(9680,2117,'2020-01-19 13:00:01','-7',''),(9229,2382,'2020-01-17 16:00:11','87',''),(9564,2382,'2020-01-19 01:00:09','74',''),(9069,1610,'2020-01-17 16:00:05','4',''),(9597,2009,'2020-01-19 04:00:01','-0',''),(9532,1613,'2020-01-18 23:00:01','762',''),(9511,2090,'2020-01-18 19:00:02','1',''),(9465,2130,'2020-01-18 16:00:02','743',''),(9458,2077,'2020-01-18 16:00:01','764',''),(9192,2180,'2020-01-17 11:00:02','5',''),(9354,2009,'2020-01-18 04:00:01','1',''),(9409,2047,'2020-01-18 11:00:02','5',''),(9186,2102,'2020-01-17 11:00:01','94',''),(9203,2117,'2020-01-17 13:00:02','3',''),(9070,1611,'2020-01-17 01:00:01','90',''),(9558,2077,'2020-01-19 01:00:09','748',''),(9153,2048,'2020-01-17 14:00:08','96',''),(9184,2090,'2020-01-17 11:00:01','0',''),(9853,2180,'2020-01-20 04:00:01','6',''),(9770,2048,'2020-01-19 23:00:21','85',''),(9227,2077,'2020-01-17 16:00:11','764',''),(9807,2169,'2020-01-20 01:00:12','1',''),(9788,2047,'2020-01-20 01:00:12','7',''),(9717,2384,'2020-01-19 16:00:05','82',''),(9388,2382,'2020-01-18 10:00:01','87',''),(9259,1611,'2020-01-17 19:00:01','91',''),(9893,2009,'2020-01-20 22:00:04','-1',''),(9719,1605,'2020-01-19 17:00:00','0',''),(9657,2048,'2020-01-19 11:00:01','86',''),(9711,2104,'2020-01-19 16:00:04','744',''),(9286,2117,'2020-01-17 23:00:05','2',''),(9606,2128,'2020-01-19 04:00:02','7',''),(9071,1613,'2020-01-17 01:00:01','759',''),(9620,1613,'2020-01-19 05:00:01','763',''),(9516,1611,'2020-01-18 20:00:01','92',''),(9537,2075,'2020-01-18 23:00:02','89',''),(9462,2104,'2020-01-18 16:00:02','749',''),(9457,2075,'2020-01-18 16:00:01','86',''),(9387,2128,'2020-01-18 14:00:02','6',''),(9386,2117,'2020-01-18 17:00:03','-2',''),(9183,2075,'2020-01-17 11:00:01','90',''),(9852,2169,'2020-01-20 04:00:01','-4',''),(9763,2023,'2020-01-19 22:00:11','764',''),(9780,2180,'2020-01-19 23:00:21','4',''),(9326,2009,'2020-01-18 02:00:02','-1',''),(9079,2063,'2020-01-17 01:00:01','2',''),(9264,2090,'2020-01-17 19:00:02','0',''),(9821,2101,'2020-01-20 02:00:20','7',''),(9701,1613,'2020-01-19 16:00:03','765',''),(9651,2009,'2020-01-19 10:00:07','-1',''),(9773,2102,'2020-01-19 23:00:21','78',''),(9285,2104,'2020-01-17 23:00:04','765',''),(9562,2117,'2020-01-19 01:00:09','-8',''),(9074,2021,'2020-01-17 01:00:01','97',''),(9574,1611,'2020-01-19 02:00:00','89',''),(9515,1610,'2020-01-18 20:00:01','5',''),(9455,2063,'2020-01-18 16:00:01','-0',''),(9461,2102,'2020-01-18 16:00:02','89',''),(9190,2156,'2020-01-17 11:00:01','744',''),(9217,2169,'2020-01-17 14:00:09','-3',''),(9213,1611,'2020-01-17 14:00:02','90',''),(9198,2063,'2020-01-17 13:00:01','0',''),(9866,2090,'2020-01-20 10:00:01','-6',''),(9715,2169,'2020-01-19 16:00:05','-2',''),(9099,1613,'2020-01-17 02:00:00','761',''),(9603,2101,'2020-01-19 04:00:01','6',''),(9454,2048,'2020-01-18 16:00:01','92',''),(9154,2063,'2020-01-17 11:00:01','-1',''),(9210,2384,'2020-01-17 14:00:09','83',''),(9906,2154,'2020-01-20 11:00:03','5',''),(9263,2036,'2020-01-17 19:00:02','-1',''),(9868,2102,'2020-01-20 10:00:01','76',''),(9100,2009,'2020-01-17 14:00:08','1',''),(9095,2180,'2020-01-17 01:00:02','5',''),(9508,2023,'2020-01-18 19:00:01','764',''),(9393,2180,'2020-01-18 10:00:01','3',''),(9799,2117,'2020-01-20 01:00:12','-3',''),(9089,2130,'2020-01-17 01:00:01','758',''),(9060,2143,'2020-01-16 23:00:04','2',''),(9528,2021,'2020-01-18 22:00:16','92',''),(9262,2021,'2020-01-17 19:00:02','91',''),(9220,2009,'2020-01-17 16:00:10','3',''),(9844,2102,'2020-01-20 04:00:01','76',''),(9762,2021,'2020-01-19 22:00:11','91',''),(9779,2156,'2020-01-19 23:00:21','749',''),(9223,2048,'2020-01-17 16:00:11','95',''),(9093,2156,'2020-01-17 01:00:02','747',''),(9226,2075,'2020-01-17 16:00:11','89',''),(9102,2021,'2020-01-17 10:00:22','97',''),(9694,2009,'2020-01-19 17:00:01','1',''),(9693,1611,'2020-01-19 14:00:02','87',''),(9646,1611,'2020-01-19 08:00:01','93',''),(9744,2090,'2020-01-19 19:00:17','-3',''),(9228,2102,'2020-01-17 16:00:11','93',''),(9605,2104,'2020-01-19 04:00:01','745',''),(9096,2384,'2020-01-17 01:00:02','79',''),(9140,2382,'2020-01-17 04:00:02','89',''),(9652,1605,'2020-01-19 11:00:00','1',''),(9527,2020,'2020-01-18 22:00:16','5',''),(9144,2383,'2020-01-17 04:00:02','86',''),(9656,2047,'2020-01-19 11:00:01','4',''),(9231,2154,'2020-01-17 16:00:11','7',''),(9148,2384,'2020-01-17 04:00:02','82',''),(9212,1605,'2020-01-17 14:00:02','2',''),(9325,1613,'2020-01-18 02:00:01','765',''),(9110,2090,'2020-01-17 02:00:01','-0',''),(8998,1613,'2020-01-16 17:00:01','755',''),(9892,1611,'2020-01-20 11:00:01','91',''),(9181,2021,'2020-01-17 11:00:01','93',''),(9942,2020,'2020-01-20 16:00:46','4',''),(9209,2180,'2020-01-17 14:00:09','5',''),(9222,2047,'2020-01-17 16:00:11','4',''),(9129,2048,'2020-01-17 04:00:01','96',''),(9304,2050,'2020-01-18 01:00:02','764',''),(9105,2048,'2020-01-17 02:00:01','93',''),(9161,2104,'2020-01-17 22:00:07','766',''),(9132,2075,'2020-01-17 04:00:01','89',''),(9133,2077,'2020-01-17 04:00:01','765',''),(9841,2077,'2020-01-20 04:00:01','742',''),(9283,2101,'2020-01-17 23:00:04','5',''),(9136,2102,'2020-01-17 04:00:02','96',''),(9137,2104,'2020-01-17 04:00:02','766',''),(9097,2182,'2020-01-17 01:00:02','752',''),(9139,2128,'2020-01-17 04:00:02','8',''),(9155,2074,'2020-01-17 14:00:08','5',''),(9526,2009,'2020-01-18 22:00:16','-2',''),(9143,2154,'2020-01-17 04:00:02','6',''),(9145,2156,'2020-01-17 04:00:02','743',''),(9147,2180,'2020-01-17 04:00:02','6',''),(9236,2182,'2020-01-17 16:00:11','750',''),(9239,1611,'2020-01-17 17:00:01','91',''),(9109,2077,'2020-01-17 02:00:01','764',''),(9077,2048,'2020-01-17 01:00:01','93',''),(9160,2102,'2020-01-17 10:00:22','96',''),(9087,2128,'2020-01-17 01:00:01','9',''),(9477,1613,'2020-01-18 17:00:02','764',''),(9141,2130,'2020-01-17 04:00:02','752',''),(9151,1613,'2020-01-17 05:00:01','762',''),(9112,2102,'2020-01-17 02:00:01','98',''),(9890,1613,'2020-01-20 16:00:46','764',''),(9751,1613,'2020-01-19 20:00:05','764',''),(9111,2101,'2020-01-17 02:00:01','1',''),(9238,1610,'2020-01-17 17:00:01','5',''),(9108,2075,'2020-01-17 02:00:01','94',''),(8971,1605,'2020-01-16 14:00:00','4',''),(9261,2020,'2020-01-17 19:00:02','5',''),(9075,2023,'2020-01-17 01:00:01','764',''),(9036,2143,'2020-01-16 22:00:09','1',''),(9088,2382,'2020-01-17 01:00:01','93',''),(9142,2143,'2020-01-17 04:00:02','-2',''),(9146,2169,'2020-01-17 04:00:02','-3',''),(8970,2384,'2020-01-16 14:00:01','82',''),(8881,2023,'2020-01-16 04:00:01','753',''),(9038,1610,'2020-01-16 22:00:02','5',''),(8963,2130,'2020-01-16 14:00:01','765',''),(9208,2169,'2020-01-17 13:00:02','-3',''),(8977,1605,'2020-01-16 16:00:00','4',''),(9092,2383,'2020-01-17 01:00:01','82',''),(9035,2117,'2020-01-16 22:00:08','1',''),(8914,2128,'2020-01-16 10:00:01','1',''),(8888,2090,'2020-01-16 04:00:01','-1',''),(8975,2090,'2020-01-16 14:00:01','0',''),(8962,2382,'2020-01-16 14:00:01','89',''),(9086,2117,'2020-01-17 01:00:01','2',''),(8913,2117,'2020-01-16 14:00:01','1',''),(9019,2009,'2020-01-16 19:00:03','2',''),(8912,2102,'2020-01-16 14:00:01','91',''),(8911,2090,'2020-01-16 11:00:08','-1',''),(8910,2075,'2020-01-16 10:00:01','92',''),(8909,2074,'2020-01-17 02:00:01','4',''),(8968,2169,'2020-01-16 14:00:01','-1',''),(8908,2063,'2020-01-16 17:00:06','1',''),(8907,2050,'2020-01-16 23:00:04','764',''),(8906,2048,'2020-01-16 10:00:01','97',''),(8905,2036,'2020-01-16 11:00:07','-0',''),(8904,2023,'2020-01-16 17:00:06','753',''),(9004,2104,'2020-01-16 22:00:08','765',''),(8903,2021,'2020-01-16 10:00:01','93',''),(8900,1611,'2020-01-16 05:00:01','93',''),(8902,2009,'2020-01-16 11:00:07','4',''),(8969,2180,'2020-01-16 14:00:01','6',''),(8880,2021,'2020-01-16 04:00:01','93',''),(9037,2169,'2020-01-16 22:00:09','-3',''),(8959,2077,'2020-01-16 22:00:08','766',''),(9182,2047,'2020-01-17 11:00:01','5',''),(8937,2048,'2020-01-16 11:00:07','94',''),(9091,2154,'2020-01-17 01:00:01','8',''),(9034,2063,'2020-01-16 23:00:04','-1',''),(8886,2074,'2020-01-16 04:00:01','4',''),(8887,2075,'2020-01-16 04:00:01','92',''),(8974,2036,'2020-01-16 17:00:06','1',''),(8961,2128,'2020-01-16 22:00:08','4',''),(9085,2104,'2020-01-17 01:00:01','770',''),(8889,2102,'2020-01-16 04:00:01','91',''),(9018,1613,'2020-01-16 19:00:01','755',''),(8890,2117,'2020-01-16 04:00:01','1',''),(8891,2128,'2020-01-16 04:00:01','1',''),(8892,2382,'2020-01-16 04:00:01','95',''),(8893,2130,'2020-01-16 04:00:01','770',''),(8967,2156,'2020-01-16 14:00:01','753',''),(8894,2383,'2020-01-16 04:00:02','93',''),(8895,2156,'2020-01-16 04:00:02','755',''),(8896,2169,'2020-01-16 04:00:02','-2',''),(8897,2180,'2020-01-16 04:00:02','5',''),(8898,2384,'2020-01-16 04:00:02','90',''),(9003,2102,'2020-01-16 22:00:08','87',''),(8931,1605,'2020-01-16 11:00:07','5',''),(8899,1610,'2020-01-16 05:00:01','6',''),(8933,1611,'2020-01-16 11:00:07','92',''),(8901,1613,'2020-01-16 05:00:01','754',''),(8955,2021,'2020-01-16 17:00:06','92',''),(8978,1610,'2020-01-16 19:00:01','7',''),(8958,2075,'2020-01-16 22:00:08','96',''),(9081,2077,'2020-01-17 01:00:01','764',''),(9033,2036,'2020-01-16 23:00:04','2',''),(9159,2101,'2020-01-17 10:00:22','5',''),(8976,2143,'2020-01-16 14:00:01','0',''),(8939,2077,'2020-01-16 11:00:07','766',''),(8960,2090,'2020-01-16 13:00:03','0',''),(9106,2050,'2020-01-17 23:00:04','765',''),(9017,1611,'2020-01-16 19:00:01','93',''),(9014,2384,'2020-01-16 22:00:09','87',''),(8940,2128,'2020-01-16 11:00:08','4',''),(8973,2009,'2020-01-16 14:00:01','5',''),(8972,1610,'2020-01-16 14:00:00','7',''),(8966,2383,'2020-01-16 14:00:01','90',''),(8943,2154,'2020-01-16 11:00:08','7',''),(8952,1613,'2020-01-16 16:00:01','753',''),(8951,1611,'2020-01-16 16:00:01','92',''),(8950,1610,'2020-01-16 13:00:02','8',''),(8947,2180,'2020-01-16 11:00:08','6',''),(8949,1605,'2020-01-16 13:00:02','5',''),(8932,1610,'2020-01-16 11:00:07','8',''),(8979,2009,'2020-01-16 16:00:01','4',''),(8954,2020,'2020-01-16 14:00:01','8',''),(8935,2020,'2020-01-16 11:00:07','8',''),(8936,2021,'2020-01-16 11:00:07','92',''),(8957,2048,'2020-01-16 14:00:01','94',''),(9078,2050,'2020-01-17 01:00:01','765',''),(9032,2023,'2020-01-16 20:00:06','755',''),(9158,2090,'2020-01-17 10:00:22','1',''),(8938,2075,'2020-01-16 11:00:07','96',''),(9101,2020,'2020-01-17 17:00:02','4',''),(9082,2090,'2020-01-17 01:00:01','-0',''),(9016,1605,'2020-01-16 22:00:02','2',''),(9013,2180,'2020-01-16 22:00:09','5',''),(9098,1611,'2020-01-17 02:00:00','92',''),(8941,2382,'2020-01-16 11:00:08','89',''),(8942,2130,'2020-01-16 11:00:08','765',''),(8965,2154,'2020-01-16 14:00:01','7',''),(8989,2154,'2020-01-16 16:00:01','6',''),(8944,2383,'2020-01-16 11:00:08','90',''),(8945,2156,'2020-01-16 11:00:08','753',''),(8946,2169,'2020-01-16 11:00:08','-1',''),(8993,2180,'2020-01-16 16:00:02','5',''),(8948,2384,'2020-01-16 11:00:08','82',''),(9028,1611,'2020-01-16 20:00:03','92',''),(8934,1613,'2020-01-16 11:00:07','753',''),(8996,1605,'2020-01-16 17:00:01','2',''),(9001,2048,'2020-01-16 22:00:08','93',''),(8953,2009,'2020-01-16 13:00:02','5',''),(8980,2020,'2020-01-16 16:00:01','7',''),(9048,2020,'2020-01-16 23:00:04','5',''),(8956,2036,'2020-01-16 13:00:02','1',''),(9107,2063,'2020-01-17 02:00:01','2',''),(9031,2021,'2020-01-16 20:00:06','93',''),(9104,2036,'2020-01-17 02:00:01','0',''),(9084,2102,'2020-01-17 01:00:01','98',''),(9050,2023,'2020-01-16 23:00:04','758',''),(9015,2182,'2020-01-16 22:00:09','743',''),(9012,2169,'2020-01-16 17:00:07','-2',''),(9010,2383,'2020-01-16 22:00:09','96',''),(8988,2143,'2020-01-16 16:00:01','2',''),(8964,2143,'2020-01-16 13:00:03','0',''),(9009,2154,'2020-01-16 22:00:09','6',''),(9008,2143,'2020-01-16 17:00:07','2',''),(9007,2130,'2020-01-16 22:00:08','764',''),(9005,2117,'2020-01-16 17:00:07','0',''),(9002,2090,'2020-01-16 23:00:04','1',''),(9044,1605,'2020-01-16 23:00:01','1',''),(9000,2020,'2020-01-16 20:00:06','7',''),(9072,2009,'2020-01-17 01:00:01','1',''),(9042,2021,'2020-01-16 22:00:08','92',''),(9022,2036,'2020-01-16 19:00:03','2',''),(8982,2090,'2020-01-16 16:00:01','1',''),(9030,2009,'2020-01-16 23:00:03','2',''),(9103,2023,'2020-01-17 23:00:04','764',''),(9083,2101,'2020-01-17 01:00:01','1',''),(8983,2102,'2020-01-16 16:00:01','87',''),(8984,2104,'2020-01-16 16:00:01','765',''),(9011,2156,'2020-01-16 22:00:09','752',''),(8986,2382,'2020-01-16 16:00:01','96',''),(8987,2130,'2020-01-16 16:00:01','764',''),(9026,2169,'2020-01-16 19:00:03','-3',''),(8990,2383,'2020-01-16 16:00:01','96',''),(8991,2156,'2020-01-16 16:00:01','752',''),(9006,2382,'2020-01-16 22:00:08','96',''),(8994,2384,'2020-01-16 16:00:02','87',''),(8995,2182,'2020-01-16 16:00:02','743',''),(8999,2009,'2020-01-16 17:00:06','4',''),(9040,1613,'2020-01-16 22:00:02','758',''),(9076,2036,'2020-01-17 01:00:01','0',''),(9024,2117,'2020-01-16 19:00:03','1',''),(8985,2117,'2020-01-16 16:00:01','0',''),(8992,2169,'2020-01-16 16:00:02','-2',''),(8997,1611,'2020-01-16 17:00:01','93',''),(9039,1611,'2020-01-16 22:00:02','92',''),(8981,2048,'2020-01-16 16:00:01','93',''),(9023,2063,'2020-01-16 19:00:03','-1',''),(9131,2074,'2020-01-17 04:00:01','5',''),(9052,2075,'2020-01-16 23:00:04','93',''),(9053,2077,'2020-01-16 23:00:04','765',''),(9054,2102,'2020-01-16 23:00:04','94',''),(9055,2104,'2020-01-16 23:00:04','764',''),(9056,2117,'2020-01-16 23:00:04','0',''),(9057,2128,'2020-01-16 23:00:04','1',''),(9058,2382,'2020-01-16 23:00:04','98',''),(9059,2130,'2020-01-16 23:00:04','770',''),(9025,2143,'2020-01-16 19:00:03','1',''),(9061,2154,'2020-01-16 23:00:04','9',''),(9062,2383,'2020-01-16 23:00:04','93',''),(9063,2156,'2020-01-16 23:00:04','758',''),(9064,2169,'2020-01-16 23:00:04','-2',''),(9065,2180,'2020-01-16 23:00:04','8',''),(9066,2384,'2020-01-16 23:00:04','82',''),(9067,2182,'2020-01-16 23:00:04','747',''),(9027,1610,'2020-01-16 20:00:03','5',''),(9046,1611,'2020-01-16 23:00:01','90',''),(9047,1613,'2020-01-16 23:00:01','759',''),(9041,2020,'2020-01-16 22:00:08','5',''),(9020,2021,'2020-01-16 19:00:03','93',''),(9021,2023,'2020-01-16 19:00:03','755',''),(9051,2048,'2020-01-16 23:00:04','97',''),(9838,2048,'2020-01-20 04:00:01','90',''),(10046,2382,'2020-01-21 01:00:02','87',''),(9985,2063,'2020-01-20 22:00:04','-3',''),(10045,2128,'2020-01-21 01:00:02','3',''),(9930,2169,'2020-01-20 13:00:02','-1',''),(10042,2102,'2020-01-21 01:00:02','86',''),(9929,2156,'2020-01-20 14:00:03','750',''),(9927,2154,'2020-01-20 14:00:03','5',''),(9900,2102,'2020-01-20 11:00:03','77',''),(10014,2104,'2020-01-21 00:00:02','751',''),(9925,2130,'2020-01-20 14:00:03','751',''),(10016,2128,'2020-01-21 00:00:02','6',''),(9847,2382,'2020-01-20 04:00:01','94',''),(9923,2128,'2020-01-20 22:00:04','7',''),(9849,2143,'2020-01-20 04:00:01','-3',''),(10172,1613,'2020-01-21 13:00:02','746',''),(9850,2383,'2020-01-20 04:00:01','89',''),(9851,2156,'2020-01-20 04:00:01','752',''),(9920,2101,'2020-01-20 22:00:04','7',''),(9854,2384,'2020-01-20 04:00:01','91',''),(9855,2182,'2020-01-20 04:00:01','751',''),(9856,1605,'2020-01-20 05:00:04','-0',''),(9889,1611,'2020-01-20 10:00:01','87',''),(9891,2009,'2020-01-20 10:00:01','-1',''),(9970,2180,'2020-01-20 22:00:04','4',''),(9918,2077,'2020-01-21 00:00:02','741',''),(9895,2047,'2020-01-20 11:00:03','7',''),(9946,2020,'2020-01-20 21:00:01','4',''),(9984,2036,'2020-01-20 22:00:04','2',''),(9897,2077,'2020-01-20 11:00:03','741',''),(9928,2383,'2020-01-20 14:00:03','85',''),(9926,2143,'2020-01-20 13:00:02','-2',''),(9902,2128,'2020-01-20 11:00:03','7',''),(9924,2382,'2020-01-20 14:00:03','92',''),(9904,2130,'2020-01-20 11:00:03','751',''),(9905,2143,'2020-01-20 11:00:03','-4',''),(9921,2102,'2020-01-20 14:00:03','77',''),(9908,2156,'2020-01-20 11:00:03','750',''),(9909,2169,'2020-01-20 11:00:03','-3',''),(9919,2090,'2020-01-20 14:00:03','-8',''),(9914,2021,'2020-01-20 14:00:02','91',''),(9913,1611,'2020-01-20 13:00:01','91',''),(10063,2047,'2020-01-21 03:00:01','8',''),(9941,1611,'2020-01-20 16:00:46','84',''),(9888,1610,'2020-01-20 13:00:01','5',''),(9886,1613,'2020-01-20 08:00:01','764',''),(10060,2021,'2020-01-21 03:00:01','90',''),(9894,2021,'2020-01-20 11:00:03','91',''),(9917,2075,'2020-01-20 14:00:03','80',''),(10034,2048,'2020-01-21 01:00:02','80',''),(9945,2050,'2020-01-20 16:00:46','747',''),(9983,2023,'2020-01-20 21:00:01','763',''),(9896,2075,'2020-01-20 11:00:03','80',''),(9898,2090,'2020-01-20 11:00:03','-8',''),(9899,2101,'2020-01-20 11:00:03','7',''),(9901,2117,'2020-01-20 11:00:03','-9',''),(9903,2382,'2020-01-20 11:00:03','92',''),(10173,2009,'2020-01-21 15:00:00','4',''),(10055,2182,'2020-01-21 01:00:03','748',''),(9907,2383,'2020-01-20 11:00:03','85',''),(10052,2169,'2020-01-21 01:00:02','-1',''),(9968,2156,'2020-01-21 00:00:02','752',''),(9910,2180,'2020-01-20 11:00:04','5',''),(9911,2384,'2020-01-20 11:00:04','86',''),(9912,2182,'2020-01-20 11:00:04','757',''),(10062,2036,'2020-01-21 03:00:01','-5',''),(9940,1610,'2020-01-20 19:00:02','4',''),(9885,1611,'2020-01-20 08:00:01','87',''),(10068,2075,'2020-01-21 03:00:02','76',''),(9939,2169,'2020-01-20 14:00:03','-1',''),(9938,2143,'2020-01-21 00:00:02','-2',''),(9937,2117,'2020-01-20 16:00:47','-5',''),(9999,1611,'2020-01-21 00:00:01','95',''),(9934,1610,'2020-01-20 14:00:01','4',''),(9936,2036,'2020-01-20 16:00:46','4',''),(10067,2074,'2020-01-21 03:00:02','6',''),(9950,2050,'2020-01-20 22:00:04','747',''),(9916,2047,'2020-01-21 00:00:01','7',''),(9948,2075,'2020-01-20 16:00:46','79',''),(9958,2154,'2020-01-20 16:00:47','4',''),(10036,2063,'2020-01-21 01:00:02','-8',''),(9954,2090,'2020-01-20 22:00:04','-7',''),(9980,1611,'2020-01-20 19:00:02','89',''),(9957,2102,'2020-01-20 22:00:04','84',''),(9961,2382,'2020-01-20 22:00:04','87',''),(9964,2180,'2020-01-20 16:00:47','4',''),(9967,2383,'2020-01-21 00:00:02','87',''),(10028,2009,'2020-01-21 03:00:01','-0',''),(9998,1610,'2020-01-21 00:00:01','5',''),(9988,1610,'2020-01-20 21:00:01','3',''),(9935,1611,'2020-01-20 14:00:01','84',''),(10066,2063,'2020-01-21 12:00:05','-8',''),(10004,2023,'2020-01-21 00:00:01','761',''),(9949,2048,'2020-01-20 22:00:04','91',''),(9915,2036,'2020-01-20 13:00:02','4',''),(9982,2021,'2020-01-20 21:00:01','89',''),(10038,2075,'2020-01-21 01:00:02','76',''),(9951,2090,'2020-01-20 16:00:46','-7',''),(10035,2050,'2020-01-21 01:00:02','741',''),(9953,2075,'2020-01-20 22:00:04','79',''),(9979,2169,'2020-01-20 18:00:08','-4',''),(9956,2130,'2020-01-20 16:00:47','752',''),(9960,2156,'2020-01-20 16:00:47','752',''),(10119,2074,'2020-01-21 10:00:01','7',''),(9966,2154,'2020-01-20 22:00:04','4',''),(10027,1613,'2020-01-21 01:00:01','759',''),(9992,1611,'2020-01-20 22:00:03','90',''),(9974,2021,'2020-01-20 18:00:07','89',''),(10003,2021,'2020-01-21 00:00:01','87',''),(9947,2021,'2020-01-20 16:00:46','84',''),(9986,2117,'2020-01-20 22:00:04','1',''),(10056,1605,'2020-01-21 03:00:01','-1',''),(9981,1613,'2020-01-20 19:00:02','763',''),(9991,1610,'2020-01-20 22:00:03','3',''),(9973,1613,'2020-01-20 18:00:01','763',''),(9943,2021,'2020-01-20 16:00:46','84',''),(9976,2036,'2020-01-20 18:00:07','2',''),(10033,2047,'2020-01-21 01:00:02','8',''),(9944,2048,'2020-01-20 16:00:46','91',''),(10044,2117,'2020-01-21 01:00:02','-2',''),(10041,2101,'2020-01-21 03:00:02','6',''),(10012,2101,'2020-01-21 00:00:02','6',''),(9952,2102,'2020-01-20 16:00:47','84',''),(9978,2117,'2020-01-20 18:00:07','1',''),(9955,2382,'2020-01-20 16:00:47','87',''),(9959,2383,'2020-01-20 16:00:47','87',''),(9963,2169,'2020-01-20 16:00:47','-2',''),(9965,2384,'2020-01-20 16:00:47','87',''),(10026,1611,'2020-01-21 01:00:01','95',''),(9990,1613,'2020-01-20 21:00:01','761',''),(10061,2023,'2020-01-21 15:00:00','746',''),(9975,2023,'2020-01-20 18:00:07','763',''),(10295,2047,'2020-01-22 00:00:01','6',''),(10047,2130,'2020-01-21 01:00:02','752',''),(9977,2063,'2020-01-20 18:00:07','-3',''),(10043,2104,'2020-01-21 03:00:02','751',''),(10040,2090,'2020-01-21 01:00:02','-3',''),(10037,2074,'2020-01-21 01:00:02','6',''),(10425,2384,'2020-01-22 15:00:03','86',''),(10013,2102,'2020-01-21 00:00:02','76',''),(10015,2117,'2020-01-21 00:00:02','-3',''),(10017,2382,'2020-01-21 00:00:02','86',''),(10054,2384,'2020-01-21 01:00:03','96',''),(10053,2180,'2020-01-21 01:00:03','7',''),(10021,2180,'2020-01-21 00:00:02','3',''),(10030,2021,'2020-01-21 01:00:02','90',''),(10025,1610,'2020-01-21 04:00:01','5',''),(9989,1611,'2020-01-20 21:00:01','90',''),(10000,1613,'2020-01-21 00:00:01','759',''),(10032,2036,'2020-01-21 01:00:02','-5',''),(10011,2090,'2020-01-21 00:00:02','-8',''),(10049,2154,'2020-01-21 03:00:02','3',''),(10020,2169,'2020-01-21 00:00:02','0',''),(9997,1605,'2020-01-21 00:00:01','-0',''),(10116,2047,'2020-01-21 15:00:01','6',''),(10059,2020,'2020-01-21 03:00:01','7',''),(10002,2020,'2020-01-21 00:00:01','4',''),(9996,2023,'2020-01-20 22:00:04','761',''),(10029,2020,'2020-01-21 01:00:02','7',''),(10024,1605,'2020-01-21 01:00:01','-0',''),(10084,1611,'2020-01-21 04:00:01','96',''),(10115,2036,'2020-01-21 15:00:01','-2',''),(10058,1613,'2020-01-21 03:00:01','757',''),(10001,2009,'2020-01-21 00:00:01','-0',''),(9994,2020,'2020-01-20 22:00:04','3',''),(9995,2021,'2020-01-20 22:00:04','90',''),(10022,2384,'2020-01-21 00:00:02','90',''),(10023,2182,'2020-01-21 00:00:02','758',''),(10057,1611,'2020-01-21 03:00:01','93',''),(10113,2020,'2020-01-21 10:00:01','6',''),(10094,2075,'2020-01-21 04:00:05','84',''),(10087,2020,'2020-01-21 04:00:05','6',''),(10092,2050,'2020-01-21 04:00:05','742',''),(10031,2023,'2020-01-21 01:00:02','746',''),(10005,2036,'2020-01-21 00:00:01','-0',''),(10006,2048,'2020-01-21 00:00:01','90',''),(10007,2050,'2020-01-21 00:00:01','746',''),(10008,2063,'2020-01-21 00:00:02','-5',''),(10009,2074,'2020-01-21 00:00:02','8',''),(10010,2075,'2020-01-21 00:00:02','80',''),(10039,2077,'2020-01-21 01:00:02','751',''),(10095,2090,'2020-01-21 04:00:05','-8',''),(10097,2102,'2020-01-21 04:00:05','89',''),(10098,2104,'2020-01-21 04:00:05','752',''),(10102,2143,'2020-01-21 04:00:06','-4',''),(10159,2128,'2020-01-21 12:00:05','2',''),(10100,2382,'2020-01-21 04:00:06','97',''),(10048,2143,'2020-01-21 01:00:02','0',''),(10050,2383,'2020-01-21 01:00:02','90',''),(10051,2156,'2020-01-21 01:00:02','758',''),(10121,2090,'2020-01-21 10:00:01','-8',''),(10118,2050,'2020-01-21 10:00:01','742',''),(10117,2048,'2020-01-21 10:00:01','76',''),(10143,1611,'2020-01-21 10:00:00','97',''),(10112,2009,'2020-01-21 07:00:02','1',''),(10093,2074,'2020-01-21 04:00:05','7',''),(10266,1610,'2020-01-21 23:00:01','7',''),(10091,2048,'2020-01-21 04:00:05','76',''),(10350,2036,'2020-01-22 05:00:01','-7',''),(10090,2047,'2020-01-21 04:00:05','6',''),(10304,2104,'2020-01-22 00:00:01','748',''),(10157,2077,'2020-01-21 12:00:05','752',''),(10181,2077,'2020-01-21 23:00:01','752',''),(10156,2075,'2020-01-21 12:00:05','73',''),(10273,2075,'2020-01-21 23:00:01','72',''),(10300,2077,'2020-01-22 00:00:01','749',''),(10175,2021,'2020-01-21 15:00:00','91',''),(10302,2101,'2020-01-22 00:00:01','4',''),(10296,2048,'2020-01-22 00:00:01','72',''),(10101,2130,'2020-01-21 04:00:06','749',''),(10277,2128,'2020-01-21 23:00:02','4',''),(10174,2020,'2020-01-21 15:00:00','7',''),(10191,2169,'2020-01-21 16:00:02','-1',''),(10171,1611,'2020-01-21 13:00:02','91',''),(10282,2156,'2020-01-21 23:00:02','755',''),(10120,2075,'2020-01-21 10:00:01','84',''),(10108,1605,'2020-01-21 06:00:01','1',''),(10083,1605,'2020-01-21 04:00:01','-0',''),(10114,2021,'2020-01-21 10:00:01','96',''),(10215,2117,'2020-01-21 16:00:02','-2',''),(10110,1611,'2020-01-21 06:00:01','94',''),(10142,1605,'2020-01-21 10:00:00','2',''),(10086,2009,'2020-01-21 04:00:05','1',''),(10088,2021,'2020-01-21 04:00:05','96',''),(10089,2036,'2020-01-21 04:00:05','-2',''),(10180,2075,'2020-01-21 15:00:01','73',''),(10099,2117,'2020-01-21 04:00:05','-3',''),(10190,2156,'2020-01-21 21:00:02','756',''),(10166,2180,'2020-01-21 12:00:06','4',''),(10104,2169,'2020-01-21 04:00:06','0',''),(10105,2180,'2020-01-21 04:00:06','6',''),(10106,2384,'2020-01-21 04:00:06','95',''),(10107,2182,'2020-01-21 04:00:06','752',''),(10109,1610,'2020-01-21 06:00:01','6',''),(10141,2009,'2020-01-21 09:00:01','2',''),(10111,1613,'2020-01-21 06:00:01','752',''),(10214,2101,'2020-01-21 16:00:02','6',''),(10153,2048,'2020-01-21 12:00:05','80',''),(10213,2075,'2020-01-21 16:00:02','71',''),(10179,2074,'2020-01-22 15:00:02','6',''),(10185,2382,'2020-01-21 15:00:01','91',''),(10189,2383,'2020-01-21 15:00:01','91',''),(10164,2156,'2020-01-21 12:00:06','756',''),(10165,2169,'2020-01-21 12:00:06','-1',''),(10292,2021,'2020-01-22 00:00:01','79',''),(10170,1610,'2020-01-21 13:00:02','7',''),(10169,1605,'2020-01-21 15:00:00','4',''),(10255,2117,'2020-01-21 23:00:02','-1',''),(10140,1613,'2020-01-21 09:00:01','749',''),(10367,1613,'2020-01-22 08:00:00','742',''),(10139,1611,'2020-01-21 09:00:01','97',''),(10199,2090,'2020-01-21 16:00:02','-5',''),(10205,1613,'2020-01-21 16:00:01','745',''),(10198,2063,'2020-01-21 23:00:01','-7',''),(10209,2023,'2020-01-21 16:00:01','745',''),(10152,2021,'2020-01-21 12:00:05','91',''),(10212,2050,'2020-01-21 16:00:01','742',''),(10154,2050,'2020-01-21 12:00:05','741',''),(10155,2074,'2020-01-21 12:00:05','6',''),(10158,2090,'2020-01-21 12:00:05','-9',''),(10184,2128,'2020-01-21 15:00:01','2',''),(10160,2382,'2020-01-21 12:00:05','91',''),(10161,2130,'2020-01-21 12:00:05','752',''),(10188,2154,'2020-01-21 15:00:01','5',''),(10162,2154,'2020-01-21 12:00:06','5',''),(10163,2383,'2020-01-21 12:00:06','91',''),(10167,2384,'2020-01-21 12:00:06','91',''),(10168,2182,'2020-01-21 12:00:06','758',''),(10204,1611,'2020-01-21 16:00:01','92',''),(10197,1613,'2020-01-21 15:00:00','745',''),(10208,2021,'2020-01-21 16:00:01','92',''),(10252,2023,'2020-01-21 20:00:03','743',''),(10211,2047,'2020-01-21 16:00:01','5',''),(10272,2050,'2020-01-21 23:00:01','741',''),(10178,2063,'2020-01-21 13:00:02','-7',''),(10502,2021,'2020-01-22 20:00:06','89',''),(10240,2130,'2020-01-21 21:00:02','754',''),(10183,2117,'2020-01-21 13:00:02','-1',''),(10278,2382,'2020-01-21 23:00:02','88',''),(10279,2130,'2020-01-21 23:00:02','748',''),(10187,2143,'2020-01-21 13:00:03','-3',''),(10293,2023,'2020-01-22 00:00:01','741',''),(10313,2169,'2020-01-22 00:00:02','2',''),(10256,2143,'2020-01-21 21:00:02','-3',''),(10290,2009,'2020-01-22 00:00:01','-5',''),(10288,1610,'2020-01-22 05:00:01','7',''),(10203,1610,'2020-01-21 18:00:01','6',''),(10254,2090,'2020-01-21 21:00:01','-0',''),(10196,1611,'2020-01-21 15:00:00','92',''),(10207,2020,'2020-01-21 16:00:01','6',''),(10265,1605,'2020-01-21 23:00:01','-0',''),(10251,2021,'2020-01-21 20:00:03','89',''),(10210,2036,'2020-01-21 16:00:01','-1',''),(10301,2090,'2020-01-22 03:00:01','-2',''),(10239,2382,'2020-01-21 21:00:02','84',''),(10238,2128,'2020-01-21 21:00:02','6',''),(10243,2383,'2020-01-21 23:00:02','83',''),(10246,2182,'2020-01-21 21:00:02','757',''),(10202,1605,'2020-01-21 16:00:01','3',''),(10253,2036,'2020-01-21 23:00:01','-3',''),(10249,1611,'2020-01-21 20:00:02','85',''),(10206,2009,'2020-01-21 16:00:01','3',''),(10264,2023,'2020-01-21 23:00:01','743',''),(10422,2383,'2020-01-22 15:00:02','78',''),(10303,2102,'2020-01-22 00:00:01','88',''),(10501,2020,'2020-01-22 20:00:06','5',''),(10236,2101,'2020-01-21 23:00:02','6',''),(10297,2050,'2020-01-22 00:00:01','752',''),(10276,2104,'2020-01-21 23:00:02','749',''),(10237,2117,'2020-01-21 18:00:07','-1',''),(10242,2154,'2020-01-21 21:00:02','4',''),(10281,2154,'2020-01-21 23:00:02','6',''),(10312,2156,'2020-01-22 00:00:02','760',''),(10245,2384,'2020-01-21 21:00:02','88',''),(10291,2020,'2020-01-22 00:00:01','5',''),(10289,1611,'2020-01-22 00:00:01','79',''),(10287,1605,'2020-01-22 00:00:00','-0',''),(10247,1605,'2020-01-21 20:00:02','1',''),(10250,1613,'2020-01-22 05:00:01','743',''),(10261,2009,'2020-01-21 21:00:01','1',''),(10294,2036,'2020-01-22 00:00:01','-8',''),(10271,2048,'2020-01-21 23:00:01','79',''),(10299,2075,'2020-01-22 00:00:01','94',''),(10500,2009,'2020-01-22 23:00:02','-3',''),(10235,2090,'2020-01-21 18:00:07','-0',''),(10275,2102,'2020-01-21 23:00:02','94',''),(10530,2154,'2020-01-22 23:00:03','5',''),(10305,2117,'2020-01-22 00:00:01','-7',''),(10241,2143,'2020-01-21 18:00:07','-3',''),(10416,2117,'2020-01-22 15:00:02','-8',''),(10311,2383,'2020-01-22 00:00:02','91',''),(10244,2169,'2020-01-21 18:00:08','-2',''),(10284,2180,'2020-01-21 23:00:02','5',''),(10285,2384,'2020-01-21 23:00:02','91',''),(10286,2182,'2020-01-21 23:00:02','760',''),(10248,1610,'2020-01-21 20:00:02','5',''),(10263,2021,'2020-01-21 21:00:01','85',''),(10550,2104,'2020-01-23 00:00:01','757',''),(10298,2063,'2020-01-22 00:00:01','-4',''),(10274,2090,'2020-01-21 23:00:01','-2',''),(10280,2143,'2020-01-21 23:00:02','-6',''),(10283,2169,'2020-01-21 23:00:02','-0',''),(10324,2047,'2020-01-22 23:00:02','6',''),(10376,2102,'2020-01-22 09:00:01','82',''),(10321,2021,'2020-01-22 09:00:01','79',''),(10262,2020,'2020-01-21 21:00:01','5',''),(10323,2036,'2020-01-22 03:00:01','-8',''),(10375,2101,'2020-01-22 09:00:01','5',''),(10320,2020,'2020-01-22 15:00:02','5',''),(10436,1605,'2020-01-22 15:00:01','-2',''),(10450,2020,'2020-01-22 17:00:02','4',''),(10393,2090,'2020-01-22 11:00:02','-3',''),(10322,2023,'2020-01-22 03:00:01','741',''),(10374,2090,'2020-01-22 09:00:01','-5',''),(10319,2009,'2020-01-22 03:00:01','-5',''),(10435,2169,'2020-01-22 14:00:02','1',''),(10775,1605,'2020-01-23 23:00:01','-8',''),(10391,2048,'2020-01-22 11:00:01','76',''),(10349,2023,'2020-01-22 05:00:01','742',''),(10549,2102,'2020-01-23 00:00:01','83',''),(10351,2048,'2020-01-22 05:00:01','74',''),(10543,2063,'2020-01-23 00:00:01','-4',''),(10433,2090,'2020-01-22 14:00:02','-1',''),(10497,1610,'2020-01-22 20:00:04','6',''),(10431,2036,'2020-01-22 14:00:02','-8',''),(10493,2156,'2020-01-22 23:00:03','759',''),(10427,1605,'2020-01-22 14:00:01','-2',''),(10424,2169,'2020-01-22 12:00:03','-1',''),(10421,2154,'2020-01-22 15:00:02','7',''),(10418,2382,'2020-01-22 15:00:02','83',''),(10359,2130,'2020-01-22 05:00:02','758',''),(10386,1611,'2020-01-22 09:00:00','92',''),(10414,2101,'2020-01-22 15:00:02','6',''),(10384,2384,'2020-01-22 09:00:01','83',''),(10382,2169,'2020-01-22 09:00:01','0',''),(10380,2143,'2020-01-22 09:00:01','-7',''),(10378,2382,'2020-01-22 09:00:01','82',''),(10412,2075,'2020-01-22 15:00:02','91',''),(10317,1605,'2020-01-22 02:00:00','-2',''),(10373,2075,'2020-01-22 09:00:01','90',''),(10318,1611,'2020-01-22 02:00:01','82',''),(10434,2143,'2020-01-22 14:00:02','-7',''),(10390,2021,'2020-01-22 11:00:01','86',''),(10511,2023,'2020-01-22 21:00:01','745',''),(10548,2101,'2020-01-23 00:00:01','5',''),(10649,1613,'2020-01-23 09:00:00','751',''),(10542,2050,'2020-01-23 00:00:01','747',''),(10432,2063,'2020-01-22 14:00:02','-5',''),(10496,2384,'2020-01-22 21:00:02','97',''),(10430,2009,'2020-01-22 14:00:01','-1',''),(10492,2383,'2020-01-22 23:00:03','92',''),(10426,2182,'2020-01-22 21:00:02','753',''),(10357,2104,'2020-01-22 05:00:02','743',''),(10420,2143,'2020-01-22 12:00:03','-13',''),(10417,2128,'2020-01-22 15:00:02','7',''),(10387,1613,'2020-01-22 12:00:01','742',''),(10399,2130,'2020-01-22 11:00:02','755',''),(10385,1610,'2020-01-22 18:00:01','5',''),(10413,2090,'2020-01-22 12:00:03','-3',''),(10383,2180,'2020-01-22 15:00:03','5',''),(10381,2156,'2020-01-22 09:00:01','758',''),(10379,2130,'2020-01-22 09:00:01','758',''),(10377,2104,'2020-01-22 21:00:02','743',''),(10408,1611,'2020-01-22 12:00:01','86',''),(10372,2063,'2020-01-22 12:00:03','-9',''),(10370,2036,'2020-01-22 12:00:03','-7',''),(10423,2156,'2020-01-22 15:00:02','763',''),(10371,2048,'2020-01-22 09:00:01','74',''),(10369,2023,'2020-01-22 14:00:01','742',''),(10348,2009,'2020-01-22 05:00:01','-2',''),(10547,2090,'2020-01-23 00:00:01','-14',''),(10352,2063,'2020-01-22 05:00:01','-9',''),(10353,2075,'2020-01-22 05:00:01','90',''),(10354,2090,'2020-01-22 05:00:02','-5',''),(10355,2101,'2020-01-22 05:00:02','5',''),(10356,2102,'2020-01-22 05:00:02','82',''),(10419,2130,'2020-01-22 15:00:02','755',''),(10400,2143,'2020-01-22 11:00:02','-13',''),(10358,2382,'2020-01-22 05:00:02','82',''),(10360,2143,'2020-01-22 05:00:02','-7',''),(10415,2102,'2020-01-22 15:00:02','81',''),(10404,2169,'2020-01-22 11:00:02','-1',''),(10361,2156,'2020-01-22 05:00:02','758',''),(10362,2169,'2020-01-22 05:00:02','0',''),(10363,2180,'2020-01-22 05:00:02','5',''),(10364,2384,'2020-01-22 05:00:02','83',''),(10407,1605,'2020-01-22 12:00:01','-1',''),(10365,1610,'2020-01-22 08:00:00','5',''),(10368,2009,'2020-01-22 11:00:01','-2',''),(10411,2048,'2020-01-22 15:00:02','76',''),(10546,2077,'2020-01-23 00:00:01','742',''),(10522,2090,'2020-01-22 23:00:03','-3',''),(10392,2075,'2020-01-22 11:00:02','91',''),(10643,2180,'2020-01-23 11:00:02','8',''),(10394,2101,'2020-01-22 11:00:02','6',''),(10395,2102,'2020-01-22 11:00:02','81',''),(10396,2117,'2020-01-22 11:00:02','-8',''),(10397,2128,'2020-01-22 11:00:02','7',''),(10398,2382,'2020-01-22 11:00:02','83',''),(10485,2102,'2020-01-22 21:00:02','90',''),(10401,2154,'2020-01-22 11:00:02','7',''),(10402,2383,'2020-01-22 11:00:02','78',''),(10403,2156,'2020-01-22 11:00:02','763',''),(10476,2021,'2020-01-22 18:00:01','89',''),(10561,2384,'2020-01-23 03:00:24','98',''),(10405,2384,'2020-01-22 11:00:02','86',''),(10406,2182,'2020-01-22 11:00:02','753',''),(10762,2063,'2020-01-23 21:00:01','-3',''),(10366,1611,'2020-01-22 08:00:00','92',''),(10389,1611,'2020-01-22 11:00:01','86',''),(10428,1611,'2020-01-22 14:00:01','83',''),(10429,1613,'2020-01-22 14:00:01','743',''),(10388,1605,'2020-01-22 11:00:01','-1',''),(10498,1611,'2020-01-22 20:00:04','83',''),(10499,1613,'2020-01-22 20:00:04','745',''),(10410,2021,'2020-01-22 14:00:01','86',''),(10448,1611,'2020-01-22 17:00:01','89',''),(10409,2009,'2020-01-22 12:00:03','-1',''),(10451,2021,'2020-01-22 17:00:02','81',''),(10495,2180,'2020-01-22 23:00:03','3',''),(10459,2101,'2020-01-22 17:00:03','5',''),(10491,2154,'2020-01-22 21:00:02','6',''),(10489,2130,'2020-01-22 21:00:02','758',''),(10462,2128,'2020-01-22 17:00:03','4',''),(10487,2128,'2020-01-22 21:00:02','4',''),(10464,2130,'2020-01-22 17:00:03','758',''),(10482,2077,'2020-01-22 21:00:01','748',''),(10480,2074,'2020-01-22 23:00:02','7',''),(10478,2048,'2020-01-22 21:00:01','75',''),(10473,1611,'2020-01-22 18:00:01','89',''),(10535,1613,'2020-01-23 00:00:01','746',''),(10447,1605,'2020-01-22 17:00:01','-3',''),(10474,2009,'2020-01-22 18:00:01','-3',''),(10517,2023,'2020-01-22 23:00:02','745',''),(10494,2169,'2020-01-22 23:00:03','0',''),(10641,2383,'2020-01-23 11:00:02','93',''),(10490,2143,'2020-01-22 18:00:02','1',''),(10488,2382,'2020-01-22 21:00:02','79',''),(10527,2128,'2020-01-22 23:00:03','5',''),(10486,2117,'2020-01-22 21:00:02','-6',''),(10529,2130,'2020-01-22 23:00:03','757',''),(10484,2101,'2020-01-22 21:00:02','5',''),(10481,2075,'2020-01-22 21:00:01','92',''),(10479,2063,'2020-01-22 18:00:02','-0',''),(10477,2036,'2020-01-22 23:00:02','-7',''),(10475,2020,'2020-01-22 18:00:01','5',''),(10472,1605,'2020-01-22 21:00:01','-3',''),(10534,1611,'2020-01-23 00:00:01','88',''),(10483,2090,'2020-01-22 18:00:02','-2',''),(10470,2180,'2020-01-22 17:00:03','3',''),(10541,2048,'2020-01-23 00:00:01','93',''),(10456,2074,'2020-01-22 17:00:03','7',''),(10457,2075,'2020-01-22 17:00:03','92',''),(10458,2077,'2020-01-22 17:00:03','748',''),(10460,2102,'2020-01-22 17:00:03','90',''),(10525,2104,'2020-01-22 23:00:03','742',''),(10461,2117,'2020-01-22 17:00:03','-6',''),(10463,2382,'2020-01-22 17:00:03','79',''),(10465,2143,'2020-01-22 17:00:03','-4',''),(10466,2154,'2020-01-22 17:00:03','6',''),(10467,2383,'2020-01-22 17:00:03','92',''),(10468,2156,'2020-01-22 17:00:03','759',''),(10469,2169,'2020-01-22 17:00:03','0',''),(10471,2384,'2020-01-22 17:00:03','97',''),(10533,1605,'2020-01-23 03:00:18','-5',''),(10514,1613,'2020-01-22 23:00:01','746',''),(10538,2023,'2020-01-23 00:00:01','752',''),(10540,2047,'2020-01-23 00:00:01','7',''),(10521,2077,'2020-01-22 23:00:02','747',''),(10545,2075,'2020-01-23 00:00:01','84',''),(10520,2075,'2020-01-22 23:00:02','93',''),(10967,2130,'2020-01-24 15:00:07','764',''),(10524,2102,'2020-01-22 23:00:03','84',''),(10637,2382,'2020-01-23 11:00:02','83',''),(10526,2117,'2020-01-22 23:00:03','-12',''),(10528,2382,'2020-01-22 23:00:03','83',''),(10569,2047,'2020-01-23 23:00:02','7',''),(10627,2063,'2020-01-23 11:00:02','-2',''),(10568,2036,'2020-01-23 03:00:23','-2',''),(10567,2023,'2020-01-23 17:00:01','752',''),(10566,2021,'2020-01-23 03:00:23','76',''),(10531,2384,'2020-01-22 23:00:03','98',''),(10532,2182,'2020-01-22 23:00:03','752',''),(10513,1611,'2020-01-22 23:00:01','88',''),(10537,2021,'2020-01-23 00:00:01','76',''),(10519,2063,'2020-01-22 23:00:02','-1',''),(10556,2154,'2020-01-23 00:00:02','3',''),(10562,2182,'2020-01-23 00:00:02','750',''),(10512,1605,'2020-01-22 23:00:01','-5',''),(10565,2009,'2020-01-23 03:00:23','-8',''),(10564,1613,'2020-01-23 02:00:01','748',''),(10536,2009,'2020-01-23 00:00:01','-8',''),(10516,2021,'2020-01-22 23:00:02','87',''),(10739,2090,'2020-01-23 18:00:11','-9',''),(10652,1613,'2020-01-23 11:00:01','752',''),(10563,1611,'2020-01-23 02:00:01','81',''),(10647,1613,'2020-01-23 08:00:01','751',''),(10682,2090,'2020-01-23 14:00:01','-9',''),(10654,1611,'2020-01-23 12:00:01','80',''),(10738,2075,'2020-01-23 23:00:02','94',''),(10737,2074,'2020-01-23 21:00:02','3',''),(10539,2036,'2020-01-23 00:00:01','-2',''),(10648,1611,'2020-01-23 09:00:00','78',''),(10544,2074,'2020-01-23 00:00:01','6',''),(10644,2384,'2020-01-23 11:00:02','94',''),(10639,2143,'2020-01-23 11:00:02','-7',''),(10636,2128,'2020-01-23 11:00:02','3',''),(10634,2104,'2020-01-23 15:00:01','758',''),(10632,2101,'2020-01-23 11:00:02','6',''),(10630,2077,'2020-01-23 21:00:02','740',''),(10555,2143,'2020-01-23 00:00:02','-4',''),(10557,2383,'2020-01-23 00:00:02','98',''),(10558,2156,'2020-01-23 00:00:02','752',''),(10559,2169,'2020-01-23 00:00:02','-1',''),(10560,2180,'2020-01-23 00:00:02','7',''),(10622,2009,'2020-01-23 12:00:02','-7',''),(10620,1611,'2020-01-23 06:00:01','82',''),(10761,2036,'2020-01-23 21:00:01','-1',''),(10646,1611,'2020-01-23 08:00:01','78',''),(10774,2023,'2020-01-23 21:00:01','755',''),(10596,2021,'2020-01-23 05:00:02','77',''),(10733,2023,'2020-01-23 18:00:11','754',''),(10653,1605,'2020-01-23 18:00:06','-6',''),(10814,2074,'2020-01-24 00:00:06','6',''),(10598,2048,'2020-01-23 05:00:02','90',''),(10599,2050,'2020-01-23 05:00:02','746',''),(10600,2063,'2020-01-23 05:00:02','-2',''),(10645,2182,'2020-01-23 11:00:02','752',''),(10603,2077,'2020-01-23 05:00:02','740',''),(10642,2156,'2020-01-23 11:00:02','756',''),(10640,2154,'2020-01-23 11:00:02','2',''),(10638,2130,'2020-01-23 11:00:02','762',''),(10607,2104,'2020-01-23 05:00:02','758',''),(10635,2117,'2020-01-23 11:00:02','-11',''),(10633,2102,'2020-01-23 11:00:02','80',''),(10631,2090,'2020-01-23 11:00:02','-8',''),(10629,2075,'2020-01-23 11:00:02','82',''),(10628,2074,'2020-01-23 15:00:01','5',''),(10626,2050,'2020-01-23 23:00:02','746',''),(10625,2048,'2020-01-23 11:00:02','90',''),(10624,2036,'2020-01-23 12:00:02','-7',''),(10685,2117,'2020-01-23 14:00:01','-6',''),(10623,2021,'2020-01-23 11:00:02','77',''),(10621,1613,'2020-01-23 06:00:01','749',''),(10619,1605,'2020-01-23 09:00:00','-7',''),(10760,2023,'2020-01-23 20:00:01','754',''),(10834,1611,'2020-01-24 02:00:04','85',''),(10773,2021,'2020-01-23 21:00:01','85',''),(10985,1605,'2020-01-24 15:00:01','-0',''),(10808,2023,'2020-01-24 00:00:05','746',''),(10597,2036,'2020-01-23 05:00:02','-7',''),(10813,2063,'2020-01-24 00:00:06','-4',''),(10658,2063,'2020-01-23 12:00:02','-3',''),(11360,2050,'2020-01-26 00:00:03','761',''),(10783,2063,'2020-01-23 23:00:02','-2',''),(10601,2074,'2020-01-23 05:00:02','5',''),(10602,2075,'2020-01-23 05:00:02','82',''),(10604,2090,'2020-01-23 05:00:02','-8',''),(10605,2101,'2020-01-23 05:00:02','6',''),(10606,2102,'2020-01-23 05:00:02','80',''),(10961,2101,'2020-01-24 15:00:07','4',''),(10608,2117,'2020-01-23 05:00:02','-11',''),(10609,2128,'2020-01-23 05:00:02','3',''),(10610,2382,'2020-01-23 05:00:02','83',''),(10611,2130,'2020-01-23 05:00:02','762',''),(10612,2143,'2020-01-23 05:00:02','-7',''),(10613,2154,'2020-01-23 05:00:02','2',''),(10614,2383,'2020-01-23 05:00:02','93',''),(10615,2156,'2020-01-23 05:00:02','756',''),(10684,2102,'2020-01-23 15:00:01','84',''),(10616,2180,'2020-01-23 05:00:02','8',''),(10617,2384,'2020-01-23 05:00:02','94',''),(10618,2182,'2020-01-23 05:00:02','752',''),(10680,2063,'2020-01-23 14:00:01','-1',''),(10713,2075,'2020-01-23 17:00:02','94',''),(10660,2090,'2020-01-23 12:00:02','-6',''),(10714,2090,'2020-01-23 17:00:02','-7',''),(10939,2382,'2020-01-24 11:00:01','89',''),(10689,2143,'2020-01-23 14:00:01','-1',''),(10688,2130,'2020-01-23 15:00:01','758',''),(10687,2382,'2020-01-23 15:00:01','93',''),(10686,2128,'2020-01-23 15:00:01','4',''),(10668,2154,'2020-01-23 12:00:03','4',''),(10667,2143,'2020-01-23 12:00:03','-2',''),(10955,2048,'2020-01-24 15:00:07','86',''),(10670,2156,'2020-01-23 12:00:03','752',''),(10742,2104,'2020-01-23 21:00:02','756',''),(10683,2101,'2020-01-23 15:00:01','7',''),(10673,2384,'2020-01-23 12:00:03','91',''),(10731,1613,'2020-01-23 18:00:06','754',''),(10675,1611,'2020-01-23 14:00:01','79',''),(10651,1611,'2020-01-23 11:00:01','80',''),(10709,2036,'2020-01-23 17:00:02','-3',''),(10681,2075,'2020-01-23 15:00:01','88',''),(10650,1605,'2020-01-23 11:00:01','-6',''),(10708,2021,'2020-01-23 17:00:01','77',''),(10677,2021,'2020-01-23 14:00:01','80',''),(10765,2143,'2020-01-23 21:00:02','-2',''),(10759,2021,'2020-01-23 20:00:01','88',''),(10707,1613,'2020-01-23 17:00:01','754',''),(10676,2009,'2020-01-23 14:00:01','-6',''),(10679,2048,'2020-01-23 15:00:01','92',''),(10657,2048,'2020-01-23 12:00:02','92',''),(10712,2074,'2020-01-23 17:00:02','3',''),(10659,2075,'2020-01-23 12:00:02','88',''),(10662,2102,'2020-01-23 12:00:02','84',''),(10663,2117,'2020-01-23 12:00:02','-8',''),(10664,2128,'2020-01-23 12:00:03','4',''),(10665,2382,'2020-01-23 12:00:03','93',''),(10666,2130,'2020-01-23 12:00:03','758',''),(10669,2383,'2020-01-23 12:00:03','95',''),(10671,2169,'2020-01-23 12:00:03','1',''),(10672,2180,'2020-01-23 12:00:03','7',''),(10674,2182,'2020-01-23 12:00:03','746',''),(10764,2117,'2020-01-23 21:00:02','-8',''),(10758,1613,'2020-01-23 20:00:01','755',''),(10925,2020,'2020-01-24 11:00:01','7',''),(10776,1610,'2020-01-23 23:00:01','4',''),(10678,2036,'2020-01-23 14:00:01','-2',''),(10812,2050,'2020-01-24 00:00:05','741',''),(10784,2074,'2020-01-23 23:00:02','4',''),(10816,2077,'2020-01-24 00:00:06','755',''),(10788,2102,'2020-01-23 23:00:02','85',''),(10747,2143,'2020-01-23 18:00:12','-2',''),(10908,2156,'2020-01-24 09:00:06','755',''),(10746,2130,'2020-01-23 21:00:02','762',''),(10745,2382,'2020-01-23 21:00:02','78',''),(10744,2128,'2020-01-23 21:00:02','2',''),(10743,2117,'2020-01-23 18:00:11','-8',''),(10741,2102,'2020-01-23 21:00:02','86',''),(10732,2021,'2020-01-23 18:00:11','88',''),(10730,1611,'2020-01-23 18:00:06','88',''),(10757,1611,'2020-01-23 20:00:01','85',''),(10772,2020,'2020-01-23 21:00:01','5',''),(10736,2063,'2020-01-23 18:00:11','-3',''),(10719,2128,'2020-01-23 17:00:02','2',''),(10723,2154,'2020-01-23 17:00:02','3',''),(10740,2101,'2020-01-23 21:00:02','5',''),(10763,2090,'2020-01-23 21:00:02','-9',''),(10756,1610,'2020-01-23 20:00:01','5',''),(10771,2009,'2020-01-23 21:00:01','-7',''),(10998,1605,'2020-01-24 17:00:01','-1',''),(10735,2048,'2020-01-23 23:00:02','93',''),(10718,2117,'2020-01-23 17:00:02','-9',''),(10720,2382,'2020-01-23 17:00:02','78',''),(10721,2130,'2020-01-23 17:00:02','762',''),(10722,2143,'2020-01-23 17:00:02','0',''),(10724,2383,'2020-01-23 17:00:02','98',''),(10725,2156,'2020-01-23 17:00:02','755',''),(10726,2169,'2020-01-23 17:00:02','1',''),(10727,2180,'2020-01-23 17:00:02','6',''),(10728,2384,'2020-01-23 17:00:02','98',''),(10729,2182,'2020-01-23 17:00:02','745',''),(10755,1605,'2020-01-23 20:00:01','-7',''),(11003,2021,'2020-01-24 17:00:01','94',''),(10734,2036,'2020-01-23 18:00:11','-1',''),(10787,2101,'2020-01-23 23:00:02','6',''),(10791,2128,'2020-01-23 23:00:02','1',''),(10792,2382,'2020-01-23 23:00:02','80',''),(10793,2130,'2020-01-23 23:00:02','761',''),(10795,2154,'2020-01-23 23:00:02','5',''),(10796,2383,'2020-01-23 23:00:02','88',''),(10797,2156,'2020-01-23 23:00:02','761',''),(10800,2384,'2020-01-23 23:00:02','97',''),(10799,2180,'2020-01-23 23:00:02','7',''),(10891,2009,'2020-01-24 08:00:01','-8',''),(10801,2182,'2020-01-23 23:00:02','750',''),(10782,2036,'2020-01-23 23:00:02','0',''),(10786,2090,'2020-01-23 23:00:02','-8',''),(10790,2117,'2020-01-23 23:00:02','-11',''),(10794,2143,'2020-01-23 23:00:02','-8',''),(10798,2169,'2020-01-23 23:00:02','-1',''),(10927,2047,'2020-01-24 11:00:01','4',''),(10835,2009,'2020-01-24 03:00:01','-3',''),(10922,1610,'2020-01-24 11:00:01','7',''),(10833,1610,'2020-01-24 02:00:04','3',''),(10999,1611,'2020-01-24 17:00:01','90',''),(10990,2020,'2020-01-24 15:00:07','6',''),(10921,1605,'2020-01-24 11:00:01','-3',''),(10988,1613,'2020-01-24 15:00:02','744',''),(10982,2117,'2020-01-24 14:00:01','-10',''),(10810,2047,'2020-01-24 00:00:05','4',''),(10811,2048,'2020-01-24 00:00:05','94',''),(10873,2063,'2020-01-24 05:00:01','-5',''),(10932,2077,'2020-01-24 11:00:01','754',''),(10815,2075,'2020-01-24 00:00:06','85',''),(10966,2382,'2020-01-24 15:00:07','89',''),(10963,2104,'2020-01-24 15:00:07','759',''),(10911,2182,'2020-01-24 09:00:06','750',''),(10905,2382,'2020-01-24 09:00:06','90',''),(10958,2075,'2020-01-25 00:00:01','86',''),(10903,2117,'2020-01-24 09:00:06','-11',''),(10900,2090,'2020-01-24 09:00:06','-8',''),(10897,2063,'2020-01-24 09:00:06','-5',''),(10894,2036,'2020-01-24 09:00:05','-5',''),(10951,2009,'2020-01-24 12:00:02','-3',''),(10890,1613,'2020-01-24 06:00:01','752',''),(10920,2009,'2020-01-24 09:00:05','-5',''),(10987,1611,'2020-01-24 15:00:01','91',''),(10984,2169,'2020-01-24 14:00:02','-7',''),(10995,2117,'2020-01-24 15:00:07','-10',''),(10974,2182,'2020-01-24 15:00:08','756',''),(10972,2169,'2020-01-24 12:00:03','-6',''),(10970,2383,'2020-01-24 21:00:01','91',''),(10929,2063,'2020-01-24 11:00:01','-6',''),(10930,2074,'2020-01-24 11:00:01','5',''),(10875,2077,'2020-01-24 05:00:02','753',''),(10965,2128,'2020-01-24 15:00:07','5',''),(10934,2101,'2020-01-24 11:00:01','4',''),(10960,2090,'2020-01-24 12:00:02','-7',''),(10910,2384,'2020-01-24 15:00:08','89',''),(10907,2383,'2020-01-24 09:00:06','89',''),(10904,2128,'2020-01-24 09:00:06','4',''),(10957,2074,'2020-01-24 15:00:07','5',''),(10902,2104,'2020-01-24 09:00:06','758',''),(10954,2047,'2020-01-24 15:00:07','4',''),(10899,2077,'2020-01-24 09:00:06','753',''),(10896,2048,'2020-01-24 09:00:06','87',''),(10893,2021,'2020-01-24 14:00:01','92',''),(10950,1613,'2020-01-24 12:00:01','746',''),(10889,1611,'2020-01-24 06:00:01','82',''),(10919,1613,'2020-01-24 09:00:01','749',''),(10913,1610,'2020-01-24 08:00:01','6',''),(10917,1610,'2020-01-24 09:00:01','6',''),(10986,1610,'2020-01-24 18:00:01','6',''),(10983,2143,'2020-01-24 14:00:02','-7',''),(10994,2090,'2020-01-24 15:00:07','-10',''),(10973,2180,'2020-01-24 15:00:08','5',''),(10971,2156,'2020-01-24 15:00:08','763',''),(10969,2154,'2020-01-24 21:00:01','5',''),(11125,2382,'2020-01-25 02:00:03','93',''),(10968,2143,'2020-01-24 12:00:02','-10',''),(11061,2023,'2020-01-25 00:00:01','743',''),(10964,2117,'2020-01-24 12:00:02','-13',''),(11055,2143,'2020-01-24 23:00:02','-5',''),(10962,2102,'2020-01-24 15:00:07','82',''),(10959,2077,'2020-01-24 15:00:07','754',''),(10909,2169,'2020-01-24 09:00:06','-1',''),(10906,2143,'2020-01-24 09:00:06','-7',''),(10956,2063,'2020-01-24 17:00:01','-6',''),(10901,2102,'2020-01-24 09:00:06','91',''),(10953,2036,'2020-01-24 12:00:02','-3',''),(10898,2075,'2020-01-24 09:00:06','82',''),(10895,2047,'2020-01-24 09:00:06','5',''),(10892,2020,'2020-01-24 09:00:05','8',''),(10949,1610,'2020-01-24 12:00:01','7',''),(10888,1610,'2020-01-24 06:00:01','4',''),(10918,1611,'2020-01-24 12:00:01','92',''),(10981,2090,'2020-01-24 14:00:01','-10',''),(10916,1605,'2020-01-24 09:00:01','-5',''),(10867,2009,'2020-01-24 05:00:01','-8',''),(10868,2020,'2020-01-24 05:00:01','8',''),(10869,2021,'2020-01-24 05:00:01','92',''),(10870,2036,'2020-01-24 05:00:01','-5',''),(10871,2047,'2020-01-24 05:00:01','5',''),(10872,2048,'2020-01-24 05:00:01','87',''),(10874,2075,'2020-01-24 05:00:02','82',''),(10876,2090,'2020-01-24 05:00:02','-8',''),(10877,2102,'2020-01-24 05:00:02','91',''),(10878,2104,'2020-01-24 05:00:02','758',''),(10879,2117,'2020-01-24 05:00:02','-11',''),(10880,2128,'2020-01-24 05:00:02','4',''),(10881,2382,'2020-01-24 05:00:02','90',''),(10940,2130,'2020-01-24 11:00:01','764',''),(10882,2143,'2020-01-24 05:00:02','-7',''),(10952,2020,'2020-01-24 14:00:01','7',''),(10883,2383,'2020-01-24 05:00:02','89',''),(10884,2156,'2020-01-24 05:00:02','755',''),(10885,2169,'2020-01-24 05:00:02','-1',''),(10948,1605,'2020-01-24 12:00:01','-3',''),(10886,2384,'2020-01-24 05:00:02','89',''),(10887,2182,'2020-01-24 05:00:02','750',''),(10912,1605,'2020-01-24 08:00:01','-5',''),(10915,1613,'2020-01-24 08:00:01','749',''),(10989,2009,'2020-01-24 15:00:07','-0',''),(11060,2021,'2020-01-24 21:00:01','87',''),(10997,2169,'2020-01-24 15:00:08','-7',''),(10926,2036,'2020-01-24 11:00:01','-3',''),(11007,2050,'2020-01-24 17:00:01','742',''),(10928,2048,'2020-01-24 11:00:01','86',''),(10931,2075,'2020-01-24 11:00:01','86',''),(10933,2090,'2020-01-24 11:00:01','-7',''),(10935,2102,'2020-01-24 11:00:01','82',''),(10936,2104,'2020-01-24 11:00:01','759',''),(10937,2117,'2020-01-24 11:00:01','-13',''),(10938,2128,'2020-01-24 11:00:01','5',''),(11036,2102,'2020-01-24 21:00:01','93',''),(11035,2101,'2020-01-24 21:00:01','2',''),(10941,2143,'2020-01-24 11:00:02','-10',''),(10942,2154,'2020-01-24 11:00:02','5',''),(10943,2383,'2020-01-24 11:00:02','91',''),(10944,2156,'2020-01-24 11:00:02','763',''),(10945,2169,'2020-01-24 11:00:02','-6',''),(10946,2180,'2020-01-24 11:00:02','5',''),(11027,2021,'2020-01-24 18:00:01','94',''),(10947,2182,'2020-01-24 11:00:02','756',''),(10975,1605,'2020-01-24 14:00:01','-0',''),(10914,1611,'2020-01-24 08:00:01','92',''),(10980,2036,'2020-01-24 14:00:01','-2',''),(10924,2009,'2020-01-24 11:00:01','-5',''),(10979,2009,'2020-01-24 14:00:01','-3',''),(10923,1613,'2020-01-24 11:00:01','746',''),(10976,1610,'2020-01-24 14:00:01','6',''),(10978,1613,'2020-01-24 14:00:01','744',''),(11002,2020,'2020-01-24 20:00:07','6',''),(10996,2143,'2020-01-24 17:00:02','-7',''),(10993,2036,'2020-01-24 21:00:01','-2',''),(11065,2036,'2020-01-24 23:00:01','-3',''),(11006,2048,'2020-01-24 17:00:01','85',''),(11033,2077,'2020-01-25 00:00:01','755',''),(11124,2128,'2020-01-25 02:00:03','3',''),(11058,1611,'2020-01-25 00:00:01','87',''),(11047,2182,'2020-01-24 21:00:01','752',''),(11045,2180,'2020-01-24 21:00:01','6',''),(11040,2382,'2020-01-24 21:00:01','91',''),(11038,2117,'2020-01-24 18:00:01','-8',''),(11044,2169,'2020-01-24 18:00:02','-2',''),(11090,2090,'2020-01-25 00:00:01','-12',''),(11089,2063,'2020-01-25 00:00:01','-4',''),(11018,2156,'2020-01-24 17:00:02','760',''),(11034,2090,'2020-01-24 18:00:01','-8',''),(11029,2048,'2020-01-24 21:00:01','85',''),(11026,2009,'2020-01-24 23:00:01','-1',''),(11024,1611,'2020-01-24 18:00:01','90',''),(11054,2117,'2020-01-24 21:00:01','-8',''),(10977,1611,'2020-01-24 14:00:01','91',''),(11001,2009,'2020-01-24 17:00:01','-1',''),(10991,2021,'2020-01-24 15:00:07','91',''),(10992,2023,'2020-01-24 15:00:07','744',''),(11213,2036,'2020-01-25 11:00:01','-8',''),(11067,2048,'2020-01-24 23:00:01','94',''),(11032,2074,'2020-01-25 00:00:01','4',''),(11123,2117,'2020-01-25 02:00:03','-0',''),(11057,1610,'2020-01-25 00:00:01','5',''),(11046,2384,'2020-01-24 21:00:01','92',''),(11041,2130,'2020-01-24 21:00:01','760',''),(11039,2128,'2020-01-24 21:00:01','4',''),(11037,2104,'2020-01-24 21:00:01','757',''),(11043,2156,'2020-01-24 21:00:01','760',''),(11077,2154,'2020-01-24 23:00:02','3',''),(11088,2048,'2020-01-25 00:00:01','94',''),(11079,2156,'2020-01-24 23:00:02','758',''),(11030,2050,'2020-01-25 00:00:01','742',''),(11028,2047,'2020-01-24 21:00:01','5',''),(11025,1613,'2020-01-25 09:00:01','743',''),(11023,1605,'2020-01-24 21:00:00','-1',''),(11064,2021,'2020-01-25 00:00:01','87',''),(11053,2090,'2020-01-24 21:00:01','-8',''),(11000,1613,'2020-01-24 17:00:01','743',''),(11056,2169,'2020-01-24 21:00:01','-2',''),(11014,2117,'2020-01-24 17:00:02','-7',''),(11042,2143,'2020-01-24 18:00:02','-5',''),(11019,2169,'2020-01-24 17:00:02','-1',''),(11063,2020,'2020-01-25 00:00:01','5',''),(11049,1611,'2020-01-24 20:00:03','87',''),(11241,2090,'2020-01-25 12:00:01','-10',''),(11086,2036,'2020-01-25 00:00:01','-3',''),(11052,2063,'2020-01-24 21:00:01','-7',''),(11051,2023,'2020-01-24 20:00:07','743',''),(11005,2047,'2020-01-24 17:00:01','5',''),(11031,2063,'2020-01-24 18:00:01','-7',''),(11122,2104,'2020-01-25 02:00:02','761',''),(11009,2077,'2020-01-24 17:00:02','755',''),(11010,2090,'2020-01-24 17:00:02','-7',''),(11011,2101,'2020-01-24 17:00:02','2',''),(11012,2102,'2020-01-24 17:00:02','93',''),(11013,2104,'2020-01-24 17:00:02','757',''),(11015,2128,'2020-01-24 17:00:02','4',''),(11016,2382,'2020-01-24 17:00:02','91',''),(11017,2130,'2020-01-24 17:00:02','760',''),(11087,2047,'2020-01-25 23:00:01','4',''),(11020,2180,'2020-01-24 17:00:02','6',''),(11021,2384,'2020-01-24 17:00:02','92',''),(11022,2182,'2020-01-24 17:00:02','752',''),(11062,1605,'2020-01-24 23:00:01','-3',''),(11048,1610,'2020-01-24 20:00:03','5',''),(11085,2009,'2020-01-25 00:00:01','-3',''),(11050,2021,'2020-01-24 20:00:07','90',''),(11263,2023,'2020-01-25 15:00:01','740',''),(11066,2047,'2020-01-24 23:00:01','4',''),(11068,2063,'2020-01-24 23:00:01','-6',''),(11121,2101,'2020-01-25 02:00:02','5',''),(11120,2090,'2020-01-25 02:00:02','-9',''),(11069,2090,'2020-01-24 23:00:02','-14',''),(11070,2101,'2020-01-24 23:00:02','3',''),(11071,2102,'2020-01-24 23:00:02','89',''),(11072,2104,'2020-01-24 23:00:02','760',''),(11091,2101,'2020-01-25 00:00:01','3',''),(11074,2128,'2020-01-24 23:00:02','5',''),(11075,2382,'2020-01-24 23:00:02','89',''),(11076,2130,'2020-01-24 23:00:02','761',''),(11099,2154,'2020-01-25 00:00:02','3',''),(11078,2383,'2020-01-24 23:00:02','93',''),(11084,1605,'2020-01-25 00:00:01','-3',''),(11081,2180,'2020-01-24 23:00:02','5',''),(11082,2384,'2020-01-24 23:00:02','96',''),(11083,2182,'2020-01-24 23:00:02','751',''),(11163,1605,'2020-01-25 05:00:00','-2',''),(11270,1611,'2020-01-25 17:00:02','93',''),(11167,2021,'2020-01-25 05:00:00','93',''),(11059,2020,'2020-01-24 21:00:01','5',''),(11202,2156,'2020-01-25 09:00:02','756',''),(11073,2117,'2020-01-24 23:00:02','-9',''),(11098,2143,'2020-01-25 00:00:02','-0',''),(11080,2169,'2020-01-24 23:00:02','-1',''),(11115,2050,'2020-01-25 02:00:02','755',''),(11114,2048,'2020-01-25 02:00:02','86',''),(11113,2036,'2020-01-25 02:00:02','-4',''),(11112,2023,'2020-01-25 02:00:02','742',''),(11109,2009,'2020-01-25 03:00:00','-3',''),(11110,2020,'2020-01-25 02:00:02','4',''),(11111,2021,'2020-01-25 02:00:02','94',''),(11393,2074,'2020-01-26 03:00:01','5',''),(11205,1610,'2020-01-25 08:00:00','4',''),(11203,2180,'2020-01-25 09:00:02','3',''),(11117,2074,'2020-01-25 02:00:02','3',''),(11118,2075,'2020-01-25 02:00:02','89',''),(11119,2077,'2020-01-25 02:00:02','760',''),(11388,2036,'2020-01-26 03:00:01','-11',''),(11201,2383,'2020-01-25 09:00:02','91',''),(11199,2143,'2020-01-25 12:00:01','-1',''),(11197,2128,'2020-01-25 09:00:02','4',''),(11176,2128,'2020-01-25 05:00:01','4',''),(11195,2104,'2020-01-25 09:00:02','762',''),(11235,2036,'2020-01-25 12:00:01','-8',''),(11193,2090,'2020-01-25 09:00:02','-11',''),(11191,2063,'2020-01-25 09:00:02','-8',''),(11189,2036,'2020-01-25 09:00:02','-7',''),(11187,2009,'2020-01-25 15:00:01','-2',''),(11234,2023,'2020-01-25 14:00:01','741',''),(11182,2180,'2020-01-25 05:00:01','3',''),(11231,1611,'2020-01-25 12:00:01','94',''),(11185,1610,'2020-01-25 06:00:01','5',''),(11108,1611,'2020-01-25 02:00:01','90',''),(11355,2021,'2020-01-26 00:00:03','85',''),(11214,2048,'2020-01-25 11:00:01','85',''),(11392,2063,'2020-01-26 03:00:01','-8',''),(11204,2182,'2020-01-25 09:00:02','755',''),(11171,2075,'2020-01-25 05:00:01','90',''),(11216,2074,'2020-01-25 11:00:01','2',''),(11236,2048,'2020-01-25 15:00:01','85',''),(11219,2090,'2020-01-25 11:00:01','-10',''),(11387,2023,'2020-01-26 09:00:02','755',''),(11200,2154,'2020-01-25 15:00:02','4',''),(11198,2382,'2020-01-25 09:00:02','94',''),(11196,2117,'2020-01-25 12:00:01','-8',''),(11222,2128,'2020-01-25 11:00:01','3',''),(11194,2102,'2020-01-25 09:00:02','90',''),(11224,2130,'2020-01-25 11:00:01','759',''),(11192,2075,'2020-01-25 09:00:02','90',''),(11190,2048,'2020-01-25 09:00:02','84',''),(11188,2021,'2020-01-25 09:00:02','93',''),(11186,1611,'2020-01-25 06:00:01','89',''),(11233,2021,'2020-01-25 14:00:01','94',''),(11228,2180,'2020-01-25 11:00:02','4',''),(11229,2384,'2020-01-25 11:00:02','93',''),(11184,1605,'2020-01-25 18:00:00','-2',''),(11208,1611,'2020-01-25 09:00:01','90',''),(11240,2077,'2020-01-25 15:00:02','759',''),(11207,1610,'2020-01-25 15:00:01','4',''),(11239,2075,'2020-01-25 15:00:01','91',''),(11166,2009,'2020-01-25 05:00:00','-2',''),(11212,2023,'2020-01-25 11:00:01','741',''),(11169,2048,'2020-01-25 05:00:01','84',''),(11170,2063,'2020-01-25 05:00:01','-8',''),(11217,2075,'2020-01-25 11:00:01','91',''),(11218,2077,'2020-01-25 11:00:01','759',''),(11172,2090,'2020-01-25 05:00:01','-11',''),(11173,2102,'2020-01-25 05:00:01','90',''),(11174,2104,'2020-01-25 05:00:01','762',''),(11175,2117,'2020-01-25 05:00:01','-8',''),(11177,2382,'2020-01-25 05:00:01','94',''),(11178,2143,'2020-01-25 05:00:01','-1',''),(11179,2154,'2020-01-25 05:00:01','4',''),(11180,2383,'2020-01-25 05:00:01','91',''),(11181,2156,'2020-01-25 05:00:01','756',''),(11232,1613,'2020-01-25 12:00:01','741',''),(11183,2182,'2020-01-25 05:00:01','755',''),(11313,1605,'2020-01-25 20:00:01','-3',''),(11206,1611,'2020-01-25 08:00:00','90',''),(11238,2074,'2020-01-25 23:00:01','2',''),(11489,2023,'2020-01-26 16:00:03','754',''),(11211,2021,'2020-01-25 11:00:01','94',''),(11338,2048,'2020-01-25 23:00:01','85',''),(11215,2063,'2020-01-25 11:00:01','-7',''),(11308,2383,'2020-01-25 21:00:07','93',''),(11307,2154,'2020-01-26 03:00:02','5',''),(11279,2090,'2020-01-25 17:00:06','-8',''),(11220,2102,'2020-01-25 11:00:01','89',''),(11221,2104,'2020-01-25 11:00:01','761',''),(11265,2063,'2020-01-25 15:00:01','-9',''),(11223,2382,'2020-01-25 11:00:01','93',''),(11261,1613,'2020-01-25 15:00:01','740',''),(11301,2090,'2020-01-25 23:00:01','-8',''),(11225,2383,'2020-01-25 11:00:02','92',''),(11226,2156,'2020-01-25 11:00:02','758',''),(11227,2169,'2020-01-25 11:00:02','-1',''),(11230,2182,'2020-01-25 11:00:02','758',''),(11455,1605,'2020-01-26 08:00:01','-8',''),(11255,2036,'2020-01-25 14:00:01','-6',''),(11237,2063,'2020-01-25 12:00:01','-7',''),(11210,1613,'2020-01-25 11:00:01','741',''),(11273,2021,'2020-01-25 17:00:05','95',''),(11269,1610,'2020-01-25 17:00:02','6',''),(11254,1613,'2020-01-25 14:00:01','740',''),(11264,2036,'2020-01-25 17:00:05','-6',''),(11297,2048,'2020-01-25 21:00:06','84',''),(11363,2075,'2020-01-26 00:00:03','91',''),(11386,2021,'2020-01-26 14:00:01','85',''),(11306,2143,'2020-01-25 18:00:01','-1',''),(11353,2009,'2020-01-26 00:00:03','-4',''),(11305,2130,'2020-01-25 21:00:07','757',''),(11375,2156,'2020-01-26 00:00:04','753',''),(11303,2117,'2020-01-25 18:00:01','-1',''),(11260,1611,'2020-01-25 15:00:01','96',''),(11300,2077,'2020-01-25 23:00:01','761',''),(11298,2063,'2020-01-25 18:00:01','-13',''),(11294,2021,'2020-01-25 18:00:01','93',''),(11317,2020,'2020-01-25 23:00:01','6',''),(11292,2009,'2020-01-25 18:00:01','-2',''),(11382,1611,'2020-01-26 02:00:06','89',''),(11290,1611,'2020-01-25 18:00:00','93',''),(11332,1610,'2020-01-25 23:00:00','5',''),(11253,1611,'2020-01-25 14:00:01','96',''),(11262,2021,'2020-01-25 15:00:01','96',''),(11296,2036,'2020-01-25 18:00:01','-5',''),(11362,2074,'2020-01-26 00:00:03','5',''),(11370,2128,'2020-01-26 00:00:03','5',''),(11281,2117,'2020-01-25 17:00:06','-4',''),(11352,1613,'2020-01-26 00:00:03','746',''),(11258,2117,'2020-01-25 14:00:02','-5',''),(11304,2128,'2020-01-25 21:00:07','4',''),(11374,2383,'2020-01-26 00:00:04','93',''),(11302,2102,'2020-01-25 23:00:01','91',''),(11259,2143,'2020-01-25 14:00:02','0',''),(11299,2075,'2020-01-25 21:00:06','87',''),(11295,2023,'2020-01-25 18:00:01','741',''),(11293,2020,'2020-01-25 18:00:01','6',''),(11312,2182,'2020-01-25 21:00:07','752',''),(11291,1613,'2020-01-25 18:00:00','741',''),(11381,1610,'2020-01-26 02:00:06','6',''),(11289,1610,'2020-01-25 21:00:06','6',''),(11316,2009,'2020-01-25 20:00:01','-2',''),(11272,2009,'2020-01-25 17:00:05','-1',''),(11335,2009,'2020-01-25 23:00:01','-3',''),(11331,1605,'2020-01-25 23:00:00','-4',''),(11394,2075,'2020-01-26 03:00:01','91',''),(11309,2156,'2020-01-25 21:00:07','752',''),(11351,1611,'2020-01-26 00:00:02','87',''),(11350,1610,'2020-01-26 00:00:02','5',''),(11311,2180,'2020-01-25 23:00:01','5',''),(11315,1613,'2020-01-25 20:00:01','743',''),(11271,1613,'2020-01-25 17:00:02','741',''),(11334,1613,'2020-01-25 23:00:00','746',''),(11330,2023,'2020-01-25 21:00:06','743',''),(11361,2063,'2020-01-26 00:00:03','-8',''),(11276,2063,'2020-01-25 17:00:06','-11',''),(11277,2075,'2020-01-25 17:00:06','87',''),(11278,2077,'2020-01-25 17:00:06','761',''),(11369,2117,'2020-01-26 00:00:03','-1',''),(11280,2102,'2020-01-25 17:00:06','91',''),(11341,2104,'2020-01-25 23:00:01','759',''),(11282,2128,'2020-01-25 17:00:06','4',''),(11373,2143,'2020-01-26 00:00:04','-3',''),(11283,2130,'2020-01-25 17:00:06','757',''),(11284,2154,'2020-01-25 17:00:06','5',''),(11285,2383,'2020-01-25 17:00:06','93',''),(11286,2156,'2020-01-25 17:00:06','752',''),(11310,2169,'2020-01-25 18:00:02','-2',''),(11287,2180,'2020-01-25 17:00:06','5',''),(11380,1605,'2020-01-26 02:00:06','-5',''),(11288,2182,'2020-01-25 17:00:06','752',''),(11314,1611,'2020-01-25 20:00:01','92',''),(11418,1613,'2020-01-26 05:00:00','752',''),(11333,1611,'2020-01-25 23:00:00','87',''),(11359,2048,'2020-01-26 00:00:03','82',''),(11356,2023,'2020-01-26 00:00:03','755',''),(11340,2075,'2020-01-25 23:00:01','82',''),(11391,2050,'2020-01-26 23:00:01','761',''),(11390,2048,'2020-01-26 09:00:02','82',''),(11366,2101,'2020-01-26 00:00:03','3',''),(11368,2104,'2020-01-26 00:00:03','758',''),(11342,2117,'2020-01-25 23:00:01','-3',''),(11343,2128,'2020-01-25 23:00:01','3',''),(11372,2130,'2020-01-26 00:00:03','755',''),(11344,2130,'2020-01-25 23:00:01','758',''),(11349,1605,'2020-01-26 00:00:02','-4',''),(11453,2384,'2020-01-26 14:00:02','95',''),(11346,2383,'2020-01-25 23:00:01','94',''),(11347,2156,'2020-01-25 23:00:01','755',''),(11385,2020,'2020-01-26 14:00:01','4',''),(11383,1613,'2020-01-26 02:00:06','749',''),(11379,2182,'2020-01-26 00:00:04','759',''),(11348,2182,'2020-01-25 23:00:01','753',''),(11460,1610,'2020-01-26 09:00:01','3',''),(11329,2021,'2020-01-25 21:00:06','92',''),(11339,2063,'2020-01-25 23:00:01','-12',''),(11389,2047,'2020-01-26 09:00:02','2',''),(11491,2048,'2020-01-26 14:00:01','84',''),(11345,2143,'2020-01-25 23:00:01','-2',''),(11384,2009,'2020-01-26 03:00:01','-4',''),(11417,1611,'2020-01-26 05:00:00','86',''),(11354,2020,'2020-01-26 00:00:03','4',''),(11357,2036,'2020-01-26 00:00:03','-11',''),(11358,2047,'2020-01-26 00:00:03','2',''),(11492,2063,'2020-01-26 12:00:01','-12',''),(11495,2090,'2020-01-26 12:00:01','-8',''),(11364,2077,'2020-01-26 00:00:03','759',''),(11365,2090,'2020-01-26 00:00:03','-3',''),(11367,2102,'2020-01-26 00:00:03','93',''),(11485,1610,'2020-01-26 12:00:00','4',''),(11371,2382,'2020-01-26 00:00:03','94',''),(11462,1613,'2020-01-26 09:00:01','753',''),(11454,2182,'2020-01-26 09:00:03','760',''),(11452,2180,'2020-01-26 09:00:03','2',''),(11449,2383,'2020-01-26 09:00:02','91',''),(11446,2130,'2020-01-26 09:00:02','756',''),(11376,2169,'2020-01-26 00:00:04','-4',''),(11377,2180,'2020-01-26 00:00:04','1',''),(11378,2384,'2020-01-26 00:00:04','94',''),(11437,1611,'2020-01-26 06:00:01','86',''),(11416,1610,'2020-01-26 05:00:00','5',''),(11499,2143,'2020-01-26 12:00:01','-2',''),(11468,2047,'2020-01-26 11:00:01','3',''),(11470,2063,'2020-01-26 11:00:01','-12',''),(11497,2128,'2020-01-26 14:00:01','6',''),(11422,2074,'2020-01-26 05:00:01','4',''),(11494,2077,'2020-01-26 14:00:01','761',''),(11472,2077,'2020-01-26 11:00:01','761',''),(11490,2047,'2020-01-26 21:00:07','3',''),(11484,1605,'2020-01-26 12:00:00','-6',''),(11461,1611,'2020-01-26 09:00:01','92',''),(11427,2143,'2020-01-26 05:00:01','-1',''),(11451,2169,'2020-01-26 09:00:02','-5',''),(11448,2154,'2020-01-26 09:00:02','4',''),(11445,2382,'2020-01-26 21:00:07','90',''),(11443,2075,'2020-01-26 14:00:01','90',''),(11441,2063,'2020-01-26 09:00:02','-9',''),(11439,2009,'2020-01-26 11:00:01','-7',''),(11436,1610,'2020-01-26 06:00:01','5',''),(11641,2020,'2020-01-27 13:00:03','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11498,2130,'2020-01-26 14:00:01','752',''),(11469,2048,'2020-01-26 11:00:01','84',''),(11496,2117,'2020-01-26 12:00:01','-0',''),(11471,2074,'2020-01-26 11:00:01','5',''),(11493,2074,'2020-01-26 21:00:07','5',''),(11721,2102,'2020-01-27 23:00:02','93','/objects/?object=ClockChime&op=m&m=onNewHour'),(11720,2101,'2020-01-27 15:00:05','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11487,1613,'2020-01-26 16:00:03','754',''),(11477,2143,'2020-01-26 11:00:02','-2',''),(11463,1605,'2020-01-26 11:00:01','-6',''),(11456,1610,'2020-01-26 08:00:01','3',''),(11450,2156,'2020-01-26 09:00:02','756',''),(11447,2143,'2020-01-26 09:00:02','-1',''),(11444,2090,'2020-01-26 09:00:02','-4',''),(11442,2074,'2020-01-26 09:00:02','4',''),(11440,2036,'2020-01-26 14:00:01','-10',''),(11438,1613,'2020-01-26 06:00:01','752',''),(11435,1605,'2020-01-26 06:00:01','-7',''),(11459,1605,'2020-01-26 09:00:01','-8',''),(11420,2036,'2020-01-26 05:00:01','-10',''),(11421,2063,'2020-01-26 05:00:01','-9',''),(11423,2075,'2020-01-26 05:00:01','90',''),(11424,2090,'2020-01-26 05:00:01','-4',''),(11486,1611,'2020-01-26 12:00:00','85',''),(11475,2128,'2020-01-26 11:00:01','6',''),(11425,2382,'2020-01-26 05:00:01','90',''),(11426,2130,'2020-01-26 05:00:01','756',''),(11428,2154,'2020-01-26 05:00:01','4',''),(11429,2383,'2020-01-26 05:00:01','91',''),(11430,2156,'2020-01-26 05:00:01','756',''),(11431,2169,'2020-01-26 05:00:01','-5',''),(11432,2180,'2020-01-26 05:00:02','2',''),(11433,2384,'2020-01-26 05:00:02','95',''),(11434,2182,'2020-01-26 05:00:02','760',''),(11465,1611,'2020-01-26 11:00:01','85',''),(11458,1613,'2020-01-26 08:00:01','753',''),(11467,2023,'2020-01-26 11:00:01','754',''),(11646,2036,'2020-01-27 03:00:02','-10','/objects/?object=ClockChime&op=m&m=onNewHour'),(11473,2090,'2020-01-26 11:00:01','-8',''),(11474,2117,'2020-01-26 11:00:01','-0',''),(11476,2130,'2020-01-26 11:00:01','752',''),(11478,2154,'2020-01-26 11:00:02','6',''),(11479,2383,'2020-01-26 11:00:02','93',''),(11480,2156,'2020-01-26 11:00:02','752',''),(11481,2169,'2020-01-26 11:00:02','-3',''),(11482,2180,'2020-01-26 11:00:02','1',''),(11483,2182,'2020-01-26 11:00:02','757',''),(11464,1610,'2020-01-26 11:00:01','4',''),(11457,1611,'2020-01-26 08:00:01','92',''),(11466,1613,'2020-01-26 11:00:01','754',''),(11692,1610,'2020-01-27 03:00:01','6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11488,2009,'2020-01-26 12:00:00','-6',''),(11638,2009,'2020-01-27 03:00:02','-14','/objects/?object=ClockChime&op=m&m=onNewHour'),(6085,2074,'2019-12-27 12:00:10','2',''),(11765,2077,'2020-01-27 23:00:02','760','/objects/?object=ClockChime&op=m&m=onNewHour'),(11682,2169,'2020-01-27 03:00:03','1','/objects/?object=ClockChime&op=m&m=onNewHour'),(11757,2009,'2020-01-27 11:00:03','-12','/objects/?object=ClockChime&op=m&m=onNewHour'),(6106,2074,'2019-12-27 15:00:01','2',''),(11727,2128,'2020-01-27 09:00:07','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11732,2383,'2020-01-27 15:00:06','93','/objects/?object=ClockChime&op=m&m=onNewHour'),(11739,2384,'2020-01-27 09:00:07','96','/objects/?object=ClockChime&op=m&m=onNewHour'),(11738,2180,'2020-01-27 09:00:07','6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11643,2021,'2020-01-27 13:00:03','88','/objects/?object=ClockChime&op=m&m=onNewHour'),(11730,2143,'2020-01-27 09:00:07','-7','/objects/?object=ClockChime&op=m&m=onNewHour'),(11691,1605,'2020-01-27 03:00:01','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(6145,2074,'2019-12-27 16:00:04','1',''),(11716,2090,'2020-01-27 09:00:07','-9','/objects/?object=ClockChime&op=m&m=onNewHour'),(11770,2104,'2020-01-27 21:00:01','757','/objects/?object=ClockChime&op=m&m=onNewHour'),(6168,2074,'2019-12-28 00:00:02','1',''),(11688,1610,'2020-01-27 03:00:01','6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11637,2009,'2020-01-27 01:00:01','-14','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11645,2036,'2020-01-27 01:00:01','-10','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11665,2117,'2020-01-27 01:00:01','-7','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11681,2169,'2020-01-27 01:00:02','1','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11687,1605,'2020-01-27 03:00:01','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11689,1611,'2020-01-27 03:00:01','89','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11690,1613,'2020-01-27 03:00:01','752','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11639,2020,'2020-01-27 01:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11640,2021,'2020-01-27 01:00:01','88','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11642,2023,'2020-01-27 01:00:01','761','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11651,2063,'2020-01-27 01:00:01','-5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(6238,2074,'2019-12-28 01:00:01','9',''),(11712,2077,'2020-01-27 05:00:02','761','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11718,2102,'2020-01-27 05:00:02','93','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(6268,2074,'2019-12-29 00:00:03','9',''),(11762,2117,'2020-01-27 11:00:03','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11764,2130,'2020-01-27 11:00:03','752','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11703,2009,'2020-01-27 05:00:01','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11784,2036,'2020-01-27 13:00:02','-10','/objects/?object=ClockChime&op=m&m=onNewHour'),(11707,2047,'2020-01-27 05:00:02','5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11756,2048,'2020-01-27 11:00:01','82','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11711,2075,'2020-01-27 05:00:02','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11715,2090,'2020-01-27 05:00:02','-9','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11904,2101,'2020-01-27 17:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11719,2104,'2020-01-27 05:00:02','758','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11725,2128,'2020-01-27 05:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11726,2382,'2020-01-27 05:00:02','93','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11729,2143,'2020-01-27 05:00:02','-7','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11768,2154,'2020-01-27 11:00:03','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11731,2383,'2020-01-27 05:00:02','93','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11733,2169,'2020-01-27 05:00:02','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11735,2180,'2020-01-27 05:00:02','6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11736,2384,'2020-01-27 05:00:02','96','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11737,2182,'2020-01-27 05:00:02','749','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11747,2009,'2020-01-27 09:00:05','-13','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(6316,2047,'2019-12-28 15:00:01','2',''),(11766,2143,'2020-01-27 11:00:03','-9','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11769,2156,'2020-01-27 11:00:03','754','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11773,2180,'2020-01-27 11:00:03','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11774,2384,'2020-01-27 11:00:03','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11741,1605,'2020-01-27 09:00:02','-13','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11742,1611,'2020-01-27 09:00:02','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11743,1613,'2020-01-27 09:00:02','759','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11797,1610,'2020-01-27 15:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11912,2383,'2020-01-27 17:00:02','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11785,2063,'2020-01-27 13:00:02','-8','/objects/?object=ClockChime&op=m&m=onNewHour'),(12472,1611,'2020-01-28 13:00:01','82','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(11890,1605,'2020-01-27 17:00:00','-14','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11798,1611,'2020-01-27 15:00:01','89','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11799,1613,'2020-01-27 15:00:02','763','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11970,2009,'2020-01-27 19:00:02','-14','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11804,2021,'2020-01-27 15:00:03','89','/objects/?object=ClockChime&op=m&m=onNewHour'),(11805,2023,'2020-01-27 15:00:03','763','/objects/?object=ClockChime&op=m&m=onNewHour'),(11902,2090,'2020-01-27 17:00:01','-5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12519,2009,'2020-01-28 13:00:01','-11','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6391,2047,'2019-12-28 16:00:01','1',''),(11906,2382,'2020-01-27 17:00:01','95','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11908,2143,'2020-01-27 17:00:02','-7','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11910,2154,'2020-01-27 17:00:02','1','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11914,2169,'2020-01-27 17:00:02','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11916,2180,'2020-01-27 17:00:02','5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11918,2182,'2020-01-27 17:00:02','751','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11974,2036,'2020-01-27 19:00:02','-10','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(6410,2047,'2019-12-28 22:00:01','1',''),(11975,2063,'2020-01-27 19:00:02','-10','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11977,2117,'2020-01-27 19:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12029,1611,'2020-01-27 21:00:00','94','/objects/?object=ClockChime&op=m&m=onNewHour'),(12030,1613,'2020-01-27 21:00:00','765','/objects/?object=ClockChime&op=m&m=onNewHour'),(12036,2021,'2020-01-27 21:00:01','94','/objects/?object=ClockChime&op=m&m=onNewHour'),(12038,2023,'2020-01-27 21:00:01','765','/objects/?object=ClockChime&op=m&m=onNewHour'),(12626,2383,'2020-01-28 19:00:02','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12558,1605,'2020-01-28 19:00:00','-10','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12596,1611,'2020-01-28 17:00:00','90','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12564,2009,'2020-01-28 19:00:01','-10','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12470,1605,'2020-01-28 13:00:01','-11','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(6461,2047,'2019-12-29 00:00:02','2',''),(12631,2169,'2020-01-28 19:00:02','-1','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12455,2020,'2020-01-28 11:00:00','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6487,2047,'2019-12-29 01:00:10','9',''),(12605,2048,'2020-01-28 17:00:01','90','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6491,2074,'2019-12-29 01:00:10','6',''),(12461,2102,'2020-01-28 11:00:01','92','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12464,2128,'2020-01-28 11:00:01','2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12473,2180,'2020-01-28 11:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6518,2047,'2019-12-29 03:00:01','9',''),(6519,2048,'2019-12-29 22:00:04','92',''),(6522,2074,'2019-12-29 03:00:02','6',''),(12459,2077,'2020-01-28 11:00:00','756','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6530,2128,'2019-12-29 22:00:04','7',''),(6543,2047,'2019-12-29 04:00:01','8',''),(12456,2050,'2020-01-28 11:00:00','759','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6546,2074,'2019-12-29 04:00:01','5',''),(12460,2090,'2020-01-28 11:00:01','-3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6566,2047,'2019-12-29 22:00:04','8',''),(6567,2050,'2019-12-29 22:00:04','755',''),(12457,2063,'2020-01-28 11:00:00','-6','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6569,2074,'2019-12-29 10:00:01','5',''),(12458,2075,'2020-01-28 11:00:00','92','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12462,2104,'2020-01-28 11:00:01','752','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12463,2117,'2020-01-28 11:00:01','-9','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12465,2382,'2020-01-28 11:00:01','93','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12466,2130,'2020-01-28 11:00:01','752','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12467,2143,'2020-01-28 11:00:01','-1','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12468,2154,'2020-01-28 11:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12469,2383,'2020-01-28 11:00:01','98','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12471,2156,'2020-01-28 11:00:01','748','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12453,1605,'2020-01-28 11:00:00','-11','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12454,1611,'2020-01-28 11:00:00','82','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12555,1605,'2020-01-28 15:00:01','-10','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12517,2009,'2020-01-28 13:00:01','-11','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(6599,2074,'2019-12-29 12:00:09','6',''),(6600,2075,'2019-12-29 12:00:09','97',''),(6603,2104,'2019-12-29 12:00:09','756',''),(6605,2382,'2019-12-29 12:00:09','90',''),(6606,2130,'2019-12-29 12:00:09','757',''),(6608,2154,'2019-12-29 12:00:10','6',''),(12622,2383,'2020-01-28 17:00:02','93','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6613,1605,'2019-12-29 22:00:01','-10',''),(6616,2009,'2019-12-29 22:00:03','-10',''),(12518,2036,'2020-01-28 13:00:01','-8','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12607,2063,'2020-01-28 17:00:01','-5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6621,2074,'2019-12-29 15:00:01','6',''),(6622,2075,'2019-12-29 15:00:01','97',''),(6626,2104,'2019-12-29 22:00:04','756',''),(6628,2382,'2019-12-29 15:00:01','90',''),(6629,2130,'2019-12-29 15:00:01','757',''),(12620,2143,'2020-01-28 17:00:02','-2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6631,2154,'2019-12-29 22:00:04','6',''),(6632,2383,'2019-12-29 22:00:04','95',''),(12556,1611,'2020-01-28 15:00:02','84','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12557,1613,'2020-01-28 15:00:02','762','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12562,2021,'2020-01-28 15:00:03','84','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12563,2023,'2020-01-28 15:00:03','762','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12595,1610,'2020-01-28 17:00:00','5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6646,1611,'2019-12-29 16:00:01','88',''),(6647,1613,'2019-12-29 16:00:01','774',''),(12599,2020,'2020-01-28 17:00:01','5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6649,2021,'2019-12-29 16:00:01','88',''),(6650,2023,'2019-12-29 16:00:01','774',''),(6651,2074,'2019-12-29 16:00:02','4',''),(6652,2075,'2019-12-29 16:00:02','98',''),(12610,2077,'2020-01-28 17:00:01','758','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12612,2090,'2020-01-28 17:00:01','-2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12614,2101,'2020-01-28 17:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12615,2102,'2020-01-28 17:00:01','91','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6657,2382,'2019-12-29 16:00:02','89',''),(6658,2130,'2019-12-29 16:00:02','753',''),(12623,2156,'2020-01-28 17:00:02','752','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12625,2169,'2020-01-28 17:00:02','-1','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12628,2180,'2020-01-28 17:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12629,2384,'2020-01-28 17:00:02','95','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12630,2182,'2020-01-28 17:00:02','746','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(6664,1610,'2019-12-29 18:00:03','3',''),(6665,1611,'2019-12-29 18:00:03','93',''),(6666,1613,'2019-12-29 18:00:03','773',''),(6667,2020,'2019-12-29 18:00:17','3',''),(6668,2021,'2019-12-29 18:00:17','93',''),(6669,2023,'2019-12-29 18:00:17','773',''),(12666,2036,'2020-01-28 19:00:01','-10','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(6671,2063,'2019-12-29 18:00:17','-0',''),(6672,2074,'2019-12-30 10:00:06','4',''),(6673,2075,'2019-12-29 22:00:04','98',''),(6674,2077,'2019-12-29 22:00:04','739',''),(6675,2090,'2019-12-29 22:00:04','-8',''),(6676,2101,'2019-12-29 22:00:04','3',''),(6677,2102,'2019-12-29 22:00:04','92',''),(12672,2117,'2020-01-28 19:00:01','-8','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(6679,2382,'2019-12-29 22:00:04','89',''),(6680,2130,'2019-12-29 22:00:04','753',''),(6681,2143,'2019-12-29 18:00:18','2',''),(6682,2156,'2019-12-30 03:00:02','749',''),(6683,2169,'2019-12-29 18:00:18','-1',''),(6684,2180,'2019-12-29 22:00:04','9',''),(6685,2384,'2019-12-29 22:00:04','87',''),(6686,2182,'2019-12-29 22:00:04','743',''),(6687,1610,'2019-12-29 22:00:02','3',''),(6688,1611,'2019-12-29 22:00:02','93',''),(6689,1613,'2019-12-29 19:00:01','773',''),(6690,2020,'2019-12-29 22:00:03','3',''),(6691,2021,'2019-12-29 22:00:03','93',''),(6692,2023,'2019-12-29 21:00:01','773',''),(6693,2036,'2019-12-29 22:00:03','-1',''),(6694,2063,'2019-12-29 22:00:04','-0',''),(6695,2117,'2019-12-30 10:00:06','1',''),(6696,2143,'2019-12-29 22:00:04','2',''),(6697,2169,'2019-12-29 22:00:04','-1',''),(6698,1613,'2019-12-29 21:00:01','772',''),(6699,1613,'2019-12-29 22:00:02','772',''),(6700,2023,'2019-12-29 22:00:03','772',''),(6701,1605,'2019-12-30 00:00:02','-9',''),(6702,1610,'2019-12-30 00:00:02','4',''),(6703,1611,'2019-12-30 00:00:02','92',''),(6704,1613,'2019-12-30 00:00:02','769',''),(6705,2009,'2019-12-30 00:00:03','1',''),(6706,2020,'2019-12-30 00:00:03','8',''),(6707,2021,'2019-12-30 00:00:03','92',''),(6708,2023,'2019-12-30 00:00:03','755',''),(6709,2036,'2019-12-30 00:00:03','-5',''),(6710,2047,'2019-12-30 00:00:03','4',''),(6711,2048,'2019-12-30 00:00:03','98',''),(6712,2050,'2019-12-30 00:00:03','739',''),(6713,2063,'2019-12-30 00:00:03','-6',''),(6714,2075,'2019-12-30 00:00:03','90',''),(6715,2077,'2019-12-30 00:00:03','756',''),(6716,2090,'2019-12-30 00:00:04','1',''),(6717,2101,'2019-12-30 00:00:04','6',''),(6718,2102,'2019-12-30 00:00:04','89',''),(6719,2104,'2019-12-30 00:00:04','750',''),(6720,2128,'2019-12-30 00:00:04','5',''),(6721,2382,'2019-12-30 00:00:04','96',''),(6722,2130,'2019-12-30 00:00:04','749',''),(6723,2143,'2019-12-30 00:00:04','-4',''),(6724,2154,'2019-12-30 00:00:04','5',''),(6725,2383,'2019-12-30 00:00:04','84',''),(6726,2169,'2019-12-30 00:00:04','-9',''),(6727,2180,'2019-12-30 00:00:04','4',''),(6728,2384,'2019-12-30 00:00:04','86',''),(6729,2182,'2019-12-30 00:00:04','765',''),(6730,1605,'2019-12-30 01:00:06','-9',''),(6731,1610,'2019-12-30 01:00:06','4',''),(6732,1611,'2019-12-30 01:00:06','92',''),(6733,1613,'2019-12-30 01:00:06','769',''),(6734,2009,'2019-12-30 03:00:02','1',''),(6735,2020,'2019-12-30 21:00:01','8',''),(6736,2021,'2019-12-30 18:00:01','92',''),(6737,2023,'2019-12-30 13:00:02','755',''),(6738,2036,'2019-12-30 03:00:02','-5',''),(6739,2047,'2019-12-30 10:00:06','4',''),(6740,2048,'2019-12-30 03:00:02','98',''),(6741,2050,'2019-12-30 03:00:02','739',''),(6742,2063,'2019-12-30 03:00:02','-6',''),(6743,2075,'2019-12-30 03:00:02','90',''),(6744,2077,'2019-12-30 10:00:06','756',''),(6745,2090,'2019-12-30 03:00:02','1',''),(6746,2101,'2019-12-30 03:00:02','6',''),(6747,2102,'2019-12-30 03:00:02','89',''),(6748,2104,'2019-12-30 03:00:02','750',''),(6749,2128,'2019-12-30 03:00:02','5',''),(6750,2382,'2019-12-30 03:00:02','96',''),(6751,2130,'2019-12-30 03:00:02','749',''),(6752,2143,'2019-12-30 03:00:02','-4',''),(6753,2154,'2019-12-30 10:00:06','5',''),(6754,2383,'2019-12-30 03:00:02','84',''),(6755,2169,'2019-12-30 03:00:02','-9',''),(6756,2180,'2019-12-30 03:00:03','4',''),(6757,2384,'2019-12-30 03:00:03','86',''),(6758,2182,'2019-12-30 03:00:03','765',''),(6759,1605,'2019-12-30 03:00:01','-7',''),(6760,1610,'2019-12-30 03:00:01','6',''),(6761,1611,'2019-12-30 03:00:01','89',''),(6762,1613,'2019-12-30 03:00:01','767',''),(6763,1605,'2019-12-30 04:00:01','-7',''),(6764,1610,'2019-12-30 04:00:01','6',''),(6765,1611,'2019-12-30 04:00:01','88',''),(6766,1613,'2019-12-30 04:00:01','767',''),(6767,2009,'2019-12-30 04:00:01','-6',''),(6768,2036,'2019-12-30 04:00:01','1',''),(6769,2048,'2019-12-30 04:00:01','94',''),(6770,2050,'2019-12-30 04:00:01','740',''),(6771,2063,'2019-12-30 04:00:01','-8',''),(6772,2075,'2019-12-30 04:00:01','88',''),(6773,2090,'2019-12-30 04:00:02','-0',''),(6774,2101,'2019-12-30 04:00:02','7',''),(6775,2102,'2019-12-30 04:00:02','93',''),(6776,2104,'2019-12-30 04:00:02','748',''),(6777,2128,'2019-12-30 04:00:02','6',''),(6778,2382,'2019-12-30 04:00:02','97',''),(6779,2130,'2019-12-30 04:00:02','747',''),(6780,2143,'2019-12-30 04:00:02','3',''),(6781,2383,'2019-12-30 04:00:02','96',''),(6782,2156,'2019-12-30 04:00:02','745',''),(6783,2169,'2019-12-30 04:00:02','-3',''),(6784,2180,'2019-12-30 04:00:02','5',''),(6785,2384,'2019-12-30 04:00:02','83',''),(6786,2182,'2019-12-30 04:00:02','761',''),(6787,1605,'2019-12-30 06:00:01','-6',''),(6788,1610,'2019-12-30 06:00:01','7',''),(6789,1611,'2019-12-30 07:00:01','88',''),(6790,1613,'2019-12-30 06:00:01','762',''),(6791,2009,'2019-12-30 07:00:02','-6',''),(6792,2036,'2019-12-30 16:00:01','1',''),(6793,2048,'2019-12-30 10:00:06','94',''),(6794,2050,'2019-12-30 15:00:01','740',''),(6795,2063,'2019-12-30 12:00:02','-8',''),(6796,2075,'2019-12-30 10:00:06','88',''),(6797,2090,'2019-12-30 10:00:06','-0',''),(6798,2101,'2019-12-30 10:00:06','7',''),(6799,2102,'2019-12-30 10:00:06','93',''),(6800,2104,'2019-12-30 15:00:02','748',''),(6801,2128,'2019-12-30 15:00:02','6',''),(6802,2382,'2019-12-30 10:00:06','97',''),(6803,2130,'2019-12-30 10:00:06','747',''),(6804,2143,'2019-12-30 12:00:02','3',''),(6805,2383,'2019-12-30 10:00:06','96',''),(6806,2156,'2019-12-30 15:00:02','745',''),(6807,2169,'2019-12-30 10:00:06','-3',''),(6808,2180,'2019-12-30 10:00:06','5',''),(6809,2384,'2019-12-30 10:00:06','83',''),(6810,2182,'2019-12-30 10:00:06','761',''),(6811,1605,'2019-12-30 07:00:01','-6',''),(6812,1610,'2019-12-30 07:00:01','7',''),(6813,1613,'2019-12-30 07:00:01','762',''),(6814,1605,'2019-12-30 09:00:01','-5',''),(6815,1610,'2019-12-30 09:00:01','8',''),(6816,1611,'2019-12-30 09:00:01','77',''),(6817,1613,'2019-12-30 09:00:01','758',''),(6818,2009,'2019-12-30 09:00:01','-5',''),(6819,1605,'2019-12-30 10:00:02','-5',''),(6820,1610,'2019-12-30 19:00:01','8',''),(6821,1611,'2019-12-30 10:00:02','77',''),(6822,1613,'2019-12-30 10:00:02','758',''),(6823,2009,'2019-12-30 10:00:05','-5',''),(6824,1605,'2019-12-30 12:00:01','-4',''),(6825,1611,'2019-12-30 12:00:01','92',''),(6826,1613,'2019-12-30 12:00:01','755',''),(6827,2009,'2019-12-30 12:00:01','-4',''),(6828,2047,'2019-12-30 12:00:01','3',''),(6829,2048,'2019-12-30 12:00:01','95',''),(6830,2074,'2019-12-30 12:00:02','3',''),(6831,2075,'2019-12-30 12:00:02','91',''),(6832,2077,'2019-12-30 12:00:02','755',''),(6833,2090,'2019-12-30 12:00:02','-1',''),(6834,2101,'2019-12-30 12:00:02','8',''),(6835,2102,'2019-12-30 12:00:02','95',''),(6836,2117,'2019-12-30 12:00:02','2',''),(6837,2382,'2019-12-30 12:00:02','96',''),(6838,2130,'2019-12-30 12:00:02','746',''),(6839,2154,'2019-12-30 12:00:02','6',''),(6840,2383,'2019-12-30 12:00:02','90',''),(6841,2169,'2019-12-30 12:00:02','0',''),(6842,2180,'2019-12-30 12:00:02','4',''),(6843,2384,'2019-12-30 12:00:02','93',''),(6844,2182,'2019-12-30 12:00:02','747',''),(6845,1605,'2019-12-30 13:00:00','-4',''),(6846,1611,'2019-12-30 16:00:01','92',''),(6847,1613,'2019-12-30 13:00:00','755',''),(6848,2009,'2019-12-30 13:00:02','-4',''),(6849,2047,'2019-12-30 15:00:01','3',''),(6850,2048,'2019-12-30 15:00:01','95',''),(6851,2063,'2019-12-30 13:00:02','-7',''),(6852,2074,'2019-12-30 22:00:01','3',''),(6853,2075,'2019-12-30 15:00:02','91',''),(6854,2077,'2019-12-30 22:00:01','755',''),(6855,2090,'2019-12-30 13:00:02','-0',''),(6856,2101,'2019-12-30 15:00:02','8',''),(6857,2102,'2019-12-31 03:00:02','95',''),(6858,2117,'2019-12-30 15:00:02','2',''),(6859,2382,'2019-12-30 15:00:02','96',''),(6860,2130,'2019-12-30 15:00:02','746',''),(6861,2143,'2019-12-30 13:00:03','2',''),(6862,2154,'2019-12-30 15:00:02','6',''),(6863,2383,'2019-12-30 22:00:02','90',''),(6864,2169,'2019-12-30 13:00:03','1',''),(6865,2180,'2019-12-31 15:00:02','4',''),(6866,2384,'2019-12-30 15:00:02','93',''),(6867,2182,'2019-12-30 15:00:02','747',''),(6868,1605,'2019-12-30 15:00:01','-3',''),(6869,1613,'2019-12-30 15:00:01','752',''),(6870,2009,'2019-12-30 15:00:01','-3',''),(6871,2023,'2019-12-30 15:00:01','752',''),(6872,2063,'2019-12-30 22:00:01','-7',''),(6873,2090,'2019-12-30 16:00:02','-0',''),(6874,2143,'2019-12-30 15:00:02','2',''),(6875,2169,'2019-12-30 15:00:02','1',''),(6876,1605,'2019-12-30 16:00:01','-3',''),(6877,1613,'2019-12-30 16:00:01','751',''),(6878,2009,'2019-12-30 16:00:01','-3',''),(6879,2023,'2019-12-30 16:00:01','751',''),(6880,2047,'2019-12-30 16:00:01','4',''),(6881,2048,'2019-12-30 16:00:01','97',''),(6882,2050,'2019-12-30 16:00:01','739',''),(6883,2075,'2019-12-30 16:00:01','90',''),(6884,2101,'2019-12-30 16:00:02','7',''),(6885,2104,'2019-12-30 16:00:02','749',''),(6886,2117,'2019-12-30 16:00:02','1',''),(6887,2128,'2019-12-30 16:00:02','4',''),(6888,2382,'2019-12-30 16:00:02','97',''),(6889,2130,'2019-12-30 16:00:02','752',''),(6890,2143,'2019-12-30 16:00:02','-0',''),(6891,2154,'2019-12-30 16:00:02','5',''),(6892,2156,'2019-12-30 16:00:02','747',''),(6893,2169,'2019-12-30 16:00:02','-1',''),(6894,2384,'2019-12-30 16:00:02','91',''),(6895,2182,'2019-12-30 16:00:02','752',''),(6896,1605,'2019-12-30 18:00:01','-2',''),(6897,1611,'2019-12-30 18:00:01','94',''),(6898,1613,'2019-12-30 18:00:01','747',''),(6899,2009,'2019-12-30 18:00:01','-2',''),(6900,2023,'2019-12-30 18:00:01','751',''),(6901,2036,'2019-12-30 18:00:01','-0',''),(6902,2047,'2019-12-30 22:00:01','4',''),(6903,2048,'2019-12-30 22:00:01','97',''),(6904,2050,'2019-12-30 22:00:01','739',''),(6905,2075,'2019-12-30 22:00:01','90',''),(6906,2090,'2019-12-30 18:00:01','1',''),(6907,2101,'2019-12-30 22:00:01','7',''),(6908,2104,'2019-12-30 22:00:01','749',''),(6909,2117,'2019-12-31 03:00:02','1',''),(6910,2128,'2019-12-31 03:00:02','4',''),(6911,2382,'2019-12-30 22:00:02','97',''),(6912,2130,'2019-12-30 22:00:02','752',''),(6913,2143,'2019-12-30 22:00:02','0',''),(6914,2154,'2019-12-31 03:00:02','5',''),(6915,2156,'2019-12-30 22:00:02','747',''),(6916,2169,'2019-12-30 18:00:02','-4',''),(6917,2384,'2019-12-30 22:00:02','91',''),(6918,2182,'2019-12-30 22:00:02','752',''),(6919,1605,'2019-12-30 19:00:01','-2',''),(6920,1611,'2019-12-30 19:00:01','94',''),(6921,1613,'2019-12-30 19:00:01','747',''),(6922,2009,'2019-12-30 21:00:01','-2',''),(6923,2021,'2019-12-30 19:00:02','94',''),(6924,2023,'2019-12-30 19:00:02','747',''),(6925,2036,'2019-12-30 22:00:01','-0',''),(6926,2090,'2019-12-31 03:00:02','1',''),(6927,2169,'2019-12-30 22:00:02','-4',''),(6928,1605,'2019-12-30 21:00:01','-0',''),(6929,1610,'2019-12-30 21:00:01','7',''),(6930,1611,'2019-12-30 21:00:01','95',''),(6931,1613,'2019-12-30 21:00:01','743',''),(6932,2021,'2019-12-30 21:00:01','94',''),(6933,2023,'2019-12-30 21:00:01','747',''),(6934,1605,'2019-12-30 22:00:01','-0',''),(6935,1610,'2019-12-30 22:00:01','7',''),(6936,1611,'2019-12-30 22:00:01','95',''),(6937,1613,'2019-12-30 22:00:01','743',''),(6938,2009,'2019-12-30 22:00:01','-0',''),(6939,2020,'2019-12-30 22:00:01','7',''),(6940,2021,'2019-12-30 22:00:01','95',''),(6941,2023,'2019-12-30 22:00:01','743',''),(6942,2009,'2019-12-31 00:00:13','-5',''),(6943,2020,'2019-12-31 00:00:13','4',''),(6944,2021,'2019-12-31 00:00:13','97',''),(6945,2023,'2019-12-31 00:00:13','739',''),(6946,2036,'2019-12-31 00:00:13','-5',''),(6947,2047,'2019-12-31 00:00:13','3',''),(6948,2048,'2019-12-31 00:00:13','91',''),(6949,2050,'2019-12-31 00:00:13','755',''),(6950,2063,'2019-12-31 00:00:13','1',''),(6951,2074,'2019-12-31 00:00:13','7',''),(6952,2075,'2019-12-31 00:00:13','96',''),(6953,2077,'2019-12-31 00:00:13','749',''),(6954,2101,'2019-12-31 00:00:14','5',''),(6955,2104,'2019-12-31 00:00:14','752',''),(6956,2382,'2019-12-31 00:00:14','92',''),(6957,2130,'2019-12-31 00:00:14','749',''),(6958,2143,'2019-12-31 00:00:14','-3',''),(6959,2383,'2019-12-31 00:00:14','89',''),(6960,2156,'2019-12-31 00:00:14','751',''),(6961,2169,'2019-12-31 00:00:14','-5',''),(6962,2384,'2019-12-31 00:00:14','83',''),(6963,2182,'2019-12-31 00:00:14','770',''),(6964,2009,'2019-12-31 03:00:01','-5',''),(6965,2020,'2019-12-31 13:00:01','4',''),(6966,2021,'2019-12-31 10:00:04','97',''),(6967,2023,'2019-12-31 10:00:04','739',''),(6968,2036,'2019-12-31 03:00:01','-5',''),(6969,2047,'2019-12-31 10:00:04','3',''),(6970,2048,'2019-12-31 03:00:01','91',''),(6971,2050,'2019-12-31 22:00:01','755',''),(6972,2063,'2019-12-31 03:00:01','1',''),(6973,2074,'2019-12-31 15:00:01','7',''),(6974,2075,'2019-12-31 03:00:02','96',''),(6975,2077,'2019-12-31 03:00:02','749',''),(6976,2101,'2019-12-31 10:00:04','5',''),(6977,2104,'2019-12-31 22:00:02','752',''),(6978,2382,'2019-12-31 03:00:02','92',''),(6979,2130,'2019-12-31 10:00:05','749',''),(6980,2143,'2019-12-31 03:00:02','-3',''),(6981,2383,'2019-12-31 03:00:02','89',''),(6982,2156,'2019-12-31 10:00:05','751',''),(6983,2169,'2019-12-31 03:00:02','-5',''),(6984,2384,'2019-12-31 03:00:02','83',''),(6985,2182,'2019-12-31 03:00:02','770',''),(6986,1605,'2019-12-31 03:00:01','2',''),(6987,1610,'2019-12-31 03:00:01','5',''),(6988,1611,'2019-12-31 03:00:01','98',''),(6989,1613,'2019-12-31 03:00:01','740',''),(6990,1605,'2019-12-31 07:00:01','2',''),(6991,1610,'2019-12-31 10:00:01','5',''),(6992,1611,'2019-12-31 04:00:01','99',''),(6993,1613,'2019-12-31 04:00:01','740',''),(6994,2009,'2019-12-31 04:00:01','2',''),(6995,2036,'2019-12-31 04:00:02','-8',''),(6996,2048,'2019-12-31 04:00:02','89',''),(6997,2063,'2019-12-31 04:00:02','-1',''),(6998,2075,'2019-12-31 04:00:02','97',''),(6999,2077,'2019-12-31 04:00:02','750',''),(7000,2090,'2019-12-31 04:00:02','2',''),(7001,2102,'2019-12-31 04:00:02','93',''),(7002,2117,'2019-12-31 04:00:02','0',''),(7003,2128,'2019-12-31 04:00:02','5',''),(7004,2382,'2019-12-31 04:00:02','90',''),(7005,2143,'2019-12-31 04:00:02','0',''),(7006,2154,'2019-12-31 04:00:02','4',''),(7007,2383,'2019-12-31 04:00:02','97',''),(7008,2169,'2019-12-31 04:00:02','-7',''),(7009,2384,'2019-12-31 04:00:02','89',''),(7010,2182,'2019-12-31 04:00:02','773',''),(7011,1611,'2019-12-31 06:00:01','96',''),(7012,1613,'2019-12-31 06:00:01','739',''),(7013,2009,'2019-12-31 07:00:01','2',''),(7014,2036,'2019-12-31 10:00:04','-8',''),(7015,2048,'2019-12-31 10:00:04','89',''),(7016,2063,'2019-12-31 12:00:03','-1',''),(7017,2075,'2019-12-31 10:00:04','97',''),(7018,2077,'2019-12-31 22:00:02','750',''),(7019,2090,'2019-12-31 16:00:02','2',''),(7020,2102,'2019-12-31 10:00:04','93',''),(7021,2117,'2019-12-31 10:00:04','0',''),(7022,2128,'2019-12-31 22:00:02','5',''),(7023,2382,'2019-12-31 15:00:01','90',''),(7024,2143,'2019-12-31 12:00:04','0',''),(7025,2154,'2019-12-31 10:00:05','4',''),(7026,2383,'2019-12-31 10:00:05','97',''),(7027,2169,'2019-12-31 10:00:05','-7',''),(7028,2384,'2019-12-31 10:00:05','89',''),(7029,2182,'2019-12-31 10:00:05','773',''),(7030,1611,'2019-12-31 07:00:01','96',''),(7031,1613,'2019-12-31 07:00:01','739',''),(7032,1605,'2019-12-31 09:00:01','1',''),(7033,1611,'2019-12-31 09:00:01','93',''),(7034,1613,'2019-12-31 09:00:01','740',''),(7035,2009,'2019-12-31 09:00:01','1',''),(7036,1605,'2019-12-31 16:00:01','1',''),(7037,1611,'2019-12-31 10:00:01','93',''),(7038,1613,'2019-12-31 16:00:01','740',''),(7039,2009,'2019-12-31 16:00:02','1',''),(7040,1610,'2019-12-31 12:00:02','4',''),(7041,1611,'2019-12-31 12:00:02','96',''),(7042,2021,'2019-12-31 12:00:03','96',''),(7043,2023,'2019-12-31 12:00:03','740',''),(7044,2036,'2019-12-31 12:00:03','-7',''),(7045,2047,'2019-12-31 12:00:03','4',''),(7046,2048,'2019-12-31 12:00:03','86',''),(7047,2075,'2019-12-31 12:00:03','94',''),(7048,2101,'2019-12-31 12:00:04','4',''),(7049,2102,'2019-12-31 12:00:04','92',''),(7050,2117,'2019-12-31 12:00:04','-1',''),(7051,2130,'2019-12-31 12:00:04','747',''),(7052,2154,'2019-12-31 12:00:04','3',''),(7053,2383,'2019-12-31 12:00:04','92',''),(7054,2156,'2019-12-31 12:00:04','757',''),(7055,2169,'2019-12-31 12:00:04','-8',''),(7056,2384,'2019-12-31 12:00:04','80',''),(7057,2182,'2019-12-31 12:00:04','776',''),(7058,1610,'2019-12-31 13:00:01','4',''),(7059,1611,'2019-12-31 13:00:01','96',''),(7060,2021,'2019-12-31 13:00:01','96',''),(7061,2023,'2019-12-31 16:00:02','740',''),(7062,2036,'2019-12-31 13:00:01','-6',''),(7063,2047,'2019-12-31 22:00:01','4',''),(7064,2048,'2019-12-31 15:00:01','86',''),(7065,2063,'2019-12-31 13:00:01','1',''),(7066,2075,'2019-12-31 15:00:01','94',''),(7067,2101,'2019-12-31 22:00:02','4',''),(7068,2102,'2019-12-31 15:00:01','92',''),(7069,2117,'2019-12-31 22:00:02','-1',''),(7070,2130,'2019-12-31 22:00:02','747',''),(7071,2143,'2019-12-31 13:00:02','-1',''),(7072,2154,'2019-12-31 22:00:02','3',''),(7073,2383,'2019-12-31 15:00:02','92',''),(7074,2156,'2019-12-31 15:00:02','757',''),(7075,2169,'2019-12-31 13:00:02','-6',''),(7076,2384,'2019-12-31 15:00:02','80',''),(7077,2182,'2019-12-31 15:00:02','776',''),(7078,1610,'2019-12-31 15:00:01','2',''),(7079,1611,'2019-12-31 15:00:01','98',''),(7080,2020,'2019-12-31 15:00:01','2',''),(7081,2021,'2019-12-31 15:00:01','98',''),(7082,2036,'2019-12-31 22:00:01','-6',''),(7083,2063,'2019-12-31 22:00:02','1',''),(7084,2143,'2019-12-31 15:00:01','-1',''),(7085,2169,'2019-12-31 15:00:02','-6',''),(7086,1610,'2019-12-31 19:00:01','2',''),(7087,1611,'2019-12-31 19:00:01','98',''),(7088,2020,'2019-12-31 19:00:01','2',''),(7089,2021,'2019-12-31 19:00:01','98',''),(7090,2048,'2019-12-31 16:00:02','88',''),(7091,2074,'2019-12-31 16:00:02','6',''),(7092,2075,'2019-12-31 16:00:02','97',''),(7093,2102,'2019-12-31 16:00:02','93',''),(7094,2382,'2019-12-31 16:00:02','88',''),(7095,2143,'2019-12-31 16:00:02','0',''),(7096,2383,'2019-12-31 16:00:03','98',''),(7097,2156,'2019-12-31 16:00:03','751',''),(7098,2169,'2019-12-31 16:00:03','-7',''),(7099,2180,'2019-12-31 16:00:03','1',''),(7100,2384,'2019-12-31 16:00:03','83',''),(7101,2182,'2019-12-31 16:00:03','777',''),(7102,1605,'2019-12-31 18:00:00','0',''),(7103,1613,'2019-12-31 18:00:00','741',''),(7104,2009,'2019-12-31 18:00:02','0',''),(7105,2023,'2019-12-31 18:00:02','741',''),(7106,2048,'2019-12-31 22:00:01','88',''),(7107,2074,'2019-12-31 22:00:02','6',''),(7108,2075,'2019-12-31 22:00:02','97',''),(7109,2090,'2019-12-31 18:00:02','1',''),(7110,2102,'2019-12-31 22:00:02','93',''),(7111,2382,'2019-12-31 22:00:02','88',''),(7112,2143,'2019-12-31 18:00:02','-1',''),(7113,2383,'2019-12-31 22:00:02','98',''),(7114,2156,'2019-12-31 22:00:02','751',''),(7115,2169,'2019-12-31 18:00:02','-9',''),(7116,2180,'2019-12-31 22:00:02','1',''),(7117,2384,'2019-12-31 22:00:02','83',''),(7118,2182,'2019-12-31 22:00:02','777',''),(7119,1605,'2019-12-31 19:00:01','0',''),(7120,1613,'2019-12-31 19:00:01','741',''),(7121,2009,'2019-12-31 19:00:01','0',''),(7122,2023,'2019-12-31 19:00:01','741',''),(7123,2090,'2019-12-31 22:00:02','1',''),(7124,2143,'2019-12-31 22:00:02','-1',''),(7125,2169,'2019-12-31 22:00:02','-9',''),(7126,1605,'2019-12-31 21:00:00','-1',''),(7127,1610,'2019-12-31 21:00:00','4',''),(7128,1611,'2019-12-31 21:00:00','95',''),(7129,1613,'2019-12-31 21:00:00','743',''),(7130,2009,'2019-12-31 21:00:01','-1',''),(7131,2020,'2019-12-31 21:00:01','4',''),(7132,2021,'2019-12-31 21:00:01','95',''),(7133,2023,'2019-12-31 21:00:01','743',''),(7134,1605,'2019-12-31 22:00:01','-1',''),(7135,1610,'2020-01-01 01:00:01','4',''),(7136,1611,'2019-12-31 22:00:01','95',''),(7137,1613,'2019-12-31 22:00:01','743',''),(7138,2009,'2019-12-31 22:00:01','-1',''),(7139,2020,'2019-12-31 22:00:01','4',''),(7140,2021,'2019-12-31 22:00:01','95',''),(7141,2023,'2019-12-31 22:00:01','743',''),(7142,1605,'2020-01-01 00:00:01','-4',''),(7143,1611,'2020-01-01 00:00:01','92',''),(7144,1613,'2020-01-01 00:00:01','746',''),(7145,2009,'2020-01-01 00:00:01','-6',''),(7146,2020,'2020-01-01 00:00:01','3',''),(7147,2021,'2020-01-01 00:00:01','90',''),(7148,2023,'2020-01-01 00:00:01','755',''),(7149,2036,'2020-01-01 00:00:01','1',''),(7150,2047,'2020-01-01 00:00:01','6',''),(7151,2048,'2020-01-01 00:00:01','97',''),(7152,2050,'2020-01-01 00:00:01','750',''),(7153,2063,'2020-01-01 00:00:01','-0',''),(7154,2074,'2020-01-01 00:00:01','5',''),(7155,2075,'2020-01-01 00:00:01','92',''),(7156,2077,'2020-01-01 00:00:01','752',''),(7157,2090,'2020-01-01 00:00:01','0',''),(7158,2101,'2020-01-01 00:00:02','6',''),(7159,2102,'2020-01-01 00:00:02','91',''),(7160,2104,'2020-01-01 00:00:02','748',''),(7161,2117,'2020-01-01 00:00:02','-7',''),(7162,2128,'2020-01-01 00:00:02','3',''),(7163,2382,'2020-01-01 00:00:02','98',''),(7164,2130,'2020-01-01 00:00:02','753',''),(7165,2143,'2020-01-01 00:00:02','-6',''),(7166,2154,'2020-01-01 00:00:02','2',''),(7167,2383,'2020-01-01 00:00:02','83',''),(7168,2156,'2020-01-01 00:00:02','776',''),(7169,2169,'2020-01-01 00:00:02','-4',''),(7170,2180,'2020-01-01 00:00:02','6',''),(7171,2384,'2020-01-01 00:00:02','81',''),(7172,2182,'2020-01-01 00:00:02','772',''),(7173,1605,'2020-01-01 01:00:01','-4',''),(7174,1611,'2020-01-01 01:00:01','92',''),(7175,1613,'2020-01-01 01:00:01','746',''),(7176,2009,'2020-01-01 03:00:01','-6',''),(7177,2020,'2020-01-01 22:00:01','3',''),(7178,2021,'2020-01-01 03:00:01','90',''),(7179,2023,'2020-01-01 03:00:01','755',''),(7180,2036,'2020-01-01 03:00:01','1',''),(7181,2047,'2020-01-01 03:00:01','6',''),(7182,2048,'2020-01-01 10:00:01','97',''),(7183,2050,'2020-01-01 22:00:01','750',''),(7184,2063,'2020-01-01 03:00:01','-0',''),(7185,2074,'2020-01-01 03:00:01','5',''),(7186,2075,'2020-01-01 03:00:01','92',''),(7187,2077,'2020-01-01 10:00:02','752',''),(7188,2090,'2020-01-01 10:00:02','0',''),(7189,2101,'2020-01-01 22:00:02','6',''),(7190,2102,'2020-01-01 03:00:01','91',''),(7191,2104,'2020-01-01 03:00:01','748',''),(7192,2117,'2020-01-01 03:00:01','-7',''),(7193,2128,'2020-01-01 15:00:01','3',''),(7194,2382,'2020-01-01 03:00:01','98',''),(7195,2130,'2020-01-01 10:00:02','753',''),(7196,2143,'2020-01-01 03:00:01','-6',''),(7197,2154,'2020-01-01 03:00:02','2',''),(7198,2383,'2020-01-01 03:00:02','83',''),(7199,2156,'2020-01-01 03:00:02','776',''),(7200,2169,'2020-01-01 03:00:02','-4',''),(7201,2180,'2020-01-01 03:00:02','6',''),(7202,2384,'2020-01-01 03:00:02','81',''),(7203,2182,'2020-01-01 03:00:02','772',''),(7204,1605,'2020-01-01 03:00:01','-6',''),(7205,1610,'2020-01-01 03:00:01','3',''),(7206,1611,'2020-01-01 03:00:01','94',''),(7207,1613,'2020-01-01 03:00:01','749',''),(7208,1605,'2020-01-01 04:00:01','-6',''),(7209,1610,'2020-01-01 04:00:01','4',''),(7210,1611,'2020-01-01 07:00:01','94',''),(7211,1613,'2020-01-01 04:00:01','749',''),(7212,2009,'2020-01-01 04:00:02','-7',''),(7213,2021,'2020-01-01 04:00:02','89',''),(7214,2023,'2020-01-01 04:00:02','754',''),(7215,2036,'2020-01-01 04:00:02','-2',''),(7216,2047,'2020-01-01 04:00:02','5',''),(7217,2063,'2020-01-01 04:00:02','1',''),(7218,2074,'2020-01-01 04:00:02','6',''),(7219,2075,'2020-01-01 04:00:02','93',''),(7220,2102,'2020-01-01 04:00:02','97',''),(7221,2104,'2020-01-01 04:00:02','747',''),(7222,2117,'2020-01-01 04:00:02','0',''),(7223,2382,'2020-01-01 04:00:02','90',''),(7224,2143,'2020-01-01 04:00:02','-7',''),(7225,2154,'2020-01-01 04:00:02','0',''),(7226,2383,'2020-01-01 04:00:02','87',''),(7227,2156,'2020-01-01 04:00:02','770',''),(7228,2169,'2020-01-01 04:00:02','-6',''),(7229,2180,'2020-01-01 04:00:02','5',''),(7230,2384,'2020-01-01 04:00:02','89',''),(7231,2182,'2020-01-01 04:00:03','764',''),(7232,1605,'2020-01-01 06:00:00','-7',''),(7233,1610,'2020-01-01 07:00:01','4',''),(7234,1613,'2020-01-01 06:00:01','751',''),(7235,2009,'2020-01-01 07:00:01','-7',''),(7236,2021,'2020-01-01 13:00:08','89',''),(7237,2023,'2020-01-01 13:00:08','754',''),(7238,2036,'2020-01-01 12:00:01','-2',''),(7239,2047,'2020-01-01 22:00:01','5',''),(7240,2063,'2020-01-01 12:00:01','1',''),(7241,2074,'2020-01-02 00:00:01','6',''),(7242,2075,'2020-01-01 10:00:02','93',''),(7243,2102,'2020-01-01 10:00:02','97',''),(7244,2104,'2020-01-01 10:00:02','747',''),(7245,2117,'2020-01-01 15:00:01','0',''),(7246,2382,'2020-01-01 10:00:02','90',''),(7247,2143,'2020-01-01 15:00:02','-7',''),(7248,2154,'2020-01-01 10:00:02','0',''),(7249,2383,'2020-01-01 10:00:02','87',''),(7250,2156,'2020-01-01 10:00:02','770',''),(7251,2169,'2020-01-01 10:00:02','-6',''),(7252,2180,'2020-01-01 10:00:02','5',''),(7253,2384,'2020-01-01 10:00:02','89',''),(7254,2182,'2020-01-01 10:00:02','764',''),(7255,1605,'2020-01-01 07:00:01','-7',''),(7256,1613,'2020-01-01 07:00:01','751',''),(7257,1605,'2020-01-01 09:00:01','-8',''),(7258,1610,'2020-01-01 09:00:01','3',''),(7259,1611,'2020-01-01 09:00:01','91',''),(7260,1613,'2020-01-01 09:00:01','753',''),(7261,2009,'2020-01-01 09:00:06','-8',''),(7262,1605,'2020-01-01 10:00:01','-8',''),(7263,1610,'2020-01-02 04:00:01','3',''),(7264,1611,'2020-01-01 10:00:01','91',''),(7265,1613,'2020-01-01 10:00:01','753',''),(7266,2009,'2020-01-01 10:00:01','-8',''),(7267,1605,'2020-01-01 12:00:01','-7',''),(7268,1611,'2020-01-01 12:00:01','89',''),(7269,1613,'2020-01-01 12:00:01','754',''),(7270,2009,'2020-01-01 12:00:01','-7',''),(7271,2048,'2020-01-01 12:00:01','98',''),(7272,2075,'2020-01-01 12:00:01','91',''),(7273,2077,'2020-01-01 12:00:01','753',''),(7274,2090,'2020-01-01 12:00:01','-1',''),(7275,2102,'2020-01-01 12:00:01','92',''),(7276,2104,'2020-01-01 12:00:01','749',''),(7277,2382,'2020-01-01 12:00:02','92',''),(7278,2130,'2020-01-01 12:00:02','754',''),(7279,2154,'2020-01-01 12:00:02','1',''),(7280,2383,'2020-01-01 12:00:02','91',''),(7281,2156,'2020-01-01 12:00:02','772',''),(7282,2169,'2020-01-01 12:00:02','-4',''),(7283,2180,'2020-01-01 12:00:02','4',''),(7284,2384,'2020-01-01 12:00:02','90',''),(7285,2182,'2020-01-01 12:00:02','770',''),(7286,1605,'2020-01-01 19:00:02','-7',''),(7287,1611,'2020-01-01 13:00:01','89',''),(7288,1613,'2020-01-01 13:00:01','754',''),(7289,2009,'2020-01-01 19:00:03','-7',''),(7290,2036,'2020-01-01 13:00:08','1',''),(7291,2048,'2020-01-01 15:00:01','98',''),(7292,2063,'2020-01-01 13:00:08','2',''),(7293,2075,'2020-01-01 15:00:01','91',''),(7294,2077,'2020-01-02 00:00:01','753',''),(7295,2090,'2020-01-01 13:00:08','0',''),(7296,2102,'2020-01-01 15:00:01','92',''),(7297,2104,'2020-01-01 15:00:01','749',''),(7298,2382,'2020-01-01 15:00:01','92',''),(7299,2130,'2020-01-01 15:00:02','754',''),(7300,2154,'2020-01-01 15:00:02','1',''),(7301,2383,'2020-01-01 15:00:02','91',''),(7302,2156,'2020-01-01 15:00:02','772',''),(7303,2169,'2020-01-01 15:00:02','-4',''),(7304,2180,'2020-01-02 03:00:01','4',''),(7305,2384,'2020-01-02 00:00:02','90',''),(7306,2182,'2020-01-01 15:00:02','770',''),(7307,1611,'2020-01-01 15:00:01','91',''),(7308,1613,'2020-01-01 15:00:01','755',''),(7309,2021,'2020-01-01 15:00:01','91',''),(7310,2023,'2020-01-01 15:00:01','755',''),(7311,2036,'2020-01-01 15:00:01','1',''),(7312,2063,'2020-01-01 15:00:01','2',''),(7313,2090,'2020-01-02 00:00:01','0',''),(7314,1611,'2020-01-01 16:00:01','91',''),(7315,1613,'2020-01-01 16:00:01','755',''),(7316,2021,'2020-01-01 16:00:01','91',''),(7317,2023,'2020-01-01 16:00:01','755',''),(7318,2036,'2020-01-01 16:00:01','-0',''),(7319,2048,'2020-01-01 16:00:01','97',''),(7320,2063,'2020-01-01 16:00:01','1',''),(7321,2075,'2020-01-01 16:00:01','94',''),(7322,2102,'2020-01-01 16:00:02','95',''),(7323,2104,'2020-01-01 16:00:02','747',''),(7324,2117,'2020-01-01 16:00:02','-1',''),(7325,2128,'2020-01-01 16:00:02','2',''),(7326,2382,'2020-01-01 16:00:02','95',''),(7327,2130,'2020-01-01 16:00:02','752',''),(7328,2143,'2020-01-01 16:00:02','-8',''),(7329,2154,'2020-01-01 16:00:02','2',''),(7330,2383,'2020-01-01 16:00:02','92',''),(7331,2156,'2020-01-01 16:00:02','768',''),(7332,2169,'2020-01-01 16:00:02','-6',''),(7333,2182,'2020-01-01 16:00:02','766',''),(7334,1611,'2020-01-01 18:00:00','94',''),(7335,1613,'2020-01-01 18:00:00','756',''),(7336,2021,'2020-01-01 18:00:01','94',''),(7337,2023,'2020-01-01 18:00:01','756',''),(7338,2036,'2020-01-01 18:00:01','2',''),(7339,2048,'2020-01-01 22:00:01','97',''),(7340,2063,'2020-01-01 18:00:01','-1',''),(7341,2075,'2020-01-01 22:00:02','94',''),(7342,2102,'2020-01-01 22:00:02','95',''),(7343,2104,'2020-01-02 00:00:01','747',''),(7344,2117,'2020-01-01 22:00:02','-1',''),(7345,2128,'2020-01-01 22:00:02','2',''),(7346,2382,'2020-01-01 22:00:02','95',''),(7347,2130,'2020-01-02 00:00:01','752',''),(7348,2143,'2020-01-01 18:00:02','-10',''),(7349,2154,'2020-01-01 22:00:02','2',''),(7350,2383,'2020-01-01 22:00:02','92',''),(7351,2156,'2020-01-01 22:00:02','768',''),(7352,2169,'2020-01-01 18:00:02','-7',''),(7353,2182,'2020-01-01 22:00:02','766',''),(7354,1611,'2020-01-01 22:00:01','94',''),(7355,1613,'2020-01-02 01:00:00','756',''),(7356,2021,'2020-01-01 22:00:01','94',''),(7357,2023,'2020-01-02 00:00:01','756',''),(7358,2036,'2020-01-01 22:00:01','2',''),(7359,2063,'2020-01-02 00:00:01','-1',''),(7360,2143,'2020-01-01 22:00:02','-10',''),(7361,2169,'2020-01-01 22:00:02','-7',''),(7362,1605,'2020-01-01 21:00:01','-5',''),(7363,2009,'2020-01-01 21:00:01','-5',''),(7364,1605,'2020-01-01 22:00:01','-5',''),(7365,2009,'2020-01-01 22:00:01','-5',''),(7366,1605,'2020-01-02 00:00:00','-7',''),(7367,1611,'2020-01-02 00:00:00','96',''),(7368,2009,'2020-01-02 00:00:01','-7',''),(7369,2020,'2020-01-02 00:00:01','2',''),(7370,2021,'2020-01-02 00:00:01','96',''),(7371,2036,'2020-01-02 00:00:01','1',''),(7372,2047,'2020-01-02 00:00:01','6',''),(7373,2048,'2020-01-02 00:00:01','94',''),(7374,2050,'2020-01-02 00:00:01','751',''),(7375,2075,'2020-01-02 00:00:01','92',''),(7376,2101,'2020-01-02 00:00:01','4',''),(7377,2102,'2020-01-02 00:00:01','97',''),(7378,2117,'2020-01-02 00:00:01','-4',''),(7379,2128,'2020-01-02 00:00:01','3',''),(7380,2382,'2020-01-02 00:00:01','90',''),(7381,2143,'2020-01-02 00:00:01','-8',''),(7382,2154,'2020-01-02 00:00:02','1',''),(7383,2383,'2020-01-02 00:00:02','88',''),(7384,2156,'2020-01-02 00:00:02','770',''),(7385,2169,'2020-01-02 00:00:02','-9',''),(7386,2182,'2020-01-02 00:00:02','768',''),(7387,1605,'2020-01-02 01:00:00','-7',''),(7388,1611,'2020-01-02 03:00:00','96',''),(7389,2009,'2020-01-02 01:00:01','1',''),(7390,2020,'2020-01-02 01:00:01','6',''),(7391,2021,'2020-01-02 01:00:01','94',''),(7392,2023,'2020-01-02 01:00:01','751',''),(7393,2036,'2020-01-02 01:00:01','-1',''),(7394,2047,'2020-01-02 22:00:02','6',''),(7395,2048,'2020-01-02 01:00:01','92',''),(7396,2050,'2020-01-02 01:00:01','753',''),(7397,2063,'2020-01-02 01:00:01','-0',''),(7398,2074,'2020-01-02 01:00:01','4',''),(7399,2075,'2020-01-02 01:00:01','97',''),(7400,2077,'2020-01-02 01:00:01','747',''),(7401,2090,'2020-01-02 01:00:01','-4',''),(7402,2101,'2020-01-02 01:00:01','3',''),(7403,2102,'2020-01-02 01:00:01','90',''),(7404,2104,'2020-01-02 01:00:01','752',''),(7405,2117,'2020-01-02 01:00:01','-8',''),(7406,2128,'2020-01-02 01:00:01','1',''),(7407,2382,'2020-01-02 01:00:01','88',''),(7408,2130,'2020-01-02 01:00:01','770',''),(7409,2143,'2020-01-02 01:00:01','-9',''),(7410,2154,'2020-01-02 01:00:01','4',''),(7411,2383,'2020-01-02 01:00:01','90',''),(7412,2156,'2020-01-02 01:00:01','768',''),(7413,2169,'2020-01-02 01:00:02','-4',''),(7414,2384,'2020-01-02 01:00:02','94',''),(7415,2182,'2020-01-02 01:00:02','767',''),(7416,1605,'2020-01-02 03:00:00','-6',''),(7417,1613,'2020-01-02 03:00:00','755',''),(7418,2009,'2020-01-02 03:00:00','1',''),(7419,2020,'2020-01-02 03:00:00','6',''),(7420,2021,'2020-01-02 03:00:00','94',''),(7421,2023,'2020-01-02 10:00:01','751',''),(7422,2036,'2020-01-02 03:00:00','-1',''),(7423,2048,'2020-01-02 03:00:01','92',''),(7424,2050,'2020-01-02 03:00:01','753',''),(7425,2063,'2020-01-02 03:00:01','-0',''),(7426,2074,'2020-01-02 03:00:01','4',''),(7427,2075,'2020-01-02 03:00:01','97',''),(7428,2077,'2020-01-02 03:00:01','747',''),(7429,2090,'2020-01-02 03:00:01','-4',''),(7430,2101,'2020-01-02 03:00:01','3',''),(7431,2102,'2020-01-02 03:00:01','90',''),(7432,2104,'2020-01-02 10:00:02','752',''),(7433,2117,'2020-01-02 03:00:01','-8',''),(7434,2128,'2020-01-02 03:00:01','1',''),(7435,2382,'2020-01-02 10:00:02','88',''),(7436,2130,'2020-01-02 10:00:02','770',''),(7437,2143,'2020-01-02 03:00:01','-9',''),(7438,2154,'2020-01-02 22:00:03','4',''),(7439,2383,'2020-01-02 03:00:01','90',''),(7440,2156,'2020-01-02 03:00:01','768',''),(7441,2169,'2020-01-02 03:00:01','-4',''),(7442,2384,'2020-01-02 10:00:02','94',''),(7443,2182,'2020-01-02 10:00:02','767',''),(7444,1605,'2020-01-02 04:00:01','-7',''),(7445,1611,'2020-01-02 04:00:01','95',''),(7446,1613,'2020-01-02 04:00:01','755',''),(7447,2009,'2020-01-02 04:00:01','-3',''),(7448,2020,'2020-01-02 04:00:01','5',''),(7449,2021,'2020-01-02 04:00:01','96',''),(7450,2036,'2020-01-02 04:00:01','1',''),(7451,2048,'2020-01-02 04:00:01','91',''),(7452,2050,'2020-01-02 04:00:01','752',''),(7453,2063,'2020-01-02 04:00:01','-1',''),(7454,2074,'2020-01-02 04:00:01','5',''),(7455,2075,'2020-01-02 04:00:01','96',''),(7456,2077,'2020-01-02 04:00:01','746',''),(7457,2090,'2020-01-02 04:00:01','-3',''),(7458,2101,'2020-01-02 04:00:01','4',''),(7459,2102,'2020-01-02 04:00:01','88',''),(7460,2117,'2020-01-02 04:00:01','-7',''),(7461,2128,'2020-01-02 04:00:01','2',''),(7462,2143,'2020-01-02 04:00:02','-7',''),(7463,2383,'2020-01-02 04:00:02','91',''),(7464,2156,'2020-01-02 04:00:02','765',''),(7465,2169,'2020-01-02 04:00:02','-6',''),(7466,2180,'2020-01-02 04:00:02','3',''),(7467,1605,'2020-01-02 06:00:01','-3',''),(7468,1610,'2020-01-02 06:00:01','5',''),(7469,1611,'2020-01-02 06:00:01','92',''),(7470,1613,'2020-01-02 06:00:01','752',''),(7471,2009,'2020-01-02 07:00:01','-3',''),(7472,2020,'2020-01-02 15:00:01','5',''),(7473,2021,'2020-01-02 15:00:01','96',''),(7474,2036,'2020-01-02 12:00:01','1',''),(7475,2048,'2020-01-02 10:00:01','91',''),(7476,2050,'2020-01-02 22:00:02','752',''),(7477,2063,'2020-01-02 10:00:01','-1',''),(7478,2074,'2020-01-02 10:00:01','5',''),(7479,2075,'2020-01-02 22:00:02','96',''),(7480,2077,'2020-01-02 10:00:01','746',''),(7481,2090,'2020-01-02 10:00:02','-3',''),(7482,2101,'2020-01-02 22:00:02','4',''),(7483,2102,'2020-01-02 10:00:02','88',''),(7484,2117,'2020-01-02 10:00:02','-7',''),(7485,2128,'2020-01-02 22:00:02','2',''),(7486,2143,'2020-01-02 10:00:02','-7',''),(7487,2383,'2020-01-02 15:00:02','91',''),(7488,2156,'2020-01-02 10:00:02','765',''),(7489,2169,'2020-01-02 10:00:02','-6',''),(7490,2180,'2020-01-02 10:00:02','3',''),(7491,1605,'2020-01-02 07:00:01','-3',''),(7492,1610,'2020-01-02 07:00:01','5',''),(7493,1611,'2020-01-02 07:00:01','92',''),(7494,1613,'2020-01-02 07:00:01','752',''),(7495,1605,'2020-01-02 09:00:01','-2',''),(7496,1610,'2020-01-02 09:00:01','6',''),(7497,1611,'2020-01-02 09:00:01','95',''),(7498,1613,'2020-01-02 09:00:01','751',''),(7499,2009,'2020-01-02 09:00:01','-2',''),(7500,1605,'2020-01-02 10:00:01','-2',''),(7501,1610,'2020-01-02 10:00:01','6',''),(7502,1611,'2020-01-02 10:00:01','95',''),(7503,1613,'2020-01-02 10:00:01','751',''),(7504,2009,'2020-01-02 10:00:01','-2',''),(7505,1605,'2020-01-02 12:00:01','-0',''),(7506,1610,'2020-01-02 12:00:01','5',''),(7507,1611,'2020-01-02 12:00:01','96',''),(7508,1613,'2020-01-02 12:00:01','750',''),(7509,2009,'2020-01-02 12:00:01','-0',''),(7510,2023,'2020-01-02 12:00:01','750',''),(7511,2048,'2020-01-02 12:00:01','92',''),(7512,2063,'2020-01-02 12:00:01','-0',''),(7513,2074,'2020-01-02 12:00:02','7',''),(7514,2077,'2020-01-02 12:00:02','745',''),(7515,2090,'2020-01-02 12:00:02','-1',''),(7516,2102,'2020-01-02 12:00:02','92',''),(7517,2104,'2020-01-02 12:00:02','751',''),(7518,2117,'2020-01-02 12:00:02','-5',''),(7519,2382,'2020-01-02 12:00:02','85',''),(7520,2130,'2020-01-02 12:00:02','768',''),(7521,2143,'2020-01-02 12:00:02','-8',''),(7522,2156,'2020-01-02 12:00:02','769',''),(7523,2169,'2020-01-02 12:00:02','-7',''),(7524,2180,'2020-01-02 12:00:02','5',''),(7525,2384,'2020-01-02 12:00:02','93',''),(7526,2182,'2020-01-02 12:00:02','768',''),(7527,1605,'2020-01-02 13:00:01','-0',''),(7528,1610,'2020-01-02 13:00:01','5',''),(7529,1611,'2020-01-02 13:00:01','96',''),(7530,1613,'2020-01-02 15:00:01','750',''),(7531,2009,'2020-01-02 15:00:01','-0',''),(7532,2023,'2020-01-02 15:00:01','750',''),(7533,2036,'2020-01-02 13:00:01','2',''),(7534,2048,'2020-01-02 15:00:01','92',''),(7535,2063,'2020-01-02 16:00:01','0',''),(7536,2074,'2020-01-02 15:00:01','7',''),(7537,2077,'2020-01-02 15:00:01','745',''),(7538,2090,'2020-01-02 16:00:01','-1',''),(7539,2102,'2020-01-02 15:00:02','92',''),(7540,2104,'2020-01-02 15:00:02','751',''),(7541,2117,'2020-01-02 13:00:02','-6',''),(7542,2382,'2020-01-02 15:00:02','85',''),(7543,2130,'2020-01-02 22:00:02','768',''),(7544,2143,'2020-01-02 13:00:02','-6',''),(7545,2156,'2020-01-02 22:00:03','769',''),(7546,2169,'2020-01-02 13:00:02','-5',''),(7547,2180,'2020-01-04 03:00:02','5',''),(7548,2384,'2020-01-02 15:00:02','93',''),(7549,2182,'2020-01-02 22:00:03','768',''),(7550,1605,'2020-01-02 15:00:01','1',''),(7551,1610,'2020-01-02 15:00:01','4',''),(7552,1611,'2020-01-02 15:00:01','98',''),(7553,2036,'2020-01-02 15:00:01','2',''),(7554,2117,'2020-01-02 15:00:02','-6',''),(7555,2143,'2020-01-02 15:00:02','-6',''),(7556,2169,'2020-01-02 15:00:02','-5',''),(7557,1605,'2020-01-02 16:00:01','1',''),(7558,1610,'2020-01-03 01:00:01','4',''),(7559,1611,'2020-01-02 16:00:01','97',''),(7560,1613,'2020-01-02 16:00:01','751',''),(7561,2009,'2020-01-02 16:00:01','1',''),(7562,2020,'2020-01-02 16:00:01','4',''),(7563,2021,'2020-01-02 16:00:01','97',''),(7564,2023,'2020-01-02 16:00:01','751',''),(7565,2036,'2020-01-02 16:00:01','1',''),(7566,2048,'2020-01-02 16:00:01','94',''),(7567,2074,'2020-01-02 16:00:01','6',''),(7568,2077,'2020-01-02 16:00:01','746',''),(7569,2102,'2020-01-02 16:00:02','86',''),(7570,2104,'2020-01-02 16:00:02','750',''),(7571,2117,'2020-01-02 16:00:02','-7',''),(7572,2382,'2020-01-02 16:00:02','87',''),(7573,2143,'2020-01-02 16:00:02','-7',''),(7574,2383,'2020-01-02 16:00:02','86',''),(7575,2169,'2020-01-02 16:00:02','-7',''),(7576,2384,'2020-01-02 16:00:02','91',''),(7577,1605,'2020-01-02 18:00:01','2',''),(7578,1611,'2020-01-02 19:00:00','97',''),(7579,1613,'2020-01-02 18:00:01','752',''),(7580,2009,'2020-01-02 18:00:01','2',''),(7581,2020,'2020-01-02 22:00:02','4',''),(7582,2021,'2020-01-02 19:00:01','97',''),(7583,2023,'2020-01-02 18:00:01','752',''),(7584,2036,'2020-01-02 22:00:02','1',''),(7585,2048,'2020-01-02 22:00:02','94',''),(7586,2063,'2020-01-02 18:00:01','1',''),(7587,2074,'2020-01-02 22:00:02','6',''),(7588,2077,'2020-01-02 22:00:02','746',''),(7589,2090,'2020-01-02 18:00:02','-3',''),(7590,2102,'2020-01-02 22:00:02','86',''),(7591,2104,'2020-01-02 22:00:02','750',''),(7592,2117,'2020-01-02 18:00:02','-9',''),(7593,2382,'2020-01-02 22:00:02','87',''),(7594,2143,'2020-01-02 18:00:02','-8',''),(7595,2383,'2020-01-02 22:00:03','86',''),(7596,2169,'2020-01-02 18:00:02','-6',''),(7597,2384,'2020-01-02 22:00:03','91',''),(7598,1605,'2020-01-02 19:00:00','2',''),(7599,1613,'2020-01-02 19:00:00','752',''),(7600,2009,'2020-01-02 19:00:01','2',''),(7601,2023,'2020-01-02 19:00:01','752',''),(7602,2063,'2020-01-02 22:00:02','1',''),(7603,2090,'2020-01-02 22:00:02','-3',''),(7604,2117,'2020-01-02 22:00:02','-9',''),(7605,2143,'2020-01-02 22:00:02','-8',''),(7606,2169,'2020-01-02 22:00:03','-6',''),(7607,1605,'2020-01-02 21:00:01','1',''),(7608,1611,'2020-01-02 21:00:01','94',''),(7609,1613,'2020-01-02 21:00:01','753',''),(7610,2009,'2020-01-02 21:00:01','1',''),(7611,2021,'2020-01-02 21:00:01','94',''),(7612,2023,'2020-01-02 21:00:01','753',''),(7613,1605,'2020-01-03 07:00:01','1',''),(7614,1611,'2020-01-02 22:00:00','94',''),(7615,1613,'2020-01-02 22:00:00','753',''),(7616,2009,'2020-01-02 22:00:02','1',''),(7617,2021,'2020-01-02 22:00:02','94',''),(7618,2023,'2020-01-02 22:00:02','753',''),(7619,1611,'2020-01-03 00:00:01','93',''),(7620,1613,'2020-01-03 00:00:01','754',''),(7621,2009,'2020-01-03 00:00:01','-0',''),(7622,2020,'2020-01-03 00:00:01','6',''),(7623,2021,'2020-01-03 00:00:01','93',''),(7624,2023,'2020-01-03 00:00:01','752',''),(7625,2036,'2020-01-03 00:00:01','-2',''),(7626,2047,'2020-01-03 00:00:01','7',''),(7627,2048,'2020-01-03 00:00:01','90',''),(7628,2050,'2020-01-03 00:00:01','745',''),(7629,2063,'2020-01-03 00:00:01','-8',''),(7630,2074,'2020-01-03 00:00:01','2',''),(7631,2075,'2020-01-03 00:00:01','94',''),(7632,2077,'2020-01-03 00:00:01','752',''),(7633,2090,'2020-01-03 00:00:01','-7',''),(7634,2101,'2020-01-03 00:00:01','3',''),(7635,2102,'2020-01-03 00:00:01','87',''),(7636,2104,'2020-01-03 00:00:01','767',''),(7637,2117,'2020-01-03 00:00:01','-8',''),(7638,2128,'2020-01-03 00:00:01','3',''),(7639,2382,'2020-01-03 00:00:01','89',''),(7640,2130,'2020-01-03 00:00:01','764',''),(7641,2143,'2020-01-03 00:00:02','1',''),(7642,2154,'2020-01-03 00:00:02','5',''),(7643,2383,'2020-01-03 00:00:02','95',''),(7644,2156,'2020-01-03 00:00:02','764',''),(7645,2169,'2020-01-03 00:00:02','-3',''),(7646,2384,'2020-01-03 00:00:02','96',''),(7647,2182,'2020-01-03 00:00:02','755',''),(7648,1611,'2020-01-03 01:00:01','93',''),(7649,1613,'2020-01-03 04:00:01','754',''),(7650,2009,'2020-01-03 03:00:01','-0',''),(7651,2020,'2020-01-03 15:00:07','6',''),(7652,2021,'2020-01-03 10:00:01','93',''),(7653,2023,'2020-01-03 03:00:01','752',''),(7654,2036,'2020-01-03 03:00:01','-2',''),(7655,2047,'2020-01-03 03:00:01','7',''),(7656,2048,'2020-01-03 03:00:01','90',''),(7657,2050,'2020-01-03 15:00:07','745',''),(7658,2063,'2020-01-03 03:00:02','-8',''),(7659,2074,'2020-01-03 03:00:02','2',''),(7660,2075,'2020-01-03 10:00:02','94',''),(7661,2077,'2020-01-03 22:00:02','752',''),(7662,2090,'2020-01-03 03:00:02','-7',''),(7663,2101,'2020-01-03 10:00:02','3',''),(7664,2102,'2020-01-03 03:00:02','87',''),(7665,2104,'2020-01-03 03:00:02','767',''),(7666,2117,'2020-01-03 03:00:02','-8',''),(7667,2128,'2020-01-03 03:00:02','3',''),(7668,2382,'2020-01-03 03:00:02','89',''),(7669,2130,'2020-01-03 03:00:02','764',''),(7670,2143,'2020-01-03 03:00:02','1',''),(7671,2154,'2020-01-03 03:00:02','5',''),(7672,2383,'2020-01-03 03:00:02','95',''),(7673,2156,'2020-01-03 03:00:02','764',''),(7674,2169,'2020-01-03 03:00:02','-3',''),(7675,2384,'2020-01-03 03:00:02','96',''),(7676,2182,'2020-01-03 03:00:02','755',''),(7677,1610,'2020-01-03 03:00:01','5',''),(7678,1611,'2020-01-03 03:00:01','94',''),(7679,1610,'2020-01-03 04:00:01','5',''),(7680,1611,'2020-01-03 04:00:01','95',''),(7681,2009,'2020-01-03 04:00:01','1',''),(7682,2023,'2020-01-03 04:00:01','751',''),(7683,2036,'2020-01-03 04:00:01','0',''),(7684,2047,'2020-01-03 04:00:01','6',''),(7685,2048,'2020-01-03 04:00:01','96',''),(7686,2063,'2020-01-03 04:00:01','-3',''),(7687,2074,'2020-01-03 04:00:01','3',''),(7688,2090,'2020-01-03 04:00:01','-9',''),(7689,2102,'2020-01-03 04:00:02','85',''),(7690,2104,'2020-01-03 04:00:02','766',''),(7691,2117,'2020-01-03 04:00:02','-7',''),(7692,2128,'2020-01-03 04:00:02','2',''),(7693,2382,'2020-01-03 04:00:02','91',''),(7694,2130,'2020-01-03 04:00:02','762',''),(7695,2143,'2020-01-03 04:00:02','-9',''),(7696,2154,'2020-01-03 04:00:02','4',''),(7697,2383,'2020-01-03 04:00:02','92',''),(7698,2156,'2020-01-03 04:00:02','765',''),(7699,2169,'2020-01-03 04:00:02','0',''),(7700,2384,'2020-01-03 04:00:02','93',''),(7701,2182,'2020-01-03 04:00:02','756',''),(7702,1610,'2020-01-03 06:00:01','7',''),(7703,1611,'2020-01-03 07:00:01','95',''),(7704,1613,'2020-01-03 06:00:01','752',''),(7705,2009,'2020-01-03 09:00:00','1',''),(7706,2023,'2020-01-03 15:00:07','751',''),(7707,2036,'2020-01-03 12:00:01','0',''),(7708,2047,'2020-01-03 22:00:02','6',''),(7709,2048,'2020-01-03 10:00:01','96',''),(7710,2063,'2020-01-03 12:00:01','-3',''),(7711,2074,'2020-01-03 10:00:02','3',''),(7712,2090,'2020-01-03 12:00:01','-9',''),(7713,2102,'2020-01-03 10:00:02','85',''),(7714,2104,'2020-01-03 10:00:02','766',''),(7715,2117,'2020-01-03 10:00:02','-7',''),(7716,2128,'2020-01-03 15:00:07','2',''),(7717,2382,'2020-01-03 10:00:02','91',''),(7718,2130,'2020-01-03 10:00:02','762',''),(7719,2143,'2020-01-03 10:00:02','-9',''),(7720,2154,'2020-01-03 15:00:08','4',''),(7721,2383,'2020-01-03 10:00:02','92',''),(7722,2156,'2020-01-03 10:00:02','765',''),(7723,2169,'2020-01-03 12:00:02','0',''),(7724,2384,'2020-01-03 10:00:02','93',''),(7725,2182,'2020-01-03 10:00:02','756',''),(7726,1610,'2020-01-03 07:00:01','7',''),(7727,1613,'2020-01-03 10:00:01','752',''),(7728,1605,'2020-01-03 09:00:00','2',''),(7729,1610,'2020-01-03 09:00:00','6',''),(7730,1611,'2020-01-03 09:00:00','93',''),(7731,1605,'2020-01-03 13:00:01','2',''),(7732,1610,'2020-01-03 15:00:02','6',''),(7733,1611,'2020-01-03 10:00:01','93',''),(7734,2009,'2020-01-03 10:00:01','2',''),(7735,1611,'2020-01-03 12:00:01','91',''),(7736,1613,'2020-01-03 12:00:01','751',''),(7737,2009,'2020-01-03 15:00:07','2',''),(7738,2021,'2020-01-03 12:00:01','91',''),(7739,2048,'2020-01-03 12:00:01','92',''),(7740,2074,'2020-01-03 12:00:01','4',''),(7741,2075,'2020-01-03 12:00:01','84',''),(7742,2101,'2020-01-03 12:00:02','4',''),(7743,2102,'2020-01-03 12:00:02','80',''),(7744,2104,'2020-01-03 12:00:02','764',''),(7745,2117,'2020-01-03 12:00:02','-8',''),(7746,2382,'2020-01-03 12:00:02','90',''),(7747,2130,'2020-01-03 12:00:02','761',''),(7748,2143,'2020-01-03 12:00:02','-10',''),(7749,2383,'2020-01-03 12:00:02','90',''),(7750,2156,'2020-01-03 12:00:02','761',''),(7751,2384,'2020-01-03 12:00:02','97',''),(7752,2182,'2020-01-03 12:00:02','744',''),(7753,1611,'2020-01-03 13:00:01','91',''),(7754,1613,'2020-01-03 13:00:01','751',''),(7755,2021,'2020-01-03 15:00:07','91',''),(7756,2036,'2020-01-03 13:00:01','1',''),(7757,2048,'2020-01-03 15:00:07','92',''),(7758,2063,'2020-01-03 13:00:02','-2',''),(7759,2074,'2020-01-03 22:00:02','4',''),(7760,2075,'2020-01-03 15:00:07','84',''),(7761,2090,'2020-01-03 13:00:02','-7',''),(7762,2101,'2020-01-03 22:00:02','4',''),(7763,2102,'2020-01-03 15:00:07','80',''),(7764,2104,'2020-01-03 22:00:02','764',''),(7765,2117,'2020-01-03 13:00:02','-7',''),(7766,2382,'2020-01-03 15:00:07','90',''),(7767,2130,'2020-01-03 15:00:07','761',''),(7768,2143,'2020-01-03 13:00:02','-8',''),(7769,2383,'2020-01-03 15:00:08','90',''),(7770,2156,'2020-01-03 15:00:08','761',''),(7771,2169,'2020-01-03 13:00:02','1',''),(7772,2384,'2020-01-03 15:00:08','97',''),(7773,2182,'2020-01-03 15:00:08','744',''),(7774,1605,'2020-01-03 15:00:01','1',''),(7775,1611,'2020-01-03 15:00:02','89',''),(7776,1613,'2020-01-03 15:00:02','750',''),(7777,2036,'2020-01-03 22:00:02','1',''),(7778,2063,'2020-01-03 16:00:02','-2',''),(7779,2090,'2020-01-03 16:00:02','-7',''),(7780,2117,'2020-01-03 16:00:02','-7',''),(7781,2143,'2020-01-03 15:00:07','-8',''),(7782,2169,'2020-01-03 16:00:02','1',''),(7783,1605,'2020-01-03 19:00:00','1',''),(7784,1610,'2020-01-03 16:00:01','5',''),(7785,1611,'2020-01-03 16:00:01','89',''),(7786,1613,'2020-01-03 19:00:00','750',''),(7787,2009,'2020-01-03 16:00:01','1',''),(7788,2020,'2020-01-03 16:00:01','5',''),(7789,2021,'2020-01-03 16:00:01','89',''),(7790,2023,'2020-01-03 16:00:01','750',''),(7791,2048,'2020-01-03 16:00:01','91',''),(7792,2050,'2020-01-03 16:00:01','746',''),(7793,2075,'2020-01-03 16:00:02','86',''),(7794,2102,'2020-01-03 16:00:02','82',''),(7795,2128,'2020-01-03 16:00:02','1',''),(7796,2382,'2020-01-03 16:00:02','94',''),(7797,2130,'2020-01-03 16:00:02','760',''),(7798,2143,'2020-01-03 16:00:02','-3',''),(7799,2154,'2020-01-03 16:00:02','5',''),(7800,2383,'2020-01-03 16:00:02','93',''),(7801,2156,'2020-01-03 16:00:02','757',''),(7802,2384,'2020-01-03 16:00:02','90',''),(7803,2182,'2020-01-03 16:00:02','740',''),(7804,1610,'2020-01-03 18:00:01','6',''),(7805,1611,'2020-01-03 18:00:01','86',''),(7806,2009,'2020-01-03 19:00:01','1',''),(7807,2020,'2020-01-03 18:00:01','6',''),(7808,2021,'2020-01-03 18:00:01','86',''),(7809,2023,'2020-01-03 19:00:01','750',''),(7810,2048,'2020-01-03 22:00:02','91',''),(7811,2050,'2020-01-03 22:00:02','746',''),(7812,2063,'2020-01-03 18:00:02','-3',''),(7813,2075,'2020-01-03 22:00:02','86',''),(7814,2090,'2020-01-03 18:00:02','-8',''),(7815,2102,'2020-01-03 22:00:02','82',''),(7816,2117,'2020-01-03 18:00:02','-8',''),(7817,2128,'2020-01-03 22:00:03','1',''),(7818,2382,'2020-01-03 22:00:03','94',''),(7819,2130,'2020-01-03 22:00:03','760',''),(7820,2143,'2020-01-03 18:00:02','-2',''),(7821,2154,'2020-01-04 03:00:02','5',''),(7822,2383,'2020-01-03 22:00:03','93',''),(7823,2156,'2020-01-03 22:00:03','757',''),(7824,2169,'2020-01-03 18:00:02','-1',''),(7825,2384,'2020-01-03 22:00:03','90',''),(7826,2182,'2020-01-03 22:00:03','740',''),(7827,1610,'2020-01-03 22:00:01','6',''),(7828,1611,'2020-01-03 19:00:00','86',''),(7829,2020,'2020-01-04 03:00:01','6',''),(7830,2021,'2020-01-03 19:00:01','86',''),(7831,2063,'2020-01-03 22:00:02','-3',''),(7832,2090,'2020-01-03 22:00:02','-8',''),(7833,2117,'2020-01-03 22:00:02','-8',''),(7834,2143,'2020-01-03 22:00:03','-2',''),(7835,2169,'2020-01-03 22:00:03','-1',''),(7836,1605,'2020-01-03 21:00:01','0',''),(7837,1611,'2020-01-03 21:00:01','87',''),(7838,1613,'2020-01-03 21:00:01','749',''),(7839,2009,'2020-01-03 21:00:02','0',''),(7840,2021,'2020-01-03 21:00:02','87',''),(7841,2023,'2020-01-03 21:00:02','749',''),(7842,1605,'2020-01-04 07:00:01','0',''),(7843,1611,'2020-01-03 22:00:01','87',''),(7844,1613,'2020-01-04 01:00:02','749',''),(7845,2009,'2020-01-04 07:00:01','0',''),(7846,2021,'2020-01-03 22:00:02','87',''),(7847,2023,'2020-01-03 22:00:02','749',''),(7848,1610,'2020-01-04 00:00:01','5',''),(7849,1611,'2020-01-04 00:00:01','90',''),(7850,2021,'2020-01-04 00:00:02','95',''),(7851,2023,'2020-01-04 00:00:02','746',''),(7852,2036,'2020-01-04 00:00:02','-5',''),(7853,2047,'2020-01-04 00:00:02','4',''),(7854,2048,'2020-01-04 00:00:02','88',''),(7855,2050,'2020-01-04 00:00:02','752',''),(7856,2063,'2020-01-04 00:00:02','-7',''),(7857,2074,'2020-01-04 00:00:02','3',''),(7858,2075,'2020-01-04 00:00:02','84',''),(7859,2077,'2020-01-04 00:00:02','764',''),(7860,2090,'2020-01-04 00:00:02','-9',''),(7861,2101,'2020-01-04 00:00:02','1',''),(7862,2102,'2020-01-04 00:00:02','94',''),(7863,2104,'2020-01-04 00:00:02','761',''),(7864,2117,'2020-01-04 00:00:02','1',''),(7865,2128,'2020-01-04 00:00:03','6',''),(7866,2382,'2020-01-04 00:00:03','92',''),(7867,2130,'2020-01-04 00:00:03','759',''),(7868,2143,'2020-01-04 00:00:03','-1',''),(7869,2383,'2020-01-04 00:00:03','88',''),(7870,2156,'2020-01-04 00:00:03','746',''),(7871,2169,'2020-01-04 00:00:03','2',''),(7872,2384,'2020-01-04 00:00:03','91',''),(7873,2182,'2020-01-04 00:00:03','753',''),(7874,1610,'2020-01-04 01:00:02','5',''),(7875,1611,'2020-01-04 01:00:02','90',''),(7876,2021,'2020-01-04 03:00:01','95',''),(7877,2023,'2020-01-04 12:00:01','746',''),(7878,2036,'2020-01-04 03:00:01','-5',''),(7879,2047,'2020-01-04 12:00:01','4',''),(7880,2048,'2020-01-04 03:00:01','88',''),(7881,2050,'2020-01-04 12:00:01','752',''),(7882,2063,'2020-01-04 03:00:02','-7',''),(7883,2074,'2020-01-04 10:00:08','3',''),(7884,2075,'2020-01-04 03:00:02','84',''),(7885,2077,'2020-01-04 10:00:08','764',''),(7886,2090,'2020-01-04 03:00:02','-9',''),(7887,2101,'2020-01-04 10:00:08','1',''),(7888,2102,'2020-01-04 10:00:08','94',''),(7889,2104,'2020-01-04 03:00:02','761',''),(7890,2117,'2020-01-04 03:00:02','1',''),(7891,2128,'2020-01-04 03:00:02','6',''),(7892,2382,'2020-01-04 03:00:02','92',''),(7893,2130,'2020-01-04 03:00:02','759',''),(7894,2143,'2020-01-04 03:00:02','-1',''),(7895,2383,'2020-01-04 03:00:02','88',''),(7896,2156,'2020-01-04 03:00:02','746',''),(7897,2169,'2020-01-04 03:00:02','2',''),(7898,2384,'2020-01-04 03:00:02','91',''),(7899,2182,'2020-01-04 03:00:02','753',''),(7900,1610,'2020-01-04 03:00:01','6',''),(7901,1611,'2020-01-04 03:00:01','87',''),(7902,1613,'2020-01-04 03:00:01','748',''),(7903,1610,'2020-01-04 04:00:01','6',''),(7904,1611,'2020-01-04 04:00:01','87',''),(7905,1613,'2020-01-04 04:00:01','748',''),(7906,2020,'2020-01-04 04:00:01','5',''),(7907,2021,'2020-01-04 04:00:01','94',''),(7908,2036,'2020-01-04 04:00:01','-1',''),(7909,2048,'2020-01-04 04:00:01','91',''),(7910,2063,'2020-01-04 04:00:01','-9',''),(7911,2075,'2020-01-04 04:00:01','83',''),(7912,2090,'2020-01-04 04:00:02','-7',''),(7913,2104,'2020-01-04 04:00:02','760',''),(7914,2117,'2020-01-04 04:00:02','-2',''),(7915,2128,'2020-01-04 04:00:02','5',''),(7916,2382,'2020-01-04 04:00:02','96',''),(7917,2130,'2020-01-04 04:00:02','756',''),(7918,2143,'2020-01-04 04:00:02','1',''),(7919,2154,'2020-01-04 04:00:02','4',''),(7920,2383,'2020-01-04 04:00:02','89',''),(7921,2156,'2020-01-04 04:00:02','743',''),(7922,2169,'2020-01-04 04:00:02','-2',''),(7923,2180,'2020-01-04 04:00:02','4',''),(7924,2384,'2020-01-04 04:00:02','90',''),(7925,2182,'2020-01-04 04:00:02','755',''),(7926,1610,'2020-01-04 06:00:01','7',''),(7927,1611,'2020-01-04 06:00:01','89',''),(7928,1613,'2020-01-04 06:00:01','746',''),(7929,2020,'2020-01-04 12:00:01','5',''),(7930,2021,'2020-01-04 12:00:01','94',''),(7931,2036,'2020-01-13 10:00:01','-1',''),(7932,2048,'2020-01-04 10:00:08','91',''),(7933,2063,'2020-01-04 12:00:01','-9',''),(7934,2075,'2020-01-04 10:00:08','83',''),(7935,2090,'2020-01-04 10:00:08','-7',''),(7936,2104,'2020-01-04 10:00:08','760',''),(7937,2117,'2020-01-04 10:00:08','-2',''),(7938,2128,'2020-01-04 10:00:08','5',''),(7939,2382,'2020-01-04 10:00:08','96',''),(7940,2130,'2020-01-04 10:00:08','756',''),(7941,2143,'2020-01-04 10:00:08','1',''),(7942,2154,'2020-01-04 10:00:08','4',''),(7943,2383,'2020-01-04 10:00:08','89',''),(7944,2156,'2020-01-04 12:00:02','743',''),(7945,2169,'2020-01-04 12:00:02','-2',''),(7946,2180,'2020-01-04 10:00:09','4',''),(7947,2384,'2020-01-04 10:00:09','90',''),(7948,2182,'2020-01-04 10:00:09','755',''),(7949,1610,'2020-01-04 07:00:01','7',''),(7950,1611,'2020-01-04 07:00:01','89',''),(7951,1613,'2020-01-04 12:00:01','746',''),(7952,1605,'2020-01-04 09:00:01','1',''),(7953,1610,'2020-01-04 09:00:01','6',''),(7954,1611,'2020-01-04 09:00:01','90',''),(7955,2009,'2020-01-04 09:00:01','1',''),(7956,1605,'2020-01-04 12:00:01','1',''),(7957,1610,'2020-01-04 10:00:02','6',''),(7958,1611,'2020-01-04 10:00:02','90',''),(7959,2009,'2020-01-04 12:00:01','1',''),(7960,1610,'2020-01-04 12:00:01','5',''),(7961,1611,'2020-01-04 12:00:01','94',''),(7962,2048,'2020-01-04 12:00:01','89',''),(7963,2074,'2020-01-04 12:00:02','2',''),(7964,2075,'2020-01-04 12:00:02','89',''),(7965,2077,'2020-01-04 12:00:02','765',''),(7966,2090,'2020-01-04 12:00:02','-6',''),(7967,2101,'2020-01-04 12:00:02','3',''),(7968,2102,'2020-01-04 12:00:02','92',''),(7969,2104,'2020-01-04 12:00:02','762',''),(7970,2117,'2020-01-04 12:00:02','-4',''),(7971,2128,'2020-01-04 12:00:02','6',''),(7972,2382,'2020-01-04 12:00:02','93',''),(7973,2130,'2020-01-04 12:00:02','758',''),(7974,2143,'2020-01-04 12:00:02','2',''),(7975,2154,'2020-01-04 12:00:02','5',''),(7976,2383,'2020-01-04 12:00:02','96',''),(7977,2180,'2020-01-04 12:00:02','3',''),(7978,2384,'2020-01-04 12:00:02','88',''),(7979,2182,'2020-01-04 12:00:02','757',''),(7980,1605,'2020-01-12 17:00:06','0',''),(7981,1610,'2020-01-12 17:00:06','8',''),(7982,1611,'2020-01-12 19:00:01','94',''),(7983,1613,'2020-01-12 17:00:06','748',''),(7984,2009,'2020-01-12 17:00:09','-1',''),(7985,2020,'2020-01-12 17:00:09','8',''),(7986,2021,'2020-01-12 17:00:09','93',''),(7987,2023,'2020-01-12 17:00:09','751',''),(7988,2047,'2020-01-12 17:00:09','5',''),(7989,2048,'2020-01-12 17:00:09','91',''),(7990,2050,'2020-01-12 17:00:09','749',''),(7991,2063,'2020-01-12 17:00:09','-1',''),(7992,2074,'2020-01-12 17:00:09','3',''),(7993,2075,'2020-01-12 17:00:09','90',''),(7994,2077,'2020-01-12 17:00:09','760',''),(7995,2090,'2020-01-12 17:00:09','0',''),(7996,2101,'2020-01-12 17:00:09','7',''),(7997,2102,'2020-01-12 17:00:09','96',''),(7998,2104,'2020-01-12 17:00:09','761',''),(7999,2117,'2020-01-12 17:00:09','3',''),(8000,2128,'2020-01-12 17:00:09','7',''),(8001,2382,'2020-01-12 17:00:09','97',''),(8002,2130,'2020-01-12 23:00:02','758',''),(8003,2143,'2020-01-12 17:00:09','1',''),(8004,2154,'2020-01-12 17:00:09','4',''),(8005,2383,'2020-01-12 17:00:09','97',''),(8006,2156,'2020-01-12 17:00:09','767',''),(8007,2169,'2020-01-12 17:00:10','-0',''),(8008,2180,'2020-01-12 17:00:10','5',''),(8009,2384,'2020-01-12 17:00:10','89',''),(8010,2182,'2020-01-12 17:00:10','771',''),(8011,1605,'2020-01-12 19:00:01','0',''),(8012,1610,'2020-01-12 19:00:01','8',''),(8013,1613,'2020-01-12 19:00:01','748',''),(8014,2009,'2020-01-12 19:00:01','0',''),(8015,2020,'2020-01-12 20:00:04','8',''),(8016,2021,'2020-01-12 19:00:02','94',''),(8017,2023,'2020-01-12 19:00:02','748',''),(8018,2047,'2020-01-12 23:00:02','5',''),(8019,2048,'2020-01-12 22:00:01','91',''),(8020,2050,'2020-01-12 23:00:02','749',''),(8021,2063,'2020-01-12 19:00:02','-3',''),(8022,2074,'2020-01-12 22:00:01','3',''),(8023,2075,'2020-01-12 22:00:01','90',''),(8024,2077,'2020-01-12 22:00:01','760',''),(8025,2090,'2020-01-12 19:00:02','1',''),(8026,2101,'2020-01-13 14:00:06','7',''),(8027,2102,'2020-01-12 23:00:02','96',''),(8028,2104,'2020-01-12 22:00:01','761',''),(8029,2117,'2020-01-12 19:00:02','2',''),(8030,2128,'2020-01-12 23:00:02','7',''),(8031,2382,'2020-01-12 22:00:01','97',''),(8032,2143,'2020-01-12 22:00:01','1',''),(8033,2154,'2020-01-12 22:00:01','4',''),(8034,2383,'2020-01-12 22:00:01','97',''),(8035,2156,'2020-01-12 22:00:01','767',''),(8036,2169,'2020-01-12 19:00:02','-1',''),(8037,2180,'2020-01-13 02:00:06','5',''),(8038,2384,'2020-01-12 22:00:02','89',''),(8039,2182,'2020-01-12 22:00:02','771',''),(8040,1605,'2020-01-12 20:00:02','2',''),(8041,1610,'2020-01-12 20:00:02','7',''),(8042,1611,'2020-01-12 20:00:02','98',''),(8043,1613,'2020-01-12 20:00:02','746',''),(8044,2009,'2020-01-12 20:00:04','0',''),(8045,2021,'2020-01-12 20:00:04','94',''),(8046,2023,'2020-01-12 20:00:04','748',''),(8047,2063,'2020-01-12 22:00:01','-3',''),(8048,2090,'2020-01-12 23:00:02','1',''),(8049,2117,'2020-01-12 23:00:02','2',''),(8050,2169,'2020-01-12 22:00:02','-1',''),(8051,1605,'2020-01-12 22:00:00','2',''),(8052,1610,'2020-01-12 22:00:00','7',''),(8053,1611,'2020-01-12 22:00:00','98',''),(8054,1613,'2020-01-12 22:00:00','746',''),(8055,2009,'2020-01-12 22:00:01','2',''),(8056,2020,'2020-01-12 22:00:01','7',''),(8057,2021,'2020-01-12 22:00:01','98',''),(8058,2023,'2020-01-12 22:00:01','746',''),(8059,1605,'2020-01-12 23:00:01','3',''),(8060,1610,'2020-01-12 23:00:01','6',''),(8061,1611,'2020-01-12 23:00:01','97',''),(8062,1613,'2020-01-12 23:00:01','745',''),(8063,2009,'2020-01-12 23:00:02','1',''),(8064,2020,'2020-01-12 23:00:02','7',''),(8065,2021,'2020-01-12 23:00:02','97',''),(8066,2023,'2020-01-12 23:00:02','746',''),(8067,2048,'2020-01-12 23:00:02','90',''),(8068,2063,'2020-01-12 23:00:02','-4',''),(8069,2074,'2020-01-12 23:00:02','4',''),(8070,2075,'2020-01-12 23:00:02','88',''),(8071,2077,'2020-01-12 23:00:02','761',''),(8072,2104,'2020-01-12 23:00:02','762',''),(8073,2382,'2020-01-12 23:00:02','94',''),(8074,2143,'2020-01-12 23:00:02','0',''),(8075,2154,'2020-01-12 23:00:02','3',''),(8076,2383,'2020-01-12 23:00:02','96',''),(8077,2156,'2020-01-12 23:00:02','768',''),(8078,2169,'2020-01-12 23:00:02','-2',''),(8079,2384,'2020-01-12 23:00:02','92',''),(8080,2182,'2020-01-12 23:00:02','773',''),(8081,1605,'2020-01-13 01:00:01','3',''),(8082,1610,'2020-01-13 02:00:01','6',''),(8083,1611,'2020-01-13 01:00:02','97',''),(8084,1613,'2020-01-13 01:00:02','745',''),(8085,2009,'2020-01-13 01:00:03','-1',''),(8086,2020,'2020-01-13 01:00:03','5',''),(8087,2021,'2020-01-13 01:00:03','90',''),(8088,2023,'2020-01-13 01:00:03','749',''),(8089,2047,'2020-01-13 01:00:03','4',''),(8090,2048,'2020-01-13 01:00:03','88',''),(8091,2050,'2020-01-13 01:00:03','761',''),(8092,2063,'2020-01-13 01:00:03','1',''),(8093,2074,'2020-01-13 01:00:03','7',''),(8094,2075,'2020-01-13 01:00:03','96',''),(8095,2077,'2020-01-13 01:00:03','762',''),(8096,2090,'2020-01-13 01:00:03','2',''),(8097,2102,'2020-01-13 01:00:03','94',''),(8098,2104,'2020-01-13 01:00:03','758',''),(8099,2117,'2020-01-13 01:00:03','-1',''),(8100,2128,'2020-01-13 01:00:03','3',''),(8101,2382,'2020-01-13 01:00:03','96',''),(8102,2130,'2020-01-13 01:00:03','768',''),(8103,2143,'2020-01-13 01:00:03','-2',''),(8104,2154,'2020-01-13 01:00:03','5',''),(8105,2383,'2020-01-13 01:00:03','92',''),(8106,2156,'2020-01-13 01:00:03','773',''),(8107,2169,'2020-01-13 11:00:02','-2',''),(8108,2384,'2020-01-13 01:00:04','87',''),(8109,2182,'2020-01-13 01:00:04','770',''),(8110,1605,'2020-01-13 02:00:01','2',''),(8111,1611,'2020-01-13 02:00:01','89',''),(8112,1613,'2020-01-13 02:00:01','747',''),(8113,2009,'2020-01-13 02:00:05','-1',''),(8114,2020,'2020-01-13 17:00:05','5',''),(8115,2021,'2020-01-13 10:00:01','90',''),(8116,2023,'2020-01-13 14:00:06','749',''),(8117,2047,'2020-01-13 02:00:05','4',''),(8118,2048,'2020-01-13 02:00:05','88',''),(8119,2050,'2020-01-13 10:00:01','761',''),(8120,2063,'2020-01-13 02:00:05','1',''),(8121,2074,'2020-01-14 22:00:05','7',''),(8122,2075,'2020-01-13 02:00:05','96',''),(8123,2077,'2020-01-13 02:00:05','762',''),(8124,2090,'2020-01-13 10:00:01','2',''),(8125,2102,'2020-01-13 02:00:05','94',''),(8126,2104,'2020-01-13 10:00:01','758',''),(8127,2117,'2020-01-13 02:00:05','-1',''),(8128,2128,'2020-01-13 14:00:06','3',''),(8129,2382,'2020-01-13 02:00:05','96',''),(8130,2130,'2020-01-13 02:00:05','768',''),(8131,2143,'2020-01-13 02:00:05','-2',''),(8132,2154,'2020-01-13 10:00:01','5',''),(8133,2383,'2020-01-13 02:00:05','92',''),(8134,2156,'2020-01-13 10:00:01','773',''),(8135,2384,'2020-01-13 02:00:06','87',''),(8136,2182,'2020-01-13 02:00:06','770',''),(8137,1605,'2020-01-13 04:00:01','2',''),(8138,1610,'2020-01-13 04:00:01','5',''),(8139,1611,'2020-01-13 04:00:01','92',''),(8140,1613,'2020-01-13 07:00:00','747',''),(8141,2009,'2020-01-13 04:00:01','1',''),(8142,2047,'2020-01-13 04:00:01','5',''),(8143,2048,'2020-01-13 04:00:01','91',''),(8144,2063,'2020-01-13 04:00:01','-1',''),(8145,2075,'2020-01-13 04:00:01','94',''),(8146,2077,'2020-01-13 04:00:01','761',''),(8147,2102,'2020-01-13 04:00:01','90',''),(8148,2117,'2020-01-13 04:00:02','1',''),(8149,2382,'2020-01-13 04:00:02','98',''),(8150,2130,'2020-01-13 04:00:02','767',''),(8151,2143,'2020-01-13 04:00:02','-0',''),(8152,2383,'2020-01-13 04:00:02','88',''),(8153,2180,'2020-01-13 04:00:02','4',''),(8154,2384,'2020-01-13 04:00:02','81',''),(8155,2182,'2020-01-13 04:00:02','773',''),(8156,1605,'2020-01-13 05:00:01','1',''),(8157,1610,'2020-01-13 05:00:01','4',''),(8158,1611,'2020-01-13 05:00:01','91',''),(8159,2009,'2020-01-13 08:00:01','1',''),(8160,2047,'2020-01-13 10:00:01','5',''),(8161,2048,'2020-01-13 10:00:01','91',''),(8162,2063,'2020-01-13 11:00:02','-1',''),(8163,2075,'2020-01-13 10:00:01','94',''),(8164,2077,'2020-01-13 10:00:01','761',''),(8165,2102,'2020-01-13 10:00:01','90',''),(8166,2117,'2020-01-13 23:00:05','1',''),(8167,2382,'2020-01-13 10:00:01','98',''),(8168,2130,'2020-01-13 10:00:01','767',''),(8169,2143,'2020-01-13 10:00:01','-0',''),(8170,2383,'2020-01-13 10:00:01','88',''),(8171,2180,'2020-01-13 10:00:02','4',''),(8172,2384,'2020-01-13 10:00:02','81',''),(8173,2182,'2020-01-13 10:00:02','773',''),(8174,1605,'2020-01-13 07:00:00','1',''),(8175,1610,'2020-01-13 10:00:00','4',''),(8176,1611,'2020-01-13 07:00:00','91',''),(8177,1605,'2020-01-13 08:00:01','-1',''),(8178,1611,'2020-01-13 08:00:01','94',''),(8179,1613,'2020-01-13 08:00:01','748',''),(8180,1605,'2020-01-13 10:00:00','-1',''),(8181,1611,'2020-01-13 10:00:00','94',''),(8182,1613,'2020-01-13 10:00:00','748',''),(8183,2009,'2020-01-13 10:00:01','-1',''),(8184,1605,'2020-01-13 11:00:01','-0',''),(8185,1610,'2020-01-13 11:00:01','5',''),(8186,1611,'2020-01-13 11:00:01','89',''),(8187,1613,'2020-01-13 11:00:01','749',''),(8188,2009,'2020-01-13 11:00:02','-1',''),(8189,2021,'2020-01-13 11:00:02','89',''),(8190,2036,'2020-01-13 11:00:02','-3',''),(8191,2047,'2020-01-13 11:00:02','6',''),(8192,2048,'2020-01-13 11:00:02','90',''),(8193,2050,'2020-01-13 11:00:02','760',''),(8194,2075,'2020-01-13 11:00:02','97',''),(8195,2077,'2020-01-13 11:00:02','759',''),(8196,2090,'2020-01-13 11:00:02','3',''),(8197,2102,'2020-01-13 11:00:02','94',''),(8198,2104,'2020-01-13 11:00:02','756',''),(8199,2382,'2020-01-13 11:00:02','97',''),(8200,2130,'2020-01-13 11:00:02','766',''),(8201,2143,'2020-01-13 11:00:02','-1',''),(8202,2154,'2020-01-13 11:00:02','3',''),(8203,2383,'2020-01-13 11:00:02','93',''),(8204,2156,'2020-01-13 11:00:02','771',''),(8205,2180,'2020-01-13 11:00:02','5',''),(8206,2384,'2020-01-13 11:00:02','86',''),(8207,2182,'2020-01-13 11:00:02','772',''),(8208,1605,'2020-01-13 16:00:02','-0',''),(8209,1610,'2020-01-13 16:00:02','5',''),(8210,1611,'2020-01-13 13:00:00','89',''),(8211,1613,'2020-01-13 13:00:00','749',''),(8212,2009,'2020-01-13 13:00:00','-0',''),(8213,2021,'2020-01-13 14:00:06','89',''),(8214,2036,'2020-01-13 13:00:01','-2',''),(8215,2047,'2020-01-13 14:00:06','6',''),(8216,2048,'2020-01-13 14:00:06','90',''),(8217,2050,'2020-01-13 22:00:01','760',''),(8218,2063,'2020-01-13 13:00:01','1',''),(8219,2075,'2020-01-13 14:00:06','97',''),(8220,2077,'2020-01-13 14:00:06','759',''),(8221,2090,'2020-01-13 17:00:06','3',''),(8222,2102,'2020-01-13 14:00:06','94',''),(8223,2104,'2020-01-13 14:00:06','756',''),(8224,2382,'2020-01-13 14:00:06','97',''),(8225,2130,'2020-01-13 14:00:06','766',''),(8226,2143,'2020-01-13 13:00:01','-0',''),(8227,2154,'2020-01-13 14:00:06','3',''),(8228,2383,'2020-01-13 14:00:06','93',''),(8229,2156,'2020-01-14 02:00:03','771',''),(8230,2169,'2020-01-13 13:00:01','-1',''),(8231,2180,'2020-01-13 22:00:02','5',''),(8232,2384,'2020-01-13 14:00:06','86',''),(8233,2182,'2020-01-13 14:00:06','772',''),(8234,1611,'2020-01-13 14:00:04','88',''),(8235,1613,'2020-01-13 14:00:04','752',''),(8236,2009,'2020-01-13 17:00:05','-0',''),(8237,2036,'2020-01-13 14:00:06','-2',''),(8238,2063,'2020-01-13 14:00:06','1',''),(8239,2143,'2020-01-13 22:00:01','-0',''),(8240,2169,'2020-01-13 17:00:06','-1',''),(8241,1611,'2020-01-13 16:00:02','88',''),(8242,1613,'2020-01-13 16:00:02','752',''),(8243,2021,'2020-01-13 16:00:02','88',''),(8244,2023,'2020-01-13 16:00:02','752',''),(8245,2036,'2020-01-13 16:00:02','-1',''),(8246,2047,'2020-01-13 16:00:02','5',''),(8247,2048,'2020-01-13 16:00:02','87',''),(8248,2063,'2020-01-13 16:00:02','0',''),(8249,2075,'2020-01-13 16:00:02','96',''),(8250,2077,'2020-01-13 16:00:02','761',''),(8251,2101,'2020-01-13 16:00:02','6',''),(8252,2102,'2020-01-13 16:00:02','97',''),(8253,2104,'2020-01-13 16:00:02','758',''),(8254,2128,'2020-01-13 16:00:02','5',''),(8255,2382,'2020-01-13 16:00:02','94',''),(8256,2130,'2020-01-13 16:00:02','764',''),(8257,2154,'2020-01-13 16:00:03','2',''),(8258,2383,'2020-01-13 16:00:03','88',''),(8259,2384,'2020-01-13 16:00:03','85',''),(8260,2182,'2020-01-13 16:00:03','773',''),(8261,1605,'2020-01-13 17:00:02','-1',''),(8262,1610,'2020-01-13 17:00:02','4',''),(8263,1611,'2020-01-13 17:00:02','87',''),(8264,1613,'2020-01-13 17:00:02','753',''),(8265,2021,'2020-01-13 17:00:05','88',''),(8266,2023,'2020-01-13 17:00:05','752',''),(8267,2036,'2020-01-13 17:00:05','-1',''),(8268,2047,'2020-01-13 22:00:01','5',''),(8269,2048,'2020-01-13 23:00:05','87',''),(8270,2063,'2020-01-13 17:00:06','0',''),(8271,2075,'2020-01-13 22:00:01','96',''),(8272,2077,'2020-01-13 23:00:05','761',''),(8273,2101,'2020-01-13 22:00:01','6',''),(8274,2102,'2020-01-13 22:00:01','97',''),(8275,2104,'2020-01-13 22:00:01','758',''),(8276,2128,'2020-01-13 22:00:01','5',''),(8277,2382,'2020-01-13 22:00:01','94',''),(8278,2130,'2020-01-13 22:00:01','764',''),(8279,2154,'2020-01-13 22:00:01','2',''),(8280,2383,'2020-01-13 22:00:01','88',''),(8281,2384,'2020-01-13 22:00:02','85',''),(8282,2182,'2020-01-13 22:00:02','773',''),(8283,1605,'2020-01-13 19:00:01','-1',''),(8284,1610,'2020-01-14 02:00:01','4',''),(8285,1611,'2020-01-13 19:00:01','87',''),(8286,1613,'2020-01-13 19:00:01','753',''),(8287,2009,'2020-01-13 19:00:01','-1',''),(8288,2020,'2020-01-13 19:00:01','4',''),(8289,2021,'2020-01-13 19:00:01','87',''),(8290,2023,'2020-01-13 19:00:01','753',''),(8291,2036,'2020-01-13 19:00:02','-2',''),(8292,2063,'2020-01-13 19:00:02','1',''),(8293,2090,'2020-01-13 19:00:02','2',''),(8294,2169,'2020-01-13 19:00:02','-3',''),(8295,1605,'2020-01-13 20:00:00','-2',''),(8296,1611,'2020-01-13 20:00:00','89',''),(8297,1613,'2020-01-13 20:00:01','755',''),(8298,2009,'2020-01-13 20:00:01','-1',''),(8299,2020,'2020-01-13 23:00:05','4',''),(8300,2021,'2020-01-13 20:00:01','87',''),(8301,2023,'2020-01-13 20:00:01','753',''),(8302,2036,'2020-01-13 23:00:05','-2',''),(8303,2063,'2020-01-14 02:00:02','1',''),(8304,2090,'2020-01-13 22:00:01','2',''),(8305,2169,'2020-01-13 22:00:01','-3',''),(8306,1605,'2020-01-14 01:00:02','-2',''),(8307,1611,'2020-01-13 22:00:00','89',''),(8308,1613,'2020-01-14 01:00:02','755',''),(8309,2009,'2020-01-13 22:00:01','-2',''),(8310,2021,'2020-01-13 22:00:01','89',''),(8311,2023,'2020-01-13 22:00:01','755',''),(8312,1611,'2020-01-13 23:00:02','94',''),(8313,2009,'2020-01-13 23:00:05','-1',''),(8314,2021,'2020-01-13 23:00:05','89',''),(8315,2023,'2020-01-13 23:00:05','755',''),(8316,2047,'2020-01-13 23:00:05','6',''),(8317,2050,'2020-01-13 23:00:05','759',''),(8318,2075,'2020-01-13 23:00:05','90',''),(8319,2090,'2020-01-13 23:00:05','4',''),(8320,2101,'2020-01-13 23:00:05','7',''),(8321,2102,'2020-01-13 23:00:05','93',''),(8322,2104,'2020-01-13 23:00:05','757',''),(8323,2128,'2020-01-13 23:00:06','4',''),(8324,2382,'2020-01-13 23:00:06','97',''),(8325,2130,'2020-01-13 23:00:06','766',''),(8326,2143,'2020-01-13 23:00:06','-1',''),(8327,2154,'2020-01-13 23:00:06','4',''),(8328,2383,'2020-01-13 23:00:06','89',''),(8329,2169,'2020-01-13 23:00:06','-1',''),(8330,2180,'2020-01-13 23:00:06','6',''),(8331,2384,'2020-01-13 23:00:06','80',''),(8332,2182,'2020-01-13 23:00:06','771',''),(8333,1611,'2020-01-14 01:00:02','94',''),(8334,2009,'2020-01-14 01:00:04','-3',''),(8335,2020,'2020-01-14 01:00:04','6',''),(8336,2021,'2020-01-14 01:00:04','87',''),(8337,2023,'2020-01-14 01:00:04','759',''),(8338,2036,'2020-01-14 01:00:04','2',''),(8339,2047,'2020-01-14 01:00:04','7',''),(8340,2048,'2020-01-14 01:00:04','90',''),(8341,2050,'2020-01-14 01:00:04','761',''),(8342,2075,'2020-01-14 01:00:04','93',''),(8343,2077,'2020-01-14 01:00:04','757',''),(8344,2090,'2020-01-14 01:00:04','1',''),(8345,2101,'2020-01-14 01:00:04','4',''),(8346,2102,'2020-01-14 01:00:04','97',''),(8347,2104,'2020-01-14 01:00:04','766',''),(8348,2117,'2020-01-14 01:00:04','-1',''),(8349,2128,'2020-01-14 02:00:03','4',''),(8350,2382,'2020-01-14 01:00:04','89',''),(8351,2130,'2020-01-14 01:00:04','771',''),(8352,2143,'2020-01-14 01:00:04','-3',''),(8353,2154,'2020-01-14 01:00:04','6',''),(8354,2383,'2020-01-14 01:00:04','80',''),(8355,2169,'2020-01-14 01:00:05','-2',''),(8356,2180,'2020-01-14 01:00:05','2',''),(8357,2384,'2020-01-14 01:00:05','93',''),(8358,2182,'2020-01-14 01:00:05','777',''),(8359,1605,'2020-01-14 02:00:01','-1',''),(8360,1611,'2020-01-14 02:00:01','89',''),(8361,1613,'2020-01-14 02:00:01','757',''),(8362,2009,'2020-01-14 02:00:02','-3',''),(8363,2020,'2020-01-14 14:00:01','6',''),(8364,2021,'2020-01-14 02:00:02','87',''),(8365,2023,'2020-01-14 10:00:01','759',''),(8366,2036,'2020-01-14 02:00:02','2',''),(8367,2047,'2020-01-14 23:00:01','7',''),(8368,2048,'2020-01-14 02:00:02','90',''),(8369,2050,'2020-01-14 02:00:02','761',''),(8370,2075,'2020-01-14 02:00:02','93',''),(8371,2077,'2020-01-14 10:00:01','757',''),(8372,2090,'2020-01-14 02:00:02','1',''),(8373,2101,'2020-01-14 14:00:02','4',''),(8374,2102,'2020-01-14 02:00:02','97',''),(8375,2104,'2020-01-14 02:00:02','766',''),(8376,2117,'2020-01-14 02:00:02','-1',''),(8377,2382,'2020-01-14 02:00:03','89',''),(8378,2130,'2020-01-14 10:00:01','771',''),(8379,2143,'2020-01-14 02:00:03','-3',''),(8380,2154,'2020-01-14 02:00:03','6',''),(8381,2383,'2020-01-14 02:00:03','80',''),(8382,2169,'2020-01-14 02:00:03','-2',''),(8383,2180,'2020-01-14 10:00:01','2',''),(8384,2384,'2020-01-14 02:00:03','93',''),(8385,2182,'2020-01-14 02:00:03','777',''),(8386,1605,'2020-01-14 04:00:00','-1',''),(8387,1610,'2020-01-14 04:00:00','5',''),(8388,1611,'2020-01-14 04:00:00','90',''),(8389,1613,'2020-01-14 04:00:00','757',''),(8390,2009,'2020-01-14 04:00:00','-2',''),(8391,2021,'2020-01-14 04:00:00','90',''),(8392,2036,'2020-01-14 04:00:00','-2',''),(8393,2048,'2020-01-14 04:00:00','96',''),(8394,2050,'2020-01-14 04:00:00','760',''),(8395,2063,'2020-01-14 04:00:01','3',''),(8396,2075,'2020-01-14 04:00:01','94',''),(8397,2090,'2020-01-14 04:00:01','-0',''),(8398,2102,'2020-01-14 04:00:01','93',''),(8399,2104,'2020-01-14 04:00:01','767',''),(8400,2117,'2020-01-14 04:00:01','-0',''),(8401,2128,'2020-01-14 04:00:01','5',''),(8402,2382,'2020-01-14 04:00:01','85',''),(8403,2143,'2020-01-14 04:00:01','-1',''),(8404,2154,'2020-01-14 04:00:01','5',''),(8405,2383,'2020-01-14 04:00:01','81',''),(8406,2156,'2020-01-14 04:00:01','772',''),(8407,2169,'2020-01-14 04:00:01','-3',''),(8408,2384,'2020-01-14 04:00:01','88',''),(8409,2182,'2020-01-14 04:00:01','772',''),(8410,1605,'2020-01-14 05:00:01','-2',''),(8411,1610,'2020-01-14 05:00:01','4',''),(8412,1611,'2020-01-14 05:00:01','92',''),(8413,1613,'2020-01-14 05:00:01','758',''),(8414,2009,'2020-01-14 10:00:01','-2',''),(8415,2021,'2020-01-14 10:00:01','90',''),(8416,2036,'2020-01-14 11:00:09','-2',''),(8417,2048,'2020-01-14 10:00:01','96',''),(8418,2050,'2020-01-14 10:00:01','760',''),(8419,2063,'2020-01-14 11:00:09','3',''),(8420,2075,'2020-01-14 10:00:01','94',''),(8421,2090,'2020-01-14 11:00:09','-0',''),(8422,2102,'2020-01-14 10:00:01','93',''),(8423,2104,'2020-01-14 10:00:01','767',''),(8424,2117,'2020-01-14 11:00:09','-0',''),(8425,2128,'2020-01-14 14:00:02','5',''),(8426,2382,'2020-01-14 10:00:01','85',''),(8427,2143,'2020-01-14 14:00:02','-1',''),(8428,2154,'2020-01-14 14:00:02','5',''),(8429,2383,'2020-01-14 10:00:01','81',''),(8430,2156,'2020-01-14 10:00:01','772',''),(8431,2169,'2020-01-14 10:00:01','-3',''),(8432,2384,'2020-01-14 10:00:01','88',''),(8433,2182,'2020-01-14 10:00:02','772',''),(8434,1605,'2020-01-14 10:00:00','-2',''),(8435,1610,'2020-01-14 10:00:00','4',''),(8436,1611,'2020-01-14 10:00:00','92',''),(8437,1613,'2020-01-14 13:00:00','758',''),(8438,1605,'2020-01-14 11:00:05','-1',''),(8439,1610,'2020-01-14 11:00:05','6',''),(8440,1611,'2020-01-14 11:00:05','89',''),(8441,2009,'2020-01-14 11:00:09','-1',''),(8442,2021,'2020-01-14 11:00:09','89',''),(8443,2023,'2020-01-14 11:00:09','758',''),(8444,2048,'2020-01-14 11:00:09','95',''),(8445,2050,'2020-01-14 11:00:09','759',''),(8446,2075,'2020-01-14 11:00:09','93',''),(8447,2077,'2020-01-14 11:00:09','755',''),(8448,2102,'2020-01-14 11:00:09','97',''),(8449,2104,'2020-01-14 11:00:09','765',''),(8450,2382,'2020-01-14 11:00:10','81',''),(8451,2130,'2020-01-14 11:00:10','770',''),(8452,2383,'2020-01-14 11:00:10','84',''),(8453,2156,'2020-01-14 11:00:10','770',''),(8454,2169,'2020-01-14 11:00:10','-0',''),(8455,2180,'2020-01-14 11:00:10','3',''),(8456,2384,'2020-01-14 11:00:10','90',''),(8457,2182,'2020-01-14 11:00:10','776',''),(8458,1605,'2020-01-14 16:00:01','-1',''),(8459,1610,'2020-01-14 13:00:00','6',''),(8460,1611,'2020-01-14 13:00:00','89',''),(8461,2009,'2020-01-14 17:00:05','-1',''),(8462,2021,'2020-01-14 14:00:01','89',''),(8463,2023,'2020-01-14 14:00:01','758',''),(8464,2036,'2020-01-14 13:00:01','0',''),(8465,2048,'2020-01-14 14:00:01','95',''),(8466,2050,'2020-01-14 23:00:01','759',''),(8467,2063,'2020-01-14 13:00:01','4',''),(8468,2075,'2020-01-14 14:00:02','93',''),(8469,2077,'2020-01-14 14:00:02','755',''),(8470,2090,'2020-01-14 13:00:01','1',''),(8471,2102,'2020-01-14 14:00:02','97',''),(8472,2104,'2020-01-14 22:00:05','765',''),(8473,2117,'2020-01-14 13:00:01','1',''),(8474,2382,'2020-01-14 14:00:02','81',''),(8475,2130,'2020-01-14 22:00:05','770',''),(8476,2383,'2020-01-14 14:00:02','84',''),(8477,2156,'2020-01-14 23:00:02','770',''),(8478,2169,'2020-01-14 14:00:02','-0',''),(8479,2180,'2020-01-14 23:00:02','3',''),(8480,2384,'2020-01-14 14:00:02','90',''),(8481,2182,'2020-01-14 14:00:02','776',''),(8482,1610,'2020-01-14 14:00:01','5',''),(8483,1611,'2020-01-14 14:00:01','88',''),(8484,1613,'2020-01-14 14:00:01','760',''),(8485,2036,'2020-01-14 17:00:05','0',''),(8486,2063,'2020-01-14 17:00:05','4',''),(8487,2090,'2020-01-14 22:00:05','1',''),(8488,2117,'2020-01-14 14:00:02','1',''),(8489,1610,'2020-01-14 19:00:03','5',''),(8490,1611,'2020-01-14 16:00:01','87',''),(8491,1613,'2020-01-14 16:00:01','760',''),(8492,2020,'2020-01-14 16:00:01','5',''),(8493,2021,'2020-01-14 16:00:01','87',''),(8494,2023,'2020-01-14 16:00:01','760',''),(8495,2048,'2020-01-14 16:00:02','96',''),(8496,2075,'2020-01-14 16:00:02','91',''),(8497,2077,'2020-01-14 16:00:02','756',''),(8498,2101,'2020-01-14 16:00:02','2',''),(8499,2102,'2020-01-14 16:00:02','92',''),(8500,2117,'2020-01-14 16:00:02','0',''),(8501,2128,'2020-01-14 16:00:02','6',''),(8502,2382,'2020-01-14 16:00:02','84',''),(8503,2143,'2020-01-14 16:00:02','-2',''),(8504,2154,'2020-01-14 16:00:02','6',''),(8505,2383,'2020-01-14 16:00:02','88',''),(8506,2169,'2020-01-14 16:00:02','-1',''),(8507,2384,'2020-01-14 16:00:02','92',''),(8508,2182,'2020-01-14 16:00:02','773',''),(8509,1605,'2020-01-14 17:00:01','-0',''),(8510,1611,'2020-01-14 17:00:01','90',''),(8511,1613,'2020-01-14 17:00:01','761',''),(8512,2020,'2020-01-14 20:00:06','5',''),(8513,2021,'2020-01-14 17:00:05','87',''),(8514,2023,'2020-01-14 17:00:05','760',''),(8515,2048,'2020-01-14 22:00:05','96',''),(8516,2075,'2020-01-14 22:00:05','91',''),(8517,2077,'2020-01-14 22:00:05','756',''),(8518,2101,'2020-01-14 22:00:05','2',''),(8519,2102,'2020-01-14 22:00:05','92',''),(8520,2117,'2020-01-14 22:00:05','0',''),(8521,2128,'2020-01-14 22:00:05','6',''),(8522,2382,'2020-01-14 22:00:05','84',''),(8523,2143,'2020-01-14 17:00:06','-2',''),(8524,2154,'2020-01-14 23:00:02','6',''),(8525,2383,'2020-01-14 22:00:05','88',''),(8526,2169,'2020-01-14 17:00:06','-1',''),(8527,2384,'2020-01-14 22:00:05','92',''),(8528,2182,'2020-01-14 22:00:05','773',''),(8529,1605,'2020-01-14 19:00:03','-0',''),(8530,1611,'2020-01-15 02:00:02','90',''),(8531,1613,'2020-01-14 19:00:03','761',''),(8532,2009,'2020-01-14 19:00:06','-0',''),(8533,2021,'2020-01-14 19:00:06','90',''),(8534,2023,'2020-01-14 19:00:06','761',''),(8535,2036,'2020-01-14 19:00:06','2',''),(8536,2063,'2020-01-14 19:00:07','3',''),(8537,2143,'2020-01-14 19:00:07','-1',''),(8538,2169,'2020-01-14 19:00:07','-2',''),(8539,1605,'2020-01-14 20:00:01','-1',''),(8540,1610,'2020-01-14 20:00:01','4',''),(8541,1613,'2020-01-14 20:00:01','762',''),(8542,2009,'2020-01-14 20:00:06','-0',''),(8543,2021,'2020-01-14 22:00:04','90',''),(8544,2023,'2020-01-14 20:00:06','761',''),(8545,2036,'2020-01-14 23:00:01','2',''),(8546,2063,'2020-01-14 22:00:05','3',''),(8547,2143,'2020-01-14 23:00:02','-1',''),(8548,2169,'2020-01-14 22:00:05','-2',''),(8549,1605,'2020-01-14 22:00:01','-1',''),(8550,1610,'2020-01-15 01:00:02','4',''),(8551,1613,'2020-01-14 22:00:01','762',''),(8552,2009,'2020-01-14 22:00:04','-1',''),(8553,2020,'2020-01-14 22:00:04','4',''),(8554,2023,'2020-01-14 22:00:05','762',''),(8555,1605,'2020-01-14 23:00:01','-2',''),(8556,1613,'2020-01-14 23:00:01','763',''),(8557,2009,'2020-01-14 23:00:01','-2',''),(8558,2020,'2020-01-14 23:00:01','4',''),(8559,2021,'2020-01-14 23:00:01','92',''),(8560,2023,'2020-01-14 23:00:01','762',''),(8561,2048,'2020-01-14 23:00:01','97',''),(8562,2063,'2020-01-14 23:00:01','4',''),(8563,2074,'2020-01-14 23:00:01','8',''),(8564,2075,'2020-01-14 23:00:01','90',''),(8565,2077,'2020-01-14 23:00:01','754',''),(8566,2090,'2020-01-14 23:00:01','0',''),(8567,2101,'2020-01-14 23:00:01','3',''),(8568,2102,'2020-01-14 23:00:01','91',''),(8569,2104,'2020-01-14 23:00:01','767',''),(8570,2117,'2020-01-14 23:00:01','-1',''),(8571,2128,'2020-01-14 23:00:01','4',''),(8572,2382,'2020-01-14 23:00:01','87',''),(8573,2130,'2020-01-14 23:00:01','772',''),(8574,2383,'2020-01-14 23:00:02','82',''),(8575,2169,'2020-01-14 23:00:02','-1',''),(8576,2384,'2020-01-14 23:00:02','89',''),(8577,2182,'2020-01-14 23:00:02','776',''),(8578,1605,'2020-01-15 07:00:01','-2',''),(8579,1613,'2020-01-15 04:00:00','763',''),(8580,2009,'2020-01-15 01:00:05','2',''),(8581,2020,'2020-01-15 01:00:05','7',''),(8582,2021,'2020-01-15 01:00:05','97',''),(8583,2023,'2020-01-15 01:00:05','759',''),(8584,2036,'2020-01-15 01:00:05','1',''),(8585,2047,'2020-01-15 01:00:05','8',''),(8586,2048,'2020-01-15 01:00:05','90',''),(8587,2050,'2020-01-15 01:00:05','754',''),(8588,2063,'2020-01-15 01:00:06','1',''),(8589,2074,'2020-01-15 01:00:06','3',''),(8590,2075,'2020-01-15 01:00:06','91',''),(8591,2077,'2020-01-15 01:00:06','767',''),(8592,2090,'2020-01-15 01:00:06','-1',''),(8593,2101,'2020-01-15 01:00:06','4',''),(8594,2102,'2020-01-15 01:00:06','87',''),(8595,2104,'2020-01-15 01:00:06','772',''),(8596,2117,'2020-01-15 01:00:06','-0',''),(8597,2128,'2020-01-15 01:00:06','6',''),(8598,2382,'2020-01-15 01:00:06','82',''),(8599,2130,'2020-01-15 01:00:06','770',''),(8600,2143,'2020-01-15 01:00:06','-3',''),(8601,2154,'2020-01-15 01:00:06','3',''),(8602,2383,'2020-01-15 01:00:06','89',''),(8603,2156,'2020-01-15 01:00:06','776',''),(8604,2169,'2020-01-15 01:00:06','2',''),(8605,2180,'2020-01-15 01:00:06','9',''),(8606,2384,'2020-01-15 01:00:06','80',''),(8607,2182,'2020-01-15 01:00:06','762',''),(8608,1610,'2020-01-15 02:00:02','5',''),(8609,2009,'2020-01-15 02:00:04','2',''),(8610,2020,'2020-01-15 17:00:02','7',''),(8611,2021,'2020-01-15 02:00:04','97',''),(8612,2023,'2020-01-15 10:00:07','759',''),(8613,2036,'2020-01-15 02:00:04','1',''),(8614,2047,'2020-01-15 10:00:07','8',''),(8615,2048,'2020-01-15 10:00:07','90',''),(8616,2050,'2020-01-15 02:00:04','754',''),(8617,2063,'2020-01-15 14:00:02','1',''),(8618,2074,'2020-01-15 02:00:04','3',''),(8619,2075,'2020-01-15 02:00:04','91',''),(8620,2077,'2020-01-15 02:00:04','767',''),(8621,2090,'2020-01-15 02:00:04','-1',''),(8622,2101,'2020-01-15 10:00:07','4',''),(8623,2102,'2020-01-15 02:00:04','87',''),(8624,2104,'2020-01-15 10:00:07','772',''),(8625,2117,'2020-01-15 02:00:04','-0',''),(8626,2128,'2020-01-15 02:00:04','6',''),(8627,2382,'2020-01-15 02:00:04','82',''),(8628,2130,'2020-01-15 02:00:04','770',''),(8629,2143,'2020-01-15 02:00:04','-3',''),(8630,2154,'2020-01-15 02:00:04','3',''),(8631,2383,'2020-01-15 02:00:04','89',''),(8632,2156,'2020-01-15 10:00:08','776',''),(8633,2169,'2020-01-15 02:00:04','2',''),(8634,2180,'2020-01-15 02:00:04','9',''),(8635,2384,'2020-01-15 02:00:05','80',''),(8636,2182,'2020-01-15 10:00:08','762',''),(8637,1610,'2020-01-15 04:00:00','6',''),(8638,1611,'2020-01-15 04:00:00','89',''),(8639,2009,'2020-01-15 04:00:01','-2',''),(8640,2021,'2020-01-15 04:00:01','96',''),(8641,2036,'2020-01-15 04:00:01','3',''),(8642,2050,'2020-01-15 04:00:01','753',''),(8643,2074,'2020-01-15 04:00:01','2',''),(8644,2075,'2020-01-15 04:00:01','99',''),(8645,2077,'2020-01-15 04:00:01','766',''),(8646,2090,'2020-01-15 04:00:01','1',''),(8647,2102,'2020-01-15 04:00:01','91',''),(8648,2117,'2020-01-15 04:00:01','-2',''),(8649,2128,'2020-01-15 04:00:01','5',''),(8650,2382,'2020-01-15 04:00:01','86',''),(8651,2130,'2020-01-15 04:00:01','769',''),(8652,2143,'2020-01-15 04:00:01','-1',''),(8653,2154,'2020-01-15 04:00:01','2',''),(8654,2383,'2020-01-15 04:00:01','84',''),(8655,2169,'2020-01-15 04:00:01','-1',''),(8656,2180,'2020-01-15 04:00:01','8',''),(8657,2384,'2020-01-15 04:00:01','92',''),(8658,1610,'2020-01-15 05:00:00','7',''),(8659,1611,'2020-01-15 05:00:00','88',''),(8660,1613,'2020-01-15 05:00:00','761',''),(8661,2009,'2020-01-15 08:00:00','-2',''),(8662,2021,'2020-01-15 10:00:07','96',''),(8663,2036,'2020-01-15 11:00:12','3',''),(8664,2050,'2020-01-15 14:00:02','753',''),(8665,2074,'2020-01-15 10:00:07','2',''),(8666,2075,'2020-01-15 10:00:07','99',''),(8667,2077,'2020-01-15 10:00:07','766',''),(8668,2090,'2020-01-15 11:00:12','1',''),(8669,2102,'2020-01-15 14:00:02','91',''),(8670,2117,'2020-01-15 10:00:07','-2',''),(8671,2128,'2020-01-15 10:00:07','5',''),(8672,2382,'2020-01-15 10:00:07','86',''),(8673,2130,'2020-01-15 10:00:07','769',''),(8674,2143,'2020-01-15 11:00:12','-1',''),(8675,2154,'2020-01-15 10:00:08','2',''),(8676,2383,'2020-01-15 10:00:08','84',''),(8677,2169,'2020-01-15 10:00:08','-1',''),(8678,2180,'2020-01-15 22:00:01','8',''),(8679,2384,'2020-01-15 10:00:08','92',''),(8680,1610,'2020-01-15 16:00:01','7',''),(8681,1611,'2020-01-15 07:00:01','88',''),(8682,1613,'2020-01-15 07:00:01','761',''),(8683,1605,'2020-01-15 08:00:00','-1',''),(8684,1611,'2020-01-15 08:00:00','89',''),(8685,1613,'2020-01-15 08:00:00','760',''),(8686,1605,'2020-01-15 10:00:01','-1',''),(8687,1611,'2020-01-15 10:00:01','89',''),(8688,1613,'2020-01-15 10:00:01','760',''),(8689,2009,'2020-01-15 10:00:07','-1',''),(8690,1605,'2020-01-15 11:00:07','1',''),(8691,1611,'2020-01-15 11:00:07','97',''),(8692,1613,'2020-01-15 11:00:07','758',''),(8693,2009,'2020-01-15 11:00:12','-0',''),(8694,2021,'2020-01-15 11:00:12','97',''),(8695,2023,'2020-01-15 11:00:12','758',''),(8696,2047,'2020-01-15 11:00:12','7',''),(8697,2048,'2020-01-15 11:00:12','92',''),(8698,2074,'2020-01-15 11:00:12','3',''),(8699,2075,'2020-01-15 11:00:12','97',''),(8700,2077,'2020-01-15 11:00:12','767',''),(8701,2101,'2020-01-15 11:00:12','5',''),(8702,2104,'2020-01-15 11:00:12','770',''),(8703,2117,'2020-01-15 11:00:12','-1',''),(8704,2128,'2020-01-15 11:00:12','6',''),(8705,2382,'2020-01-15 11:00:12','83',''),(8706,2130,'2020-01-15 11:00:12','767',''),(8707,2154,'2020-01-15 11:00:13','4',''),(8708,2383,'2020-01-15 11:00:13','88',''),(8709,2156,'2020-01-15 11:00:13','770',''),(8710,2169,'2020-01-15 11:00:13','-2',''),(8711,2384,'2020-01-15 11:00:13','94',''),(8712,2182,'2020-01-15 11:00:13','755',''),(8713,1605,'2020-01-15 13:00:01','1',''),(8714,1611,'2020-01-15 19:00:01','97',''),(8715,1613,'2020-01-15 16:00:01','758',''),(8716,2009,'2020-01-15 13:00:01','1',''),(8717,2021,'2020-01-15 20:00:02','97',''),(8718,2023,'2020-01-15 17:00:02','758',''),(8719,2036,'2020-01-15 13:00:01','4',''),(8720,2047,'2020-01-15 23:00:44','7',''),(8721,2048,'2020-01-15 23:00:44','92',''),(8722,2074,'2020-01-15 22:00:01','3',''),(8723,2075,'2020-01-15 22:00:01','97',''),(8724,2077,'2020-01-15 22:00:01','767',''),(8725,2090,'2020-01-15 13:00:01','0',''),(8726,2101,'2020-01-15 23:00:45','5',''),(8727,2104,'2020-01-15 14:00:02','770',''),(8728,2117,'2020-01-15 14:00:02','-1',''),(8729,2128,'2020-01-15 14:00:02','6',''),(8730,2382,'2020-01-15 14:00:02','83',''),(8731,2130,'2020-01-15 22:00:01','767',''),(8732,2143,'2020-01-15 13:00:02','-2',''),(8733,2154,'2020-01-15 22:00:01','4',''),(8734,2383,'2020-01-15 14:00:02','88',''),(8735,2156,'2020-01-15 14:00:02','770',''),(8736,2169,'2020-01-15 13:00:02','-1',''),(8737,2384,'2020-01-15 14:00:02','94',''),(8738,2182,'2020-01-15 14:00:02','755',''),(8739,1605,'2020-01-15 14:00:01','2',''),(8740,2009,'2020-01-15 14:00:01','1',''),(8741,2036,'2020-01-15 17:00:02','4',''),(8742,2090,'2020-01-15 17:00:02','0',''),(8743,2143,'2020-01-15 14:00:02','-2',''),(8744,2169,'2020-01-15 14:00:02','-1',''),(8745,1605,'2020-01-16 01:00:01','2',''),(8746,2009,'2020-01-15 16:00:02','2',''),(8747,2050,'2020-01-15 16:00:02','754',''),(8748,2063,'2020-01-15 16:00:02','0',''),(8749,2102,'2020-01-15 16:00:02','88',''),(8750,2104,'2020-01-15 16:00:02','768',''),(8751,2117,'2020-01-15 16:00:02','-0',''),(8752,2128,'2020-01-15 16:00:02','5',''),(8753,2382,'2020-01-15 16:00:02','85',''),(8754,2143,'2020-01-15 16:00:02','-0',''),(8755,2383,'2020-01-15 16:00:03','92',''),(8756,2156,'2020-01-15 16:00:03','772',''),(8757,2169,'2020-01-15 16:00:03','0',''),(8758,2384,'2020-01-15 16:00:03','89',''),(8759,2182,'2020-01-15 16:00:03','754',''),(8760,1610,'2020-01-15 17:00:01','8',''),(8761,1613,'2020-01-15 17:00:01','755',''),(8762,2009,'2020-01-15 23:00:44','2',''),(8763,2050,'2020-01-15 23:00:44','754',''),(8764,2063,'2020-01-15 17:00:02','0',''),(8765,2102,'2020-01-15 22:00:01','88',''),(8766,2104,'2020-01-15 22:00:01','768',''),(8767,2117,'2020-01-15 22:00:01','-0',''),(8768,2128,'2020-01-15 22:00:01','5',''),(8769,2382,'2020-01-15 22:00:01','85',''),(8770,2143,'2020-01-15 17:00:02','-0',''),(8771,2383,'2020-01-15 22:00:01','92',''),(8772,2156,'2020-01-15 22:00:01','772',''),(8773,2169,'2020-01-15 17:00:02','0',''),(8774,2384,'2020-01-15 22:00:01','89',''),(8775,2182,'2020-01-15 22:00:01','754',''),(8776,1610,'2020-01-15 22:00:00','8',''),(8777,1613,'2020-01-15 22:00:00','755',''),(8778,2020,'2020-01-15 19:00:08','8',''),(8779,2023,'2020-01-15 19:00:08','755',''),(8780,2036,'2020-01-15 19:00:08','2',''),(8781,2063,'2020-01-15 19:00:08','2',''),(8782,2090,'2020-01-15 19:00:08','-1',''),(8783,2143,'2020-01-15 19:00:08','-2',''),(8784,2169,'2020-01-15 19:00:09','2',''),(8785,1611,'2020-01-15 20:00:01','92',''),(8786,2020,'2020-01-15 22:00:01','8',''),(8787,2023,'2020-01-15 23:00:44','755',''),(8788,2036,'2020-01-15 23:00:44','2',''),(8789,2063,'2020-01-15 23:00:44','2',''),(8790,2090,'2020-01-15 23:00:45','-1',''),(8791,2143,'2020-01-15 22:00:01','-2',''),(8792,2169,'2020-01-15 22:00:01','2',''),(8793,1611,'2020-01-15 22:00:00','92',''),(8794,2021,'2020-01-15 22:00:01','92',''),(8795,1610,'2020-01-15 23:00:43','7',''),(8796,1611,'2020-01-15 23:00:43','94',''),(8797,1613,'2020-01-15 23:00:43','754',''),(8798,2020,'2020-01-15 23:00:44','7',''),(8799,2021,'2020-01-15 23:00:44','93',''),(8800,2074,'2020-01-15 23:00:44','4',''),(8801,2075,'2020-01-15 23:00:44','96',''),(8802,2077,'2020-01-15 23:00:44','765',''),(8803,2102,'2020-01-15 23:00:45','90',''),(8804,2104,'2020-01-15 23:00:45','767',''),(8805,2117,'2020-01-15 23:00:45','1',''),(8806,2128,'2020-01-15 23:00:45','4',''),(8807,2382,'2020-01-15 23:00:45','89',''),(8808,2130,'2020-01-15 23:00:45','764',''),(8809,2143,'2020-01-15 23:00:45','-5',''),(8810,2154,'2020-01-15 23:00:45','3',''),(8811,2383,'2020-01-15 23:00:45','78',''),(8812,2156,'2020-01-15 23:00:45','774',''),(8813,2169,'2020-01-15 23:00:45','1',''),(8814,2180,'2020-01-15 23:00:45','9',''),(8815,2384,'2020-01-15 23:00:45','91',''),(8816,2182,'2020-01-15 23:00:45','752',''),(8817,1610,'2020-01-16 04:00:00','7',''),(8818,1611,'2020-01-16 04:00:00','94',''),(8819,1613,'2020-01-16 01:00:01','754',''),(8820,2009,'2020-01-16 01:00:01','1',''),(8821,2020,'2020-01-16 10:00:01','7',''),(8822,2021,'2020-01-16 01:00:01','92',''),(8823,2023,'2020-01-16 01:00:01','754',''),(8824,2036,'2020-01-16 01:00:01','1',''),(8825,2047,'2020-01-16 01:00:01','4',''),(8826,2048,'2020-01-16 01:00:01','96',''),(8827,2050,'2020-01-16 01:00:01','765',''),(8828,2063,'2020-01-16 01:00:01','-1',''),(8829,2074,'2020-01-16 01:00:01','5',''),(8830,2075,'2020-01-16 01:00:01','90',''),(8831,2077,'2020-01-16 01:00:01','767',''),(8832,2090,'2020-01-16 01:00:01','0',''),(8833,2101,'2020-01-16 01:00:01','4',''),(8834,2102,'2020-01-16 01:00:01','89',''),(8835,2104,'2020-01-16 01:00:01','764',''),(8836,2117,'2020-01-16 01:00:02','-2',''),(8837,2128,'2020-01-16 01:00:02','3',''),(8838,2382,'2020-01-16 01:00:02','78',''),(8839,2130,'2020-01-16 01:00:02','774',''),(8840,2143,'2020-01-16 01:00:02','-1',''),(8841,2154,'2020-01-16 01:00:02','9',''),(8842,2383,'2020-01-16 01:00:02','91',''),(8843,2156,'2020-01-16 01:00:02','752',''),(8844,2169,'2020-01-16 01:00:02','-3',''),(8845,2180,'2020-01-16 01:00:02','6',''),(8846,2384,'2020-01-16 01:00:02','86',''),(8847,2182,'2020-01-16 01:00:02','746',''),(8848,1605,'2020-01-16 02:00:01','4',''),(8849,1613,'2020-01-16 02:00:01','755',''),(8850,2009,'2020-01-16 02:00:01','1',''),(8851,2021,'2020-01-16 02:00:01','92',''),(8852,2023,'2020-01-16 02:00:01','754',''),(8853,2036,'2020-01-16 02:00:01','1',''),(8854,2047,'2020-01-17 10:00:22','4',''),(8855,2048,'2020-01-16 02:00:01','96',''),(8856,2050,'2020-01-16 02:00:01','765',''),(8857,2063,'2020-01-16 02:00:02','-1',''),(8858,2074,'2020-01-16 02:00:02','5',''),(8859,2075,'2020-01-16 02:00:02','90',''),(8860,2077,'2020-01-16 10:00:01','767',''),(8861,2090,'2020-01-16 02:00:02','0',''),(8862,2101,'2020-01-16 23:00:04','4',''),(8863,2102,'2020-01-16 02:00:02','89',''),(8864,2104,'2020-01-16 14:00:01','764',''),(8865,2117,'2020-01-16 02:00:02','-2',''),(8866,2128,'2020-01-16 02:00:02','3',''),(8867,2382,'2020-01-16 02:00:02','78',''),(8868,2130,'2020-01-16 02:00:02','774',''),(8869,2143,'2020-01-16 11:00:08','-1',''),(8870,2154,'2020-01-16 10:00:01','9',''),(8871,2383,'2020-01-16 02:00:02','91',''),(8872,2156,'2020-01-16 02:00:02','752',''),(8873,2169,'2020-01-16 02:00:02','-3',''),(8874,2180,'2020-01-16 02:00:02','6',''),(8875,2384,'2020-01-16 02:00:02','86',''),(8876,2182,'2020-01-16 14:00:01','746',''),(8877,1605,'2020-01-16 10:00:00','4',''),(8878,1613,'2020-01-16 04:00:01','755',''),(8879,2009,'2020-01-16 04:00:01','4',''),(8882,2036,'2020-01-16 04:00:01','-0',''),(8883,2048,'2020-01-16 04:00:01','97',''),(8884,2050,'2020-01-16 04:00:01','764',''),(8885,2063,'2020-01-16 04:00:01','1',''),(8915,2382,'2020-01-16 10:00:01','95',''),(8916,2130,'2020-01-16 10:00:01','770',''),(8917,2383,'2020-01-16 10:00:01','93',''),(8918,2156,'2020-01-16 10:00:01','755',''),(8919,2169,'2020-01-16 10:00:02','-2',''),(8920,2180,'2020-01-16 10:00:02','5',''),(8921,2384,'2020-01-16 10:00:02','90',''),(8922,1610,'2020-01-16 07:00:01','6',''),(8923,1611,'2020-01-16 07:00:01','93',''),(8924,1613,'2020-01-16 07:00:01','754',''),(8925,1610,'2020-01-16 08:00:01','7',''),(8926,1611,'2020-01-16 08:00:01','94',''),(8927,1613,'2020-01-16 08:00:01','755',''),(8928,1610,'2020-01-16 10:00:00','7',''),(8929,1611,'2020-01-16 10:00:00','94',''),(8930,1613,'2020-01-16 10:00:00','755',''),(9113,2104,'2020-01-17 02:00:01','770',''),(9114,2117,'2020-01-17 02:00:01','2',''),(9115,2128,'2020-01-17 02:00:01','9',''),(9116,2382,'2020-01-17 02:00:01','93',''),(9117,2130,'2020-01-17 02:00:01','758',''),(9118,2143,'2020-01-17 02:00:01','-3',''),(9119,2154,'2020-01-17 02:00:01','8',''),(9120,2383,'2020-01-17 02:00:01','82',''),(9121,2156,'2020-01-17 02:00:01','747',''),(9122,2169,'2020-01-17 02:00:01','-6',''),(9123,2180,'2020-01-17 02:00:02','5',''),(9124,2384,'2020-01-17 02:00:02','79',''),(9125,2182,'2020-01-17 02:00:02','752',''),(9127,1613,'2020-01-17 04:00:01','761',''),(9128,2036,'2020-01-17 04:00:01','1',''),(9130,2063,'2020-01-17 04:00:01','-1',''),(9162,2117,'2020-01-17 11:00:01','-0',''),(9163,2128,'2020-01-18 02:00:02','8',''),(9164,2382,'2020-01-17 10:00:23','89',''),(9165,2130,'2020-01-17 14:00:08','752',''),(9166,2143,'2020-01-17 10:00:23','-2',''),(9167,2154,'2020-01-17 14:00:09','6',''),(9168,2383,'2020-01-17 10:00:23','86',''),(9169,2156,'2020-01-17 10:00:23','743',''),(9170,2169,'2020-01-17 10:00:23','-3',''),(9171,2180,'2020-01-17 10:00:23','6',''),(9172,2384,'2020-01-17 10:00:23','82',''),(9173,2182,'2020-01-17 10:00:23','749',''),(9174,1611,'2020-01-17 07:00:01','93',''),(9175,1613,'2020-01-17 07:00:01','762',''),(9178,1611,'2020-01-17 10:00:22','96',''),(9179,1613,'2020-01-18 01:00:01','764',''),(9180,1611,'2020-01-17 11:00:00','93',''),(9395,2182,'2020-01-18 10:00:01','758',''),(9396,1611,'2020-01-18 07:00:01','96',''),(9397,1613,'2020-01-18 07:00:01','764',''),(9408,2036,'2020-01-18 11:00:02','-0',''),(9504,1613,'2020-01-18 20:00:01','764',''),(9505,2009,'2020-01-18 19:00:01','-1',''),(9506,2020,'2020-01-18 19:00:01','4',''),(9507,2021,'2020-01-18 19:00:01','93',''),(9579,2074,'2020-01-19 23:00:21','7',''),(9580,2075,'2020-01-19 02:00:01','95',''),(9581,2077,'2020-01-19 02:00:01','748',''),(9582,2090,'2020-01-19 02:00:01','-7',''),(9583,2102,'2020-01-19 02:00:01','87',''),(9584,2104,'2020-01-19 02:00:01','743',''),(9585,2117,'2020-01-19 11:00:01','-8',''),(9586,2128,'2020-01-19 02:00:01','8',''),(9587,2382,'2020-01-19 02:00:01','74',''),(9588,2130,'2020-01-19 02:00:01','752',''),(9589,2143,'2020-01-19 02:00:01','1',''),(9590,2154,'2020-01-19 02:00:01','7',''),(9591,2383,'2020-01-19 02:00:02','92',''),(9592,2156,'2020-01-19 02:00:02','758',''),(9593,2169,'2020-01-19 02:00:02','1',''),(9594,2180,'2020-01-19 02:00:02','6',''),(9595,2384,'2020-01-19 02:00:02','93',''),(9596,1611,'2020-01-19 04:00:01','88',''),(9636,2156,'2020-01-19 10:00:08','757',''),(9637,2169,'2020-01-19 10:00:08','-2',''),(9638,2180,'2020-01-19 10:00:08','3',''),(9639,2384,'2020-01-19 10:00:08','88',''),(9640,2182,'2020-01-19 10:00:08','761',''),(9641,1605,'2020-01-19 07:00:01','-0',''),(9642,1610,'2020-01-19 10:00:01','4',''),(9643,1611,'2020-01-19 07:00:01','87',''),(9644,1613,'2020-01-19 07:00:01','763',''),(9645,1605,'2020-01-19 08:00:01','-1',''),(9650,1613,'2020-01-19 14:00:02','764',''),(9686,2383,'2020-01-19 22:00:12','90',''),(9687,2156,'2020-01-19 14:00:05','753',''),(9688,2169,'2020-01-19 13:00:01','-3',''),(9689,2180,'2020-01-19 14:00:05','4',''),(9690,2384,'2020-01-19 14:00:05','89',''),(9691,2182,'2020-01-19 14:00:05','759',''),(9692,1610,'2020-01-19 14:00:02','4',''),(9697,2143,'2020-01-19 17:00:01','-5',''),(9698,2169,'2020-01-19 14:00:05','-3',''),(9699,1610,'2020-01-19 16:00:03','4',''),(9700,1611,'2020-01-19 16:00:03','88',''),(9823,2117,'2020-01-20 02:00:20','-3',''),(9824,2128,'2020-01-20 02:00:20','5',''),(9825,2382,'2020-01-20 02:00:20','89',''),(9826,2130,'2020-01-20 02:00:20','749',''),(9827,2143,'2020-01-20 02:00:20','-2',''),(9828,2154,'2020-01-20 10:00:02','4',''),(9829,2383,'2020-01-20 02:00:20','90',''),(9830,2156,'2020-01-20 02:00:20','753',''),(9831,2169,'2020-01-20 02:00:20','1',''),(9832,2384,'2020-01-20 02:00:20','97',''),(9833,2182,'2020-01-20 02:00:20','752',''),(9834,1611,'2020-01-20 04:00:00','96',''),(9871,2382,'2020-01-20 10:00:01','94',''),(9872,2130,'2020-01-20 10:00:01','746',''),(9873,2143,'2020-01-20 10:00:01','-3',''),(9874,2383,'2020-01-20 10:00:02','89',''),(9875,2156,'2020-01-20 10:00:02','752',''),(9876,2169,'2020-01-20 10:00:02','-4',''),(9877,2180,'2020-01-20 10:00:02','6',''),(9878,2384,'2020-01-20 10:00:02','91',''),(9879,2182,'2020-01-20 10:00:02','751',''),(9880,1605,'2020-01-20 07:00:01','-0',''),(9881,1610,'2020-01-20 07:00:01','7',''),(9882,1611,'2020-01-20 07:00:01','89',''),(9883,1605,'2020-01-20 08:00:01','-1',''),(9884,1610,'2020-01-20 08:00:01','5',''),(10070,2090,'2020-01-21 03:00:02','-3',''),(10071,2102,'2020-01-21 03:00:02','86',''),(10072,2117,'2020-01-21 03:00:02','-2',''),(10073,2128,'2020-01-21 10:00:01','3',''),(10074,2382,'2020-01-21 03:00:02','87',''),(10075,2130,'2020-01-21 03:00:02','752',''),(10076,2143,'2020-01-21 03:00:02','0',''),(10077,2383,'2020-01-21 10:00:01','90',''),(10078,2156,'2020-01-21 10:00:01','758',''),(10079,2169,'2020-01-21 03:00:02','-1',''),(10080,2180,'2020-01-21 03:00:02','7',''),(10081,2384,'2020-01-21 03:00:02','96',''),(10082,2182,'2020-01-21 03:00:02','748',''),(10085,1613,'2020-01-21 04:00:02','757',''),(10096,2101,'2020-01-21 04:00:05','5',''),(10103,2154,'2020-01-21 04:00:06','4',''),(10122,2101,'2020-01-21 15:00:01','5',''),(10123,2102,'2020-01-21 21:00:01','89',''),(10124,2104,'2020-01-21 21:00:01','752',''),(10125,2117,'2020-01-21 12:00:05','-3',''),(10126,2382,'2020-01-21 10:00:01','97',''),(10127,2130,'2020-01-21 10:00:01','749',''),(10128,2143,'2020-01-21 12:00:05','-4',''),(10129,2154,'2020-01-21 10:00:01','4',''),(10130,2169,'2020-01-21 10:00:01','0',''),(10131,2180,'2020-01-21 10:00:02','6',''),(10132,2384,'2020-01-21 10:00:02','95',''),(10133,2182,'2020-01-21 10:00:02','752',''),(10134,1605,'2020-01-21 07:00:02','1',''),(10135,1610,'2020-01-21 10:00:00','6',''),(10136,1611,'2020-01-21 07:00:02','94',''),(10137,1613,'2020-01-21 07:00:02','752',''),(10138,1605,'2020-01-21 09:00:01','2',''),(10144,1613,'2020-01-21 10:00:00','749',''),(10145,2009,'2020-01-21 10:00:01','2',''),(10146,1605,'2020-01-21 12:00:01','4',''),(10147,1610,'2020-01-21 12:00:01','7',''),(10148,1611,'2020-01-21 12:00:01','91',''),(10149,1613,'2020-01-21 12:00:01','746',''),(10150,2009,'2020-01-21 12:00:05','4',''),(10151,2020,'2020-01-21 12:00:05','7',''),(10176,2048,'2020-01-21 21:00:01','80',''),(10177,2050,'2020-01-21 15:00:01','741',''),(10182,2090,'2020-01-21 13:00:02','-5',''),(10186,2130,'2020-01-21 15:00:01','752',''),(10192,2180,'2020-01-21 21:00:02','4',''),(10193,2384,'2020-01-21 15:00:01','91',''),(10194,2182,'2020-01-21 15:00:01','758',''),(10195,1610,'2020-01-21 15:00:00','6',''),(10200,2117,'2020-01-21 15:00:01','-1',''),(10201,2143,'2020-01-21 15:00:01','-3',''),(10216,2128,'2020-01-21 16:00:02','6',''),(10217,2382,'2020-01-21 16:00:02','84',''),(10218,2130,'2020-01-21 16:00:02','754',''),(10219,2143,'2020-01-21 16:00:02','-2',''),(10220,2154,'2020-01-21 16:00:02','4',''),(10221,2383,'2020-01-21 16:00:02','83',''),(10222,2384,'2020-01-21 16:00:02','88',''),(10223,2182,'2020-01-21 16:00:02','757',''),(10224,1605,'2020-01-21 18:00:01','3',''),(10225,1611,'2020-01-21 18:00:01','89',''),(10226,1613,'2020-01-21 18:00:01','743',''),(10227,2009,'2020-01-21 20:00:03','3',''),(10228,2020,'2020-01-21 20:00:03','6',''),(10229,2021,'2020-01-21 18:00:07','92',''),(10230,2023,'2020-01-21 18:00:07','745',''),(10231,2036,'2020-01-21 18:00:07','-3',''),(10232,2047,'2020-01-21 23:00:01','5',''),(10233,2050,'2020-01-21 21:00:01','742',''),(10234,2075,'2020-01-21 21:00:01','71',''),(10257,2169,'2020-01-21 21:00:02','-2',''),(10258,1605,'2020-01-21 21:00:01','1',''),(10259,1610,'2020-01-21 21:00:01','5',''),(10260,1611,'2020-01-21 21:00:01','85',''),(10267,1611,'2020-01-21 23:00:01','79',''),(10268,2009,'2020-01-21 23:00:01','2',''),(10269,2020,'2020-01-21 23:00:01','6',''),(10270,2021,'2020-01-21 23:00:01','92',''),(10306,2128,'2020-01-22 00:00:01','6',''),(10307,2382,'2020-01-22 00:00:01','83',''),(10308,2130,'2020-01-22 00:00:01','755',''),(10309,2143,'2020-01-22 00:00:01','-1',''),(10310,2154,'2020-01-22 00:00:02','5',''),(10314,2180,'2020-01-22 00:00:02','6',''),(10315,2384,'2020-01-22 00:00:02','84',''),(10316,2182,'2020-01-22 00:00:02','754',''),(10325,2048,'2020-01-22 03:00:01','72',''),(10326,2050,'2020-01-22 23:00:02','752',''),(10327,2063,'2020-01-22 03:00:01','-4',''),(10328,2075,'2020-01-22 03:00:01','94',''),(10329,2077,'2020-01-22 15:00:02','749',''),(10330,2101,'2020-01-22 03:00:01','4',''),(10331,2102,'2020-01-22 03:00:01','88',''),(10332,2104,'2020-01-22 03:00:01','748',''),(10333,2117,'2020-01-22 09:00:01','-7',''),(10334,2128,'2020-01-22 09:00:01','6',''),(10335,2382,'2020-01-22 03:00:01','83',''),(10336,2130,'2020-01-22 03:00:01','755',''),(10337,2143,'2020-01-22 03:00:01','-1',''),(10338,2154,'2020-01-22 09:00:01','5',''),(10339,2383,'2020-01-22 09:00:01','91',''),(10340,2156,'2020-01-22 03:00:02','760',''),(10341,2169,'2020-01-22 03:00:02','2',''),(10342,2180,'2020-01-22 03:00:02','6',''),(10343,2384,'2020-01-22 03:00:02','84',''),(10344,2182,'2020-01-22 09:00:01','754',''),(10345,1605,'2020-01-22 09:00:00','-2',''),(10346,1611,'2020-01-22 03:00:00','82',''),(10347,1611,'2020-01-22 05:00:01','86',''),(10437,1611,'2020-01-22 15:00:01','83',''),(10438,1613,'2020-01-22 18:00:01','743',''),(10439,2009,'2020-01-22 15:00:02','-2',''),(10440,2021,'2020-01-22 15:00:02','83',''),(10441,2023,'2020-01-22 15:00:02','743',''),(10442,2036,'2020-01-22 15:00:02','-8',''),(10443,2063,'2020-01-22 15:00:02','-5',''),(10444,2090,'2020-01-22 17:00:03','-1',''),(10445,2143,'2020-01-22 15:00:02','-7',''),(10446,2169,'2020-01-22 15:00:02','1',''),(10449,2009,'2020-01-22 17:00:02','-2',''),(10452,2023,'2020-01-22 20:00:06','743',''),(10453,2036,'2020-01-22 17:00:03','-7',''),(10454,2048,'2020-01-22 17:00:03','75',''),(10455,2063,'2020-01-22 17:00:03','-4',''),(10503,2063,'2020-01-22 21:00:01','-0',''),(10504,2090,'2020-01-22 21:00:01','-2',''),(10505,2143,'2020-01-22 23:00:03','1',''),(10506,1610,'2020-01-23 18:00:06','6',''),(10507,1611,'2020-01-22 21:00:01','83',''),(10508,1613,'2020-01-22 21:00:01','745',''),(10509,2020,'2020-01-22 21:00:01','6',''),(10510,2021,'2020-01-22 21:00:01','83',''),(10515,2020,'2020-01-23 20:00:01','6',''),(10518,2048,'2020-01-22 23:00:02','76',''),(10523,2101,'2020-01-22 23:00:03','6',''),(10551,2117,'2020-01-23 00:00:02','1',''),(10552,2128,'2020-01-23 03:00:24','5',''),(10553,2382,'2020-01-23 00:00:02','92',''),(10554,2130,'2020-01-23 00:00:02','759',''),(10570,2048,'2020-01-23 03:00:23','93',''),(10571,2050,'2020-01-23 03:00:23','747',''),(10572,2063,'2020-01-23 03:00:23','-4',''),(10573,2074,'2020-01-23 03:00:24','6',''),(10574,2075,'2020-01-23 03:00:24','84',''),(10575,2077,'2020-01-23 03:00:24','742',''),(10576,2090,'2020-01-23 03:00:24','-14',''),(10577,2101,'2020-01-23 03:00:24','5',''),(10578,2102,'2020-01-23 03:00:24','83',''),(10579,2104,'2020-01-23 03:00:24','757',''),(10580,2117,'2020-01-23 03:00:24','1',''),(10581,2382,'2020-01-23 03:00:24','92',''),(10582,2130,'2020-01-23 03:00:24','759',''),(10583,2143,'2020-01-23 03:00:24','-4',''),(10584,2154,'2020-01-23 03:00:24','3',''),(10585,2383,'2020-01-23 03:00:24','98',''),(10586,2156,'2020-01-23 03:00:24','752',''),(10587,2169,'2020-01-23 11:00:02','-1',''),(10588,2180,'2020-01-23 03:00:24','7',''),(10589,2182,'2020-01-23 03:00:24','750',''),(10590,1611,'2020-01-23 03:00:18','81',''),(10591,1613,'2020-01-23 03:00:18','748',''),(10592,1605,'2020-01-23 05:00:01','-7',''),(10593,1611,'2020-01-23 05:00:01','82',''),(10594,1613,'2020-01-23 05:00:01','749',''),(10595,2009,'2020-01-23 05:00:02','-7',''),(10655,1613,'2020-01-23 15:00:01','752',''),(10656,2021,'2020-01-23 12:00:02','80',''),(10661,2101,'2020-01-23 12:00:02','7',''),(10690,2154,'2020-01-23 15:00:02','4',''),(10691,2383,'2020-01-23 15:00:02','95',''),(10692,2156,'2020-01-23 15:00:02','752',''),(10693,2169,'2020-01-23 14:00:02','0',''),(10694,2180,'2020-01-23 15:00:02','7',''),(10695,2384,'2020-01-23 15:00:02','91',''),(10696,2182,'2020-01-23 15:00:02','746',''),(10697,1611,'2020-01-23 15:00:00','79',''),(10698,2009,'2020-01-23 20:00:01','-6',''),(10699,2021,'2020-01-23 15:00:01','79',''),(10700,2036,'2020-01-23 15:00:01','-2',''),(10701,2063,'2020-01-23 15:00:01','-1',''),(10702,2090,'2020-01-23 15:00:01','-9',''),(10703,2117,'2020-01-23 15:00:01','-6',''),(10704,2143,'2020-01-23 15:00:02','-1',''),(10705,2169,'2020-01-23 15:00:02','0',''),(10706,1611,'2020-01-23 17:00:01','88',''),(10710,2048,'2020-01-23 17:00:02','93',''),(10711,2063,'2020-01-23 17:00:02','-2',''),(10715,2101,'2020-01-23 17:00:02','5',''),(10716,2102,'2020-01-23 17:00:02','86',''),(10717,2104,'2020-01-23 17:00:02','756',''),(10748,2154,'2020-01-23 21:00:02','3',''),(10749,2383,'2020-01-23 21:00:02','98',''),(10750,2156,'2020-01-23 21:00:02','755',''),(10751,2169,'2020-01-23 18:00:12','-0',''),(10752,2180,'2020-01-23 21:00:02','6',''),(10753,2384,'2020-01-23 21:00:02','98',''),(10754,2182,'2020-01-23 21:00:02','745',''),(10766,2169,'2020-01-23 21:00:02','-0',''),(10767,1605,'2020-01-23 21:00:01','-7',''),(10768,1610,'2020-01-23 21:00:01','5',''),(10769,1611,'2020-01-23 21:00:01','85',''),(10770,1613,'2020-01-24 03:00:01','755',''),(10777,1611,'2020-01-23 23:00:01','88',''),(10778,2009,'2020-01-23 23:00:01','-7',''),(10779,2020,'2020-01-23 23:00:01','5',''),(10780,2021,'2020-01-23 23:00:01','88',''),(10781,2023,'2020-01-23 23:00:01','755',''),(10785,2077,'2020-01-23 23:00:02','741',''),(10789,2104,'2020-01-23 23:00:02','755',''),(10802,1605,'2020-01-24 06:00:01','-8',''),(10803,1610,'2020-01-24 00:00:04','4',''),(10804,1611,'2020-01-24 00:00:04','88',''),(10805,2009,'2020-01-24 00:00:05','-3',''),(10806,2020,'2020-01-24 00:00:05','7',''),(10807,2021,'2020-01-24 00:00:05','93',''),(10809,2036,'2020-01-24 00:00:05','-4',''),(10817,2090,'2020-01-24 00:00:06','-12',''),(10818,2101,'2020-01-24 00:00:06','1',''),(10819,2102,'2020-01-24 00:00:06','80',''),(10820,2104,'2020-01-24 00:00:06','761',''),(10821,2117,'2020-01-24 00:00:06','-8',''),(10822,2128,'2020-01-24 00:00:06','5',''),(10823,2382,'2020-01-24 00:00:06','88',''),(10824,2130,'2020-01-24 09:00:06','761',''),(10825,2143,'2020-01-24 00:00:06','-2',''),(10826,2154,'2020-01-24 00:00:06','7',''),(10827,2383,'2020-01-24 00:00:06','97',''),(10828,2156,'2020-01-24 00:00:06','750',''),(10829,2169,'2020-01-24 00:00:06','-0',''),(10830,2180,'2020-01-24 00:00:06','6',''),(10831,2384,'2020-01-24 00:00:06','98',''),(10832,2182,'2020-01-24 00:00:06','749',''),(10836,2020,'2020-01-24 03:00:01','7',''),(10837,2021,'2020-01-24 03:00:01','93',''),(10838,2023,'2020-01-24 14:00:01','746',''),(10839,2036,'2020-01-24 03:00:02','-4',''),(10840,2047,'2020-01-24 03:00:02','4',''),(10841,2048,'2020-01-24 03:00:02','94',''),(10842,2050,'2020-01-24 15:00:07','741',''),(10843,2063,'2020-01-24 03:00:02','-4',''),(10844,2074,'2020-01-24 09:00:06','6',''),(10845,2075,'2020-01-24 03:00:02','85',''),(10846,2077,'2020-01-24 03:00:02','755',''),(10847,2090,'2020-01-24 03:00:02','-12',''),(10848,2101,'2020-01-24 09:00:06','1',''),(10849,2102,'2020-01-24 03:00:02','80',''),(10850,2104,'2020-01-24 03:00:02','761',''),(10851,2117,'2020-01-24 03:00:02','-8',''),(10852,2128,'2020-01-24 03:00:02','5',''),(10853,2382,'2020-01-24 03:00:02','88',''),(10854,2143,'2020-01-24 03:00:02','-2',''),(10855,2154,'2020-01-24 09:00:06','7',''),(10856,2383,'2020-01-24 03:00:02','97',''),(10857,2156,'2020-01-24 03:00:02','750',''),(10858,2169,'2020-01-24 03:00:02','-0',''),(10859,2180,'2020-01-24 09:00:06','6',''),(10860,2384,'2020-01-24 03:00:02','98',''),(10861,2182,'2020-01-24 03:00:02','749',''),(10862,1610,'2020-01-24 03:00:01','3',''),(10863,1611,'2020-01-24 03:00:01','85',''),(10864,1610,'2020-01-24 05:00:01','4',''),(10865,1611,'2020-01-24 05:00:01','82',''),(10866,1613,'2020-01-24 05:00:01','752',''),(11004,2023,'2020-01-24 18:00:01','744',''),(11008,2074,'2020-01-24 17:00:02','4',''),(11092,2102,'2020-01-25 03:00:01','89',''),(11093,2104,'2020-01-25 00:00:01','760',''),(11094,2117,'2020-01-25 00:00:01','-9',''),(11095,2128,'2020-01-25 00:00:02','5',''),(11096,2382,'2020-01-25 00:00:02','89',''),(11097,2130,'2020-01-25 00:00:02','761',''),(11100,2383,'2020-01-25 00:00:02','93',''),(11101,2156,'2020-01-25 00:00:02','758',''),(11102,2169,'2020-01-25 00:00:02','-3',''),(11103,2180,'2020-01-25 00:00:02','5',''),(11104,2384,'2020-01-25 00:00:02','96',''),(11105,2182,'2020-01-25 00:00:02','751',''),(11106,1605,'2020-01-25 02:00:01','-4',''),(11107,1610,'2020-01-25 02:00:01','4',''),(11116,2063,'2020-01-25 02:00:02','-12',''),(11126,2130,'2020-01-25 02:00:03','758',''),(11127,2143,'2020-01-25 02:00:03','-3',''),(11128,2154,'2020-01-25 02:00:03','5',''),(11129,2383,'2020-01-25 02:00:03','96',''),(11130,2156,'2020-01-25 02:00:03','751',''),(11131,2169,'2020-01-25 02:00:03','-6',''),(11132,2180,'2020-01-25 02:00:03','0',''),(11133,2384,'2020-01-25 02:00:03','95',''),(11134,2182,'2020-01-25 02:00:03','749',''),(11135,1605,'2020-01-25 03:00:00','-4',''),(11136,1610,'2020-01-25 03:00:00','4',''),(11137,1611,'2020-01-25 03:00:00','90',''),(11138,2020,'2020-01-25 17:00:05','4',''),(11139,2021,'2020-01-25 03:00:01','94',''),(11140,2023,'2020-01-25 09:00:02','742',''),(11141,2036,'2020-01-25 03:00:01','-4',''),(11142,2048,'2020-01-25 03:00:01','86',''),(11143,2050,'2020-01-25 23:00:01','755',''),(11144,2063,'2020-01-25 03:00:01','-12',''),(11145,2074,'2020-01-25 09:00:02','3',''),(11146,2075,'2020-01-25 03:00:01','89',''),(11147,2077,'2020-01-25 09:00:02','760',''),(11148,2090,'2020-01-25 03:00:01','-9',''),(11149,2101,'2020-01-25 23:00:01','5',''),(11150,2104,'2020-01-25 03:00:01','761',''),(11151,2117,'2020-01-25 03:00:01','-0',''),(11152,2128,'2020-01-25 03:00:01','3',''),(11153,2382,'2020-01-25 03:00:01','93',''),(11154,2130,'2020-01-25 09:00:02','758',''),(11155,2143,'2020-01-25 03:00:01','-3',''),(11156,2154,'2020-01-25 03:00:01','5',''),(11157,2383,'2020-01-25 03:00:01','96',''),(11158,2156,'2020-01-25 03:00:01','751',''),(11159,2169,'2020-01-25 09:00:02','-6',''),(11160,2180,'2020-01-25 03:00:01','0',''),(11161,2384,'2020-01-25 09:00:02','95',''),(11162,2182,'2020-01-25 03:00:01','749',''),(11164,1610,'2020-01-25 05:00:00','5',''),(11165,1611,'2020-01-25 05:00:00','89',''),(11168,2036,'2020-01-25 05:00:01','-7',''),(11209,1611,'2020-01-25 11:00:01','94',''),(11242,2102,'2020-01-25 15:00:02','89',''),(11243,2104,'2020-01-25 21:00:06','761',''),(11244,2128,'2020-01-25 15:00:02','3',''),(11245,2382,'2020-01-25 23:00:01','93',''),(11246,2130,'2020-01-25 15:00:02','759',''),(11247,2383,'2020-01-25 15:00:02','92',''),(11248,2156,'2020-01-25 15:00:02','758',''),(11249,2169,'2020-01-25 17:00:06','-1',''),(11250,2180,'2020-01-25 15:00:02','4',''),(11251,2384,'2020-01-25 23:00:01','93',''),(11252,2182,'2020-01-25 15:00:02','758',''),(11256,2063,'2020-01-25 14:00:01','-9',''),(11257,2090,'2020-01-25 14:00:01','-9',''),(11266,2090,'2020-01-25 15:00:02','-9',''),(11267,2117,'2020-01-25 15:00:02','-5',''),(11268,2143,'2020-01-25 17:00:06','0',''),(11274,2023,'2020-01-25 17:00:05','740',''),(11275,2048,'2020-01-25 17:00:05','84',''),(11318,2021,'2020-01-25 20:00:01','93',''),(11319,2023,'2020-01-25 20:00:01','741',''),(11320,2036,'2020-01-25 23:00:01','-5',''),(11321,2063,'2020-01-25 21:00:06','-13',''),(11322,2117,'2020-01-25 21:00:07','-1',''),(11323,2143,'2020-01-25 21:00:07','-1',''),(11324,2169,'2020-01-25 23:00:01','-2',''),(11325,1605,'2020-01-25 21:00:06','-3',''),(11326,1611,'2020-01-25 21:00:06','92',''),(11327,1613,'2020-01-25 21:00:06','743',''),(11328,2009,'2020-01-25 21:00:06','-3',''),(11336,2021,'2020-01-25 23:00:01','94',''),(11337,2023,'2020-01-25 23:00:01','743',''),(11395,2077,'2020-01-26 09:00:02','759',''),(11396,2090,'2020-01-26 03:00:01','-3',''),(11397,2101,'2020-01-26 23:00:01','3',''),(11398,2102,'2020-01-26 14:00:01','93',''),(11399,2104,'2020-01-26 14:00:01','758',''),(11400,2117,'2020-01-26 09:00:02','-1',''),(11401,2128,'2020-01-26 09:00:02','5',''),(11402,2382,'2020-01-26 03:00:01','94',''),(11403,2130,'2020-01-26 03:00:01','755',''),(11404,2143,'2020-01-26 03:00:01','-3',''),(11405,2383,'2020-01-26 03:00:02','93',''),(11406,2156,'2020-01-26 03:00:02','753',''),(11407,2169,'2020-01-26 03:00:02','-4',''),(11408,2180,'2020-01-26 03:00:02','1',''),(11409,2384,'2020-01-26 03:00:02','94',''),(11410,2182,'2020-01-26 03:00:02','759',''),(11411,1605,'2020-01-26 03:00:00','-5',''),(11412,1610,'2020-01-26 03:00:00','6',''),(11413,1611,'2020-01-26 03:00:00','89',''),(11414,1613,'2020-01-26 03:00:00','749',''),(11415,1605,'2020-01-26 05:00:00','-7',''),(11419,2009,'2020-01-26 05:00:01','-7',''),(11500,2154,'2020-01-26 14:00:02','6',''),(11501,2383,'2020-01-26 21:00:07','93',''),(11502,2156,'2020-01-26 14:00:02','752',''),(11503,2169,'2020-01-26 12:00:01','-3',''),(11504,2180,'2020-01-26 14:00:02','1',''),(11505,2182,'2020-01-26 14:00:02','757',''),(11506,1605,'2020-01-26 14:00:00','-5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11507,1605,'2020-01-26 14:00:00','-5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11508,1610,'2020-01-26 14:00:00','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11509,1610,'2020-01-26 14:00:00','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11510,1611,'2020-01-26 14:00:00','86','/objects/?object=ClockChime&op=m&m=onNewHour'),(11511,1611,'2020-01-26 16:00:03','86','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11512,2009,'2020-01-26 16:00:03','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11513,2063,'2020-01-26 14:00:01','-9','/objects/?object=ClockChime&op=m&m=onNewHour'),(11514,2063,'2020-01-26 14:00:01','-9','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11515,2090,'2020-01-26 14:00:01','-5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11516,2090,'2020-01-26 14:00:01','-5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11517,2117,'2020-01-26 14:00:01','-2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11518,2117,'2020-01-26 14:00:01','-2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11519,2143,'2020-01-26 14:00:02','-1','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11520,2143,'2020-01-26 14:00:02','-1','/objects/?object=ClockChime&op=m&m=onNewHour'),(11521,2169,'2020-01-26 14:00:02','-2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11522,2169,'2020-01-26 16:00:04','-2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11523,1605,'2020-01-26 16:00:01','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11524,1610,'2020-01-26 16:00:01','2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11525,2020,'2020-01-26 16:00:02','2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11526,2021,'2020-01-26 16:00:02','86','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11527,2036,'2020-01-26 16:00:02','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11528,2048,'2020-01-26 16:00:02','89','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11529,2063,'2020-01-26 16:00:02','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11530,2075,'2020-01-26 16:00:02','88','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11531,2077,'2020-01-26 16:00:02','763','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11532,2090,'2020-01-26 16:00:02','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11533,2102,'2020-01-26 16:00:02','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11534,2104,'2020-01-26 16:00:02','759','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11535,2117,'2020-01-26 16:00:02','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11536,2128,'2020-01-26 16:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11537,2130,'2020-01-26 16:00:02','755','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11538,2143,'2020-01-26 16:00:02','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11539,1605,'2020-01-26 16:00:02','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11540,1610,'2020-01-26 16:00:03','2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11541,2154,'2020-01-26 16:00:03','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11542,2156,'2020-01-26 16:00:03','754','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11543,2180,'2020-01-26 16:00:03','2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11544,2384,'2020-01-26 16:00:03','85','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11545,2182,'2020-01-26 16:00:03','759','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11546,2020,'2020-01-26 16:00:03','2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11547,2021,'2020-01-26 16:00:03','86','/objects/?object=ClockChime&op=m&m=onNewHour'),(11548,2036,'2020-01-26 16:00:03','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11549,2048,'2020-01-26 21:00:07','89','/objects/?object=ClockChime&op=m&m=onNewHour'),(11550,2063,'2020-01-26 16:00:03','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11551,2075,'2020-01-26 21:00:07','88','/objects/?object=ClockChime&op=m&m=onNewHour'),(11552,2077,'2020-01-26 21:00:07','763','/objects/?object=ClockChime&op=m&m=onNewHour'),(11553,2090,'2020-01-26 21:00:07','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11554,2102,'2020-01-26 21:00:07','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11555,2104,'2020-01-26 21:00:07','759','/objects/?object=ClockChime&op=m&m=onNewHour'),(11556,2117,'2020-01-26 16:00:03','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11557,2128,'2020-01-26 21:00:07','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11558,2130,'2020-01-26 23:00:02','755','/objects/?object=ClockChime&op=m&m=onNewHour'),(11559,2143,'2020-01-26 21:00:07','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11560,2154,'2020-01-26 23:00:02','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11561,2156,'2020-01-26 23:00:02','754','/objects/?object=ClockChime&op=m&m=onNewHour'),(11562,2180,'2020-01-26 23:00:02','2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11563,2384,'2020-01-26 21:00:08','85','/objects/?object=ClockChime&op=m&m=onNewHour'),(11564,2182,'2020-01-26 21:00:08','759','/objects/?object=ClockChime&op=m&m=onNewHour'),(11565,1605,'2020-01-26 19:00:01','-5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11566,1605,'2020-01-26 19:00:01','-5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11567,1610,'2020-01-26 19:00:01','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11568,1610,'2020-01-27 01:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11569,1611,'2020-01-26 19:00:01','93','/objects/?object=ClockChime&op=m&m=onNewHour'),(11570,1611,'2020-01-26 19:00:01','93','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11571,1613,'2020-01-26 19:00:01','752','/objects/?object=ClockChime&op=m&m=onNewHour'),(11572,1613,'2020-01-26 19:00:01','752','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11573,2009,'2020-01-26 19:00:01','-5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11574,2020,'2020-01-26 19:00:01','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11575,2021,'2020-01-26 19:00:01','93','/objects/?object=ClockChime&op=m&m=onNewHour'),(11576,2023,'2020-01-26 19:00:01','752','/objects/?object=ClockChime&op=m&m=onNewHour'),(11577,2036,'2020-01-26 19:00:02','-14','/objects/?object=ClockChime&op=m&m=onNewHour'),(11578,2009,'2020-01-26 19:00:02','-5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11579,2020,'2020-01-26 23:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11580,2021,'2020-01-26 19:00:02','93','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11581,2023,'2020-01-26 19:00:02','752','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11582,2036,'2020-01-26 23:00:01','-14','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11583,2063,'2020-01-26 19:00:02','-9','/objects/?object=ClockChime&op=m&m=onNewHour'),(11584,2063,'2020-01-26 21:00:07','-9','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11585,2117,'2020-01-26 19:00:02','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11586,2117,'2020-01-26 21:00:07','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11587,2169,'2020-01-26 19:00:03','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11588,2169,'2020-01-26 21:00:08','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11589,1605,'2020-01-26 21:00:01','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11590,1611,'2020-01-26 21:00:01','95','/objects/?object=ClockChime&op=m&m=onNewHour'),(11591,1613,'2020-01-26 21:00:01','749','/objects/?object=ClockChime&op=m&m=onNewHour'),(11592,2009,'2020-01-26 21:00:02','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11593,2021,'2020-01-26 21:00:02','95','/objects/?object=ClockChime&op=m&m=onNewHour'),(11594,2023,'2020-01-26 21:00:02','749','/objects/?object=ClockChime&op=m&m=onNewHour'),(11595,1605,'2020-01-27 01:00:01','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11596,1611,'2020-01-26 21:00:03','95','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11597,1613,'2020-01-27 01:00:01','749','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11598,2009,'2020-01-26 23:00:01','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11599,2021,'2020-01-26 23:00:01','95','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11600,2023,'2020-01-26 23:00:01','749','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11601,1611,'2020-01-26 23:00:00','96','/objects/?object=ClockChime&op=m&m=onNewHour'),(11602,1611,'2020-01-27 01:00:01','96','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11603,2047,'2020-01-26 23:00:01','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11604,2048,'2020-01-26 23:00:01','88','/objects/?object=ClockChime&op=m&m=onNewHour'),(11605,2063,'2020-01-26 23:00:01','-10','/objects/?object=ClockChime&op=m&m=onNewHour'),(11606,2047,'2020-01-27 03:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11607,2048,'2020-01-26 23:00:01','88','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11608,2074,'2020-01-26 23:00:01','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11609,2075,'2020-01-26 23:00:01','83','/objects/?object=ClockChime&op=m&m=onNewHour'),(11610,2077,'2020-01-26 23:00:01','764','/objects/?object=ClockChime&op=m&m=onNewHour'),(11611,2063,'2020-01-26 23:00:01','-10','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11612,2074,'2020-01-26 23:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11613,2090,'2020-01-26 23:00:01','-7','/objects/?object=ClockChime&op=m&m=onNewHour'),(11614,2075,'2020-01-26 23:00:01','83','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11615,2077,'2020-01-26 23:00:01','764','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11616,2102,'2020-01-26 23:00:01','91','/objects/?object=ClockChime&op=m&m=onNewHour'),(11617,2104,'2020-01-26 23:00:01','760','/objects/?object=ClockChime&op=m&m=onNewHour'),(11618,2090,'2020-01-26 23:00:01','-7','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11619,2117,'2020-01-26 23:00:01','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11620,2102,'2020-01-27 03:00:02','91','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11621,2104,'2020-01-26 23:00:01','760','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11622,2128,'2020-01-26 23:00:01','5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11623,2382,'2020-01-26 23:00:01','91','/objects/?object=ClockChime&op=m&m=onNewHour'),(11624,2117,'2020-01-26 23:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11625,2128,'2020-01-26 23:00:02','5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11626,2382,'2020-01-26 23:00:02','91','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11627,2143,'2020-01-26 23:00:02','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11628,2383,'2020-01-26 23:00:02','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11629,2143,'2020-01-26 23:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11630,2383,'2020-01-26 23:00:02','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11631,2169,'2020-01-26 23:00:02','-7','/objects/?object=ClockChime&op=m&m=onNewHour'),(11632,2384,'2020-01-26 23:00:02','94','/objects/?object=ClockChime&op=m&m=onNewHour'),(11633,2169,'2020-01-26 23:00:02','-7','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11634,2182,'2020-01-26 23:00:02','758','/objects/?object=ClockChime&op=m&m=onNewHour'),(11635,2384,'2020-01-27 03:00:03','94','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11636,2182,'2020-01-26 23:00:02','758','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11644,2023,'2020-01-27 13:00:03','761','/objects/?object=ClockChime&op=m&m=onNewHour'),(11647,2048,'2020-01-27 01:00:01','83','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11648,2050,'2020-01-27 01:00:01','764','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11649,2048,'2020-01-27 09:00:06','83','/objects/?object=ClockChime&op=m&m=onNewHour'),(11650,2050,'2020-01-27 23:00:01','764','/objects/?object=ClockChime&op=m&m=onNewHour'),(11652,2063,'2020-01-27 03:00:02','-5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11653,2074,'2020-01-27 01:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11654,2075,'2020-01-27 01:00:01','91','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11655,2077,'2020-01-27 01:00:01','760','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11656,2074,'2020-01-27 23:00:02','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11657,2075,'2020-01-27 03:00:02','91','/objects/?object=ClockChime&op=m&m=onNewHour'),(11658,2077,'2020-01-27 03:00:02','760','/objects/?object=ClockChime&op=m&m=onNewHour'),(11659,2090,'2020-01-27 01:00:01','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11660,2090,'2020-01-27 03:00:02','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11661,2101,'2020-01-27 01:00:01','5','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11662,2104,'2020-01-27 01:00:01','755','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11663,2101,'2020-01-27 03:00:02','5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11664,2104,'2020-01-27 03:00:03','755','/objects/?object=ClockChime&op=m&m=onNewHour'),(11666,2117,'2020-01-27 03:00:03','-7','/objects/?object=ClockChime&op=m&m=onNewHour'),(11667,2128,'2020-01-27 01:00:02','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11668,2382,'2020-01-27 01:00:02','92','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11669,2130,'2020-01-27 01:00:02','754','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11670,2128,'2020-01-27 03:00:03','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11671,2382,'2020-01-27 03:00:03','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11672,2130,'2020-01-27 09:00:07','754','/objects/?object=ClockChime&op=m&m=onNewHour'),(11673,2143,'2020-01-27 01:00:02','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11674,2143,'2020-01-27 03:00:03','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11675,2154,'2020-01-27 01:00:02','2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11676,2383,'2020-01-27 01:00:02','94','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11677,2156,'2020-01-27 01:00:02','758','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11678,2154,'2020-01-27 09:00:07','2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11679,2383,'2020-01-27 03:00:03','94','/objects/?object=ClockChime&op=m&m=onNewHour'),(11680,2156,'2020-01-27 09:00:07','758','/objects/?object=ClockChime&op=m&m=onNewHour'),(11683,2180,'2020-01-27 01:00:02','7','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11684,2182,'2020-01-27 01:00:02','751','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11685,2180,'2020-01-27 03:00:03','7','/objects/?object=ClockChime&op=m&m=onNewHour'),(11686,2182,'2020-01-27 03:00:03','751','/objects/?object=ClockChime&op=m&m=onNewHour'),(11693,1611,'2020-01-27 03:00:01','89','/objects/?object=ClockChime&op=m&m=onNewHour'),(11694,1613,'2020-01-27 03:00:01','752','/objects/?object=ClockChime&op=m&m=onNewHour'),(11695,1605,'2020-01-27 05:00:01','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11696,1605,'2020-01-27 07:00:01','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11697,1610,'2020-01-27 05:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11698,1611,'2020-01-27 05:00:01','90','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11699,1610,'2020-01-27 13:00:02','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11700,1613,'2020-01-27 05:00:01','756','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11701,1611,'2020-01-27 07:00:01','90','/objects/?object=ClockChime&op=m&m=onNewHour'),(11702,1613,'2020-01-27 07:00:01','756','/objects/?object=ClockChime&op=m&m=onNewHour'),(11704,2009,'2020-01-27 07:00:01','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11705,2036,'2020-01-27 05:00:02','-14','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11706,2036,'2020-01-27 11:00:03','-14','/objects/?object=ClockChime&op=m&m=onNewHour'),(11708,2047,'2020-01-27 21:00:01','5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11709,2063,'2020-01-27 05:00:02','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11710,2063,'2020-01-27 11:00:03','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11713,2075,'2020-01-27 21:00:01','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11714,2077,'2020-01-27 09:00:07','761','/objects/?object=ClockChime&op=m&m=onNewHour'),(11717,2101,'2020-01-27 05:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11722,2104,'2020-01-27 09:00:07','758','/objects/?object=ClockChime&op=m&m=onNewHour'),(11723,2117,'2020-01-27 05:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11724,2117,'2020-01-27 09:00:07','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11728,2382,'2020-01-27 15:00:05','93','/objects/?object=ClockChime&op=m&m=onNewHour'),(11734,2169,'2020-01-27 09:00:07','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11740,2182,'2020-01-27 15:00:06','749','/objects/?object=ClockChime&op=m&m=onNewHour'),(11744,1605,'2020-01-27 09:00:05','-13','/objects/?object=ClockChime&op=m&m=onNewHour'),(11745,1611,'2020-01-27 09:00:05','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11746,1613,'2020-01-27 09:00:05','759','/objects/?object=ClockChime&op=m&m=onNewHour'),(11748,2009,'2020-01-27 09:00:06','-13','/objects/?object=ClockChime&op=m&m=onNewHour'),(11749,1605,'2020-01-27 11:00:01','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11750,1605,'2020-01-27 15:00:02','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11751,1611,'2020-01-27 11:00:01','88','/objects/?object=ClockChime&op=m&m=onNewHour'),(11752,1613,'2020-01-27 11:00:01','761','/objects/?object=ClockChime&op=m&m=onNewHour'),(11753,1611,'2020-01-27 13:00:02','88','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11754,1613,'2020-01-27 13:00:02','761','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11755,2009,'2020-01-27 11:00:01','-12','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11758,2077,'2020-01-27 11:00:03','760','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11759,2090,'2020-01-27 11:00:03','-6','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11760,2104,'2020-01-27 11:00:03','757','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11761,2048,'2020-01-27 21:00:01','82','/objects/?object=ClockChime&op=m&m=onNewHour'),(11763,2128,'2020-01-27 11:00:03','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11767,2090,'2020-01-27 11:00:03','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11771,2169,'2020-01-27 11:00:03','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11772,2117,'2020-01-27 11:00:03','-6','/objects/?object=ClockChime&op=m&m=onNewHour'),(11775,2128,'2020-01-27 23:00:02','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11776,2130,'2020-01-27 21:00:02','752','/objects/?object=ClockChime&op=m&m=onNewHour'),(11777,2143,'2020-01-27 11:00:03','-9','/objects/?object=ClockChime&op=m&m=onNewHour'),(11778,2154,'2020-01-27 15:00:06','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11779,2156,'2020-01-27 23:00:02','754','/objects/?object=ClockChime&op=m&m=onNewHour'),(11780,2169,'2020-01-27 11:00:04','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11781,2180,'2020-01-27 15:00:06','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11782,2384,'2020-01-27 21:00:02','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11783,2009,'2020-01-27 13:00:02','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11786,2090,'2020-01-27 13:00:02','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11787,2117,'2020-01-27 13:00:02','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11788,2143,'2020-01-27 13:00:02','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11789,2169,'2020-01-27 13:00:02','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11790,2009,'2020-01-27 17:00:00','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11791,2036,'2020-01-27 15:00:05','-10','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11792,2063,'2020-01-27 17:00:01','-8','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11793,2090,'2020-01-27 15:00:05','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11794,2117,'2020-01-27 17:00:01','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11795,2143,'2020-01-27 15:00:06','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11796,2169,'2020-01-27 15:00:06','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11800,1610,'2020-01-27 15:00:03','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11801,1611,'2020-01-27 15:00:03','89','/objects/?object=ClockChime&op=m&m=onNewHour'),(11802,1613,'2020-01-27 15:00:03','763','/objects/?object=ClockChime&op=m&m=onNewHour'),(11803,2020,'2020-01-27 15:00:03','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11806,2020,'2020-01-27 15:00:05','3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11807,2021,'2020-01-27 17:00:01','89','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11808,2023,'2020-01-27 17:00:01','763','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11809,2605,'2020-01-27 15:14:24','23','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11810,2606,'2020-01-27 15:14:45','22','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11811,2606,'2020-01-27 15:15:12','22','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11812,2607,'2020-01-27 15:15:49','20','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11813,2608,'2020-01-27 15:16:19','24','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11814,2609,'2020-01-27 15:16:44','21','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11815,2610,'2020-01-27 15:17:03','23','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11816,2611,'2020-01-27 15:17:24','22','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(11817,2615,'2020-01-27 15:30:52',' 15:30','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11818,2630,'2020-01-27 15:30:52','-1','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11819,2632,'2020-01-27 15:30:52','-1','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11820,2637,'2020-01-27 15:30:52','overcast','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11821,2638,'2020-01-27 15:30:52','overcast','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11822,2644,'2020-01-27 15:30:53','1.8','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11823,2645,'2020-01-27 15:30:53','1.8','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11824,2646,'2020-01-27 15:30:53','ne','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11825,2647,'2020-01-27 15:30:53','ne','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11826,2648,'2020-01-27 15:30:53','747','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11827,2649,'2020-01-27 15:30:53','747','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11828,2650,'2020-01-27 15:30:53','76','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11829,2651,'2020-01-27 15:30:53','76','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11830,2652,'2020-01-27 15:30:53','0','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11831,2653,'2020-01-27 15:30:53','0','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11832,2654,'2020-01-27 15:30:53','0','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11833,2655,'2020-01-27 15:30:53','0','/admin.php?pd=eWFuZGV4d2VhdGhlcjp7aW5zdGFuY2U9YWRtfQ%3D%3Dpz_cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11834,2615,'2020-01-27 15:31:27',' 15:31',''),(11835,2630,'2020-01-27 15:31:28','-1',''),(11836,2632,'2020-01-27 15:31:28','-1',''),(11837,2637,'2020-01-27 15:31:28','overcast',''),(11838,2638,'2020-01-27 15:33:03','overcast',''),(11839,2644,'2020-01-27 15:31:28','1.8',''),(11840,2645,'2020-01-27 15:31:28','1.8',''),(11841,2646,'2020-01-27 15:31:28','ne',''),(11842,2647,'2020-01-27 15:31:28','ne',''),(11843,2648,'2020-01-27 15:31:28','747',''),(11844,2649,'2020-01-27 15:31:28','747',''),(11845,2650,'2020-01-27 15:31:28','76',''),(11846,2651,'2020-01-27 15:33:03','76',''),(11847,2652,'2020-01-27 15:31:28','0',''),(11848,2653,'2020-01-28 19:49:33','0',''),(11849,2654,'2020-01-27 15:31:28','0',''),(11850,2655,'2020-01-27 15:31:28','0',''),(11851,2760,'2020-01-27 15:33:02',' 15:33','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11852,2770,'2020-01-27 15:33:03','-12','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11853,2632,'2020-01-27 15:33:03','-12','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11854,2772,'2020-01-27 15:33:03','overcast','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11855,2773,'2020-01-27 15:33:03','2.8','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11856,2645,'2020-01-27 15:33:03','2.8','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11857,2774,'2020-01-27 15:33:03','n','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11858,2647,'2020-01-27 15:33:03','n','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11859,2775,'2020-01-27 15:33:03','750','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11860,2649,'2020-01-27 15:33:03','750','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11861,2776,'2020-01-27 15:33:03','76','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11862,2777,'2020-01-27 15:33:03','0','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11863,2778,'2020-01-27 15:33:03','-1','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11864,2655,'2020-01-27 15:33:03','-1','/admin.php?pd=cGFuZWw6e2FjdGlvbj15YW5kZXh3ZWF0aGVyfQ%3D%3Dpz_&md=yandexweather&inst=adm&data_source=&view_mode=get&tab=&part_load=1'),(11865,2760,'2020-01-27 16:01:28',' 16:01',''),(11866,2770,'2020-01-27 16:31:30','-12',''),(11867,2632,'2020-01-27 16:31:30','-12',''),(11868,2772,'2020-01-27 16:01:29','clear',''),(11869,2638,'2020-01-27 16:01:29','clear',''),(11870,2773,'2020-01-27 16:01:29','4',''),(11871,2645,'2020-01-27 16:01:29','4',''),(11872,2774,'2020-01-27 16:01:29','nw',''),(11873,2647,'2020-01-27 16:01:29','nw',''),(11874,2775,'2020-01-27 17:01:31','750',''),(11875,2649,'2020-01-27 17:01:31','750',''),(11876,2776,'2020-01-27 16:01:29','74',''),(11877,2651,'2020-01-27 16:01:29','74',''),(11878,2777,'2020-01-28 19:49:33','0',''),(11879,2778,'2020-01-27 21:19:11','-1',''),(11880,2655,'2020-01-27 21:19:11','-1',''),(11881,2760,'2020-01-27 16:31:30',' 16:31',''),(11882,2772,'2020-01-27 16:31:30','clear',''),(11883,2638,'2020-01-27 16:31:30','clear',''),(11884,2773,'2020-01-27 16:31:30','4',''),(11885,2645,'2020-01-27 16:31:30','4',''),(11886,2774,'2020-01-27 16:31:30','nw',''),(11887,2647,'2020-01-27 16:31:30','nw',''),(11888,2776,'2020-01-27 16:31:30','74',''),(11889,2651,'2020-01-27 16:31:30','74',''),(11891,1610,'2020-01-27 17:00:00','2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11892,1611,'2020-01-27 17:00:00','95','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11893,1605,'2020-01-27 19:00:04','-14','/objects/?object=ClockChime&op=m&m=onNewHour'),(11894,1613,'2020-01-27 17:00:00','764','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11895,1610,'2020-01-28 03:00:01','2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11896,1611,'2020-01-27 19:00:04','95','/objects/?object=ClockChime&op=m&m=onNewHour'),(11897,1613,'2020-01-27 19:00:04','764','/objects/?object=ClockChime&op=m&m=onNewHour'),(11898,2020,'2020-01-27 17:00:01','4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11899,2020,'2020-01-27 17:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11900,2036,'2020-01-27 17:00:01','-11','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11901,2036,'2020-01-27 17:00:01','-11','/objects/?object=ClockChime&op=m&m=onNewHour'),(11903,2090,'2020-01-27 17:00:01','-5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11905,2101,'2020-01-27 21:00:01','3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11907,2382,'2020-01-27 21:00:02','95','/objects/?object=ClockChime&op=m&m=onNewHour'),(11909,2143,'2020-01-27 17:00:02','-7','/objects/?object=ClockChime&op=m&m=onNewHour'),(11911,2154,'2020-01-27 21:00:02','1','/objects/?object=ClockChime&op=m&m=onNewHour'),(11913,2383,'2020-01-27 21:00:02','92','/objects/?object=ClockChime&op=m&m=onNewHour'),(11915,2169,'2020-01-27 17:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11917,2180,'2020-01-28 03:00:02','5','/objects/?object=ClockChime&op=m&m=onNewHour'),(11919,2182,'2020-01-27 21:00:02','751','/objects/?object=ClockChime&op=m&m=onNewHour'),(11920,2760,'2020-01-27 17:01:31',' 17:01',''),(11921,2770,'2020-01-27 17:01:31','-13',''),(11922,2632,'2020-01-27 17:01:31','-13',''),(11923,2772,'2020-01-27 17:01:31','overcast',''),(11924,2638,'2020-01-27 17:01:31','overcast',''),(11925,2773,'2020-01-27 17:01:31','2.9',''),(11926,2645,'2020-01-27 17:01:31','2.9',''),(11927,2774,'2020-01-27 17:01:31','n',''),(11928,2647,'2020-01-27 17:01:31','n',''),(11929,2776,'2020-01-27 17:01:31','80',''),(11930,2651,'2020-01-27 17:01:31','80',''),(11931,2760,'2020-01-27 17:31:32',' 17:31',''),(11932,2770,'2020-01-27 17:31:32','-13',''),(11933,2632,'2020-01-27 17:31:33','-13',''),(11934,2772,'2020-01-27 17:31:33','overcast',''),(11935,2638,'2020-01-27 17:31:33','overcast',''),(11936,2773,'2020-01-27 17:31:33','2.1',''),(11937,2645,'2020-01-27 17:31:33','2.1',''),(11938,2774,'2020-01-27 17:31:33','n',''),(11939,2647,'2020-01-27 17:31:33','n',''),(11940,2775,'2020-01-27 17:31:33','751',''),(11941,2649,'2020-01-27 17:31:33','751',''),(11942,2776,'2020-01-27 17:31:33','81',''),(11943,2651,'2020-01-27 17:31:33','81',''),(11944,2760,'2020-01-27 18:01:33',' 18:01',''),(11945,2770,'2020-01-27 18:01:34','-14',''),(11946,2632,'2020-01-27 18:01:34','-14',''),(11947,2772,'2020-01-27 18:01:34','clear',''),(11948,2638,'2020-01-27 18:01:34','clear',''),(11949,2773,'2020-01-27 18:01:34','1.3',''),(11950,2645,'2020-01-27 18:01:34','1.3',''),(11951,2774,'2020-01-27 18:01:34','nw',''),(11952,2647,'2020-01-27 18:01:34','nw',''),(11953,2775,'2020-01-27 18:01:34','752',''),(11954,2649,'2020-01-27 18:01:34','752',''),(11955,2776,'2020-01-27 18:01:34','81',''),(11956,2651,'2020-01-27 18:01:34','81',''),(11957,2760,'2020-01-27 18:31:33',' 18:31',''),(11958,2770,'2020-01-27 18:31:34','-14',''),(11959,2632,'2020-01-27 18:31:34','-14',''),(11960,2772,'2020-01-27 18:31:34','clear',''),(11961,2638,'2020-01-27 18:31:34','clear',''),(11962,2773,'2020-01-27 18:31:34','1.4',''),(11963,2645,'2020-01-27 18:31:34','1.4',''),(11964,2774,'2020-01-27 20:31:39','nw',''),(11965,2647,'2020-01-27 20:31:39','nw',''),(11966,2775,'2020-01-27 18:31:34','752',''),(11967,2649,'2020-01-27 18:31:34','752',''),(11968,2776,'2020-01-27 18:31:34','82',''),(11969,2651,'2020-01-27 18:31:34','82',''),(11971,2020,'2020-01-27 19:00:02','2','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11972,2021,'2020-01-27 19:00:02','95','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11973,2023,'2020-01-27 19:00:02','764','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11976,2090,'2020-01-27 19:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11978,2143,'2020-01-27 19:00:03','-9','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11979,2169,'2020-01-27 19:00:03','-3','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(11980,2009,'2020-01-27 19:00:05','-14','/objects/?object=ClockChime&op=m&m=onNewHour'),(11981,2020,'2020-01-27 23:00:01','2','/objects/?object=ClockChime&op=m&m=onNewHour'),(11982,2021,'2020-01-27 19:00:05','95','/objects/?object=ClockChime&op=m&m=onNewHour'),(11983,2023,'2020-01-27 19:00:05','764','/objects/?object=ClockChime&op=m&m=onNewHour'),(11984,2036,'2020-01-27 23:00:01','-10','/objects/?object=ClockChime&op=m&m=onNewHour'),(11985,2063,'2020-01-27 21:00:01','-10','/objects/?object=ClockChime&op=m&m=onNewHour'),(11986,2090,'2020-01-27 23:00:02','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11987,2117,'2020-01-27 21:00:01','-4','/objects/?object=ClockChime&op=m&m=onNewHour'),(11988,2143,'2020-01-27 21:00:02','-9','/objects/?object=ClockChime&op=m&m=onNewHour'),(11989,2169,'2020-01-27 21:00:02','-3','/objects/?object=ClockChime&op=m&m=onNewHour'),(11990,2760,'2020-01-27 19:01:34',' 19:01',''),(11991,2770,'2020-01-27 19:01:35','-15',''),(11992,2632,'2020-01-27 19:01:35','-15',''),(11993,2772,'2020-01-27 19:01:35','partly-cloudy',''),(11994,2638,'2020-01-27 19:01:35','partly-cloudy',''),(11995,2773,'2020-01-27 19:01:35','3',''),(11996,2645,'2020-01-27 19:01:35','3',''),(11997,2775,'2020-01-27 19:01:35','751',''),(11998,2649,'2020-01-27 19:01:35','751',''),(11999,2776,'2020-01-27 19:01:35','81',''),(12000,2651,'2020-01-27 19:01:35','81',''),(12001,2760,'2020-01-27 19:31:36',' 19:31',''),(12002,2770,'2020-01-27 20:31:38','-15',''),(12003,2632,'2020-01-27 20:31:38','-15',''),(12004,2772,'2020-01-27 19:31:36','partly-cloudy',''),(12005,2638,'2020-01-27 19:31:36','partly-cloudy',''),(12006,2773,'2020-01-27 19:31:36','3',''),(12007,2645,'2020-01-27 19:31:36','3',''),(12008,2775,'2020-01-27 20:01:37','751',''),(12009,2649,'2020-01-27 20:01:37','751',''),(12010,2776,'2020-01-27 19:31:37','81',''),(12011,2651,'2020-01-27 19:31:37','81',''),(12012,2760,'2020-01-27 20:01:37',' 20:01',''),(12013,2772,'2020-01-27 20:01:37','clear',''),(12014,2638,'2020-01-27 20:01:37','clear',''),(12015,2773,'2020-01-27 20:01:37','1.5',''),(12016,2645,'2020-01-27 20:01:37','1.5',''),(12017,2776,'2020-01-27 20:01:37','84',''),(12018,2651,'2020-01-27 20:01:37','84',''),(12019,2760,'2020-01-27 20:31:38',' 20:31',''),(12020,2772,'2020-01-27 21:19:11','clear',''),(12021,2638,'2020-01-27 21:19:11','clear',''),(12022,2773,'2020-01-27 20:31:39','1.5',''),(12023,2645,'2020-01-27 20:31:39','1.5',''),(12024,2775,'2020-01-27 20:31:39','752',''),(12025,2649,'2020-01-27 20:31:39','752',''),(12026,2776,'2020-01-27 20:31:39','84',''),(12027,2651,'2020-01-27 20:31:39','84',''),(12028,1605,'2020-01-27 21:00:00','-15','/objects/?object=ClockChime&op=m&m=onNewHour'),(12031,1605,'2020-01-27 21:00:00','-15','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12032,1611,'2020-01-27 21:00:00','94','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12033,1613,'2020-01-27 21:00:00','765','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12034,2009,'2020-01-27 21:00:01','-15','/objects/?object=ClockChime&op=m&m=onNewHour'),(12035,2009,'2020-01-27 23:00:01','-15','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12037,2021,'2020-01-27 23:00:01','94','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12039,2023,'2020-01-27 23:00:01','765','/objects/?processSubscriptions=1&event=HOURLY&params=%5B%5D'),(12040,2760,'2020-01-27 21:01:39',' 21:01',''),(12041,2770,'2020-01-27 21:01:40','-16',''),(12042,2632,'2020-01-27 21:01:40','-16',''),(12043,2773,'2020-01-27 21:01:40','1.4',''),(12044,2645,'2020-01-27 21:01:40','1.4',''),(12045,2774,'2020-01-27 21:01:40','n',''),(12046,2647,'2020-01-27 21:01:40','n',''),(12047,2775,'2020-01-27 21:01:40','753',''),(12048,2649,'2020-01-27 21:01:40','753',''),(12049,2776,'2020-01-27 21:01:40','83',''),(12050,2651,'2020-01-27 21:01:40','83',''),(12051,2760,'2020-01-27 21:19:10',' 21:18',''),(12052,2770,'2020-01-27 21:19:11','-16',''),(12053,2632,'2020-01-27 21:19:11','-16',''),(12054,2773,'2020-01-27 21:19:11','1.5',''),(12055,2645,'2020-01-27 21:19:11','1.5',''),(12056,2774,'2020-01-27 22:19:13','n',''),(12057,2647,'2020-01-27 22:19:13','n',''),(12058,2775,'2020-01-27 23:19:11','753',''),(12059,2649,'2020-01-27 23:19:11','753',''),(12060,2776,'2020-01-27 21:19:11','84',''),(12061,2651,'2020-01-27 21:19:11','84',''),(12062,2760,'2020-01-27 22:49:09',' 21:18',''),(12063,2770,'2020-01-27 21:49:12','-17',''),(12064,2632,'2020-01-27 21:49:12','-17',''),(12065,2772,'2020-01-27 21:49:12','overcast',''),(12066,2638,'2020-01-27 21:49:12','overcast',''),(12067,2773,'2020-01-27 21:49:12','1',''),(12068,2645,'2020-01-27 21:49:12','1',''),(12069,2776,'2020-01-27 21:49:12','80',''),(12070,2651,'2020-01-27 21:49:12','80',''),(12071,2778,'2020-01-27 21:49:14','-2',''),(12072,2655,'2020-01-27 21:49:14','-2',''),(12073,2770,'2020-01-27 22:49:10','-17',''),(12074,2632,'2020-01-27 22:49:10','-17',''),(12075,2772,'2020-01-27 22:19:13','overcast',''),(12076,2638,'2020-01-27 22:19:13','overcast',''),(12077,2773,'2020-01-27 22:19:13','1',''),(12078,2645,'2020-01-27 22:19:13','1',''),(12079,2776,'2020-01-27 22:19:13','80',''),(12080,2651,'2020-01-27 22:19:13','80',''),(12081,2778,'2020-01-28 09:19:12','-2',''),(12082,2655,'2020-01-28 09:19:12','-2',''),(12083,2772,'2020-01-27 22:49:10','clear',''),(12084,2638,'2020-01-27 22:49:10','clear',''),(12085,2773,'2020-01-27 22:49:10','1.7',''),(12086,2645,'2020-01-27 22:49:10','1.7',''),(12087,2774,'2020-01-27 22:49:10','ne',''),(12088,2647,'2020-01-27 22:49:10','ne',''),(12089,2776,'2020-01-27 22:49:10','85',''),(12090,2651,'2020-01-27 22:49:10','85',''),(12091,1605,'2020-01-27 23:00:01','-14','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12092,1611,'2020-01-27 23:00:01','92','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12093,1613,'2020-01-27 23:00:01','766','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12094,2047,'2020-01-27 23:00:01','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12095,2048,'2020-01-27 23:00:01','83','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12096,2063,'2020-01-27 23:00:01','-9','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12097,2075,'2020-01-27 23:00:02','91','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12098,2101,'2020-01-27 23:00:02','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12099,2104,'2020-01-27 23:00:02','758','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12100,2117,'2020-01-27 23:00:02','-3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12101,2382,'2020-01-27 23:00:02','90','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12102,2130,'2020-01-27 23:00:02','755','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12103,2143,'2020-01-27 23:00:02','-4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12104,2154,'2020-01-27 23:00:02','2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12105,2383,'2020-01-27 23:00:02','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12106,2169,'2020-01-27 23:00:02','-2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12107,2384,'2020-01-27 23:00:02','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12108,2182,'2020-01-27 23:00:02','748','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12109,2760,'2020-01-27 23:19:10',' 23:19',''),(12110,2770,'2020-01-27 23:19:10','-18',''),(12111,2632,'2020-01-27 23:19:11','-18',''),(12112,2772,'2020-01-28 00:19:13','clear',''),(12113,2638,'2020-01-28 00:19:13','clear',''),(12114,2773,'2020-01-27 23:49:11','1.7',''),(12115,2645,'2020-01-27 23:49:11','1.7',''),(12116,2774,'2020-01-27 23:19:11','ne',''),(12117,2647,'2020-01-27 23:19:11','ne',''),(12118,2776,'2020-01-27 23:19:11','84',''),(12119,2651,'2020-01-27 23:19:11','84',''),(12120,2760,'2020-01-27 23:49:10',' 23:49',''),(12121,2770,'2020-01-27 23:49:11','-19',''),(12122,2632,'2020-01-27 23:49:11','-19',''),(12123,2774,'2020-01-27 23:49:11','e',''),(12124,2647,'2020-01-27 23:49:11','e',''),(12125,2775,'2020-01-27 23:49:11','754',''),(12126,2649,'2020-01-27 23:49:11','754',''),(12127,2776,'2020-01-27 23:49:11','83',''),(12128,2651,'2020-01-27 23:49:11','83',''),(12129,1392,'2020-01-28 00:14:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12130,1393,'2020-01-28 00:14:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12131,1394,'2020-01-28 00:14:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12132,1395,'2020-01-28 00:14:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12133,1396,'2020-01-28 00:14:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12134,1397,'2020-01-28 00:14:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12135,1398,'2020-01-28 00:14:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12136,1399,'2020-01-28 00:14:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12137,1400,'2020-01-28 00:14:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12138,1401,'2020-01-28 00:14:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12139,1392,'2020-01-28 00:15:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12140,1393,'2020-01-28 00:15:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12141,1394,'2020-01-28 01:33:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12142,1395,'2020-01-28 19:11:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12143,1396,'2020-01-28 19:40:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12144,1397,'2020-01-28 20:15:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12145,1398,'2020-01-28 20:15:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12146,1399,'2020-01-28 20:15:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12147,1400,'2020-01-28 20:15:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12148,1401,'2020-01-28 20:15:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12149,1392,'2020-01-28 00:16:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12150,1393,'2020-01-28 00:16:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12151,1392,'2020-01-28 00:41:01','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12152,1393,'2020-01-28 01:02:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12153,2760,'2020-01-28 00:19:12',' 00:19',''),(12154,2770,'2020-01-28 03:18:58','-19',''),(12155,2632,'2020-01-28 03:18:58','-19',''),(12156,2773,'2020-01-28 00:19:13','1.8',''),(12157,2645,'2020-01-28 00:19:13','1.8',''),(12158,2774,'2020-01-28 00:19:13','e',''),(12159,2647,'2020-01-28 00:19:13','e',''),(12160,2775,'2020-01-28 00:19:13','754',''),(12161,2649,'2020-01-28 00:19:13','754',''),(12162,2776,'2020-01-28 00:19:13','82',''),(12163,2651,'2020-01-28 00:19:13','82',''),(12164,1392,'2020-01-28 00:42:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12165,1392,'2020-01-28 01:38:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12166,2760,'2020-01-28 00:48:53',' 00:48',''),(12167,2772,'2020-01-28 00:48:53','partly-cloudy',''),(12168,2638,'2020-01-28 00:48:54','partly-cloudy',''),(12169,2773,'2020-01-28 00:48:54','0',''),(12170,2645,'2020-01-28 00:48:54','0',''),(12171,2774,'2020-01-28 00:48:54','n',''),(12172,2647,'2020-01-28 00:48:54','n',''),(12173,2775,'2020-01-28 00:48:54','753',''),(12174,2649,'2020-01-28 00:48:54','753',''),(12175,2776,'2020-01-28 00:48:54','73',''),(12176,2651,'2020-01-28 00:48:54','73',''),(12177,1605,'2020-01-28 01:00:00','-14','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12178,1611,'2020-01-28 03:00:01','92','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12179,1613,'2020-01-28 03:00:01','766','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12180,2009,'2020-01-28 01:00:01','-11','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12181,2009,'2020-01-28 03:00:01','-11','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12182,2020,'2020-01-28 01:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12183,2021,'2020-01-28 01:00:01','83','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12184,2023,'2020-01-28 01:00:01','764','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12185,2020,'2020-01-28 03:00:01','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12186,2021,'2020-01-28 03:00:01','83','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12187,2023,'2020-01-28 13:00:01','764','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12188,2036,'2020-01-28 01:00:01','-9','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12189,2036,'2020-01-28 03:00:01','-9','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12190,2047,'2020-01-28 01:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12191,2048,'2020-01-28 01:00:01','91','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12192,2047,'2020-01-28 19:00:01','3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12193,2048,'2020-01-28 15:00:04','91','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12194,2050,'2020-01-28 01:00:01','760','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12195,2050,'2020-01-28 09:00:01','760','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12196,2063,'2020-01-28 01:00:01','-4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12197,2063,'2020-01-28 03:00:01','-4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12198,2074,'2020-01-28 01:00:01','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12199,2074,'2020-01-28 19:00:01','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12200,2075,'2020-01-28 01:00:01','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12201,2075,'2020-01-28 03:00:01','93','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12202,2077,'2020-01-28 01:00:01','758','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12203,2077,'2020-01-28 03:00:01','758','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12204,2090,'2020-01-28 01:00:01','-5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12205,2090,'2020-01-28 09:00:01','-5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12206,2101,'2020-01-28 01:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12207,2101,'2020-01-28 03:00:02','3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12208,2102,'2020-01-28 01:00:01','90','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12209,2102,'2020-01-28 03:00:02','90','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12210,2104,'2020-01-28 01:00:01','755','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12211,2104,'2020-01-28 03:00:02','755','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12212,2117,'2020-01-28 01:00:02','-4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12213,2117,'2020-01-28 03:00:02','-4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12214,2128,'2020-01-28 01:00:02','2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12215,2128,'2020-01-28 03:00:02','2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12216,2382,'2020-01-28 01:00:02','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12217,2382,'2020-01-28 03:00:02','93','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12218,2130,'2020-01-28 01:00:02','754','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12219,2130,'2020-01-28 03:00:02','754','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12220,2143,'2020-01-28 01:00:02','-2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12221,2143,'2020-01-28 09:00:02','-2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12222,2154,'2020-01-28 01:00:02','5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12223,2154,'2020-01-28 03:00:02','5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12224,2383,'2020-01-28 03:00:02','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12225,2156,'2020-01-28 01:00:02','748','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12226,2156,'2020-01-28 03:00:02','748','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12227,2169,'2020-01-28 03:00:02','-2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12228,2384,'2020-01-28 01:00:02','97','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12229,2384,'2020-01-28 03:00:02','97','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12230,2182,'2020-01-28 01:00:02','739','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12231,2182,'2020-01-28 03:00:02','739','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12232,1393,'2020-01-28 01:03:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12233,1393,'2020-01-28 01:56:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12234,2760,'2020-01-28 01:18:54',' 01:18',''),(12235,2772,'2020-01-28 01:18:55','cloudy',''),(12236,2638,'2020-01-28 01:18:55','cloudy',''),(12237,2773,'2020-01-28 01:48:56','0',''),(12238,2645,'2020-01-28 01:48:56','0',''),(12239,2774,'2020-01-28 01:48:56','n',''),(12240,2647,'2020-01-28 01:48:56','n',''),(12241,2775,'2020-01-28 02:18:57','753',''),(12242,2649,'2020-01-28 02:18:57','753',''),(12243,2776,'2020-01-28 01:18:55','70',''),(12244,2651,'2020-01-28 01:18:55','70',''),(12245,1394,'2020-01-28 01:34:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12246,1394,'2020-01-28 17:47:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12247,1392,'2020-01-28 01:39:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12248,1392,'2020-01-28 01:40:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12249,1392,'2020-01-28 01:58:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12250,2760,'2020-01-28 01:48:55',' 01:48',''),(12251,2772,'2020-01-28 01:48:56','cloudy',''),(12252,2638,'2020-01-28 01:48:56','cloudy',''),(12253,2776,'2020-01-28 01:48:56','70',''),(12254,2651,'2020-01-28 01:48:56','70',''),(12255,1393,'2020-01-28 01:57:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12256,1393,'2020-01-28 17:47:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12257,1392,'2020-01-28 01:59:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12258,1392,'2020-01-28 17:57:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12259,2760,'2020-01-28 02:18:56',' 02:18',''),(12260,2772,'2020-01-28 02:18:56','clear',''),(12261,2638,'2020-01-28 02:18:56','clear',''),(12262,2773,'2020-01-28 02:18:56','1.9',''),(12263,2645,'2020-01-28 02:18:56','1.9',''),(12264,2774,'2020-01-28 02:18:56','se',''),(12265,2647,'2020-01-28 02:18:56','se',''),(12266,2776,'2020-01-28 02:18:57','84',''),(12267,2651,'2020-01-28 02:18:57','84',''),(12268,2760,'2020-01-28 02:48:57',' 02:48',''),(12269,2772,'2020-01-28 03:18:58','clear',''),(12270,2638,'2020-01-28 03:18:58','clear',''),(12271,2773,'2020-01-28 02:48:57','1.7',''),(12272,2645,'2020-01-28 02:48:58','1.7',''),(12273,2774,'2020-01-28 19:49:33','se',''),(12274,2647,'2020-01-28 19:49:33','se',''),(12275,2775,'2020-01-28 02:48:58','754',''),(12276,2649,'2020-01-28 02:48:58','754',''),(12277,2776,'2020-01-28 02:48:58','83',''),(12278,2651,'2020-01-28 02:48:58','83',''),(12279,1605,'2020-01-28 03:00:01','-15','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12280,1605,'2020-01-28 03:00:01','-15','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12281,2760,'2020-01-28 03:18:57',' 03:18',''),(12282,2773,'2020-01-28 03:18:58','1.7',''),(12283,2645,'2020-01-28 03:18:58','1.7',''),(12284,2775,'2020-01-28 03:18:58','754',''),(12285,2649,'2020-01-28 03:18:58','754',''),(12286,2776,'2020-01-28 03:18:58','83',''),(12287,2651,'2020-01-28 03:18:58','83',''),(12288,2760,'2020-01-28 03:48:59',' 03:48',''),(12289,2770,'2020-01-28 03:48:59','-18',''),(12290,2632,'2020-01-28 03:48:59','-18',''),(12291,2772,'2020-01-28 03:48:59','overcast',''),(12292,2638,'2020-01-28 03:48:59','overcast',''),(12293,2773,'2020-01-28 03:48:59','1',''),(12294,2645,'2020-01-28 03:48:59','1',''),(12295,2775,'2020-01-28 03:48:59','753',''),(12296,2649,'2020-01-28 03:48:59','753',''),(12297,2776,'2020-01-28 03:48:59','74',''),(12298,2651,'2020-01-28 03:48:59','74',''),(12299,2760,'2020-01-28 04:19:00',' 04:18',''),(12300,2770,'2020-01-28 04:49:01','-18',''),(12301,2632,'2020-01-28 04:49:01','-18',''),(12302,2772,'2020-01-28 04:19:00','overcast',''),(12303,2638,'2020-01-28 04:19:00','overcast',''),(12304,2773,'2020-01-28 04:19:00','1',''),(12305,2645,'2020-01-28 04:19:00','1',''),(12306,2775,'2020-01-28 09:19:12','753',''),(12307,2649,'2020-01-28 09:19:12','753',''),(12308,2776,'2020-01-28 04:19:00','74',''),(12309,2651,'2020-01-28 04:19:00','74',''),(12310,2760,'2020-01-28 04:49:01',' 04:49',''),(12311,2772,'2020-01-28 04:49:01','clear',''),(12312,2638,'2020-01-28 04:49:01','clear',''),(12313,2773,'2020-01-28 04:49:01','2',''),(12314,2645,'2020-01-28 04:49:01','2',''),(12315,2776,'2020-01-28 04:49:01','83',''),(12316,2651,'2020-01-28 04:49:01','83',''),(12317,1605,'2020-01-28 05:00:01','-14','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12318,1605,'2020-01-28 09:00:01','-14','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12319,1610,'2020-01-28 05:00:01','3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12320,1610,'2020-01-28 07:00:01','3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12321,1611,'2020-01-28 05:00:01','87','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12322,1611,'2020-01-28 07:00:01','87','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12323,1613,'2020-01-28 05:00:01','765','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12324,1613,'2020-01-28 07:00:01','765','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12325,2009,'2020-01-28 05:00:01','-14','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12326,2009,'2020-01-28 11:00:02','-14','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12327,2020,'2020-01-28 05:00:01','5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12328,2021,'2020-01-28 05:00:01','82','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12329,2020,'2020-01-28 09:00:01','5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12330,2021,'2020-01-28 13:00:01','82','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12331,2036,'2020-01-28 05:00:01','-12','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12332,2036,'2020-01-28 11:00:02','-12','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12333,2063,'2020-01-28 05:00:01','-8','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12334,2063,'2020-01-28 09:00:01','-8','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12335,2075,'2020-01-28 05:00:01','95','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12336,2077,'2020-01-28 05:00:01','759','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12337,2075,'2020-01-28 09:00:01','95','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12338,2077,'2020-01-28 09:00:01','759','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12339,2101,'2020-01-28 05:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12340,2102,'2020-01-28 05:00:02','95','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12341,2104,'2020-01-28 05:00:02','754','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12342,2101,'2020-01-28 15:00:04','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12343,2102,'2020-01-28 09:00:02','95','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12344,2104,'2020-01-28 09:00:02','754','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12345,2117,'2020-01-28 05:00:02','-6','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12346,2117,'2020-01-28 09:00:02','-6','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12347,2128,'2020-01-28 05:00:02','3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12348,2382,'2020-01-28 05:00:02','91','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12349,2130,'2020-01-28 05:00:02','753','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12350,2128,'2020-01-28 09:00:02','3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12351,2382,'2020-01-28 09:00:02','91','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12352,2130,'2020-01-28 09:00:02','753','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12353,2154,'2020-01-28 05:00:02','7','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12354,2383,'2020-01-28 05:00:02','95','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12355,2156,'2020-01-28 05:00:02','746','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12356,2154,'2020-01-28 09:00:02','7','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12357,2383,'2020-01-28 09:00:02','95','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12358,2156,'2020-01-28 09:00:02','746','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12359,2169,'2020-01-28 05:00:02','-0','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12360,2169,'2020-01-28 15:00:04','-0','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12361,2180,'2020-01-28 05:00:02','2','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12362,2384,'2020-01-28 05:00:02','96','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12363,2182,'2020-01-28 05:00:02','743','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12364,2180,'2020-01-28 09:00:02','2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12365,2384,'2020-01-28 15:00:05','96','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12366,2182,'2020-01-28 15:00:05','743','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12367,2760,'2020-01-28 05:19:02',' 05:19',''),(12368,2770,'2020-01-28 05:19:03','-17',''),(12369,2632,'2020-01-28 05:19:03','-17',''),(12370,2772,'2020-01-28 05:19:03','clear',''),(12371,2638,'2020-01-28 05:19:03','clear',''),(12372,2773,'2020-01-28 05:19:03','2.1',''),(12373,2645,'2020-01-28 05:19:03','2.1',''),(12374,2776,'2020-01-28 06:19:04','83',''),(12375,2651,'2020-01-28 06:19:04','83',''),(12376,2760,'2020-01-28 05:49:03',' 05:49',''),(12377,2770,'2020-01-28 05:49:03','-16',''),(12378,2632,'2020-01-28 05:49:04','-16',''),(12379,2772,'2020-01-28 05:49:04','overcast',''),(12380,2638,'2020-01-28 05:49:04','overcast',''),(12381,2773,'2020-01-28 05:49:04','2.2',''),(12382,2645,'2020-01-28 05:49:04','2.2',''),(12383,2760,'2020-01-28 06:19:04',' 06:19',''),(12384,2770,'2020-01-28 08:19:09','-16',''),(12385,2632,'2020-01-28 08:19:09','-16',''),(12386,2772,'2020-01-28 15:49:26','overcast',''),(12387,2638,'2020-01-28 15:49:26','overcast',''),(12388,2773,'2020-01-28 06:19:04','2.4',''),(12389,2645,'2020-01-28 06:19:04','2.4',''),(12390,2760,'2020-01-28 06:49:05',' 06:49',''),(12391,2773,'2020-01-28 06:49:06','1',''),(12392,2645,'2020-01-28 06:49:06','1',''),(12393,2776,'2020-01-28 06:49:06','78',''),(12394,2651,'2020-01-28 06:49:06','78',''),(12395,2760,'2020-01-28 07:19:06',' 07:19',''),(12396,2773,'2020-01-28 07:19:07','1',''),(12397,2645,'2020-01-28 07:19:07','1',''),(12398,2776,'2020-01-28 07:19:07','78',''),(12399,2651,'2020-01-28 07:19:07','78',''),(12400,2760,'2020-01-28 07:49:08',' 07:49',''),(12401,2773,'2020-01-28 07:49:09','2.8',''),(12402,2645,'2020-01-28 07:49:09','2.8',''),(12403,2776,'2020-01-28 07:49:09','83',''),(12404,2651,'2020-01-28 07:49:09','83',''),(12405,2760,'2020-01-28 08:19:09',' 08:19',''),(12406,2773,'2020-01-28 08:19:10','2.8',''),(12407,2645,'2020-01-28 08:19:10','2.8',''),(12408,2776,'2020-01-28 09:19:12','83',''),(12409,2651,'2020-01-28 09:19:12','83',''),(12410,2760,'2020-01-28 08:49:10',' 08:49',''),(12411,2770,'2020-01-28 08:49:11','-15',''),(12412,2632,'2020-01-28 08:49:11','-15',''),(12413,2773,'2020-01-28 08:49:11','2.7',''),(12414,2645,'2020-01-28 08:49:11','2.7',''),(12415,1610,'2020-01-28 09:00:01','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12416,1610,'2020-01-28 15:00:02','4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12417,1611,'2020-01-28 09:00:01','83','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12418,1611,'2020-01-28 09:00:01','83','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12419,1613,'2020-01-28 09:00:01','764','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12420,1613,'2020-01-28 13:00:01','764','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12421,2760,'2020-01-28 09:19:11',' 09:19',''),(12422,2770,'2020-01-28 09:19:11','-15',''),(12423,2632,'2020-01-28 09:19:11','-15',''),(12424,2773,'2020-01-28 09:19:12','2.9',''),(12425,2645,'2020-01-28 09:19:12','2.9',''),(12426,2760,'2020-01-28 09:49:12',' 09:49',''),(12427,2770,'2020-01-28 09:49:12','-14',''),(12428,2632,'2020-01-28 09:49:12','-14',''),(12429,2773,'2020-01-28 09:49:12','2',''),(12430,2645,'2020-01-28 09:49:12','2',''),(12431,2775,'2020-01-28 09:49:12','752',''),(12432,2649,'2020-01-28 09:49:12','752',''),(12433,2776,'2020-01-28 09:49:12','77',''),(12434,2651,'2020-01-28 09:49:12','77',''),(12435,2778,'2020-01-28 09:49:13','-3',''),(12436,2655,'2020-01-28 09:49:13','-3',''),(12437,2760,'2020-01-28 10:19:13',' 10:19',''),(12438,2770,'2020-01-28 11:19:15','-14',''),(12439,2632,'2020-01-28 11:19:15','-14',''),(12440,2773,'2020-01-28 10:19:14','2',''),(12441,2645,'2020-01-28 10:19:14','2',''),(12442,2775,'2020-01-28 13:49:22','752',''),(12443,2649,'2020-01-28 13:49:22','752',''),(12444,2776,'2020-01-28 10:19:14','77',''),(12445,2651,'2020-01-28 10:19:14','77',''),(12446,2778,'2020-01-28 11:19:16','-3',''),(12447,2655,'2020-01-28 11:19:16','-3',''),(12448,2760,'2020-01-28 10:49:14',' 10:49',''),(12449,2773,'2020-01-28 10:49:15','3.5',''),(12450,2645,'2020-01-28 10:49:15','3.5',''),(12451,2776,'2020-01-28 10:49:15','81',''),(12452,2651,'2020-01-28 10:49:15','81',''),(12474,2020,'2020-01-28 15:00:04','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12475,2050,'2020-01-28 15:00:04','759','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12476,2063,'2020-01-28 11:00:03','-6','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12477,2075,'2020-01-28 19:00:01','92','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12478,2077,'2020-01-28 15:00:04','756','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12479,2090,'2020-01-28 15:00:04','-3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12480,2102,'2020-01-28 15:00:04','92','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12481,2104,'2020-01-28 19:00:01','752','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12482,2117,'2020-01-28 11:00:03','-9','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12483,2128,'2020-01-28 15:00:04','2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12484,2382,'2020-01-28 19:00:01','93','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12485,2130,'2020-01-28 19:00:01','752','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12486,2143,'2020-01-28 11:00:03','-1','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12487,2154,'2020-01-28 19:00:02','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12488,2383,'2020-01-28 15:00:04','98','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12489,2156,'2020-01-28 15:00:04','748','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12490,2180,'2020-01-28 15:00:05','3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12491,2760,'2020-01-28 11:19:15',' 11:19',''),(12492,2773,'2020-01-28 11:19:15','3.5',''),(12493,2645,'2020-01-28 11:19:15','3.5',''),(12494,2776,'2020-01-28 12:19:17','81',''),(12495,2651,'2020-01-28 12:19:17','81',''),(12496,2760,'2020-01-28 11:49:15',' 11:49',''),(12497,2770,'2020-01-28 11:49:16','-13',''),(12498,2632,'2020-01-28 11:49:16','-13',''),(12499,2773,'2020-01-28 11:49:16','3.4',''),(12500,2645,'2020-01-28 11:49:16','3.4',''),(12501,2778,'2020-01-28 11:49:16','-2',''),(12502,2655,'2020-01-28 11:49:16','-2',''),(12503,2760,'2020-01-28 12:19:16',' 12:19',''),(12504,2770,'2020-01-28 12:19:17','-13',''),(12505,2632,'2020-01-28 12:19:17','-13',''),(12506,2773,'2020-01-28 12:19:17','3.6',''),(12507,2645,'2020-01-28 12:19:17','3.6',''),(12508,2778,'2020-01-28 19:49:34','-2',''),(12509,2655,'2020-01-28 19:49:34','-2',''),(12510,2760,'2020-01-28 12:49:18',' 12:49',''),(12511,2770,'2020-01-28 12:49:19','-12',''),(12512,2632,'2020-01-28 12:49:19','-12',''),(12513,2773,'2020-01-28 12:49:19','3',''),(12514,2645,'2020-01-28 12:49:19','3',''),(12515,2776,'2020-01-28 12:49:19','80',''),(12516,2651,'2020-01-28 12:49:19','80',''),(12520,2063,'2020-01-28 13:00:01','-4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12521,2036,'2020-01-28 17:00:01','-8','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12522,2063,'2020-01-28 15:00:04','-4','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12523,2117,'2020-01-28 13:00:02','-5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12524,2143,'2020-01-28 13:00:02','1','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12525,2117,'2020-01-28 17:00:02','-5','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12526,2143,'2020-01-28 15:00:04','1','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12527,2760,'2020-01-28 13:19:20',' 13:19',''),(12528,2770,'2020-01-28 13:49:21','-12',''),(12529,2632,'2020-01-28 13:49:21','-12',''),(12530,2773,'2020-01-28 13:19:21','3',''),(12531,2645,'2020-01-28 13:19:21','3',''),(12532,2776,'2020-01-28 13:19:21','78',''),(12533,2651,'2020-01-28 13:19:21','78',''),(12534,2760,'2020-01-28 13:49:21',' 13:49',''),(12535,2773,'2020-01-28 13:49:22','3.9',''),(12536,2645,'2020-01-28 13:49:22','3.9',''),(12537,2776,'2020-01-28 13:49:22','79',''),(12538,2651,'2020-01-28 13:49:22','79',''),(12539,2760,'2020-01-28 14:19:21',' 14:19',''),(12540,2770,'2020-01-28 14:19:22','-11',''),(12541,2632,'2020-01-28 14:19:22','-11',''),(12542,2773,'2020-01-28 14:19:22','3.7',''),(12543,2645,'2020-01-28 14:19:22','3.7',''),(12544,2775,'2020-01-28 14:19:22','751',''),(12545,2649,'2020-01-28 14:19:22','751',''),(12546,2776,'2020-01-28 14:49:23','79',''),(12547,2651,'2020-01-28 14:49:23','79',''),(12548,2760,'2020-01-28 14:49:22',' 14:49',''),(12549,2770,'2020-01-28 14:49:23','-10',''),(12550,2632,'2020-01-28 14:49:23','-10',''),(12551,2773,'2020-01-28 14:49:23','3.4',''),(12552,2645,'2020-01-28 14:49:23','3.4',''),(12553,2775,'2020-01-28 14:49:23','750',''),(12554,2649,'2020-01-28 14:49:23','750',''),(12559,1611,'2020-01-28 15:00:02','84','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12560,1613,'2020-01-28 19:00:01','762','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12561,2009,'2020-01-28 15:00:03','-10','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12565,2021,'2020-01-28 15:00:04','84','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12566,2023,'2020-01-28 15:00:04','762','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12567,2760,'2020-01-28 15:19:24',' 15:19',''),(12568,2770,'2020-01-28 19:49:33','-10',''),(12569,2632,'2020-01-28 19:49:33','-10',''),(12570,2773,'2020-01-28 15:19:24','3.5',''),(12571,2645,'2020-01-28 15:19:24','3.5',''),(12572,2775,'2020-01-28 18:19:30','750',''),(12573,2649,'2020-01-28 18:19:30','750',''),(12574,2776,'2020-01-28 15:19:24','80',''),(12575,2651,'2020-01-28 15:19:24','80',''),(12576,2760,'2020-01-28 15:49:26',' 15:49',''),(12577,2773,'2020-01-28 15:49:26','4',''),(12578,2645,'2020-01-28 15:49:26','4',''),(12579,2776,'2020-01-28 15:49:26','77',''),(12580,2651,'2020-01-28 15:49:26','77',''),(12581,2760,'2020-01-28 16:19:25',' 16:19',''),(12582,2772,'2020-01-28 16:19:26','overcast-and-light-snow',''),(12583,2638,'2020-01-28 16:19:26','overcast-and-light-snow',''),(12584,2773,'2020-01-28 16:19:26','4',''),(12585,2645,'2020-01-28 16:19:26','4',''),(12586,2776,'2020-01-28 16:19:26','75',''),(12587,2651,'2020-01-28 16:19:26','75',''),(12588,2760,'2020-01-28 16:49:26',' 16:49',''),(12589,2772,'2020-01-28 19:19:32','overcast-and-light-snow',''),(12590,2638,'2020-01-28 19:19:32','overcast-and-light-snow',''),(12591,2773,'2020-01-28 16:49:27','3.8',''),(12592,2645,'2020-01-28 16:49:27','3.8',''),(12593,2776,'2020-01-28 16:49:27','82',''),(12594,2651,'2020-01-28 16:49:27','82',''),(12597,1610,'2020-01-28 19:00:00','5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12598,1611,'2020-01-28 19:00:00','90','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12600,2021,'2020-01-28 17:00:01','83','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12601,2023,'2020-01-28 17:00:01','763','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12602,2020,'2020-01-28 19:00:01','5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12603,2021,'2020-01-28 17:00:01','83','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12604,2023,'2020-01-28 17:00:01','763','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12606,2050,'2020-01-28 17:00:01','760','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12608,2048,'2020-01-28 19:00:01','90','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12609,2050,'2020-01-28 19:00:01','760','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12611,2063,'2020-01-28 19:00:01','-5','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12613,2077,'2020-01-28 19:00:01','758','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12616,2090,'2020-01-28 17:00:01','-2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12617,2101,'2020-01-28 19:00:01','3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12618,2102,'2020-01-28 19:00:01','91','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12619,2128,'2020-01-28 17:00:01','0','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12621,2128,'2020-01-28 19:00:01','0','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12624,2143,'2020-01-28 17:00:02','-2','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12627,2156,'2020-01-28 19:00:02','752','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12632,2180,'2020-01-28 19:00:02','4','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12633,2384,'2020-01-28 19:00:02','95','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12634,2182,'2020-01-28 19:00:02','746','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12635,2760,'2020-01-28 17:19:28',' 17:19',''),(12636,2773,'2020-01-28 17:19:29','3.7',''),(12637,2645,'2020-01-28 17:19:29','3.7',''),(12638,2776,'2020-01-28 17:19:29','82',''),(12639,2651,'2020-01-28 17:19:29','82',''),(12640,1393,'2020-01-28 17:48:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12641,1394,'2020-01-28 17:48:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12642,1393,'2020-01-28 19:05:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12643,1394,'2020-01-28 19:06:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12644,2760,'2020-01-28 17:49:29',' 17:49',''),(12645,2773,'2020-01-28 17:49:30','3.6',''),(12646,2645,'2020-01-28 17:49:30','3.6',''),(12647,2776,'2020-01-28 17:49:30','81',''),(12648,2651,'2020-01-28 17:49:30','81',''),(12649,1392,'2020-01-28 17:58:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12650,1392,'2020-01-28 17:59:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12651,1392,'2020-01-28 19:11:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12652,2760,'2020-01-28 18:19:30',' 18:19',''),(12653,2773,'2020-01-28 18:19:30','3.8',''),(12654,2645,'2020-01-28 18:19:30','3.8',''),(12655,2776,'2020-01-28 18:19:30','82',''),(12656,2651,'2020-01-28 18:19:30','82',''),(12657,2760,'2020-01-28 18:49:32',' 18:49',''),(12658,2773,'2020-01-28 18:49:32','4',''),(12659,2645,'2020-01-28 18:49:32','4',''),(12660,2775,'2020-01-28 18:49:32','749',''),(12661,2649,'2020-01-28 18:49:32','749',''),(12662,2776,'2020-01-28 18:49:32','76',''),(12663,2651,'2020-01-28 18:49:32','76',''),(12664,2021,'2020-01-28 19:00:01','90','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12665,2023,'2020-01-28 19:00:01','762','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12667,2021,'2020-01-28 19:00:01','90','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12668,2023,'2020-01-28 19:00:01','762','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12669,2036,'2020-01-28 19:00:01','-10','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12670,2090,'2020-01-28 19:00:01','-3','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12671,2090,'2020-01-28 19:00:01','-3','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12673,2117,'2020-01-28 19:00:01','-8','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12674,2143,'2020-01-28 19:00:01','-1','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(12675,2143,'2020-01-28 19:00:02','-1','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(12676,1393,'2020-01-28 19:06:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12677,1393,'2020-01-28 19:11:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12678,1394,'2020-01-28 19:07:01','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12679,1394,'2020-01-28 19:08:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12680,1394,'2020-01-28 19:10:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12681,1394,'2020-01-28 19:11:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12682,1392,'2020-01-28 19:12:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12683,1393,'2020-01-28 19:12:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12684,1394,'2020-01-28 20:15:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12685,1395,'2020-01-28 19:12:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12686,1392,'2020-01-28 19:58:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12687,1393,'2020-01-28 20:11:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12688,1395,'2020-01-28 20:15:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12689,2760,'2020-01-28 19:19:31',' 19:19',''),(12690,2773,'2020-01-28 19:19:32','4',''),(12691,2645,'2020-01-28 19:19:32','4',''),(12692,2775,'2020-01-28 19:49:33','749',''),(12693,2649,'2020-01-28 19:49:33','749',''),(12694,2776,'2020-01-28 19:19:32','73',''),(12695,2651,'2020-01-28 19:19:32','73',''),(12696,1396,'2020-01-28 19:41:01','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12697,1396,'2020-01-28 20:15:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12698,2760,'2020-01-28 19:49:33',' 19:49',''),(12699,2772,'2020-01-28 19:49:33','overcast',''),(12700,2638,'2020-01-28 19:49:33','overcast',''),(12701,2773,'2020-01-28 19:49:33','4.1',''),(12702,2645,'2020-01-28 19:49:33','4.1',''),(12703,2776,'2020-01-28 19:49:33','83',''),(12704,2651,'2020-01-28 19:49:33','83',''),(12705,1392,'2020-01-28 19:59:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12706,1392,'2020-01-28 20:15:00','1','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12707,1393,'2020-01-28 20:12:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(12708,1393,'2020-01-28 20:15:00','0','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1');
/*!40000 ALTER TABLE `phistory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `phistory_queue`
--

DROP TABLE IF EXISTS `phistory_queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `phistory_queue` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `VALUE_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `VALUE` text NOT NULL,
  `OLD_VALUE` text NOT NULL,
  `KEEP_HISTORY` int(10) unsigned NOT NULL DEFAULT '0',
  `ADDED` datetime DEFAULT NULL,
  `SOURCE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=36105 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `phistory_queue`
--

LOCK TABLES `phistory_queue` WRITE;
/*!40000 ALTER TABLE `phistory_queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `phistory_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pinghosts`
--

DROP TABLE IF EXISTS `pinghosts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pinghosts` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `HOSTNAME` varchar(255) NOT NULL DEFAULT '',
  `TYPE` int(30) NOT NULL DEFAULT '0',
  `STATUS` int(3) NOT NULL DEFAULT '0',
  `SEARCH_WORD` varchar(255) NOT NULL DEFAULT '',
  `CHECK_LATEST` datetime DEFAULT NULL,
  `CHECK_NEXT` datetime DEFAULT NULL,
  `SCRIPT_ID_ONLINE` int(10) NOT NULL DEFAULT '0',
  `CODE_ONLINE` text,
  `SCRIPT_ID_OFFLINE` int(10) NOT NULL DEFAULT '0',
  `CODE_OFFLINE` text,
  `OFFLINE_INTERVAL` int(10) NOT NULL DEFAULT '0',
  `ONLINE_INTERVAL` int(10) NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LOG` text,
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `COUNTER_CURRENT` int(10) NOT NULL DEFAULT '0',
  `COUNTER_REQUIRED` int(10) NOT NULL DEFAULT '0',
  `STATUS_EXPECTED` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pinghosts`
--

LOCK TABLES `pinghosts` WRITE;
/*!40000 ALTER TABLE `pinghosts` DISABLE KEYS */;
INSERT INTO `pinghosts` VALUES (8,'tut.by',0,1,'','2020-01-28 20:12:49','2020-01-28 20:22:49',0,'',0,'',600,600,'Internet','2020-01-27 16:29:01 Host is online\n2020-01-27 16:19:01 Host is offline\n2020-01-26 23:20:30 Host is online\n2020-01-26 23:10:24 Host is offline\n2020-01-26 21:29:19 Host is online\n2020-01-26 21:19:13 Host is offline\n2020-01-26 15:24:55 Host is online\n2020-01-26 15:14:55 Host is offline\n2020-01-25 00:20:02 Host is online\n2020-01-25 00:09:53 Host is offline\n2020-01-24 00:48:17 Host is online\n2020-01-23 23:06:48 Host is offline\n2020-01-22 20:03:18 Host is online\n2020-01-22 19:43:07 Host is offline\n2020-01-22 06:06:22 Host is online\n2020-01-22 05:45:50 Host is offline\n2020-01-21 21:11:16 Host is online\n2020-01-21 21:01:15 Host is offline\n2020-01-20 22:19:55 Host is online\n2020-01-20 22:09:49 Host is offline\n2020-01-20 00:08:53 Host is online\n2020-01-19 23:58:48 Host is offline\n2020-01-19 21:57:38 Host is online\n2020-01-19 21:37:24 Host is offline\n2020-01-19 20:56:46 Host is online\n2020-01-19 20:46:39 Host is offline\n2020-01-19 19:15:53 Host is online\n2020-01-19 19:05:37 Host is offline\n2020-01-19 16:44:11 Host is online\n2020-01-19 16:13:44 Host is offline','','',0,0,1);
/*!40000 ALTER TABLE `pinghosts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plan_components`
--

DROP TABLE IF EXISTS `plan_components`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plan_components` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PLAN_ID` int(10) NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `COMPONENT_NAME` varchar(255) NOT NULL DEFAULT '',
  `REPLACE_NAME` varchar(255) NOT NULL DEFAULT '',
  `ACTION_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `ACTION_METHOD` varchar(255) NOT NULL DEFAULT '',
  `CODE` text,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `MENU_ITEM_ID` int(10) NOT NULL DEFAULT '0',
  `HOMEPAGE_ID` int(10) NOT NULL DEFAULT '0',
  `EXT_URL` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plan_components`
--

LOCK TABLES `plan_components` WRITE;
/*!40000 ALTER TABLE `plan_components` DISABLE KEYS */;
/*!40000 ALTER TABLE `plan_components` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plan_components_data`
--

DROP TABLE IF EXISTS `plan_components_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plan_components_data` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `COMPONENT_ID` int(10) NOT NULL DEFAULT '0',
  `PROPERTY_NAME` varchar(255) NOT NULL DEFAULT '',
  `PROPERTY_VALUE` varchar(255) NOT NULL DEFAULT '',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plan_components_data`
--

LOCK TABLES `plan_components_data` WRITE;
/*!40000 ALTER TABLE `plan_components_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `plan_components_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plan_states`
--

DROP TABLE IF EXISTS `plan_states`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plan_states` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PLAN_ID` int(10) NOT NULL DEFAULT '0',
  `ITEM` varchar(255) NOT NULL DEFAULT '',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CONDITION` int(3) NOT NULL DEFAULT '0',
  `CONDITION_VALUE` varchar(255) NOT NULL DEFAULT '',
  `CONDITION_ADVANCED` text,
  `CSS_CLASS` varchar(255) NOT NULL DEFAULT '',
  `CSS_CLASS_INVERSE` varchar(255) NOT NULL DEFAULT '',
  `ACTION_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `ACTION_METHOD` varchar(255) NOT NULL DEFAULT '',
  `CODE` text,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `MENU_ITEM_ID` int(10) NOT NULL DEFAULT '0',
  `HOMEPAGE_ID` int(10) NOT NULL DEFAULT '0',
  `EXT_URL` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=28 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plan_states`
--

LOCK TABLES `plan_states` WRITE;
/*!40000 ALTER TABLE `plan_states` DISABLE KEYS */;
INSERT INTO `plan_states` VALUES (1,'lam2',3,'lamp2','Switch2','status',1,'1',NULL,'roof1','roof2','Switch2','switch','',0,0,0,''),(2,'lam1',3,'lamp1','Switch1','status',1,'1','','roof1','roof2','Switch1','switch','',0,0,0,''),(3,'lam3',3,'lamp3','Switch3','status',1,'1','','roof1','roof2','Switch3','switch','',0,0,0,''),(4,'lam4',3,'lamp4','Switch4','status',1,'1','','roof1','roof2','Switch4','switch','',0,0,0,''),(5,'lam5',3,'lamp5','Switch5','status',1,'1','','roof1','roof2','Switch5','switch','',0,0,0,''),(6,'lam7',3,'lamp7','Switch7','status',1,'1','','roof1','roof2','Switch7','switch','',0,0,0,''),(7,'lam6',3,'lamp6','Switch6','status',1,'1','','roof1','roof2','Switch6','switch','',0,0,0,''),(8,'temp2_minus',3,'temp2_minus','','',1,'',NULL,'','','tempD2','tu_minus','',0,0,0,''),(9,'temp1_plus',3,'temp1_plus','','',1,'','','','','tempD1','tu_plus','',0,0,0,''),(10,'temp1_minus',3,'temp1_minus','','',1,'','','','','tempD1','tu_minus','',0,0,0,''),(11,'temp3_minus',3,'temp3_minus','','',1,'','','','','tempD3','tu_minus','',0,0,0,''),(12,'temp2_plus',3,'temp2_plus','','',1,'','','','','tempD2','tu_plus','',0,0,0,''),(13,'temp3_plus',3,'temp3_plus','','',1,'','','','','tempD3','tu_plus','',0,0,0,''),(14,'temp4_minus',3,'temp4_minus','','',1,'','','','','tempD4','tu_minus','',0,0,0,''),(15,'temp4_plus',3,'temp4_plus','','',1,'','','','','tempD4','tu_plus','',0,0,0,''),(16,'clap1',3,'temp1','clapan1','status',1,'1',NULL,'clap_off','clap_on','','','',0,0,0,''),(17,'clap2',3,'temp2','clapan2','status',1,'1','','clap_off','clap_on','','','',0,0,0,''),(18,'clap3',3,'temp3','clapan3','status',1,'1','','clap_off','clap_on','','','',0,0,0,''),(19,'clap4',3,'temp4','clapan4','status',1,'1','','clap_off','clap_on','','','',0,0,0,''),(21,'clap5',3,'temp5','clapan5','status',1,'1','','clap_off','clap_on','','','',0,0,0,''),(22,'clap6',3,'temp6','clapan6','status',1,'1','','clap_off','clap_on','','','',0,0,0,''),(24,'temp5_minus',3,'temp5_minus','','',1,'','','','','tempD5','tu_minus','',0,0,0,''),(25,'temp5_plus',3,'temp5_plus','','',1,'','','','','tempD5','tu_plus','',0,0,0,''),(26,'temp6_minus',3,'temp6_minus','','',1,'','','','','tempD6','tu_minus','',0,0,0,''),(27,'temp6_plus',3,'temp6_plus','','',1,'','','','','tempD6','tu_plus','',0,0,0,'');
/*!40000 ALTER TABLE `plan_states` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plans`
--

DROP TABLE IF EXISTS `plans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plans` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `IMAGE` varchar(255) NOT NULL DEFAULT '',
  `NEED_ZOOM` int(3) NOT NULL DEFAULT '0',
  `AUTO_ZOOM` int(3) NOT NULL DEFAULT '0',
  `CUSTOM_CSS` text,
  `CUSTOM_JAVASCRIPT` text,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plans`
--

LOCK TABLES `plans` WRITE;
/*!40000 ALTER TABLE `plans` DISABLE KEYS */;
INSERT INTO `plans` VALUES (2,'Plan1','2.svg',0,0,NULL,NULL),(3,'plan2','3.svg',0,1,'.roof2 {\r\n fill:black !important;\r\n}\r\n.roof1 {\r\n fill:yellow !important;\r\n}\r\n.clap_on {\r\n fill:red !important;\r\n}\r\n.clap_off {\r\n fill:blue !important;\r\n}',NULL);
/*!40000 ALTER TABLE `plans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plugins`
--

DROP TABLE IF EXISTS `plugins`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `plugins` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `MODULE_NAME` varchar(255) NOT NULL DEFAULT '',
  `REPOSITORY_URL` char(255) NOT NULL DEFAULT '',
  `AUTHOR` varchar(255) NOT NULL DEFAULT '',
  `SUPPORT_URL` char(255) NOT NULL DEFAULT '',
  `DESCRIPTION_RU` text,
  `DESCRIPTION_EN` text,
  `CURRENT_VERSION` varchar(255) NOT NULL DEFAULT '',
  `LATEST_VERSION` varchar(255) NOT NULL DEFAULT '',
  `IS_INSTALLED` int(3) NOT NULL DEFAULT '0',
  `WHATSNEW` text,
  `LATEST_UPDATE` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=31 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plugins`
--

LOCK TABLES `plugins` WRITE;
/*!40000 ALTER TABLE `plugins` DISABLE KEYS */;
INSERT INTO `plugins` VALUES (1,'','app_gpstrack','','','',NULL,NULL,'2019-08-02 14:44:20','',1,NULL,'2020-01-26 12:16:37'),(2,'','app_products','','','',NULL,NULL,'2019-05-08 21:55:20','',1,NULL,'2020-01-26 12:16:42'),(3,'','app_quotes','','','',NULL,NULL,'2019-08-12 11:57:31','',1,NULL,'2020-01-26 12:16:42'),(4,'','app_readit','','','',NULL,NULL,'2019-08-12 11:57:23','',1,NULL,'2020-01-26 12:16:43'),(5,'','rss_channels','','','',NULL,NULL,'2018-10-24 22:37:58','',1,NULL,'2020-01-26 12:16:44'),(6,'','app_calendar','','','',NULL,NULL,'2019-05-21 09:59:32','',1,NULL,'2020-01-26 12:16:45'),(7,'','app_tdwiki','','','',NULL,NULL,'2018-02-15 23:38:36','',1,NULL,'2020-01-26 12:16:47'),(9,'','phpfm','','','',NULL,NULL,'2016-12-23 14:00:08','',1,NULL,'2020-01-26 12:17:01'),(22,'','app_openweather','','','',NULL,NULL,'2019-10-16 16:10:39','',1,NULL,'2020-01-26 12:16:40'),(12,'','app_radio','','','',NULL,NULL,'2018-12-17 08:42:23','',1,NULL,'2020-01-26 12:16:49'),(13,'','onewire','','','',NULL,NULL,'2016-09-20 10:45:08','',1,NULL,'2020-01-26 12:16:50'),(14,'','energomera','','','',NULL,NULL,'2019-01-29 10:29:28','',1,NULL,'2020-01-26 12:16:51'),(15,'','mqtt','','','',NULL,NULL,'2019-11-07 13:30:24','',1,NULL,'2020-01-26 12:16:52'),(16,'','cron','','','',NULL,NULL,'2018-02-27 11:45:34','',1,NULL,'2020-01-26 12:17:00'),(17,'','mysensor','','','',NULL,NULL,'2020-01-18 09:45:00','',1,NULL,'2020-01-26 12:16:56'),(18,'','app_chatbox','','','',NULL,NULL,'2018-09-22 16:22:11','',1,NULL,'2020-01-26 12:16:32'),(19,'','backup','','','',NULL,NULL,'2019-12-21 10:43:13','',1,NULL,'2020-01-26 12:16:59'),(28,'','yandex_tts','','','',NULL,NULL,'2019-12-09 09:09:38','',1,NULL,'2020-01-26 12:16:35'),(21,'','charts','','','',NULL,NULL,'2019-11-27 17:43:37','',1,NULL,'2020-01-26 12:16:36'),(23,'','telegram','','','',NULL,NULL,'2020-01-23 16:21:06','',1,NULL,'2020-01-26 12:16:34'),(24,'','ExchangeRates','','','',NULL,NULL,'2020-01-08 15:36:08','',1,NULL,'2020-01-26 12:16:48'),(25,'','apiai','','','',NULL,NULL,'2018-12-12 08:46:57','',1,NULL,'2020-01-26 12:16:31'),(26,'','xiaomihome','','','',NULL,NULL,'2019-11-06 14:32:49','',1,NULL,'2020-01-26 12:16:57'),(27,'','rhvoice','','','',NULL,NULL,'2019-12-02 15:34:46','',1,NULL,'2020-01-26 12:16:33'),(30,'','yandexweather','','','',NULL,NULL,'2019-12-11 06:18:48','',1,NULL,'2020-01-27 15:30:29');
/*!40000 ALTER TABLE `plugins` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prod_categories`
--

DROP TABLE IF EXISTS `prod_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prod_categories` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prod_categories`
--

LOCK TABLES `prod_categories` WRITE;
/*!40000 ALTER TABLE `prod_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `prod_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_categories`
--

DROP TABLE IF EXISTS `product_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `product_categories` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `PARENT_ID` int(10) NOT NULL DEFAULT '0',
  `SUB_LIST` text,
  `PARENT_LIST` text,
  `IMAGE` varchar(70) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_categories`
--

LOCK TABLES `product_categories` WRITE;
/*!40000 ALTER TABLE `product_categories` DISABLE KEYS */;
INSERT INTO `product_categories` VALUES (1,'<#LANG_APP_PRODUCTS#>',0,0,'2,3,4,5,7,8','0','');
/*!40000 ALTER TABLE `product_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_codes`
--

DROP TABLE IF EXISTS `product_codes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `product_codes` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `CODE` varchar(255) NOT NULL DEFAULT '',
  `PRODUCT_ID` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=35 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_codes`
--

LOCK TABLES `product_codes` WRITE;
/*!40000 ALTER TABLE `product_codes` DISABLE KEYS */;
INSERT INTO `product_codes` VALUES (33,'ХЛЕБ ','4811002027133',1),(34,'МОЛОЧНАЯ КАША ДЛЯ ДЕТСКОГО ПИТАНИЯ ','4606272002061',2);
/*!40000 ALTER TABLE `product_codes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_log`
--

DROP TABLE IF EXISTS `product_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `product_log` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PRODUCT_ID` int(10) NOT NULL DEFAULT '0',
  `CODE_ID` int(10) NOT NULL DEFAULT '0',
  `ACTION` char(10) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  `QTY` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_log`
--

LOCK TABLES `product_log` WRITE;
/*!40000 ALTER TABLE `product_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_units`
--

DROP TABLE IF EXISTS `product_units`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `product_units` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(25) NOT NULL DEFAULT '',
  `SHORT_NAME` varchar(25) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_units`
--

LOCK TABLES `product_units` WRITE;
/*!40000 ALTER TABLE `product_units` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_units` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `products`
--

DROP TABLE IF EXISTS `products`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `products` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `COMMENTS` varchar(255) NOT NULL DEFAULT '',
  `CATEGORY_ID` int(10) NOT NULL DEFAULT '0',
  `INSTOCK` int(3) NOT NULL DEFAULT '0',
  `IMAGE` varchar(70) NOT NULL DEFAULT '',
  `WILL_EXPIRE` int(3) NOT NULL DEFAULT '0',
  `EXPIRE_DATE` date DEFAULT NULL,
  `EXPIRE_DEFAULT` int(10) NOT NULL DEFAULT '0',
  `UPDATED` datetime DEFAULT NULL,
  `QTY` int(10) NOT NULL DEFAULT '0',
  `MIN_QTY` int(10) NOT NULL DEFAULT '0',
  `DETAILS` text,
  `DEFAULT_PRICE` float NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `products`
--

LOCK TABLES `products` WRITE;
/*!40000 ALTER TABLE `products` DISABLE KEYS */;
/*!40000 ALTER TABLE `products` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_modules`
--

DROP TABLE IF EXISTS `project_modules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_modules` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(50) NOT NULL DEFAULT '',
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `CATEGORY` varchar(50) NOT NULL DEFAULT '',
  `PARENT_NAME` varchar(50) NOT NULL DEFAULT '',
  `DATA` text,
  `HIDDEN` int(3) NOT NULL DEFAULT '0',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `ADDED` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=136 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_modules`
--

LOCK TABLES `project_modules` WRITE;
/*!40000 ALTER TABLE `project_modules` DISABLE KEYS */;
INSERT INTO `project_modules` VALUES (1,'control_modules','<#LANG_MODULE_MODULES#>','<#LANG_SECTION_SYSTEM#>','','',0,0,'2015-01-29 08:24:27'),(67,'scripts','<#LANG_MODULE_SCRIPTS#>','<#LANG_SECTION_OBJECTS#>','','',0,0,'2010-09-13 15:12:16'),(4,'control_access','Control Access','<#LANG_SECTION_SYSTEM#>','','',1,0,'2011-09-29 18:16:01'),(7,'master','<#LANG_MODULE_MASTER_LOGIN#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2014-10-30 11:57:40'),(70,'pinghosts','<#LANG_MODULE_PINGHOSTS#>','<#LANG_SECTION_DEVICES#>','','',0,0,'2011-01-05 22:02:57'),(20,'saverestore','<#LANG_MODULE_SAVERESTORE#>','<#LANG_SECTION_SYSTEM#>','','a:2:{s:17:\"MASTER_UPDATE_URL\";s:58:\"https://github.com/sergejey/majordomo/archive/alpha.tar.gz\";s:17:\"LATEST_UPDATED_ID\";s:40:\"d1998b04ae060c8f44db7e54d2eb0e9137c2c50c\";}',0,0,'2009-02-07 11:35:05'),(21,'userlog','<#LANG_MODULE_USERLOG#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2009-02-07 11:45:52'),(22,'skins','<#LANG_MODULE_SKINS#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2009-02-07 12:02:54'),(23,'settings','<#LANG_MODULE_SETTINGS#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2009-02-07 12:05:40'),(24,'dateselect','Date Selector','System','','',1,0,'2009-02-07 12:47:32'),(25,'thumb','<#LANG_MODULE_THUMB#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2009-02-07 12:48:32'),(74,'app_gpstrack','<#LANG_APP_GPSTRACK#>','<#LANG_SECTION_APPLICATIONS#>','','a:3:{s:11:\"MAPPROVIDER\";s:6:\"yandex\";s:7:\"MAPTYPE\";s:3:\"map\";s:12:\"MAX_ACCURACY\";s:1:\"0\";}',0,0,'2011-07-25 11:27:19'),(73,'app_player','<#LANG_APP_PLAYER#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2011-05-03 11:02:57'),(28,'dashboard','Dashboard','CMS','','a:5:{s:12:\"CPANEL_STATS\";i:0;s:15:\"CPANEL_USERNAME\";s:0:\"\";s:15:\"CPANEL_PASSWORD\";s:0:\"\";s:13:\"CPANEL_DOMAIN\";s:0:\"\";s:10:\"CPANEL_URL\";s:0:\"\";}',1,0,'2009-02-23 10:15:23'),(29,'events','<#LANG_MODULE_EVENTS#>','<#LANG_SECTION_SYSTEM#>','','',0,0,'2017-10-03 20:45:39'),(30,'users','<#LANG_MODULE_USERS#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2009-03-27 13:08:07'),(31,'terminals','<#LANG_MODULE_TERMINALS#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2009-03-27 13:10:00'),(34,'commands','<#LANG_MODULE_CONTROL_MENU#>','<#LANG_SECTION_OBJECTS#>','','',0,0,'2009-04-11 03:14:03'),(37,'classes','<#LANG_MODULE_OBJECTS#>','<#LANG_SECTION_OBJECTS#>','','a:3:{s:12:\"DEFAULT_VIEW\";s:0:\"\";s:15:\"FILTER_CLASS_ID\";i:25;s:18:\"FILTER_LOCATION_ID\";i:0;}',0,0,'2009-05-22 10:09:27'),(38,'history','<#LANG_MODULE_OBJECTS_HISTORY#>','<#LANG_SECTION_OBJECTS#>','','',1,0,'2009-05-22 10:09:51'),(39,'locations','<#LANG_MODULE_LOCATIONS#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2009-05-22 10:11:01'),(40,'methods','<#LANG_MODULE_METHODS#>','<#LANG_SECTION_OBJECTS#>','','',1,0,'2009-05-22 10:11:23'),(41,'properties','<#LANG_MODULE_PROPERTIES#>','<#LANG_SECTION_OBJECTS#>','','',1,0,'2009-05-22 10:11:47'),(42,'objects','<#LANG_MODULE_OBJECT_INSTANCES#>','<#LANG_SECTION_OBJECTS#>','','',1,0,'2009-05-22 10:12:04'),(85,'pvalues','<#LANG_MODULE_PVALUES#>','<#LANG_SECTION_OBJECTS#>','','',1,0,'2012-11-16 15:04:26'),(44,'shoutbox','<#LANG_MODULE_SHOUTBOX#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2009-07-29 13:53:13'),(45,'shoutrooms','<#LANG_MODULE_SHOUTROOMS#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2009-07-29 13:53:28'),(46,'jobs','<#LANG_MODULE_JOBS#>','<#LANG_SECTION_SYSTEM#>','','',1,0,'2014-10-30 11:57:40'),(80,'app_calendar','<#LANG_APP_CALENDAR#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2012-06-25 09:34:08'),(81,'scenes','<#LANG_MODULE_SCENES#>','<#LANG_SECTION_OBJECTS#>','','',0,0,'2012-06-25 09:34:26'),(49,'usbdevices','<#LANG_MODULE_USB_DEVICES#>','<#LANG_SECTION_DEVICES#>','','',0,0,'2010-03-22 12:18:32'),(68,'rss_channels','<#LANG_MODULE_RSS_CHANNELS#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2010-09-22 10:54:52'),(61,'app_mediabrowser','<#LANG_APP_MEDIA_BROWSER#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2010-08-31 09:09:33'),(64,'app_tdwiki','<#LANG_APP_TDWIKI#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2010-08-31 09:11:38'),(63,'app_products','<#LANG_APP_PRODUCTS#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2010-08-31 09:11:24'),(66,'layouts','<#LANG_MODULE_LAYOUTS#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2010-09-13 15:03:49'),(82,'webvars','<#LANG_MODULE_WEBVARS#>','<#LANG_SECTION_OBJECTS#>','','',0,0,'2012-11-06 08:49:14'),(77,'patterns','<#LANG_MODULE_PATTERNS#>','<#LANG_SECTION_OBJECTS#>','','',0,0,'2011-12-13 14:36:03'),(83,'xray','X-Ray','<#LANG_SECTION_SYSTEM#>','','',0,0,'2012-11-16 14:59:57'),(87,'app_readit','<#LANG_APP_READIT#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2013-03-06 12:25:29'),(88,'security_rules','<#LANG_MODULE_SECURITY_RULES#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2013-05-18 11:31:37'),(90,'connect','<#LANG_MODULE_CONNECT#>','<#LANG_SECTION_SYSTEM#>','','a:9:{s:16:\"CONNECT_USERNAME\";s:8:\"immortal\";s:16:\"CONNECT_PASSWORD\";s:9:\"123525654\";s:12:\"CONNECT_SYNC\";i:0;s:9:\"SEND_MENU\";i:1;s:12:\"SEND_OBJECTS\";i:1;s:12:\"SEND_SCRIPTS\";i:1;s:13:\"SEND_PATTERNS\";i:1;s:14:\"CONNECT_BACKUP\";i:0;s:19:\"CONNECT_BACKUP_HOUR\";i:4;}',0,0,'2013-08-09 10:02:04'),(93,'market','<#LANG_MODULE_MARKET#>','<#LANG_SECTION_SYSTEM#>','','',0,0,'2014-01-25 14:04:20'),(97,'blockly_code','Blockly code','<#LANG_SECTION_SYSTEM#>','','',1,0,'2014-09-03 09:28:23'),(98,'myblocks','<#LANG_MODULE_MYBLOCKS#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2014-10-30 11:57:40'),(99,'soundfiles','<#LANG_MODULE_SOUNDFILES#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2014-10-30 11:57:41'),(100,'textfiles','<#LANG_MODULE_TEXTFILES#>','<#LANG_SECTION_SETTINGS#>','','',0,0,'2014-10-30 11:57:41'),(101,'linkedobject','LinkedObject','<#LANG_SECTION_SYSTEM#>','','',1,0,'2015-01-29 08:24:25'),(102,'system_errors','<#LANG_MODULE_SYSTEM_ERRORS#>','<#LANG_SECTION_SYSTEM#>','','',0,0,'2015-01-29 08:24:26'),(107,'app_quotes','<#LANG_APP_QUOTES#>','<#LANG_SECTION_APPLICATIONS#>','','',0,0,'2015-12-03 11:42:24'),(108,'cron','Cron','<#LANG_SECTION_SYSTEM#>','',NULL,0,0,'2016-12-17 08:17:32'),(110,'app_radio','Онлайн радио','<#LANG_SECTION_APPLICATIONS#>','',NULL,0,0,'2016-12-17 09:13:14'),(111,'mqtt','<#LANG_MODULE_MQTT#>','<#LANG_SECTION_DEVICES#>','','a:7:{s:9:\"MQTT_HOST\";s:9:\"localhost\";s:9:\"MQTT_PORT\";i:1883;s:10:\"MQTT_QUERY\";s:1:\"#\";s:11:\"MQTT_CLIENT\";s:0:\"\";s:13:\"MQTT_USERNAME\";s:0:\"\";s:13:\"MQTT_PASSWORD\";s:0:\"\";s:9:\"MQTT_AUTH\";i:0;}',0,0,'2016-12-24 13:58:53'),(112,'devices','Простые устройства','<#LANG_SECTION_DEVICES#>','',NULL,0,0,'2020-01-27 21:48:48'),(113,'phpfm','File Manager','<#LANG_SECTION_APPLICATIONS#>','',NULL,0,0,'2017-04-08 05:08:39'),(125,'app_openweather','Погода от OpenWeatherMap','<#LANG_SECTION_APPLICATIONS#>','',NULL,0,0,'2018-01-13 09:01:15'),(132,'yandex_tts','Yandex TTS','<#LANG_SECTION_APPLICATIONS#>','','a:5:{s:10:\"ACCESS_KEY\";s:36:\"23863f03-a491-4a64-9c6e-1d6f3fe81821\";s:7:\"SPEAKER\";s:4:\"jane\";s:7:\"EMOTION\";s:4:\"good\";s:8:\"EMPHASIS\";s:1:\"0\";s:8:\"DISABLED\";s:1:\"0\";}',0,0,'2018-09-18 17:20:16'),(118,'charts','Графики','<#LANG_SECTION_OBJECTS#>','',NULL,0,0,'2020-01-27 21:48:48'),(119,'energomera','Energomera','<#LANG_SECTION_DEVICES#>','','a:2:{s:8:\"E_SERIAL\";s:10:\"/dev/ttyS1\";s:10:\"E_INTERVAL\";s:2:\"10\";}',0,0,'2017-10-01 21:37:22'),(120,'onewire','<#LANG_MODULE_ONEWIRE#>','<#LANG_SECTION_DEVICES#>','',NULL,0,0,'2017-10-01 21:37:22'),(121,'mysensor','MySensors','<#LANG_SECTION_DEVICES#>','','a:8:{s:10:\"MS_CONTYPE\";s:1:\"0\";s:7:\"MS_HOST\";s:7:\"0.0.0.0\";s:7:\"MS_PORT\";i:5003;s:9:\"MS_SERIAL\";s:24:\"/dev/ttyMySensorsGateway\";s:10:\"MS_MEASURE\";s:1:\"M\";s:9:\"MS_AUTOID\";s:1:\"1\";s:9:\"MS_NEXTID\";s:2:\"10\";s:17:\"MS_INCLUSION_MODE\";i:0;}',0,0,'2017-11-11 19:58:13'),(122,'app_chatbox','ChatBox','<#LANG_SECTION_APPLICATIONS#>','','a:1:{s:6:\"AVATAR\";s:10:\"_alice.png\";}',0,0,'2017-12-03 14:20:47'),(123,'backup','Backup','<#LANG_SECTION_SYSTEM#>','','a:13:{s:8:\"PROVIDER\";s:1:\"0\";s:10:\"LOCAL_PATH\";s:15:\"/var/www/backup\";s:11:\"WEBDAV_PATH\";s:0:\"\";s:10:\"WEBDAV_URL\";s:0:\"\";s:12:\"WEBDAV_LOGIN\";s:0:\"\";s:15:\"WEBDAV_PASSWORD\";s:0:\"\";s:11:\"MAILRU_PATH\";s:0:\"\";s:12:\"MAILRU_LOGIN\";s:0:\"\";s:15:\"MAILRU_PASSWORD\";s:0:\"\";s:9:\"MAX_COUNT\";s:2:\"10\";s:15:\"BACKUP_DATABASE\";s:1:\"1\";s:11:\"BACKUP_DIRS\";s:280:\"SteelSeries,admin.php,api.php,backup.php,btraced.php,cms,command.php,config.php.sample,cycle.php,gps.php,img,index.php,js,languages,lib,load_settings.php,modules,pChart,php.php,print_all.php,rss.php,scripts,templates,templates_alt,test.php,trackme.php,verimage.php,write_error.php\";s:12:\"BACKUP_DEBUG\";N;}',0,0,'2017-12-03 14:36:35'),(126,'telegram','Telegram','<#LANG_SECTION_APPLICATIONS#>','','a:17:{s:9:\"TLG_TOKEN\";s:0:\"\";s:11:\"TLG_STORAGE\";s:14:\"/var/www/files\";s:13:\"TLG_COUNT_ROW\";s:1:\"4\";s:11:\"TLG_TIMEOUT\";s:2:\"30\";s:9:\"TLG_DEBUG\";s:1:\"1\";s:11:\"TLG_WEBHOOK\";N;s:15:\"TLG_WEBHOOK_URL\";s:0:\"\";s:16:\"TLG_WEBHOOK_CERT\";s:0:\"\";s:11:\"TLG_BOTNAME\";N;s:12:\"TLG_USEPROXY\";N;s:14:\"TLG_PROXY_TYPE\";s:1:\"1\";s:13:\"TLG_PROXY_URL\";s:0:\"\";s:15:\"TLG_PROXY_LOGIN\";s:0:\"\";s:18:\"TLG_PROXY_PASSWORD\";s:0:\"\";s:16:\"TLG_BOT_USERNAME\";N;s:12:\"TLG_BOT_NAME\";N;s:10:\"TLG_BOT_ID\";N;}',0,0,'2018-03-09 08:14:43'),(127,'ExchangeRates','Курс валют','<#LANG_SECTION_APPLICATIONS#>','',NULL,0,0,'2018-03-17 19:25:28'),(128,'apiai','API.AI','<#LANG_SECTION_OBJECTS#>','','a:8:{s:7:\"API_KEY\";s:32:\"3e759df4cfac415d862fa4aad538e2b8\";s:11:\"DEV_API_KEY\";s:32:\"c588808bfb934340a33df8548c26acf7\";s:22:\"CONFIG_MODULE_PRIORITY\";i:100;s:14:\"SPEAK_PRIORITY\";i:0;s:13:\"SPEAK_UNKNOWN\";i:0;s:8:\"LANGUAGE\";s:2:\"ru\";s:15:\"SESSION_TIMEOUT\";i:0;s:8:\"SESSIONS\";a:3:{s:0:\"\";a:2:{s:2:\"id\";s:14:\".5aad7ba42b013\";s:4:\"time\";i:1521319566;}s:4:\"MAIN\";a:2:{s:2:\"id\";s:18:\"MAIN.5acba9949fcba\";s:4:\"time\";i:1576570481;}s:9:\"telegram4\";a:2:{s:2:\"id\";s:23:\"telegram4.5ba9e7d44f2b2\";s:4:\"time\";i:1537861592;}}}',0,0,'2018-03-17 19:36:03'),(129,'xiaomihome','Xiaomi Home','<#LANG_SECTION_DEVICES#>','',NULL,0,0,'2018-03-18 18:41:54'),(130,'rhvoice','RHVoice','<#LANG_SECTION_APPLICATIONS#>','',NULL,0,0,'2018-09-18 16:44:09'),(133,'actions_log','<#LANG_MODULE_ACTIONS_LOG#>','<#LANG_SECTION_SYSTEM#>','',NULL,0,0,'2019-12-16 19:54:27'),(134,'plans','<#LANG_MODULE_PLANS#>','<#LANG_SECTION_OBJECTS#>','',NULL,0,0,'2019-12-16 19:54:27'),(135,'yandexweather','Погода Яндекс','<#LANG_SECTION_APPLICATIONS#>','',NULL,0,0,'2020-01-27 12:30:32');
/*!40000 ALTER TABLE `project_modules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `properties`
--

DROP TABLE IF EXISTS `properties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `properties` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `CLASS_ID` int(10) NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `DESCRIPTION` text,
  `OBJECT_ID` int(10) NOT NULL DEFAULT '0',
  `KEEP_HISTORY` int(10) NOT NULL DEFAULT '0',
  `ONCHANGE` varchar(255) NOT NULL DEFAULT '',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  `DATA_KEY` int(3) NOT NULL DEFAULT '0',
  `DATA_TYPE` int(3) NOT NULL DEFAULT '0',
  `VALIDATION_TYPE` int(3) NOT NULL DEFAULT '0',
  `VALIDATION_NUM_MIN` varchar(20) NOT NULL DEFAULT '',
  `VALIDATION_NUM_MAX` varchar(20) NOT NULL DEFAULT '',
  `VALIDATION_LIST` varchar(255) NOT NULL DEFAULT '',
  `VALIDATION_CODE` text,
  PRIMARY KEY (`ID`),
  KEY `CLASS_ID` (`CLASS_ID`),
  KEY `OBJECT_ID` (`OBJECT_ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2769 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `properties`
--

LOCK TABLES `properties` WRITE;
/*!40000 ALTER TABLE `properties` DISABLE KEYS */;
INSERT INTO `properties` VALUES (1,1,'lastTimePressed','когда нажималась в последний раз',0,0,'','',0,0,0,'','','',NULL),(8,5,'СтепеньКрасноты','',0,0,'','',0,0,0,'','','',NULL),(12,7,'time','текущее время',0,0,'','',0,0,0,'','','',NULL),(1178,10,'checked','время последней проверки',0,0,'','',0,0,0,'','','',NULL),(19,19,'temp','',0,7,'','',0,0,0,'','','',NULL),(24,20,'tempOutside',NULL,0,7,'','',0,0,0,'','','',NULL),(25,20,'relHumOutside',NULL,0,7,'','',0,0,0,'','','',NULL),(26,20,'dewPoint',NULL,0,7,'','',0,0,0,'','','',NULL),(27,20,'windLatest',NULL,0,7,'','',0,0,0,'','','',NULL),(28,20,'windAverage',NULL,0,7,'','',0,0,0,'','','',NULL),(29,20,'rainfallRate',NULL,0,7,'','',0,0,0,'','','',NULL),(30,20,'rainfallHour',NULL,0,7,'','',0,0,0,'','','',NULL),(31,20,'rainfall24',NULL,0,7,'','',0,0,0,'','','',NULL),(32,20,'pressure',NULL,0,7,'','',0,0,0,'','','',NULL),(33,20,'pressureTrend',NULL,0,7,'','',0,0,0,'','','',NULL),(34,20,'windDirection',NULL,0,7,'','',0,0,0,'','','',NULL),(35,20,'windDirectionAverage',NULL,0,7,'','',0,0,0,'','','',NULL),(36,20,'tempInside',NULL,0,7,'','',0,0,0,'','','',NULL),(37,20,'relHumInside',NULL,0,7,'','',0,0,0,'','','',NULL),(38,20,'pressureRt',NULL,0,7,'','',0,0,0,'','','',NULL),(39,20,'updatedTime',NULL,0,7,'','',0,0,0,'','','',NULL),(40,20,'updatedDate',NULL,0,7,'','',0,0,0,'','','',NULL),(41,21,'stateDetails','details for the state',0,0,'','',0,0,0,'','','',NULL),(42,21,'stateColor','green / yellow / red',0,0,'','',0,0,0,'','','',NULL),(49,22,'alive','',0,0,'','',0,0,0,'','','',NULL),(50,22,'aliveTimeOut','',0,0,'','',0,0,0,'','','',NULL),(51,22,'status','',0,0,'','',0,0,0,'','','',NULL),(52,22,'statusText','',0,0,'','',0,0,0,'','','',NULL),(53,22,'updatedTimestamp','',0,0,'','',0,0,0,'','','',NULL),(54,23,'LinkedRoom','',0,0,'','',0,0,0,'','','',NULL),(55,24,'active','',0,0,'modeChanged','',0,0,0,'','','',NULL),(56,24,'title','',0,0,'','',0,0,0,'','','',NULL),(57,24,'updated','',0,0,'','',0,0,0,'','','',NULL),(58,24,'updatedTime','',0,0,'','',0,0,0,'','','',NULL),(59,25,'LatestActivity','',0,0,'','',0,0,0,'','','',NULL),(60,25,'LatestActivityTime','',0,0,'','',0,0,0,'','','',NULL),(61,25,'SomebodyHere','Somebody in the room',0,0,'','',0,0,0,'','','',NULL),(62,25,'Temperature','Temperature',0,365,'','',0,0,0,'','','',NULL),(63,26,'status','',0,0,'','',0,0,0,'','','',NULL),(64,19,'LinkedRoom','',0,0,'','',0,0,0,'','','',NULL),(65,19,'alive','',0,0,'','',0,0,0,'','','',NULL),(66,19,'aliveTimeOut','',0,0,'','',0,0,0,'','','',NULL),(67,19,'updated','',0,0,'','',0,0,0,'','','',NULL),(68,19,'updatedTime','',0,0,'','',0,0,0,'','','',NULL),(76,0,'stateTitle',NULL,17,0,'','',0,0,0,'','','',NULL),(77,0,'stateTitle',NULL,18,0,'','',0,0,0,'','','',NULL),(78,0,'stateTitle',NULL,16,0,'','',0,0,0,'','','',NULL),(119,30,'linkedRoom','',0,0,'','',0,0,0,'','','',NULL),(118,30,'aliveTimeOut','',0,0,'','',0,0,0,'','','',NULL),(117,30,'alive','',0,0,'','',0,0,0,'','','',NULL),(115,29,'Code1','',0,0,'','',0,0,0,'','','',NULL),(116,29,'Code2','',0,0,'','',0,0,0,'','','',NULL),(120,30,'humidity','',0,0,'','',0,0,0,'','','',NULL),(121,30,'updated','',0,0,'','',0,0,0,'','','',NULL),(122,30,'updatedTime','',0,0,'','',0,0,0,'','','',NULL),(124,23,'motionDetected','',0,0,'','',0,0,0,'','','',NULL),(125,0,'direction',NULL,52,0,'','',0,0,0,'','','',NULL),(126,0,'direction',NULL,26,0,'','',0,0,0,'','','',NULL),(127,25,'Humidity','Humidity',0,365,'','',0,0,0,'','','',NULL),(132,25,'Title','',0,0,'','',0,0,0,'','','',NULL),(133,31,'channel','Канал noolight устройства',0,0,'','',0,0,0,'','','',NULL),(134,32,'atHome','',0,0,'','',0,0,0,'','','',NULL),(135,32,'Coordinates','',0,0,'','',0,0,0,'','','',NULL),(136,32,'CoordinatesUpdated','',0,0,'','',0,0,0,'','','',NULL),(137,32,'CoordinatesUpdatedTimestamp','',0,0,'','',0,0,0,'','','',NULL),(138,32,'fullName','',0,0,'','',0,0,0,'','','',NULL),(139,32,'isMoving','',0,0,'','',0,0,0,'','','',NULL),(140,32,'seenAt','',0,0,'','',0,0,0,'','','',NULL),(1285,0,'EnergoMinTemp',NULL,191,0,'','',0,0,0,'','','',NULL),(157,34,'Enable','Вкл - 1, выкл - 0',0,0,'Update','',0,0,0,'','','',NULL),(158,34,'Crontab','Периодичность выполнения (cron синтаксис)',0,0,'Update','',0,0,0,'','','',NULL),(159,34,'LastRun','Последний запуск',0,0,'','',0,0,0,'','','',NULL),(162,0,'LastStationID',NULL,76,0,'','',0,0,0,'','','',NULL),(163,0,'VolumeLevel',NULL,76,0,'','',0,0,0,'','','',NULL),(164,0,'PlayTerminal',NULL,76,0,'','',0,0,0,'','','',NULL),(165,0,'On',NULL,76,0,'','',0,0,0,'','','',NULL),(1284,63,'status','статус клапана',0,365,'','',0,0,0,'','','',NULL),(1283,0,'timeHH',NULL,191,0,'','',0,0,0,'','','',NULL),(168,36,'status','Статус',0,365,'statusUpdated','',1,0,0,'','','',NULL),(169,36,'alive','Alive',0,365,'','',0,0,0,'','','',NULL),(170,36,'linkedRoom','LinkedRoom',0,0,'','',0,0,0,'','','',NULL),(171,36,'updated','Updated Timestamp',0,0,'','',0,0,0,'','','',NULL),(172,36,'updatedText','Updated Time (text)',0,0,'','',0,0,0,'','','',NULL),(173,37,'groupEco','Выключать в режиме экономии',0,0,'','',0,0,0,'','','',NULL),(174,37,'groupSunrise','Выключать с рассветом',0,0,'','',0,0,0,'','','',NULL),(175,39,'level','Current brightness level',0,0,'levelUpdated','',1,0,0,'','','',NULL),(176,41,'isActivity','Изменение означает активность в помещении',0,0,'','',0,0,0,'','','',NULL),(177,43,'value','Current Sensor Value',0,365,'valueUpdated','',1,0,0,'','','',NULL),(178,43,'minValue','Нижний порог',0,0,'','',0,0,0,'','','',NULL),(179,43,'maxValue','Верхний порог',0,0,'','',0,0,0,'','','',NULL),(180,43,'notify','Уведомлять при выходе за порог',0,0,'','',0,0,0,'','','',NULL),(181,43,'normalValue','Значение в нормальных пределах',0,0,'','',0,0,0,'','','',NULL),(2012,0,'temp_morn',NULL,257,0,'','',0,0,0,'','','',NULL),(2011,0,'date',NULL,257,0,'','',0,0,0,'','','',NULL),(2010,0,'civil_twilight_end',NULL,256,0,'','',0,0,0,'','','',NULL),(2009,0,'civil_twilight_begin',NULL,256,0,'','',0,0,0,'','','',NULL),(2008,0,'transit',NULL,256,0,'','',0,0,0,'','','',NULL),(2007,0,'day_length',NULL,256,0,'','',0,0,0,'','','',NULL),(2006,0,'sunset',NULL,256,0,'','',0,0,0,'','','',NULL),(2005,0,'sunrise',NULL,256,0,'','',0,0,0,'','','',NULL),(1282,0,'MonthShrt',NULL,191,0,'','',0,0,0,'','','',NULL),(1281,0,'reelFeel',NULL,191,0,'','',0,0,0,'','','',NULL),(2004,0,'condCode',NULL,256,0,'','',0,0,0,'','','',NULL),(2003,0,'snow',NULL,256,0,'','',0,0,0,'','','',NULL),(2002,0,'rain',NULL,256,0,'','',0,0,0,'','','',NULL),(2001,0,'clouds',NULL,256,0,'','',0,0,0,'','','',NULL),(2000,0,'image',NULL,256,0,'','',0,0,0,'','','',NULL),(1999,0,'pressure',NULL,256,0,'','',0,0,0,'','','',NULL),(1998,0,'wind_direction_full',NULL,256,0,'','',0,0,0,'','','',NULL),(357,0,'1',NULL,105,0,'','',0,0,0,'','','',NULL),(358,0,'2',NULL,105,0,'','',0,0,0,'','','',NULL),(359,0,'3',NULL,105,0,'','',0,0,0,'','','',NULL),(360,0,'4',NULL,105,0,'','',0,0,0,'','','',NULL),(361,0,'5',NULL,105,0,'','',0,0,0,'','','',NULL),(362,0,'6',NULL,105,0,'','',0,0,0,'','','',NULL),(363,0,'7',NULL,105,0,'','',0,0,0,'','','',NULL),(364,0,'8',NULL,105,0,'','',0,0,0,'','','',NULL),(365,0,'9',NULL,105,0,'','',0,0,0,'','','',NULL),(366,0,'10',NULL,105,0,'','',0,0,0,'','','',NULL),(367,0,'11',NULL,105,0,'','',0,0,0,'','','',NULL),(368,0,'12',NULL,105,0,'','',0,0,0,'','','',NULL),(369,0,'13',NULL,105,0,'','',0,0,0,'','','',NULL),(370,0,'14',NULL,105,0,'','',0,0,0,'','','',NULL),(371,0,'15',NULL,105,0,'','',0,0,0,'','','',NULL),(372,0,'16',NULL,105,0,'','',0,0,0,'','','',NULL),(373,0,'17',NULL,105,0,'','',0,0,0,'','','',NULL),(374,0,'18',NULL,105,0,'','',0,0,0,'','','',NULL),(375,0,'19',NULL,105,0,'','',0,0,0,'','','',NULL),(376,0,'20',NULL,105,0,'','',0,0,0,'','','',NULL),(378,0,'coord1',NULL,106,0,'','',0,0,0,'','','',NULL),(379,0,'coord2',NULL,106,0,'','',0,0,0,'','','',NULL),(1997,0,'wind_direction_text',NULL,256,0,'','',0,0,0,'','','',NULL),(1996,0,'wind_direction',NULL,256,0,'','',0,0,0,'','','',NULL),(1995,0,'weather_type',NULL,256,0,'','',0,0,0,'','','',NULL),(1994,0,'temp_max',NULL,256,0,'','',0,0,0,'','','',NULL),(1993,0,'temp_min',NULL,256,0,'','',0,0,0,'','','',NULL),(1992,0,'temp_night',NULL,256,0,'','',0,0,0,'','','',NULL),(1991,0,'temp_eve',NULL,256,0,'','',0,0,0,'','','',NULL),(1990,0,'temp_day',NULL,256,0,'','',0,0,0,'','','',NULL),(1989,0,'temp_morn',NULL,256,0,'','',0,0,0,'','','',NULL),(1988,0,'date',NULL,256,0,'','',0,0,0,'','','',NULL),(1987,0,'civil_twilight_end',NULL,255,0,'','',0,0,0,'','','',NULL),(1986,0,'civil_twilight_begin',NULL,255,0,'','',0,0,0,'','','',NULL),(1985,0,'transit',NULL,255,0,'','',0,0,0,'','','',NULL),(1984,0,'day_length',NULL,255,0,'','',0,0,0,'','','',NULL),(1983,0,'sunset',NULL,255,0,'','',0,0,0,'','','',NULL),(1982,0,'sunrise',NULL,255,0,'','',0,0,0,'','','',NULL),(1981,0,'condCode',NULL,255,0,'','',0,0,0,'','','',NULL),(1980,0,'snow',NULL,255,0,'','',0,0,0,'','','',NULL),(1979,0,'rain',NULL,255,0,'','',0,0,0,'','','',NULL),(786,0,'LastStationName',NULL,76,0,'','',0,0,0,'','','',NULL),(1978,0,'clouds',NULL,255,0,'','',0,0,0,'','','',NULL),(1977,0,'image',NULL,255,0,'','',0,0,0,'','','',NULL),(785,49,'temperature','',0,30,'','',0,0,0,'','','',NULL),(787,0,'namehost',NULL,106,0,'','',0,0,0,'','','',NULL),(1976,0,'pressure',NULL,255,0,'','',0,0,0,'','','',NULL),(1975,0,'wind_direction_full',NULL,255,0,'','',0,0,0,'','','',NULL),(1974,0,'wind_direction_text',NULL,255,0,'','',0,0,0,'','','',NULL),(1973,0,'wind_direction',NULL,255,0,'','',0,0,0,'','','',NULL),(1972,0,'weather_type',NULL,255,0,'','',0,0,0,'','','',NULL),(1971,0,'temp_max',NULL,255,0,'','',0,0,0,'','','',NULL),(1512,0,'updScript',NULL,231,0,'','',0,0,0,'','','',NULL),(1511,0,'civil_twilight_end',NULL,233,0,'','',0,0,0,'','','',NULL),(1510,0,'civil_twilight_begin',NULL,233,0,'','',0,0,0,'','','',NULL),(1509,0,'transit',NULL,233,0,'','',0,0,0,'','','',NULL),(1508,0,'day_length',NULL,233,0,'','',0,0,0,'','','',NULL),(1507,0,'sunset',NULL,233,0,'','',0,0,0,'','','',NULL),(1506,0,'sunrise',NULL,233,0,'','',0,0,0,'','','',NULL),(1505,0,'data_update',NULL,230,0,'','',0,0,0,'','','',NULL),(1504,0,'condCode',NULL,233,0,'','',0,0,0,'','','',NULL),(1503,0,'rain',NULL,233,0,'','',0,0,0,'','','',NULL),(1502,0,'clouds',NULL,233,0,'','',0,0,0,'','','',NULL),(1501,0,'image',NULL,233,0,'','',0,0,0,'','','',NULL),(1499,0,'pressure',NULL,233,0,'','',0,0,0,'','','',NULL),(1265,0,'tempP9',NULL,191,0,'','',0,0,0,'','','',NULL),(1496,0,'wind_direction_full',NULL,233,0,'','',0,0,0,'','','',NULL),(1157,36,'aliveTimeout','Допустимое время отсутствия данных (часов)',0,0,'','',0,0,0,'','','',NULL),(1158,50,'color','Current color',0,0,'colorUpdated','',1,0,0,'','','',NULL),(1159,50,'colorSaved','Saved color',0,0,'','',0,0,0,'','','',NULL),(1160,40,'ignoreNobodysHome','Игнорировать события от устройства, когда никого нет дома',0,0,'','',0,0,0,'','','',NULL),(1161,51,'streamURL','URL видео-потока (LQ)',0,0,'updatePreview','',0,0,0,'','','',NULL),(1162,51,'streamURL_HQ','URL видео-потока (HQ)',0,0,'updatePreview','',0,0,0,'','','',NULL),(1163,51,'cameraUsername','Имя пользователя',0,0,'','',0,0,0,'','','',NULL),(1164,51,'cameraPassword','Пароль',0,0,'updatePreview','',0,0,0,'','','',NULL),(1165,51,'snapshotURL','URL статического снимка',0,0,'','',0,0,0,'','','',NULL),(1166,51,'snapshot','Снимок',0,365,'','',0,5,0,'','','',NULL),(1167,51,'previewHTML','Preview HTML',0,0,'','',0,0,0,'','','',NULL),(1168,41,'ncno','Тип устройства/сенсора',0,0,'','',0,0,0,'','','',NULL),(1169,54,'unit','Единица измерения',0,0,'','',0,0,0,'','','',NULL),(1170,54,'value','Data Value',0,365,'valueUpdated','',1,0,0,'','','',NULL),(1171,43,'mainSensor','Основной сенсор помещения',0,0,'','',0,0,0,'','','',NULL),(1172,61,'unit','Единица измерения',0,0,'','',0,0,0,'','','',NULL),(1174,62,'direction','направление изменения',0,0,'','',0,0,0,'','','',NULL),(1175,62,'temp','Температура',0,90,'','',0,0,0,'','','',NULL),(1176,62,'updated','',0,0,'','',0,0,0,'','','',NULL),(1177,62,'updatedTime','',0,0,'','',0,0,0,'','','',NULL),(1179,10,'minMsgLevel','',0,0,'','',0,0,0,'','','',NULL),(1180,0,'testProp','',191,0,'','',0,0,0,'','','',NULL),(1181,0,'weatherFull','',191,0,'','',0,0,0,'','','',NULL),(1182,0,'AlarmTime','',191,0,'','',0,0,0,'','','',NULL),(1183,0,'textBoxTest','',191,0,'','',0,0,0,'','','',NULL),(1184,0,'1w_temp','',191,0,'','',0,0,0,'','','',NULL),(1185,0,'TempOutside','',191,0,'','',0,0,0,'','','',NULL),(1186,0,'Econom','',191,0,'','',0,0,0,'','','',NULL),(1187,0,'securityMode','',191,0,'','',0,0,0,'','','',NULL),(1188,0,'nobodyHome','',191,0,'','',0,0,0,'','','',NULL),(1189,0,'WeHaveGuests','',191,0,'','',0,0,0,'','','',NULL),(2753,0,'cycle_rssRun',NULL,191,0,'','',0,0,0,'','','',NULL),(1198,0,'volumeLevel','',191,0,'','',0,0,0,'','','',NULL),(1199,0,'somebodyHome','',191,0,'','',0,0,0,'','','',NULL),(1200,0,'timeNow','',191,0,'','',0,0,0,'','','',NULL),(1201,0,'HomeStatus','',191,0,'','',0,0,0,'','','',NULL),(1202,0,'isDark','',191,0,'','',0,0,0,'','','',NULL),(1203,0,'SunSetTime','',191,0,'','',0,0,0,'','','',NULL),(1204,0,'SunRiseTime','',191,0,'','',0,0,0,'','','',NULL),(1205,0,'somebodyHomeText','',191,0,'','',0,0,0,'','','',NULL),(1207,0,'wunderHost','',191,0,'','',0,0,0,'','','',NULL),(1209,0,'weatherTomorrow','',191,0,'','',0,0,0,'','','',NULL),(1210,0,'weatherTomorrowweatherToday','',191,0,'','',0,0,0,'','','',NULL),(1211,0,'weatherToday','',191,0,'','',0,0,0,'','','',NULL),(1212,0,'connect_manualRun','',191,0,'','',0,0,0,'','','',NULL),(1213,0,'clockChimeEnabled','',191,0,'','',0,0,0,'','','',NULL),(1214,0,'lastNewsRead','',191,0,'','',0,0,0,'','','',NULL),(1215,0,'NoolightCommandSend','',191,0,'','',0,0,0,'','','',NULL),(1216,0,'AlreadyPlayedMusic','',191,0,'','',0,0,0,'','','',NULL),(1219,0,'lastSayTime','',191,0,'','',0,0,0,'','','',NULL),(1220,0,'uptime','',191,0,'','',0,0,0,'','','',NULL),(1221,0,'started_time','',191,0,'','',0,0,0,'','','',NULL),(1224,0,'UpdateVersion','',191,0,'','',0,0,0,'','','',NULL),(2755,0,'cycle_mqttRun',NULL,191,0,'','',0,0,0,'','','',NULL),(1227,0,'lastSayMessage','',191,0,'','',0,0,0,'','','',NULL),(1229,0,'runCronUpdater','',191,0,'','',0,0,0,'','','',NULL),(1232,0,'WSClientsTotal','',191,0,'','',0,0,0,'','','',NULL),(1233,0,'timeH','',191,0,'','',0,0,0,'','','',NULL),(1234,0,'timeM','',191,0,'','',0,0,0,'','','',NULL),(1235,0,'DateD','',191,0,'','',0,0,0,'','','',NULL),(1236,0,'DateM','',191,0,'','',0,0,0,'','','',NULL),(1237,0,'DateY','',191,0,'','',0,0,0,'','','',NULL),(1238,0,'Date','',191,0,'','',0,0,0,'','','',NULL),(1239,0,'Day','',191,0,'','',0,0,0,'','','',NULL),(1240,0,'Month','',191,0,'','',0,0,0,'','','',NULL),(1241,0,'MonthAlt','',191,0,'','',0,0,0,'','','',NULL),(1242,0,'LongTagTime','',191,0,'','',0,0,0,'','','',NULL),(1243,0,'TransitTime','',191,0,'','',0,0,0,'','','',NULL),(1244,0,'Chicivil_beginTime','',191,0,'','',0,0,0,'','','',NULL),(1245,0,'civil_endTime','',191,0,'','',0,0,0,'','','',NULL),(1248,0,'tempP1','',191,0,'','',0,0,0,'','','',NULL),(1249,0,'tempP2','',191,0,'','',0,0,0,'','','',NULL),(1250,0,'tempP3','',191,0,'','',0,0,0,'','','',NULL),(1251,0,'tempP4','',191,0,'','',0,0,0,'','','',NULL),(1252,0,'tempP5','',191,0,'','',0,0,0,'','','',NULL),(1253,0,'tempP6','',191,0,'','',0,0,0,'','','',NULL),(1254,0,'tempP7','',191,0,'','',0,0,0,'','','',NULL),(1255,0,'tempP8','',191,0,'','',0,0,0,'','','',NULL),(1256,0,'tempP10','',191,0,'','',0,0,0,'','','',NULL),(1257,0,'cycle_telegram','',191,0,'','',0,0,0,'','','',NULL),(1258,0,'kotel','',191,0,'','',0,0,0,'','','',NULL),(1259,0,'kotel2','',191,0,'','',0,0,0,'','','',NULL),(1288,64,'SNUMB','Заводской номер счетчика',0,0,'','',0,0,0,'','','',NULL),(1289,64,'VOLTA','Действующее значение напряжения [В]',0,30,'','',0,0,0,'','','',NULL),(1290,64,'CURRE','Действующее значение тока [A]',0,30,'','',0,0,0,'','','',NULL),(1291,64,'POWEP','Мгновенное значение мощности [кВт]',0,30,'','',0,0,0,'','','',NULL),(1292,64,'FREQU','Значение частоты сети [Гц]',0,1,'','',0,0,0,'','','',NULL),(1293,64,'COS_f','Значение коэффициента мощности',0,0,'','',0,0,0,'','','',NULL),(1294,64,'ET0PE','Запрос показаний энергии',0,0,'','',0,0,0,'','','',NULL),(1495,0,'wind_direction_text',NULL,233,0,'','',0,0,0,'','','',NULL),(1427,65,'locationTitle',NULL,0,0,'','',0,0,0,'','','',NULL),(1428,65,'latestVisit',NULL,0,0,'','',0,0,0,'','','',NULL),(1429,0,'pctemp',NULL,191,0,'','',0,0,0,'','','',NULL),(1430,0,'CPU_temp',NULL,191,0,'','',0,0,0,'','','',NULL),(1431,0,'CPU_usage',NULL,191,0,'','',0,0,0,'','','',NULL),(1432,0,'System_uptime',NULL,191,0,'','',0,0,0,'','','',NULL),(1433,0,'System_memory',NULL,191,0,'','',0,0,0,'','','',NULL),(1434,0,'System_freespace',NULL,191,0,'','',0,0,0,'','','',NULL),(1435,0,'cpu_load1',NULL,191,0,'','',0,0,0,'','','',NULL),(1436,0,'cpu_load5',NULL,191,0,'','',0,0,0,'','','',NULL),(1437,0,'cpu_load15',NULL,191,0,'','',0,0,0,'','','',NULL),(1438,0,'mem_total',NULL,191,0,'','',0,0,0,'','','',NULL),(1439,0,'mem_free',NULL,191,0,'','',0,0,0,'','','',NULL),(1440,0,'mem_cached',NULL,191,0,'','',0,0,0,'','','',NULL),(1441,0,'mem_swap_total',NULL,191,0,'','',0,0,0,'','','',NULL),(1442,0,'mem_swap_free',NULL,191,0,'','',0,0,0,'','','',NULL),(1443,0,'mem_swap_used',NULL,191,0,'','',0,0,0,'','','',NULL),(1444,0,'mem_used',NULL,191,0,'','',0,0,0,'','','',NULL),(1445,0,'sd_total',NULL,191,0,'','',0,0,0,'','','',NULL),(1446,0,'sd_used',NULL,191,0,'','',0,0,0,'','','',NULL),(1447,0,'sd_free',NULL,191,0,'','',0,0,0,'','','',NULL),(1448,0,'Serial',NULL,191,0,'','',0,0,0,'','','',NULL),(1449,25,'IdleDelay','Nobody here idle delay',0,0,'','',0,0,0,'','','',NULL),(1450,37,'groupEcoOn','Включать при выходе из режима экономии',0,0,'','',0,0,0,'','','',NULL),(1451,37,'isActivity','Изменение означает активность в помещении',0,0,'','',0,0,0,'','','',NULL),(1452,37,'loadType','Тип устройства',0,0,'','',0,0,0,'','','',NULL),(1453,66,'relay_status','Статус реле',0,365,'','',1,0,0,'','','',NULL),(1454,66,'value','Текущая температура',0,365,'valueUpdated','',1,0,0,'','','',NULL),(1455,66,'currentTargetValue','Целевая температура',0,0,'','',1,0,0,'','','',NULL),(1456,66,'normalTargetValue','Обычная целевая температура',0,0,'valueUpdated','',0,0,0,'','','',NULL),(1457,66,'ecoTargetValue','ECO целевая температура',0,0,'valueUpdated','',0,0,0,'','','',NULL),(1458,66,'threshold','Порог срабатывания термостата (0.25 по-умолчанию)',0,0,'valueUpdated','',0,0,0,'','','',NULL),(1459,66,'ncno','Тип устройства/сенсора',0,0,'','',0,0,0,'','','',NULL),(1460,51,'streamTransport','Транспорт потока',0,0,'updatePreview','',0,0,0,'','','',NULL),(1461,51,'previewType','Предпросмотр',0,0,'updatePreview','',0,0,0,'','','',NULL),(1462,51,'clickAction','Действие по нажатию на изображение',0,0,'updatePreview','',0,0,0,'','','',NULL),(1463,51,'snapshotPreviewURL','Snapshot Preview URL',0,0,'','',0,0,0,'','','',NULL),(1464,51,'activeHTML','Active HTML',0,0,'','',0,0,0,'','','',NULL),(1494,0,'wind_direction',NULL,233,0,'','',0,0,0,'','','',NULL),(1493,0,'weather_type',NULL,233,0,'','',0,0,0,'','','',NULL),(1491,0,'countTime',NULL,231,0,'','',0,0,0,'','','',NULL),(1490,0,'forecast_interval',NULL,231,0,'','',0,0,0,'','','',NULL),(1489,0,'updatetime',NULL,231,0,'','',0,0,0,'','','',NULL),(1488,0,'ow_imagecache',NULL,231,0,'','',0,0,0,'','','',NULL),(1487,0,'ow_ws_active',NULL,231,0,'','',0,0,0,'','','',NULL),(1486,0,'ow_round',NULL,231,0,'','',0,0,0,'','','',NULL),(1485,0,'api_method',NULL,231,0,'','',0,0,0,'','','',NULL),(1484,0,'api_key',NULL,231,0,'','',0,0,0,'','','',NULL),(1483,0,'lon',NULL,230,0,'','',0,0,0,'','','',NULL),(1482,0,'lat',NULL,230,0,'','',0,0,0,'','','',NULL),(1481,0,'name',NULL,230,0,'','',0,0,0,'','','',NULL),(1480,0,'id',NULL,230,0,'','',0,0,0,'','','',NULL),(1970,0,'temp_min',NULL,255,0,'','',0,0,0,'','','',NULL),(1969,0,'temp_night',NULL,255,0,'','',0,0,0,'','','',NULL),(1968,0,'temp_eve',NULL,255,0,'','',0,0,0,'','','',NULL),(1967,0,'temp_day',NULL,255,0,'','',0,0,0,'','','',NULL),(1966,0,'temp_morn',NULL,255,0,'','',0,0,0,'','','',NULL),(1965,0,'date',NULL,255,0,'','',0,0,0,'','','',NULL),(1964,0,'civil_twilight_end',NULL,254,0,'','',0,0,0,'','','',NULL),(1963,0,'civil_twilight_begin',NULL,254,0,'','',0,0,0,'','','',NULL),(1962,0,'transit',NULL,254,0,'','',0,0,0,'','','',NULL),(1961,0,'day_length',NULL,254,0,'','',0,0,0,'','','',NULL),(1960,0,'sunset',NULL,254,0,'','',0,0,0,'','','',NULL),(1959,0,'sunrise',NULL,254,0,'','',0,0,0,'','','',NULL),(1958,0,'condCode',NULL,254,0,'','',0,0,0,'','','',NULL),(1957,0,'snow',NULL,254,0,'','',0,0,0,'','','',NULL),(1956,0,'rain',NULL,254,0,'','',0,0,0,'','','',NULL),(1955,0,'clouds',NULL,254,0,'','',0,0,0,'','','',NULL),(1954,0,'image',NULL,254,0,'','',0,0,0,'','','',NULL),(1953,0,'pressure',NULL,254,0,'','',0,0,0,'','','',NULL),(1952,0,'wind_direction_full',NULL,254,0,'','',0,0,0,'','','',NULL),(1951,0,'wind_direction_text',NULL,254,0,'','',0,0,0,'','','',NULL),(1950,0,'wind_direction',NULL,254,0,'','',0,0,0,'','','',NULL),(1949,0,'weather_type',NULL,254,0,'','',0,0,0,'','','',NULL),(1948,0,'temp_max',NULL,254,0,'','',0,0,0,'','','',NULL),(1947,0,'temp_min',NULL,254,0,'','',0,0,0,'','','',NULL),(1946,0,'temp_night',NULL,254,0,'','',0,0,0,'','','',NULL),(1945,0,'temp_eve',NULL,254,0,'','',0,0,0,'','','',NULL),(1944,0,'temp_day',NULL,254,0,'','',0,0,0,'','','',NULL),(1943,0,'temp_morn',NULL,254,0,'','',0,0,0,'','','',NULL),(1942,0,'date',NULL,254,0,'','',0,0,0,'','','',NULL),(1941,0,'civil_twilight_end',NULL,253,0,'','',0,0,0,'','','',NULL),(1940,0,'civil_twilight_begin',NULL,253,0,'','',0,0,0,'','','',NULL),(1939,0,'transit',NULL,253,0,'','',0,0,0,'','','',NULL),(1938,0,'day_length',NULL,253,0,'','',0,0,0,'','','',NULL),(1937,0,'sunset',NULL,253,0,'','',0,0,0,'','','',NULL),(1936,0,'sunrise',NULL,253,0,'','',0,0,0,'','','',NULL),(1881,67,'temperature','',0,30,'','',0,0,0,'','','',NULL),(1935,0,'condCode',NULL,253,0,'','',0,0,0,'','','',NULL),(1934,0,'snow',NULL,253,0,'','',0,0,0,'','','',NULL),(1933,0,'rain',NULL,253,0,'','',0,0,0,'','','',NULL),(1932,0,'clouds',NULL,253,0,'','',0,0,0,'','','',NULL),(1931,0,'image',NULL,253,0,'','',0,0,0,'','','',NULL),(1930,0,'pressure',NULL,253,0,'','',0,0,0,'','','',NULL),(1929,0,'wind_direction_full',NULL,253,0,'','',0,0,0,'','','',NULL),(1699,68,'StreamingCodeMenu',NULL,0,0,'','',0,0,0,'','','',NULL),(1700,68,'StreamingCodeScene',NULL,0,0,'','',0,0,0,'','','',NULL),(1701,68,'menuCSS',NULL,0,0,'','',0,0,0,'','','',NULL),(1702,68,'sceneCSS',NULL,0,0,'','',0,0,0,'','','',NULL),(1703,68,'JS',NULL,0,0,'','',0,0,0,'','','',NULL),(1704,68,'sayTodo',NULL,0,0,'','',0,0,0,'','','',NULL),(1705,68,'todo',NULL,0,0,'','',0,0,0,'','','',NULL),(1928,0,'wind_direction_text',NULL,253,0,'','',0,0,0,'','','',NULL),(1927,0,'wind_direction',NULL,253,0,'','',0,0,0,'','','',NULL),(1926,0,'weather_type',NULL,253,0,'','',0,0,0,'','','',NULL),(1925,0,'temp_max',NULL,253,0,'','',0,0,0,'','','',NULL),(1924,0,'temp_min',NULL,253,0,'','',0,0,0,'','','',NULL),(1923,0,'temp_night',NULL,253,0,'','',0,0,0,'','','',NULL),(1922,0,'temp_eve',NULL,253,0,'','',0,0,0,'','','',NULL),(1921,0,'temp_day',NULL,253,0,'','',0,0,0,'','','',NULL),(1920,0,'temp_morn',NULL,253,0,'','',0,0,0,'','','',NULL),(1919,0,'date',NULL,253,0,'','',0,0,0,'','','',NULL),(1918,0,'civil_twilight_end',NULL,252,0,'','',0,0,0,'','','',NULL),(1917,0,'civil_twilight_begin',NULL,252,0,'','',0,0,0,'','','',NULL),(1916,0,'transit',NULL,252,0,'','',0,0,0,'','','',NULL),(1915,0,'day_length',NULL,252,0,'','',0,0,0,'','','',NULL),(1914,0,'sunset',NULL,252,0,'','',0,0,0,'','','',NULL),(1913,0,'sunrise',NULL,252,0,'','',0,0,0,'','','',NULL),(1912,0,'condCode',NULL,252,0,'','',0,0,0,'','','',NULL),(1911,0,'snow',NULL,252,0,'','',0,0,0,'','','',NULL),(1910,0,'rain',NULL,252,0,'','',0,0,0,'','','',NULL),(1878,67,'humidity','',0,30,'','',0,0,0,'','','',NULL),(1879,67,'pressure_mmhg','',0,30,'','',0,0,0,'','','',NULL),(1880,67,'wind_speed','',0,30,'','',0,0,0,'','','',NULL),(1909,0,'clouds',NULL,252,0,'','',0,0,0,'','','',NULL),(1908,0,'image',NULL,252,0,'','',0,0,0,'','','',NULL),(1907,0,'pressure',NULL,252,0,'','',0,0,0,'','','',NULL),(1906,0,'wind_direction_full',NULL,252,0,'','',0,0,0,'','','',NULL),(1905,0,'wind_direction_text',NULL,252,0,'','',0,0,0,'','','',NULL),(1904,0,'wind_direction',NULL,252,0,'','',0,0,0,'','','',NULL),(1903,0,'weather_type',NULL,252,0,'','',0,0,0,'','','',NULL),(1902,0,'temp_max',NULL,252,0,'','',0,0,0,'','','',NULL),(1901,0,'temp_min',NULL,252,0,'','',0,0,0,'','','',NULL),(1900,0,'temp_night',NULL,252,0,'','',0,0,0,'','','',NULL),(1899,0,'temp_eve',NULL,252,0,'','',0,0,0,'','','',NULL),(1898,0,'temp_day',NULL,252,0,'','',0,0,0,'','','',NULL),(1897,0,'temp_morn',NULL,252,0,'','',0,0,0,'','','',NULL),(1896,0,'date',NULL,252,0,'','',0,0,0,'','','',NULL),(2013,0,'temp_day',NULL,257,0,'','',0,0,0,'','','',NULL),(2014,0,'temp_eve',NULL,257,0,'','',0,0,0,'','','',NULL),(2015,0,'temp_night',NULL,257,0,'','',0,0,0,'','','',NULL),(2016,0,'temp_min',NULL,257,0,'','',0,0,0,'','','',NULL),(2017,0,'temp_max',NULL,257,0,'','',0,0,0,'','','',NULL),(2018,0,'weather_type',NULL,257,0,'','',0,0,0,'','','',NULL),(2019,0,'wind_direction',NULL,257,0,'','',0,0,0,'','','',NULL),(2020,0,'wind_direction_text',NULL,257,0,'','',0,0,0,'','','',NULL),(2021,0,'wind_direction_full',NULL,257,0,'','',0,0,0,'','','',NULL),(2022,0,'pressure',NULL,257,0,'','',0,0,0,'','','',NULL),(2023,0,'image',NULL,257,0,'','',0,0,0,'','','',NULL),(2024,0,'clouds',NULL,257,0,'','',0,0,0,'','','',NULL),(2025,0,'rain',NULL,257,0,'','',0,0,0,'','','',NULL),(2026,0,'snow',NULL,257,0,'','',0,0,0,'','','',NULL),(2027,0,'condCode',NULL,257,0,'','',0,0,0,'','','',NULL),(2028,0,'sunrise',NULL,257,0,'','',0,0,0,'','','',NULL),(2029,0,'sunset',NULL,257,0,'','',0,0,0,'','','',NULL),(2030,0,'day_length',NULL,257,0,'','',0,0,0,'','','',NULL),(2031,0,'transit',NULL,257,0,'','',0,0,0,'','','',NULL),(2032,0,'civil_twilight_begin',NULL,257,0,'','',0,0,0,'','','',NULL),(2033,0,'civil_twilight_end',NULL,257,0,'','',0,0,0,'','','',NULL),(2034,0,'date',NULL,258,0,'','',0,0,0,'','','',NULL),(2035,0,'temp_morn',NULL,258,0,'','',0,0,0,'','','',NULL),(2036,0,'temp_day',NULL,258,0,'','',0,0,0,'','','',NULL),(2037,0,'temp_eve',NULL,258,0,'','',0,0,0,'','','',NULL),(2038,0,'temp_night',NULL,258,0,'','',0,0,0,'','','',NULL),(2039,0,'temp_min',NULL,258,0,'','',0,0,0,'','','',NULL),(2040,0,'temp_max',NULL,258,0,'','',0,0,0,'','','',NULL),(2041,0,'weather_type',NULL,258,0,'','',0,0,0,'','','',NULL),(2042,0,'wind_direction',NULL,258,0,'','',0,0,0,'','','',NULL),(2043,0,'wind_direction_text',NULL,258,0,'','',0,0,0,'','','',NULL),(2044,0,'wind_direction_full',NULL,258,0,'','',0,0,0,'','','',NULL),(2045,0,'pressure',NULL,258,0,'','',0,0,0,'','','',NULL),(2046,0,'image',NULL,258,0,'','',0,0,0,'','','',NULL),(2047,0,'clouds',NULL,258,0,'','',0,0,0,'','','',NULL),(2048,0,'rain',NULL,258,0,'','',0,0,0,'','','',NULL),(2049,0,'snow',NULL,258,0,'','',0,0,0,'','','',NULL),(2050,0,'condCode',NULL,258,0,'','',0,0,0,'','','',NULL),(2051,0,'sunrise',NULL,258,0,'','',0,0,0,'','','',NULL),(2052,0,'sunset',NULL,258,0,'','',0,0,0,'','','',NULL),(2053,0,'day_length',NULL,258,0,'','',0,0,0,'','','',NULL),(2054,0,'transit',NULL,258,0,'','',0,0,0,'','','',NULL),(2055,0,'civil_twilight_begin',NULL,258,0,'','',0,0,0,'','','',NULL),(2056,0,'civil_twilight_end',NULL,258,0,'','',0,0,0,'','','',NULL),(2057,0,'security',NULL,191,0,'','',0,0,0,'','','',NULL),(2059,0,'date1',NULL,270,0,'','',0,0,0,'','','',NULL),(2060,0,'date2',NULL,270,0,'','',0,0,0,'','','',NULL),(2061,0,'rurnbu',NULL,270,0,'','',0,0,0,'','','',NULL),(2062,0,'usdnbu',NULL,270,0,'','',0,0,0,'','','',NULL),(2063,0,'euronbu',NULL,270,0,'','',0,0,0,'','','',NULL),(2064,0,'rurbuy',NULL,270,0,'','',0,0,0,'','','',NULL),(2065,0,'rursale',NULL,270,0,'','',0,0,0,'','','',NULL),(2066,0,'dollarrur',NULL,270,0,'','',0,0,0,'','','',NULL),(2067,0,'eurorur',NULL,270,0,'','',0,0,0,'','','',NULL),(2070,71,'temp','температура',0,30,'','',0,0,0,'','','',NULL),(2071,71,'hum','влажность',0,30,'','',0,0,0,'','','',NULL),(2072,71,'press_kpa','давление',0,30,'','',0,0,0,'','','',NULL),(2073,71,'bat','заряд батареи',0,0,'','',0,0,0,'','','',NULL),(2074,71,'press_mm','',0,30,'','',0,0,0,'','','',NULL),(2075,73,'status','открыто или закрыто',0,0,'','',0,0,0,'','','',NULL),(2076,73,'bat','заряд батареи',0,0,'','',0,0,0,'','','',NULL),(2077,72,'motion','движение',0,0,'','',0,0,0,'','','',NULL),(2078,72,'no_motion','',0,0,'','',0,0,0,'','','',NULL),(2079,72,'bat','заряд батареи',0,0,'','',0,0,0,'','','',NULL),(2080,76,'rgb','цвет',0,0,'','',0,0,0,'','','',NULL),(2081,76,'brightness','яркость',0,0,'','',0,0,0,'','','',NULL),(2082,76,'illumination','',0,0,'','',0,0,0,'','','',NULL),(2083,0,'rgb',NULL,277,0,'','',0,0,0,'','','',NULL),(2084,0,'brightness',NULL,277,0,'','',0,0,0,'','','',NULL),(2085,0,'illumination',NULL,277,0,'','',0,0,0,'','','',NULL),(2086,0,'eurobuy',NULL,270,0,'','',0,0,0,'','','',NULL),(2087,0,'eurosale',NULL,270,0,'','',0,0,0,'','','',NULL),(2088,0,'usdbuy',NULL,270,0,'','',0,0,0,'','','',NULL),(2089,0,'usdsale',NULL,270,0,'','',0,0,0,'','','',NULL),(2090,0,'date3',NULL,270,0,'','',0,0,0,'','','',NULL),(2092,37,'icon','Изображение',0,0,'','',0,0,0,'','','',NULL),(2093,40,'timeout','Время активности (секунд)',0,0,'','',0,0,0,'','','',NULL),(2094,51,'series','Снимок',0,30,'','',0,5,0,'','','',NULL),(2095,54,'valueWork','Work Value',0,0,'valueWorkUpdated','',0,0,0,'','','',NULL),(2096,54,'valueHour','Hour Value',0,365,'','',0,0,0,'','','',NULL),(2097,54,'valueDay','Day Value',0,1825,'','',0,0,0,'','','',NULL),(2098,54,'valueMonth','Month Value',0,1825,'','',0,0,0,'','','',NULL),(2099,54,'conversion','Conversion coefficient (work-to-data)',0,0,'','',0,0,0,'','','',NULL),(2100,42,'icon','Изображение',0,0,'','',0,0,0,'','','',NULL),(2101,39,'levelWork','Brightness level (work)',0,0,'levelWorkUpdated','',0,0,0,'','','',NULL),(2102,39,'minWork','Мин. уровень (рабочий)',0,0,'','',0,0,0,'','','',NULL),(2103,39,'maxWork','Макс. уровень (рабочий)',0,0,'','',0,0,0,'','','',NULL),(2104,43,'direction','Direction of changes',0,0,'','',0,0,0,'','','',NULL),(2105,43,'directionTimeout','Интервал времени расчета направления изменений (сек)',0,0,'valueUpdated','',0,0,0,'','','',NULL),(2106,77,'unit','Единица измерения',0,0,'','',0,0,0,'','','',NULL),(2107,58,'loadStatusTimeout','Таймер изменения статуса нагрузки',0,0,'','',0,0,0,'','','',NULL),(2108,34,'Category','Категория',0,0,'','',0,0,0,'','','',NULL),(2109,0,'date4',NULL,270,0,'','',0,0,0,'','','',NULL),(2110,0,'kztusd',NULL,270,0,'','',0,0,0,'','','',NULL),(2111,0,'kzteur',NULL,270,0,'','',0,0,0,'','','',NULL),(2120,0,'LatestUpdateId',NULL,191,0,'','',0,0,0,'','','',NULL),(2121,0,'LatestUpdateTimestamp',NULL,191,0,'','',0,0,0,'','','',NULL),(2122,66,'disabled','Disabled',0,0,'','',0,0,0,'','','',NULL),(2123,50,'brightness','Current brightness',0,0,'colorUpdated','',0,0,0,'','','',NULL),(2124,41,'notify_status','Уведомлять при смене статуса',0,0,'','',0,0,0,'','','',NULL),(2125,41,'notify_nc','Напоминать об открытом состоянии',0,0,'','',0,0,0,'','','',NULL),(2181,78,'data','Данные',0,0,'','',0,0,0,'','','',NULL),(2758,0,'cycle_statesRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2752,0,'cycle_db_saveRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2374,37,'groupSunset','Включать с закатом',0,0,'','',0,0,0,'','','',NULL),(2375,37,'groupNight','Выключать при входе в ночной режим',0,0,'','',0,0,0,'','','',NULL),(2376,79,'groupName','Group system name',0,0,'','',0,0,0,'','','',NULL),(2377,39,'levelSaved','Latest level saved',0,0,'','',0,0,0,'','','',NULL),(2378,39,'setMaxTurnOn','Устанавливать максимальную яркость при включении',0,0,'','',0,0,0,'','','',NULL),(2379,40,'resetNobodysHome','Сброс статуса \"никого нет дома\" без таймера установки',0,0,'','',0,0,0,'','','',NULL),(2380,40,'blocked','Is blocked',0,0,'','',0,0,0,'','','',NULL),(2381,51,'ignoreNobodysHome','Игнорировать события от устройства, когда никого нет дома',0,0,'','',0,0,0,'','','',NULL),(2382,51,'timeout','Время активности (секунд)',0,0,'','',0,0,0,'','','',NULL),(2383,41,'blocked','Is blocked',0,0,'','',0,0,0,'','','',NULL),(2384,80,'notify_status','Уведомлять при смене статуса',0,0,'','',0,0,0,'','','',NULL),(2385,80,'notify_nc','Напоминать об открытом состоянии',0,0,'','',0,0,0,'','','',NULL),(2386,80,'openType','Тип устройства',0,0,'','',0,0,0,'','','',NULL),(2387,52,'notify_eliminated','Уведомлять каждую минуту до восстановления статуса',0,0,'','',0,0,0,'','','',NULL),(2388,52,'blocked','Is blocked',0,0,'','',0,0,0,'','','',NULL),(2389,53,'notify_eliminated','Уведомлять каждую минуту до восстановления статуса',0,0,'','',0,0,0,'','','',NULL),(2390,53,'blocked','Is blocked',0,0,'','',0,0,0,'','','',NULL),(2391,43,'notify_eliminated','Уведомлять каждую минуту до восстановления статуса',0,0,'','',0,0,0,'','','',NULL),(2392,43,'blocked','Is blocked',0,0,'','',0,0,0,'','','',NULL),(2417,0,'uptimeText',NULL,191,0,'','',0,0,0,'','','',NULL),(2442,0,'dollarbyn',NULL,270,0,'','',0,0,0,'','','',NULL),(2443,0,'eurobyn',NULL,270,0,'','',0,0,0,'','','',NULL),(2444,0,'date5',NULL,270,0,'','',0,0,0,'','','',NULL),(2751,0,'cycle_webvarsRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2756,0,'cycle_schedulerRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2757,0,'cycle_rss_channelsRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2747,0,'cycle_cronRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2748,0,'cycle_telegramRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2495,81,'temp','Фактическая температура',0,30,'Changetemp','',0,0,0,'','','',NULL),(2496,81,'wind_speed','Скорость ветра',0,30,'','',0,0,0,'','','',NULL),(2497,81,'condition','Состояние погоды',0,30,'ChangeCondition','',0,0,0,'','','',NULL),(2498,81,'locality_name','Название населенного пункта',0,0,'','',0,0,0,'','','',NULL),(2499,81,'conditionrus','Состояние погоды сейчас по русски',0,0,'','',0,0,0,'','','',NULL),(2500,81,'condition1rus','Состояние погоды на завтра  по русски',0,0,'','',0,0,0,'','','',NULL),(2501,81,'condition2rus','Состояние погоды на после-завтра  по русски',0,0,'','',0,0,0,'','','',NULL),(2502,81,'condition3rus','Состояние погоды на после-после-завтра  по русски',0,0,'','',0,0,0,'','','',NULL),(2503,81,'pressure_pa',' Нормальное давление для заданных координат, кПА',0,30,'','',0,0,0,'','','',NULL),(2504,81,'pressure_mm','Атмосферное давление, ммртст.',0,10,'','',0,0,0,'','','',NULL),(2505,81,'now','Когда обновлена инфомация',0,2,'OnChange','',0,0,0,'','','',NULL),(2506,81,'humidity','Текущая влажность',0,10,'','',0,0,0,'','','',NULL),(2507,81,'wind_dir','Направление ветра',0,10,'','',0,0,0,'','','',NULL),(2508,81,'phenom','',0,10,'','',0,0,0,'','','',NULL),(2509,81,'soil_temp','Ощущение погоды',0,10,'','',0,0,0,'','','',NULL),(2510,81,'uv_index','УФ-индекс',0,10,'','',0,0,0,'','','',NULL),(2761,0,'cycle_websocketsRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2512,0,'forecast_0_date',NULL,280,0,'','',0,0,0,'','','',NULL),(2513,0,'forecast_1_date',NULL,280,0,'','',0,0,0,'','','',NULL),(2514,0,'forecast_2_date',NULL,280,0,'','',0,0,0,'','','',NULL),(2515,0,'forecast_3_date',NULL,280,0,'','',0,0,0,'','','',NULL),(2516,0,'TITLE',NULL,280,0,'','',0,0,0,'','','',NULL),(2517,0,'TITLE',NULL,279,0,'','',0,0,0,'','','',NULL),(2518,0,'CID',NULL,280,0,'','',0,0,0,'','','',NULL),(2519,0,'CID',NULL,279,0,'','',0,0,0,'','','',NULL),(2520,0,'mycity',NULL,280,0,'','',0,0,0,'','','',NULL),(2521,0,'mycity',NULL,279,0,'','',0,0,0,'','','',NULL),(2522,0,'DESCRIPTION',NULL,280,0,'','',0,0,0,'','','',NULL),(2523,0,'DESCRIPTION',NULL,279,0,'','',0,0,0,'','','',NULL),(2524,0,'trandtemp-3',NULL,279,0,'','',0,0,0,'','','',NULL),(2525,0,'trandtemp',NULL,279,0,'','',0,0,0,'','','',NULL),(2526,0,'trandtempfa',NULL,279,0,'','',0,0,0,'','','',NULL),(2527,0,'feels_like',NULL,280,0,'','',0,0,0,'','','',NULL),(2528,0,'feels_like',NULL,279,0,'','',0,0,0,'','','',NULL),(2529,0,'lastcondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2530,0,'daytime',NULL,280,0,'','',0,0,0,'','','',NULL),(2531,0,'daytime',NULL,279,0,'','',0,0,0,'','','',NULL),(2532,0,'polar',NULL,280,0,'','',0,0,0,'','','',NULL),(2533,0,'polar',NULL,279,0,'','',0,0,0,'','','',NULL),(2534,0,'season',NULL,280,0,'','',0,0,0,'','','',NULL),(2535,0,'season',NULL,279,0,'','',0,0,0,'','','',NULL),(2536,0,'forecast_0_sunrise',NULL,280,0,'','',0,0,0,'','','',NULL),(2537,0,'forecast_0_sunrise',NULL,279,0,'','',0,0,0,'','','',NULL),(2538,0,'forecast_0_sunset',NULL,280,0,'','',0,0,0,'','','',NULL),(2539,0,'forecast_0_sunset',NULL,279,0,'','',0,0,0,'','','',NULL),(2540,0,'forecast_0_week',NULL,280,0,'','',0,0,0,'','','',NULL),(2541,0,'forecast_0_week',NULL,279,0,'','',0,0,0,'','','',NULL),(2542,0,'forecast_0_rise_begin',NULL,280,0,'','',0,0,0,'','','',NULL),(2543,0,'forecast_0_rise_begin',NULL,279,0,'','',0,0,0,'','','',NULL),(2544,0,'forecast_0_set_end',NULL,280,0,'','',0,0,0,'','','',NULL),(2545,0,'forecast_0_set_end',NULL,279,0,'','',0,0,0,'','','',NULL),(2546,0,'forecast_0_night_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2547,0,'forecast_0_night_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2548,0,'forecast_0_night_wind_speed',NULL,280,0,'','',0,0,0,'','','',NULL),(2549,0,'forecast_0_night_wind_speed',NULL,279,0,'','',0,0,0,'','','',NULL),(2550,0,'forecast_0_night_wind_dir',NULL,280,0,'','',0,0,0,'','','',NULL),(2551,0,'forecast_0_night_wind_dir',NULL,279,0,'','',0,0,0,'','','',NULL),(2552,0,'forecast_0_nightcondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2553,0,'forecast_0_nightcondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2554,0,'forecast_0_morning_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2555,0,'forecast_0_morning_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2556,0,'forecast_0_morning_wind_speed',NULL,280,0,'','',0,0,0,'','','',NULL),(2557,0,'forecast_0_morning_wind_speed',NULL,279,0,'','',0,0,0,'','','',NULL),(2558,0,'forecast_0_morning_wind_dir',NULL,280,0,'','',0,0,0,'','','',NULL),(2559,0,'forecast_0_morning_wind_dir',NULL,279,0,'','',0,0,0,'','','',NULL),(2560,0,'forecast_0_morning_pressure_mm',NULL,280,0,'','',0,0,0,'','','',NULL),(2561,0,'forecast_0_morning_pressure_mm',NULL,279,0,'','',0,0,0,'','','',NULL),(2562,0,'forecast_0_morningcondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2563,0,'forecast_0_morningcondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2564,0,'forecast_0_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2565,0,'forecast_0_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2566,0,'forecast_0_day_wind_speed',NULL,280,0,'','',0,0,0,'','','',NULL),(2567,0,'forecast_0_day_wind_speed',NULL,279,0,'','',0,0,0,'','','',NULL),(2568,0,'forecast_0_day_wind_dir',NULL,280,0,'','',0,0,0,'','','',NULL),(2569,0,'forecast_0_day_wind_dir',NULL,279,0,'','',0,0,0,'','','',NULL),(2570,0,'forecast_0_day_pressure_mm',NULL,280,0,'','',0,0,0,'','','',NULL),(2571,0,'forecast_0_day_pressure_mm',NULL,279,0,'','',0,0,0,'','','',NULL),(2572,0,'forecast_0_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2573,0,'forecast_0_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2574,0,'forecast_0_evening_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2575,0,'forecast_0_evening_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2576,0,'forecast_0_evening_wind_speed',NULL,280,0,'','',0,0,0,'','','',NULL),(2577,0,'forecast_0_evening_wind_speed',NULL,279,0,'','',0,0,0,'','','',NULL),(2578,0,'forecast_0_evening_wind_dir',NULL,280,0,'','',0,0,0,'','','',NULL),(2579,0,'forecast_0_evening_wind_dir',NULL,279,0,'','',0,0,0,'','','',NULL),(2580,0,'forecast_0_evening_pressure_mm',NULL,280,0,'','',0,0,0,'','','',NULL),(2581,0,'forecast_0_evening_pressure_mm',NULL,279,0,'','',0,0,0,'','','',NULL),(2582,0,'forecast_0_eveningcondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2583,0,'forecast_0_eveningcondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2584,0,'forecast_0_night_short_pressure_mm',NULL,280,0,'','',0,0,0,'','','',NULL),(2585,0,'forecast_0_night_short_pressure_mm',NULL,279,0,'','',0,0,0,'','','',NULL),(2586,0,'forecast_1_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2587,0,'forecast_1_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2588,0,'forecast_1_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2589,0,'forecast_1_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2590,0,'forecast_2_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2591,0,'forecast_2_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2592,0,'forecast_2_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2593,0,'forecast_2_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2594,0,'forecast_3_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2595,0,'forecast_3_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2596,0,'forecast_3_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2597,0,'forecast_3_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2762,0,'cycle_wscacheRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2599,0,'ID',NULL,280,0,'','',0,0,0,'','','',NULL),(2600,0,'ID',NULL,279,0,'','',0,0,0,'','','',NULL),(2601,0,'district_name',NULL,280,0,'','',0,0,0,'','','',NULL),(2602,0,'district_name',NULL,279,0,'','',0,0,0,'','','',NULL),(2603,0,'trandpres',NULL,279,0,'','',0,0,0,'','','',NULL),(2604,0,'trandpresfa',NULL,279,0,'','',0,0,0,'','','',NULL),(2605,0,'trandhum',NULL,279,0,'','',0,0,0,'','','',NULL),(2606,0,'trandhumfa',NULL,279,0,'','',0,0,0,'','','',NULL),(2607,0,'trandwind_speed',NULL,279,0,'','',0,0,0,'','','',NULL),(2608,0,'forecast_4_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2609,0,'forecast_4_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2610,0,'forecast_5_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2611,0,'forecast_5_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2612,0,'forecast_6_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2613,0,'forecast_6_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2614,0,'forecast_7_day_temp_avg',NULL,280,0,'','',0,0,0,'','','',NULL),(2615,0,'forecast_7_day_temp_avg',NULL,279,0,'','',0,0,0,'','','',NULL),(2616,0,'forecast_4_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2617,0,'forecast_4_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2618,0,'forecast_5_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2619,0,'forecast_5_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2620,0,'forecast_6_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2621,0,'forecast_6_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2622,0,'forecast_7_daycondition',NULL,280,0,'','',0,0,0,'','','',NULL),(2623,0,'forecast_7_daycondition',NULL,279,0,'','',0,0,0,'','','',NULL),(2624,0,'day',NULL,280,0,'','',0,0,0,'','','',NULL),(2625,0,'day',NULL,279,0,'','',0,0,0,'','','',NULL),(2626,0,'date',NULL,280,0,'','',0,0,0,'','','',NULL),(2627,0,'date',NULL,279,0,'','',0,0,0,'','','',NULL),(2628,0,'date_ts',NULL,280,0,'','',0,0,0,'','','',NULL),(2629,0,'date_ts',NULL,279,0,'','',0,0,0,'','','',NULL),(2630,0,'forecast_0_moon_code',NULL,280,0,'','',0,0,0,'','','',NULL),(2631,0,'forecast_0_moon_code',NULL,279,0,'','',0,0,0,'','','',NULL),(2632,0,'forecast_0_moon_text',NULL,280,0,'','',0,0,0,'','','',NULL),(2633,0,'forecast_0_moon_text',NULL,279,0,'','',0,0,0,'','','',NULL),(2634,0,'forecast_0_date',NULL,281,0,'','',0,0,0,'','','',NULL),(2635,0,'forecast_1_date',NULL,281,0,'','',0,0,0,'','','',NULL),(2636,0,'forecast_2_date',NULL,281,0,'','',0,0,0,'','','',NULL),(2637,0,'forecast_3_date',NULL,281,0,'','',0,0,0,'','','',NULL),(2638,0,'TITLE',NULL,281,0,'','',0,0,0,'','','',NULL),(2639,0,'CID',NULL,281,0,'','',0,0,0,'','','',NULL),(2640,0,'mycity',NULL,281,0,'','',0,0,0,'','','',NULL),(2641,0,'DESCRIPTION',NULL,281,0,'','',0,0,0,'','','',NULL),(2642,0,'feels_like',NULL,281,0,'','',0,0,0,'','','',NULL),(2643,0,'daytime',NULL,281,0,'','',0,0,0,'','','',NULL),(2644,0,'polar',NULL,281,0,'','',0,0,0,'','','',NULL),(2645,0,'season',NULL,281,0,'','',0,0,0,'','','',NULL),(2646,0,'forecast_0_sunrise',NULL,281,0,'','',0,0,0,'','','',NULL),(2647,0,'forecast_0_sunset',NULL,281,0,'','',0,0,0,'','','',NULL),(2648,0,'forecast_0_week',NULL,281,0,'','',0,0,0,'','','',NULL),(2649,0,'forecast_0_rise_begin',NULL,281,0,'','',0,0,0,'','','',NULL),(2650,0,'forecast_0_set_end',NULL,281,0,'','',0,0,0,'','','',NULL),(2651,0,'forecast_0_night_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2652,0,'forecast_0_night_wind_speed',NULL,281,0,'','',0,0,0,'','','',NULL),(2653,0,'forecast_0_night_wind_dir',NULL,281,0,'','',0,0,0,'','','',NULL),(2654,0,'forecast_0_nightcondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2655,0,'forecast_0_morning_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2656,0,'forecast_0_morning_wind_speed',NULL,281,0,'','',0,0,0,'','','',NULL),(2657,0,'forecast_0_morning_wind_dir',NULL,281,0,'','',0,0,0,'','','',NULL),(2658,0,'forecast_0_morning_pressure_mm',NULL,281,0,'','',0,0,0,'','','',NULL),(2659,0,'forecast_0_morningcondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2660,0,'forecast_0_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2661,0,'forecast_0_day_wind_speed',NULL,281,0,'','',0,0,0,'','','',NULL),(2662,0,'forecast_0_day_wind_dir',NULL,281,0,'','',0,0,0,'','','',NULL),(2663,0,'forecast_0_day_pressure_mm',NULL,281,0,'','',0,0,0,'','','',NULL),(2664,0,'forecast_0_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2665,0,'forecast_0_evening_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2666,0,'forecast_0_evening_wind_speed',NULL,281,0,'','',0,0,0,'','','',NULL),(2667,0,'forecast_0_evening_wind_dir',NULL,281,0,'','',0,0,0,'','','',NULL),(2668,0,'forecast_0_evening_pressure_mm',NULL,281,0,'','',0,0,0,'','','',NULL),(2669,0,'forecast_0_eveningcondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2670,0,'forecast_0_night_short_pressure_mm',NULL,281,0,'','',0,0,0,'','','',NULL),(2671,0,'forecast_1_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2672,0,'forecast_1_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2673,0,'forecast_2_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2674,0,'forecast_2_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2675,0,'forecast_3_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2676,0,'forecast_3_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2677,0,'ID',NULL,281,0,'','',0,0,0,'','','',NULL),(2678,0,'district_name',NULL,281,0,'','',0,0,0,'','','',NULL),(2679,0,'forecast_4_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2680,0,'forecast_5_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2681,0,'forecast_6_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2682,0,'forecast_7_day_temp_avg',NULL,281,0,'','',0,0,0,'','','',NULL),(2683,0,'forecast_4_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2684,0,'forecast_5_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2685,0,'forecast_6_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2686,0,'forecast_7_daycondition',NULL,281,0,'','',0,0,0,'','','',NULL),(2687,0,'day',NULL,281,0,'','',0,0,0,'','','',NULL),(2688,0,'date',NULL,281,0,'','',0,0,0,'','','',NULL),(2689,0,'date_ts',NULL,281,0,'','',0,0,0,'','','',NULL),(2690,0,'forecast_0_moon_code',NULL,281,0,'','',0,0,0,'','','',NULL),(2691,0,'forecast_0_moon_text',NULL,281,0,'','',0,0,0,'','','',NULL),(2754,0,'cycle_xiaomihomeRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2745,0,'cycle_pingRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2746,0,'cycle_mainRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2716,62,'tu','установленная температура',0,0,'','',0,0,0,'','','',NULL),(2763,0,'cycle_skypeRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2760,0,'cycle_yandexweatherRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2759,0,'cycle_execsRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2750,0,'cycle_energomeraRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2749,0,'cycle_phistoryRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2764,0,'cycle_mysensorRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2765,0,'cycle_onewireRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2766,0,'cycle_connectRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2767,0,'cycle_onewire_starredRun',NULL,191,0,'','',0,0,0,'','','',NULL),(2768,0,'cycle_X101_skypeRun',NULL,191,0,'','',0,0,0,'','','',NULL);
/*!40000 ALTER TABLE `properties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `public_calls`
--

DROP TABLE IF EXISTS `public_calls`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `public_calls` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(255) NOT NULL DEFAULT '',
  `PUBLIC_USERNAME` varchar(255) NOT NULL DEFAULT '',
  `PUBLIC_PASSWORD` varchar(255) NOT NULL DEFAULT '',
  `PUBLIC_KEY` varchar(255) NOT NULL DEFAULT '',
  `PROTECTED` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `public_calls`
--

LOCK TABLES `public_calls` WRITE;
/*!40000 ALTER TABLE `public_calls` DISABLE KEYS */;
/*!40000 ALTER TABLE `public_calls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pvalues`
--

DROP TABLE IF EXISTS `pvalues`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pvalues` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PROPERTY_ID` int(10) NOT NULL DEFAULT '0',
  `OBJECT_ID` int(10) NOT NULL DEFAULT '0',
  `VALUE` text NOT NULL,
  `UPDATED` datetime DEFAULT NULL,
  `PROPERTY_NAME` varchar(100) NOT NULL DEFAULT '',
  `LINKED_MODULES` varchar(255) NOT NULL DEFAULT '',
  `SOURCE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`),
  KEY `PROPERTY_ID` (`PROPERTY_ID`),
  KEY `OBJECT_ID` (`OBJECT_ID`),
  KEY `PROPERTY_NAME` (`PROPERTY_NAME`)
) ENGINE=MyISAM AUTO_INCREMENT=2914 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pvalues`
--

LOCK TABLES `pvalues` WRITE;
/*!40000 ALTER TABLE `pvalues` DISABLE KEYS */;
INSERT INTO `pvalues` VALUES (1399,1284,199,'0','2020-01-28 20:15:00','clapan8.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1398,1284,198,'1','2020-01-28 20:15:00','clapan7.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1397,1284,197,'1','2020-01-28 20:15:00','clapan6.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(24,12,6,'2020-01-28 20:15:00','2020-01-28 20:15:00','ClockChime.time','',''),(1385,1237,191,'2020','2020-01-28 00:00:00','ThisComputer.DateY','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1386,1238,191,'28.01.2020','2020-01-28 00:00:00','ThisComputer.Date','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1387,1239,191,'вторник','2020-01-28 00:00:00','ThisComputer.Day','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1388,1240,191,'января','2020-01-28 00:00:00','ThisComputer.Month','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1389,1241,191,'ЯНВАРЬ','2020-01-28 00:00:00','ThisComputer.MonthAlt','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1390,1282,191,'ЯНВ','2020-01-28 00:00:00','ThisComputer.MonthShrt','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1391,1283,191,'20','2020-01-28 20:00:00','ThisComputer.timeHH','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1392,1284,192,'1','2020-01-28 20:15:00','clapan1.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1393,1284,193,'0','2020-01-28 20:15:00','clapan2.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1394,1284,194,'1','2020-01-28 20:15:00','clapan3.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1395,1284,195,'0','2020-01-28 20:15:00','clapan4.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1396,1284,196,'1','2020-01-28 20:15:00','clapan5.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1383,1235,191,'28','2020-01-28 00:00:00','ThisComputer.DateD','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1384,1236,191,'01','2020-01-28 00:00:00','ThisComputer.DateM','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(186,54,51,'Hall','2014-09-04 12:12:08','MotionSensor1.LinkedRoom','',''),(1382,1281,191,'-0','2018-01-13 08:00:02','ThisComputer.reelFeel','',''),(1409,1221,191,'1580161739','2020-01-28 00:48:59','ThisComputer.started_time','',''),(65,24,15,'','0000-00-00 00:00:00','ws.tempOutside','',''),(66,25,15,'','0000-00-00 00:00:00','ws.relHumOutside','',''),(67,26,15,'','0000-00-00 00:00:00','ws.dewPoint','',''),(68,27,15,'','0000-00-00 00:00:00','ws.windLatest','',''),(69,28,15,'','0000-00-00 00:00:00','ws.windAverage','',''),(70,29,15,'','0000-00-00 00:00:00','ws.rainfallRate','',''),(71,30,15,'','0000-00-00 00:00:00','ws.rainfallHour','',''),(72,31,15,'','0000-00-00 00:00:00','ws.rainfall24','',''),(73,32,15,'','0000-00-00 00:00:00','ws.pressure','',''),(74,33,15,'','0000-00-00 00:00:00','ws.pressureTrend','',''),(75,34,15,'','0000-00-00 00:00:00','ws.windDirection','',''),(76,35,15,'','0000-00-00 00:00:00','ws.windDirectionAverage','',''),(77,36,15,'26','2014-09-03 12:12:37','ws.TempInside','',''),(78,37,15,'','0000-00-00 00:00:00','ws.relHumInside','',''),(79,38,15,'0','0000-00-00 00:00:00','ws.pressureRt','',''),(93,42,17,'green','2019-12-16 22:54:31','System.stateColor','',''),(94,76,17,'Зелёный','2019-12-16 22:54:31','System.stateTitle','',''),(95,42,18,'green','2020-01-27 16:29:05','Communication.stateColor','',''),(96,77,18,'Зелёный','2020-01-27 16:29:05','Communication.stateTitle','',''),(97,42,16,'green','2013-08-09 13:29:00','Security.stateColor','',''),(98,78,16,'Green','2013-08-09 13:29:00','Security.stateTitle','',''),(99,41,17,'','2019-12-16 22:54:31','System.stateDetails','',''),(310,136,68,'10:00','2015-12-03 14:47:55','admin.CoordinatesUpdated','',''),(308,134,68,'','2015-12-03 14:47:55','admin.atHome','',''),(309,135,68,'','2015-12-03 14:47:55','admin.Coordinates','',''),(191,62,29,'22.5','2014-09-05 12:44:59','Kitchen.Temperature','',''),(189,64,26,'Kitchen','2014-09-04 12:14:26','TempSensor01.LinkedRoom','',''),(188,52,51,'','2014-09-04 12:12:08','MotionSensor1.statusText','',''),(187,50,51,'','2014-09-04 12:12:08','MotionSensor1.aliveTimeOut','',''),(185,126,26,'1','2014-09-05 12:44:59','TempSensor01.direction','',''),(182,68,26,'12:44','2014-09-05 12:44:59','TempSensor01.updatedTime','',''),(183,65,26,'1','2014-09-05 12:44:59','TempSensor01.alive','',''),(184,19,26,'22.5','2014-09-05 12:44:59','TempSensor01.temp','',''),(120,59,30,'1409901138','2014-09-05 10:12:18','Hall.LatestActivity','',''),(121,60,30,'10:12','2014-09-05 10:12:18','Hall.LatestActivityTime','',''),(122,61,30,'0','2014-09-05 10:22:19','Hall.SomebodyHere','',''),(124,55,20,'0','2014-09-05 10:12:16','NobodyHomeMode.active','',''),(125,57,20,'1409901136','2014-09-05 10:12:16','NobodyHomeMode.updated','',''),(126,58,20,'10:12','2014-09-05 10:12:16','NobodyHomeMode.updatedTime','',''),(190,66,26,'','2014-09-04 12:14:26','TempSensor01.aliveTimeOut','',''),(128,59,24,'1409838134','2014-09-04 16:42:14','Livingroom.LatestActivity','',''),(129,60,24,'16:42','2014-09-04 16:42:14','Livingroom.LatestActivityTime','',''),(130,61,24,'0','2014-09-04 16:52:14','Livingroom.SomebodyHere','',''),(181,67,26,'1409910299','2014-09-05 12:44:59','TempSensor01.updated','',''),(132,59,29,'1409838113','2014-09-04 16:41:53','Kitchen.LatestActivity','',''),(133,60,29,'16:41','2014-09-04 16:41:53','Kitchen.LatestActivityTime','',''),(134,61,29,'0','2014-09-04 16:51:53','Kitchen.SomebodyHere','',''),(135,56,20,'Никого нет дома','2014-07-21 12:43:30','NobodyHomeMode.title','',''),(136,55,19,'0','2014-09-05 10:12:16','EconomMode.active','',''),(137,57,19,'1409901136','2014-09-05 10:12:16','EconomMode.updated','',''),(138,58,19,'10:12','2014-09-05 10:12:16','EconomMode.updatedTime','',''),(139,56,19,'Экономия','2014-07-21 12:44:15','EconomMode.title','',''),(140,55,23,'1','2017-12-03 14:47:01','DarknessMode.active','',''),(141,57,23,'1512301621','2017-12-03 14:47:01','DarknessMode.updated','',''),(142,58,23,'14:47','2017-12-03 14:47:01','DarknessMode.updatedTime','',''),(143,56,23,'Темное время суток','2014-07-21 12:44:48','DarknessMode.title','',''),(147,55,47,'0','2017-11-13 08:00:00','NightMode.active','',''),(148,57,47,'1510549200','2017-11-13 08:00:00','NightMode.updated','',''),(149,58,47,'08:00','2017-11-13 08:00:00','NightMode.updatedTime','',''),(150,56,47,'Ночной','2014-07-21 12:51:25','NightMode.title','',''),(180,125,52,'1','2014-09-05 12:44:59','humSensor01.direction','',''),(179,120,52,'43','2014-09-05 12:44:59','humSensor01.humidity','',''),(178,117,52,'1','2014-09-05 12:44:59','humSensor01.alive','',''),(177,122,52,'12:44','2014-09-05 12:44:59','humSensor01.updatedTime','',''),(176,121,52,'1409910299','2014-09-05 12:44:59','humSensor01.updated','',''),(175,124,51,'0','2014-09-05 10:12:48','MotionSensor1.motionDetected','',''),(173,49,51,'1','2014-09-05 11:26:54','MotionSensor1.alive','',''),(172,53,51,'1409905614','2014-09-05 11:26:54','MotionSensor1.updatedTimestamp','',''),(171,51,51,'0','2014-09-05 11:26:54','MotionSensor1.status','',''),(213,59,54,'1409911260','2014-09-05 13:01:00','Kinderroom.LatestActivity','',''),(214,60,54,'13:01','2014-09-05 13:01:00','Kinderroom.LatestActivityTime','',''),(215,61,54,'1','2014-09-05 13:01:00','Kinderroom.SomebodyHere','',''),(223,59,28,'1409838048','2014-09-04 16:40:48','Bedroom.LatestActivity','',''),(224,60,28,'16:40','2014-09-04 16:40:48','Bedroom.LatestActivityTime','',''),(225,61,28,'0','2014-09-04 16:50:48','Bedroom.SomebodyHere','',''),(239,119,52,'Kitchen','2014-09-04 15:45:22','humSensor01.LinkedRoom','',''),(240,118,52,'','2014-09-04 15:45:22','humSensor01.aliveTimeOut','',''),(242,62,24,'22.4','2014-09-05 12:26:26','Livingroom.Temperature','',''),(243,127,29,'43','2014-09-05 12:44:59','Kitchen.Humidity','',''),(251,62,28,'22.5','2014-09-05 12:54:30','Bedroom.Temperature','',''),(253,127,24,'42','2014-09-05 12:26:26','Livingroom.Humidity','',''),(266,59,53,'','2014-09-04 16:07:54','Bathroom.LatestActivity','',''),(267,60,53,'','2014-09-04 16:07:54','Bathroom.LatestActivityTime','',''),(268,61,53,'','2014-09-04 16:07:54','Bathroom.SomebodyHere','',''),(269,62,53,'','2014-09-04 16:07:54','Bathroom.Temperature','',''),(270,127,53,'','2014-09-04 16:07:54','Bathroom.Humidity','',''),(271,132,53,'Ванная','2014-09-04 16:07:54','Bathroom.Title','',''),(272,127,28,'42','2014-09-05 12:54:30','Bedroom.Humidity','',''),(273,132,28,'Спальня','2014-09-04 16:08:08','Bedroom.Title','',''),(274,62,30,'','2014-09-04 16:08:23','Hall.Temperature','',''),(275,127,30,'','2014-09-04 16:08:23','Hall.Humidity','',''),(276,132,30,'Коридор','2014-09-04 16:08:23','Hall.Title','',''),(277,62,54,'','2014-09-04 16:08:36','Kinderroom.Temperature','',''),(278,127,54,'','2014-09-04 16:08:36','Kinderroom.Humidity','',''),(279,132,54,'Детская','2014-09-04 16:08:36','Kinderroom.Title','',''),(280,132,29,'Кухня','2014-09-04 16:08:48','Kitchen.Title','',''),(281,132,24,'Гостиная','2014-09-04 16:09:01','Livingroom.Title','',''),(282,59,55,'','2014-09-04 16:09:14','Toilet.LatestActivity','',''),(283,60,55,'','2014-09-04 16:09:14','Toilet.LatestActivityTime','',''),(284,61,55,'','2014-09-04 16:09:14','Toilet.SomebodyHere','',''),(285,62,55,'','2014-09-04 16:09:14','Toilet.Temperature','',''),(286,127,55,'','2014-09-04 16:09:14','Toilet.Humidity','',''),(287,132,55,'Туалет','2014-09-04 16:09:14','Toilet.Title','',''),(294,41,18,'','2020-01-27 16:29:05','Communication.stateDetails','',''),(1366,1179,191,'1','2017-11-13 08:00:00','ThisComputer.minMsgLevel','',''),(307,63,74,'0','2020-01-28 16:58:01','Switch1.status','commands','/ajax/plans.html?op=click&id=2'),(311,137,68,'','2015-12-03 14:47:55','admin.CoordinatesUpdatedTimestamp','',''),(312,138,68,'','2015-12-03 14:47:55','admin.fullName','',''),(313,139,68,'','2015-12-03 14:47:55','admin.isMoving','',''),(314,140,68,'Home','2015-12-03 14:47:55','admin.seenAt','',''),(1365,1245,191,'16:22','2020-01-28 20:00:00','ThisComputer.civil_endTime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1364,1244,191,'06:37','2020-01-28 20:00:00','ThisComputer.Chicivil_beginTime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1363,1243,191,'11:29','2020-01-28 20:00:00','ThisComputer.TransitTime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1362,1242,191,'08:22','2020-01-28 20:00:00','ThisComputer.LongTagTime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1361,1203,191,'15:40','2020-01-28 20:00:00','ThisComputer.SunSetTime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1360,1204,191,'07:18','2020-01-28 20:00:00','ThisComputer.SunRiseTime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1359,1227,191,'Статус связи восстановился на Зелёный','2020-01-27 16:29:05','ThisComputer.lastSayMessage','',''),(325,164,76,'MAIN','2016-12-17 12:12:51','RadioSetting.PlayTerminal','',''),(1358,1219,191,'1580131745','2020-01-27 16:29:05','ThisComputer.lastSayTime','',''),(1357,1265,191,'22','2017-10-28 19:56:46','ThisComputer.tempP9','',''),(329,63,78,'0','2020-01-27 18:31:49','Switch3.status','commands','/ajax/plans.html?op=click&id=3'),(330,63,79,'0','2020-01-27 18:31:50','Switch4.status','commands','/ajax/plans.html?op=click&id=4'),(331,63,77,'0','2020-01-28 20:11:16','Switch2.status','commands','/ajax/plans.html?op=click&id=1'),(332,63,80,'0','2020-01-26 21:13:43','Switch5.status','commands','/ajax/scenes.html?op=click&id=583'),(333,63,81,'0','2020-01-27 18:36:11','Switch6.status','commands','/ajax/plans.html?op=click&id=7'),(334,63,82,'0','2020-01-26 21:10:09','Switch7.status','commands','/ajax/scenes.html?op=click&id=587'),(335,63,83,'0','2020-01-26 21:13:53','Switch8.status','commands','/ajax/scenes.html?op=click&id=589'),(336,63,84,'0','2017-04-08 21:52:39','Switch9.status','commands',''),(337,63,85,'0','2017-04-08 21:52:39','Switch10.status','commands',''),(338,63,86,'0','2017-04-08 21:52:38','Switch11.status','commands',''),(339,63,87,'0','2017-04-08 21:52:38','Switch12.status','commands',''),(340,63,88,'0','2017-04-09 11:23:50','Switch13.status','commands',''),(341,63,89,'0','2017-04-08 21:52:36','Switch14.status','commands',''),(342,63,90,'0','2017-04-08 21:52:35','Switch15.status','commands',''),(343,63,91,'0','2017-04-08 21:52:35','Switch16.status','commands',''),(1356,1253,191,'21','2017-10-28 20:12:11','ThisComputer.tempP6','',''),(1355,1256,191,'22','2017-10-28 20:12:17','ThisComputer.tempP10','',''),(1354,1201,191,'15:07 Дома кто-то есть   ','2017-12-03 15:07:00','ThisComputer.HomeStatus','',''),(1353,1200,191,'20:15','2020-01-28 20:15:00','ThisComputer.timeNow','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1352,1234,191,'15','2020-01-28 20:15:00','ThisComputer.timeM','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1351,1233,191,'20','2020-01-28 20:15:00','ThisComputer.timeH','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1350,1251,191,'21','2020-01-28 00:59:53','ThisComputer.tempP4','','/ajax/plans.html?op=click&id=15'),(1349,1252,191,'22','2017-10-28 20:12:09','ThisComputer.tempP5','',''),(1348,1229,191,'20:15','2020-01-28 20:15:10','ThisComputer.runCronUpdater','',''),(519,358,105,'Спальня','2018-03-17 02:29:59','key.2','',''),(518,357,105,'Зал','2018-03-17 02:29:53','key.1','',''),(520,359,105,'Детская','2018-03-17 02:32:06','key.3','',''),(521,360,105,'Кухня','2018-03-17 02:32:13','key.4','',''),(522,361,105,'5','2017-04-11 11:37:00','key.5','',''),(523,362,105,'6','2017-04-11 11:37:00','key.6','',''),(524,363,105,'7',NULL,'key.7','',''),(525,364,105,'8','2017-04-11 11:38:26','key.8','',''),(526,365,105,'9','2017-04-11 11:38:26','key.9','',''),(527,366,105,'10','2017-04-11 11:38:26','key.10','',''),(528,367,105,'11','2017-04-11 11:38:26','key.11','',''),(529,368,105,'12','2017-04-11 11:38:26','key.12','',''),(530,369,105,'13','2017-04-11 11:38:26','key.13','',''),(531,370,105,'14','2017-04-11 11:38:26','key.14','',''),(532,371,105,'15','2017-04-11 11:38:26','key.15','',''),(533,372,105,'16','2017-04-11 11:38:26','key.16','',''),(534,373,105,'17','2017-04-11 11:38:26','key.17','',''),(535,374,105,'18','2017-04-11 11:38:26','key.18','',''),(536,375,105,'19','2017-04-11 11:38:26','key.19','',''),(537,376,105,'20','2017-04-11 11:38:26','key.20','',''),(538,378,106,'55.752220','2017-04-13 13:20:58','myobject.coord1','commands',''),(539,379,106,'37.615555','2017-04-13 13:20:58','myobject.coord2','commands',''),(2189,2052,258,'1580737309','2020-01-28 19:00:02','ow_day6.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2188,2051,258,'1580707591','2020-01-28 19:00:02','ow_day6.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2187,2050,258,'601','2020-01-28 19:00:02','ow_day6.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2186,2049,258,'2.89','2020-01-28 19:00:02','ow_day6.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2185,2048,258,'0','2020-01-28 19:00:02','ow_day6.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2184,2047,258,'100','2020-01-28 19:00:02','ow_day6.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2183,2046,258,'13d','2020-01-28 19:00:02','ow_day6.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2182,1879,258,'746','2020-01-28 19:00:02','ow_day6.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2181,2045,258,'994','2020-01-28 19:00:02','ow_day6.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2180,1880,258,'4','2020-01-28 19:00:02','ow_day6.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2179,2044,258,'Юго-Восток','2020-01-28 19:00:02','ow_day6.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2178,2043,258,'ЮВ','2020-01-28 19:00:02','ow_day6.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2177,2042,258,'136','2020-01-28 19:00:02','ow_day6.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(740,785,116,'-9','2018-01-13 08:00:01','ow_fact.temperature','',''),(2176,2041,258,'снег','2020-01-28 19:00:02','ow_day6.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2175,2040,258,'-0','2020-01-28 19:00:02','ow_day6.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2174,2039,258,'-2','2020-01-28 19:00:02','ow_day6.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2173,2038,258,'-2','2020-01-28 19:00:02','ow_day6.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2172,2037,258,'-1','2020-01-28 19:00:02','ow_day6.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2171,2036,258,'-1','2020-01-28 19:00:02','ow_day6.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2170,2035,258,'-1','2020-01-28 19:00:02','ow_day6.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2169,1881,258,'-1','2020-01-28 19:00:02','ow_day6.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2168,2034,258,'03.02.2020','2020-01-28 19:00:02','ow_day6.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2167,2033,257,'1580653496','2020-01-28 19:00:02','ow_day5.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2166,2032,257,'1580618590','2020-01-28 19:00:02','ow_day5.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(945,162,76,'37','2020-01-26 12:13:43','RadioSetting.LastStationID','',''),(946,786,76,'Maximum','2020-01-26 12:13:43','RadioSetting.LastStationName','',''),(947,165,76,'1','2020-01-26 12:13:43','RadioSetting.On','',''),(948,163,76,'100','2018-09-18 19:17:08','RadioSetting.VolumeLevel','',''),(949,787,106,'127.0.0.1','2017-04-17 09:52:00','myobject.namehost','',''),(2165,2031,257,'1580636043','2020-01-28 19:00:02','ow_day5.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2164,2030,257,'29430','2020-01-28 19:00:02','ow_day5.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2163,2029,257,'1580650758','2020-01-28 19:00:02','ow_day5.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2162,2028,257,'1580621328','2020-01-28 19:00:02','ow_day5.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2161,2027,257,'600','2020-01-28 19:00:02','ow_day5.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2160,2026,257,'0.56','2020-01-28 19:00:02','ow_day5.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2159,2025,257,'0','2020-01-28 19:00:02','ow_day5.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2158,2024,257,'100','2020-01-28 19:00:02','ow_day5.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2157,2023,257,'13d','2020-01-28 19:00:02','ow_day5.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2156,1879,257,'752','2020-01-28 19:00:02','ow_day5.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2155,2022,257,'1003','2020-01-28 19:00:02','ow_day5.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2154,1880,257,'4','2020-01-28 19:00:02','ow_day5.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1535,785,228,'-11','2018-01-13 08:00:02','ow_day6.temperature','',''),(2153,2021,257,'Юго-Восток','2020-01-28 19:00:02','ow_day5.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2152,2020,257,'ЮВ','2020-01-28 19:00:02','ow_day5.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2151,2019,257,'143','2020-01-28 19:00:02','ow_day5.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2150,2018,257,'небольшой снег','2020-01-28 19:00:02','ow_day5.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2149,2017,257,'-1','2020-01-28 19:00:02','ow_day5.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2148,2016,257,'-6','2020-01-28 19:00:02','ow_day5.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2147,2015,257,'-1','2020-01-28 19:00:02','ow_day5.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2146,2014,257,'-1','2020-01-28 19:00:02','ow_day5.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2145,2013,257,'-2','2020-01-28 19:00:02','ow_day5.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2144,2012,257,'-6','2020-01-28 19:00:02','ow_day5.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2143,1881,257,'-1','2020-01-28 19:00:02','ow_day5.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2142,2011,257,'02.02.2020','2020-01-28 19:00:02','ow_day5.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2141,2010,256,'1580566961','2020-01-28 19:00:02','ow_day4.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2140,2009,256,'1580532309','2020-01-28 19:00:02','ow_day4.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2139,2008,256,'1580549635','2020-01-28 19:00:02','ow_day4.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2138,2007,256,'29144','2020-01-28 19:00:02','ow_day4.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1517,785,227,'-10','2018-01-13 08:00:02','ow_day5.temperature','',''),(2137,2006,256,'1580564207','2020-01-28 19:00:02','ow_day4.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2136,2005,256,'1580535063','2020-01-28 19:00:02','ow_day4.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2135,2004,256,'804','2020-01-28 19:00:02','ow_day4.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2134,2003,256,'0','2020-01-28 19:00:02','ow_day4.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2133,2002,256,'0','2020-01-28 19:00:02','ow_day4.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2132,2001,256,'91','2020-01-28 19:00:02','ow_day4.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2131,2000,256,'04d','2020-01-28 19:00:02','ow_day4.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2130,1879,256,'752','2020-01-28 19:00:01','ow_day4.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2129,1999,256,'1003','2020-01-28 19:00:01','ow_day4.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2128,1880,256,'0','2020-01-28 19:00:01','ow_day4.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2127,1998,256,'Северо-Северо-Восток','2020-01-28 19:00:01','ow_day4.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2905,2716,142,'23','2020-01-28 20:11:03','tempD2.tu','commands','/ajax/plans.html?op=click&id=12'),(2126,1997,256,'ССВ','2020-01-28 19:00:01','ow_day4.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2125,1996,256,'29','2020-01-28 19:00:01','ow_day4.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2124,1995,256,'пасмурно','2020-01-28 19:00:01','ow_day4.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1499,785,226,'-14','2018-01-13 08:00:02','ow_day4.temperature','',''),(2123,1994,256,'-5','2020-01-28 19:00:01','ow_day4.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2122,1993,256,'-9','2020-01-28 19:00:01','ow_day4.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2121,1992,256,'-5','2020-01-28 19:00:01','ow_day4.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2120,1991,256,'-8','2020-01-28 19:00:01','ow_day4.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2119,1990,256,'-5','2020-01-28 19:00:01','ow_day4.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2118,1989,256,'-8','2020-01-28 19:00:01','ow_day4.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2117,1881,256,'-8','2020-01-28 19:00:01','ow_day4.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2116,1988,256,'01.02.2020','2020-01-28 19:00:01','ow_day4.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2115,1987,255,'1580480427','2020-01-28 19:00:01','ow_day3.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2114,1986,255,'1580446026','2020-01-28 19:00:01','ow_day3.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2113,1985,255,'1580463226','2020-01-28 19:00:01','ow_day3.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2112,1984,255,'28860','2020-01-28 19:00:01','ow_day3.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2111,1983,255,'1580477656','2020-01-28 19:00:01','ow_day3.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2110,1982,255,'1580448796','2020-01-28 19:00:01','ow_day3.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2109,1981,255,'600','2020-01-28 19:00:01','ow_day3.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2108,1980,255,'0.76','2020-01-28 19:00:01','ow_day3.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2107,1979,255,'0','2020-01-28 19:00:01','ow_day3.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2106,1978,255,'99','2020-01-28 19:00:01','ow_day3.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1480,785,225,'-15','2018-01-13 08:00:02','ow_day3.temperature','',''),(2105,1977,255,'13d','2020-01-28 19:00:01','ow_day3.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2104,1879,255,'752','2020-01-28 19:00:01','ow_day3.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2103,1976,255,'1002','2020-01-28 19:00:01','ow_day3.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2102,1878,255,'91','2020-01-28 19:00:01','ow_day3.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2101,1880,255,'3','2020-01-28 19:00:01','ow_day3.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2100,1975,255,'Юго-Восток','2020-01-28 19:00:01','ow_day3.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2099,1974,255,'ЮВ','2020-01-28 19:00:01','ow_day3.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2098,1973,255,'132','2020-01-28 19:00:01','ow_day3.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2097,1972,255,'небольшой снег','2020-01-28 19:00:01','ow_day3.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2096,1971,255,'-2','2020-01-28 19:00:01','ow_day3.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2095,1970,255,'-5','2020-01-28 19:00:01','ow_day3.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2094,1969,255,'-5','2020-01-28 19:00:01','ow_day3.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2093,1968,255,'-3','2020-01-28 19:00:01','ow_day3.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2092,1967,255,'-2','2020-01-28 19:00:01','ow_day3.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2091,1966,255,'-4','2020-01-28 19:00:01','ow_day3.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2090,1881,255,'-3','2020-01-28 19:00:01','ow_day3.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2089,1965,255,'31.01.2020','2020-01-28 19:00:01','ow_day3.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1461,785,224,'-8','2018-01-13 08:00:01','ow_day2.temperature','',''),(2088,1964,254,'1580393893','2020-01-28 19:00:01','ow_day2.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2087,1963,254,'1580359740','2020-01-28 19:00:01','ow_day2.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2086,1962,254,'1580376817','2020-01-28 19:00:01','ow_day2.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2085,1961,254,'28579','2020-01-28 19:00:01','ow_day2.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2084,1960,254,'1580391106','2020-01-28 19:00:01','ow_day2.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2083,1959,254,'1580362527','2020-01-28 19:00:01','ow_day2.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2082,1958,254,'601','2020-01-28 19:00:01','ow_day2.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2081,1957,254,'1.68','2020-01-28 19:00:01','ow_day2.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2079,1955,254,'100','2020-01-28 19:00:01','ow_day2.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2080,1956,254,'0','2020-01-28 19:00:01','ow_day2.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2078,1954,254,'13d','2020-01-28 19:00:01','ow_day2.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2077,1879,254,'758','2020-01-28 19:00:01','ow_day2.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2076,1953,254,'1010','2020-01-28 19:00:01','ow_day2.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2075,1878,254,'92','2020-01-28 19:00:01','ow_day2.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2074,1880,254,'4','2020-01-28 19:00:01','ow_day2.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2073,1952,254,'Восток','2020-01-28 19:00:01','ow_day2.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2072,1951,254,'В','2020-01-28 19:00:01','ow_day2.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2071,1950,254,'99','2020-01-28 19:00:01','ow_day2.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2070,1949,254,'снег','2020-01-28 19:00:01','ow_day2.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1442,785,223,'-10','2018-01-13 08:00:01','ow_day1.temperature','',''),(2069,1948,254,'-4','2020-01-28 19:00:01','ow_day2.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2068,1947,254,'-7','2020-01-28 19:00:01','ow_day2.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2067,1946,254,'-5','2020-01-28 19:00:01','ow_day2.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1625,1512,231,'','2018-03-17 00:41:08','ow_setting.updScript','',''),(1624,1511,233,'1580220829','2020-01-28 19:00:01','ow_fact.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1623,1510,233,'1580187161','2020-01-28 19:00:01','ow_fact.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1622,1509,233,'1580203995','2020-01-28 19:00:01','ow_fact.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1621,1508,233,'28027','2020-01-28 19:00:01','ow_fact.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1620,1507,233,'1580218008','2020-01-28 19:00:01','ow_fact.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1619,1506,233,'1580189981','2020-01-28 19:00:01','ow_fact.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1617,1504,233,'600','2020-01-28 19:00:01','ow_fact.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1618,1505,230,'28.01.2020 18:58:26 MSK 2020','2020-01-28 19:00:01','ow_city.data_update','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1616,1503,233,'','2020-01-28 19:00:01','ow_fact.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1615,1502,233,'100','2020-01-28 19:00:01','ow_fact.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1614,1501,233,'13n','2020-01-28 19:00:01','ow_fact.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1613,1879,233,'762','2020-01-28 19:00:01','ow_fact.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1612,1499,233,'1016','2020-01-28 19:00:01','ow_fact.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1611,1878,233,'90','2020-01-28 19:00:00','ow_fact.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1423,785,222,'-9','2018-01-13 08:00:01','ow_day0.temperature','',''),(1610,1880,233,'5','2020-01-28 19:00:00','ow_fact.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1340,1220,191,'69990','2020-01-28 20:15:29','ThisComputer.uptime','',''),(1336,1232,191,'11','2020-01-28 20:15:31','ThisComputer.WSClientsTotal','',''),(1400,1284,200,'0','2020-01-28 20:15:00','clapan9.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1401,1284,201,'0','2020-01-28 20:15:00','clapan10.status','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1402,1248,191,'22','2020-01-28 01:58:27','ThisComputer.tempP1','','/ajax/plans.html?op=click&id=10'),(1403,1249,191,'22','2020-01-28 16:57:52','ThisComputer.tempP2','','/ajax/plans.html?op=click&id=8'),(1404,1250,191,'19','2020-01-28 01:39:09','ThisComputer.tempP3','','/ajax/plans.html?op=click&id=13'),(1405,1254,191,'21','2017-10-28 20:12:12','ThisComputer.tempP7','',''),(1406,1255,191,'22','2017-10-28 20:12:14','ThisComputer.tempP8','',''),(1407,1285,191,'15','2020-01-28 17:43:34','ThisComputer.EnergoMinTemp','commands','/ajax/commands.html?op=value_changed&item_id=149&new_value=15'),(1408,1186,191,'0','2018-03-17 02:13:13','ThisComputer.Econom','commands',''),(1410,1202,191,'1','2017-12-03 14:47:01','ThisComputer.isDark','',''),(1418,1224,191,'','2018-04-09 20:09:40','ThisComputer.UpdateVersion','',''),(1558,1429,191,'36683\n','2020-01-28 00:13:00','ThisComputer.pctemp','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1560,1431,191,'38.1','2020-01-28 00:13:00','ThisComputer.CPU_usage','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1564,1435,191,'0.10','2020-01-28 00:13:00','ThisComputer.cpu_load1','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1559,1430,191,'38.3','2020-01-28 00:13:00','ThisComputer.CPU_temp','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1561,1432,191,'1 day,   5:46','2020-01-28 00:13:00','ThisComputer.System_uptime','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1562,1433,191,'86.7','2020-01-28 00:13:00','ThisComputer.System_memory','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1563,1434,191,'12 GB','2020-01-28 00:13:00','ThisComputer.System_freespace','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1565,1436,191,'0.16','2020-01-28 00:13:00','ThisComputer.cpu_load5','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1566,1437,191,'0.17','2020-01-28 00:13:00','ThisComputer.cpu_load15','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1567,1438,191,'1021972','2020-01-28 00:13:00','ThisComputer.mem_total','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1568,1439,191,'136468','2020-01-28 00:13:00','ThisComputer.mem_free','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1569,1440,191,'475532','2020-01-28 00:13:00','ThisComputer.mem_cached','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1570,1441,191,'510984','2020-01-28 00:13:00','ThisComputer.mem_swap_total','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1571,1442,191,'510984','2020-01-28 00:13:00','ThisComputer.mem_swap_free','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1572,1443,191,'0','2020-01-28 00:13:00','ThisComputer.mem_swap_used','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1573,1444,191,'409972','2020-01-28 00:13:00','ThisComputer.mem_used','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1574,1445,191,'15162048','2020-01-28 00:13:00','ThisComputer.sd_total','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1575,1446,191,'2374008','2020-01-28 00:13:00','ThisComputer.sd_used','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1576,1447,191,'12609176','2020-01-28 00:13:00','ThisComputer.sd_free','','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(1577,1448,191,'340050344314203d040e','2018-01-12 19:42:08','ThisComputer.Serial','',''),(1609,1496,233,'Юго-Восток','2020-01-28 19:00:00','ow_fact.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1608,1495,233,'ЮВ','2020-01-28 19:00:00','ow_fact.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1606,1493,233,'небольшой снег','2020-01-28 19:00:00','ow_fact.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1607,1494,233,'143','2020-01-28 19:00:00','ow_fact.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1605,1881,233,'-10','2020-01-28 19:00:00','ow_fact.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1603,1490,231,'7','2018-03-17 00:41:08','ow_setting.forecast_interval','',''),(1604,1491,231,'3','2020-01-28 20:00:00','ow_setting.countTime','','/api.php/method/ClockChime.onNewHour?m_c_s[0]=ClockChime.onNewHour&no_session=1'),(1602,1489,231,'3','2018-03-17 00:41:08','ow_setting.updatetime','',''),(1601,1488,231,'on','2018-03-17 00:41:08','ow_setting.ow_imagecache','',''),(1600,1487,231,'0','2018-03-17 00:41:08','ow_setting.ow_ws_active','',''),(1599,1486,231,'0','2018-03-17 00:41:08','ow_setting.ow_round','',''),(1598,1485,231,'16d','2018-03-17 00:41:08','ow_setting.api_method','',''),(1597,1484,231,'c29bbadbdebec9469a16540b97ca3bf0','2018-03-17 00:41:08','ow_setting.api_key','',''),(1596,1483,230,'39.888599','2018-03-09 13:23:47','ow_city.lon','',''),(1595,1482,230,'59.218700','2018-03-09 13:23:47','ow_city.lat','',''),(1594,1481,230,'Vologda','2018-03-09 13:23:47','ow_city.name','',''),(1593,1480,230,'472459','2018-03-09 13:23:47','ow_city.id','',''),(2066,1945,254,'-5','2020-01-28 19:00:01','ow_day2.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2065,1944,254,'-5','2020-01-28 19:00:01','ow_day2.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2064,1943,254,'-7','2020-01-28 19:00:01','ow_day2.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2063,1881,254,'-5','2020-01-28 19:00:01','ow_day2.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2062,1942,254,'30.01.2020','2020-01-28 19:00:01','ow_day2.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2061,1941,253,'1580307360','2020-01-28 19:00:01','ow_day1.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2060,1940,253,'1580273452','2020-01-28 19:00:01','ow_day1.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2059,1939,253,'1580290406','2020-01-28 19:00:01','ow_day1.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2058,1938,253,'28302','2020-01-28 19:00:01','ow_day1.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2057,1937,253,'1580304557','2020-01-28 19:00:01','ow_day1.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2056,1936,253,'1580276255','2020-01-28 19:00:01','ow_day1.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2055,1935,253,'600','2020-01-28 19:00:01','ow_day1.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2053,1933,253,'0','2020-01-28 19:00:01','ow_day1.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2054,1934,253,'0','2020-01-28 19:00:01','ow_day1.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2052,1932,253,'100','2020-01-28 19:00:01','ow_day1.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2051,1931,253,'13d','2020-01-28 19:00:01','ow_day1.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2050,1879,253,'760','2020-01-28 19:00:01','ow_day1.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2049,1930,253,'1013','2020-01-28 19:00:01','ow_day1.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2048,1878,253,'90','2020-01-28 19:00:01','ow_day1.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2047,1880,253,'3','2020-01-28 19:00:01','ow_day1.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2046,1929,253,'Юго-Восток','2020-01-28 19:00:01','ow_day1.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2045,1928,253,'ЮВ','2020-01-28 19:00:01','ow_day1.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2044,1927,253,'127','2020-01-28 19:00:01','ow_day1.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2043,1926,253,'небольшой снег','2020-01-28 19:00:01','ow_day1.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2042,1925,253,'-7','2020-01-28 19:00:01','ow_day1.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2041,1924,253,'-11','2020-01-28 19:00:01','ow_day1.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2040,1923,253,'-10','2020-01-28 19:00:01','ow_day1.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2039,1922,253,'-10','2020-01-28 19:00:01','ow_day1.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2038,1921,253,'-8','2020-01-28 19:00:01','ow_day1.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2037,1920,253,'-11','2020-01-28 19:00:01','ow_day1.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2036,1881,253,'-10','2020-01-28 19:00:01','ow_day1.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2035,1919,253,'29.01.2020','2020-01-28 19:00:01','ow_day1.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2034,1918,252,'1580220829','2020-01-28 19:00:01','ow_day0.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2033,1917,252,'1580187161','2020-01-28 19:00:01','ow_day0.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2032,1916,252,'1580203995','2020-01-28 19:00:01','ow_day0.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2031,1915,252,'28027','2020-01-28 19:00:01','ow_day0.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2030,1914,252,'1580218008','2020-01-28 19:00:01','ow_day0.sunset','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2028,1912,252,'600','2020-01-28 19:00:01','ow_day0.condCode','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2029,1913,252,'1580189981','2020-01-28 19:00:01','ow_day0.sunrise','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2027,1911,252,'0.44','2020-01-28 19:00:01','ow_day0.snow','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2026,1910,252,'0','2020-01-28 19:00:01','ow_day0.rain','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2025,1909,252,'100','2020-01-28 19:00:01','ow_day0.clouds','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2024,1908,252,'13d','2020-01-28 19:00:01','ow_day0.image','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2023,1879,252,'762','2020-01-28 19:00:01','ow_day0.pressure_mmhg','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2022,1907,252,'1016','2020-01-28 19:00:01','ow_day0.pressure','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2021,1878,252,'90','2020-01-28 19:00:01','ow_day0.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2020,1880,252,'5','2020-01-28 19:00:01','ow_day0.wind_speed','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(1812,1257,191,'restart','2018-09-25 10:52:11','ThisComputer.cycle_telegram','',''),(1814,1705,244,'- to do list by Vovix -|-приехать на IT форум 2018|+отметить новый год|+отметить 23 февраля|+отметить 8 марта','2018-03-09 13:08:19','TodoList.todo','',''),(1815,1704,244,'2','2018-03-09 12:42:47','TodoList.sayTodo','',''),(1816,1701,244,'\r\n@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n \r\n#item194 { /* здесь item194 - это номер ID пункта меню в котором он размещен - меняйте на свой! */\r\n padding: 0;\r\n }\r\n \r\n#list {\r\n  position: relative;\r\n /* width: calc(100% + 40px); */\r\n /* margin: 0 -20px 0 -20px; */\r\n width: 100%;\r\n margin: 0;\r\n \r\n}\r\n#list .new {\r\n width: 100%;\r\n height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n }\r\n \r\n#list .new #newtask {\r\n  float: left;\r\n  width: calc(100% - 76px);\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  background: #333333;\r\n  text-indent: 8px;\r\n}\r\n\r\n#list .new input {\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 14px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  text-shadow: none;\r\n}\r\n\r\n#list .new #newtask::-webkit-input-placeholder {\r\n  color: rgba(255, 255, 255, 0.5);\r\n}\r\n\r\n#list .new button {\r\n  cursor: pointer;\r\n  float: right;\r\n  width: 76px;\r\n  height: 50px;\r\n  padding: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  margin: -9px 0 0 0;\r\n  background: #111111;\r\n  font-size: 24px;\r\n  color: #FFF;\r\n}\r\n\r\n#list .list .item {\r\n  clear: both;\r\n  width: 100%;\r\n  height: 38px;\r\n margin: 0;\r\n }\r\n\r\n#list .list .item span {\r\n  cursor: default;\r\n  float: left;\r\n  width: calc(100% - 76px);\r\n  height: 20px;\r\n  padding: 9px 0 0 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: transparent;\r\n  text-indent: 8px;\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 14px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  text-shadow: none;\r\n  text-overflow: ellipsis;\r\n  overflow: hidden;\r\n  white-space: nowrap;\r\n  }\r\n\r\n#list .list .item span.checked {\r\n  opacity: .5;\r\n  text-decoration: line-through;\r\n}\r\n\r\n#list .list .item .rightblock {\r\n  float: right;\r\n  width: 76px;\r\n  height: 38px;\r\n  padding: 0;\r\n  margin: 0;\r\n }\r\n\r\n#list .list .item .rightblock button {\r\n cursor: pointer;\r\n  float: left;\r\n  width: 38px;\r\n  height: 38px;\r\n  padding: 0px;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  background: rgba(0,0,0,0.1);\r\n  font-size: 20px;\r\n  color: #FFF;  \r\n}\r\n','2018-03-09 12:42:47','TodoList.menuCSS','',''),(1817,1702,244,'\r\n@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n\r\n#list {\r\n  position: relative;\r\n width: 100%;\r\n max-height: 528px;\r\n overflow: auto;\r\n margin: 0;\r\n}\r\n\r\n#list .new #newtask {\r\n  float: left;\r\n  width: calc(100% - 100px);\r\n  height: 100px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: #333333;\r\n  line-height: 50px;\r\n  text-indent: 25px;\r\n}\r\n\r\n#list .new input {\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 28px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  text-shadow: 0px;\r\n\r\n}\r\n\r\n\r\n#list .new #newtask::-webkit-input-placeholder {\r\n  color: rgba(255, 255, 255, 0.5);\r\n}\r\n#list .new button {\r\n  cursor: pointer;\r\n  float: right;\r\n  width: 100px;\r\n  height: 100px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  background: #111111;\r\n  font-size: 84px;\r\n  color: #FFF;\r\n}\r\n#list .list .item {\r\n  clear: both;\r\n  width: 100%;\r\n  height: 50px;\r\n  margin: 0;\r\n  padding: 5px 0 0 0;\r\n}\r\n#list .list .item span {\r\n  cursor: default;\r\n  float: left;\r\n  width: calc(100% - 150px);\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: transparent;\r\n  text-indent: 25px;\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 28px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  text-overflow: ellipsis;\r\n  overflow: hidden;\r\n  white-space: nowrap;\r\n  \r\n}\r\n#list .list .item span.checked {\r\n  opacity: .5;\r\n  text-decoration: line-through;\r\n}\r\n#list .list .item .rightblock {\r\n  float: right;\r\n  padding: 0;\r\n  margin: -2px 0 0 0;\r\n}\r\n#list .list .item button{\r\n cursor: pointer;\r\n  float: left;\r\n  width: 50px;\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  box-shadow: 0 0 3px rgba(0,0,0,0.2);\r\n  background: rgba(0,0,0,0.1);\r\n  font-size: 32px;\r\n  color: #FFF;  \r\n}\r\n','2018-03-09 12:42:47','TodoList.sceneCSS','',''),(1818,1703,244,'\r\nfunction btnRunClicked() {\r\n    var newtask = $(\"#newtask\").val(),\r\n		ni = $(\"div.item\").length + 1;\r\n		\r\n	$(\"#newtask\").val(\"\");\r\n	\r\n    if (newtask) {\r\n		var task1 = String(newtask);\r\n		var codItem1 = \'<div class=\"item\" id=\"taskbox_\' + ni + \'\" style =\"background: hsl(\' + (190+ni*6) + \',73%,50%);\">\';\r\n		var codItem2 = \'<span id=\"task_\' + ni + \'\">\' + task1 + \'</span>\';\r\n  		var codItem3 = \'<div class=\"rightblock\"><button id=\"check_\' + ni + \'\" class=\"check fa fa-check ui-btn ui-shadow ui-corner-all\" onClick=\"checkClicked(\' + ni +\');\"></button>\';\r\n		var codItem4 = \'<button id=\"delete_\' + ni + \'\" class=\"delete fa fa-times ui-btn ui-shadow ui-corner-all\" onClick=\"deleteClicked(\' + ni + \');\"></button></div></div>\';\r\n \r\n		$.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"new\", task:newtask } );\r\n		setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n 		$(codItem1 + codItem2 + codItem3 + codItem4).appendTo(\"div.list\");\r\n		return false;\r\n    } \r\n} \r\n\r\nfunction checkClicked(ctask) {\r\n    if (ctask) {\r\n        $.get( \"/objects/\", { object:\"TodoList\", op:\"m\",m:\"check\", task:ctask } );\r\n		$(\"#task_\"+ctask).toggleClass(\"checked\");\r\n                setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n        return false;\r\n    } \r\n}   \r\n\r\nfunction deleteClicked(dtask) {\r\n    if (dtask) {\r\n        $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"delete\", task:dtask } );\r\n		$(\"#taskbox_\"+dtask).remove();\r\n               setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n        return false;\r\n    } \r\n}\r\n','2018-03-09 12:42:47','TodoList.JS','',''),(1819,1700,244,'<div id=\"list\">\r\n   <div class=\"new\">\r\n      <input id=\"newtask\" placeholder=\"New Item\" type=\"text\">\r\n      <button onClick=\"btnRunClicked();\" class=\"fa fa-plus\"></button>\r\n   </div>\r\n   <div class=\"list\">\r\n\r\n               <div class=\"item\" id=\"taskbox_1\" style =\"background: hsl(196,73%,50%);\">\r\n               \r\n               <span id=\"task_1\">приехать на IT форум 2018</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_1\" class=\"check fa fa-check\" onClick=\"checkClicked(1);\"></button>\r\n                 <button id=\"delete_1\" class=\"delete fa fa-times\" onClick=\"deleteClicked(1);\"></button>\r\n               </div>\r\n            </div>\r\n\r\n               <div class=\"item\" id=\"taskbox_2\" style =\"background: hsl(202,73%,50%);\">\r\n               \r\n               <span id=\"task_2\" class=\"checked\">отметить новый год</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_2\" class=\"check fa fa-check\" onClick=\"checkClicked(2);\"></button>\r\n                 <button id=\"delete_2\" class=\"delete fa fa-times\" onClick=\"deleteClicked(2);\"></button>\r\n               </div>\r\n            </div>\r\n\r\n               <div class=\"item\" id=\"taskbox_3\" style =\"background: hsl(208,73%,50%);\">\r\n               \r\n               <span id=\"task_3\" class=\"checked\">отметить 23 февраля</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_3\" class=\"check fa fa-check\" onClick=\"checkClicked(3);\"></button>\r\n                 <button id=\"delete_3\" class=\"delete fa fa-times\" onClick=\"deleteClicked(3);\"></button>\r\n               </div>\r\n            </div>\r\n\r\n               <div class=\"item\" id=\"taskbox_4\" style =\"background: hsl(214,73%,50%);\">\r\n               \r\n               <span id=\"task_4\" class=\"checked\">отметить 8 марта</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_4\" class=\"check fa fa-check\" onClick=\"checkClicked(4);\"></button>\r\n                 <button id=\"delete_4\" class=\"delete fa fa-times\" onClick=\"deleteClicked(4);\"></button>\r\n               </div>\r\n            </div>\r\n   </div>\r\n</div>','2018-03-09 13:08:19','TodoList.StreamingCodeScene','',''),(1820,1699,244,'<style>\r\n@import url(\"https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css\");\r\n \r\n#item194 { /* здесь item194 - это номер ID пункта меню в котором он размещен - меняйте на свой! */\r\n padding: 0;\r\n }\r\n \r\n#list {\r\n  position: relative;\r\n /* width: calc(100% + 40px); */\r\n /* margin: 0 -20px 0 -20px; */\r\n width: 100%;\r\n margin: 0;\r\n \r\n}\r\n#list .new {\r\n width: 100%;\r\n height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n }\r\n \r\n#list .new #newtask {\r\n  float: left;\r\n  width: calc(100% - 76px);\r\n  height: 50px;\r\n  padding: 0;\r\n  margin: 0;\r\n  background: #333333;\r\n  text-indent: 8px;\r\n}\r\n\r\n#list .new input {\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 14px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  line-height: normal;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  text-shadow: none;\r\n}\r\n\r\n#list .new #newtask::-webkit-input-placeholder {\r\n  color: rgba(255, 255, 255, 0.5);\r\n}\r\n\r\n#list .new button {\r\n  cursor: pointer;\r\n  float: right;\r\n  width: 76px;\r\n  height: 50px;\r\n  padding: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  margin: -9px 0 0 0;\r\n  background: #111111;\r\n  font-size: 24px;\r\n  color: #FFF;\r\n}\r\n\r\n#list .list .item {\r\n  clear: both;\r\n  width: 100%;\r\n  height: 38px;\r\n margin: 0;\r\n }\r\n\r\n#list .list .item span {\r\n  cursor: default;\r\n  float: left;\r\n  width: calc(100% - 76px);\r\n  height: 20px;\r\n  padding: 9px 0 0 0;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  background: transparent;\r\n  text-indent: 8px;\r\n  font-family: \"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif;\r\n  font-size: 14px;\r\n  color: #FFF;\r\n  text-align: justify;\r\n  text-shadow: none;\r\n  text-overflow: ellipsis;\r\n  overflow: hidden;\r\n  white-space: nowrap;\r\n  }\r\n\r\n#list .list .item span.checked {\r\n  opacity: .5;\r\n  text-decoration: line-through;\r\n}\r\n\r\n#list .list .item .rightblock {\r\n  float: right;\r\n  width: 76px;\r\n  height: 38px;\r\n  padding: 0;\r\n  margin: 0;\r\n }\r\n\r\n#list .list .item .rightblock button {\r\n cursor: pointer;\r\n  float: left;\r\n  width: 38px;\r\n  height: 38px;\r\n  padding: 0px;\r\n  margin: 0;\r\n  outline: 0;\r\n  border: 0;\r\n  border-radius: 0px;\r\n  background: rgba(0,0,0,0.1);\r\n  font-size: 20px;\r\n  color: #FFF;  \r\n}\r\n</style><script type=\'text/javascript\'>\r\nfunction btnRunClicked() {\r\n    var newtask = $(\"#newtask\").val(),\r\n		ni = $(\"div.item\").length + 1;\r\n		\r\n	$(\"#newtask\").val(\"\");\r\n	\r\n    if (newtask) {\r\n		var task1 = String(newtask);\r\n		var codItem1 = \'<div class=\"item\" id=\"taskbox_\' + ni + \'\" style =\"background: hsl(\' + (190+ni*6) + \',73%,50%);\">\';\r\n		var codItem2 = \'<span id=\"task_\' + ni + \'\">\' + task1 + \'</span>\';\r\n  		var codItem3 = \'<div class=\"rightblock\"><button id=\"check_\' + ni + \'\" class=\"check fa fa-check ui-btn ui-shadow ui-corner-all\" onClick=\"checkClicked(\' + ni +\');\"></button>\';\r\n		var codItem4 = \'<button id=\"delete_\' + ni + \'\" class=\"delete fa fa-times ui-btn ui-shadow ui-corner-all\" onClick=\"deleteClicked(\' + ni + \');\"></button></div></div>\';\r\n \r\n		$.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"new\", task:newtask } );\r\n		setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n 		$(codItem1 + codItem2 + codItem3 + codItem4).appendTo(\"div.list\");\r\n		return false;\r\n    } \r\n} \r\n\r\nfunction checkClicked(ctask) {\r\n    if (ctask) {\r\n        $.get( \"/objects/\", { object:\"TodoList\", op:\"m\",m:\"check\", task:ctask } );\r\n		$(\"#task_\"+ctask).toggleClass(\"checked\");\r\n                setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n        return false;\r\n    } \r\n}   \r\n\r\nfunction deleteClicked(dtask) {\r\n    if (dtask) {\r\n        $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"delete\", task:dtask } );\r\n		$(\"#taskbox_\"+dtask).remove();\r\n               setTimeout(function() { $.get( \"/objects/\", { object:\"TodoList\", op:\"m\", m:\"view\" } ) }, 100);\r\n        return false;\r\n    } \r\n}\r\n</script><div id=\"list\">\r\n   <div class=\"new\">\r\n      <input id=\"newtask\" placeholder=\"New Item\" type=\"text\">\r\n      <button onClick=\"btnRunClicked();\" class=\"fa fa-plus\"></button>\r\n   </div>\r\n   <div class=\"list\">\r\n\r\n               <div class=\"item\" id=\"taskbox_1\" style =\"background: hsl(196,73%,50%);\">\r\n               \r\n               <span id=\"task_1\">приехать на IT форум 2018</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_1\" class=\"check fa fa-check\" onClick=\"checkClicked(1);\"></button>\r\n                 <button id=\"delete_1\" class=\"delete fa fa-times\" onClick=\"deleteClicked(1);\"></button>\r\n               </div>\r\n            </div>\r\n\r\n               <div class=\"item\" id=\"taskbox_2\" style =\"background: hsl(202,73%,50%);\">\r\n               \r\n               <span id=\"task_2\" class=\"checked\">отметить новый год</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_2\" class=\"check fa fa-check\" onClick=\"checkClicked(2);\"></button>\r\n                 <button id=\"delete_2\" class=\"delete fa fa-times\" onClick=\"deleteClicked(2);\"></button>\r\n               </div>\r\n            </div>\r\n\r\n               <div class=\"item\" id=\"taskbox_3\" style =\"background: hsl(208,73%,50%);\">\r\n               \r\n               <span id=\"task_3\" class=\"checked\">отметить 23 февраля</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_3\" class=\"check fa fa-check\" onClick=\"checkClicked(3);\"></button>\r\n                 <button id=\"delete_3\" class=\"delete fa fa-times\" onClick=\"deleteClicked(3);\"></button>\r\n               </div>\r\n            </div>\r\n\r\n               <div class=\"item\" id=\"taskbox_4\" style =\"background: hsl(214,73%,50%);\">\r\n               \r\n               <span id=\"task_4\" class=\"checked\">отметить 8 марта</span>\r\n               <div class=\"rightblock\">\r\n                 <button id=\"check_4\" class=\"check fa fa-check\" onClick=\"checkClicked(4);\"></button>\r\n                 <button id=\"delete_4\" class=\"delete fa fa-times\" onClick=\"deleteClicked(4);\"></button>\r\n               </div>\r\n            </div>\r\n   </div>\r\n</div>','2018-03-09 13:08:19','TodoList.StreamingCodeMenu','',''),(2019,1906,252,'Юго-Восток','2020-01-28 19:00:01','ow_day0.wind_direction_full','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2018,1905,252,'ЮВ','2020-01-28 19:00:01','ow_day0.wind_direction_text','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2017,1904,252,'143','2020-01-28 19:00:01','ow_day0.wind_direction','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2016,1903,252,'небольшой снег','2020-01-28 19:00:01','ow_day0.weather_type','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2015,1902,252,'-10','2020-01-28 19:00:01','ow_day0.temp_max','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2014,1901,252,'-10','2020-01-28 19:00:01','ow_day0.temp_min','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2013,1900,252,'-10','2020-01-28 19:00:01','ow_day0.temp_night','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2010,1897,252,'-10','2020-01-28 19:00:01','ow_day0.temp_morn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2011,1898,252,'-10','2020-01-28 19:00:01','ow_day0.temp_day','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2012,1899,252,'-10','2020-01-28 19:00:01','ow_day0.temp_eve','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2008,1896,252,'28.01.2020','2020-01-28 19:00:01','ow_day0.date','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2009,1881,252,'-10','2020-01-28 19:00:01','ow_day0.temperature','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2007,1187,191,'0','2018-09-25 10:46:58','ThisComputer.securityMode','',''),(2190,2053,258,'29718','2020-01-28 19:00:02','ow_day6.day_length','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2191,2054,258,'1580722450','2020-01-28 19:00:02','ow_day6.transit','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2192,2055,258,'1580704868','2020-01-28 19:00:02','ow_day6.civil_twilight_begin','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2193,2056,258,'1580740032','2020-01-28 19:00:02','ow_day6.civil_twilight_end','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2194,2057,191,'0','2018-03-17 01:56:03','ThisComputer.security','',''),(2196,2059,270,'2020-01-28 20:00:01','2020-01-28 20:00:01','exchange_rate.date1','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2197,2060,270,'2020-01-28 20:00:01','2020-01-28 20:00:01','exchange_rate.date2','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2198,2061,270,'0.39','2020-01-28 20:00:01','exchange_rate.rurnbu','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2199,2062,270,'24.6','2020-01-28 20:00:01','exchange_rate.usdnbu','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2200,2063,270,'27.12','2020-01-28 20:00:01','exchange_rate.euronbu','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2201,2064,270,'0.36','2020-01-28 20:00:01','exchange_rate.rurbuy','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2202,2065,270,'0.4','2020-01-28 20:00:01','exchange_rate.rursale','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2203,2066,270,'62.34','2020-01-28 20:00:01','exchange_rate.dollarrur','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2204,2067,270,'68.78','2020-01-28 20:00:01','exchange_rate.eurorur','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2207,2070,273,'24.12','2018-03-19 11:18:30','Temp1.temp','xiaomihome',''),(2208,2071,273,'35.4','2018-03-19 11:18:30','Temp1.hum','xiaomihome',''),(2209,2072,273,'98.08','2018-03-19 11:18:30','Temp1.press_kpa','xiaomihome',''),(2210,2074,273,'735.66','2018-03-19 11:18:30','Temp1.press_mm','xiaomihome',''),(2211,2073,273,'3045','2018-03-19 10:32:01','Temp1.bat','xiaomihome',''),(2212,2070,274,'28.75','2018-03-19 11:06:44','Temp2.temp','xiaomihome',''),(2213,2071,274,'25.21','2018-03-19 11:06:45','Temp2.hum','xiaomihome',''),(2214,2073,274,'3055','2018-03-19 10:34:59','Temp2.bat','xiaomihome',''),(2215,2076,275,'',NULL,'Magnet1.bat','xiaomihome',''),(2216,2075,275,'0','2018-03-19 09:55:36','Magnet1.status','xiaomihome',''),(2217,2079,272,'3035','2018-03-19 11:15:37','Motion1.bat','xiaomihome',''),(2218,2077,272,'1','2018-03-19 11:22:38','Motion1.motion','xiaomihome',''),(2219,2083,277,'ff0800','2018-03-18 22:54:27','Gateway1.rgb','xiaomihome',''),(2220,2084,277,'42','2018-03-19 11:22:18','Gateway1.brightness','xiaomihome,commands',''),(2221,2085,277,'1209','2018-03-19 11:22:18','Gateway1.illumination','xiaomihome',''),(2222,1158,278,'ea0606','2018-03-18 22:57:57','Rgb01.color','',''),(2223,1159,278,'ea0606','2018-03-18 22:57:57','Rgb01.colorSaved','',''),(2224,168,278,'1','2018-03-18 22:57:57','Rgb01.status','',''),(2225,171,278,'1521403077','2018-03-18 22:57:57','Rgb01.updated','',''),(2226,172,278,'только что','2018-03-18 22:57:57','Rgb01.updatedText','',''),(2227,169,278,'1','2018-03-18 22:57:57','Rgb01.alive','',''),(2228,1158,277,'56ea09','2018-03-19 11:22:18','Gateway1.color','xiaomihome',''),(2229,1159,277,'56ea09','2018-03-19 11:22:18','Gateway1.colorSaved','',''),(2230,168,277,'1','2018-03-19 00:20:30','Gateway1.status','',''),(2231,171,277,'1521408030','2018-03-19 00:20:30','Gateway1.updated','',''),(2232,172,277,'только что','2018-03-19 00:20:30','Gateway1.updatedText','',''),(2233,169,277,'1','2018-03-19 00:20:30','Gateway1.alive','',''),(2234,2086,270,'26.9','2020-01-28 20:00:01','exchange_rate.eurobuy','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2235,2087,270,'27.2','2020-01-28 20:00:01','exchange_rate.eurosale','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2236,2088,270,'24.5','2020-01-28 20:00:01','exchange_rate.usdbuy','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2237,2089,270,'24.8','2020-01-28 20:00:01','exchange_rate.usdsale','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2238,2090,270,'2020-01-28 20:00:01','2020-01-28 20:00:01','exchange_rate.date3','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2240,1198,191,'100','2018-09-18 19:17:08','ThisComputer.volumeLevel','',''),(2241,2109,270,'2020-01-28 20:00:02','2020-01-28 20:00:02','exchange_rate.date4','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2242,2110,270,'380.84','2020-01-28 20:00:02','exchange_rate.kztusd','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2243,2111,270,'419.5','2020-01-28 20:00:02','exchange_rate.kzteur','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2252,2120,191,'d1998b04ae060c8f44db7e54d2eb0e9137c2c50c','2020-01-28 00:48:41','ThisComputer.LatestUpdateId','','/modules/saverestore/update_iframe.php?with_extensions=&backup=&design=&code=&data=&save_files='),(2253,2121,191,'2020-01-28 00:48:41','2020-01-28 00:48:41','ThisComputer.LatestUpdateTimestamp','','/modules/saverestore/update_iframe.php?with_extensions=&backup=&design=&code=&data=&save_files='),(2893,2758,191,'1580231725','2020-01-28 20:15:25','ThisComputer.cycle_statesRun','',''),(2894,2759,191,'1580231723','2020-01-28 20:15:23','ThisComputer.cycle_execsRun','',''),(2895,2760,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_yandexweatherRun','',''),(2884,2750,191,'','2020-01-28 00:48:53','ThisComputer.cycle_energomeraRun','',''),(2885,2749,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_phistoryRun','',''),(2886,2751,191,'1580231726','2020-01-28 20:15:26','ThisComputer.cycle_webvarsRun','',''),(2382,1878,256,'93','2020-01-28 19:00:01','ow_day4.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2383,1878,257,'93','2020-01-28 19:00:02','ow_day5.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2384,1878,258,'95','2020-01-28 19:00:02','ow_day6.humidity','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2529,2417,191,'19h 26m','2020-01-28 20:15:29','ThisComputer.uptimeText','',''),(2889,2755,191,'1580231730','2020-01-28 20:15:30','ThisComputer.cycle_mqttRun','',''),(2554,2442,270,'2.1283','2020-01-28 20:00:02','exchange_rate.dollarbyn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2555,2443,270,'2.3454','2020-01-28 20:00:02','exchange_rate.eurobyn','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2556,2444,270,'2020-01-28 20:00:02','2020-01-28 20:00:02','exchange_rate.date5','','/objects/?processSubscriptions=1&event=HOURLY&params=[]'),(2890,2756,191,'1580231728','2020-01-28 20:15:28','ThisComputer.cycle_schedulerRun','',''),(2891,2754,191,'1580231729','2020-01-28 20:15:29','ThisComputer.cycle_xiaomihomeRun','',''),(2880,2745,191,'1580231723','2020-01-28 20:15:23','ThisComputer.cycle_pingRun','',''),(2881,2746,191,'1580231729','2020-01-28 20:15:29','ThisComputer.cycle_mainRun','',''),(2882,2747,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_cronRun','',''),(2605,1175,175,'23','2020-01-27 15:14:24','tempD1.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2606,1175,142,'22','2020-01-27 15:15:12','tempD2.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2607,1175,143,'20','2020-01-27 15:15:49','tempD3.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2608,1175,144,'24','2020-01-27 15:16:19','tempD4.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2609,1175,145,'21','2020-01-27 15:16:44','tempD5.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2610,1175,146,'23','2020-01-27 15:17:03','tempD6.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2611,1175,147,'22','2020-01-27 15:17:24','tempD7.temp','','/admin.php?pd=Y2xhc3Nlczp7aWQ9NjIsdmlld19tb2RlPWVkaXRfY2xhc3Nlcyx0YWI9b2JqZWN0cyxpbnN0YW5jZT1hZG19pz_cGFuZWw6e2FjdGlvbj1jbGFzc2VzfQ%3D%3Dpz_&md=objects&inst=&'),(2897,2762,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_wscacheRun','',''),(2892,2757,191,'1580231725','2020-01-28 20:15:25','ThisComputer.cycle_rss_channelsRun','',''),(2615,2505,280,' 15:31','2020-01-27 15:31:27','moscow.now','',''),(2616,2512,280,'27-01-2020','2020-01-27 15:31:27','moscow.forecast_0_date','',''),(2797,2661,281,'4','2020-01-28 19:49:34','vologda.forecast_0_day_wind_speed','',''),(2617,2513,280,'28-01-2020','2020-01-27 15:31:27','moscow.forecast_1_date','',''),(2618,2514,280,'29-01-2020','2020-01-27 15:31:27','moscow.forecast_2_date','',''),(2796,2660,281,'-11','2020-01-28 19:49:34','vologda.forecast_0_day_temp_avg','',''),(2619,2515,280,'30-01-2020','2020-01-27 15:31:27','moscow.forecast_3_date','',''),(2725,2599,280,'1','2020-01-27 15:31:28','moscow.ID','',''),(2726,2600,279,'2','2020-01-28 19:49:33','yw_mycity.ID','',''),(2620,2516,280,'moscow','2020-01-27 15:31:28','moscow.TITLE','',''),(2621,2517,279,'vologda','2020-01-28 19:49:33','yw_mycity.TITLE','',''),(2766,2639,281,'21','2020-01-28 19:49:33','vologda.CID','',''),(2622,2518,280,'213','2020-01-27 15:31:28','moscow.CID','',''),(2623,2519,279,'21','2020-01-28 19:49:33','yw_mycity.CID','',''),(2767,2640,281,'1','2020-01-28 19:49:33','vologda.mycity','',''),(2624,2520,280,'1','2020-01-27 15:31:28','moscow.mycity','',''),(2625,2521,279,'1','2020-01-28 19:49:33','yw_mycity.mycity','',''),(2768,2641,281,'28.01.2020 19:49','2020-01-28 19:49:33','vologda.DESCRIPTION','',''),(2626,2522,280,'27.01.2020 15:31','2020-01-27 15:31:28','moscow.DESCRIPTION','',''),(2794,2658,281,'753','2020-01-28 19:49:34','vologda.forecast_0_morning_pressure_mm','',''),(2627,2523,279,'28.01.2020 19:49','2020-01-28 19:49:33','yw_mycity.DESCRIPTION','',''),(2769,2498,281,'Вологда','2020-01-28 19:49:33','vologda.locality_name','',''),(2628,2498,280,'Москва','2020-01-27 15:31:28','moscow.locality_name','',''),(2795,2659,281,'overcast','2020-01-28 19:49:33','vologda.forecast_0_morningcondition','',''),(2629,2498,279,'Вологда','2020-01-28 19:49:33','yw_mycity.locality_name','',''),(2727,2601,280,'','2020-01-27 15:31:28','moscow.district_name','',''),(2728,2602,279,'','2020-01-28 19:49:33','yw_mycity.district_name','',''),(2630,2495,280,'-1','2020-01-27 15:31:28','moscow.temp','',''),(2631,2524,279,'-10','2020-01-28 19:49:33','yw_mycity.trandtemp-3','','/api.php/method/yw_mycity.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=yw_mycity.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2632,2495,279,'-10','2020-01-28 19:49:33','yw_mycity.temp','',''),(2771,2642,281,'-16','2020-01-28 19:49:33','vologda.feels_like','',''),(2633,2525,279,'=','2020-01-28 19:49:33','yw_mycity.trandtemp','','/api.php/method/yw_mycity.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=yw_mycity.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2634,2526,279,'fa-pause-circle','2020-01-28 19:49:33','yw_mycity.trandtempfa','','/api.php/method/yw_mycity.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=yw_mycity.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2635,2527,280,'-5','2020-01-27 15:31:28','moscow.feels_like','',''),(2793,2657,281,'se','2020-01-28 19:49:34','vologda.forecast_0_morning_wind_dir','',''),(2636,2528,279,'-16','2020-01-28 19:49:33','yw_mycity.feels_like','',''),(2637,2497,280,'overcast','2020-01-27 15:31:28','moscow.condition','',''),(2638,2497,279,'overcast','2020-01-28 19:49:33','yw_mycity.condition','',''),(2732,2606,279,'fa-arrow-circle-down','2020-01-28 19:49:33','yw_mycity.trandhumfa','','/api.php/method/vologda.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=vologda.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2639,2499,279,'пасмурно','2020-01-28 19:49:33','yw_mycity.conditionrus','','/api.php/method/yw_mycity.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=yw_mycity.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(2640,2500,279,'пасмурно, небольшой снег','2020-01-28 19:49:33','yw_mycity.condition1rus','','/api.php/method/yw_mycity.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=yw_mycity.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(2641,2501,279,'пасмурно, небольшой снег','2020-01-28 19:49:33','yw_mycity.condition2rus','','/api.php/method/yw_mycity.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=yw_mycity.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(2642,2502,279,'пасмурно, небольшой снег','2020-01-28 19:49:33','yw_mycity.condition3rus','','/api.php/method/yw_mycity.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=yw_mycity.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(2643,2529,279,'overcast','2020-01-28 19:49:33','yw_mycity.lastcondition','','/api.php/method/yw_mycity.ChangeCondition?PROPERTY=condition&NEW_VALUE=overcast&OLD_VALUE=overcast-and-light-snow&SOURCE=&m_c_s[0]=yw_mycity.ChangeCondition.4876044cba25408fd6f98964332b77b1&no_session=1'),(2644,2496,280,'1.8','2020-01-27 15:31:28','moscow.wind_speed','',''),(2645,2496,279,'4.1','2020-01-28 19:49:33','yw_mycity.wind_speed','',''),(2729,2603,279,'down','2020-01-28 19:49:33','yw_mycity.trandpres','','/api.php/method/yw_mycity.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=yw_mycity.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2646,2507,280,'ne','2020-01-27 15:31:28','moscow.wind_dir','',''),(2730,2604,279,'fa-arrow-circle-down','2020-01-28 19:49:33','yw_mycity.trandpresfa','','/api.php/method/vologda.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=vologda.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2647,2507,279,'se','2020-01-28 19:49:33','yw_mycity.wind_dir','',''),(2648,2504,280,'747','2020-01-27 15:31:28','moscow.pressure_mm','',''),(2731,2605,279,'down','2020-01-28 19:49:33','yw_mycity.trandhum','','/api.php/method/vologda.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=vologda.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2649,2504,279,'749','2020-01-28 19:49:33','yw_mycity.pressure_mm','',''),(2773,2496,281,'4.1','2020-01-28 19:49:33','vologda.wind_speed','',''),(2650,2506,280,'76','2020-01-27 15:31:28','moscow.humidity','',''),(2733,2607,279,'=','2020-01-28 19:49:33','yw_mycity.trandwind_speed','','/api.php/method/vologda.Changetemp?PROPERTY=temp&NEW_VALUE=-10&OLD_VALUE=-10&SOURCE=&m_c_s[0]=vologda.Changetemp.21c9318befe678f37eff48e78c030e46&no_session=1'),(2651,2506,279,'83','2020-01-28 19:49:33','yw_mycity.humidity','',''),(2777,2510,281,'0','2020-01-28 19:49:33','vologda.uv_index','',''),(2652,2510,280,'0','2020-01-27 15:31:28','moscow.uv_index','',''),(2792,2656,281,'3.5','2020-01-28 19:49:34','vologda.forecast_0_morning_wind_speed','',''),(2653,2510,279,'0','2020-01-28 19:49:33','yw_mycity.uv_index','',''),(2778,2509,281,'-2','2020-01-28 19:49:34','vologda.soil_temp','',''),(2654,2509,280,'0','2020-01-27 15:31:28','moscow.soil_temp','',''),(2655,2509,279,'-2','2020-01-28 19:49:34','yw_mycity.soil_temp','',''),(2656,2530,280,'d','2020-01-27 15:31:28','moscow.daytime','',''),(2657,2531,279,'n','2020-01-28 19:49:34','yw_mycity.daytime','',''),(2658,2532,280,'','2020-01-27 15:31:28','moscow.polar','',''),(2659,2533,279,'','2020-01-28 19:49:34','yw_mycity.polar','',''),(2660,2534,280,'winter','2020-01-27 15:31:28','moscow.season','',''),(2814,2678,281,'','2020-01-28 19:49:33','vologda.district_name','',''),(2770,2495,281,'-10','2020-01-28 19:49:33','vologda.temp','',''),(2661,2535,279,'winter','2020-01-28 19:49:34','yw_mycity.season','',''),(2662,2536,280,'08:33','2020-01-27 15:31:28','moscow.forecast_0_sunrise','',''),(2663,2537,279,'08:40','2020-01-28 19:49:34','yw_mycity.forecast_0_sunrise','',''),(2813,2677,281,'2','2020-01-28 19:49:33','vologda.ID','',''),(2765,2638,281,'vologda','2020-01-28 19:49:33','vologda.TITLE','',''),(2664,2538,280,'16:51','2020-01-27 15:31:28','moscow.forecast_0_sunset','',''),(2764,2637,281,'31-01-2020','2020-01-28 19:49:33','vologda.forecast_3_date','',''),(2665,2539,279,'16:27','2020-01-28 19:49:34','yw_mycity.forecast_0_sunset','',''),(2763,2636,281,'30-01-2020','2020-01-28 19:49:33','vologda.forecast_2_date','',''),(2666,2540,280,'5','2020-01-27 15:31:28','moscow.forecast_0_week','',''),(2667,2541,279,'5','2020-01-28 19:49:34','yw_mycity.forecast_0_week','',''),(2762,2635,281,'29-01-2020','2020-01-28 19:49:33','vologda.forecast_1_date','',''),(2668,2542,280,'07:51','2020-01-27 15:31:28','moscow.forecast_0_rise_begin','',''),(2761,2634,281,'28-01-2020','2020-01-28 19:49:33','vologda.forecast_0_date','',''),(2669,2543,279,'07:53','2020-01-28 19:49:34','yw_mycity.forecast_0_rise_begin','',''),(2760,2505,281,' 19:49','2020-01-28 19:49:33','vologda.now','',''),(2670,2544,280,'17:33','2020-01-27 15:31:28','moscow.forecast_0_set_end','',''),(2758,2632,280,'','2020-01-27 15:31:28','moscow.forecast_0_moon_text','',''),(2759,2633,279,'','2020-01-28 19:49:34','yw_mycity.forecast_0_moon_text','',''),(2671,2545,279,'17:14','2020-01-28 19:49:34','yw_mycity.forecast_0_set_end','',''),(2756,2630,280,'','2020-01-27 15:31:28','moscow.forecast_0_moon_code','',''),(2757,2631,279,'','2020-01-28 19:49:34','yw_mycity.forecast_0_moon_code','',''),(2672,2546,280,'2','2020-01-27 15:31:28','moscow.forecast_0_night_temp_avg','',''),(2784,2648,281,'5','2020-01-28 19:49:34','vologda.forecast_0_week','',''),(2673,2547,279,'-18','2020-01-28 19:49:34','yw_mycity.forecast_0_night_temp_avg','',''),(2674,2548,280,'7','2020-01-27 15:31:28','moscow.forecast_0_night_wind_speed','',''),(2675,2549,279,'2','2020-01-28 19:49:34','yw_mycity.forecast_0_night_wind_speed','',''),(2780,2644,281,'','2020-01-28 19:49:34','vologda.polar','',''),(2676,2550,280,'w','2020-01-27 15:31:28','moscow.forecast_0_night_wind_dir','',''),(2776,2506,281,'83','2020-01-28 19:49:33','vologda.humidity','',''),(2677,2551,279,'se','2020-01-28 19:49:34','yw_mycity.forecast_0_night_wind_dir','',''),(2678,2552,280,'overcast-and-light-rain','2020-01-27 15:31:28','moscow.forecast_0_nightcondition','',''),(2679,2553,279,'clear','2020-01-28 19:49:34','yw_mycity.forecast_0_nightcondition','',''),(2826,2690,281,'','2020-01-28 19:49:34','vologda.forecast_0_moon_code','',''),(2787,2651,281,'-18','2020-01-28 19:49:34','vologda.forecast_0_night_temp_avg','',''),(2680,2554,280,'1','2020-01-27 15:31:28','moscow.forecast_0_morning_temp_avg','',''),(2827,2691,281,'','2020-01-28 19:49:34','vologda.forecast_0_moon_text','',''),(2681,2555,279,'-15','2020-01-28 19:49:34','yw_mycity.forecast_0_morning_temp_avg','',''),(2786,2650,281,'17:14','2020-01-28 19:49:34','vologda.forecast_0_set_end','',''),(2682,2556,280,'4.2','2020-01-27 15:31:28','moscow.forecast_0_morning_wind_speed','',''),(2783,2647,281,'16:27','2020-01-28 19:49:34','vologda.forecast_0_sunset','',''),(2683,2557,279,'3.5','2020-01-28 19:49:34','yw_mycity.forecast_0_morning_wind_speed','',''),(2684,2558,280,'nw','2020-01-27 15:31:28','moscow.forecast_0_morning_wind_dir','',''),(2685,2559,279,'se','2020-01-28 19:49:34','yw_mycity.forecast_0_morning_wind_dir','',''),(2779,2643,281,'n','2020-01-28 19:49:34','vologda.daytime','',''),(2686,2560,280,'743','2020-01-27 15:31:28','moscow.forecast_0_morning_pressure_mm','',''),(2775,2504,281,'749','2020-01-28 19:49:33','vologda.pressure_mm','',''),(2687,2561,279,'753','2020-01-28 19:49:34','yw_mycity.forecast_0_morning_pressure_mm','',''),(2688,2562,280,'overcast','2020-01-27 15:31:28','moscow.forecast_0_morningcondition','',''),(2790,2654,281,'clear','2020-01-28 19:49:33','vologda.forecast_0_nightcondition','',''),(2689,2563,279,'overcast','2020-01-28 19:49:33','yw_mycity.forecast_0_morningcondition','',''),(2690,2564,280,'-1','2020-01-27 15:31:28','moscow.forecast_0_day_temp_avg','',''),(2691,2565,279,'-11','2020-01-28 19:49:34','yw_mycity.forecast_0_day_temp_avg','',''),(2692,2566,280,'2.7','2020-01-27 15:31:28','moscow.forecast_0_day_wind_speed','',''),(2693,2567,279,'4','2020-01-28 19:49:34','yw_mycity.forecast_0_day_wind_speed','',''),(2782,2646,281,'08:40','2020-01-28 19:49:34','vologda.forecast_0_sunrise','',''),(2694,2568,280,'n','2020-01-27 15:31:28','moscow.forecast_0_day_wind_dir','',''),(2695,2569,279,'se','2020-01-28 19:49:34','yw_mycity.forecast_0_day_wind_dir','',''),(2696,2570,280,'747','2020-01-27 15:31:28','moscow.forecast_0_day_pressure_mm','',''),(2774,2507,281,'se','2020-01-28 19:49:33','vologda.wind_dir','',''),(2697,2571,279,'751','2020-01-28 19:49:34','yw_mycity.forecast_0_day_pressure_mm','',''),(2698,2572,280,'overcast','2020-01-27 15:31:28','moscow.forecast_0_daycondition','',''),(2789,2653,281,'se','2020-01-28 19:49:34','vologda.forecast_0_night_wind_dir','',''),(2699,2573,279,'overcast-and-light-snow','2020-01-28 19:49:33','yw_mycity.forecast_0_daycondition','',''),(2700,2574,280,'-2','2020-01-27 15:31:28','moscow.forecast_0_evening_temp_avg','',''),(2785,2649,281,'07:53','2020-01-28 19:49:34','vologda.forecast_0_rise_begin','',''),(2701,2575,279,'-9','2020-01-28 19:49:34','yw_mycity.forecast_0_evening_temp_avg','',''),(2702,2576,280,'3.1','2020-01-27 15:31:28','moscow.forecast_0_evening_wind_speed','',''),(2703,2577,279,'4.1','2020-01-28 19:49:34','yw_mycity.forecast_0_evening_wind_speed','',''),(2781,2645,281,'winter','2020-01-28 19:49:34','vologda.season','',''),(2704,2578,280,'e','2020-01-27 15:31:28','moscow.forecast_0_evening_wind_dir','',''),(2705,2579,279,'se','2020-01-28 19:49:34','yw_mycity.forecast_0_evening_wind_dir','',''),(2706,2580,280,'748','2020-01-27 15:31:28','moscow.forecast_0_evening_pressure_mm','',''),(2707,2581,279,'749','2020-01-28 19:49:34','yw_mycity.forecast_0_evening_pressure_mm','',''),(2772,2497,281,'overcast','2020-01-28 19:49:33','vologda.condition','',''),(2708,2582,280,'overcast-and-light-snow','2020-01-27 15:31:28','moscow.forecast_0_eveningcondition','',''),(2709,2583,279,'overcast-and-light-snow','2020-01-28 19:49:33','yw_mycity.forecast_0_eveningcondition','',''),(2788,2652,281,'2','2020-01-28 19:49:34','vologda.forecast_0_night_wind_speed','',''),(2710,2584,280,'741','2020-01-27 15:31:28','moscow.forecast_0_night_short_pressure_mm','',''),(2753,2627,279,'','2020-01-28 19:49:34','yw_mycity.date','',''),(2754,2628,280,'','2020-01-27 15:31:28','moscow.date_ts','',''),(2755,2629,279,'','2020-01-28 19:49:34','yw_mycity.date_ts','',''),(2711,2585,279,'753','2020-01-28 19:49:34','yw_mycity.forecast_0_night_short_pressure_mm','',''),(2750,2624,280,'','2020-01-27 15:31:28','moscow.day','',''),(2751,2625,279,'','2020-01-28 19:49:34','yw_mycity.day','',''),(2752,2626,280,'','2020-01-27 15:31:28','moscow.date','',''),(2712,2586,280,'-4','2020-01-27 15:31:28','moscow.forecast_1_day_temp_avg','',''),(2713,2587,279,'-7','2020-01-28 19:49:33','yw_mycity.forecast_1_day_temp_avg','',''),(2714,2588,280,'cloudy-and-snow','2020-01-27 15:31:28','moscow.forecast_1_daycondition','',''),(2791,2655,281,'-15','2020-01-28 19:49:34','vologda.forecast_0_morning_temp_avg','',''),(2715,2589,279,'overcast-and-light-snow','2020-01-28 19:49:33','yw_mycity.forecast_1_daycondition','',''),(2716,2590,280,'1','2020-01-27 15:31:28','moscow.forecast_2_day_temp_avg','',''),(2740,2614,280,'','2020-01-27 15:31:28','moscow.forecast_7_day_temp_avg','',''),(2741,2615,279,'','2020-01-28 19:49:33','yw_mycity.forecast_7_day_temp_avg','',''),(2717,2591,279,'-5','2020-01-28 19:49:33','yw_mycity.forecast_2_day_temp_avg','',''),(2738,2612,280,'','2020-01-27 15:31:28','moscow.forecast_6_day_temp_avg','',''),(2739,2613,279,'','2020-01-28 19:49:33','yw_mycity.forecast_6_day_temp_avg','',''),(2718,2592,280,'overcast','2020-01-27 15:31:28','moscow.forecast_2_daycondition','',''),(2748,2622,280,'','2020-01-27 15:31:28','moscow.forecast_7_daycondition','',''),(2749,2623,279,'','2020-01-28 19:49:33','yw_mycity.forecast_7_daycondition','',''),(2719,2593,279,'overcast-and-light-snow','2020-01-28 19:49:33','yw_mycity.forecast_2_daycondition','',''),(2746,2620,280,'','2020-01-27 15:31:28','moscow.forecast_6_daycondition','',''),(2747,2621,279,'','2020-01-28 19:49:33','yw_mycity.forecast_6_daycondition','',''),(2720,2594,280,'0','2020-01-27 15:31:28','moscow.forecast_3_day_temp_avg','',''),(2736,2610,280,'','2020-01-27 15:31:28','moscow.forecast_5_day_temp_avg','',''),(2737,2611,279,'','2020-01-28 19:49:33','yw_mycity.forecast_5_day_temp_avg','',''),(2721,2595,279,'-3','2020-01-28 19:49:33','yw_mycity.forecast_3_day_temp_avg','',''),(2734,2608,280,'','2020-01-27 15:31:28','moscow.forecast_4_day_temp_avg','',''),(2735,2609,279,'','2020-01-28 19:49:33','yw_mycity.forecast_4_day_temp_avg','',''),(2722,2596,280,'overcast-and-light-snow','2020-01-27 15:31:28','moscow.forecast_3_daycondition','',''),(2744,2618,280,'','2020-01-27 15:31:28','moscow.forecast_5_daycondition','',''),(2745,2619,279,'','2020-01-28 19:49:33','yw_mycity.forecast_5_daycondition','',''),(2723,2597,279,'overcast-and-light-snow','2020-01-28 19:49:33','yw_mycity.forecast_3_daycondition','',''),(2742,2616,280,'','2020-01-27 15:31:28','moscow.forecast_4_daycondition','',''),(2743,2617,279,'','2020-01-28 19:49:33','yw_mycity.forecast_4_daycondition','',''),(2798,2662,281,'se','2020-01-28 19:49:34','vologda.forecast_0_day_wind_dir','',''),(2799,2663,281,'751','2020-01-28 19:49:34','vologda.forecast_0_day_pressure_mm','',''),(2800,2664,281,'overcast-and-light-snow','2020-01-28 19:49:33','vologda.forecast_0_daycondition','',''),(2801,2665,281,'-9','2020-01-28 19:49:34','vologda.forecast_0_evening_temp_avg','',''),(2802,2666,281,'4.1','2020-01-28 19:49:34','vologda.forecast_0_evening_wind_speed','',''),(2803,2667,281,'se','2020-01-28 19:49:34','vologda.forecast_0_evening_wind_dir','',''),(2804,2668,281,'749','2020-01-28 19:49:34','vologda.forecast_0_evening_pressure_mm','',''),(2805,2669,281,'overcast-and-light-snow','2020-01-28 19:49:33','vologda.forecast_0_eveningcondition','',''),(2806,2670,281,'753','2020-01-28 19:49:34','vologda.forecast_0_night_short_pressure_mm','',''),(2825,2689,281,'','2020-01-28 19:49:34','vologda.date_ts','',''),(2823,2687,281,'','2020-01-28 19:49:34','vologda.day','',''),(2824,2688,281,'','2020-01-28 19:49:34','vologda.date','',''),(2807,2671,281,'-7','2020-01-28 19:49:33','vologda.forecast_1_day_temp_avg','',''),(2808,2672,281,'overcast-and-light-snow','2020-01-28 19:49:33','vologda.forecast_1_daycondition','',''),(2809,2673,281,'-5','2020-01-28 19:49:33','vologda.forecast_2_day_temp_avg','',''),(2810,2674,281,'overcast-and-light-snow','2020-01-28 19:49:33','vologda.forecast_2_daycondition','',''),(2811,2675,281,'-3','2020-01-28 19:49:33','vologda.forecast_3_day_temp_avg','',''),(2817,2681,281,'','2020-01-28 19:49:33','vologda.forecast_6_day_temp_avg','',''),(2818,2682,281,'','2020-01-28 19:49:33','vologda.forecast_7_day_temp_avg','',''),(2815,2679,281,'','2020-01-28 19:49:33','vologda.forecast_4_day_temp_avg','',''),(2816,2680,281,'','2020-01-28 19:49:33','vologda.forecast_5_day_temp_avg','',''),(2812,2676,281,'overcast-and-light-snow','2020-01-28 19:49:33','vologda.forecast_3_daycondition','',''),(2821,2685,281,'','2020-01-28 19:49:33','vologda.forecast_6_daycondition','',''),(2822,2686,281,'','2020-01-28 19:49:33','vologda.forecast_7_daycondition','',''),(2819,2683,281,'','2020-01-28 19:49:33','vologda.forecast_4_daycondition','',''),(2820,2684,281,'','2020-01-28 19:49:33','vologda.forecast_5_daycondition','',''),(2898,2763,191,'','2020-01-28 00:48:53','ThisComputer.cycle_skypeRun','',''),(2896,2761,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_websocketsRun','',''),(2888,2753,191,'1580231725','2020-01-28 20:15:25','ThisComputer.cycle_rssRun','',''),(2887,2752,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_db_saveRun','',''),(2883,2748,191,'1580231731','2020-01-28 20:15:31','ThisComputer.cycle_telegramRun','',''),(2899,2764,191,'','2020-01-28 00:48:53','ThisComputer.cycle_mysensorRun','',''),(2900,2765,191,'','2020-01-28 00:48:53','ThisComputer.cycle_onewireRun','',''),(2901,2766,191,'','2020-01-28 00:48:53','ThisComputer.cycle_connectRun','',''),(2902,2767,191,'','2020-01-28 00:48:53','ThisComputer.cycle_onewire_starredRun','',''),(2903,2768,191,'','2020-01-28 00:48:53','ThisComputer.cycle_X101_skypeRun','',''),(2904,2716,175,'22','2020-01-28 19:58:22','tempD1.tu','commands','/ajax/plans.html?op=click&id=10'),(2906,2716,143,'19','2020-01-28 19:10:37','tempD3.tu','commands','/ajax/plans.html?op=click&id=11'),(2907,2716,144,'25','2020-01-28 19:11:13','tempD4.tu','commands','/ajax/plans.html?op=click&id=15'),(2908,2716,145,'20','2020-01-28 19:40:09','tempD5.tu','commands','/ajax/plans.html?op=click&id=24'),(2909,2716,146,'22','2020-01-28 19:40:03','tempD6.tu','commands','/ajax/plans.html?op=click&id=27'),(2910,2716,147,'20','2020-01-28 17:43:23','tempD7.tu','commands','/ajax/commands.html?op=value_changed&item_id=145&new_value=20'),(2911,2716,148,'20','2020-01-28 17:43:25','tempD8.tu','commands','/ajax/commands.html?op=value_changed&item_id=146&new_value=20'),(2912,2716,149,'20','2020-01-28 17:43:27','tempD9.tu','commands','/ajax/commands.html?op=value_changed&item_id=148&new_value=20'),(2913,2716,150,'21','2020-01-28 17:43:29','tempD10.tu','commands','/ajax/commands.html?op=value_changed&item_id=147&new_value=21');
/*!40000 ALTER TABLE `pvalues` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `readit_channels`
--

DROP TABLE IF EXISTS `readit_channels`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `readit_channels` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `readit_channels`
--

LOCK TABLES `readit_channels` WRITE;
/*!40000 ALTER TABLE `readit_channels` DISABLE KEYS */;
/*!40000 ALTER TABLE `readit_channels` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `readit_urls`
--

DROP TABLE IF EXISTS `readit_urls`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `readit_urls` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `URL` char(255) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `FAVORITE` int(3) NOT NULL DEFAULT '0',
  `ADDED` datetime DEFAULT NULL,
  `SYS_ID` varchar(255) NOT NULL DEFAULT '',
  `CHANNEL_ID` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `readit_urls`
--

LOCK TABLES `readit_urls` WRITE;
/*!40000 ALTER TABLE `readit_urls` DISABLE KEYS */;
/*!40000 ALTER TABLE `readit_urls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rss_channels`
--

DROP TABLE IF EXISTS `rss_channels`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rss_channels` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `URL` char(255) NOT NULL DEFAULT '',
  `NEXT_UPDATE` datetime DEFAULT NULL,
  `LAST_UPDATE` datetime DEFAULT NULL,
  `UPDATE_EVERY` int(10) NOT NULL DEFAULT '0',
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rss_channels`
--

LOCK TABLES `rss_channels` WRITE;
/*!40000 ALTER TABLE `rss_channels` DISABLE KEYS */;
/*!40000 ALTER TABLE `rss_channels` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rss_items`
--

DROP TABLE IF EXISTS `rss_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rss_items` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `BODY` text,
  `URL` char(255) NOT NULL DEFAULT '',
  `GUID` varchar(255) NOT NULL DEFAULT '',
  `ADDED` varchar(255) NOT NULL DEFAULT '',
  `CHANNEL_ID` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=11992 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rss_items`
--

LOCK TABLES `rss_items` WRITE;
/*!40000 ALTER TABLE `rss_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `rss_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `safe_execs`
--

DROP TABLE IF EXISTS `safe_execs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `safe_execs` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `COMMAND` text NOT NULL,
  `ADDED` datetime DEFAULT NULL,
  `EXCLUSIVE` int(3) NOT NULL DEFAULT '0',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `ON_COMPLETE` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=3157 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `safe_execs`
--

LOCK TABLES `safe_execs` WRITE;
/*!40000 ALTER TABLE `safe_execs` DISABLE KEYS */;
/*!40000 ALTER TABLE `safe_execs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `scenes`
--

DROP TABLE IF EXISTS `scenes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `scenes` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `BACKGROUND` varchar(255) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `HIDDEN` int(3) NOT NULL DEFAULT '0',
  `WALLPAPER` varchar(255) NOT NULL DEFAULT '',
  `WALLPAPER_FIXED` int(3) NOT NULL DEFAULT '0',
  `WALLPAPER_NOREPEAT` int(3) NOT NULL DEFAULT '0',
  `AUTO_SCALE` int(3) NOT NULL DEFAULT '0',
  `SYSTEM` varchar(255) NOT NULL DEFAULT '',
  `DEVICES_BACKGROUND` varchar(10) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `scenes`
--

LOCK TABLES `scenes` WRITE;
/*!40000 ALTER TABLE `scenes` DISABLE KEYS */;
INSERT INTO `scenes` VALUES (7,'comp','/cms/scenes/imm/fon/fon_1280x699_3.jpg',10000,0,'',0,0,0,'',''),(3,'droid_menu','/cms/scenes/imm/fon/fon_360x560.jpg',0,1,'',0,0,0,'',''),(5,'Tablet_Clock','/cms/scenes/imm/fon/fon_black2.png',0,1,'',0,0,0,'',''),(9,'Главная','/cms/scenes/imm/fon/hong-kong-china-victoria.jpg',0,1,'',0,0,0,'',''),(10,'Погода','/cms/scenes/imm/fon/listia-priroda-osen-2.jpg',0,1,'',0,0,0,'',''),(11,'Настройки','/cms/scenes/imm/fon/fon5.jpg',0,1,'',0,0,0,'',''),(13,'погода2','',0,1,'',0,0,0,'',''),(17,'droid_погода','',0,1,'',0,0,0,'',''),(15,'Погода горизонтальная','/cms/scenes/weather/elements/weather_mid_panel2.png',120,1,'',0,0,0,'',''),(18,'Погодная станция (imported)','',0,1,'/cms/scenes/chor.png',0,0,0,'',''),(20,'telcast_Управление','/cms/scenes/imm/fon/hong-kong-china-victoria4.jpg',0,1,'',0,0,0,'',''),(21,'ToDo','/cms/scenes/imm/fon/hong-kong-china-victoria.jpg',0,1,'',0,0,0,'',''),(22,'Графики','/cms/scenes/imm/fon/hong-kong-china-victoria.jpg',0,1,'',0,0,0,'',''),(23,'telcast_Главная','/cms/scenes/imm/fon/hong-kong-china-victoria4.jpg',0,1,'',0,0,0,'',''),(24,'Главная2','/cms/scenes/imm/fon/hong-kong-china-victoria.jpg',0,1,'',0,0,1,'',''),(25,'telcast_ToDo','/cms/scenes/imm/fon/hong-kong-china-victoria4.jpg',0,1,'',0,0,0,'',''),(26,'telcast_Погода','/cms/scenes/imm/fon/hong-kong-china-victoria4.jpg',0,1,'',0,0,0,'',''),(27,'telcast_Настройки','/cms/scenes/imm/fon/hong-kong-china-victoria4.jpg',0,1,'',0,0,0,'',''),(28,'telcast_Маршруты','/cms/scenes/imm/fon/hong-kong-china-victoria4.jpg',0,1,'',0,0,0,'','');
/*!40000 ALTER TABLE `scenes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `script_categories`
--

DROP TABLE IF EXISTS `script_categories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `script_categories` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `script_categories`
--

LOCK TABLES `script_categories` WRITE;
/*!40000 ALTER TABLE `script_categories` DISABLE KEYS */;
INSERT INTO `script_categories` VALUES (3,'Test'),(4,'<#LANG_GENERAL_OPERATIONAL_MODES#>'),(5,'<#LANG_GENERAL_SENSORS#>'),(6,'Scenarios'),(7,'mycategory'),(8,'plan');
/*!40000 ALTER TABLE `script_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `scripts`
--

DROP TABLE IF EXISTS `scripts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `scripts` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `CODE` text,
  `DESCRIPTION` text,
  `TYPE` int(3) unsigned NOT NULL DEFAULT '0',
  `XML` text,
  `CATEGORY_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `EXECUTED` datetime DEFAULT NULL,
  `EXECUTED_PARAMS` varchar(255) DEFAULT NULL,
  `RUN_PERIODICALLY` int(3) unsigned NOT NULL DEFAULT '0',
  `RUN_DAYS` char(30) NOT NULL DEFAULT '',
  `RUN_TIME` char(30) NOT NULL DEFAULT '',
  `AUTO_LINK` int(3) unsigned NOT NULL DEFAULT '0',
  `AUTO_LINK_AVAILABLE` int(3) unsigned NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  `EXECUTED_SRC` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=43 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `scripts`
--

LOCK TABLES `scripts` WRITE;
/*!40000 ALTER TABLE `scripts` DISABLE KEYS */;
INSERT INTO `scripts` VALUES (8,'timeNow','say(timeNow());',NULL,0,NULL,3,NULL,NULL,0,'','',0,0,'','',NULL,NULL),(3,'rssProcess','/*\r\n$params[\'URL\'] --link\r\n$params[\'TITLE\'] -- title\r\n$params[\'BODY\'] -- body\r\n$params[\'CHANNEL_ID\'] -- channel ID\r\n$params[\'CHANNEL_TITLE\'] -- channed title\r\n\r\n*/\r\n\r\n//say($params[\'TITLE\']); // reading news','',0,'',0,'2014-10-30 14:57:24','a:10:{s:10:\"CHANNEL_ID\";s:1:\"4\";s:5:\"ADDED\";s:19:\"2014-10-16 16:36:00\";s:5:\"TITLE\";s:184:\"Белтелерадиокомпания: Надеемся, решение украинской стороны о закрытии \"Беларусь 24\" не окончательное\";s:4:\"BODY\";s:386:\"<img src=\"http://img.tyt.by/thumbnails/n/07/2',0,'','',0,0,'','',NULL,NULL),(10,'test','//setTimeOut(\'testTimer\',\'say(\"Hello world!\");\',30);\r\n\r\n$myip = $_SERVER[\'SERVER_ADDR\'];\r\n\r\necho $myip;','',0,'',3,'2018-03-09 11:09:16','a:1:{s:6:\"script\";s:4:\"test\";}',0,'','00:00',0,0,'','',NULL,NULL),(11,'easyRF','$device_id=$params[\'did\'];\r\n$destination_id=$params[\'dest\'];\r\n$packet_id=$params[\'pid\'];\r\n$command_id=$params[\'c\'];\r\n$data=$params[\'d\'];\r\n\r\nif ($device_id==0) {\r\n if ($command_id==10) {\r\n  //temp\r\n setGlobal(\'ws.tempInside\',round($data/100));\r\n } elseif ($command_id==12) {\r\n  //motion\r\n  callMethod(\'intSensor.statusChanged\',array(\'status\'=>1));\r\n  clearTimeOut($id.\'_move\');\r\n  setTimeOut($id.\'_move\',\"callMethod(\'intSensor.statusChanged\',array(\'status\'=>0));\",20);  \r\n }\r\n}','',0,'',5,'2014-09-03 12:12:37','a:6:{s:6:\"script\";s:6:\"easyRF\";s:3:\"did\";s:1:\"0\";s:4:\"dest\";s:1:\"0\";s:3:\"pid\";s:4:\"8339\";s:1:\"c\";s:2:\"10\";s:1:\"d\";s:4:\"2600\";}',0,'','00:00',0,0,'','',NULL,NULL),(12,'RCSwitch','$id=$params[\'rcswitch\'];\r\nif ($id==\'15170948\') {\r\n //золотистый 3-кл, клавиша 1\r\ncallMethod(\'Switch1.switch\'); \r\n}\r\nif ($id==\'15170946\') {\r\n //золотистый 3-кл, клавиша 2\r\ncallMethod(\'Switch2.switch\'); \r\n}\r\nif ($id==\'15170952\') {\r\n //золотистый 3-кл, клавиша 3\r\ncallMethod(\'Switch3.switch\'); \r\n}\r\nif ($id==\'15170950\') {\r\n //золотистый 3-кл, клавиша 1+2\r\ncallMethod(\'Switch4.switch\'); \r\n}\r\nif ($id==\'15170954\') {\r\n //золотистый 3-кл, клавиша 2+3\r\ncallMethod(\'Switch5.switch\'); \r\n}\r\nif ($id==\'15170956\') {\r\n //золотистый 3-кл, клавиша 1+3\r\ncallMethod(\'Switch6.switch\'); \r\n}','',0,'',5,'2018-03-18 23:49:38','a:2:{s:6:\"script\";s:8:\"RCSwitch\";s:8:\"rcswitch\";s:8:\"15170948\";}',0,'','00:00',0,0,'','',NULL,NULL),(15,'readWeatherToday','$weather.=\"Сегодня ожидается \".str_replace(\'&deg;\',\' \',getGlobal(\'weatherToday\'));\r\n$weather.=\". Завтра \".str_replace(\'&deg;\',\' \',getGlobal(\'weatherTomorrow\'));\r\n$weather.=\". Сейчас на улице \".getGlobal(\'TempOutside\').\'.\';\r\n$weather=str_replace(\'&deg;\',\'\',$weather);\r\nsay($weather,2);','',0,'',0,'2018-09-18 19:10:42','a:2:{i:0;s:12:\"погода\";i:1;s:2:\"а\";}',0,'','00:00',0,0,'','',NULL,NULL),(18,'playFavoriteMusic','// вытягиваем историю из переменной\r\n$alreadyPlayed=gg(\"AlreadyPlayedMusic\");\r\nif (!$alreadyPlayed) {\r\n $alreadyPlayed=\'0\';\r\n}\r\n\r\n// выбираем случайную папку\r\n$rec=SQLSelectOne(\"SELECT * FROM media_favorites WHERE ID NOT IN (\".$alreadyPlayed.\") ORDER BY RAND()\");\r\n\r\nif (!$rec[\'ID\']) {\r\n // папок больше не осталось, поэтому выбираем случайную и сбрасываем истоирю\r\n $rec=SQLSelectOne(\"SELECT * FROM media_favorites ORDER BY RAND()\");\r\n $alreadyPlayed=\'0\';\r\n}\r\n\r\n\r\nif ($rec[\'ID\']) {\r\n\r\n // добавляем выбранную папку в историю\r\n $alreadyPlayed.=\',\'.$rec[\'ID\'];\r\n sg(\"AlreadyPlayedMusic\",$alreadyPlayed);\r\n\r\n // запускаем на проигрывание\r\n $collection=SQLSelectOne(\"SELECT * FROM collections WHERE ID=\".(int)$rec[\'COLLECTION_ID\']);\r\n $path=$collection[\'PATH\'].$rec[\'PATH\'];\r\n playMedia($path);\r\n //setTimeOut(\'VLCPlayer_update\',\"callMethod(\'VLCPlayer.update\');\",10);\r\n\r\n}','',0,'',0,'2018-09-18 19:10:42','',0,'','00:00',0,0,'','',NULL,NULL),(22,'Greeting','runScript(\"reportStatus\", array());\r\n','',0,'',0,'2018-09-18 19:10:42','',0,'','00:00',0,0,'','',NULL,NULL),(19,'playPause','getURL(\'http://localhost/rc/?command=vlc_pause\',0);','',0,'',0,'2018-09-18 19:10:42','',0,'','00:00',0,0,'','',NULL,NULL),(20,'Watching movie','say(LANG_GENERAL_SETTING_UP_LIGHTS,2);\r\n// to-do','',0,'',6,'2018-09-18 19:10:42','',0,'','00:00',0,0,'','',NULL,NULL),(21,'reportStatus','$res=\'\';\r\n if (gg(\'Security.stateColor\')==\'green\' && gg(\'System.stateColor\')==\'green\' && gg(\'Communication.stateColor\')==\'green\') {\r\n  $res=\'Все системы работают в штатном режиме\';\r\n } else {\r\n  if (gg(\'Security.stateColor\')!=\'green\') {\r\n   $res.=\" Проблема безопасности: \".getGlobal(\'Security.stateDetails\');\r\n  }\r\n  if (gg(\'System.stateColor\')!=\'green\') {\r\n   $res.=\" Системная проблема: \".getGlobal(\'System.stateDetails\');\r\n  }  \r\n  if (gg(\'Communication.stateColor\')!=\'green\') {\r\n   $res.=\" Проблема связи: \".getGlobal(\'Communication.stateDetails\');\r\n  }  \r\n }\r\n say($res,5);','',0,'',0,'2018-09-18 19:10:42','a:1:{i:0;s:27:\"статус системы\";}',0,'','00:00',0,0,'','',NULL,NULL),(23,'scene_switch','//------ включение-выключение реле-----\r\n//------ esp8266 WiFi IoT \r\n//getURL (\"http://ip_adres/gpio&st=1&pin=13\",0);\r\n//getURL (\"http://ip_adres/gpio&st=0&pin=13\",0);\r\n//------ esp8266 скетч http://кушеев.рф/archives/836\r\n//getURL (\"http://ip_adres/gpio13on\",0);\r\n//getURL (\"http://ip_adres/gpio13off\",0);\r\n//------ iMatic http://кушеев.рф/archives/494\r\n//exec (\"python /var/www/cms/scenes/imatic.py 13 1\");\r\n//exec (\"python /var/www/cms/scenes/imatic.py 13 0);\r\n//------ Arduino uart скетч http://кушеев.рф/archives/650\r\n//exec (\"echo 1013 > /dev/ttyS3\");\r\n//exec (\"echo 1113 > /dev/ttyS3\");\r\n//------ GPIO http://кушеев.рф/archives/817\r\n// exec (\"gpio -1 write 29 0\")\r\n// exec (\"gpio -1 write 29 1\")\r\n//------ i2c http://кушеев.рф/archives/923\r\n// exec (\"/var/www/cms/scenes/rele.sh 0x20 1 0\");\r\n// exec (\"/var/www/cms/scenes/rele.sh 0x20 1 1\");\r\n//------ 433Utils\r\n//exec (\"/var/www/cms/scenes/codesend433 7777777\");\r\n//exec (\"/var/www/cms/scenes/codesend315 7777777\");\r\n\r\n$n = $params[\'nameobj\'];\r\n\r\nif ($n == \"Switch1\") {\r\n if (getGlobal(\"Switch1.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 1 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 1 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch2\") {\r\n if (getGlobal(\"Switch2.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 2 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 2 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch3\") {\r\n if (getGlobal(\"Switch3.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 4 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 4 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch4\") {\r\n if (getGlobal(\"Switch4.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 8 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 8 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch5\") {\r\n if (getGlobal(\"Switch5.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 16 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 16 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch6\") {\r\n if (getGlobal(\"Switch6.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 32 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 32 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch7\") {\r\n if (getGlobal(\"Switch7.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 64 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 64 1\");        \r\n    }\r\n}\r\nif ($n == \"Switch8\") {\r\n if (getGlobal(\"Switch8.status\")==1) {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 128 0\");        \r\n    } else {\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 128 1\");        \r\n    }\r\n}\r\n\r\n','Скрипт для управления реле',0,NULL,7,'2020-01-28 20:11:16','a:1:{s:7:\"nameobj\";s:7:\"Switch2\";}',0,'','00:00',0,0,'','',NULL,'/ajax/plans.html?op=click&id=1'),(24,'voshod','$latitude=(double) getGlobal(\"myobject.coord1\");\r\n$longitude=(double) getGlobal(\"myobject.coord1\");\r\n$sun_info = date_sun_info(time(), $latitude, $longitude); //Ваши географические координаты.\r\n\r\nforeach ($sun_info as $key => $val) {\r\n\r\nif ($key == \'sunrise\') {\r\n\r\n$sunrise = $val;\r\n//echo \'Восход: \'.date(\"H:i:s\", $sunrise).\'<br>\';\r\nsetGlobal(\'ThisComputer.SunRiseTime\',date(\"H:i\", $sunrise));\r\n}\r\n\r\nif ($key == \'sunset\') {\r\n\r\n$sunset = $val;\r\n$day_length = $sunset - $sunrise;\r\n\r\n//echo \'Заход: \'.date(\"H:i\", $sunset).\'<br>\';\r\n//echo \'Долгота дня: \'.gmdate(\"H:i\", $day_length).\'<br>\';\r\nsetGlobal(\'ThisComputer.SunSetTime\',date(\"H:i\", $sunset));\r\nsetGlobal(\'ThisComputer.LongTagTime\',gmdate(\"H:i\", $day_length));\r\n}\r\n\r\nif ($key == \'transit\') {\r\n//echo \'В зените: \'.date(\"H:i:s\", $val).\'<br>\';\r\nsetGlobal(\'ThisComputer.TransitTime\',date(\"H:i\", $val));\r\n}\r\n\r\nif ($key == \'civil_twilight_begin\') {\r\n//echo \'Начало утренних сумерек: \'.date(\"H:i\", $val).\'<br>\';\r\nsetGlobal(\'ThisComputer.Chicivil_beginTime\',date(\"H:i\", $val));\r\n}\r\n\r\nif ($key == \'civil_twilight_end\') {\r\n//echo \'Конец вечерних сумерек: \'.date(\"H:i:s\", $val).\'<br>\';\r\nsetGlobal(\'ThisComputer.civil_endTime\',date(\"H:i\", $val));\r\n}\r\n\r\n} ','',0,NULL,7,'2020-01-28 20:00:00','a:1:{s:6:\"script\";s:6:\"voshod\";}',0,'','00:00',0,0,'','',NULL,'/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(25,'OW_code','$ow_gorod=getGlobal(\"ow_city.name\");\r\n$Record = SQLSelectOne(\"SELECT * FROM `OPENWEATHER_CITY` WHERE `CITY_NAME`=\'\".$ow_gorod.\"\'\");\r\n   $ow_city_id = $Record[\'CITY_ID\'];\r\n   $ow_city_lat = $Record[\'CITY_LAT\']; \r\n   $ow_city_lng = $Record[\'CITY_LNG\']; \r\nsetGlobal(\'ow_city.id\',$ow_city_id);\r\nsetGlobal(\'myobject.coord1\',$ow_city_lat);\r\nsetGlobal(\'myobject.coord2\',$ow_city_lng);','код города для Open Weather',0,NULL,7,'2017-04-13 13:20:58','a:2:{s:5:\"VALUE\";s:6:\"Moscow\";s:9:\"OLD_VALUE\";s:12:\"Novyye Gorki\";}',0,'','00:00',0,0,'','',NULL,NULL),(26,'cam','$n = $params[\'url\'];\r\n$m = $params[\'coun\'];\r\n$s = $params[\'vid\'];\r\n//$n = \"https://youtu.be/JYBpu1OyP0c\";\r\n//$m = \"5\";\r\nshell_exec(\"/var/www/cam/1 $n $m $s\");','',0,NULL,3,'2018-03-19 10:45:33','a:3:{s:3:\"url\";s:28:\"https://youtu.be/jKtjpJBM2x8\";s:4:\"coun\";s:1:\"8\";s:3:\"vid\";s:2:\"96\";}',0,'','00:00',0,0,'','',NULL,NULL),(27,'calculate_realfeel','$t = gg(\'ow_fact.temperature\'); // температура на улице\r\n$h = gg(\'ow_fact.humidity\'); // влажность на улице %\r\n$w = gg(\'ow_fact.wind_speed\'); // данные о ветре из прогноза OpenWeather m/s\r\n$tF = $t *1.8+32; // перевод температуры в Farenheit\r\nif ($t > 26.6){\r\n // Считаем HeatIndex\r\n $_f=-42.379 + 2.04901523*$tF + 10.14333127*$h - 0.22475541*$tF*$h - 0.00683783*$tF*$tF - 0.05481717*$h*$h + 0.00122874*$tF*$tF*$h + 0.00085282*$tF*$h*$h -0.00000199*$tF*$tF*$h*$h;\r\n}else if ($t <= 10){\r\n // Считаем фактор WindChild\r\n $_f = 35.74+(0.6215*$tF)-(35.75*($w*0.16))+((0.4275*$tF)*($w*0.16));\r\n}else{\r\n //считаем по Rothfusz\r\n $_f = 0.5*($tF+61+(($tF-68)*1.2)+($h*0.094));\r\n}\r\n// переводим в цельсии\r\n $rf = round(($_f-32)/1.8,0);\r\n//и пропишем значение\r\nsg(\"ThisComputer.reelFeel\",$rf);\r\nsg(\'ow_fact.reelFeel\',$rf);\r\n// внесем дни недели прогноза\r\n$numD=gg(\"ow_setting.forecast_interval\");\r\n$day[0]=\"ВСК\";\r\n$day[1]=\"ПНД\";\r\n$day[2]=\"ВТР\";\r\n$day[3]=\"СРД\";\r\n$day[4]=\"ЧТВ\";\r\n$day[5]=\"ПТН\";\r\n$day[6]=\"СБТ\";\r\nfor ($i = 1; $i < $numD; $i++) {\r\n $dayNum = date(\"w\", strtotime($date .\' +\'.$i.\' day\'));\r\n $name = $day[date(\"w\", strtotime($date .\' +\'.$i.\' day\'))];\r\n sg(\"ow_day\".$i.\".name\", $name);\r\n } ','Скрипт вычисления на сколько чувствуется температура',0,NULL,5,'2018-01-13 08:00:02','a:1:{s:6:\"script\";s:18:\"calculate_realfeel\";}',0,'','00:00',0,0,'','',NULL,NULL),(28,'reboot','$filename  = ROOT . \'/database_backup/db.sql\';\r\n$mysqlDumpPath = \"/usr/bin/mysqldump\";\r\n$mysqlDumpParam = \" --user=\" . DB_USER . \" --password=\" . DB_PASSWORD;\r\n$mysqlDumpParam .= \" --no-create-db --add-drop-table --databases \" . DB_NAME;\r\nif (file_exists($filename)) rename($filename, $filename . \'.prev\');\r\nexec($mysqlDumpPath . $mysqlDumpParam . \" > \" . $filename);\r\nsay(\"Подготовка к перезагрузке\",2);\r\nsetTimeout(\"shutdownTimer\",\"safe_exec(\'shutdown -r now\');\",15); ','Скрипт перезагрузки с сохранением базы данных',0,NULL,7,NULL,NULL,0,'','00:00',0,0,'','',NULL,NULL),(29,'halt','$filename  = ROOT . \'/database_backup/db.sql\';\r\n$mysqlDumpPath = \"/usr/bin/mysqldump\";\r\n$mysqlDumpParam = \" --user=\" . DB_USER . \" --password=\" . DB_PASSWORD;\r\n$mysqlDumpParam .= \" --no-create-db --add-drop-table --databases \" . DB_NAME;\r\nif (file_exists($filename)) rename($filename, $filename . \'.prev\');\r\nexec($mysqlDumpPath . $mysqlDumpParam . \" > \" . $filename);\r\nsay(\"Подготовка к выключению\",2);\r\nsetTimeout(\"shutdownTimer\",\"safe_exec(\'shutdown -h now\');\",15); ','Скрипт выключения с сохранением базы данных',0,NULL,7,'2017-10-28 23:48:16',NULL,0,'','00:00',0,0,'','',NULL,NULL),(30,'Econom','// $pom - количество помещений\r\n$pom = 10;\r\n// $pom1 - номер помещения которое открыто при\r\n// закрытии всех клапанов\r\n$pom1 = 8;\r\n// если возможно перекрытие всех клапанов\r\n// то $clall больше i на 1, иначе $clall = i;\r\n$clall = 10;\r\nfor ($i = 1; $i <= $pom; $i++) {\r\n	$tempcab[1]=gg(\"tempD\".$i.\".temp\");\r\n  	if (gg(\"Econom\")) {\r\n  		$tempstab[1]=gg(\"EnergoMinTemp\");\r\n  	}else{\r\n  		$tempstab[1]=gg(\"tempD\".$i.\".tu\");\r\n  	}\r\n	if($tempstab[1]<$tempcab[1]){\r\n		sg(\"clapan\".$i.\".status\", \"1\");\r\n     	$clall++;\r\n	}else{\r\n		sg(\"clapan\".$i.\".status\", \"0\");\r\n	}\r\n}\r\nif($clall==$pom){\r\n sg(\"clapan\".$pom1.\".status\", \"0\");\r\n}\r\n// управление реле, команды для разных реле смотреть\r\n// в скрипте scene_switch\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 1 \".gg(\"clapan1.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 2 \".gg(\"clapan2.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 4 \".gg(\"clapan3.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 8 \".gg(\"clapan4.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 16 \".gg(\"clapan5.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 32 \".gg(\"clapan6.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 128 \".gg(\"clapan7.status\"));\r\nexec (\"/var/www/cms/scenes/rele.sh 0x20 256 \".gg(\"clapan8.status\"));\r\n\r\n','Скрипт управления отоплением',0,NULL,7,'2020-01-28 20:15:00','a:1:{s:6:\"script\";s:6:\"Econom\";}',0,'','00:00',0,0,'','','2020-01-28 17:48:38','/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(31,'backup','$filename  = ROOT . \'/database_backup/db.sql\';\r\n$mysqlDumpPath = \"/usr/bin/mysqldump\";\r\n$mysqlDumpParam = \" --user=\" . DB_USER . \" --password=\" . DB_PASSWORD;\r\n$mysqlDumpParam .= \" --no-create-db --add-drop-table --databases \" . DB_NAME;\r\nif (file_exists($filename)) rename($filename, $filename . \'.prev\');\r\nexec($mysqlDumpPath . $mysqlDumpParam . \" > \" . $filename);\r\nsay(\"Бэкаплю базу данных\",2);','Бэкап базы данных',0,NULL,7,'2017-11-13 02:27:17',NULL,0,'','00:00',0,0,'','',NULL,NULL),(32,'pcparam','$temp0 = file_get_contents (\"/sys/class/thermal/thermal_zone0/temp\");\r\nsg(\'pctemp\',$temp0);\r\n//CPU temp\r\n$cpu_temp=shell_exec(\'cat /sys/class/thermal/thermal_zone0/temp\') / 1000;\r\n$cpu_temp=round($cpu_temp,1);\r\nsg(\"CPU_temp\",$cpu_temp);\r\n\r\n//CPU usage\r\n$cpu_usage=exec(\"top -bn 1 | awk \'{print $9}\' | tail -n +8 | awk \'{s+=$1} END {print s}\'\");\r\nsg(\"CPU_usage\",$cpu_usage);\r\n\r\n//System uptime\r\n$sys_uptime=shell_exec(\"uptime\");\r\n$sys_uptime = explode(\" up \", $sys_uptime);\r\n$sys_uptime = explode(\",\", $sys_uptime[1]);\r\n$sys_uptime = $sys_uptime[0].\", \".$sys_uptime[1];\r\nsg(\"System_uptime\",$sys_uptime);\r\n\r\n//Memory usage/total\r\n$mem_total=exec(\"cat /proc/meminfo | grep MemTotal | awk \'{print $2}\'\");\r\n$mem_usage=$mem_total - exec(\"cat /proc/meminfo | grep MemFree | awk \'{print $2}\'\");\r\n$sys_memory=round($mem_usage * 100 / $mem_total, 1);\r\nsg(\"System_memory\",$sys_memory);\r\n\r\n//Memory Card\r\n$bytes = disk_free_space(\".\"); \r\n$si_prefix = array( \'B\', \'KB\', \'MB\', \'GB\', \'TB\', \'EB\', \'ZB\', \'YB\' );\r\n$base = 1024;\r\n$class = min((int)log($bytes , $base) , count($si_prefix) - 1);\r\n$temp = round($bytes / pow($base,$class)) . \' \' . $si_prefix[$class];\r\nsg(\'System_freespace\',$temp);\r\n\r\n//CPU 1 5 15\r\n$cpu_load=shell_exec(\'cat /proc/loadavg\');\r\n$pos1 = strpos($cpu_load,\" \");\r\n$pos2 = strpos($cpu_load,\" \",$pos1+1);\r\n$pos3 = strpos($cpu_load,\" \",$pos2+1);\r\n$cpu_load1  = substr($cpu_load,0,$pos1);\r\n$cpu_load5  = substr($cpu_load,$pos1+1,$pos2-$pos1-1);\r\n$cpu_load15 = substr($cpu_load,$pos2+1,$pos3-$pos2-1);\r\nsg(\"cpu_load1\",$cpu_load1);\r\nsg(\"cpu_load5\",$cpu_load5);\r\nsg(\"cpu_load15\",$cpu_load15);\r\n//mem info\r\n$mem_info=shell_exec(\'cat /proc/meminfo\');\r\n$pos1 = strpos($mem_info,\"MemTotal\");\r\n$pos2 = strpos($mem_info,\"MemFree\");\r\n$pos3 = strpos($mem_info,\"Cached\");\r\n$pos4 = strpos($mem_info,\"SwapTotal\");\r\n$pos5 = strpos($mem_info,\"SwapFree\");\r\n$mem_total = substr($mem_info,$pos1+11,13)*1;\r\n$mem_free = substr($mem_info,$pos2+11,13)*1;\r\n$mem_cached = substr($mem_info,$pos3+11,13)*1;\r\n$mem_swap_total = substr($mem_info,$pos4+11,13)*1;\r\n$mem_swap_free = substr($mem_info,$pos5+11,13)*1;\r\n$mem_swap_used = $mem_swap_total - $mem_swap_free;\r\n$mem_used = $mem_total - $mem_free - $mem_cached;\r\nsg(\"mem_total\",$mem_total);\r\nsg(\"mem_free\",$mem_free);\r\nsg(\"mem_cached\",$mem_cached);\r\nsg(\"mem_swap_total\",$mem_swap_total);\r\nsg(\"mem_swap_free\",$mem_swap_free);\r\nsg(\"mem_swap_used\",$mem_swap_used);\r\nsg(\"mem_used\",$mem_used);\r\n\r\n$sd_info=shell_exec(\'df /\');\r\n$pos0 = strpos($sd_info,\"dev\");\r\n$pos1 = strpos($sd_info,\" \",$pos0+5);\r\n$pos2 = strpos($sd_info,\" \",$pos1+3);\r\n$pos3 = strpos($sd_info,\" \",$pos2+3);\r\n$pos4 = strpos($sd_info,\" \",$pos3+4);\r\n$sd_total = substr($sd_info,$pos1,$pos2-$pos1)*1;\r\n$sd_used = substr($sd_info,$pos2,$pos3-$pos2)*1;\r\n$sd_free = substr($sd_info,$pos3,$pos4-$pos3)*1;\r\nsg(\"sd_total\",$sd_total);\r\nsg(\"sd_used\",$sd_used);\r\nsg(\"sd_free\",$sd_free);\r\n','температура процессора',0,NULL,4,'2020-01-28 00:13:00','a:1:{s:6:\"script\";s:7:\"pcparam\";}',0,'','00:00',0,0,'','',NULL,'/api.php/method/ClockChime.onNewMinute?m_c_s[0]=ClockChime.onNewMinute&no_session=1'),(33,'security','$mod=gg(\'securityMode\');\r\n\r\nif ($mod){\r\n sg(\'securityMode\',0);\r\n}else{\r\n sg(\'securityMode\',1);\r\n}\r\n\r\n\r\n\r\n','',0,NULL,4,'2018-03-17 02:13:10','a:1:{s:5:\"STATE\";s:2:\"on\";}',0,'','00:00',0,0,'','',NULL,NULL),(34,'econom_switch','$mod=gg(\'Econom\');\r\n\r\nif ($mod){\r\n sg(\'Econom\',0);\r\n}else{\r\n sg(\'Econom\',1);\r\n}\r\n\r\n\r\n\r\n','',0,'',4,'2018-03-17 02:13:13','a:1:{s:5:\"STATE\";s:2:\"on\";}',0,'','00:00',0,0,'','',NULL,NULL),(35,'temp1_minus','$tek = gg(\"tempP1\");\r\n$tek = $tek-1;\r\nsg(\"tempP1\", $tek);','',0,NULL,8,'2020-01-28 01:58:27',NULL,0,'0','00:00',0,0,'','','2020-01-27 19:47:49','/ajax/plans.html?op=click&id=10'),(36,'temp1_plus','$tek = gg(\"tempP1\");\r\n$tek = $tek+1;\r\nsg(\"tempP1\", $tek);','',0,'',8,'2020-01-28 01:39:01','',0,'0','00:00',0,0,'','','2020-01-27 19:56:29','/ajax/plans.html?op=click&id=9'),(37,'temp2_plus','$tek = gg(\"tempP2\");\r\n$tek = $tek+1;\r\nsg(\"tempP2\", $tek);','',0,'',8,'2020-01-28 01:56:50','',0,'0','00:00',0,0,'','','2020-01-27 20:11:10','/ajax/plans.html?op=click&id=12'),(38,'temp3_plus','$tek = gg(\"tempP3\");\r\n$tek = $tek+1;\r\nsg(\"tempP3\", $tek);','',0,'',8,'2020-01-28 01:39:09','',0,'0','00:00',0,0,'','','2020-01-27 20:11:28','/ajax/plans.html?op=click&id=13'),(39,'temp2_minus','$tek = gg(\"tempP2\");\r\n$tek = $tek-1;\r\nsg(\"tempP2\", $tek);','',0,'',8,'2020-01-28 16:57:52','',0,'0','00:00',0,0,'','','2020-01-27 20:11:51','/ajax/plans.html?op=click&id=8'),(40,'temp3_minus','$tek = gg(\"tempP3\");\r\n$tek = $tek-1;\r\nsg(\"tempP3\", $tek);','',0,'',8,'2020-01-28 01:39:07','',0,'0','00:00',0,0,'','','2020-01-27 20:12:13','/ajax/plans.html?op=click&id=11'),(41,'temp4_minus','$tek = gg(\"tempP4\");\r\n$tek = $tek-1;\r\nsg(\"tempP4\", $tek);','',0,'',8,'2020-01-28 00:59:51','',0,'0','00:00',0,0,'','','2020-01-27 22:38:50','/ajax/plans.html?op=click&id=14'),(42,'temp4_plus','$tek = gg(\"tempP4\");\r\n$tek = $tek+1;\r\nsg(\"tempP4\", $tek);','',0,'',8,'2020-01-28 00:59:53','',0,'0','00:00',0,0,'','','2020-01-27 22:39:19','/ajax/plans.html?op=click&id=15');
/*!40000 ALTER TABLE `scripts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `security_rules`
--

DROP TABLE IF EXISTS `security_rules`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `security_rules` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `OBJECT_TYPE` char(20) NOT NULL DEFAULT '',
  `OBJECT_ID` int(10) NOT NULL DEFAULT '0',
  `TERMINALS` varchar(255) NOT NULL DEFAULT '',
  `TERMINALS_EXCEPT` int(3) NOT NULL DEFAULT '0',
  `USERS` varchar(255) NOT NULL DEFAULT '',
  `USERS_EXCEPT` int(3) NOT NULL DEFAULT '0',
  `TIMES` varchar(255) NOT NULL DEFAULT '',
  `TIMES_EXCEPT` int(3) NOT NULL DEFAULT '0',
  `CONDITION_ACTIVE` int(3) NOT NULL DEFAULT '0',
  `CONDITION_LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `CONDITION_LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CONDITION` int(3) NOT NULL DEFAULT '0',
  `CONDITION_VALUE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `security_rules`
--

LOCK TABLES `security_rules` WRITE;
/*!40000 ALTER TABLE `security_rules` DISABLE KEYS */;
/*!40000 ALTER TABLE `security_rules` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `settings`
--

DROP TABLE IF EXISTS `settings`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `settings` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `PRIORITY` int(3) unsigned NOT NULL DEFAULT '0',
  `HR` int(3) unsigned NOT NULL DEFAULT '0',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `NAME` varchar(50) NOT NULL DEFAULT '',
  `TYPE` varchar(59) NOT NULL DEFAULT '',
  `NOTES` text NOT NULL,
  `VALUE` text,
  `DEFAULTVALUE` varchar(255) NOT NULL DEFAULT '',
  `URL` varchar(255) NOT NULL DEFAULT '',
  `URL_TITLE` varchar(255) NOT NULL DEFAULT '',
  `DATA` text NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=99 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `settings`
--

LOCK TABLES `settings` WRITE;
/*!40000 ALTER TABLE `settings` DISABLE KEYS */;
INSERT INTO `settings` VALUES (7,0,0,'Days to show in \"soon\" section','APP_CALENDAR_SOONLIMIT','text','','6','6','','',''),(8,0,0,'Show recently done items','APP_CALENDAR_SHOWDONE','yesno','','1','1','','',''),(9,0,0,'Scene width','SCENES_WIDTH','text','','803','803','','',''),(24,0,0,'Scene height','SCENES_HEIGHT','text','','606','606','','',''),(95,0,0,'Показывать календарь в Делах и Событиях','APP_CALENDAR_SHOWCALENDAR','yesno','','1','1','','',''),(61,0,0,'Voice notifications language','VOICE_LANGUAGE','text','','ru','en','','',''),(62,0,0,'Color theme','THEME','text','','light','dark','','',''),(44,0,0,'Play sound signal before speaking','SPEAK_SIGNAL','onoff','','1','1','','',''),(59,30,0,'Before SAY (code)','HOOK_BEFORE_SAY','text','','','','','',''),(60,29,0,'After SAY (code)','HOOK_AFTER_SAY','text','','','','','',''),(69,0,0,'Path to store backup','BACKUP_PATH','text','','','','','',''),(72,0,0,'Computer\'s name','GENERAL_ALICE_NAME','text','','','','','',''),(74,0,0,'Time zone','SITE_TIMEZONE','text','','Europe/Moscow','Europe/Moscow','','',''),(98,0,0,'HOOK_EVENT_MINUTELY','HOOK_EVENT_MINUTELY','json','','{\"devices\":{\"filter\":\"\"}}','','','',''),(79,0,0,'Language','SITE_LANGUAGE','text','','ru','en','','',''),(80,0,0,'HOOK_EVENT_HOURLY','HOOK_EVENT_HOURLY','json','','{\"connect\":{\"filter\":\"\"},\"app_openweather\":{\"filter\":\"\"},\"ExchangeRates\":{\"filter\":\"\"},\"terminals\":{\"filter\":\"\"}}','','','',''),(81,0,0,'HOOK_EVENT_SAY','HOOK_EVENT_SAY','json','','{\"telegram\":{\"filter\":\"\",\"priority\":10},\"rhvoice\":{\"filter\":\"\"},\"yandex_tts\":{\"filter\":\"\",\"priority\":10},\"patterns\":{\"filter\":\"\"},\"terminals\":{\"filter\":\"\",\"priority\":99},\"connect\":{\"filter\":\"\"}}','','','',''),(82,0,0,'HOOK_EVENT_COMMAND','HOOK_EVENT_COMMAND','json','','{\"devices\":{\"filter\":\"\"},\"apiai\":{\"priority\":100,\"filter\":\"\"},\"patterns\":{\"filter\":\"\"},\"scripts\":{\"filter\":\"\"}}','','','',''),(83,0,0,'HOOK_EVENT_SAYTO','HOOK_EVENT_SAYTO','json','','{\"telegram\":{\"filter\":\"\",\"priority\":10},\"terminals\":{\"filter\":\"\",\"priority\":99},\"yandex_tts\":{\"filter\":\"\"},\"rhvoice\":{\"filter\":\"\",\"priority\":100}}','','','',''),(84,0,0,'HOOK_EVENT_SAYREPLY','HOOK_EVENT_SAYREPLY','json','','{\"telegram\":{\"filter\":\"\",\"priority\":10},\"terminals\":{\"filter\":\"\",\"priority\":99},\"rhvoice\":{\"filter\":\"\",\"priority\":100},\"yandex_tts\":{\"filter\":\"\",\"priority\":100}}','','','',''),(85,0,0,'Vertical navigation','SCENES_VERTICAL_NAV','onoff','','','0','','',''),(86,0,0,'Path to background','SCENES_BACKGROUND','path','','','','','',''),(87,0,0,'Path to video background','SCENES_BACKGROUND_VIDEO','path','','','','','',''),(88,0,0,'Path to click-sound file','SCENES_CLICKSOUND','path','','','','','',''),(89,0,0,'Backround Fixed','SCENES_BACKGROUND_FIXED','onoff','','','0','','',''),(90,0,0,'Background No repeat','SCENES_BACKGROUND_NOREPEAT','onoff','','','0','','',''),(91,0,0,'Bar-code reading (code)','HOOK_BARCODE','text','','','','','',''),(92,0,0,'Playmedia (code)','HOOK_PLAYMEDIA','text','','','','','',''),(93,0,0,'Before PlaySound (code)','HOOK_BEFORE_PLAYSOUND','text','','','','','',''),(94,0,0,'After PlaySound (code)','HOOK_AFTER_PLAYSOUND','text','','','','','',''),(96,0,0,'HOOK_EVENT_ASK','HOOK_EVENT_ASK','json','','{\"terminals\":{\"filter\":\"\",\"priority\":99},\"yandex_tts\":{\"filter\":\"\"},\"rhvoice\":{\"filter\":\"\",\"priority\":100}}','','','',''),(97,0,0,'HOOK_EVENT_SAY_CACHED_READY','HOOK_EVENT_SAY_CACHED_READY','json','','{\"terminals\":{\"filter\":99}}','','','','');
/*!40000 ALTER TABLE `settings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shoplist`
--

DROP TABLE IF EXISTS `shoplist`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shoplist` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shoplist`
--

LOCK TABLES `shoplist` WRITE;
/*!40000 ALTER TABLE `shoplist` DISABLE KEYS */;
/*!40000 ALTER TABLE `shoplist` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_list_items`
--

DROP TABLE IF EXISTS `shopping_list_items`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shopping_list_items` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `PRODUCT_ID` int(10) NOT NULL DEFAULT '0',
  `PRICE` float NOT NULL DEFAULT '0',
  `CODE` varchar(255) NOT NULL DEFAULT '',
  `IN_CART` int(3) NOT NULL DEFAULT '0',
  `List_Qty` int(3) NOT NULL DEFAULT '1',
  `Ed_Izm` varchar(15) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shopping_list_items`
--

LOCK TABLES `shopping_list_items` WRITE;
/*!40000 ALTER TABLE `shopping_list_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_list_items` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shoutrooms`
--

DROP TABLE IF EXISTS `shoutrooms`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shoutrooms` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(250) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '0',
  `ADDED_BY` int(10) NOT NULL DEFAULT '0',
  `ADDED` datetime DEFAULT NULL,
  `IS_PUBLIC` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shoutrooms`
--

LOCK TABLES `shoutrooms` WRITE;
/*!40000 ALTER TABLE `shoutrooms` DISABLE KEYS */;
/*!40000 ALTER TABLE `shoutrooms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shouts`
--

DROP TABLE IF EXISTS `shouts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shouts` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ROOM_ID` int(10) NOT NULL DEFAULT '0',
  `MEMBER_ID` int(10) NOT NULL DEFAULT '0',
  `MESSAGE` varchar(255) NOT NULL DEFAULT '',
  `ADDED` datetime DEFAULT NULL,
  `IMPORTANCE` int(10) NOT NULL DEFAULT '0',
  `SOURCE` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=787 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shouts`
--

LOCK TABLES `shouts` WRITE;
/*!40000 ALTER TABLE `shouts` DISABLE KEYS */;
INSERT INTO `shouts` VALUES (760,0,0,'Статус связи изменился на Жёлтый.','2020-01-21 21:01:20',0,''),(761,0,0,'Нет доступа в Интернет','2020-01-21 21:01:20',0,''),(762,0,0,'Статус связи восстановился на Зелёный','2020-01-21 21:11:17',0,''),(763,0,0,'Статус связи изменился на Жёлтый.','2020-01-22 05:45:54',0,''),(764,0,0,'Нет доступа в Интернет','2020-01-22 05:45:54',0,''),(765,0,0,'Статус связи восстановился на Зелёный','2020-01-22 06:06:26',0,''),(766,0,0,'Статус связи изменился на Жёлтый.','2020-01-22 19:43:13',0,''),(767,0,0,'Нет доступа в Интернет','2020-01-22 19:43:13',0,''),(768,0,0,'Статус связи восстановился на Зелёный','2020-01-22 20:03:21',0,''),(769,0,0,'Статус связи изменился на Жёлтый.','2020-01-23 23:06:49',0,''),(770,0,0,'Нет доступа в Интернет','2020-01-23 23:06:49',0,''),(771,0,0,'Статус связи восстановился на Зелёный','2020-01-24 00:48:19',0,''),(772,0,0,'Статус связи изменился на Жёлтый.','2020-01-25 00:09:55',0,''),(773,0,0,'Нет доступа в Интернет','2020-01-25 00:09:55',0,''),(774,0,0,'Статус связи восстановился на Зелёный','2020-01-25 00:20:07',0,''),(775,0,0,'Статус связи изменился на Жёлтый.','2020-01-26 15:14:56',0,''),(776,0,0,'Нет доступа в Интернет','2020-01-26 15:14:56',0,''),(777,0,0,'Статус связи восстановился на Зелёный','2020-01-26 15:24:57',0,''),(778,0,0,'Статус связи изменился на Жёлтый.','2020-01-26 21:19:18',0,''),(779,0,0,'Нет доступа в Интернет','2020-01-26 21:19:18',0,''),(780,0,0,'Статус связи восстановился на Зелёный','2020-01-26 21:29:25',0,''),(781,0,0,'Статус связи изменился на Жёлтый.','2020-01-26 23:10:27',0,''),(782,0,0,'Нет доступа в Интернет','2020-01-26 23:10:27',0,''),(783,0,0,'Статус связи восстановился на Зелёный','2020-01-26 23:20:33',0,''),(784,0,0,'Статус связи изменился на Жёлтый.','2020-01-27 16:19:04',0,''),(785,0,0,'Нет доступа в Интернет','2020-01-27 16:19:04',0,''),(786,0,0,'Статус связи восстановился на Зелёный','2020-01-27 16:29:05',0,'');
/*!40000 ALTER TABLE `shouts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_errors`
--

DROP TABLE IF EXISTS `system_errors`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system_errors` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `CODE` varchar(50) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `DETAILS` text,
  `ACTIVE` int(3) NOT NULL DEFAULT '0',
  `LATEST_UPDATE` datetime DEFAULT NULL,
  `KEEP_HISTORY` int(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system_errors`
--

LOCK TABLES `system_errors` WRITE;
/*!40000 ALTER TABLE `system_errors` DISABLE KEYS */;
INSERT INTO `system_errors` VALUES (12,'cycle_hang','',NULL,23,'2019-12-16 22:54:17',1),(13,'cycle_stop','',NULL,8,'2018-11-29 10:45:58',1);
/*!40000 ALTER TABLE `system_errors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_errors_data`
--

DROP TABLE IF EXISTS `system_errors_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system_errors_data` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ERROR_ID` int(10) NOT NULL DEFAULT '0',
  `COMMENTS` text,
  `ADDED` datetime DEFAULT NULL,
  `PROPERTIES_DATA` text,
  `METHODS_DATA` text,
  `SCRIPTS_DATA` text,
  `TIMERS_DATA` text,
  `EVENTS_DATA` text,
  `DEBUG_DATA` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=134 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system_errors_data`
--

LOCK TABLES `system_errors_data` WRITE;
/*!40000 ALTER TABLE `system_errors_data` DISABLE KEYS */;
INSERT INTO `system_errors_data` VALUES (103,12,'cycle_scheduler\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_scheduler\')\n#1 {main}','2018-11-29 10:45:48',NULL,NULL,NULL,NULL,NULL,NULL),(104,12,'cycle_ping\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_ping\')\n#1 {main}','2018-11-29 10:45:48',NULL,NULL,NULL,NULL,NULL,NULL),(105,12,'cycle_execs\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_execs\')\n#1 {main}','2018-11-29 10:45:48',NULL,NULL,NULL,NULL,NULL,NULL),(106,12,'cycle_mqtt\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_mqtt\')\n#1 {main}','2018-11-29 10:45:48',NULL,NULL,NULL,NULL,NULL,NULL),(107,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2018-11-29 10:45:48',NULL,NULL,NULL,NULL,NULL,NULL),(108,12,'cycle_ping\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_ping\')\n#1 {main}','2018-11-29 10:45:49',NULL,NULL,NULL,NULL,NULL,NULL),(109,12,'cycle_execs\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_execs\')\n#1 {main}','2018-11-29 10:45:49',NULL,NULL,NULL,NULL,NULL,NULL),(110,12,'cycle_mqtt\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_mqtt\')\n#1 {main}','2018-11-29 10:45:49',NULL,NULL,NULL,NULL,NULL,NULL),(111,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2018-11-29 10:45:49',NULL,NULL,NULL,NULL,NULL,NULL),(112,12,'cycle_ping\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_ping\')\n#1 {main}','2018-11-29 10:45:50',NULL,NULL,NULL,NULL,NULL,NULL),(113,12,'cycle_execs\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_execs\')\n#1 {main}','2018-11-29 10:45:50',NULL,NULL,NULL,NULL,NULL,NULL),(114,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2018-11-29 10:45:50',NULL,NULL,NULL,NULL,NULL,NULL),(115,12,'cycle_ping\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_ping\')\n#1 {main}','2018-11-29 10:45:51',NULL,NULL,NULL,NULL,NULL,NULL),(116,12,'cycle_execs\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_execs\')\n#1 {main}','2018-11-29 10:45:51',NULL,NULL,NULL,NULL,NULL,NULL),(117,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2018-11-29 10:45:52',NULL,NULL,NULL,NULL,NULL,NULL),(118,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(366): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2018-11-29 10:45:53',NULL,NULL,NULL,NULL,NULL,NULL),(119,13,'./scripts/cycle_scheduler.php\n1THREAD CLOSED: [exec php -q ./scripts/cycle_scheduler.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_scheduler.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_ping.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_ping.php.txt]\nTHREAD CLOSED: [exec php -q ./scripts/cycle_phistory.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_phistory.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_execs.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_execs.php.txt]\n1111THREAD CLOSED: [exec php -q ./scripts/cycle_mqtt.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_mqtt.php.txt]\n111111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:53',NULL,NULL,NULL,NULL,NULL,NULL),(120,13,'./scripts/cycle_ping.php\n1THREAD CLOSED: [exec php -q ./scripts/cycle_scheduler.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_scheduler.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_ping.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_ping.php.txt]\nTHREAD CLOSED: [exec php -q ./scripts/cycle_phistory.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_phistory.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_execs.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_execs.php.txt]\n1111THREAD CLOSED: [exec php -q ./scripts/cycle_mqtt.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_mqtt.php.txt]\n111111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:53',NULL,NULL,NULL,NULL,NULL,NULL),(121,13,'./scripts/cycle_phistory.php\n1THREAD CLOSED: [exec php -q ./scripts/cycle_scheduler.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_scheduler.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_ping.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_ping.php.txt]\nTHREAD CLOSED: [exec php -q ./scripts/cycle_phistory.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_phistory.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_execs.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_execs.php.txt]\n1111THREAD CLOSED: [exec php -q ./scripts/cycle_mqtt.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_mqtt.php.txt]\n111111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:53',NULL,NULL,NULL,NULL,NULL,NULL),(122,13,'./scripts/cycle_execs.php\n1THREAD CLOSED: [exec php -q ./scripts/cycle_scheduler.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_scheduler.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_ping.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_ping.php.txt]\nTHREAD CLOSED: [exec php -q ./scripts/cycle_phistory.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_phistory.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_execs.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_execs.php.txt]\n1111THREAD CLOSED: [exec php -q ./scripts/cycle_mqtt.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_mqtt.php.txt]\n111111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:53',NULL,NULL,NULL,NULL,NULL,NULL),(123,13,'./scripts/cycle_mqtt.php\n1THREAD CLOSED: [exec php -q ./scripts/cycle_scheduler.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_scheduler.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_ping.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_ping.php.txt]\nTHREAD CLOSED: [exec php -q ./scripts/cycle_phistory.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_phistory.php.txt]\n1THREAD CLOSED: [exec php -q ./scripts/cycle_execs.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_execs.php.txt]\n1111THREAD CLOSED: [exec php -q ./scripts/cycle_mqtt.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_mqtt.php.txt]\n111111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:53',NULL,NULL,NULL,NULL,NULL,NULL),(124,13,'./scripts/cycle_webvars.php\n111111111THREAD CLOSED: [exec php -q ./scripts/cycle_webvars.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_webvars.php.txt]\n111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:54',NULL,NULL,NULL,NULL,NULL,NULL),(125,13,'./scripts/cycle_execs.php\n111111111111THREAD CLOSED: [exec php -q ./scripts/cycle_execs.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_execs.php.txt]\n1111\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:57',NULL,NULL,NULL,NULL,NULL,NULL),(126,13,'./scripts/cycle_ping.php\n11111111111111THREAD CLOSED: [exec php -q ./scripts/cycle_ping.php --params \"a:0:{}\">>/var/www/cms/debmes/log_2018-11-29-cycle_ping.php.txt]\n1\nBacktrace:\n#0 /var/www/cycle.php(455): registerError(\'cycle_stop\', \'./scripts/cycle...\')\n#1 {main}','2018-11-29 10:45:58',NULL,NULL,NULL,NULL,NULL,NULL),(127,12,'cycle_ping\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_ping\')\n#1 {main}','2019-12-16 22:54:16',NULL,NULL,NULL,NULL,NULL,NULL),(128,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2019-12-16 22:54:16',NULL,NULL,NULL,NULL,NULL,NULL),(129,12,'cycle_scheduler\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_scheduler\')\n#1 {main}','2019-12-16 22:54:16',NULL,NULL,NULL,NULL,NULL,NULL),(130,12,'cycle_execs\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_execs\')\n#1 {main}','2019-12-16 22:54:16',NULL,NULL,NULL,NULL,NULL,NULL),(131,12,'cycle_ping\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_ping\')\n#1 {main}','2019-12-16 22:54:17',NULL,NULL,NULL,NULL,NULL,NULL),(132,12,'cycle_webvars\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_webvars\')\n#1 {main}','2019-12-16 22:54:17',NULL,NULL,NULL,NULL,NULL,NULL),(133,12,'cycle_execs\nBacktrace:\n#0 /var/www/cycle.php(362): registerError(\'cycle_hang\', \'cycle_execs\')\n#1 {main}','2019-12-16 22:54:17',NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `system_errors_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tdwiki`
--

DROP TABLE IF EXISTS `tdwiki`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tdwiki` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(100) NOT NULL DEFAULT '',
  `CONTENT` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tdwiki`
--

LOCK TABLES `tdwiki` WRITE;
/*!40000 ALTER TABLE `tdwiki` DISABLE KEYS */;
INSERT INTO `tdwiki` VALUES (1,'','<!--#\n @version 0.1 (auto-set)\n#-->\n<div tiddler=\"DefaultTiddlers\" modified=\"200610311519\" modifier=\"Serge J.\" tags=\"\">[[Notes]]</div>\r\n<div tiddler=\"MainMenu\" modified=\"200610311519\" modifier=\"Serge J.\" tags=\"\">[[Notes]]  [[FormattingInstructions]] [[MainMenu]] [[DefaultTiddlers]]</div>\r\n<div tiddler=\"FormattingInstructions\" modified=\"200607061334\" modifier=\"YourName\" tags=\"\">TiddlyWiki uses Wiki style markup, a way of lightly &quot;tagging&quot; plain text so it can be transformed into HTML. Edit this Tiddler to see samples.\\n\\n! Header Samples\\n!Header 1\\n!!Header 2\\n!!!Header 3\\n!!!!Header 4\\n!!!!!Header 5\\n\\n! Unordered Lists:\\n* Lists are where it\'s at\\n* Just use an asterisk and you\'re set\\n** To nest lists just add more asterisks...\\n***...like this\\n* The circle makes a great bullet because once you\'ve printed a list you can mark off completed items\\n* You can also nest mixed list types\\n## Like this\\n\\n! Ordered Lists\\n# Ordered lists are pretty neat too\\n# If you\'re handy with HTML and CSS you could customize the [[numbering scheme|http://www.w3schools.com/css/pr_list-style-type.asp]]\\n## To nest, just add more octothorpes (pound signs)...\\n### Like this\\n* You can also\\n** Mix list types\\n*** like this\\n# Pretty neat don\'t you think?\\n\\n! Tiddler links\\nTo create a Tiddler link, just use mixed-case WikiWord, or use [[brackets]] for NonWikiWordLinks. This is how the GTD style [[@Action]] lists are created. \\n\\nNote that existing Tiddlers are in bold and empty Tiddlers are in italics. See CreatingTiddlers for details.\\n\\n! External Links\\nYou can link to [[external sites|http://google.com]] with brackets. You can also LinkToFolders on your machine or network shares.\\n\\n! Images\\nEdit this tiddler to see how it\'s done.\\n[img[http://img110.echo.cx/img110/139/gorilla8nw.jpg]]\\n\\n!Tables\\n|!th1111111111|!th2222222222|\\n|&gt;| colspan |\\n| rowspan |left|\\n|~| right|\\n|colored| center |\\n|caption|c\\n\\nFor a complex table example, see PeriodicTable.\\n\\n! Horizontal Rules\\nYou can divide a tiddler into\\n----\\nsections by typing four dashes on a line by themselves.\\n\\n! Blockquotes\\n&lt;&lt;&lt;\\nThis is how you do an extended, wrapped blockquote so you don\'t have to put angle quotes on every line.\\n&lt;&lt;&lt;\\n&gt;level 1\\n&gt;level 1\\n&gt;&gt;level 2\\n&gt;&gt;level 2\\n&gt;&gt;&gt;level 3\\n&gt;&gt;&gt;level 3\\n&gt;&gt;level 2\\n&gt;level 1\\n\\n! Other Formatting\\n\'\'Bold\'\'\\n==Strike==\\n__Underline__\\n//Italic//\\nSuperscript: 2^^3^^=8\\nSubscript: a~~ij~~ = -a~~ji~~\\n@@highlight@@ Unfortunately highlighting is broken right now.\\n@@color(green):green colored@@\\n@@bgcolor(#ff0000):color(#ffffff):red colored@@ Hex colors are also broken right now.\\n</div>'),(2,'default','<!--#\n @version 0.1 (auto-set)\n#-->\n<div tiddler=\"DefaultTiddlers\" modified=\"200610311519\" modifier=\"Serge J.\" tags=\"\">[[Notes]]</div>\r\n<div tiddler=\"MainMenu\" modified=\"200610311519\" modifier=\"Serge J.\" tags=\"\">[[Notes]]  [[FormattingInstructions]] [[MainMenu]] [[DefaultTiddlers]]</div>\r\n<div tiddler=\"FormattingInstructions\" modified=\"200607061334\" modifier=\"YourName\" tags=\"\">TiddlyWiki uses Wiki style markup, a way of lightly &quot;tagging&quot; plain text so it can be transformed into HTML. Edit this Tiddler to see samples.\\n\\n! Header Samples\\n!Header 1\\n!!Header 2\\n!!!Header 3\\n!!!!Header 4\\n!!!!!Header 5\\n\\n! Unordered Lists:\\n* Lists are where it\'s at\\n* Just use an asterisk and you\'re set\\n** To nest lists just add more asterisks...\\n***...like this\\n* The circle makes a great bullet because once you\'ve printed a list you can mark off completed items\\n* You can also nest mixed list types\\n## Like this\\n\\n! Ordered Lists\\n# Ordered lists are pretty neat too\\n# If you\'re handy with HTML and CSS you could customize the [[numbering scheme|http://www.w3schools.com/css/pr_list-style-type.asp]]\\n## To nest, just add more octothorpes (pound signs)...\\n### Like this\\n* You can also\\n** Mix list types\\n*** like this\\n# Pretty neat don\'t you think?\\n\\n! Tiddler links\\nTo create a Tiddler link, just use mixed-case WikiWord, or use [[brackets]] for NonWikiWordLinks. This is how the GTD style [[@Action]] lists are created. \\n\\nNote that existing Tiddlers are in bold and empty Tiddlers are in italics. See CreatingTiddlers for details.\\n\\n! External Links\\nYou can link to [[external sites|http://google.com]] with brackets. You can also LinkToFolders on your machine or network shares.\\n\\n! Images\\nEdit this tiddler to see how it\'s done.\\n[img[http://img110.echo.cx/img110/139/gorilla8nw.jpg]]\\n\\n!Tables\\n|!th1111111111|!th2222222222|\\n|&gt;| colspan |\\n| rowspan |left|\\n|~| right|\\n|colored| center |\\n|caption|c\\n\\nFor a complex table example, see PeriodicTable.\\n\\n! Horizontal Rules\\nYou can divide a tiddler into\\n----\\nsections by typing four dashes on a line by themselves.\\n\\n! Blockquotes\\n&lt;&lt;&lt;\\nThis is how you do an extended, wrapped blockquote so you don\'t have to put angle quotes on every line.\\n&lt;&lt;&lt;\\n&gt;level 1\\n&gt;level 1\\n&gt;&gt;level 2\\n&gt;&gt;level 2\\n&gt;&gt;&gt;level 3\\n&gt;&gt;&gt;level 3\\n&gt;&gt;level 2\\n&gt;level 1\\n\\n! Other Formatting\\n\'\'Bold\'\'\\n==Strike==\\n__Underline__\\n//Italic//\\nSuperscript: 2^^3^^=8\\nSubscript: a~~ij~~ = -a~~ji~~\\n@@highlight@@ Unfortunately highlighting is broken right now.\\n@@color(green):green colored@@\\n@@bgcolor(#ff0000):color(#ffffff):red colored@@ Hex colors are also broken right now.\\n</div>');
/*!40000 ALTER TABLE `tdwiki` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `terminals`
--

DROP TABLE IF EXISTS `terminals`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `terminals` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(255) NOT NULL DEFAULT '',
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `HOST` varchar(255) NOT NULL DEFAULT '',
  `CANPLAY` int(3) NOT NULL DEFAULT '0',
  `PLAYER_TYPE` char(10) NOT NULL DEFAULT '',
  `PLAYER_PORT` varchar(255) NOT NULL DEFAULT '',
  `PLAYER_USERNAME` varchar(255) NOT NULL DEFAULT '',
  `PLAYER_PASSWORD` varchar(255) NOT NULL DEFAULT '',
  `IS_ONLINE` int(3) NOT NULL DEFAULT '0',
  `MAJORDROID_API` int(3) NOT NULL DEFAULT '0',
  `LATEST_REQUEST` varchar(255) NOT NULL DEFAULT '',
  `LATEST_REQUEST_TIME` datetime DEFAULT NULL,
  `LATEST_ACTIVITY` datetime DEFAULT NULL,
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LEVEL_LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CANTTS` int(3) NOT NULL DEFAULT '0',
  `MIN_MSG_LEVEL` varchar(255) NOT NULL DEFAULT '',
  `PLAYER_CONTROL_ADDRESS` varchar(255) NOT NULL DEFAULT '',
  `TTS_TYPE` char(20) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `terminals`
--

LOCK TABLES `terminals` WRITE;
/*!40000 ALTER TABLE `terminals` DISABLE KEYS */;
INSERT INTO `terminals` VALUES (2,'MAIN','Server','localhost',1,'vlcweb','7070','','12345',1,0,'','2019-12-17 11:14:40','2020-01-28 20:11:16','','',0,'','','');
/*!40000 ALTER TABLE `terminals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tlg_cmd`
--

DROP TABLE IF EXISTS `tlg_cmd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tlg_cmd` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `DESCRIPTION` text,
  `CODE` text,
  `ACCESS` int(10) NOT NULL DEFAULT '0',
  `SHOW_MODE` int(10) NOT NULL DEFAULT '1',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CONDITION` int(10) NOT NULL DEFAULT '1',
  `CONDITION_VALUE` varchar(255) NOT NULL DEFAULT '',
  `PRIORITY` int(10) NOT NULL DEFAULT '1',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tlg_cmd`
--

LOCK TABLES `tlg_cmd` WRITE;
/*!40000 ALTER TABLE `tlg_cmd` DISABLE KEYS */;
INSERT INTO `tlg_cmd` VALUES (1,'Ping','Example command Ping-Pong','return \"Pong!\";',2,2,'','',1,'',1),(2,'меню','','',3,1,'','',1,'',0),(3,'Назад','','return \"Выберите действие:\";',3,2,'','',1,'',0),(4,'назад','','return \"Выберите действие:\";',3,2,'','',1,'',0),(5,'как пройти','','',3,1,'','',1,'',0);
/*!40000 ALTER TABLE `tlg_cmd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tlg_event`
--

DROP TABLE IF EXISTS `tlg_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tlg_event` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `DESCRIPTION` text,
  `TYPE_EVENT` int(3) unsigned NOT NULL DEFAULT '1',
  `ENABLE` int(3) unsigned NOT NULL DEFAULT '0',
  `CODE` text,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tlg_event`
--

LOCK TABLES `tlg_event` WRITE;
/*!40000 ALTER TABLE `tlg_event` DISABLE KEYS */;
INSERT INTO `tlg_event` VALUES (1,'messageHook','',1,1,'$off = hex2bin(\'F09F8C91\');\r\n$off1 = hex2bin(\'F09F94B4\');\r\n$on  = hex2bin(\'F09F8C95\');\r\n$on1  = hex2bin(\'F09F94B5\');\r\n$cam = hex2bin(\'F09F8EA5\');	\r\n$pog = hex2bin(\'E29B85\');\r\n$sta = hex2bin(\'F09F92AC\');\r\n$p1 =  hex2bin(\'F09F9188\');\r\n$p2 =  hex2bin(\'F09F9189\');\r\n$p3 =  hex2bin(\'F09F9187\');\r\n$p4 =  hex2bin(\'F09F9186\');\r\n$p5 =  hex2bin(\'F09F918D\');\r\n\r\n$st1 = $off;\r\n$st2 = $off;\r\nif(gg(\"securityMode\")){$st1=$on;}\r\nif(gg(\"Econom\")){$st2=$on;}\r\n//основное меню\r\n$option1 = array(array($cam.\"Камеры\", $pog.\"Погода\", $sta.\"Статус\"),array($st1.\"Охрана\", $st2.\"Эконом\",\"Освещение\"),array(\"Назад\"));\r\n//меню камер\r\n$option2 = array(array($cam.\"Токио\", $cam.\"NASA1\", $cam.\"NASA2\", $cam.\"Птички\"),array($cam.\"Питер1\", $cam.\"Питер2\", $cam.\"Акв1\", $cam.\"Акв2\"),array(\"меню\"));\r\n//меню освещение\r\n$option3 = array(array($cam.\"комната1\", $cam.\"комната2\", $cam.\"комната3\", $cam.\"комната4\"),array($cam.\"комната5\", $cam.\"комната6\", $cam.\"комната7\", $cam.\"комната8\"),array(\"меню\"));\r\n\r\n\r\n//режим экономии\r\n$pos = strripos($text , \"Эконом\");\r\nif ($pos > -1) {\r\n 	if (gg(\"Econom\")){\r\n 	sg(\"Econom\",0);\r\n    $status=\"отключен\";\r\n    $st2=$off;\r\n	}else{\r\n 	sg(\"Econom\",1);\r\n    $status=\"включен\";\r\n    $st2=$on;\r\n	}\r\n 	$option1 = array(array($cam.\"Камеры\", $pog.\"Погода\", $sta.\"Статус\"),array($st1.\"Охрана\", $st2.\"Эконом\",\"Освещение\"),array(\"Назад\"));\r\n 	$this->sendMessageToUser($chat_id,\"Режим экономии \".$status,$option1);\r\n   	$skip = true;\r\n}\r\n//режим охраны\r\n$pos = strripos($text , \"Охрана\");\r\nif ($pos > -1) {\r\n 	if (gg(\"securityMode\")){\r\n 	sg(\"securityMode\",0);\r\n    $status=\"выключена\";\r\n    $st1=$off;\r\n	}else{\r\n 	sg(\"securityMode\",1);\r\n    $status=\"включена\";\r\n    $st1=$on;\r\n	}\r\n 	$option1 = array(array($cam.\"Камеры\", $pog.\"Погода\", $sta.\"Статус\"),array($st1.\"Охрана\", $st2.\"Эконом\",\"Освещение\"),array(\"Назад\"));\r\n 	$this->sendMessageToUser($chat_id,\"Охрана \".$status,$option1);\r\n   	$skip = true;\r\n}\r\n\r\n\r\n//вызов меню камер\r\n$pos = strripos($text , \"Камеры\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите камеру:\",$option2);\r\n   	$skip = true;\r\n}\r\n//вызов меню света\r\n$pos = strripos($text , \"Освещение\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите свет:\",$option3);\r\n   	$skip = true;\r\n}\r\n\r\n\r\n//отправка изображения с камер\r\n\r\n$pos = strripos($text , \"Токио\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/JYBpu1OyP0c\";\r\n$par2 = \"1\";\r\n$par3 = \"96\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"NASA1\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/RtU_mdL2vBM\";\r\n$par2 = \"2\";\r\n$par3 = \"301\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"NASA2\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/ddFvjfvPnqk\";\r\n$par2 = \"3\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Птички\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/jECodSsU8Ds\";\r\n$par2 = \"4\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Питер1\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/OCfjCg4LeDA\";\r\n$par2 = \"5\";\r\n$par3 = \"94\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Питер2\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/oioklYcidp0\";\r\n$par2 = \"6\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Акв1\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/FEiOjdr9Nz4\";\r\n$par2 = \"7\";\r\n$par3 = \"95\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n$pos = strripos($text , \"Акв2\");\r\nif ($pos > -1) {\r\n$par1 = \"https://youtu.be/jKtjpJBM2x8\";\r\n$par2 = \"8\";\r\n$par3 = \"96\";\r\n runScript(\"cam\",array(\"url\"=>$par1,\"coun\"=>$par2,\"vid\"=>$par3));\r\n $jpg=\"/var/www/cam/$par2.jpg\";\r\n $this->sendImageToUser($chat_id,$jpg,\"Камера\".$par2,$option2);\r\n   $skip = true;\r\n}\r\n\r\n\r\n$pos = strripos($text , \"Камера\");\r\nif ($pos > -1) {\r\n 	$channel=substr($text, -1);\r\n	$url=\"rtsp://192.168.1.10:554/user=immortal&password=123525654&channel=\".$channel.\"&stream=0.sdp?\";  \r\n	$jpg=\"/var/www/cached/snapshot.jpg\";\r\n	exec(\'ffmpeg -y -i \"\'.$url.\'\" -f image2 -vframes 1 \'.$jpg);\r\n	$this->sendImageToUser($chat_id,$jpg,\"Камера \".$channel,$option2);\r\n   $skip = true;\r\n}\r\n//показать погоду\r\n$pos = strripos($text , \"Погода\");\r\nif ($pos > -1) {\r\n	$weather=     \"Сейчас\".hex2bin(\'F09F8CA1\').gg(\'ow_fact.temperature\').\"°C,\".gg(\'ow_fact.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_fact.wind_direction_my\').\" \".gg(\'ow_fact.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_fact.humidity\').\"%, \".hex2bin(\'F09F92AA\').round(gg(\'ow_fact.pressure_mmhg\'),0);\r\n	$weather.=\"\\r\\nЗавтра\".hex2bin(\'F09F8CA1\').gg(\'ow_day1.temperature\').\"°C,\".gg(\'ow_day1.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_day1.wind_direction_my\').\" \".gg(\'ow_day1.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_day1.humidity\').\"%, \".hex2bin(\'F09F92AA\').gg(\'ow_day1.pressure_mmhg\');\r\n	$weather.=\"\\r\\n\".substr(gg(\'ow_day2.date\'),0,6).hex2bin(\'F09F8CA1\').gg(\'ow_day2.temperature\').\"°C,\".gg(\'ow_day2.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_day2.wind_direction_my\').\" \".gg(\'ow_day2.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_day2.humidity\').\"%, \".hex2bin(\'F09F92AA\').round(gg(\'ow_day2.pressure_mmhg\'),0);\r\n	$weather.=\"\\r\\n\".substr(gg(\'ow_day3.date\'),0,6).hex2bin(\'F09F8CA1\').gg(\'ow_day3.temperature\').\"°C,\".gg(\'ow_day3.weather_type\').\",\".hex2bin(\'F09F92A8\').gg(\'ow_day3.wind_direction_my\').\" \".gg(\'ow_day3.wind_speed\').\"км/ч, \".hex2bin(\'F09F92A7\').gg(\'ow_day3.humidity\').\"%, \".hex2bin(\'F09F92AA\').round(gg(\'ow_day3.pressure_mmhg\'),0);\r\n	$this->sendMessageToUser($chat_id, $weather, $option1);\r\n	$skip = true;\r\n}\r\n//показать статус\r\n$pos = strripos($text , \"Статус\");\r\nif ($pos > -1) {\r\n if(gg(\'clapan1.status\')){$sttc1=$on1;}else{$sttc1=$off1;};\r\n if(gg(\'clapan2.status\')){$sttc2=$on1;}else{$sttc2=$off1;};\r\n if(gg(\'clapan3.status\')){$sttc3=$on1;}else{$sttc3=$off1;};\r\n if(gg(\'clapan4.status\')){$sttc4=$on1;}else{$sttc4=$off1;};\r\n if(gg(\'clapan5.status\')){$sttc5=$on1;}else{$sttc5=$off1;};\r\n if(gg(\'clapan6.status\')){$sttc6=$on1;}else{$sttc6=$off1;};\r\n if(gg(\'clapan7.status\')){$sttc7=$on1;}else{$sttc7=$off1;};\r\n if(gg(\'clapan8.status\')){$sttc8=$on1;}else{$sttc8=$off1;};\r\n if(gg(\'clapan10.status\')){$sttc10=$on1;}else{$sttc10=$off1;}; \r\n	$weather=     $sttc1.\"Комната1:\".hex2bin(\'F09F8CA1\').gg(\'tempD1.temp\').\"°C,\";\r\n	$weather.=\"\\r\\n\".$sttc2.\"Комната2:\".hex2bin(\'F09F8CA1\').gg(\'tempD2.temp\').\"°C,\";\r\n	$weather.=\"\\r\\n\".$sttc3.\"Комната3:\".hex2bin(\'F09F8CA1\').gg(\'tempD3.temp\').\"°C,\";\r\n	$weather.=   \"\\r\\n\".$sttc4.\"Комната4:\".hex2bin(\'F09F8CA1\').gg(\'tempD4.temp\').\"°C,\";\r\n	$weather.= \"\\r\\n\".$sttc5.\"Комната5:\".hex2bin(\'F09F8CA1\').gg(\'tempD5.temp\').\"°C,\";\r\n	$weather.=    \"\\r\\n\".$sttc6.\"Комната6:\".hex2bin(\'F09F8CA1\').gg(\'tempD6.temp\').\"°C,\";\r\n	$weather.=\"\\r\\n\".$sttc7.\"Комната7:\".hex2bin(\'F09F8CA1\').gg(\'tempD7.temp\').\"°C,\";\r\n 	$weather.=\"\\r\\n\".$sttc8.\"Комната8:\".hex2bin(\'F09F8CA1\').gg(\'tempD8.temp\').\"°C,\";\r\n 	$weather.=  \"\\r\\n\".$sttc10.\"Комната9:\".hex2bin(\'F09F8CA1\').gg(\'tempD10.temp\').\"°C,\";\r\n\r\n	$this->sendMessageToUser($chat_id, $weather, $option1);\r\n	$skip = true;\r\n}\r\necho $text;\r\n$pos = strripos($text , \"как пройти\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,$p1.\" \".$p2.\" \".$p2.\" \".$p1.\" \".$p2.\" \".$p1.\" \".$p4.\" \".$p5);\r\n 	$skip = true;\r\n}\r\n\r\n//показать меню\r\necho $text;\r\n$pos = strripos($text , \"Меню\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите действие:\",$option1);\r\n 	$skip = true;\r\n}\r\necho $text;\r\n$pos = strripos($text , \"меню\");\r\nif ($pos > -1) {\r\n 	$this->sendMessageToUser($chat_id,\"Выберите действие:\",$option1);\r\n 	$skip = true;\r\n}\r\n');
/*!40000 ALTER TABLE `tlg_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tlg_user`
--

DROP TABLE IF EXISTS `tlg_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tlg_user` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `NAME` varchar(255) NOT NULL DEFAULT '',
  `USER_ID` varchar(25) NOT NULL DEFAULT '0',
  `MEMBER_ID` int(10) NOT NULL DEFAULT '1',
  `CREATED` datetime DEFAULT NULL,
  `ADMIN` int(3) unsigned NOT NULL DEFAULT '0',
  `HISTORY` int(3) unsigned NOT NULL DEFAULT '0',
  `HISTORY_LEVEL` int(3) unsigned NOT NULL DEFAULT '0',
  `CMD` int(3) unsigned NOT NULL DEFAULT '0',
  `PATTERNS` int(3) unsigned NOT NULL DEFAULT '0',
  `DOWNLOAD` int(3) unsigned NOT NULL DEFAULT '0',
  `PLAY` int(3) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tlg_user`
--

LOCK TABLES `tlg_user` WRITE;
/*!40000 ALTER TABLE `tlg_user` DISABLE KEYS */;
INSERT INTO `tlg_user` VALUES (4,'Сергей Кушеев','202343323',1,'2018-09-25 10:45:41',1,1,0,1,1,1,1);
/*!40000 ALTER TABLE `tlg_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tlg_user_cmd`
--

DROP TABLE IF EXISTS `tlg_user_cmd`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tlg_user_cmd` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `USER_ID` int(10) NOT NULL,
  `CMD_ID` int(10) NOT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tlg_user_cmd`
--

LOCK TABLES `tlg_user_cmd` WRITE;
/*!40000 ALTER TABLE `tlg_user_cmd` DISABLE KEYS */;
INSERT INTO `tlg_user_cmd` VALUES (1,0,1),(7,0,2),(8,0,3),(6,0,4),(9,0,5);
/*!40000 ALTER TABLE `tlg_user_cmd` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `usbdevices`
--

DROP TABLE IF EXISTS `usbdevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `usbdevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `SERIAL` varchar(255) NOT NULL DEFAULT '',
  `LOG` text NOT NULL,
  `LAST_FOUND` datetime DEFAULT NULL,
  `FIRST_FOUND` datetime DEFAULT NULL,
  `USER_ID` int(10) NOT NULL DEFAULT '0',
  `SCRIPT` text NOT NULL,
  `SCRIPT_ID` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=67 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `usbdevices`
--

LOCK TABLES `usbdevices` WRITE;
/*!40000 ALTER TABLE `usbdevices` DISABLE KEYS */;
/*!40000 ALTER TABLE `usbdevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `userlog`
--

DROP TABLE IF EXISTS `userlog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `userlog` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `USER_ID` int(10) NOT NULL DEFAULT '0',
  `MESSAGE` varchar(100) NOT NULL DEFAULT '',
  `IP` varchar(20) NOT NULL DEFAULT '',
  `ADDED` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `userlog`
--

LOCK TABLES `userlog` WRITE;
/*!40000 ALTER TABLE `userlog` DISABLE KEYS */;
/*!40000 ALTER TABLE `userlog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `USERNAME` varchar(255) NOT NULL DEFAULT '',
  `NAME` varchar(255) NOT NULL DEFAULT '',
  `EMAIL` varchar(255) NOT NULL DEFAULT '',
  `SKYPE` varchar(255) NOT NULL DEFAULT '',
  `MOBILE` varchar(255) NOT NULL DEFAULT '',
  `AVATAR` varchar(255) NOT NULL DEFAULT '',
  `PASSWORD` varchar(255) NOT NULL DEFAULT '',
  `IS_ADMIN` tinyint(3) NOT NULL DEFAULT '0',
  `IS_DEFAULT` tinyint(3) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `HOST` varchar(255) NOT NULL DEFAULT '',
  `ACTIVE_CONTEXT_ID` int(10) NOT NULL DEFAULT '0',
  `ACTIVE_CONTEXT_EXTERNAL` int(3) NOT NULL DEFAULT '0',
  `ACTIVE_CONTEXT_UPDATED` datetime DEFAULT NULL,
  `ACTIVE_CONTEXT_HISTORY` text,
  `COLOR` char(20) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (1,'admin','Admin','admin@smartliving.com','','','','',1,1,'admin','',0,0,'2019-12-17 11:15:41','','');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `webvars`
--

DROP TABLE IF EXISTS `webvars`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webvars` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(255) NOT NULL DEFAULT '',
  `HOSTNAME` varchar(255) NOT NULL DEFAULT '',
  `TYPE` int(30) NOT NULL DEFAULT '0',
  `SEARCH_PATTERN` varchar(255) NOT NULL DEFAULT '',
  `CHECK_PATTERN` varchar(255) NOT NULL DEFAULT '',
  `LATEST_VALUE` text NOT NULL,
  `CHECK_LATEST` datetime DEFAULT NULL,
  `CHECK_NEXT` datetime DEFAULT NULL,
  `SCRIPT_ID` int(10) NOT NULL DEFAULT '0',
  `ONLINE_INTERVAL` int(10) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(255) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(255) NOT NULL DEFAULT '',
  `CODE` text,
  `LOG` text,
  `ENCODING` varchar(50) NOT NULL DEFAULT '',
  `AUTH` int(3) NOT NULL DEFAULT '0',
  `USERNAME` varchar(100) NOT NULL DEFAULT '',
  `PASSWORD` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=13 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `webvars`
--

LOCK TABLES `webvars` WRITE;
/*!40000 ALTER TABLE `webvars` DISABLE KEYS */;
/*!40000 ALTER TABLE `webvars` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `xicommands`
--

DROP TABLE IF EXISTS `xicommands`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `xicommands` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `VALUE` varchar(255) NOT NULL DEFAULT '',
  `DEVICE_ID` int(10) NOT NULL DEFAULT '0',
  `LINKED_OBJECT` varchar(100) NOT NULL DEFAULT '',
  `LINKED_PROPERTY` varchar(100) NOT NULL DEFAULT '',
  `LINKED_METHOD` varchar(100) NOT NULL DEFAULT '',
  `UPDATED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=38 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `xicommands`
--

LOCK TABLES `xicommands` WRITE;
/*!40000 ALTER TABLE `xicommands` DISABLE KEYS */;
/*!40000 ALTER TABLE `xicommands` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `xidevices`
--

DROP TABLE IF EXISTS `xidevices`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `xidevices` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `TITLE` varchar(100) NOT NULL DEFAULT '',
  `TYPE` varchar(100) NOT NULL DEFAULT '',
  `SID` varchar(255) NOT NULL DEFAULT '',
  `GATE_KEY` varchar(255) NOT NULL DEFAULT '',
  `GATE_IP` varchar(255) NOT NULL DEFAULT '',
  `TOKEN` varchar(255) NOT NULL DEFAULT '',
  `PARENT_ID` int(10) unsigned NOT NULL DEFAULT '0',
  `UPDATED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `xidevices`
--

LOCK TABLES `xidevices` WRITE;
/*!40000 ALTER TABLE `xidevices` DISABLE KEYS */;
/*!40000 ALTER TABLE `xidevices` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `xiqueue`
--

DROP TABLE IF EXISTS `xiqueue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `xiqueue` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `IP` varchar(100) NOT NULL DEFAULT '',
  `DATA` text,
  `ADDED` datetime DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM AUTO_INCREMENT=40 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `xiqueue`
--

LOCK TABLES `xiqueue` WRITE;
/*!40000 ALTER TABLE `xiqueue` DISABLE KEYS */;
/*!40000 ALTER TABLE `xiqueue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `yandex_tts_emphasis`
--

DROP TABLE IF EXISTS `yandex_tts_emphasis`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `yandex_tts_emphasis` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `search_str` text,
  `replace_str` text,
  `case` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `yandex_tts_emphasis`
--

LOCK TABLES `yandex_tts_emphasis` WRITE;
/*!40000 ALTER TABLE `yandex_tts_emphasis` DISABLE KEYS */;
/*!40000 ALTER TABLE `yandex_tts_emphasis` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `yaweather_cities`
--

DROP TABLE IF EXISTS `yaweather_cities`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `yaweather_cities` (
  `country` varchar(100) DEFAULT NULL,
  `cityname` varchar(30) DEFAULT NULL,
  `part` varchar(100) DEFAULT NULL,
  `ID` int(30) unsigned NOT NULL,
  `check` int(30) DEFAULT NULL,
  `head` varchar(100) DEFAULT NULL,
  `type` varchar(100) DEFAULT NULL,
  `region` varchar(100) DEFAULT NULL,
  `mycity` int(30) DEFAULT NULL,
  `latlon` varchar(50) DEFAULT NULL,
  `url` varchar(300) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `yaweather_cities`
--

LOCK TABLES `yaweather_cities` WRITE;
/*!40000 ALTER TABLE `yaweather_cities` DISABLE KEYS */;
INSERT INTO `yaweather_cities` VALUES ('Россия','Москва','Московская область',213,0,'0',NULL,NULL,0,NULL,NULL),(' Россия','Вологда',' Вологодская область',21,1,NULL,NULL,NULL,1,'',NULL);
/*!40000 ALTER TABLE `yaweather_cities` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `yaweather_cities_temp`
--

DROP TABLE IF EXISTS `yaweather_cities_temp`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `yaweather_cities_temp` (
  `country` varchar(100) DEFAULT NULL,
  `cityname` varchar(30) DEFAULT NULL,
  `part` varchar(100) DEFAULT NULL,
  `ID` int(30) unsigned NOT NULL,
  `check` int(30) DEFAULT NULL,
  `head` varchar(100) DEFAULT NULL,
  `type` varchar(100) DEFAULT NULL,
  `region` varchar(100) DEFAULT NULL,
  `mycity` int(30) DEFAULT NULL,
  `url` varchar(100) DEFAULT NULL,
  `latlon` varchar(100) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `yaweather_cities_temp`
--

LOCK TABLES `yaweather_cities_temp` WRITE;
/*!40000 ALTER TABLE `yaweather_cities_temp` DISABLE KEYS */;
INSERT INTO `yaweather_cities_temp` VALUES (' Россия','Вологда',' Вологодская область',21,0,' Вологодская область','',' Вологодская область',0,'//yandex.ru/pogoda?name=Россия, Вологодская область, Вологда&kind=weather','lat=59.22049713&lon=39.89152145'),(' Россия','городок Вологда-20',' Вологодская область',99126,0,' Шекснинский район','',' Вологодская область',0,'//yandex.ru/pogoda?name=Россия, Вологодская область, Шекснинский район, городок Вологда-20&kind=dist','lat=59.15644836&lon=38.72131348'),('','Вологда',' Россия',21,0,' Россия','',' Россия',0,'//yandex.ru/pogoda?name=Россия, Вологда&kind=locality','lat=59.22050095&lon=39.89152527'),(' Россия','аэропорт Вологда',' Вологодская область',163806,0,' Вологодский район','',' Вологодская область',0,'//yandex.ru/pogoda?name=Россия, Вологодская область, Вологодский район, аэропорт Вологда&kind=airpor','lat=59.28414536&lon=39.93602753'),('','','',0,0,'','','',0,'','');
/*!40000 ALTER TABLE `yaweather_cities_temp` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `yaweather_config`
--

DROP TABLE IF EXISTS `yaweather_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `yaweather_config` (
  `parametr` varchar(300) DEFAULT NULL,
  `value` varchar(100) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `yaweather_config`
--

LOCK TABLES `yaweather_config` WRITE;
/*!40000 ALTER TABLE `yaweather_config` DISABLE KEYS */;
INSERT INTO `yaweather_config` VALUES ('EVERY','30'),('ENABLE_EVENTS','0'),('DUUID',''),('DEVICEID',''),('LASTCYCLE_TS','1580230174'),('LASTCYCLE_TXT','2020-01-28 19:49:34'),('FORECAST_DAY','3'),('MSG_LEVEL','2'),('LASTCONDITION','overcast');
/*!40000 ALTER TABLE `yaweather_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `yaweather_hf`
--

DROP TABLE IF EXISTS `yaweather_hf`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `yaweather_hf` (
  `ID` int(30) unsigned NOT NULL AUTO_INCREMENT,
  `CID` int(30) DEFAULT NULL,
  `day` int(30) DEFAULT NULL,
  `hour` int(30) DEFAULT NULL,
  `hour_ts` varchar(20) DEFAULT NULL,
  `temp` varchar(20) DEFAULT NULL,
  `feels_like` varchar(30) DEFAULT NULL,
  `icon` varchar(30) DEFAULT NULL,
  `condition` varchar(80) DEFAULT NULL,
  `wind_speed` varchar(20) DEFAULT NULL,
  `wind_gust` varchar(20) DEFAULT NULL,
  `rise_begin` varchar(20) DEFAULT NULL,
  `wind_dir` varchar(20) DEFAULT NULL,
  `pressure_mm` varchar(20) DEFAULT NULL,
  `pressure_pa` varchar(20) DEFAULT NULL,
  `humidity` varchar(20) DEFAULT NULL,
  `soil_temp` varchar(20) DEFAULT NULL,
  `soil_moisture` varchar(20) DEFAULT NULL,
  `prec_mm` varchar(20) DEFAULT NULL,
  `prec_period` varchar(20) DEFAULT NULL,
  `prec_prob` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=179 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `yaweather_hf`
--

LOCK TABLES `yaweather_hf` WRITE;
/*!40000 ALTER TABLE `yaweather_hf` DISABLE KEYS */;
INSERT INTO `yaweather_hf` VALUES (1,213,0,0,'1580072400','1','-5','ovc_-ra','overcast-and-light-rain','6.1','14.2',NULL,'w','740','987','90','0','0.36','0.1','60','70'),(2,213,0,1,'1580076000','2','-5','ovc_-ra','overcast-and-light-rain','6.9','14.2',NULL,'w','740','987','91','0','0.36','0.1','60','70'),(3,213,0,2,'1580079600','2','-5','ovc_-ra','overcast-and-light-rain','6.9','14.2',NULL,'w','740','987','92','0','0.36','0.1','60','70'),(4,213,0,3,'1580083200','2','-4','ovc_-ra','overcast-and-light-rain','6.3','14.3',NULL,'w','741','988','90','0','0.36','0.1','60','60'),(5,213,0,4,'1580086800','2','-5','ovc_-ra','overcast-and-light-rain','7','14.3',NULL,'w','741','988','92','0','0.36','0.1','60','60'),(6,213,0,5,'1580090400','2','-5','ovc_-ra','overcast-and-light-rain','7','14.3',NULL,'w','741','988','92','0','0.36','0.1','60','60'),(7,213,0,6,'1580094000','1','-4','ovc','overcast','3.6','8.8',NULL,'nw','743','991','91','1','0.37','0','60','0'),(8,213,0,7,'1580097600','1','-4','ovc','overcast','4.2','8.8',NULL,'nw','742','990','92','1','0.37','0','60','0'),(9,213,0,8,'1580101200','0','-5','ovc','overcast','4.2','8.8',NULL,'nw','742','990','92','1','0.37','0','60','0'),(10,213,0,9,'1580104800','0','-4','ovc','overcast','2.2','5.7',NULL,'n','745','994','89','0','0.37','0','60','0'),(11,213,0,10,'1580108400','0','-4','ovc','overcast','2.9','6.3',NULL,'nw','744','992','88','0','0.37','0','60','0'),(12,213,0,11,'1580112000','0','-4','ovc','overcast','3','6.3',NULL,'nw','744','992','85','0','0.37','0','60','0'),(13,213,0,12,'1580115600','-1','-5','ovc','overcast','2.3','7.1',NULL,'n','747','996','83','0','0.37','0','60','0'),(14,213,0,13,'1580119200','-1','-5','ovc','overcast','2.7','7.1',NULL,'n','746','995','80','0','0.37','0','60','0'),(15,213,0,14,'1580122800','-1','-5','ovc','overcast','2.6','7.1',NULL,'n','746','995','79','0','0.37','0','60','0'),(16,213,0,15,'1580126400','-1','-5','ovc','overcast','1.7','4.9',NULL,'ne','747','996','75','0','0.37','0','60','0'),(17,213,0,16,'1580130000','-1','-5','ovc','overcast','2','4.9',NULL,'ne','747','996','77','0','0.37','0','60','0'),(18,213,0,17,'1580133600','-1','-5','ovc','overcast','2','4.9',NULL,'ne','747','996','80','0','0.37','0','60','0'),(19,213,0,18,'1580137200','-2','-6','ovc','overcast','2','5.1',NULL,'e','748','998','83','0','0.37','0','60','0'),(20,213,0,19,'1580140800','-2','-6','ovc','overcast','2.3','5.1',NULL,'e','748','998','84','0','0.37','0','60','0'),(21,213,0,20,'1580144400','-2','-6','ovc','overcast','2.3','5.1',NULL,'e','748','998','83','0','0.37','0','60','0'),(22,213,0,21,'1580148000','-3','-8','ovc_-sn','overcast-and-light-snow','2.8','6.9',NULL,'e','749','999','81','0','0.36','0.1','60','70'),(23,213,0,22,'1580151600','-3','-8','ovc_-sn','overcast-and-light-snow','3.1','6.9',NULL,'e','748','998','83','0','0.36','0.1','60','70'),(24,213,0,23,'1580155200','-3','-8','ovc_-sn','overcast-and-light-snow','3.1','6.9',NULL,'e','748','998','84','0','0.36','0.1','60','70'),(25,213,1,0,'1580158800','-4','-9','ovc_sn','cloudy-and-snow','3.5','8.5',NULL,'e','749','999','84','0','0.36','0.2','60','80'),(26,213,1,1,'1580162400','-4','-9','ovc_sn','cloudy-and-snow','3.9','8.5',NULL,'e','748','998','86','0','0.36','0.2','60','80'),(27,213,1,2,'1580166000','-4','-9','ovc_sn','cloudy-and-snow','3.9','8.5',NULL,'e','748','998','87','0','0.36','0.2','60','80'),(28,213,1,3,'1580169600','-5','-11','ovc_sn','cloudy-and-snow','4','9.4',NULL,'e','748','998','87','0','0.36','0.4','60','100'),(29,213,1,4,'1580173200','-5','-11','ovc_sn','cloudy-and-snow','4.4','9.4',NULL,'e','747','996','89','0','0.36','0.4','60','100'),(30,213,1,5,'1580176800','-5','-11','ovc_sn','cloudy-and-snow','4.4','9.4',NULL,'e','747','996','89','0','0.36','0.4','60','100'),(31,213,1,6,'1580180400','-5','-11','ovc_sn','cloudy-and-snow','4.3','9.7',NULL,'e','747','996','88','-1','0.36','0.3','60','100'),(32,213,1,7,'1580184000','-5','-11','ovc_sn','cloudy-and-snow','4.7','9.7',NULL,'se','746','995','90','-1','0.36','0.3','60','100'),(33,213,1,8,'1580187600','-5','-11','ovc_sn','cloudy-and-snow','4.7','9.7',NULL,'se','746','995','90','-1','0.36','0.3','60','100'),(34,213,1,9,'1580191200','-6','-12','ovc_-sn','overcast-and-light-snow','4.1','9.7',NULL,'e','746','995','90','-1','0.36','0.1','60','90'),(35,213,1,10,'1580194800','-5','-11','ovc_-sn','overcast-and-light-snow','4.7','9.7',NULL,'se','746','995','91','-1','0.36','0.1','60','90'),(36,213,1,11,'1580198400','-5','-11','ovc_-sn','overcast-and-light-snow','4.8','9.7',NULL,'se','746','995','90','-1','0.36','0.1','60','90'),(37,213,1,12,'1580202000','-5','-11','ovc_sn','cloudy-and-snow','4.1','9.7',NULL,'se','746','995','90','-1','0.36','0.2','60','100'),(38,213,1,13,'1580205600','-4','-10','ovc_sn','cloudy-and-snow','4.6','9.7',NULL,'se','746','995','91','-1','0.36','0.2','60','100'),(39,213,1,14,'1580209200','-4','-10','ovc_sn','cloudy-and-snow','4.6','9.7',NULL,'se','746','995','91','-1','0.36','0.2','60','100'),(40,213,1,15,'1580212800','-4','-9','ovc_sn','cloudy-and-snow','3.1','7.9',NULL,'e','745','994','91','-1','0.36','0.2','60','100'),(41,213,1,16,'1580216400','-3','-8','ovc_sn','cloudy-and-snow','3.4','7.9',NULL,'se','744','992','93','-1','0.36','0.2','60','100'),(42,213,1,17,'1580220000','-3','-8','ovc_sn','cloudy-and-snow','3.4','7.9',NULL,'se','744','992','93','-1','0.36','0.2','60','100'),(43,213,1,18,'1580223600','-3','-8','ovc_-sn','overcast-and-light-snow','2.9','7.3',NULL,'e','745','994','93','-1','0.36','0.1','60','90'),(44,213,1,19,'1580227200','-3','-8','ovc_-sn','overcast-and-light-snow','3.3','7.3',NULL,'se','744','992','94','-1','0.36','0.1','60','90'),(45,213,1,20,'1580230800','-3','-8','ovc_-sn','overcast-and-light-snow','3.2','7.3',NULL,'se','744','992','94','-1','0.36','0.1','60','90'),(46,213,1,21,'1580234400','-3','-7','ovc_-sn','overcast-and-light-snow','1.9','5.2',NULL,'se','744','992','93','-1','0.36','0.1','60','80'),(47,213,1,22,'1580238000','-2','-6','ovc_-sn','overcast-and-light-snow','2.1','5.2',NULL,'se','744','992','94','-1','0.36','0.1','60','80'),(48,213,1,23,'1580241600','-2','-6','ovc_-sn','overcast-and-light-snow','2.1','5.2',NULL,'se','744','992','94','-1','0.36','0.1','60','80'),(49,213,2,0,'1580245200','-2','-5','ovc_-sn','overcast-and-light-snow','1.6','4.1',NULL,'se','744','992','95','-1','0.35','0.1','60','80'),(50,213,2,1,'1580248800','-2','-6','ovc_-sn','overcast-and-light-snow','1.7','4.1',NULL,'se','744','992','96','-1','0.35','0.1','60','80'),(51,213,2,2,'1580252400','-1','-4','ovc_-sn','overcast-and-light-snow','1.7','4.1',NULL,'se','744','992','96','-1','0.35','0.1','60','80'),(52,213,2,3,'1580256000','0','-3','ovc_-sn','overcast-and-light-snow','1.3','3.5',NULL,'se','744','992','96','-1','0.35','0.1','60','60'),(53,213,2,4,'1580259600','0','-3','ovc_-sn','overcast-and-light-snow','1.6','3.5',NULL,'se','743','991','97','-1','0.35','0.1','60','60'),(54,213,2,5,'1580263200','0','-3','ovc_-sn','overcast-and-light-snow','1.6','3.5',NULL,'se','743','991','97','-1','0.35','0.1','60','60'),(55,213,2,6,'1580266800','1','-2','ovc','overcast','1.6','4',NULL,'s','743','991','95','-1','0.35','0','60','0'),(56,213,2,7,'1580270400','1','-2','ovc','overcast','2','4',NULL,'s','743','991','96','-1','0.35','0','60','0'),(57,213,2,8,'1580274000','1','-2','ovc','overcast','2','4',NULL,'s','743','991','97','-1','0.35','0','60','0'),(58,213,2,9,'1580277600','0','-3','ovc','overcast','1.6','3.5',NULL,'se','743','991','96','-1','0.35','0','60','0'),(59,213,2,10,'1580281200','0','-3','ovc','overcast','2','3.5',NULL,'s','743','991','96','-1','0.35','0','60','0'),(60,213,2,11,'1580284800','0','-4','ovc','overcast','2.1','3.5',NULL,'s','743','991','94','-1','0.35','0','60','0'),(61,213,2,12,'1580288400','1','-2','ovc','overcast','2','5',NULL,'s','743','991','91','-1','0.35','0','60','0'),(62,213,2,13,'1580292000','1','-3','ovc','overcast','2.6','5',NULL,'s','743','991','91','-1','0.35','0','60','0'),(63,213,2,14,'1580295600','1','-3','ovc','overcast','2.5','5',NULL,'s','743','991','91','-1','0.35','0','60','0'),(64,213,2,15,'1580299200','0','-4','ovc','overcast','2','4.3',NULL,'se','742','990','90','0','0.35','0','60','0'),(65,213,2,16,'1580302800','1','-3','ovc','overcast','2.3','4.3',NULL,'se','741','988','93','0','0.35','0','60','0'),(66,213,2,17,'1580306400','1','-3','ovc','overcast','2.2','4.3',NULL,'se','741','988','94','0','0.35','0','60','0'),(67,213,2,18,'1580310000','1','-3','ovc','overcast','2.6','6.8',NULL,'se','742','990','94','0','0.35','0','60','0'),(68,213,2,19,'1580313600','1','-3','ovc','overcast','3.1','6.8',NULL,'se','741','988','95','0','0.35','0','60','0'),(69,213,2,20,'1580317200','1','-3','ovc','overcast','3.1','6.8',NULL,'se','741','988','96','0','0.35','0','60','0'),(70,213,2,21,'1580320800','0','-4','ovc_-sn','overcast-and-light-snow','3','7.2',NULL,'se','740','987','95','0','0.35','0.1','60','70'),(71,213,2,22,'1580324400','0','-4','ovc_-sn','overcast-and-light-snow','3.4','7.2',NULL,'se','740','987','96','0','0.35','0.1','60','70'),(72,213,2,23,'1580328000','0','-4','ovc_-sn','overcast-and-light-snow','3.4','7.2',NULL,'se','740','987','96','0','0.35','0.1','60','70'),(73,213,3,0,'1580331600','0','-4','ovc_-sn','overcast-and-light-snow','3.3','7.9',NULL,'e','739','986','96','0','0.35','0.1','60','80'),(74,213,3,1,'1580335200','0','-5','ovc_-sn','overcast-and-light-snow','3.7','7.9',NULL,'e','739','986','96','0','0.35','0.1','60','80'),(75,213,3,2,'1580338800','0','-5','ovc_-sn','overcast-and-light-snow','3.7','7.9',NULL,'e','739','986','96','0','0.35','0.1','60','80'),(76,213,3,3,'1580342400','0','-5','ovc_-sn','overcast-and-light-snow','3.6','8.7',NULL,'e','738','984','95','0','0.35','0.1','60','70'),(77,213,3,4,'1580346000','0','-5','ovc_-sn','overcast-and-light-snow','4','8.7',NULL,'e','738','984','96','0','0.35','0.1','60','70'),(78,213,3,5,'1580349600','0','-5','ovc_-sn','overcast-and-light-snow','4','8.7',NULL,'e','738','984','96','0','0.35','0.1','60','70'),(79,213,3,6,'1580353200','0','-5','ovc_sn','cloudy-and-snow','4.2','10',NULL,'e','738','984','95','0','0.35','0.4','60','80'),(80,213,3,7,'1580356800','0','-5','ovc_sn','cloudy-and-snow','4.6','10',NULL,'e','737','983','96','0','0.35','0.4','60','80'),(81,213,3,8,'1580360400','0','-5','ovc_sn','cloudy-and-snow','4.6','10',NULL,'e','737','983','96','0','0.35','0.4','60','90'),(82,213,3,9,'1580364000','-1','-6','ovc_+sn','overcast-and-snow','4.4','11',NULL,'e','737','983','95','0','0.35','0.5','60','80'),(83,213,3,10,'1580367600','-1','-7','ovc_+sn','overcast-and-snow','4.9','11',NULL,'e','737','983','95','0','0.35','0.5','60','80'),(84,213,3,11,'1580371200','-1','-7','ovc_+sn','overcast-and-snow','4.9','11',NULL,'e','737','983','94','0','0.35','0.5','60','80'),(85,213,3,12,'1580374800','-1','-6','ovc_-sn','overcast-and-light-snow','3.5','9.3',NULL,'e','737','983','94','0','0.35','0.1','60','70'),(86,213,3,13,'1580378400','0','-5','ovc_-sn','overcast-and-light-snow','3.9','9.3',NULL,'e','737','983','93','0','0.35','0.1','60','70'),(87,21,0,0,'1580158800','-19','-24','skc_n','clear','1.7','3.9',NULL,'e','754','1006','82','-2','0.37','0','60','0'),(88,21,0,1,'1580162400','-19','-24','skc_n','clear','2','3.9',NULL,'se','753','1004','83','-2','0.37','0','60','0'),(89,21,0,2,'1580166000','-19','-24','skc_n','clear','2','3.9',NULL,'se','753','1004','84','-2','0.37','0','60','0'),(90,21,0,3,'1580169600','-19','-24','skc_n','clear','1.6','3.5',NULL,'se','754','1006','83','-2','0.37','0','60','0'),(91,21,0,4,'1580173200','-18','-23','skc_n','clear','2','3.5',NULL,'se','753','1004','83','-2','0.37','0','60','0'),(92,21,0,5,'1580176800','-18','-23','skc_n','clear','2','3.5',NULL,'se','753','1004','83','-2','0.37','0','60','0'),(93,21,0,6,'1580180400','-16','-21','ovc','overcast','2.3','5.4',NULL,'se','753','1004','83','-2','0.37','0','60','0'),(94,21,0,7,'1580184000','-16','-21','ovc','overcast','2.7','5.4',NULL,'se','753','1004','84','-2','0.37','0','60','0'),(95,21,0,8,'1580187600','-16','-21','ovc','overcast','2.8','5.4',NULL,'se','753','1004','83','-2','0.37','0','60','0'),(96,21,0,9,'1580191200','-15','-20','ovc','overcast','2.7','6.7',NULL,'se','753','1004','83','-2','0.37','0','60','0'),(97,21,0,10,'1580194800','-14','-20','ovc','overcast','3.4','6.8',NULL,'se','752','1003','83','-3','0.37','0','60','0'),(98,21,0,11,'1580198400','-14','-20','ovc','overcast','3.5','6.8',NULL,'se','752','1003','81','-3','0.37','0','60','0'),(99,21,0,12,'1580202000','-13','-19','ovc','overcast','3.4','7.3',NULL,'se','752','1003','81','-2','0.37','0','60','0'),(100,21,0,13,'1580205600','-12','-18','ovc','overcast','4','7.3',NULL,'se','752','1003','80','-2','0.37','0','60','0'),(101,21,0,14,'1580209200','-12','-18','ovc','overcast','3.9','7.3',NULL,'se','752','1003','79','-2','0.37','0','60','0'),(102,21,0,15,'1580212800','-10','-16','ovc_-sn','overcast-and-light-snow','3.3','7.4',NULL,'se','750','1000','79','-2','0.37','0.1','60','70'),(103,21,0,16,'1580216400','-10','-16','ovc_-sn','overcast-and-light-snow','3.8','7.4',NULL,'se','750','1000','81','-2','0.37','0.1','60','70'),(104,21,0,17,'1580220000','-10','-16','ovc_-sn','overcast-and-light-snow','3.8','7.4',NULL,'se','750','1000','82','-2','0.37','0.1','60','40'),(105,21,0,18,'1580223600','-10','-16','ovc_-sn','overcast-and-light-snow','3.6','8.3',NULL,'se','750','1000','81','-2','0.37','0.3','60','40'),(106,21,0,19,'1580227200','-10','-16','ovc_-sn','overcast-and-light-snow','4.1','8.3',NULL,'se','749','999','83','-2','0.37','0.2','60','40'),(107,21,0,20,'1580230800','-10','-16','ovc','overcast','4.1','8.3',NULL,'se','749','999','83','-2','0.37','0','60','0'),(108,21,0,21,'1580234400','-9','-15','ovc','overcast','3.5','8.3',NULL,'se','749','999','83','-2','0.37','0','60','0'),(109,21,0,22,'1580238000','-9','-15','ovc_-sn','overcast-and-light-snow','4','8.3',NULL,'se','749','999','85','-2','0.37','0.1','60','80'),(110,21,0,23,'1580241600','-9','-15','ovc_-sn','overcast-and-light-snow','4','8.3',NULL,'se','749','999','85','-2','0.37','0.1','60','80'),(111,21,1,0,'1580245200','-10','-15','ovc_-sn','overcast-and-light-snow','3.1','7.5',NULL,'se','749','999','85','-2','0.37','0.1','60','80'),(112,21,1,1,'1580248800','-10','-16','ovc_-sn','overcast-and-light-snow','3.6','7.5',NULL,'se','748','998','86','-2','0.37','0.1','60','80'),(113,21,1,2,'1580252400','-10','-16','ovc_-sn','overcast-and-light-snow','3.6','7.5',NULL,'se','748','998','87','-2','0.37','0.1','60','80'),(114,21,1,3,'1580256000','-10','-15','ovc_-sn','overcast-and-light-snow','2.5','5.6',NULL,'se','748','998','86','-2','0.37','0.1','60','80'),(115,21,1,4,'1580259600','-10','-15','ovc_-sn','overcast-and-light-snow','3','5.6',NULL,'se','748','998','87','-2','0.37','0.1','60','80'),(116,21,1,5,'1580263200','-10','-15','ovc_-sn','overcast-and-light-snow','3','5.6',NULL,'se','748','998','88','-2','0.37','0.1','60','80'),(117,21,1,6,'1580266800','-10','-15','ovc_-sn','overcast-and-light-snow','2.5','5.4',NULL,'se','748','998','88','-2','0.37','0.1','60','80'),(118,21,1,7,'1580270400','-10','-15','ovc_-sn','overcast-and-light-snow','2.9','5.4',NULL,'se','748','998','89','-2','0.37','0.1','60','80'),(119,21,1,8,'1580274000','-10','-15','ovc_-sn','overcast-and-light-snow','2.9','5.4',NULL,'se','748','998','89','-2','0.37','0.1','60','80'),(120,21,1,9,'1580277600','-10','-15','ovc_-sn','overcast-and-light-snow','2.5','5.8',NULL,'se','748','998','88','-2','0.37','0.1','60','70'),(121,21,1,10,'1580281200','-9','-14','ovc_-sn','overcast-and-light-snow','3','5.8',NULL,'se','748','998','88','-2','0.37','0.1','60','70'),(122,21,1,11,'1580284800','-9','-14','ovc_-sn','overcast-and-light-snow','3','5.8',NULL,'se','748','998','86','-2','0.37','0.1','60','70'),(123,21,1,12,'1580288400','-8','-13','ovc_-sn','overcast-and-light-snow','2.3','4.3',NULL,'e','748','998','86','-2','0.37','0.1','60','60'),(124,21,1,13,'1580292000','-8','-13','ovc_-sn','overcast-and-light-snow','2.6','4.3',NULL,'se','747','996','86','-2','0.37','0.1','60','60'),(125,21,1,14,'1580295600','-7','-12','ovc_-sn','overcast-and-light-snow','2.6','4.3',NULL,'se','747','996','86','-2','0.37','0.1','60','60'),(126,21,1,15,'1580299200','-7','-12','ovc_-sn','overcast-and-light-snow','2.2','4.5',NULL,'e','748','998','87','-2','0.37','0.1','60','60'),(127,21,1,16,'1580302800','-8','-13','ovc_-sn','overcast-and-light-snow','2.5','4.5',NULL,'e','747','996','89','-2','0.37','0.1','60','60'),(128,21,1,17,'1580306400','-8','-13','ovc_-sn','overcast-and-light-snow','2.5','4.5',NULL,'e','747','996','90','-2','0.37','0.1','60','60'),(129,21,1,18,'1580310000','-7','-11','ovc_-sn','overcast-and-light-snow','2.1','4.1',NULL,'e','748','998','89','-2','0.37','0.1','60','60'),(130,21,1,19,'1580313600','-7','-12','ovc_-sn','overcast-and-light-snow','2.4','4.1',NULL,'e','747','996','91','-2','0.37','0.1','60','60'),(131,21,1,20,'1580317200','-7','-12','ovc_-sn','overcast-and-light-snow','2.4','4.1',NULL,'e','747','996','91','-2','0.37','0.1','60','60'),(132,21,1,21,'1580320800','-7','-11','ovc_-sn','overcast-and-light-snow','2.2','4.9',NULL,'e','748','998','90','-2','0.37','0.1','60','70'),(133,21,1,22,'1580324400','-7','-12','ovc_-sn','overcast-and-light-snow','2.5','4.9',NULL,'e','747','996','91','-2','0.37','0.1','60','70'),(134,21,1,23,'1580328000','-7','-12','ovc_-sn','overcast-and-light-snow','2.5','4.9',NULL,'e','747','996','91','-2','0.37','0.1','60','70'),(135,21,2,0,'1580331600','-7','-12','ovc_-sn','overcast-and-light-snow','2.3','5.4',NULL,'e','748','998','91','-2','0.37','0.1','60','70'),(136,21,2,1,'1580335200','-7','-12','ovc_-sn','overcast-and-light-snow','2.6','5.4',NULL,'e','747','996','92','-2','0.37','0.1','60','70'),(137,21,2,2,'1580338800','-7','-12','ovc_-sn','overcast-and-light-snow','2.6','5.4',NULL,'e','747','996','92','-2','0.37','0.1','60','70'),(138,21,2,3,'1580342400','-7','-12','ovc_-sn','overcast-and-light-snow','2.3','5.4',NULL,'e','747','996','91','-2','0.37','0.1','60','70'),(139,21,2,4,'1580346000','-6','-11','ovc_-sn','overcast-and-light-snow','2.6','5.4',NULL,'e','747','996','92','-2','0.37','0.1','60','70'),(140,21,2,5,'1580349600','-6','-11','ovc_-sn','overcast-and-light-snow','2.6','5.4',NULL,'e','747','996','92','-2','0.37','0.1','60','70'),(141,21,2,6,'1580353200','-6','-11','ovc_-sn','overcast-and-light-snow','2.5','6',NULL,'e','747','996','92','-2','0.37','0.1','60','80'),(142,21,2,7,'1580356800','-6','-11','ovc_-sn','overcast-and-light-snow','2.8','6',NULL,'e','747','996','93','-2','0.37','0.1','60','80'),(143,21,2,8,'1580360400','-6','-11','ovc_-sn','overcast-and-light-snow','2.8','6',NULL,'e','747','996','94','-2','0.37','0.1','60','80'),(144,21,2,9,'1580364000','-6','-11','ovc_-sn','overcast-and-light-snow','2.8','6.4',NULL,'e','746','995','93','-2','0.37','0.1','60','80'),(145,21,2,10,'1580367600','-6','-11','ovc_-sn','overcast-and-light-snow','3.2','6.4',NULL,'e','746','995','94','-2','0.37','0.1','60','80'),(146,21,2,11,'1580371200','-5','-10','ovc_-sn','overcast-and-light-snow','3.2','6.4',NULL,'e','746','995','93','-2','0.37','0.1','60','80'),(147,21,2,12,'1580374800','-5','-10','ovc_-sn','overcast-and-light-snow','3','6.9',NULL,'e','746','995','92','-2','0.37','0.1','60','80'),(148,21,2,13,'1580378400','-5','-10','ovc_-sn','overcast-and-light-snow','3.4','6.9',NULL,'e','746','995','93','-2','0.37','0.1','60','80'),(149,21,2,14,'1580382000','-5','-10','ovc_-sn','overcast-and-light-snow','3.4','6.9',NULL,'e','746','995','92','-2','0.37','0.1','60','80'),(150,21,2,15,'1580385600','-5','-10','ovc_-sn','overcast-and-light-snow','3','6.9',NULL,'e','745','994','92','-2','0.37','0.1','60','80'),(151,21,2,16,'1580389200','-5','-10','ovc_-sn','overcast-and-light-snow','3.4','6.9',NULL,'e','745','994','93','-2','0.37','0.1','60','80'),(152,21,2,17,'1580392800','-5','-10','ovc_-sn','overcast-and-light-snow','3.3','6.9',NULL,'e','745','994','93','-2','0.37','0.1','60','80'),(153,21,2,18,'1580396400','-5','-10','ovc_-sn','overcast-and-light-snow','3.4','8.2',NULL,'e','745','994','92','-2','0.37','0.2','60','90'),(154,21,2,19,'1580400000','-5','-10','ovc_-sn','overcast-and-light-snow','3.8','8.2',NULL,'e','744','992','93','-2','0.37','0.2','60','90'),(155,21,2,20,'1580403600','-5','-10','ovc_-sn','overcast-and-light-snow','3.8','8.2',NULL,'e','744','992','94','-2','0.37','0.2','60','90'),(156,21,2,21,'1580407200','-5','-10','ovc_sn','cloudy-and-snow','3.4','8.2',NULL,'e','744','992','92','-2','0.37','0.2','60','90'),(157,21,2,22,'1580410800','-5','-10','ovc_sn','cloudy-and-snow','3.8','8.2',NULL,'e','743','991','93','-2','0.37','0.2','60','90'),(158,21,2,23,'1580414400','-5','-10','ovc_sn','cloudy-and-snow','3.8','8.2',NULL,'e','743','991','93','-2','0.37','0.2','60','90'),(159,21,3,0,'1580418000','-5','-10','ovc_-sn','overcast-and-light-snow','3.1','7.8',NULL,'e','743','991','92','-2','0.37','0.1','60','100'),(160,21,3,1,'1580421600','-5','-10','ovc_-sn','overcast-and-light-snow','3.5','7.8',NULL,'e','743','991','93','-2','0.37','0.1','60','100'),(161,21,3,2,'1580425200','-5','-10','ovc_-sn','overcast-and-light-snow','3.5','7.8',NULL,'e','743','991','93','-2','0.37','0.1','60','100'),(162,21,3,3,'1580428800','-5','-10','ovc_sn','cloudy-and-snow','2.8','7.2',NULL,'e','742','990','92','-2','0.37','0.3','60','100'),(163,21,3,4,'1580432400','-5','-10','ovc_sn','cloudy-and-snow','3.1','7.2',NULL,'e','742','990','93','-2','0.37','0.3','60','100'),(164,21,3,5,'1580436000','-5','-10','ovc_sn','cloudy-and-snow','3.1','7.2',NULL,'e','742','990','93','-2','0.37','0.3','60','100'),(165,21,3,6,'1580439600','-5','-9','ovc_sn','cloudy-and-snow','2.4','6.3',NULL,'e','742','990','92','-2','0.37','0.3','60','90'),(166,21,3,7,'1580443200','-5','-10','ovc_sn','cloudy-and-snow','2.7','6.3',NULL,'e','742','990','93','-2','0.37','0.3','60','90'),(167,21,3,8,'1580446800','-5','-10','ovc_sn','cloudy-and-snow','2.7','6.3',NULL,'e','742','990','94','-2','0.37','0.3','60','90'),(168,21,3,9,'1580450400','-5','-9','ovc_-sn','overcast-and-light-snow','2.2','5.4',NULL,'e','742','990','93','-2','0.37','0.1','60','80'),(169,21,3,10,'1580454000','-5','-10','ovc_-sn','overcast-and-light-snow','2.6','5.4',NULL,'e','741','988','93','-2','0.37','0.1','60','80'),(170,21,3,11,'1580457600','-4','-8','ovc_-sn','overcast-and-light-snow','2.6','5.4',NULL,'e','741','988','92','-2','0.37','0.1','60','80'),(171,21,3,12,'1580461200','-4','-8','ovc_-sn','overcast-and-light-snow','1.8','3.5',NULL,'se','741','988','91','-2','0.37','0.1','60','70'),(172,21,3,13,'1580464800','-3','-7','ovc_-sn','overcast-and-light-snow','2.2','3.5',NULL,'se','741','988','92','-2','0.37','0.1','60','70'),(173,21,3,14,'1580468400','-3','-7','ovc_-sn','overcast-and-light-snow','2.1','3.5',NULL,'se','741','988','92','-2','0.37','0.1','60','70'),(174,21,3,15,'1580472000','-2','-6','ovc_-sn','overcast-and-light-snow','1.7','3.5',NULL,'se','741','988','92','-2','0.37','0.1','60','60'),(175,21,3,16,'1580475600','-2','-6','ovc_-sn','overcast-and-light-snow','2','3.5',NULL,'se','741','988','94','-2','0.37','0.1','60','60'),(176,21,3,17,'1580479200','-2','-6','ovc_-sn','overcast-and-light-snow','2','3.5',NULL,'se','741','988','95','-2','0.37','0.1','60','60'),(177,21,3,18,'1580482800','-2','-5','ovc_-sn','overcast-and-light-snow','1.6','3.4',NULL,'e','742','990','94','-1','0.37','0.1','60','70'),(178,21,3,19,'1580400000','-3','-8','ovc_-sn','overcast-and-light-snow','4','9.3',NULL,'e','743','991','93','-1','0.37','0.1','60','90');
/*!40000 ALTER TABLE `yaweather_hf` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `yaweather_main`
--

DROP TABLE IF EXISTS `yaweather_main`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `yaweather_main` (
  `ID` int(30) unsigned NOT NULL AUTO_INCREMENT,
  `CID` int(30) DEFAULT NULL,
  `mycity` int(30) DEFAULT NULL,
  `locality_name` varchar(100) DEFAULT NULL,
  `district_name` varchar(100) DEFAULT NULL,
  `TITLE` varchar(100) DEFAULT NULL,
  `DESCRIPTION` varchar(100) DEFAULT NULL,
  `temp` varchar(100) DEFAULT NULL,
  `feels_like` varchar(100) DEFAULT NULL,
  `condition` varchar(100) DEFAULT NULL,
  `wind_speed` varchar(100) DEFAULT NULL,
  `wind_dir` varchar(100) DEFAULT NULL,
  `pressure_mm` varchar(100) DEFAULT NULL,
  `humidity` varchar(100) DEFAULT NULL,
  `uv_index` varchar(100) DEFAULT NULL,
  `forecast_1_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_2_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_3_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_4_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_5_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_6_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_7_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_1_daycondition` varchar(100) DEFAULT NULL,
  `forecast_2_daycondition` varchar(100) DEFAULT NULL,
  `forecast_3_daycondition` varchar(100) DEFAULT NULL,
  `forecast_4_daycondition` varchar(100) DEFAULT NULL,
  `forecast_5_daycondition` varchar(100) DEFAULT NULL,
  `forecast_6_daycondition` varchar(100) DEFAULT NULL,
  `forecast_7_daycondition` varchar(100) DEFAULT NULL,
  `forecast_0_morningcondition` varchar(100) DEFAULT NULL,
  `forecast_0_daycondition` varchar(100) DEFAULT NULL,
  `forecast_0_eveningcondition` varchar(100) DEFAULT NULL,
  `forecast_0_nightcondition` varchar(100) DEFAULT NULL,
  `forecast_0_morning_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_0_day_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_0_evening_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_0_night_temp_avg` varchar(100) DEFAULT NULL,
  `forecast_0_morning_wind_speed` varchar(100) DEFAULT NULL,
  `forecast_0_day_wind_speed` varchar(100) DEFAULT NULL,
  `forecast_0_evening_wind_speed` varchar(100) DEFAULT NULL,
  `forecast_0_night_wind_speed` varchar(100) DEFAULT NULL,
  `forecast_0_morning_wind_dir` varchar(100) DEFAULT NULL,
  `forecast_0_day_wind_dir` varchar(100) DEFAULT NULL,
  `forecast_0_evening_wind_dir` varchar(100) DEFAULT NULL,
  `forecast_0_night_wind_dir` varchar(100) DEFAULT NULL,
  `forecast_0_morning_pressure_mm` varchar(100) DEFAULT NULL,
  `forecast_0_day_pressure_mm` varchar(100) DEFAULT NULL,
  `forecast_0_evening_pressure_mm` varchar(100) DEFAULT NULL,
  `forecast_0_night_short_pressure_mm` varchar(100) DEFAULT NULL,
  `day` int(30) DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `date_ts` varchar(20) DEFAULT NULL,
  `daytime` varchar(40) DEFAULT NULL,
  `season` varchar(40) DEFAULT NULL,
  `polar` varchar(40) DEFAULT NULL,
  `soil_temp` varchar(40) DEFAULT NULL,
  `forecast_0_sunrise` varchar(100) DEFAULT NULL,
  `forecast_0_sunset` varchar(100) DEFAULT NULL,
  `forecast_0_week` varchar(100) DEFAULT NULL,
  `forecast_0_rise_begin` varchar(100) DEFAULT NULL,
  `forecast_0_set_end` varchar(100) DEFAULT NULL,
  `forecast_0_moon_code` varchar(100) DEFAULT NULL,
  `forecast_0_moon_text` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `yaweather_main`
--

LOCK TABLES `yaweather_main` WRITE;
/*!40000 ALTER TABLE `yaweather_main` DISABLE KEYS */;
INSERT INTO `yaweather_main` VALUES (1,213,1,'Москва',NULL,'moscow','27.01.2020 15:31','-1','-5','overcast','1.8','ne','747','76','0','-4','1','0',NULL,NULL,NULL,NULL,'cloudy-and-snow','overcast','overcast-and-light-snow',NULL,NULL,NULL,NULL,'overcast','overcast','overcast-and-light-snow','overcast-and-light-rain','1','-1','-2','2','4.2','2.7','3.1','7','nw','n','e','w','743','747','748','741',NULL,NULL,NULL,'d','winter','','0','08:33','16:51','5','07:51','17:33',NULL,NULL),(2,21,1,'Вологда',NULL,'vologda','28.01.2020 19:49','-10','-16','overcast','4.1','se','749','83','0','-7','-5','-3',NULL,NULL,NULL,NULL,'overcast-and-light-snow','overcast-and-light-snow','overcast-and-light-snow',NULL,NULL,NULL,NULL,'overcast','overcast-and-light-snow','overcast-and-light-snow','clear','-15','-11','-9','-18','3.5','4','4.1','2','se','se','se','se','753','751','749','753',NULL,NULL,NULL,'n','winter','','-2','08:40','16:27','5','07:53','17:14',NULL,NULL);
/*!40000 ALTER TABLE `yaweather_main` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2020-01-28 17:15:32
